set autocommit = 0;

CREATE TABLE `region` (
`id`  bigint NOT NULL AUTO_INCREMENT ,
`region_key`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '地区的简写' ,
`region_value`  varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '0' COMMENT '地区的说明' ,
`root_node`  bigint NOT NULL DEFAULT 0 COMMENT '上级区域id' ,
`level`  int NOT NULL DEFAULT 1 COMMENT '地域等级（1为最高级）' ,
` region_index`  int NULL DEFAULT 1 COMMENT '排序（用于调整地域的展示顺序）' ,
`ctime`  timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '创建时间' ,
PRIMARY KEY (`id`)
);

ALTER TABLE `region`
ADD COLUMN `is_show`  tinyint NULL DEFAULT 1 COMMENT '是否展示（1可用  0不可用）' AFTER `ctime`;

ALTER TABLE `region`
ADD UNIQUE(region_key);


insert into region(id,region_key,region_value,root_node,level,region_index,is_show) values(1,'ALL','所有地区',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('RW','卢旺达',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SO','索马里',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('YE','也门',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IQ','伊拉克',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SA','沙特阿拉伯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IR','伊朗伊斯兰共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CY','塞浦路斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TZ','坦桑尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SY','叙利亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AM','亚美尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KE','肯尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CD','扎伊尔',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('DJ','吉布提',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('UG','乌干达',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CF','中非共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SC','塞舌尔群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('JO','约旦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LB','黎巴嫩',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KW','科威特',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('OM','阿曼',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('QA','卡塔尔',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BH','巴林',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AE','阿拉伯联合酋长国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IL','以色列',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TR','土耳其',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ET','埃塞俄比亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ER','厄立特里亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('EG','埃及',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SD','苏丹',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GR','希腊',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BI','布隆迪',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('EE','爱沙尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LV','拉脱维亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AZ','阿塞拜疆',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LT','立陶宛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SJ','斯瓦尔巴特和扬马延',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GE','格鲁吉亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MD','摩尔多瓦共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BY','白俄罗斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('FI','芬兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AX','奥兰群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('UA','乌克兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MK','前南斯拉夫马其顿共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('HU','匈牙利',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BG','保加利亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AL','阿尔巴尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PL','波兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('RO','罗马尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('XK','科索沃',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ZW','津巴布韦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ZM','赞比亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KM','科摩罗',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MW','马拉维',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LS','莱索托',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BW','博茨瓦纳',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MU','毛里求斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SZ','斯威士兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('RE','留尼汪',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ZA','南非',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('YT','马约特',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MZ','莫桑比克',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MG','马达加斯加',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AF','阿富汗',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PK','巴基斯坦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BD','孟加拉',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TM','土库曼斯坦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TJ','塔吉克斯坦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LK','斯里兰卡',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BT','不丹',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IN','印度',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MV','马尔代夫',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IO','英属印度洋领地',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NP','尼泊尔',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MM','缅甸',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('UZ','乌兹别克斯坦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KZ','哈萨克斯坦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KG','吉尔吉克斯坦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TF','法属南部领土',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('HM','赫德与麦克唐纳群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CC','科科斯群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PW','帕劳',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('VN','越南',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TH','泰国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ID','印度尼西亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LA','老挝人民民主共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TW','台湾',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PH','菲律宾',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MY','马来西亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CN','中国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('HK','香港',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BN','文莱',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MO','澳门',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KH','柬埔寨',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KR','大韩民国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('JP','日本',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KP','朝鲜民主共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SG','新加坡',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CK','库克群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TL','东帝汶',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('RU','俄罗斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MN','蒙古',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AU','澳大利亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CX','圣诞岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MH','马绍尔群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('FM','密克罗尼西亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PG','巴布亚新几内亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SB','所罗门群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TV','图瓦卢',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NR','瑙鲁',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('VU','瓦努阿图',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NC','新喀里多尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NF','诺福克岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NZ','新西兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('FJ','斐济',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LY','阿拉伯利比亚民众国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CM','喀麦隆',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SN','塞内加尔',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CG','刚果',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PT','葡萄牙',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LR','利比里亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CI','象牙海岸',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GH','加纳',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GQ','赤道几内亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NG','尼日利亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BF','布基纳法索',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TG','多哥',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GW','几内亚比绍',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MR','毛里塔尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BJ','贝宁',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GA','加蓬',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SL','塞拉利昂',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ST','圣多美和普林西比',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GI','直布罗陀',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GM','冈比亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GN','几内亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TD','乍得',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NE','尼日尔',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ML','马里',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('EH','西撒哈拉',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TN','突尼斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ES','西班牙',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MA','摩洛哥',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MT','马耳他',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('DZ','阿尔及利亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('FO','法罗群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('DK','丹麦',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IS','冰岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GB','英国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CH','瑞士',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SE','瑞典',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NL','荷兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AT','奥地利',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BE','比利时',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('DE','德国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LU','卢森堡',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IE','爱尔兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MC','摩纳哥',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('FR','法国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AD','安道尔',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LI','列支敦士登',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('JE','泽西岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IM','曼岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GG','格恩西岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SK','斯洛伐克共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CZ','捷克共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NO','挪威',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('VA','圣座（梵蒂冈）',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SM','圣马力诺',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('IT','意大利',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SI','斯洛文尼亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('ME','黑山共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('HR','克罗地亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BA','波斯尼亚和黑山共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AO','安哥拉',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NA','纳米比亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SH','圣赫勒拿',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BV','布维特岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BB','巴巴多斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CV','佛得角',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GY','圭亚那',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GF','法属圭亚那',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SR','苏里南',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PM','圣皮埃尔和密克隆',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GL','格陵兰',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PY','巴拉圭',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('UY','乌拉圭',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BR','巴西',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('FK','福克兰群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GS','南乔治亚岛和南桑威齐群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('JM','牙买加',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('DO','多米尼加共和国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CU','古巴',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MQ','马提尼克群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BS','巴哈马',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BM','百慕大',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AI','安圭拉',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TT','特立尼达和多巴哥',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KN','圣基茨和尼维斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('DM','多米尼加',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AG','安提瓜和巴布达',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('LC','圣卢西亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TC','特克斯和凯科斯群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AW','阿鲁巴',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('VG','英属维京群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('VC','圣文森特和格林纳丁斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MS','蒙塞拉特群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MF','圣马丁',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BL','圣巴泰勒米',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GP','瓜德罗普岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GD','格林纳达',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KY','开曼群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BZ','伯利兹',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SV','萨尔瓦多',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GT','危地马拉',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('HN','洪都拉斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NI','尼加拉瓜',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CR','哥斯达黎加',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('VE','委内瑞拉',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('EC','厄瓜多尔',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CO','哥伦比亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PA','巴拿马',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('HT','海地',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AR','阿根廷',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CL','智利',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BO','玻利维亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PE','秘鲁',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MX','墨西哥',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PF','法属波利尼西亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PN','皮特凯恩群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('KI','基里巴斯',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TK','托克劳',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('TO','汤加',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('WF','瓦利斯和富图纳',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('WS','萨摩亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('NU','纽埃',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('MP','北马里亚纳群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('GU','关岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PR','波多黎各',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('VI','美属维京群岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('UM','美国边远小岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AS','美属萨摩亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CA','加拿大',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('US','美国',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('PS','巴勒斯坦领土',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('RS','塞尔维亚',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('AQ','南极洲',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SX','圣马丁岛',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('CW','库拉索',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('BQ','博奈尔岛、圣尤斯达蒂斯和萨巴',1,1,1,1);
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('SS','南苏丹',1,1,1,1);
UPDATE  region set region_value = "中国香港" where region_value like "%香港%";
UPDATE  region set region_value = "中国澳门" where region_value like "%澳门%";
UPDATE  region set region_value = "中国台湾" where region_value like "%台湾%";
insert into region(region_key,region_value,root_node,level,region_index,is_show) values('unknown','其他',1,1,1,1);


commit;
set autocommit = 1;