package com.reyun.controller;

import com.reyun.model.AbTest;
import com.reyun.model.Account;
import com.reyun.repository.AbTestRepository;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.BussinessManRepository;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.AutoTodayFlowService;
import com.reyun.service.TipService;
import com.reyun.task.AutoCalculateFlow;
import com.reyun.util.ResultModel;
import com.reyun.util.SendCommonPostMail;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by sunhao on 17/9/21.
 * 优先测试账号查询
 */
@Controller
@RequestMapping("abtest")
public class AbTestController {

    @Autowired
    private AbTestRepository abTestRepository;
    @Autowired
    private AccountRepository accountRepository;

    @Autowired
    private BussinessManRepository bussinessManRepository;

    @Autowired
    AutoTodayFlowService autoTodayFlowService;

    @Autowired
    AutoCalculateFlow autoCalculateFlow;

    @Autowired
    TipService tipService;





    @RequestMapping(value = "find/{menu}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAll(@CurrentAccount Account loginAccount, @PathVariable String menu) {

        Account account = accountRepository.findOne(loginAccount.getId());

        AbTest apTestList = abTestRepository.findByAccountAndMenu(menu, account.getRootParent());

        return ResultModel.OK(null != apTestList);
    }

    /**
     * 测试方法
     * @param loginAccount
     * @param id
     * @return
     */
    @RequestMapping(value = "find/sales/{id}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAllSals(@CurrentAccount Account loginAccount, @PathVariable Long id) {

        String mails = bussinessManRepository.findEmialWithLeader(id);

        List a = bussinessManRepository.findAll();

        List aaa = bussinessManRepository.findAllIncumbency();

        String [] aaaa = mails.split(",");

        return ResultModel.OK(aaaa);

    }





    @RequestMapping(value = "userflow/all/{id}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAllSalsTotalAll(@CurrentAccount Account loginAccount, @PathVariable Long id) {
        autoCalculateFlow.run();
        return ResultModel.OK("ok.......");
    }




    @RequestMapping(value = "buss/all/{id}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findBussByAccount(@CurrentAccount Account loginAccount, @PathVariable Long id) {

        Account account = accountRepository.findOne(id);
        List<String> bcc = new ArrayList<>();
        List<String> accountList = new ArrayList<>();
        autoTodayFlowService.getBussiness(account,bcc,accountList);
        return ResultModel.OK(bcc);
    }


}
