package com.reyun.controller;

import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.ChannelWangyan;
import com.reyun.repository.AppRepository;
import com.reyun.repository.ChannelWangyanRepository;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.AppService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import java.io.IOException;
import java.util.List;

/**
 * Created by nolan on 22/12/2016.
 * description:
 */
@Controller
@RequestMapping("app")
public class AppController {

    @Autowired
    private AppService appService;
    @Autowired
    private AppRepository appRepository;
    @Autowired
    private ChannelWangyanRepository channelWangyanRepository;

    @RequestMapping(value = "findall", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAll(@CurrentAccount Account loginAccount) {
        System.out.print(loginAccount.getId());
        return ResultModel.OK(appService.listAppByAccount(loginAccount.getId()));
    }

    @RequestMapping(value = "findApp", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAllByAccount(@CurrentAccount Account loginAccount) throws IOException {
        return ResultModel.OK(appService.listAppByAccountForMobile(loginAccount.getId()));
    }

    @RequestMapping(value = "find/{subAccountId}/AuthApp", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAuthApp(@CurrentAccount Account loginAccount, @PathVariable Long subAccountId) {
        return ResultModel.OK(appService.listAuthAppByAccount(loginAccount, subAccountId));
    }

    @RequestMapping(value = "find/cpcallback/app/downlist", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findDownlist(@CurrentAccount Account loginAccount) {
        return ResultModel.OK(appService.findDownlist(loginAccount.getId()));
    }

    @RequestMapping(value = "createchannelwebeye", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel createChannelWebeye(long id) {
        ChannelWangyan channelWangyan = channelWangyanRepository.findOne(id);
        if(channelWangyan!=null){
            List<App> allByWangyan = appRepository.findAllByWangyan();
            for (App app : allByWangyan) {
                appService.putWangyan(channelWangyan,app,app.getAccount());
            }
        }
        return ResultModel.OK("添加成功");
    }
}
