package com.reyun.controller;

import com.reyun.dic.RoleEnumType;
import com.reyun.model.*;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.AppRepository;
import com.reyun.repository.DataAuthRepository;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.AuthService;
import com.reyun.service.CampaignService;
import com.reyun.service.ChannelService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by nolan on 26/12/2016.
 * description:
 */
@Controller
@RequestMapping("/{appId}/channel")
public class ChannelController {

    @Autowired
    private ChannelService channelService;

    @Autowired
    private AuthService authService;

    @Autowired
    private AppRepository appRepository;

    @Autowired
    private AccountRepository accountRepository;

    @Autowired
    private CampaignService campaignService;
    @Autowired
    private DataAuthRepository dataAuthRepository;

    @RequestMapping(value = "find", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findAllChannel(@PathVariable Long appId, @CurrentAccount Account loginAccount) {
        return ResultModel.OK(channelService.listCampaignChannelAndDisable(appId, loginAccount.getId()));
    }

    @RequestMapping(value = "findall", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findChannelExistsCampaign(@PathVariable Long appId, @CurrentAccount Account loginAccount,String delflag) {

        if("1".equals(delflag)){
            return ResultModel.OK(authService.getAuthChannelListByAppIngnorDel(loginAccount.getId(),appId));
        }else{
            return ResultModel.OK(authService.getAuthChannelListByApp(loginAccount.getId(),appId));
        }
    }

    /**
     * 获取推广活动详情-广点通点击后追加的下拉框值
     * create by zhangyao 2018-11-12
     */
    @RequestMapping(value = "findGuangDianTongChannel", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findGuangDianTongChannel( @PathVariable Long appId , long cid ,@CurrentAccount Account currentAccount) {
        //RoleEnumType.CHANNEL_PERSON.
        Account account = accountRepository.findOne(currentAccount.getId());
        DataAuth dataAuth = dataAuthRepository.getByAllCampaign(account.getId(), appId, 5305L);
        //dataAuth 子账号该渠道在全部授权的情况下按主账号处理
        if (dataAuth!=null || account.getIsSuperUser() || RoleEnumType.MANAGER.getKey().equals(account.getRoleCategory())
                || RoleEnumType.SUB_APP_MANAGER.getKey().equals(account.getRoleCategory())) {
            return ResultModel.OK(authService.findGuangDianTongChannel(appId,cid));
        } else {
            return ResultModel.OK(authService.findGuangDianTongChannelByRole(appId,cid,currentAccount.getId()));
        }
    }
    /**
     * 获取广点通账号
     * create by zhangyao 2019-04-1
     */
    @RequestMapping(value = "findGdtThirdAccount", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findGdtThirdAccount( @PathVariable Long appId ,Long account) {
        return ResultModel.OK(authService.findGdtThirdAccount(appId,account));
    }



    @RequestMapping(value = "findcoop", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findCooperationChannel(){
        return ResultModel.OK(channelService.listAllCooperationChannel());
    }

    @RequestMapping(value = "find/{uniquename}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findByUniqueName(@PathVariable String uniquename,@CurrentAccount Account loginAccount){
        return ResultModel.OK(channelService.findByUniqueName(uniquename,loginAccount));
    }

    @RequestMapping(value = "findchannelcamp4io", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findBy(@RequestParam String appkey, String email){

        App app = appRepository.findByAppkey(appkey);
        Account account = accountRepository.findAccountByEmail(email);
        Map<String, Map> result = new HashMap<>();
        if (app == null || account == null) {
            return ResultModel.OK(result);
        }
        Map<String, String> channelMap = channelService.findChannelMapWithDefault(app.getId(), account.getId());
        Map<String, String> campaignMap = campaignService.findCampaignMapWithDefault(app.getId(), account.getId());

        result.put("channel", channelMap);
        result.put("campaign", campaignMap);

        return ResultModel.OK(result);
    }
}
