package com.reyun.controller;

import com.reyun.service.ClickMonitorService;
import com.reyun.util.ResultModel;
import com.reyun.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.text.SimpleDateFormat;
import java.util.UUID;

/**
 */
@Controller
@RequestMapping("ClickMonitor/")
public class ClickMonitorController {

    private static final SimpleDateFormat sdf =new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    @Autowired
    private ClickMonitorService clickMonitorService;


    @RequestMapping(value = "click")
    @ResponseBody
    public ResultModel click(HttpServletRequest request, HttpServletResponse response, String email, String menu,String type, String cip ,@RequestParam(required = false) String data,@RequestParam(required = false) String totalCount) {

        Cookie[] cookies = request.getCookies();
        if(cookies==null||cookies.length==0) return ResultModel.OK(false);
        String clickToken = "";
        for (Cookie cookie : cookies) {
                if("clickToken".equals(cookie.getName())){
                    clickToken=cookie.getValue();
                    break;
                }
            }
            if(StringUtil.isEmpty(clickToken)){
                clickToken = UUID.randomUUID().toString().replaceAll("-", "");
                Cookie cookie = new Cookie("clickToken", clickToken);
                cookie.setPath("/");
                //此cookie为了确认独立访客,所以过期时间较长
                cookie.setMaxAge(60*60*24*30*12*300);
                response.addCookie(cookie);
            }

        return ResultModel.OK(this.clickMonitorService.recordClick(email,menu,type,cip,data,clickToken,totalCount));
    }

}
