package com.reyun.controller;

import com.reyun.service.CampaignService;
import com.reyun.service.ConfigParamService;
import com.reyun.service.SmSearchService;
import com.reyun.util.RedisUtilNew;
import com.reyun.util.ResultModel;
import org.apache.commons.lang.time.DateUtils;
import org.joda.time.DateTime;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * description:
 *
 * @author nolan
 * @date 11/12/2017
 */
@Controller
@RequestMapping("ops")
public class DevOpsController {
    private Logger logger = LoggerFactory.getLogger(DevOpsController.class);
    private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE * 1 / 1000;

    @Autowired
    private SmSearchService smSearchService;
    @Autowired
    private ConfigParamService configParamService;
    @Autowired
    private CampaignService campaignService;

    @RequestMapping(value = "/sm/taskrun", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel taskBuild(@RequestParam String pwd) {
        if (!configParamService.generateMasterPwd().equals(pwd)) {
            throw new IllegalAccessError("非法访问");
        }

        smSearchService.task();
        return ResultModel.OK();
    }

    @RequestMapping(value = "/sm/schedule/taskrun", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel taskBuildRun(@RequestParam String pwd) {
        if (!configParamService.generateMasterPwd().equals(pwd)) {
            throw new IllegalAccessError("非法访问");
        }

        logger.info("同步神马关键词和创意................//Begin, 执行时间: {}", DateTime.now());

        if (RedisUtilNew.getInstance().tryLock("AutoSyncShenMaKeywordsTask", EXPIRE_PERIOD) != null) {
            smSearchService.task();
        } else {
            logger.info("AutoSyncShenMaKeywordsTask正在执行中......");
        }

        logger.info("同步神马关键词和创意................//End");
        return ResultModel.OK();
    }


    @RequestMapping(value = "/campaign/diableddb", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel disableCampaignDDB(@RequestParam String pwd) {
        if (!configParamService.generateMasterPwd().equals(pwd)) {
            throw new IllegalAccessError("非法访问");
        }
        campaignService.doDisableCampaign2ddb();
        return ResultModel.OK();
    }


}
