package com.reyun.controller;

import com.reyun.model.Account;
import com.reyun.model.DeviceWhiteList;
import com.reyun.repository.DeviceWhiteListRepository;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.DeviceWhiteListService;
import com.reyun.util.ResultModel;
import com.reyun.util.ResultStatus;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Controller
@RequestMapping("white")
public class DeviceWhiteListController {

    @Autowired
    private DeviceWhiteListService deviceWhiteListService;

    @Autowired
    private DeviceWhiteListRepository deviceWhiteListRepository;


    @RequestMapping(value = "create", method = RequestMethod.POST)
    @ResponseBody
    public ResultModel create(@CurrentAccount Account loginAccount, @RequestBody DeviceWhiteList resource) {
        List<DeviceWhiteList> byAccount = deviceWhiteListRepository.findByAccount(loginAccount.getRootParent());
        if(byAccount.size()>=200){
            return ResultModel.ERROR(ResultStatus.NUMBER_LIMIT);
        }
        return ResultModel.OK(deviceWhiteListService.create(loginAccount, resource));
    }

    @RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
    @ResponseBody
    public ResultModel delete(@PathVariable Long id) {
        deviceWhiteListRepository.delete(id);
        return ResultModel.OK();
    }

    @RequestMapping(value = "update/{id}", method = RequestMethod.POST)
    @ResponseBody
    public ResultModel update(@CurrentAccount Account loginAccount,@RequestBody DeviceWhiteList resource) {
        return ResultModel.OK(deviceWhiteListService.update(loginAccount,resource));
    }

    @RequestMapping(value = "find", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel find(@CurrentAccount Account loginAccount) {
        return ResultModel.OK(deviceWhiteListRepository.findByAccount(loginAccount.getRootParent()));
    }
}
