package com.reyun.controller;

import com.reyun.service.EventService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.List;


/**
 * Created by nolan on 22/12/2016. description:
 */
@Controller
@RequestMapping("{app}/event")
public class EventController {

    @Autowired
    EventService eventService;

    @ResponseBody
    @RequestMapping(value = "find", method = RequestMethod.GET)
    public ResultModel findAllEvent(@PathVariable Long app, @RequestHeader(name = "lang", defaultValue = "zh") String lanType) {

        return ResultModel.OK(eventService.listAllEvent(app, lanType));
    }

    @ResponseBody
    @RequestMapping(value = "find/callback", method = RequestMethod.GET)
    public ResultModel findAllEventToCallback(@PathVariable Long app) {
        return ResultModel.OK(eventService.listAllEventToCallback(app));
    }

    @ResponseBody
    @RequestMapping(value = "find/valuespecail", method = RequestMethod.GET)
    public ResultModel findValueSpecail(@PathVariable Long app, @RequestParam String attrName, @RequestParam String values) {
        List<String> valueList = Arrays.asList(values.split(","));
        return ResultModel.OK(eventService.getValueResult(attrName, valueList));
    }

}
