package com.reyun.controller;

import com.reyun.dic.LogEnumType;
import com.reyun.model.Account;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.ExportGdtService;
import com.reyun.service.UserLogService;
import com.reyun.util.ResultModel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpRequest;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;

/**
 * Created by nolan on 22/12/2016.
 * description:
 */
@Controller
@RequestMapping("exportgdt")
public class ExportGdtController {

    Logger logger = LoggerFactory.getLogger(ExportGdtController.class);

    @Autowired
    private ExportGdtService exportGdtService;

    @Autowired
    UserLogService userLogService;

    @RequestMapping(value = "find", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel find(Long app) {

        return ResultModel.OK(exportGdtService.check(app));
    }

    @RequestMapping(value = "able", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel able(@CurrentAccount Account loginAccount, Long app, boolean status, HttpServletRequest request) {


        try {

            LogEnumType logEnumType = status? LogEnumType.DOWNLOAD_GDT:LogEnumType.DOWNLOAD_GDT_CLOSE;
            userLogService.insertLog(loginAccount, logEnumType.getCode(), logEnumType.getName() + loginAccount.getEmail(), loginAccount, null, null, request);

        } catch (Exception e) {
            logger.error("fail to parse ip," + e.getMessage());
        }

        return ResultModel.OK(exportGdtService.able(app, loginAccount.getEmail(), status));
    }
}
