package com.reyun.controller;

import java.util.HashMap;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import com.reyun.util.ResultModel;

import ch.qos.logback.classic.Level;
import ch.qos.logback.classic.LoggerContext;

/**
 * 动态设置日志等级接口
 * 
 * @author zhangsy
 */
@Controller
@RequestMapping("/logback")
public class LogbackController {
	protected Logger log = LoggerFactory.getLogger(LogbackController.class);
	private static Map<String,String> RELMAP = new HashMap<>();
	static {
		RELMAP.put("root","root");
		RELMAP.put("dev_springframework","org.springframework");
		RELMAP.put("dev_quartz","org.springframework.scheduling.quartz");
		RELMAP.put("dev_jpa","org.springframework.data.jpa");
		RELMAP.put("dev_hibernate","org.hibernate");
		
		RELMAP.put("product_springframework","org.springframework");
		RELMAP.put("product_hibernate","org.hibernate");
		RELMAP.put("product_http","org.apache.commons.httpclient.HttpMethodBase");
		RELMAP.put("product_jpa","org.springframework.data.jpa");
	}
	
	@RequestMapping(value = "inf", method = RequestMethod.POST)
    @ResponseBody
    public ResultModel info() {
        return ResultModel.OK(RELMAP.toString());
    }
	
	@RequestMapping(value = "set/{logger}/{level}", method = RequestMethod.POST)
    @ResponseBody
    public ResultModel test(@PathVariable String logger,@PathVariable String level) {
		try {
            LoggerContext loggerContext = (LoggerContext) LoggerFactory.getILoggerFactory();
            if(RELMAP.get(logger) != null && loggerContext.getLogger(RELMAP.get(logger)) != null) {
            	loggerContext.getLogger(RELMAP.get(logger)).setLevel(Level.valueOf(level));
            	log.info("logger " + RELMAP.get(logger) + " has been seted " + level);
            }else {
            	log.info("logger:" + logger + " not exist!");
            }
        } catch (Exception e) {
            log.error("动态修改日志级别出错", e);
        }
        return ResultModel.OK();
    }
}
