package com.reyun.controller;

import com.reyun.util.Constant;
import com.reyun.util.HttpClientUtil;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

/**
 * <p>
 * 财务大后台迁移到汇量服务器，需要查report，但report只能内网调用，故在此包装接口以供外网调用
 * </p>
 *
 * @author reyun
 * @since 2022/1/19
 */
@RestController
@RequestMapping("/tkio/report/{project}")
public class MobvistaManagerController {

    @RequestMapping("/{param1}/{privateKey}")
    public String report1(@PathVariable("project") String project,@PathVariable("param1") String param1,@PathVariable("privateKey") String privateKey, Map<String, String> conditions){
        if(!privateKey.equals("fd7ee4f73ea9d9619471aacc2ced1357")){//md5(reyun123)
            return "privateKey error";
        }
        return HttpClientUtil.doHttpPostRequest(Constant.reportUrl + "/" +param1, project, conditions);
    }

    @RequestMapping("/{param1}/{param2}/{privateKey}")
    public String report2(@PathVariable("project") String project,@PathVariable("param1")String param1,@PathVariable("privateKey") String privateKey,@PathVariable("param2") String param2, Map<String, String> conditions){
        if(!privateKey.equals("fd7ee4f73ea9d9619471aacc2ced1357")){//md5(reyun123)
            return "privateKey error";
        }
        return HttpClientUtil.doHttpPostRequest(Constant.reportUrl + "/" +param1+ "/" +param2, project, conditions);
    }

}
