package com.reyun.controller;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.reyun.model.*;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.RecoveryReportService;
import com.reyun.service.ReportService;
import com.reyun.util.ResultModel;
import org.json.JSONException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by mxq on 2017/7/17.
 */
@Controller
@RequestMapping("/costrecovery/")
public class RecoveryReportController {

    @Autowired
    private RecoveryReportService recoveryReportService;

    @RequestMapping(value = "{appid}/param/channel", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findChannel(@PathVariable Long appid,@CurrentAccount Account loginAccount) {
        List<RecoveryParamModel> list = recoveryReportService.findChannelByAccount(appid, loginAccount.getId());
        return ResultModel.OK(list);
    }

    @RequestMapping(value = "{appid}/param/channelaccount", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findChannelAccountByChannel(@PathVariable Long appid,@CurrentAccount Account loginAccount, @RequestParam(required = false) String uniquename) {
        List<RecoveryParamModel> list = recoveryReportService.findChannelAccountByChannel(appid, loginAccount.getId(), uniquename);
        return ResultModel.OK(list);
    }


    @RequestMapping(value = "{appid}/param/plan", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findPlanByChannelAccount(@PathVariable Long appid,@CurrentAccount Account loginAccount, @RequestParam(required = false) String uniquename,
                                                @RequestParam(required = false) Long channelaccountid) {
        List<RecoveryParamModel> list = recoveryReportService.findPlanByChannelAccount(appid, loginAccount.getId(),uniquename,channelaccountid);
        return ResultModel.OK(list);
    }


    @RequestMapping(value = "{appid}/param/campaign", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel findCampaign(@PathVariable Long appid,@CurrentAccount Account loginAccount, @RequestParam(required = false) String uniquename,
                                    @RequestParam(required = false) Long channelaccountid,@RequestParam(required = false) String plan)  {
        List<RecoveryParamModel> list = recoveryReportService.findCampaignByPlan(appid, loginAccount.getId(),uniquename,channelaccountid,plan);
        return ResultModel.OK(list);
    }


}
