package com.reyun.controller;

import com.reyun.model.FunnelSetting;
import com.reyun.model.SdkEvent;
import com.reyun.repository.*;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.*;
import java.util.stream.Collector;
import java.util.stream.Collectors;

/**
 * Created by song on 2018/2/1.
 */

@Controller
@RequestMapping("sdkevent")
public class SDKEventController {

    @Autowired
    EventRepository eventRepository;

    @Autowired
    SdkEventRepository sdkEventRepository;

    @Autowired
    AppRepository appRepository;

    @Autowired
    FunnelSettingRepository funnelSettingRepository;

    @Autowired
    ConfigParamRepository configParamRepository;

    @RequestMapping(value = "find/{appid}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel find(@PathVariable Long appid) {
        String appkey = appRepository.findAppkeyById(appid);
        List<String> eventNames = eventRepository.findAllEventNameByAppKey(appkey);
        List<String> allName = sdkEventRepository.findAllName(appkey);
        String[] sdkevent = configParamRepository.findParamsByKey("sdkevent").split(",");
        for (String event : eventNames) {
            if (Arrays.asList(sdkevent).contains(event) && !allName.contains(event)) {
                SdkEvent sdkEvent = new SdkEvent();
                sdkEvent.setEventAlias(event.substring(7, event.length()));
                sdkEvent.setEventName(event);
                sdkEvent.setAppid(appid);
                sdkEvent.setAppkey(appkey);
                sdkEvent.setEventNameSubstring(event.substring(7, event.length()));
                sdkEventRepository.save(sdkEvent);
            }
        }

        List<SdkEvent> sdkEvents = sdkEventRepository.findAll(appkey);
        ArrayList<SdkEvent> result = new ArrayList<>();

        for (SdkEvent sdk : sdkEvents) {
            String eventName = sdk.getEventName();
            String substring = sdk.getEventName().substring(7, eventName.length());
            sdk.setEventName(substring);
            result.add(sdk);
        }
        return ResultModel.OK(result);
    }

    @RequestMapping(value = "update/{id}", method = RequestMethod.PUT)
    @ResponseBody
    public Object update(@PathVariable Long id, @RequestBody SdkEvent sdkEvent) {
        SdkEvent byEventAliasAndAppkey = sdkEventRepository.findByEventAliasAndAppkey(sdkEvent.getAppkey(), sdkEvent.getEventAlias());
        if (byEventAliasAndAppkey != null && !byEventAliasAndAppkey.getEventName().equals(sdkEvent.getEventName())) {
            return false;
        } else {
            SdkEvent one = sdkEventRepository.findOne(id);
            one.setEventAlias(sdkEvent.getEventAlias());
            sdkEventRepository.save(one);
            return true;
        }
    }

    /**
     * 转化漏斗 相关接口
     *
     * @return
     */
    @RequestMapping(value = "/default/list/{appid}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel enventListDefault(@PathVariable Long appid) {

        List<String> eventKeys = Arrays.asList("install", "reg", "loggedin", "order", "pay");
        List<String> eventNames = Arrays.asList("激活", "注册", "登录", "订单", "付费");
        List<Map> data = new ArrayList<>(18);
        for (int i = 0, j = eventKeys.size(); i < j; i++) {
            Map item = new HashMap(2);
            item.put("key", eventKeys.get(i));
            item.put("value", eventNames.get(i));
            data.add(item);
        }

        List<SdkEvent> sdkEvents = sdkEventRepository.findAllByAppid(appid);
        Map<String, String> sdkevnetName = sdkEvents.stream().collect(Collectors.toMap(SdkEvent::getEventNameSubstring, SdkEvent::getEventAlias, (v1, v2) -> v1));

        for (int i = 1; i <= 12; i++) {
            Map item = new HashMap(2);
            String key = "event_" + i;
            item.put("key", key);
            item.put("value", sdkevnetName.containsKey(key) ? sdkevnetName.get(key) : key);
            data.add(item);
        }
        return ResultModel.OK(data);
    }

    @RequestMapping(value = "/funnel/template/add", method = RequestMethod.POST)
    @ResponseBody
    public ResultModel funnelSettingDefault(@RequestBody FunnelSetting setting) {
        if (setting != null) {
            setting.setCreatTime(new Date());
        }
        FunnelSetting settingdata = funnelSettingRepository.save(setting);

        return ResultModel.OK(settingdata);

    }

    @RequestMapping(value = "/funnel/template/list/{appid}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel funnelSettingList(@PathVariable String appid) {

        List<FunnelSetting> settings = funnelSettingRepository.findByAppKey(appid);

        return ResultModel.OK(settings);


    }

}
