package com.reyun.controller;


import com.reyun.service.AccountService;
import com.reyun.service.AppService;
import com.reyun.service.CampaignService;
import com.reyun.util.Constant;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("server/check")
public class ServerCheckController {

    @Autowired
    private CampaignService campaignService;

    @Autowired
    private AccountService accountService;

    @Autowired
    private AppService appService;

    @RequestMapping(value = "/surl", method = RequestMethod.GET)
    public ResultModel getSulrOnServer(String surls){
        return ResultModel.OK(campaignService.getSulrOnServer(surls));
    }

    @RequestMapping(value = "/account/email", method = RequestMethod.GET)
    public ResultModel emailCheck(String email){
        return ResultModel.OK(accountService.emailCheck(email));
    }

    @RequestMapping(value = "/bundleid", method = RequestMethod.GET)
    public ResultModel checkBundleidAndSycDDb(String bundleid){
        return ResultModel.OK(appService.checkBundleidAndSycDDb(bundleid));
    }
    @RequestMapping(value = "/currentSystem", method = RequestMethod.GET)
    public ResultModel currentSystem(){
        return ResultModel.OK(Constant.getServerDomain());
    }
}
