package com.reyun.controller;

import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.repository.*;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.*;
import com.reyun.task.ExportReportTask;
import com.reyun.util.IPAddrUtil;
import com.reyun.util.NoSQLDBUtil;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *
 */
@Controller
public class TestController {


	@Autowired
	AutoTodayFlowService autoTodayFlowService;

	@Autowired
	ExportReportTask exportReportTask;
	@Autowired
	private CampaignService campaignService;
	@Autowired
	private AccountFlowRestrictService accountFlowRestrictService;
	@Autowired
	private AccountRepository accountRepository;
	@Autowired
	private AppRepository appRepository;

	@Autowired
	private SynchronizeCampaignTaskService synchronizeCampaignTaskService;

	@Autowired
	DingTalkService dingTalkService;


	@RequestMapping(value = "test/export/report/{id}", method = RequestMethod.GET)
	@ResponseBody
	public ResultModel testExport(@CurrentAccount Account loginAccount, @PathVariable Long id) {
		exportReportTask.exportReport(id);
		return ResultModel.OK("ok");
	}

	@RequestMapping(value = "test/auto", method = RequestMethod.GET)
	@ResponseBody
	public ResultModel testAuto(Long appid) {
		return ResultModel.OK("ok");
	}


	@RequestMapping(value = "test/ip", method = RequestMethod.GET)
	@ResponseBody
	public ResultModel testIp(HttpServletRequest request) {

		Map data = new HashMap<>();
		String downloadIP = request.getHeader("x-forwarded-for") == null
				? request.getRemoteAddr() : request.getHeader("x-forwarded-for");
		data.put("downloadIP", downloadIP);
		data.put("getIpAddr", IPAddrUtil.getIpAddr(request));
		data.put("getIpAddrNew", IPAddrUtil.getIpAddrNew(request));
		return ResultModel.OK(data);
	}

	@RequestMapping(value = "test/yestodyflow/{accountId}", method = RequestMethod.GET)
	@ResponseBody
	public ResultModel testYestodayFlow(@PathVariable Long accountId) {
		Account account = new Account();
		account.setId(accountId);
		accountFlowRestrictService.RestrictFlowByAccountTask(account, "zh");
		return ResultModel.OK("ok");
	}

	@RequestMapping(value = "test/todayflow/{id}", method = RequestMethod.GET)
	@ResponseBody
	public ResultModel findAllSalsTotal(@CurrentAccount Account loginAccount, @PathVariable Long id) {
		Account account = accountRepository.findOne(id);
		return ResultModel.OK(autoTodayFlowService.autoTodayFlowTask(account));
	}

	@RequestMapping(value = "test/syscampaign/{appkey}", method = RequestMethod.GET)
	@ResponseBody
	public void SycCompaignController(@CurrentAccount Account loginAccount, @PathVariable String appkey) {

		if (!loginAccount.getIsMasterLogin()) {
			return;
		}

		synchronizeCampaignTaskService.syncThirdCammpaigns(appkey);
	}

	@RequestMapping(value = "/test/dingFlow", method = RequestMethod.GET)
	@ResponseBody
	public ResultModel dingFlow(String eamil) {
		return ResultModel.OK(dingTalkService.getFlowText(null, null, eamil));
	}

}
