package com.reyun.controller.manage;


import com.reyun.model.Account;
import com.reyun.model.CallBackTemplet;
import com.reyun.model.Cpcallback;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.CpcallbackService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

@RestController
public class MngCpCallBackController {

    @Autowired
    CpcallbackService cpcallbackService;

    @GetMapping("mng/cpcallback/template")
    public ResultModel getTemplate(Long appkey, String evnet) {
        CallBackTemplet template = cpcallbackService.getTemplate(appkey, evnet);
        if (template == null) {
            return ResultModel.ERROR("未查询到模板");
        }
        return ResultModel.OK(template);
    }


    @GetMapping("mng/cpcallback/envent")
    public ResultModel getAvlibalEvents(String appkey) {
        List<Map> events = cpcallbackService.getAvlibalEvents(appkey);
        return ResultModel.OK(events);

    }

    @GetMapping("mng/cpcallback/list")
    public ResultModel getCpCallBackList(@CurrentAccount Account account) {

        List<Cpcallback> callbacks = cpcallbackService.getCpCallBackList(account);
        return ResultModel.OK(callbacks);

    }

    @PostMapping("mng/cpcallback/put")
    public void putCpCallBack(@RequestBody Cpcallback cpcallback) {
        cpcallbackService.putOrSave(cpcallback);
    }

    @PostMapping("mng/cpcallback/status")
    public ResultModel updteStatus(@RequestBody Cpcallback cpcallback) {

        cpcallbackService.updateStatus(cpcallback);
        return ResultModel.OK();

    }

}
