package com.reyun.controller.manage;

import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.AppDeepLink;
import com.reyun.repository.AppDeepLinkRepository;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.AppService;
import com.reyun.service.DeepLinkService;
import com.reyun.util.DateUtil;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import sun.applet.Main;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

/**
 * @author liyin
 * @description
 * @date
 */
@Controller
@RequestMapping("/mng/deeplink")
public class MngDeepLinkController {

    @Autowired
    private DeepLinkService deepLinkService;

    @Autowired
    private AppService appService;


    @PostMapping("/editAppDeepLink")
    @ResponseBody
    public Object createDeepLink(@RequestBody AppDeepLink appDeepLink,@CurrentAccount Account loginAccount){
        appDeepLink.setAccountId(loginAccount.getRootParent());
        if(appDeepLink.getId()==null){
            //创建
            appDeepLink.setCreateTime(DateUtil.getCurrentDateStr("yyyy-MM-dd HH:mm:ss"));
            appDeepLink = deepLinkService.createDeepLink(appDeepLink);
        }else{
            //修改
            appDeepLink = deepLinkService.updateDeepLink(appDeepLink);
        }
        return ResultModel.OK(appDeepLink);
    }

    @GetMapping("/{appid}/echoDeepLink")
    @ResponseBody
    public Object echoDeepLink(@PathVariable Long appid,@CurrentAccount Account loginAccount){
        return ResultModel.OK(deepLinkService.findDeepLinkByAppId(appid));
    }

    @GetMapping("/myDeepLinksConfig")
    @ResponseBody
    public Object selectDeepLinkList(@CurrentAccount Account loginAccount){
        List<App> apps = appService.listAppByAccount(loginAccount.getId());
        List<BigInteger> Ids =  deepLinkService.selectDeepLinkAppIds(loginAccount.getRootParent());
        ArrayList<App> noDebugs = new ArrayList<>();
        for (App app : apps) {
            app.setIsDeepLink(Ids.contains(BigInteger.valueOf(app.getId())));
            if(!app.getIsDebug()&&(app.getPlatform().equals("Android")||app.getPlatform().equals("iOS"))){
                noDebugs.add(app);
            }
        }
        return ResultModel.OK(noDebugs);
    }

    public static void main(String[] args) {
        List<Long> Ids = new ArrayList<>();
        Ids.add(1L);

        System.out.println(Ids.contains(1L));
    }
}
