package com.reyun.controller.manage;

import com.reyun.dic.LogEnumType;
import com.reyun.dic.OperateObjectEnumType;
import com.reyun.exception.TipException;
import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.BlacklistApplication;
import com.reyun.repository.BlacklistApplicationRepository;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.AppService;
import com.reyun.service.BlacklistService;
import com.reyun.service.SdkDebugService;
import com.reyun.service.UserLogService;
import com.reyun.util.ResultModel;
import com.reyun.util.ResultStatus;
import com.reyun.util.StringUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;

@Controller
@RequestMapping("/mng/fake")
public class MngDefenceFakeController {
    protected Logger logger = LoggerFactory.getLogger(MngDefenceFakeController.class);

    @Autowired
    private BlacklistService blacklistService;

    @Autowired
    private UserLogService userLogService;

    @Autowired
    private BlacklistApplicationRepository blacklistApplicationRepository;

    @RequestMapping(value = "find/tell", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel list(HttpServletRequest request, @CurrentAccount Account loginAccount) {
       return ResultModel.OK(blacklistService.findTell(loginAccount));
    }

    @RequestMapping(value = "find/report", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel report(HttpServletRequest request, @CurrentAccount Account loginAccount) {
        return ResultModel.OK(blacklistService.report(loginAccount));
    }



    @RequestMapping(value = "/create", method = RequestMethod.POST)
    @ResponseStatus(HttpStatus.CREATED)
    @ResponseBody
    public ResultModel create(HttpServletRequest request, @RequestBody BlacklistApplication resource, @CurrentAccount Account account) {
        BlacklistApplication one = blacklistService.findOne(account);
        if(null != one && !(one.getStatus() > 0) && "fake".equals(resource.getMenu())){
            return ResultModel.ERROR(ResultStatus.NUMBER_LIMIT);
        } else{
            blacklistService.create(account,resource);
        }
    return ResultModel.OK();
    }


    @RequestMapping(value = "/renew/{id}", method = RequestMethod.GET)
    @ResponseStatus(HttpStatus.CREATED)
    @ResponseBody
    public ResultModel renew(HttpServletRequest request,@PathVariable("id") Long id,@CurrentAccount Account account) {
        String phone = request.getParameter("phone");
        BlacklistApplication save=blacklistService.renew(id,phone,account);
        return ResultModel.OK(save);
    }

    @RequestMapping(value = "/close", method = RequestMethod.PUT)
    @ResponseStatus(HttpStatus.CREATED)
    @ResponseBody
    public ResultModel close(HttpServletRequest request, @CurrentAccount Account account) {
        blacklistService.close(account);
        return ResultModel.OK();
    }

}
