package com.reyun.controller.manage;

import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.service.MiniProgramService;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@Controller
@RequestMapping("/mng/mip")
@SuppressWarnings("SpringAutowiredFieldsWarningInspection")
public class MngMiniProgramController {

    @Autowired
    private MiniProgramService miniProgramService;

    @RequestMapping(value = "/getToken", method = RequestMethod.POST)
    @ResponseBody
    public ResultModel generateAccessToken(@RequestBody App resource) {
        return ResultModel.OK(miniProgramService.generateAccessToken(resource));
    }

    @RequestMapping(value = "/valid", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel appidValid(HttpServletRequest request, @CurrentAccount Account account) {
        return ResultModel.OK(miniProgramService.appidValid(account.getId(), request.getParameter("mipAppid")));
    }

    @RequestMapping(value = "download/{campaignId}", method = RequestMethod.GET, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
    public ResponseEntity<byte[]> getDownloadResponseEntity(@PathVariable Long campaignId) {
        return miniProgramService.downloadQrCode(campaignId);
    }

    @RequestMapping(value = "impression/{campaignId}", method = RequestMethod.GET, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
    public ResponseEntity<byte[]> getImpressionResponseEntity(@PathVariable Long campaignId) {
        return miniProgramService.impression(campaignId);
    }


    @RequestMapping(value = "listChannel/{appid}/{type}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel listChannel(@PathVariable Long appid, @CurrentAccount Account loginAccount, @PathVariable String type) {
        return ResultModel.OK(miniProgramService.listChannel(loginAccount, appid, type));
    }

    @RequestMapping(value = "/checkAppValid/{appid}", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel checkAppValid(@PathVariable Long appid, @CurrentAccount Account loginAccount) {
        return ResultModel.OK(miniProgramService.checkAppValid(appid,loginAccount));
    }

}