package com.reyun.controller.manage;

import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.ServeridBackflow;
import com.reyun.repository.AppRepository;
import com.reyun.repository.ServeridBackflowRepository;
import com.reyun.security.annotation.CurrentAccount;
import com.reyun.util.ResultModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * description:
 *
 * @author nolan
 * @date 13/09/2017
 */
@RestController
@RequestMapping("/mng/serveridbackflow")
public class MngServeridBackflowController
{

    @Autowired
    private ServeridBackflowRepository serveridBackflowRepository;
    @Autowired
    private AppRepository appRepository;

    @RequestMapping(value = "/findlist", method = RequestMethod.GET)
    public ResultModel findlist(@CurrentAccount Account loginAccount,Long app)
    {
        return ResultModel.OK(serveridBackflowRepository.findAByRootAccount(loginAccount.getRootParent(),app));
    }

    @RequestMapping(value = "/update", method = RequestMethod.POST)
    public ResultModel update(@RequestBody ServeridBackflow serveridBackflow)
    {
        ServeridBackflow byServerName = serveridBackflowRepository.getByServerName(serveridBackflow.getServerName(),serveridBackflow.getApp());
        if(byServerName!=null&&byServerName.getId()!=serveridBackflow.getId()){
            return new ResultModel(301,"服务器名称重复");
        }
        ServeridBackflow one = serveridBackflowRepository.findOne(serveridBackflow.getId());
        one.setServerName(serveridBackflow.getServerName());
        one.setServerType(serveridBackflow.getServerType());

        return ResultModel.OK(serveridBackflowRepository.save(one));
    }

    @RequestMapping(value = "/create", method = RequestMethod.POST)
    public ResultModel create(@CurrentAccount Account loginAccount,@RequestBody ServeridBackflow serveridBackflow)
    {
        ServeridBackflow byServerName = serveridBackflowRepository.getByServerName(serveridBackflow.getServerName(),serveridBackflow.getApp());
        if(byServerName!=null){
            return new ResultModel(301,"服务器名称重复");
        }
        ServeridBackflow byServerId = serveridBackflowRepository.getByServerId(serveridBackflow.getServerId(),serveridBackflow.getApp());
        if(byServerId!=null){
            return new ResultModel(302,"服务器ID重复");
        }
        App app = appRepository.findOne(serveridBackflow.getApp());
        serveridBackflow.setAppkey(app.getAppkey());
        serveridBackflow.setCreateAccount(loginAccount.getCreateAccount());
        serveridBackflow.setRootAccount(loginAccount.getRootParent());
        return ResultModel.OK(serveridBackflowRepository.save(serveridBackflow));
    }

    @RequestMapping(value = "/openAndClose", method = RequestMethod.GET)
    public ResultModel openAndClose(Integer status,Long id)
    {
        ServeridBackflow one = serveridBackflowRepository.findOne(id);
        one.setStatus(status);
        return ResultModel.OK(serveridBackflowRepository.save(one));
    }
    @RequestMapping(value = "/delete", method = RequestMethod.GET)
    public ResultModel delete(Long id)
    {
        serveridBackflowRepository.delete(id);
        return ResultModel.OK();
    }


}
