package com.reyun.model;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.math.BigInteger;
import java.util.Date;

@Entity
public class AccountRestrict4Web {
    private Long id;
    private String packageName;
    private String originalName;
    private BigInteger IOLimit;
    private String pastDate;
    private BigInteger TrackLimit;//套餐流量
    private Long accountId;
    private int priceLevel;
    private int iOremainingDays;
    private int trackRemainingDays;
    private BigInteger TrackTotalFlow;//已使用流量（前2日以前）
    private BigInteger thisMonthIOFlow;
    private Double trackRemainPercent;
    private Double IORemainPercent;
    private BigInteger lastMonthIOFlow;
    private Boolean isFlowRestrict;
    private Long packLevel;
    private Boolean isTrackPastTimeNotified;
    private Boolean isIOPastTimeNotified;
    private Boolean isTrackFlowNotified;
    private Boolean isIOFlowNotified;
    private Boolean allowBehavior;
    private Boolean superLevel;
    private Boolean ioPastTime;
    private Boolean trackPastTime;
    private Boolean ioFlow;
    private Boolean trackFlow;
    private Date createTime;
    private Date modifyTime;
    private BigInteger incrementFlow;//近2日流量
    private BigInteger incrementToday;//今日流量
    private BigInteger incrementContanct;//重置前今日已使用流量
    private String trackNotifyFlag;
    private String trackTipshowFlag;
    private Boolean delFlag;// 1 已删除 0 为删除
    private Account rootAccoount;
    private PackageType packageType;
    private String firstDayOfThisMonth;
    private int remainDays;
    private Date etlFlowModifyTime;
    private Integer packageFlowId;//流量包id
    private BigInteger packageLimit;//流量包总流量：流量包+附加
    private BigInteger packageTotalFlow;//流量包两日前所有离线流量
    private BigInteger packageContractTotalFlow;//流量包新合同开始日到两日前离线流量
    private BigInteger packageIncrementFlow;//流量包近两日实时流量
    private BigInteger packageIncrementContractFlow;//流量包对对应新合同近两日实时流量
    private String packageFlowName;//流量包名

    private Double packageFlowPercent;//流量包已使用百分比

    @Id
    @GeneratedValue
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getPackLevel() {
        return packLevel;
    }

    public void setPackLevel(Long packLevel) {
        this.packLevel = packLevel;
    }

    public Boolean getFlowRestrict() {
        return isFlowRestrict;
    }

    public void setFlowRestrict(Boolean flowRestrict) {
        isFlowRestrict = flowRestrict;
    }

    public String getPackageName() {
        return packageName;
    }

    public void setPackageName(String packageName) {
        this.packageName = packageName;
    }

    public String getOriginalName() {
        return originalName;
    }

    public void setOriginalName(String originalName) {
        this.originalName = originalName;
    }

    public BigInteger getIOLimit() {
        return IOLimit;
    }

    public void setIOLimit(BigInteger IOLimit) {
        this.IOLimit = IOLimit;
    }

    public String getPastDate() {
        return pastDate;
    }

    public void setPastDate(String pastDate) {
        this.pastDate = pastDate;
    }

    public BigInteger getTrackLimit() {
        return TrackLimit;
    }

    public void setTrackLimit(BigInteger trackLimit) {
        TrackLimit = trackLimit;
    }

    public Long getAccountId() {
        return accountId;
    }

    public void setAccountId(Long accountId) {
        this.accountId = accountId;
    }

    public int getPriceLevel() {
        return priceLevel;
    }

    public void setPriceLevel(int priceLevel) {
        this.priceLevel = priceLevel;
    }

    public int getiOremainingDays() {
        return iOremainingDays;
    }

    public void setiOremainingDays(int iOremainingDays) {
        this.iOremainingDays = iOremainingDays;
    }

    public int getTrackRemainingDays() {
        return trackRemainingDays;
    }

    public void setTrackRemainingDays(int trackRemainingDays) {
        this.trackRemainingDays = trackRemainingDays;
    }

    public BigInteger getTrackTotalFlow() {
        return TrackTotalFlow;
    }

    public void setTrackTotalFlow(BigInteger trackTotalFlow) {
        TrackTotalFlow = trackTotalFlow;
    }

    public BigInteger getThisMonthIOFlow() {
        return thisMonthIOFlow;
    }

    public void setThisMonthIOFlow(BigInteger thisMonthIOFlow) {
        this.thisMonthIOFlow = thisMonthIOFlow;
    }

    public Double getTrackRemainPercent() {
        return trackRemainPercent;
    }

    public void setTrackRemainPercent(Double trackRemainPercent) {
        this.trackRemainPercent = trackRemainPercent;
    }

    public Double getIORemainPercent() {
        return IORemainPercent;
    }

    public void setIORemainPercent(Double IORemainPercent) {
        this.IORemainPercent = IORemainPercent;
    }

    public BigInteger getLastMonthIOFlow() {
        return lastMonthIOFlow;
    }

    public void setLastMonthIOFlow(BigInteger lastMonthIOFlow) {
        this.lastMonthIOFlow = lastMonthIOFlow;
    }

    public Boolean getTrackPastTimeNotified() {
        return isTrackPastTimeNotified;
    }

    public void setTrackPastTimeNotified(Boolean trackPastTimeNotified) {
        isTrackPastTimeNotified = trackPastTimeNotified;
    }

    public Boolean getIOPastTimeNotified() {
        return isIOPastTimeNotified;
    }

    public void setIOPastTimeNotified(Boolean IOPastTimeNotified) {
        isIOPastTimeNotified = IOPastTimeNotified;
    }

    public Boolean getTrackFlowNotified() {
        return isTrackFlowNotified;
    }

    public void setTrackFlowNotified(Boolean trackFlowNotified) {
        isTrackFlowNotified = trackFlowNotified;
    }

    public Boolean getIOFlowNotified() {
        return isIOFlowNotified;
    }

    public void setIOFlowNotified(Boolean IOFlowNotified) {
        isIOFlowNotified = IOFlowNotified;
    }

    public Boolean getAllowBehavior() {
        return allowBehavior;
    }

    public void setAllowBehavior(Boolean allowBehavior) {
        this.allowBehavior = allowBehavior;
    }

    public Boolean getSuperLevel() {
        return superLevel;
    }

    public void setSuperLevel(Boolean superLevel) {
        this.superLevel = superLevel;
    }

    public Date getModifyTime() {
        return modifyTime;
    }

    public void setModifyTime(Date modifyTime) {
        this.modifyTime = modifyTime;
    }

    @Transient
    public Boolean getIoPastTime() {
        return ioPastTime;
    }

    public void setIoPastTime(Boolean ioPastTime) {
        this.ioPastTime = ioPastTime;
    }

    @Transient
    public Boolean getTrackPastTime() {
        return trackPastTime;
    }

    public void setTrackPastTime(Boolean trackPastTime) {
        this.trackPastTime = trackPastTime;
    }

    @Transient
    public Boolean getIoFlow() {
        return ioFlow;
    }

    public void setIoFlow(Boolean ioFlow) {
        this.ioFlow = ioFlow;
    }

    @Transient
    public Boolean getTrackFlow() {
        return trackFlow;
    }

    public void setTrackFlow(Boolean trackFlow) {
        this.trackFlow = trackFlow;
    }


    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Transient
    public Account getRootAccoount() {
        return rootAccoount;
    }

    public void setRootAccoount(Account rootAccoount) {
        this.rootAccoount = rootAccoount;
    }

    @Transient
    public PackageType getPackageType() {
        return packageType;
    }

    public void setPackageType(PackageType packageType) {
        this.packageType = packageType;
    }

    @Transient
    public String getFirstDayOfThisMonth() {
        return firstDayOfThisMonth;
    }

    public void setFirstDayOfThisMonth(String firstDayOfThisMonth) {
        this.firstDayOfThisMonth = firstDayOfThisMonth;
    }

    @Transient
    public int getRemainDays() {
        return remainDays;
    }

    public void setRemainDays(int remainDays) {
        this.remainDays = remainDays;
    }

    public BigInteger getIncrementFlow() {
        return incrementFlow;
    }

    public void setIncrementFlow(BigInteger incrementFlow) {
        this.incrementFlow = incrementFlow;
    }


    public String getTrackNotifyFlag() {
        return trackNotifyFlag;
    }

    public void setTrackNotifyFlag(String trackNotifyFlag) {
        this.trackNotifyFlag = trackNotifyFlag;
    }

    public String getTrackTipshowFlag() {
        return trackTipshowFlag;
    }

    public void setTrackTipshowFlag(String trackTipshowFlag) {
        this.trackTipshowFlag = trackTipshowFlag;
    }

    public BigInteger getIncrementToday() {
        return incrementToday;
    }

    public void setIncrementToday(BigInteger incrementToday) {
        this.incrementToday = incrementToday;
    }

    public BigInteger getIncrementContanct() {
        return incrementContanct;
    }

    public void setIncrementContanct(BigInteger incrementContanct) {
        this.incrementContanct = incrementContanct;
    }

    public Boolean getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Boolean delFlag) {
        this.delFlag = delFlag;
    }

    public Integer getPackageFlowId() {
        return packageFlowId;
    }

    public void setPackageFlowId(Integer packageFlowId) {
        this.packageFlowId = packageFlowId;
    }

    public BigInteger getPackageLimit() {
        return packageLimit;
    }

    public void setPackageLimit(BigInteger packageLimit) {
        this.packageLimit = packageLimit;
    }

    public BigInteger getPackageTotalFlow() {
        return packageTotalFlow;
    }

    public void setPackageTotalFlow(BigInteger packageTotalFlow) {
        this.packageTotalFlow = packageTotalFlow;
    }

    public BigInteger getPackageIncrementFlow() {
        return packageIncrementFlow;
    }

    public Date getEtlFlowModifyTime() {
        return etlFlowModifyTime;
    }

    public void setEtlFlowModifyTime(Date etlFlowModifyTime) {
        this.etlFlowModifyTime = etlFlowModifyTime;
    }

    public void setPackageIncrementFlow(BigInteger packageIncrementFlow) {
        this.packageIncrementFlow = packageIncrementFlow;
    }

    public String getPackageFlowName() {
        return packageFlowName;
    }

    public void setPackageFlowName(String packageFlowName) {
        this.packageFlowName = packageFlowName;
    }

    public BigInteger getPackageContractTotalFlow() {
        return packageContractTotalFlow;
    }

    public void setPackageContractTotalFlow(BigInteger packageContractTotalFlow) {
        this.packageContractTotalFlow = packageContractTotalFlow;
    }

    public BigInteger getPackageIncrementContractFlow() {
        return packageIncrementContractFlow;
    }

    public void setPackageIncrementContractFlow(BigInteger packageIncrementContractFlow) {
        this.packageIncrementContractFlow = packageIncrementContractFlow;
    }

    @Transient
    public Double getPackageFlowPercent() {
        return packageFlowPercent;
    }

    public void setPackageFlowPercent(Double packageFlowPercent) {
        this.packageFlowPercent = packageFlowPercent;
    }

}
