package com.reyun.model;

import com.fasterxml.jackson.annotation.JsonIdentityInfo;
import com.fasterxml.jackson.annotation.ObjectIdGenerators;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;

@JsonIdentityInfo(generator=ObjectIdGenerators.IntSequenceGenerator.class, property="@id")
@Entity
public class App {

	private Long id;
	@NotNull
	private String name;
	private String platform;
	private String appGenre;
	private String appGenreName;
	private String gameGenre;
	//private String gameCategory;
	private String appkey;
	private String url;
	private Long account;
	private boolean sync;
	// private boolean isActive;
	private Long origiApp;
	private String bundleid;
	private String token;
	private String installtoken;
	private boolean regedbutton;

	private Date createTime = new Date();
	private String createAccount;
	private Date modifyTime = new Date();
	private String modifyAccount;
	private Boolean delFlag;
    //是否同步DDB
    private Boolean syncDdb;

    private Long installNum;
    private Long registerNum;
    //是够是debug模式 true 是测试,false不是测试
    private Boolean isDebug;

	private Boolean trackAndIoBothExhaust;
    private Boolean mainAccountExpire;

	private Boolean distributeTask;
	private Date distributeTime;

	private String tagType;
	//行业
	private String industory;

	private String debugDate;

	private List<AppTag> appTagList;

	private Integer sort;

	private Long rootParent;

	private String mipAppid;

	private String mipSecret;

	private String accessToken;

	private String tokenMessage;

	private Boolean tokenValid;

	private Boolean appValid;
	private String invalidMessage;

	private String erroMessage;
	private Boolean isDeepLink;
	private Boolean whetherOnline;
	private Boolean whetherAppointmentMonitor;
	private String onlineDate;
	private Boolean waitStopCampaign;

	public Long getRootParent() {
		return rootParent;
	}

	public void setRootParent(Long rootParent) {
		this.rootParent = rootParent;
	}

	public Integer getSort() {
		return sort;
	}

	public void setSort(Integer sort) {
		this.sort = sort;
	}

	public App() {
		super();
	}

	public App(String name, String platform, String appGenre, String gameGenre) {
		this.name = name;
		this.platform = platform;
		this.appGenre = appGenre;
		this.gameGenre = gameGenre;
	}

	public App(String name, String platform, String appGenre, String gameGenre,
			   Long account) {
		this.name = name;
		this.platform = platform;
		this.appGenre = appGenre;
		this.gameGenre = gameGenre;
		this.account = account;
	}

	public Long getAccount() {
		return account;
	}

	public String getAppGenre() {
		return appGenre;
	}

	@Transient
	public String getAppGenreName() {
		return appGenreName;
	}

	public void setAppGenreName(String appGenreName) {
		this.appGenreName = appGenreName;
	}

    @Transient
    public String getErroMessage() {
        return erroMessage;
    }

    public void setErroMessage(String erroMessage) {
        this.erroMessage = erroMessage;
    }

    public String getAppkey() {
		return appkey;
	}

	public String getGameGenre() {
		return gameGenre;
	}

	@Id
	@GeneratedValue
	public Long getId() {
		return id;
	}

	public String getName() {
		return name;
	}

	public String getPlatform() {
		return platform;
	}

	public String getUrl() {
		return url;
	}

	public boolean isSync() {
		return sync;
	}

	public void setAccount(Long account) {
		this.account = account;
	}

	public void setAppGenre(String appGenre) {
		this.appGenre = appGenre;
	}

	public void setAppkey(String appkey) {
		this.appkey = appkey;
	}

	public void setGameGenre(String gameGenre) {
		this.gameGenre = gameGenre;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setPlatform(String platform) {
		this.platform = platform;
	}

	public void setSync(boolean sync) {
		this.sync = sync;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public Long getOrigiApp() {
		return origiApp;
	}

	public void setOrigiApp(Long origiApp) {
		this.origiApp = origiApp;
	}

	public String getBundleid() {
		return bundleid;
	}

	public void setBundleid(String bundleid) {
		this.bundleid = bundleid;
	}

	public String getToken() {
		return token;
	}

	public void setToken(String token) {
		this.token = token;
	}

	public boolean isRegedbutton() {
		return regedbutton;
	}

	public void setRegedbutton(boolean regedbutton) {
		this.regedbutton = regedbutton;
	}

	public String getInstalltoken() {
		return installtoken;
	}

	public void setInstalltoken(String installtoken) {
		this.installtoken = installtoken;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public String getCreateAccount() {
		return createAccount;
	}

	public void setCreateAccount(String createAccount) {
		this.createAccount = createAccount;
	}

	public Date getModifyTime() {
		return modifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		this.modifyTime = modifyTime;
	}

	public String getModifyAccount() {
		return modifyAccount;
	}

	public void setModifyAccount(String modifyAccount) {
		this.modifyAccount = modifyAccount;
	}

	public Boolean getDelFlag() {
		return delFlag;
	}

	public void setDelFlag(Boolean delFlag) {
		this.delFlag = delFlag;
	}

    public Boolean getIsDebug() {
        return this.isDebug;
    }

    public void setIsDebug(Boolean isDebug) {
        this.isDebug = isDebug;
    }

    public Boolean getSyncDdb() {
        return syncDdb;
    }

    public void setSyncDdb(Boolean syncDdb) {
        this.syncDdb = syncDdb;
    }

	@Transient
	public Boolean getTrackAndIoBothExhaust() {
		return trackAndIoBothExhaust;
	}

	public void setTrackAndIoBothExhaust(Boolean trackAndIoBothExhaust) {
		this.trackAndIoBothExhaust = trackAndIoBothExhaust;
	}

	@Transient
	public Boolean getMainAccountExpire() {
		return mainAccountExpire;
	}

	public void setMainAccountExpire(Boolean mainAccountExpire) {
		this.mainAccountExpire = mainAccountExpire;
	}

	@Transient
    public Long getInstallNum() {
        return installNum;
    }

    public void setInstallNum(Long installNum) {
        this.installNum = installNum;
    }

    @Transient
    public Long getRegisterNum() {
        return registerNum;
    }

    public void setRegisterNum(Long registerNum) {
        this.registerNum = registerNum;
    }

	public Boolean getDebug() {
		return isDebug;
	}

	public void setDebug(Boolean debug) {
		isDebug = debug;
	}

	public Boolean getDistributeTask() {
		return distributeTask;
	}

	public void setDistributeTask(Boolean distributeTask) {
		this.distributeTask = distributeTask;
	}

	public String getIndustory() {
		return industory;
	}

	public void setIndustory(String industory) {
		this.industory = industory;
	}

	public Date getDistributeTime() {
		return distributeTime;
	}

	public void setDistributeTime(Date distributeTime) {
		this.distributeTime = distributeTime;
	}

	@OneToMany(targetEntity = AppTag.class,fetch = FetchType.EAGER, cascade = CascadeType.DETACH)
	@JoinColumn(name = "app", referencedColumnName = "id", insertable = false, updatable = false)
	public List<AppTag> getAppTagList() {
		return appTagList;
	}

	public void setAppTagList(List<AppTag> appTagList) {
		this.appTagList = appTagList;
	}

	public String getTagType() {
		return tagType;
	}

	public void setTagType(String tagType) {
		this.tagType = tagType;
	}

	public String getDebugDate() {
		return debugDate;
	}

	public void setDebugDate(String debugDate) {
		this.debugDate = debugDate;
	}

	public String getMipAppid() {
		return mipAppid;
	}

	public void setMipAppid(String mipAppid) {
		this.mipAppid = mipAppid;
	}

	public String getMipSecret() {
		return mipSecret;
	}

	public void setMipSecret(String mipSecret) {
		this.mipSecret = mipSecret;
	}

	@Lob
	@Column(columnDefinition="TEXT")
	public String getAccessToken() {
		return accessToken;
	}

	@Lob
	@Column(columnDefinition="TEXT")
	public String getTokenMessage() {
		return tokenMessage;
	}

	public void setTokenMessage(String tokenMessage) {
		this.tokenMessage = tokenMessage;
	}

	public void setAccessToken(String accessToken) {
		this.accessToken = accessToken;
	}

	public Boolean getTokenValid() {
		return tokenValid;
	}

	public void setTokenValid(Boolean tokenValid) {
		this.tokenValid = tokenValid;
	}

	public Boolean getAppValid() {
		return appValid;
	}

	public void setAppValid(Boolean appValid) {
		this.appValid = appValid;
	}

	@Lob
	@Column(columnDefinition="TEXT")
	public String getInvalidMessage() {
		return invalidMessage;
	}

	public void setInvalidMessage(String invalidMessage) {
		this.invalidMessage = invalidMessage;
	}

	@Transient
	public Boolean getIsDeepLink() {
		return isDeepLink;
	}

	public void setIsDeepLink(Boolean deepLink) {
		isDeepLink = deepLink;
	}

	public Boolean getWhetherOnline() {
		return whetherOnline;
	}

	public void setWhetherOnline(Boolean whetherOnline) {
		this.whetherOnline = whetherOnline;
	}

	public Boolean getWhetherAppointmentMonitor() {
		return whetherAppointmentMonitor;
	}

	public void setWhetherAppointmentMonitor(Boolean whetherAppointmentMonitor) {
		this.whetherAppointmentMonitor = whetherAppointmentMonitor;
	}

	public String getOnlineDate() {
		return onlineDate;
	}

	public void setOnlineDate(String onlineDate) {
		this.onlineDate = onlineDate;
	}

	public Boolean getWaitStopCampaign() {
		return waitStopCampaign;
	}

	public void setWaitStopCampaign(Boolean waitStopCampaign) {
		this.waitStopCampaign = waitStopCampaign;
	}

	@Override
	public String toString() {
		return "App{" +
				"id=" + id +
				", name='" + name + '\'' +
				", platform='" + platform + '\'' +
				", appGenre='" + appGenre + '\'' +
				", appGenreName='" + appGenreName + '\'' +
				", gameGenre='" + gameGenre + '\'' +
				", appkey='" + appkey + '\'' +
				", url='" + url + '\'' +
				", account=" + account +
				", sync=" + sync +
				", origiApp=" + origiApp +
				", bundleid='" + bundleid + '\'' +
				", token='" + token + '\'' +
				", installtoken='" + installtoken + '\'' +
				", regedbutton=" + regedbutton +
				", createTime=" + createTime +
				", createAccount='" + createAccount + '\'' +
				", modifyTime=" + modifyTime +
				", modifyAccount='" + modifyAccount + '\'' +
				", delFlag=" + delFlag +
				", syncDdb=" + syncDdb +
				", installNum=" + installNum +
				", registerNum=" + registerNum +
				", isDebug=" + isDebug +
				", trackAndIoBothExhaust=" + trackAndIoBothExhaust +
				", mainAccountExpire=" + mainAccountExpire +
				", distributeTask=" + distributeTask +
				", distributeTime=" + distributeTime +
				", tagType='" + tagType + '\'' +
				", industory='" + industory + '\'' +
				", debugDate='" + debugDate + '\'' +
				", appTagList=" + appTagList +
				", sort=" + sort +
				", rootParent=" + rootParent +
				", mipAppid='" + mipAppid + '\'' +
				", mipSecret='" + mipSecret + '\'' +
				", accessToken='" + accessToken + '\'' +
				", tokenMessage='" + tokenMessage + '\'' +
				", tokenValid=" + tokenValid +
				", appValid=" + appValid +
				", invalidMessage='" + invalidMessage + '\'' +
				", erroMessage='" + erroMessage + '\'' +
				", isDeepLink=" + isDeepLink +
				", whetherOnline=" + whetherOnline +
				", whetherAppointmentMonitor=" + whetherAppointmentMonitor +
				", onlineDate='" + onlineDate + '\'' +
				'}';
	}
}
