package com.reyun.model;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.Date;

@Entity
public class CallbackCustomize {

	private Long id;
	private String name;
	private Long app;
	private Long channel;
	private boolean isAllData;
	private String what;
	private String url;
	private Long account;
	private String updatetime;
	private boolean active;
	private String pubdatetime;
	
	private String successcode;
	private String successkey;
	private String successvalue;
	private int iscallback = 0;
	private String callbackKey;
	private int timeout=500;
	
	private Date createTime = new Date();
    private String createAccount;
    private Date modifyTime = new Date();
    private String modifyAccount;
    private Boolean delFlag;
    private String channelName;
    private String event;
	private Integer special_nextday=0;
	private String special_event;

    private Integer hasPaymentAmount;
    private String erroMessage;


	public CallbackCustomize() {
		super();
	}


    public CallbackCustomize(Long id, String name, Long app, Long channel, String what, Long account, boolean active, String pubdatetime, Date createTime, Boolean delFlag) {
        this.id = id;
        this.name = name;
        this.app = app;
        this.channel = channel;
        this.what = what;
        this.account = account;
        this.active = active;
        this.pubdatetime = pubdatetime;
        this.createTime = createTime;
        this.delFlag = delFlag;
    }

    @Id
	@GeneratedValue
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Long getApp() {
		return app;
	}

	public void setApp(Long app) {
		this.app = app;
	}

	public Long getChannel() {
		return channel;
	}

	public void setChannel(Long channel) {
		this.channel = channel;
	}
	

	public boolean isAllData() {
		return isAllData;
	}

	public void setAllData(boolean isAllData) {
		this.isAllData = isAllData;
	}

	public String getWhat() {
		return what;
	}

	public void setWhat(String what) {
		this.what = what;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public Long getAccount() {
		return account;
	}

	public void setAccount(Long account) {
		this.account = account;
	}

	public String getUpdatetime() {
		return updatetime;
	}

	public void setUpdatetime(String updatetime) {
		this.updatetime = updatetime;
	}

	public boolean isActive() {
		return active;
	}

	public void setActive(boolean active) {
		this.active = active;
	}

	public String getPubdatetime() {
		return pubdatetime;
	}

	public void setPubdatetime(String pubdatetime) {
		this.pubdatetime = pubdatetime;
	}

	public String getSuccesscode() {
		return successcode;
	}

	public void setSuccesscode(String successcode) {
		this.successcode = successcode;
	}

	public String getSuccesskey() {
		return successkey;
	}

	public void setSuccesskey(String successkey) {
		this.successkey = successkey;
	}

	public String getSuccessvalue() {
		return successvalue;
	}

	public void setSuccessvalue(String successvalue) {
		this.successvalue = successvalue;
	}

	public int getTimeout() {
		return timeout;
	}

	public void setTimeout(int timeout) {
		this.timeout = timeout;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public String getCreateAccount() {
		return createAccount;
	}

	public void setCreateAccount(String createAccount) {
		this.createAccount = createAccount;
	}

	public Date getModifyTime() {
		return modifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		this.modifyTime = modifyTime;
	}

	public String getModifyAccount() {
		return modifyAccount;
	}

	public void setModifyAccount(String modifyAccount) {
		this.modifyAccount = modifyAccount;
	}

	public Boolean getDelFlag() {
		return delFlag;
	}

	public void setDelFlag(Boolean delFlag) {
		this.delFlag = delFlag;
	}

	public int getIscallback() {
		return iscallback;
	}

	public void setIscallback(int iscallback) {
		this.iscallback = iscallback;
	}

	public String getCallbackKey() {
		return callbackKey;
	}

	public void setCallbackKey(String callbackKey) {
		this.callbackKey = callbackKey;
	}

	@Transient
	public String getChannelName() {
		return channelName;
	}

	public void setChannelName(String channelName) {
		this.channelName = channelName;
	}

	public String getEvent() {
		return event;
	}

	public void setEvent(String event) {
		this.event = event;
	}

	public Integer getHasPaymentAmount() {
		return hasPaymentAmount;
	}

	public void setHasPaymentAmount(Integer hasPaymentAmount) {
		this.hasPaymentAmount = hasPaymentAmount;
	}

	@Transient
	public String getErroMessage() {
		return erroMessage;
	}

	public void setErroMessage(String erroMessage) {
		this.erroMessage = erroMessage;
	}

	@Transient
	public Integer getSpecial_nextday() {
		return special_nextday;
	}

	public void setSpecial_nextday(Integer special_nextday) {
		this.special_nextday = special_nextday;
	}

	@Transient
	public String getSpecial_event() {
		return special_event;
	}

	public void setSpecial_event(String special_event) {
		this.special_event = special_event;
	}

	@Override
	public String toString() {
		return "CallbackCustomize [id=" + id + ", name=" + name + ", app="
				+ app + ", channel=" + channel + ", isAllData=" + isAllData
				+ ", what=" + what + ", url=" + url + ", account=" + account
				+ ", updatetime=" + updatetime + ", active=" + active
				+ ", pubdatetime=" + pubdatetime + ", successcode="
				+ successcode + ", successkey=" + successkey
				+ ", successvalue=" + successvalue + ", timeout=" + timeout
				+ "]";
	}
	
	
}
