package com.reyun.model;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
 * Created by mxq on 2017/9/11.
 */
@Entity
public class ChannelParam {
    private Long id;
    //账号id
    private Long account;
    //渠道id
    private Long cid;
    //点击有效期
    private Integer clickDay;
    //激活匹配点击有效期
    private Integer ciDay;
    //激活有效期
    private Integer installDay;
    //广告作弊模型设置
    private Integer cilag;
    //激活IP离散度设置
    private Integer normalClick;
    //点击IP离散度设置
    private Integer normalInstall;
    //作弊参数设置状态
    private Boolean cheatStatus;
    //黑名单库状态
    private Boolean blacklistStatus;
    //防作弊等级
    private Integer blacklistLevel;
    //等级对应的渠道个数
    private Integer channelNum;

    //全局黑名单库状态
    private Boolean wholeBlacklistStatus;
    //全局
    private Integer wholeLevel;
    //全局等级对应的渠道个数
    private Integer wholeChannelNum;

    private Date modifyTime = new Date();
    private Long modifyAccount;

    private Boolean allChannelValidMatch;
    private Boolean allChannelFakeMatch;
    private Boolean allChannelBlackMatch;

    List<String> channelLevel;
    //关闭的渠道数
    List<String> channelLevelClosed;

    private Boolean impAttribute;

    private Boolean deviceBlackStatus;
    private Boolean wholeDeviceBlackStatus;
    //归因方式设置
    private Integer attrCfg;
    private Long app;
    private Integer backflowAttrNum = 604800;

    //预约归因参数 （用于展示）
    private Integer deadLineDays; // 默认两天
    private Integer priority; // 0 常规点击优先归因  1 预约点击优先归因(默认)
    private String onlineDate; // 预约上线时间

    @Id
    @GeneratedValue
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getAccount() {
        return account;
    }

    public void setAccount(Long account) {
        this.account = account;
    }

    public Long getCid() {
        return cid;
    }

    public void setCid(Long cid) {
        this.cid = cid;
    }

    public Integer getClickDay() {
        return clickDay;
    }

    public void setClickDay(Integer clickDay) {
        this.clickDay = clickDay;
    }

    public Integer getCiDay() {
        return ciDay;
    }

    public void setCiDay(Integer ciDay) {
        this.ciDay = ciDay;
    }

    public Integer getInstallDay() {
        return installDay;
    }

    public void setInstallDay(Integer installDay) {
        this.installDay = installDay;
    }

    public Integer getCilag() {
        return cilag;
    }

    public void setCilag(Integer cilag) {
        this.cilag = cilag;
    }

    public Integer getNormalClick() {
        return normalClick;
    }

    public void setNormalClick(Integer normalClick) {
        this.normalClick = normalClick;
    }

    public Integer getNormalInstall() {
        return normalInstall;
    }

    public void setNormalInstall(Integer normalInstall) {
        this.normalInstall = normalInstall;
    }

    public Boolean getCheatStatus() {
        return cheatStatus;
    }

    public void setCheatStatus(Boolean cheatStatus) {
        this.cheatStatus = cheatStatus;
    }

    public Boolean getBlacklistStatus() {
        return blacklistStatus;
    }

    public void setBlacklistStatus(Boolean blacklistStatus) {
        this.blacklistStatus = blacklistStatus;
    }

    public Integer getBlacklistLevel() {
        return blacklistLevel;
    }

    public void setBlacklistLevel(Integer blacklistLevel) {
        this.blacklistLevel = blacklistLevel;
    }

    public Integer getChannelNum() {
        return channelNum;
    }

    public void setChannelNum(Integer channelNum) {
        this.channelNum = channelNum;
    }

    public Date getModifyTime() {
        return modifyTime;
    }

    public void setModifyTime(Date modifyTime) {
        this.modifyTime = modifyTime;
    }

    public Long getModifyAccount() {
        return modifyAccount;
    }

    public void setModifyAccount(Long modifyAccount) {
        this.modifyAccount = modifyAccount;
    }

    @Transient
    public Boolean getAllChannelValidMatch() {
        return allChannelValidMatch;
    }

    public void setAllChannelValidMatch(Boolean allChannelValidMatch) {
        this.allChannelValidMatch = allChannelValidMatch;
    }

    @Transient
    public Boolean getAllChannelFakeMatch() {
        return allChannelFakeMatch;
    }

    public void setAllChannelFakeMatch(Boolean allChannelFakeMatch) {
        this.allChannelFakeMatch = allChannelFakeMatch;
    }

    @Transient
    public Boolean getAllChannelBlackMatch() {
        return allChannelBlackMatch;
    }

    public void setAllChannelBlackMatch(Boolean allChannelBlackMatch) {
        this.allChannelBlackMatch = allChannelBlackMatch;
    }

    @Transient
    public List<String> getChannelLevel() {
        return channelLevel;
    }

    public void setChannelLevel(List<String> channelLevel) {
        this.channelLevel = channelLevel;
    }

    @Transient
    public List<String> getChannelLevelClosed() {
        return channelLevelClosed;
    }

    public void setChannelLevelClosed(List<String> channelLevelClosed) {
        this.channelLevelClosed = channelLevelClosed;
    }

    public Integer getWholeLevel() {
        return wholeLevel;
    }

    public void setWholeLevel(Integer wholeLevel) {
        this.wholeLevel = wholeLevel;
    }

    public Boolean getWholeBlacklistStatus() {
        return wholeBlacklistStatus;
    }

    public void setWholeBlacklistStatus(Boolean wholeBlacklistStatus) {
        this.wholeBlacklistStatus = wholeBlacklistStatus;
    }

    public Integer getWholeChannelNum() {
        return wholeChannelNum;
    }

    public void setWholeChannelNum(Integer wholeChannelNum) {
        this.wholeChannelNum = wholeChannelNum;
    }

    public Boolean getImpAttribute() {
        return impAttribute;
    }

    public void setImpAttribute(Boolean impAttribute) {
        this.impAttribute = impAttribute;
    }

    public Boolean getDeviceBlackStatus() {
        return deviceBlackStatus;
    }

    public void setDeviceBlackStatus(Boolean deviceBlackStatus) {
        this.deviceBlackStatus = deviceBlackStatus;
    }

    public Boolean getWholeDeviceBlackStatus() {
        return wholeDeviceBlackStatus;
    }

    public void setWholeDeviceBlackStatus(Boolean wholeDeviceBlackStatus) {
        this.wholeDeviceBlackStatus = wholeDeviceBlackStatus;
    }

    public Long getApp() {
        return app;
    }

    public void setApp(Long app) {
        this.app = app;
    }

    public Integer getAttrCfg() {
        return attrCfg;
    }

    public void setAttrCfg(Integer attrCfg) {
        this.attrCfg = attrCfg;
    }

    public Integer getBackflowAttrNum() {
        return backflowAttrNum;
    }

    public void setBackflowAttrNum(Integer backflowAttrNum) {
        this.backflowAttrNum = backflowAttrNum;
    }

    @Override
    public String toString() {
        return "ChannelParam{" +
                "id=" + id +
                ", account=" + account +
                ", cid=" + cid +
                ", ciDay=" + ciDay +
                ", blacklistStatus=" + blacklistStatus +
                ", blacklistLevel=" + blacklistLevel +
                ", channelNum=" + channelNum +
                ", modifyTime=" + modifyTime +
                ", modifyAccount=" + modifyAccount +
                ", allChannelValidMatch=" + allChannelValidMatch +
                ", allChannelFakeMatch=" + allChannelFakeMatch +
                ", allChannelBlackMatch=" + allChannelBlackMatch +
                '}';
    }

    @Transient
    public Integer getDeadLineDays() {
        return deadLineDays;
    }

    public void setDeadLineDays(Integer deadLineDays) {
        this.deadLineDays = deadLineDays;
    }

    public Integer getPriority() {
        return priority;
    }

    @Transient
    public void setPriority(Integer priority) {
        this.priority = priority;
    }


    @Transient
    public String getOnlineDate() {
        return onlineDate;
    }

    public void setOnlineDate(String onlineDate) {
        this.onlineDate = onlineDate;
    }
}
