package com.reyun.model;

import com.reyun.dic.LanguageTypeEnum;
import org.apache.commons.lang.StringUtils;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;

/**
 * Created by sunhao on 18/5/17.
 * 回本分析的渠道
 */
@Entity
public class RecycleChannel {

    private Long id;
    //渠道ID
    private Long cid;
    //渠道名称
    private String name;
    //渠道唯一标示
    private String uniqueName;
    //实现类
    private String implementClass;
    //openAPI的客户端ID
    private String clientId;
    //OPEN API的客户端密钥
    private String clientSecret;
    //是否启用
    private Boolean enable;

    //多渠道对应的渠道id,中间用逗号分隔（如百度）
    private String mcCid;

    //多渠道对应的渠道名称,中间用逗号分隔（百度）
    private String mcUniqueName;

    private String engName = "";//英文名

    @Id
    @GeneratedValue
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getCid() {
        return cid;
    }

    public void setCid(Long cid) {
        this.cid = cid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getUniqueName() {
        return uniqueName;
    }

    public void setUniqueName(String uniqueName) {
        this.uniqueName = uniqueName;
    }

    public String getImplementClass() {
        return implementClass;
    }

    public void setImplementClass(String implementClass) {
        this.implementClass = implementClass;
    }

    public String getClientId() {
        return clientId;
    }

    public void setClientId(String clientId) {
        this.clientId = clientId;
    }

    public String getClientSecret() {
        return clientSecret;
    }

    public void setClientSecret(String clientSecret) {
        this.clientSecret = clientSecret;
    }

    public Boolean getEnable() {
        return enable;
    }

    public void setEnable(Boolean enable) {
        this.enable = enable;
    }
    public String getMcCid() {
        return mcCid;
    }

    public void setMcCid(String mcCid) {
        this.mcCid = mcCid;
    }

    public String getMcUniqueName() {
        return mcUniqueName;
    }

    public void setMcUniqueName(String mcUniqueName) {
        this.mcUniqueName = mcUniqueName;
    }

    public String getEngName() {
        return engName;
    }

    public void setEngName(String engName) {
        this.engName = engName;
    }

    public RecycleChannel() {
    }

    public RecycleChannel(RecycleChannel recycleChannel) {
        this.id = recycleChannel.getId();
        this.cid = recycleChannel.getCid();
        this.name = recycleChannel.getName();
        this.uniqueName = recycleChannel.getUniqueName();
        this.implementClass = recycleChannel.getImplementClass();
        this.clientId = recycleChannel.getClientId();
        this.clientSecret = recycleChannel.getClientSecret();
        this.enable = recycleChannel.getEnable();
        this.mcCid = recycleChannel.getMcCid();
        this.mcUniqueName = recycleChannel.getMcUniqueName();
    }

    /**
     * @param recycleChannel
     * @param lanType(语种)
     * @return 转化语种后处理的channel
     * （前端默认使用name，此为中文，处理时将engName替换）
     */
    public RecycleChannel toTransEng(RecycleChannel recycleChannel, String lanType){
        if(recycleChannel == null){
            return  recycleChannel;
        }
        if(LanguageTypeEnum.ENGLISH.getCode().equals(lanType) && StringUtils.isNotEmpty(recycleChannel.getEngName())){
            recycleChannel.setName(recycleChannel.getEngName());
        }
        return recycleChannel;
    }
}
