package com.reyun.model;

import javax.persistence.*;
import java.util.Date;
import java.util.List;

@Entity
public class Region {

	private Long id;
	private String regionKey;//地区的简写
	private String regionValue;//地区的说明
	private Long rootNode;//上级区域id
	private Integer level;//地域等级（1为最高级）
	private Integer regionIndex;//排序（用于调整地域的展示顺序）
	private Date ctime;//创建时间
	private Boolean isShow = true;//是否展示（1可用  0不可用）
	private String showValue;//用于前端展示（组合regionKey与regionValue）
	private List<Region> childRegions;

	@Id
	@GeneratedValue
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getRegionKey() {
		return regionKey;
	}

	public void setRegionKey(String regionKey) {
		this.regionKey = regionKey;
	}

	public String getRegionValue() {
		return regionValue;
	}

	public void setRegionValue(String regionValue) {
		this.regionValue = regionValue;
	}

	public Long getRootNode() {
		return rootNode;
	}

	public void setRootNode(Long rootNode) {
		this.rootNode = rootNode;
	}

	public Integer getLevel() {
		return level;
	}

	public void setLevel(Integer level) {
		this.level = level;
	}

	public Integer getRegionIndex() {
		return regionIndex;
	}

	public void setRegionIndex(Integer regionIndex) {
		this.regionIndex = regionIndex;
	}

	public Date getCtime() {
		return ctime;
	}

	public void setCtime(Date ctime) {
		this.ctime = ctime;
	}

	@Transient
	public String getShowValue() {
		showValue = regionValue + " ("+regionKey+")";
		return showValue;
	}

	public void setShowValue(String showValue) {
		this.showValue = showValue;
	}

	@Transient
	public List<Region> getChildRegions() {
		return childRegions;
	}

	public void setChildRegions(List<Region> childRegions) {
		this.childRegions = childRegions;
	}

	@Column(name = "is_show")
	public Boolean getShow() {
		return isShow;
	}

	public void setShow(Boolean show) {
		isShow = show;
	}
}
