package com.reyun.model;

import com.reyun.dic.LanguageTypeEnum;
import org.apache.commons.lang.StringUtils;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;

/**
 * Created by sunhao on 17/6/6.
 * description:角色权限的详情
 */
@Entity
public class RoleAuthDetail {

    private Long id;
    private String auth;
    private String authName;
    private String parentAuth;
    private int sort;
    private Boolean view;
    private Boolean edit;
    private Long roleId;
    private String engAuthName = "";

    public RoleAuthDetail() {}

    public RoleAuthDetail(RoleAuthDetail roleAuthDetail) {
        this.auth = roleAuthDetail.getAuth();
        this.authName = roleAuthDetail.getAuthName();
        this.engAuthName = roleAuthDetail.getEngAuthName();
        this.parentAuth = roleAuthDetail.getParentAuth();
        this.sort = roleAuthDetail.getSort();
        this.view = roleAuthDetail.getView();
        this.edit = roleAuthDetail.getEdit();
        this.roleId = roleAuthDetail.getRoleId();
    }

    @Id
    @GeneratedValue
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getAuth() {
        return auth;
    }

    public void setAuth(String auth) {
        this.auth = auth;
    }

    public String getAuthName() {
        return authName;
    }

    public void setAuthName(String authName) {
        this.authName = authName;
    }

    public String getParentAuth() {
        return parentAuth;
    }

    public void setParentAuth(String parentAuth) {
        this.parentAuth = parentAuth;
    }

    public int getSort() {
        return sort;
    }

    public void setSort(int sort) {
        this.sort = sort;
    }

    public Boolean getView() {
        return view;
    }

    public void setView(Boolean view) {
        this.view = view;
    }

    public Boolean getEdit() {
        return edit;
    }

    public void setEdit(Boolean edit) {
        this.edit = edit;
    }

    public Long getRoleId() {
        return roleId;
    }

    public void setRoleId(Long roleId) {
        this.roleId = roleId;
    }

    public String getEngAuthName() {
        return engAuthName;
    }

    public void setEngAuthName(String engAuthName) {
        this.engAuthName = engAuthName;
    }

    /**
     * @param lanType(语种)
     * @return 转化语种后处理的RoleAuthDetail
     * （前端默认使用name，此为中文，处理时将engName替换）
     */
    public RoleAuthDetail toTransEng(RoleAuthDetail roleAuthDetail, String lanType){
        if(roleAuthDetail == null){
            return  roleAuthDetail;
        }
        if(LanguageTypeEnum.ENGLISH.getCode().equals(lanType) &&
                StringUtils.isNotEmpty(roleAuthDetail.getEngAuthName()) ){
            roleAuthDetail.setAuthName(roleAuthDetail.getEngAuthName());
        }
        return roleAuthDetail;
    }
}
