package com.reyun.model;

import com.reyun.dic.LanguageTypeEnum;
import org.apache.commons.lang.StringUtils;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;


@Entity
public class Tip {

	private Long id;
	private String menu;
	private String key;
	private String tip;
	private String engKey = "";
	private String engTip = "";
	private String platFormExt = "";// 用于处理小游戏、小程序指标文案
	private String pageTitle = "0";
	private String helpPage ="0";
	
	@Id
	@GeneratedValue
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public String getMenu() {
		return menu;
	}
	public void setMenu(String menu) {
		this.menu = menu;
	}
	@Column(name="`key`")
	public String getKey() {
		return key;
	}
	public void setKey(String key) {
		this.key = key;
	}
	public String getTip() {
		return tip;
	}
	public void setTip(String tip) {
		this.tip = tip;
	}

    public String getEngKey() {
        return engKey;
    }

    public void setEngKey(String engKey) {
        this.engKey = engKey;
    }

    public String getEngTip() {
        return engTip;
    }

    public void setEngTip(String engTip) {
        this.engTip = engTip;
    }

    public String getPlatFormExt() {
        return platFormExt;
    }

    public void setPlatFormExt(String platFormExt) {
        this.platFormExt = platFormExt;
    }

	public String getPageTitle() {
		return pageTitle;
	}

	public void setPageTitle(String pageTitle) {
		this.pageTitle = pageTitle;
	}

	public String getHelpPage() {
		return helpPage;
	}

	public void setHelpPage(String helpPage) {
		this.helpPage = helpPage;
	}

	/**
	 * @param lanType(语种)
	 * @return 转化语种后处理的channel
	 * （前端默认使用name，此为中文，处理时将engName替换）
	 */
	public Tip toTransEng(Tip tip, String lanType){
		if(tip == null){
			return  tip;
		}
		if(LanguageTypeEnum.ENGLISH.getCode().equals(lanType) &&
				(StringUtils.isNotEmpty(tip.getEngKey()) || StringUtils.isNotEmpty(tip.getEngTip()))){
			tip.setKey(tip.getEngKey());
			tip.setTip(tip.getEngTip());
		}
		return tip;
	}

}
