package com.reyun.report;

import com.google.common.collect.ImmutableList;
import com.reyun.model.ReportChartResult;

import java.util.Arrays;
import java.util.List;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public abstract class AbstractChartReportParse extends AbstractReportParse {
    private final List REPORT_CAMPAIGN = ImmutableList.of();
    private final List REPORT_CAMPAIGN_GROUP = ImmutableList.of();
    private final List REPORT_CHANNEL = ImmutableList.of();
    /**
     * 解析报表串
     *
     * @param reportResult
     * @return
     */
    public abstract ReportChartResult parse(ReportChartResult reportResult, Long app, Long account, String reportName);

    protected boolean isReplaceLableName(String name) {
        List itemlist =  Arrays.asList("channelinfo_amount_top5_byds","channelinfo_payer_top5_byds","channelinfo_reged_top5_byds",
                "rate_channelinfo_install_top5_byds","channelinfo_install_top5_byds","channelinfo_click_top5_byds",
                "channelinfo_click_top5_byhour", "channelinfo_install_top5_byhour", "rate_channelinfo_install_top5_byhour",
                "channelinfo_reged_top5_byhour", "channelinfo_payer_top5_byhour", "channelinfo_amount_top5_byhour",
                "h5_channel_top5_click_byhour","h5_channel_top5_pv_byhour","h5_channel_top5_uv_byhour",
                "h5_channel_top5_ip_byhour","h5_channel_top5_newuser_byhour","h5_channel_top5_reged_byhour",
                "h5_channel_top5_payer_byhour","h5_channel_top5_amount_byhour","h5_channel_top5_click_byds",
                "h5_channel_top5_pv_byds","h5_channel_top5_uv_byds","h5_channel_top5_ip_byds","h5_channel_top5_newuser_byds",
                "h5_channel_top5_reged_byds","h5_channel_top5_payer_byds","h5_channel_top5_amount_byds"
                ,"channelinfo_order_top5_byhour","channelinfo_order_top5_byds","channelinfo_device_top5_byhour",
                "channelinfo_device_top5_byds", "channelinfo_amt_top5_byhour","channelinfo_amt_top5_byds","channelinfo_ticket_top5_byhour","channelinfo_ticket_top5_byds",
                "channelinfo_rate_top5_byhour","channelinfo_rate_top5_byds",
                "recycle_dashboard_expense_trend","recycle_dashboard_ecpa_trend","recycle_dashboard_payment_trend","recycle_dashboard_roi_trend",
                "wx_channel_top5_click_byds","wx_channel_top5_click_byhour",
                "wx_channel_top5_newuser_byds","wx_channel_top5_newuser_byhour",
                "wx_channel_top5_payer_byds","wx_channel_top5_payer_byhour","wx_channel_top5_pv_byds",
                "wx_channel_top5_pv_byhour","wx_channel_top5_reged_byds","wx_channel_top5_reged_byhour",
                "wx_channel_top5_uv_byds","wx_channel_top5_uv_byhour",
                "wx_channel_top5_amount_byds","wx_channel_top5_amount_byhour"
        );
        return itemlist.contains(name);
    }

    protected boolean isReplaceLableKey(String name) {
        List itemlist =  Arrays.asList("decision_potencial_top10_bychannel","channelinfo_base_top5_bychannel",
                "rate_channelinfo_install_top5_bychannel", "rate_channelinfo_retention_top5_bychannel",
                "delay_click_bycampaign", "channelincome_top10_bychannel", "channelinstall_top10_bychannel",
                "channelclick_top10_bychannel","h5_channel_top5_basic","h5_channel_top5_newuser","h5_channel_top5_flow",
                "h5_dashboard_income_top10_bychannel","h5_dashboard_newuser_top10_bychannel","h5_dashboard_channelclick_top10_bychannel"
                ,"channelinfo_ticket_top5_bychannel","channelinfo_amt_top5_bychannel","order_top10_bychannel",
                "order_amt_top10_bychannel","perticket_top10_bychannel","order_pay_rate_top10_bychannel",
                "wx_dashboard_channelclick_top10_bychannel","wx_dashboard_income_top10_bychannel","wx_dashboard_newuser_top10_bychannel",
                "wx_channel_top5_basic",
                "wx_channel_top5_bounce","wx_channel_top5_flow","black_top5_click_cid","black_top5_device_cid"
        );
        return itemlist.contains(name);
    }

    protected boolean isReplaceCampinName(String name){
        List itemlist =  Arrays.asList("black_top5_click_campaignid","black_top5_device_campaignid");
        return itemlist.contains(name);
    }

    protected boolean isReplaceCategoryNameFromKey(String name)
    {
        List itemList = ImmutableList.of("decision_potencial_bycategory");
        return itemList.contains(name);
    }


    protected boolean isReplaceScene(String name)
    {
        List itemlist =  Arrays.asList(
        "wx_dashboard_incomescene_top10","wx_dashboard_newuserscene_top10","wx_dashboard_openscene_top10"
        );
        return itemlist.contains(name);
    }

    protected boolean isReplaceWeiXinChannel(String name)
    {
        List itemlist =  Arrays.asList(
                "wx_dashboard_channelclick_top10_bychannel","wx_dashboard_income_top10_bychannel","wx_dashboard_newuser_top10_bychannel",
                "wx_channel_top5_amount_byds","wx_channel_top5_amount_byhour","wx_channel_top5_basic",
                "wx_channel_top5_bounce","wx_channel_top5_click_byds","wx_channel_top5_click_byhour",
                "wx_channel_top5_flow","wx_channel_top5_newuser_byds","wx_channel_top5_newuser_byhour",
                "wx_channel_top5_payer_byds","wx_channel_top5_payer_byhour","wx_channel_top5_pv_byds",
                "wx_channel_top5_pv_byhour","wx_channel_top5_reged_byds","wx_channel_top5_reged_byhour",
                "wx_channel_top5_uv_byds","wx_channel_top5_uv_byhour"
        );
        return itemlist.contains(name);
    }


}
