package com.reyun.report;

import com.google.common.base.Function;
import com.google.common.base.Strings;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.reyun.context.AppUtils;
import com.reyun.dic.ChannelCategoryEnumType;
import com.reyun.dic.KeywordsDataType;
import com.reyun.dic.RoleEnumType;
import com.reyun.model.*;
import com.reyun.repository.*;
import com.reyun.service.AuthService;
import com.reyun.service.CampaignGroupService;
import com.reyun.service.CampaignService;
import com.reyun.service.ChannelService;
import com.reyun.util.*;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public abstract class AbstractReportParse {

    protected AuthService authService = AppUtils.getApplicationContext().getBean(AuthService.class);
    protected CampaignService campaignService = AppUtils.getApplicationContext().getBean(CampaignService.class);
    protected ChannelService channelService = AppUtils.getApplicationContext().getBean(ChannelService.class);
    protected CampaignGroupService campaignGroupService = AppUtils.getApplicationContext().getBean(CampaignGroupService.class);
    protected CamCamgroupMapRepository camCamGroupMapRepository = AppUtils.getApplicationContext().getBean(CamCamgroupMapRepository.class);
    protected CampaignRepository campaignRepository = AppUtils.getApplicationContext().getBean(CampaignRepository.class);
    protected CategoryRepository categoryRepository = AppUtils.getApplicationContext().getBean(CategoryRepository.class);
    protected KeywordsCreativeRepository keywordsCreativeRepository = AppUtils.getApplicationContext().getBean(KeywordsCreativeRepository.class);
    protected PackageSubCampaignRepository packageSubCampaignRepository = AppUtils.getApplicationContext().getBean(PackageSubCampaignRepository.class);
    protected SceneRepository sceneRepository = AppUtils.getApplicationContext().getBean(SceneRepository.class);
    protected ChannelAccountMapRepository channelAccountMapRepository = AppUtils.getApplicationContext().getBean(ChannelAccountMapRepository.class);
    protected ServeridBackflowRepository serveridBackflowRepository = AppUtils.getApplicationContext().getBean(ServeridBackflowRepository.class);

    public List<Map<String, Object>> transCampaignName(List<Map<String, Object>> val, Long app, Long account) {
        return transName(val, app, account, true, false, false, false, false, false);
    }

    public List<Map<String, Object>> transCampaignGroupName(List<Map<String, Object>> val, Long app, Long account) {
        return transName(val, app, account, false, true, false, false, false, false);
    }

    public List<Map<String, Object>> transChannelName(List<Map<String, Object>> val, Long app, Long account) {
        return transName(val, app, account, false, false, true, false, false, true);
    }

    public List<Map<String, Object>> transServerName(List<Map<String, Object>> val, Long app, Long account,Map<String, String> conditions) {
        return transServeridName(val, app, account,conditions);
    }

    public List<Map<String, Object>> transChannelAdvertisinginName(List<Map<String, Object>> val, Long app, Long account) {
        return transChannelAdvertisingName(val, app, account);
        //return transName(val, app, account, false, false, true, false, false, false);

    }

    public List<Map<String, Object>> transRemarketingName(List<Map<String, Object>> val, Long app, Long account) {
        return transRemarketingChannelName(val, app, account);
        //return transName(val, app, account, false, false, true, false, false, false);

    }

    public List<Map<String, Object>> transChannelNameAddName(List<Map<String, Object>> val, Long app, Long account) {
        return transName(val, app, account, false, false, true, false, false, true);
    }

    public List<Map<String, Object>> transCampaignNameAddName(List<Map<String, Object>> val, Long app, Long account) {
        return transName(val, app, account, true, false, false, true, false, false);
    }

    public List<String> transChannelNameList(List<String> val, Long app, Long account) {
        Map<String, Channel> uniqueMap = getDicChannelMap(app);

        List<String> translist = Lists.newArrayList();
        for (String channelid : val) {
            final Channel channel = uniqueMap.get(channelid);
            if (channel == null) {
                translist.add(channelid);
            } else {
                translist.add(channel.getName());
            }
        }
        return translist;
    }

    public List<String> transSceneNameList(List<String> val, Long app, Long account) {
        List<Scene> allScene = sceneRepository.findAll();

        Map<String, Scene> uniqueMap = Maps.uniqueIndex(allScene, new Function<Scene, String>() {
            @Override
            public String apply(Scene scene) {
                return String.valueOf(scene.getSceneId());
            }
        });

        List<String> translist = Lists.newArrayList();
        for (String sceneid : val) {
            final Scene scene = uniqueMap.get(sceneid);
            if (scene == null) {
                translist.add(sceneid);
            } else {
                translist.add(scene.getSceneComment());
            }
        }
        return translist;
    }


    /**
     * 新的 激活率 计算方式 处理
     *
     * @param viewColumn
     * @param valMap
     * @param linkFieldValue2
     * @return
     */
    public Object getNewRateInstallData(String viewColumn, Map valMap, Object linkFieldValue2) {
        /*if(viewColumn.toLowerCase().equals("rate_install")){

            //【排重点击】=0 and 【按天排重点击】>0 and 【排重激活设备数】>0 ,激活率 = 【排重激活设备数】/【按天排重点击】
            // 原  激活率 = 【排重激活设备数】/【排重点击】
            String dupnum_click_all = valMap.get("dupnum_click_all")==null?"0":valMap.get("dupnum_click_all").toString();
            String dupnum_click_day = valMap.get("dupnum_click_day")==null?"0":valMap.get("dupnum_click_day").toString();
            String num_install = valMap.get("num_install")==null?"0":valMap.get("num_install").toString();

            if ("0".equals(dupnum_click_all)  && !"0".equals(dupnum_click_day)  && !"0".equals(num_install)) {

                return dupnum_click_day;
            } else {

                return linkFieldValue2;
            }
        }*/
        return linkFieldValue2;
    }


    public List<String> transCampaignNameList(List<String> val, Long app, Long account) {
        Map<String, Campaign> uniqueMap = getDicCampaignMap(app, account);

        List<String> translist = Lists.newArrayList();
        for (String cmpid : val) {
            final Campaign campaign = uniqueMap.get(cmpid);
            if (campaign == null) {
                translist.add(cmpid);
            } else {
                translist.add(campaign.getName());
            }
        }
        return translist;
    }

    public List<String> transCampaignNameListShortColum(List<String> val, Long app, Long account) {

        if (val == null || val.size() == 0) {
            return val;
        }

        List<Object[]> itemlist = campaignService.listAllCampaignObject(val, app, account);

        Map<String, String> dic = itemlist.stream().collect(Collectors.toMap(
                p -> p[0].toString(),
                p -> p[1].toString(),
                (key1, key2) -> key1));

        List<String> transName = new ArrayList<>();

        val.stream().forEach(v -> {

            String name = dic.get(v);

            if (name != null) {
                transName.add(name);
            } else {
                transName.add(v);
            }
        });

        return transName;

    }

    /**
     * 按照指定的维度，对report结果进行聚合.
     *
     * @param dimension                 指定的维度值
     * @param dimentionCampaignMapValue 这个维度值对应的推广活动id和推广活动对象 Map
     * @param valMap                    report结果数据
     * @param viewColumns               列
     * @return 指定维度值的聚合结果
     */
    public Map<String, Map<String, Object>> aggregateByDimension(String dimension, Map<String, Campaign> dimentionCampaignMapValue, Map<String, Map<String, Object>> valMap, List<String> viewColumns, Map<String, Object> totalResult) {
        Map<String, Map<String, Object>> result = new HashMap<>();
        Map<String, Object> tmpResultValue = null;

        if (null != dimentionCampaignMapValue) {

            for (String campaignId : dimentionCampaignMapValue.keySet()) {

                Map<String, Object> valMapValue = valMap.get(campaignId);

                if (null == valMapValue) {
                    continue;
                }

                //匹配report返回的数据到结果集中
                if (null == tmpResultValue) {

                    tmpResultValue = Maps.newHashMap();
                    //copy过去
                    for (String viewColumn : valMapValue.keySet()) {
                        Object value = valMapValue.get(viewColumn);
                        tmpResultValue.put(viewColumn, value);
                        if (totalResult != null) {
                            if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {

                                totalResult.put(viewColumn, new java.text.DecimalFormat("0.00").format(Double.valueOf(String.valueOf(value)) +
                                        (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d)));
                            } else if (value instanceof Long || tmpResultValue.get(viewColumn) instanceof Long) {

                                totalResult.put(viewColumn, Long.valueOf(String.valueOf(value)) +
                                        (totalResult.containsKey(viewColumn) ? Long.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0));
                            }
                        }
                    }
                } else {

                    //数字字段数据累加
                    for (String viewColumn : tmpResultValue.keySet()) {

                        Object value = valMapValue.get(viewColumn);

                        if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {

                            tmpResultValue.put(viewColumn, new java.text.DecimalFormat("0.00").format(Double.valueOf(String.valueOf(value)) +
                                    Double.valueOf(String.valueOf(tmpResultValue.get(viewColumn)))));

                            if (totalResult != null) {
                                totalResult.put(viewColumn, Double.valueOf(String.valueOf(value))
                                        + (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d));
                            }
                        } else if (value instanceof Long || tmpResultValue.get(viewColumn) instanceof Long) {

                            tmpResultValue.put(viewColumn, Long.valueOf(String.valueOf(value)) +
                                    Long.valueOf(String.valueOf(tmpResultValue.get(viewColumn))));

                            if (totalResult != null) {
                                totalResult.put(viewColumn, Long.valueOf(String.valueOf(value))
                                        + (totalResult.containsKey(viewColumn) ? Long.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0));
                            }
                        }
                    }
                }
            }
        }

        //账号数据为0的数据
        if (null == tmpResultValue) {

            List<String> viewColumnsTemp = new ArrayList<>();
            viewColumnsTemp.addAll(viewColumns);
            for (String viewColumn : viewColumns) {
                Collection<String> linkfields = ViewColumnDependUtil.getRateDependFields(viewColumn);
                if (linkfields != null && linkfields.size() > 0) {
                    String[] linkfield = new String[linkfields.size()];
                    linkfield = linkfields.toArray(linkfield);
                    if (!viewColumnsTemp.contains(linkfield[0])) viewColumnsTemp.add(linkfield[0]);
                    if (!viewColumnsTemp.contains(linkfield[1])) viewColumnsTemp.add(linkfield[1]);
                }
            }
            tmpResultValue = getAllZeroValue(viewColumnsTemp);
        }

        //计算rate,必须等上面合计完成后算rate
        tmpResultValue = calculateRate(tmpResultValue);
        tmpResultValue.put("campaignid", dimension);
        result.put("single", tmpResultValue);
        result.put("total", totalResult);
        return result;
    }

    /**
     * 按照指定的维度，对report结果进行聚合.
     *
     * @param dimension                 指定的维度值
     * @param dimentionCampaignMapValue 这个维度值对应的推广活动id和推广活动对象 Map
     * @param valMap                    report结果数据
     * @param viewColumns               列
     * @return 指定维度值的聚合结果
     */
    public Map<String, Map<String, Object>> aggregateByDimensionCam(String dimension, Map<String, Campaign> dimentionCampaignMapValue, Map<String, Map<String, Object>> valMap, List<String> viewColumns, Map<String, Object> totalResult) {
        Map<String, Map<String, Object>> result = new HashMap<>();
        Map<String, Object> tmpResultValue = null;

        if (null != dimentionCampaignMapValue) {

            for (String campaignId : dimentionCampaignMapValue.keySet()) {

                Map<String, Object> valMapValue = valMap.get(campaignId);

                if (null == valMapValue) {
                    continue;
                }

                //匹配report返回的数据到结果集中
                if (null == tmpResultValue) {

                    tmpResultValue = Maps.newHashMap();
                    //copy过去
                    for (String viewColumn : valMapValue.keySet()) {
                        Object value = valMapValue.get(viewColumn);
                        tmpResultValue.put(viewColumn, value);
                        if (totalResult != null) {
                            if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {

                                totalResult.put(viewColumn, new java.text.DecimalFormat("0.00").format(Double.valueOf(String.valueOf(value)) +
                                        (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d)));
                            } else if (value instanceof Long || tmpResultValue.get(viewColumn) instanceof Long) {

                                totalResult.put(viewColumn, Long.valueOf(String.valueOf(value)) +
                                        (totalResult.containsKey(viewColumn) ? Long.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0));
                            }
                        }
                    }
                } else {

                    //数字字段数据累加
                    for (String viewColumn : tmpResultValue.keySet()) {

                        Object value = valMapValue.get(viewColumn);

                        if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {

                            tmpResultValue.put(viewColumn, new java.text.DecimalFormat("0.00").format(Double.valueOf(String.valueOf(value)) +
                                    Double.valueOf(String.valueOf(tmpResultValue.get(viewColumn)))));

                            if (totalResult != null) {
                                totalResult.put(viewColumn, Double.valueOf(String.valueOf(value))
                                        + (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d));
                            }
                        } else if (value instanceof Long || tmpResultValue.get(viewColumn) instanceof Long) {

                            tmpResultValue.put(viewColumn, Long.valueOf(String.valueOf(value)) +
                                    Long.valueOf(String.valueOf(tmpResultValue.get(viewColumn))));

                            if (totalResult != null) {
                                totalResult.put(viewColumn, Long.valueOf(String.valueOf(value))
                                        + (totalResult.containsKey(viewColumn) ? Long.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0));
                            }
                        }
                    }
                }
            }
        }

        //账号数据为0的数据
        if (null == tmpResultValue) {

            tmpResultValue = getAllZeroValue(viewColumns);
        }

        //计算rate,必须等上面合计完成后算rate
        tmpResultValue = calculateRateCam(tmpResultValue);
        tmpResultValue.put("campaignid", dimension);
        result.put("single", tmpResultValue);
        result.put("total", totalResult);
        return result;
    }

    public Map<String, Map<String, Object>> advertisingByDimension(Map<String, Object> valMapValue, List<String> viewColumns, Map<String, Object> totalResult) {
        Map<String, Map<String, Object>> result = new HashMap<>();
        Map<String, Object> tmpResultValue = null;


        //匹配report返回的数据到结果集中
        if (null == tmpResultValue) {

            tmpResultValue = Maps.newHashMap();
            //copy过去
            for (String viewColumn : valMapValue.keySet()) {
                Object value = valMapValue.get(viewColumn);
                tmpResultValue.put(viewColumn, value);
                if (totalResult != null) {
                    if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {

                        totalResult.put(viewColumn, new java.text.DecimalFormat("0.00").format(Double.valueOf(String.valueOf(value)).doubleValue() +
                                (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))).doubleValue() : 0d)));
                    } else if (value instanceof Long || tmpResultValue.get(viewColumn) instanceof Long) {

                        totalResult.put(viewColumn, Long.valueOf(String.valueOf(value)) +
                                (totalResult.containsKey(viewColumn) ? Long.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0));
                    }
                }
            }
        } else {

            //数字字段数据累加
            for (String viewColumn : tmpResultValue.keySet()) {

                Object value = valMapValue.get(viewColumn);

                if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {

                    tmpResultValue.put(viewColumn, new java.text.DecimalFormat("0.00").format(Double.valueOf(String.valueOf(value)).doubleValue() +
                            Double.valueOf(String.valueOf(tmpResultValue.get(viewColumn))).doubleValue()));

                    if (totalResult != null) {
                        totalResult.put(viewColumn, Double.valueOf(String.valueOf(value))
                                + (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d));
                    }
                } else if (value instanceof Long || tmpResultValue.get(viewColumn) instanceof Long) {

                    tmpResultValue.put(viewColumn, Long.valueOf(String.valueOf(value)) +
                            Long.valueOf(String.valueOf(tmpResultValue.get(viewColumn))));

                    if (totalResult != null) {
                        totalResult.put(viewColumn, Long.valueOf(String.valueOf(value))
                                + (totalResult.containsKey(viewColumn) ? Long.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0));
                    }
                }
            }
        }

        //账号数据为0的数据
        if (null == tmpResultValue) {
            tmpResultValue = getAllZeroValue(viewColumns);
        }

        //计算rate,必须等上面合计完成后算rate
        tmpResultValue = calculateRate(tmpResultValue);
        result.put("single", tmpResultValue);
        result.put("total", totalResult);
        return result;
    }

    /**
     * 按照指定的维度，对report结果进行聚合.
     *
     * @param dimension 指定的维度值
     * @param valMap    report结果数据
     * @return 指定维度值的聚合结果
     */
    public Map<String, Map<String, Object>> aggregateBySingleDimension(String dimension, Map<String, Map<String, Object>> valMap,
                                                                       Map<String, Object> totalResult) {
        Map<String, Map<String, Object>> result = new HashMap<>();
        Map<String, Object> tmpResultValue = Maps.newHashMap();
        ;
        Map<String, Object> valMapValue = valMap.get(dimension);

        //匹配report返回的数据到结果集中
        for (String viewColumn : valMapValue.keySet()) {

            Object value = valMapValue.get(viewColumn);
            tmpResultValue.put(viewColumn, value);

            if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_ltv")) {

//                totalResult.put(viewColumn, new java.text.DecimalFormat("0.00").format(Double.valueOf(String.valueOf(value))
//                        + (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d)));

                totalResult.put(viewColumn, Double.valueOf(String.valueOf(value)) +
                        (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d));
            } else if (viewColumn.toLowerCase().startsWith("amt_")) {
                totalResult.put(viewColumn, new java.text.DecimalFormat("########0.00").format(Double.valueOf(String.valueOf(value))
                        + (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d)));
            } else if (value instanceof Long || tmpResultValue.get(viewColumn) instanceof Long) {

                totalResult.put(viewColumn, Long.valueOf(String.valueOf(value))
                        + (totalResult.containsKey(viewColumn) ? Long.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0));
            } else if (viewColumn.startsWith("avg_time")) {
                totalResult.put(viewColumn, Double.valueOf(String.valueOf(value)) +
                        (totalResult.containsKey(viewColumn) ? Double.valueOf(String.valueOf(totalResult.get(viewColumn))) : 0d));
            }
        }

        //计算rate,必须等上面合计完成后算rate
        tmpResultValue = calculateRate(tmpResultValue);
        tmpResultValue.put("campaignid", dimension);
        result.put("single", tmpResultValue);
        result.put("total", totalResult);
        return result;
    }

    public Map<String, Object> calculateRateForRateInstall(Map<String, Object> valMap) {
        return calculateRate(valMap);
    }

    /**
     * 相关百分比率的计算
     */
    public Map<String, Object> calculateRate(Map<String, Object> valMap) {

        boolean isAllZero = true;

        for (String viewColumn : valMap.keySet()) {


            Collection<String> linkfields = ViewColumnDependUtil.getRateDependFields(viewColumn);

            if (linkfields != null && linkfields.size() > 0) {

                Object[] objects = linkfields.toArray();
                String[] linkfield = Arrays.copyOf(objects, objects.length, String[].class);
                final Object f1 = valMap.get(linkfield[0]);
                final Object linkFieldValue2 = valMap.get(linkfield[1]);


                if (linkFieldValue2 != null) {
                    if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {
                        if (viewColumn.toLowerCase().startsWith("amt_ltv") || viewColumn.equals("amt_use_freq") || viewColumn.toLowerCase().equals("amt_pay_perticket") || viewColumn.toLowerCase().equals("amt_pay_perticket") || viewColumn.toLowerCase().equals("amt_time")
                                || (viewColumn.toLowerCase().startsWith("amt_arp") && viewColumn.toLowerCase().endsWith("_new"))) {
                            valMap.put(viewColumn, divideAmt((Double.valueOf(f1.toString())) / 100, Double.valueOf(String.valueOf(linkFieldValue2))));

//                            valMap.put(viewColumn, divideAmt((
//                                Double.valueOf(f1.toString())) / 100,
//                                Double.valueOf(String.valueOf(getNewRateInstallData(viewColumn,valMap,linkFieldValue2)))));

                        } else if ((viewColumn.toLowerCase().startsWith("rate_"))) {
                            if (!viewColumn.toLowerCase().equals("rate_install_fake")) {
                                if ("rate_roi".equals(viewColumn)) {
                                    valMap.put(viewColumn, divideAmt(Double.valueOf(f1.toString()), Double.valueOf(String.valueOf(getNewRateInstallData(viewColumn, valMap, linkFieldValue2)))));
                                } else {
                                    valMap.put(viewColumn, divide(Double.valueOf(f1.toString()), Double.valueOf(String.valueOf(getNewRateInstallData(viewColumn, valMap, linkFieldValue2)))));
                                }
                            }
                        }
                    } else if (viewColumn.toLowerCase().startsWith("avg_")) {
                        if (viewColumn.toLowerCase().startsWith("avg_time")) {
                            valMap.put(viewColumn, divideAvgTime(Long.valueOf(String.valueOf(f1.toString())), Long.valueOf(String.valueOf(linkFieldValue2))));
                            //valMap.put(viewColumn, DateUtil.formatCaseTime(Long.valueOf(valMap.get(viewColumn)==null?"0":String.valueOf(valMap.get(viewColumn)))));
                        }
                    } else {

                        if (f1.getClass().isAssignableFrom(Long.class)) {
                            valMap.put(viewColumn, divide((Long) f1, (Long) linkFieldValue2));
                        } else if (f1.getClass().isAssignableFrom(Double.class)) {
                            Double f1d = (Double) f1;
                            if ("activation_cost".equals(viewColumn)) {
                                f1d = f1d / 100;
                            }
                            valMap.put(viewColumn, divide(f1d, Double.valueOf(String.valueOf(linkFieldValue2))));
                        }

                    }
                } else {
                    valMap.put(viewColumn, 0.0d);
                }
            } else if (viewColumn.toLowerCase().equals("duration")) {
                valMap.put(viewColumn, DateUtil.formatCaseTime(Long.valueOf(valMap.get(viewColumn) == null ? "0" : valMap.get(viewColumn).toString())));
            }

            if (!"ds".equals(viewColumn) && !"campaignid".equals(viewColumn) && isAllZero) {
                Object tmpval = valMap.get(viewColumn);
                if (tmpval.getClass().isAssignableFrom(Double.class)) {
                    if ((Double) tmpval > 0) {
                        isAllZero = false;
                    }
                } else if (tmpval.getClass().isAssignableFrom(Long.class)) {
                    if ((Long) tmpval > 0) {
                        isAllZero = false;
                    }
                }
            }
        }

        valMap.put("isall0", isAllZero);

        return valMap;
    }

    /**
     * 相关百分比率的计算
     */
    public Map<String, Object> calculateRateCam(Map<String, Object> valMap) {

        boolean isAllZero = true;

        for (String viewColumn : valMap.keySet()) {


            Collection<String> linkfields = ViewColumnDependUtil.getRateDependFields(viewColumn);

            if (linkfields != null && linkfields.size() > 0 && !viewColumn.toLowerCase().startsWith("avg_time")) {

                Object[] objects = linkfields.toArray();
                String[] linkfield = Arrays.copyOf(objects, objects.length, String[].class);
                final Object f1 = valMap.get(linkfield[0]);
                final Object linkFieldValue2 = valMap.get(linkfield[1]);


                if (linkFieldValue2 != null) {
                    if (viewColumn.toLowerCase().startsWith("rate_") || viewColumn.toLowerCase().startsWith("amt_")) {
                        if (viewColumn.toLowerCase().startsWith("amt_ltv") || viewColumn.toLowerCase().equals("amt_pay_perticket") || viewColumn.toLowerCase().equals("amt_pay_perticket") || viewColumn.toLowerCase().equals("amt_time")
                                || (viewColumn.toLowerCase().startsWith("amt_arp") && viewColumn.toLowerCase().endsWith("_new"))) {
                            valMap.put(viewColumn, divideAmt((Double.valueOf(f1.toString())) / 100, Double.valueOf(String.valueOf(linkFieldValue2))));

//                            valMap.put(viewColumn, divideAmt((
//                                Double.valueOf(f1.toString())) / 100,
//                                Double.valueOf(String.valueOf(getNewRateInstallData(viewColumn,valMap,linkFieldValue2)))));

                        } else if ((viewColumn.toLowerCase().startsWith("rate_"))) {
                            if (!viewColumn.toLowerCase().equals("rate_install_fake")) {
                                valMap.put(viewColumn, divide(Double.valueOf(f1.toString()), Double.valueOf(String.valueOf(getNewRateInstallData(viewColumn, valMap, linkFieldValue2)))));
                            }
                        }
                    }/*else if (viewColumn.toLowerCase().startsWith("avg_")) {
                        if(viewColumn.toLowerCase().startsWith("avg_time")){
                            valMap.put(viewColumn, divideAvgTime(Long.valueOf(String.valueOf(f1.toString())), Long.valueOf(String.valueOf(linkFieldValue2))));
                            //valMap.put(viewColumn, DateUtil.formatCaseTime(Long.valueOf(valMap.get(viewColumn)==null?"0":String.valueOf(valMap.get(viewColumn)))));
                        }
                    }*/ else {
                        if (f1.getClass().isAssignableFrom(Long.class)) {
                            valMap.put(viewColumn, divide((Long) f1, (Long) linkFieldValue2));
                        } else if (f1.getClass().isAssignableFrom(Double.class)) {
                            valMap.put(viewColumn, divide((Double) f1, Double.valueOf(String.valueOf(linkFieldValue2))));
                        }

                    }
                } else {
                    valMap.put(viewColumn, 0.0d);
                }
            }/*else if (viewColumn.toLowerCase().equals("duration")) {
                valMap.put(viewColumn, DateUtil.formatCaseTime(Long.valueOf(valMap.get(viewColumn)==null?"0":valMap.get(viewColumn).toString())));
            }*/

            if (!"ds".equals(viewColumn) && !"campaignid".equals(viewColumn) && isAllZero) {
                Object tmpval = valMap.get(viewColumn);
                if (tmpval.getClass().isAssignableFrom(Double.class)) {
                    if ((Double) tmpval > 0) {
                        isAllZero = false;
                    }
                } else if (tmpval.getClass().isAssignableFrom(Long.class)) {
                    if ((Long) tmpval > 0) {
                        isAllZero = false;
                    }
                }
            }
        }

        valMap.put("isall0", isAllZero);

        return valMap;
    }

    private List<Map<String, Object>> transName(List<Map<String, Object>> val, Long app, Long account, boolean isReplaceCampaign,
                                                boolean isReplaceGroup, boolean isReplaceChannel, boolean isAddCampaignName,
                                                boolean isAddCampaignGroupName, boolean isAddChannelName) {

        return transName(val, app, account, isReplaceCampaign, isReplaceGroup, isReplaceChannel, isAddCampaignName,
                isAddCampaignGroupName, isAddChannelName, null);
    }

    private List<Map<String, Object>> transName(List<Map<String, Object>> val, Long app, Long account, boolean isReplaceCampaign, boolean isReplaceGroup, boolean isReplaceChannel, boolean isAddCampaignName,
                                                boolean isAddCampaignGroupName, boolean isAddChannelName, String parentCampaign) {
        Map<String, Campaign> dicCampaign = Maps.newHashMap();
        Map<String, PackageSubCampaign> dicCampaignSub = Maps.newHashMap();
        Map<String, CampaignGroup> dicCampaignGroup = Maps.newHashMap();
        Map<String, Channel> dicChannel = Maps.newHashMap();

        if (isReplaceCampaign) {

            if (parentCampaign == null) {
                dicCampaign = getDicCampaignMap(app, account);
            } else {
                dicCampaignSub = getDicCampaignMapSub(app, account);
            }


        } else if (isReplaceGroup) {
            dicCampaignGroup = getDicCampaignGroupMap(app, account);
        } else if (isReplaceChannel) {
            dicChannel = getDicChannelMap(app);
        }

        List<Map<String, Object>> translist = Lists.newArrayList();
        for (int i = 0; val != null && i < val.size(); i++) {
            Map rowItem = val.get(i);

            String transname = "";
            Object transid = null;
            if (isReplaceCampaign) {
                transid = rowItem.get("campaignid");
                //


                if (parentCampaign == null) {
                    Campaign campaign_1 = dicCampaign.get(transid);
                    transname = campaign_1 == null ? "" : campaign_1.getName();
                } else {
                    PackageSubCampaign campaign_sub = dicCampaignSub.get(transid);
                    transname = campaign_sub == null ? "" : campaign_sub.getName();
                }

                boolean ispackchannel = false;
                final Campaign campaign = dicCampaign.get(transid);

                if (transid != null && campaign != null) {
//                    transname = campaign.getName();
                    ispackchannel = !Strings.isNullOrEmpty(campaign.getPack_channelid());
                }
                if (isAddCampaignName) {
                    rowItem.put("campaignname", !Strings.isNullOrEmpty(transname) ? transname : transid);
                } else {
                    rowItem.put("campaignid", !Strings.isNullOrEmpty(transname) ? transname : transid);
                }
                rowItem.put("ispackchannel", ispackchannel);
            } else if (isReplaceGroup) {
                transid = rowItem.get("campaignid");
                if (transid != null && dicCampaignGroup.get(transid) != null) {
                    transname = dicCampaignGroup.get(transid).getName();
                }
                if (isAddCampaignGroupName) {
                    rowItem.put("campaigngroupname", !Strings.isNullOrEmpty(transname) ? transname : transid);
                } else {
                    rowItem.put("campaignid", !Strings.isNullOrEmpty(transname) ? transname : transid);
                }
            } else if (isReplaceChannel) {
                transid = String.valueOf(rowItem.get("cid"));
                boolean ispackchannel = false;
                final Channel channel = dicChannel.get(transid);
                if (transid != null && channel != null) {
                    transname = channel.getName();
                    ispackchannel = ChannelCategoryEnumType.APPMARKET.getKey().equals(channel.getCategory());
                }
                if ("汇总".equals(transid)) {
                    continue;
                }
                /*else if (transid != null && transid.equals("汇总")){

                } else {
                    continue;
                }*/


                if ("cid".equals(firstShowRowNeedReplaceId())) {
                    rowItem.put("cid", !Strings.isNullOrEmpty(transname) ? transname : transid);
                } else if (isAddChannelName) {
                    rowItem.put("channelname", !Strings.isNullOrEmpty(transname) ? transname : transid);
                } else {
                    rowItem.put("cid", !Strings.isNullOrEmpty(transname) ? transname : transid);
                }
                rowItem.put("ispackchannel", ispackchannel);
            }
            translist.add(rowItem);
        }
        return translist;


    }

    private List<Map<String, Object>> transChannelAdvertisingName(List<Map<String, Object>> val, Long app, Long account) {
        List<Channel> channels = channelService.listAllCooperationChannel();
        Map<String, Channel> dicChannel = new HashMap<>(channels.size());
        for (Channel channel : channels) {
            dicChannel.put(channel.getId().toString(), channel);
        }
        List<Map<String, Object>> translist = Lists.newArrayList();
        for (Map<String, Object> rowItem : val) {
            String transid = String.valueOf(rowItem.get("cid"));
            final Channel channel = dicChannel.get(transid);
            if (transid != null && channel != null) {
                rowItem.put("ispackchannel", ChannelCategoryEnumType.APPMARKET.getKey().equals(channel.getCategory()));
                rowItem.put("cid", channel.getName());
            }
            rowItem.put("channel", transid);
            translist.add(rowItem);
        }
        return translist;
    }
    private List<Map<String, Object>> transServeridName(List<Map<String, Object>> val, Long app, Long account,Map<String, String> conditions) {
        List<ServeridBackflow> serveridBackflows = serveridBackflowRepository.findAByApp(app);
        Map<String, String> dicServeridBackflow = new HashMap<>(serveridBackflows.size());
        for (ServeridBackflow serveridBackflow : serveridBackflows) {
            dicServeridBackflow.put(serveridBackflow.getServerId(),serveridBackflow.getServerName());
        }
        List<Map<String, Object>> translist = Lists.newArrayList();
        for (Map<String, Object> rowItem : val) {
            String serverid = String.valueOf(rowItem.get("serverid"));
            final String servername = dicServeridBackflow.get(serverid);
            if (serverid != null && servername != null) {
                rowItem.put("serverid", servername);
            }
            rowItem.put("server_id", serverid);
            translist.add(rowItem);
        }
        if(conditions.containsKey("searchtxt")&&!StringUtil.isEmpty(conditions.get("searchtxt"))){
            Iterator<Map<String, Object>> iterator = translist.iterator();
            while(iterator.hasNext()){
                Map<String, Object> next = iterator.next();
                if(next.get("serverid").toString().indexOf(conditions.get("searchtxt"))<0){
                    iterator.remove();
                }
            }
        }
        return translist;
    }

    private List<Map<String, Object>> transRemarketingChannelName(List<Map<String, Object>> val, Long app, Long account) {
        List<Channel> channels = channelService.listAllCooperationChannel();
        Map<String, Channel> dicChannel = new HashMap<>(channels.size());
        for (Channel channel : channels) {
            dicChannel.put(channel.getId().toString(), channel);
        }
        List<Map<String, Object>> translist = Lists.newArrayList();
        for (Map<String, Object> rowItem : val) {
            String transid = String.valueOf(rowItem.get("cid"));
            final Channel channel = dicChannel.get(transid);
            if (transid != null && channel != null) {
                rowItem.put("ispackchannel", ChannelCategoryEnumType.APPMARKET.getKey().equals(channel.getCategory()));
                rowItem.put("cid", channel.getName());
            }
            rowItem.put("channel", transid);
            translist.add(rowItem);
        }
        return translist;
    }


    /**
     * 查询分类名称
     */
    private Map<String, Category> getDicCategoryMap(List<String> vals) {

        Map<String, Category> categoryMap;

        List<Long> integerList = Lists.newArrayList();
        for (String val : vals) {
            try {
                integerList.add(Long.parseLong(val));
            } catch (NumberFormatException e) {
                e.printStackTrace();
            }
        }

        List<Category> categoryList = this.categoryRepository.findByIds(integerList);

        categoryMap = Maps.uniqueIndex(categoryList, new Function<Category, String>() {
            @Override
            public String apply(Category category) {
                return String.valueOf(category.getCategoryid());
            }
        });

        return categoryMap;
    }


    protected List<Map<String, Object>> transKeywordAndCreativeName(List<Map<String, Object>> val, boolean isKeywordOrCreative, Long cid, Account rootAccount) {

        String dataType = isKeywordOrCreative ? KeywordsDataType.KEYWORDS.getKey() : KeywordsDataType.CREATIVE.getKey();
        String keyColumnName = isKeywordOrCreative ? "kwid" : "creative";
        String addColumnName = isKeywordOrCreative ? "keywordname" : "creativename";

        if (cid == null) {

            for (int i = 0; val != null && i < val.size(); i++) {

                Map rowItem = val.get(i);
                String keyId = String.valueOf(rowItem.get(keyColumnName));

                rowItem.put(addColumnName, keyId);
            }

        } else {
            List<String> keyidList = new ArrayList<>();

            for (int i = 0; val != null && i < val.size(); i++) {

                Map rowItem = val.get(i);
                String keyId = String.valueOf(rowItem.get(keyColumnName));
                keyidList.add(keyId);
            }

            Long root_account_id = rootAccount.getRootParent() > 0 ? rootAccount.getRootParent() : rootAccount.getId();
            ArrayList<BigInteger> as = new ArrayList<>();
            as.add(BigInteger.valueOf(root_account_id));
            if (RoleEnumType.CHANNEL_PERSON.getKey().equals(rootAccount.getRoleCategory())) {
                as.addAll(channelAccountMapRepository.findRootAccountsByChannelAcountId(rootAccount.getId()));
            } else {
                as.addAll(channelAccountMapRepository.findChannelAccountsByRootAccount(root_account_id));
            }

            List<KeywordsCreative> list = keywordsCreativeRepository.findKeywordsCreativesByAccountKey(cid, dataType, keyidList, as);

            Map<String, String> map = new HashMap<>();
            for (KeywordsCreative kc : list) {
                map.put(kc.getKeyId(), kc.getValue());
            }
            for (int i = 0; val != null && i < val.size(); i++) {

                Map rowItem = val.get(i);
                String keyId = String.valueOf(rowItem.get(keyColumnName));

                if (cid == null) {
                    rowItem.put(addColumnName, keyId);
                } else {
                    if (map.containsKey(keyId)) {
                        rowItem.put(addColumnName, map.get(keyId));
                    } else {
                        rowItem.put(addColumnName, keyId);
                    }
                }
            }
        }

        return val;
    }

    public Map<String, Campaign> getDicCampaignMap(Long app, Long account) {
        Map<String, Campaign> dicCampaign = new HashMap<>();
        //根据权限加自然量
        if (authService.isNature(account, app)) {
            Campaign camp = new Campaign();
            camp.setCampaignid("_default_");
            camp.setName("自然量");
            dicCampaign.put("_default_", camp);
        }
        List<Campaign> itemlist = this.campaignService.listAllCampaign(app, account);
        Map<String, Campaign> dicCampaignNew = Maps.uniqueIndex(itemlist, new Function<Campaign, String>() {
            @Override
            public String apply(Campaign campaign) {
                return campaign.getCampaignid();
            }
        });
        dicCampaign.putAll(dicCampaignNew);

        return dicCampaign;
    }


    private Map<String, PackageSubCampaign> getDicCampaignMapSub(Long app, Long account) {
        List<PackageSubCampaign> packageSubCampaignList = packageSubCampaignRepository.listAllCampByApp(app);

        Map<String, PackageSubCampaign> dicCampaignNew2 = Maps.uniqueIndex(packageSubCampaignList, new Function<PackageSubCampaign, String>() {
            @Override
            public String apply(PackageSubCampaign campaign) {
                return campaign.getCampaignid() + "_" + campaign.getParentCampaignid();
            }
        });

        return dicCampaignNew2;
    }

    private Map<String, CampaignGroup> getDicCampaignGroupMap(Long app, Long account) {
        Map<String, CampaignGroup> dicCampaignGroup;
        List<CampaignGroup> itemlist = this.campaignGroupService.listCamgroupByAccountAndApp(app, account);
        dicCampaignGroup = Maps.uniqueIndex(itemlist, new Function<CampaignGroup, String>() {
            @Override
            public String apply(CampaignGroup campaignGroup) {
                return String.valueOf(campaignGroup.getId());
            }
        });
        return dicCampaignGroup;
    }

    public Map<String, Channel> getDicChannelMap(Long appId) {


        List<Channel> itemList = this.channelService.findAllChannelByApp(appId);
        itemList = null == itemList ? new ArrayList<Channel>() : itemList;

        //翻译字典加入自然量
        itemList.add(new Channel(-1L, "自然量"));

        return Maps.uniqueIndex(itemList, new Function<Channel, String>() {
            @Override
            public String apply(Channel channel) {
                return String.valueOf(channel.getId());
            }
        });
    }

    public Long plus(Long[] longValue) {
        long total = 0;
        if (longValue == null || longValue.length == 0) {
            return total;
        }

        for (Long tmp : longValue) {
            total += tmp.longValue();
        }

        return total;
    }

    public Double plus(Double[] doubleVal) {
        double total = 0d;
        if (doubleVal == null || doubleVal.length == 0) {
            return total;
        }

        for (Double tmp : doubleVal) {
            total += tmp.doubleValue();
        }

        return BigDecimal.valueOf(total).setScale(Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
    }

    public Double divide(Double f1, Double f2) {
        if (f2 == null || f2.doubleValue() == 0d) {
            return 0d;
        }

        final double doubleValue = BigDecimal.valueOf(f1 * 100).divide(new BigDecimal(f2), Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        return doubleValue > 100d ? 100d : doubleValue;
    }

    public Double divideAmt(Double f1, Double f2) {
        if (f2 == null || f2.doubleValue() == 0d) {
            return 0d;
        }

        final double doubleValue = BigDecimal.valueOf(f1 * 100).divide(new BigDecimal(f2), Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        return doubleValue;
    }

    public Object divideTwoValue(Object f1, Object f2, int rate, boolean isDouble, boolean isPercent) {

        if (f2 == null) {
            return 0.0d;
        }
        String f2Value = f2.toString();
        if (f2Value.equals("0") || f2Value.equals("0.0")) {
            return 0.0d;
        }

        Double value = null;

        if (isDouble) {
            value = BigDecimal.valueOf((Double) f1 / rate * 100).divide(new BigDecimal(f2Value),
                    Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        } else {
            value = BigDecimal.valueOf((Long) f1 / rate * 100).divide(new BigDecimal(f2Value),
                    Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        }

        if (isPercent) {
            return value > 100d ? 100d : value;
        }

        return value;
    }


    public String divideAvgTime(Long f1, Long f2) {
        if (f2 == null || f2 == 0L) {
            return "0秒";
        }
        return DateUtil.formatCaseTime(f1 / f2);
    }

    public Double divide(Long f1, Long f2) {
        if (f2 == null || f2.longValue() == 0) {
            return 0d;
        }

        final double doubleValue = BigDecimal.valueOf(f1 * 100).divide(new BigDecimal(f2), Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        return doubleValue > 100d ? 100d : doubleValue;
    }

    public Double divideAmt(Long f1, Long f2) {
        if (f2 == null || f2.longValue() == 0) {
            return 0d;
        }

        final double doubleValue = BigDecimal.valueOf(f1 * 100).divide(new BigDecimal(f2), Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        return doubleValue;
    }


    public Double rateCal(Double f1, Double f2) {
        if (f2 == null || f2.doubleValue() == 0d) {
            return 0d;
        }

        final double doubleValue = BigDecimal.valueOf(f1 * 100).divide(new BigDecimal(f2), Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        return doubleValue > 100d ? 100d : doubleValue;
    }

    public Double rateCal(Long f1, Long f2) {
        if (f2 == null || f2.longValue() == 0) {
            return 0d;
        }

        final double doubleValue = BigDecimal.valueOf(f1 * 100).divide(new BigDecimal(f2), Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        return doubleValue > 100d ? 100d : doubleValue;
    }

    /**
     * 将分类转换成中文名
     */
    public List<String> transCategoryNameList(List<String> val) {

        Map<String, Category> categoryMap = getDicCategoryMap(val);

        List<String> nameList = Lists.newArrayList();

        for (String categoryId : val) {
            final Category category = categoryMap.get(categoryId);

            if (category == null) {
                nameList.add(categoryId);
            } else {
                nameList.add(category.getCategoryname());
            }
        }

        return nameList;
    }

    /**
     * 根据查询字段构建全0数据
     * created by sunhao
     */
    protected Map<String, Object> getAllZeroValue(List<String> viewColumnList) {
        Map<String, Object> resultMap = Maps.newHashMap();
        resultMap.put("isall0", true);

        for (String column : viewColumnList) {
            if (isRateFields(column)) {
                resultMap.put(column, 0.0);
            } else {
                resultMap.put(column, 0l);
            }

        }
        return resultMap;
    }

    protected boolean isRateFields(String column) {
        return column.toLowerCase().endsWith("_rate")
                || column.toLowerCase().startsWith("rate_")
                || column.toLowerCase().startsWith("amt_")
                || column.toLowerCase().startsWith("aaus");
    }

    public Double multiply(Double f1, Double f2) {
        if (f2 == null || f2.doubleValue() == 0d) {
            return 0d;
        }

        return BigDecimal.valueOf(f1).multiply(new BigDecimal(f2)).doubleValue();
    }

    public Double multiply(Long f1, Long f2) {
        if (f2 == null || f2.longValue() == 0) {
            return 0d;
        }

        return BigDecimal.valueOf(f1).multiply(new BigDecimal(f2)).doubleValue();
    }

    public double divideRateInstallFake(Long f1, Long f2) {
        if (f2 == null || f2.longValue() == 0) {
            return 0d;
        }

        final double doubleValue = BigDecimal.valueOf(f1 * 100).divide(new BigDecimal(f2).add(BigDecimal.valueOf(f1)), Constant.FMT_NEWSCALE, Constant.FMT_ROUNDINGMODE).doubleValue();
        return doubleValue > 100d ? 100d : doubleValue;
    }

    protected String firstShowRowNeedReplaceId() {
        return "";
    }

}
