package com.reyun.report;

import com.reyun.dic.DataViewEnumType;
import com.reyun.model.Account;
import com.reyun.model.ReportListResult;
import com.reyun.report.parse.*;
import org.json.JSONException;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public class CampaignReportResultBuilder
{

    /**
     * 列表报表处理
     *
     * @param reportListResult
     * @param dataViewEnumType
     * @return
     * @throws IOException
     */
    public ReportListResult doListReport(ReportListResult reportListResult, DataViewEnumType dataViewEnumType, Long appid,
                                         Account loginAcount, List<String> viewColumns, String reportName, List<String> fillCampids,
                                         boolean isSearchText, List<String> searchIds, Map<String, String> conditions)
            throws IOException {
        if ("campaigninfo_bysubpackagecampaign".equals(reportName)) {
            return new ListPackageCampaignParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids,conditions);
        } else if (DataViewEnumType.DATE.equals(dataViewEnumType)) {
            return new ListCampaignDateParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null);
        } else if (DataViewEnumType.CAMPAIGN.equals(dataViewEnumType)) {
            return new ListCampaignParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids,null,conditions);
        } else if (DataViewEnumType.CAMPAIGN_DATE.equals(dataViewEnumType)) {
            return new ListCampaignAndDateParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if (DataViewEnumType.CAMPGROUP_DATE.equals(dataViewEnumType)) {
            return new ListCampGroupAndDateParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if (DataViewEnumType.CAMPAIGNGROUP.equals(dataViewEnumType)) {
            return new ListCampaignGroupParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids,null,conditions);
        } else if (DataViewEnumType.THIRDACCOUNT.equals(dataViewEnumType)) {
            return new ListThirdAccountParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if (DataViewEnumType.CHANNEL.equals(dataViewEnumType)) {
            return new ListChannelParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if (DataViewEnumType.CHANNLE_DATE.equals(dataViewEnumType)) {
            return new ListChannelDateParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if (DataViewEnumType.SCENE.equals(dataViewEnumType)) {
            return new ListSceneParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if (DataViewEnumType.SUBCHANNEL.equals(dataViewEnumType)) {
            return new ListSubChannelParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null, null, conditions);
        } else if (DataViewEnumType.BDKEYWORD.equals(dataViewEnumType)) {
            return new ListBDKeywordParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null, null, conditions);
        } else if (DataViewEnumType.SUBACCOUNT.equals(dataViewEnumType)) {
            return new ListSubAccountParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null);
        } else if (DataViewEnumType.CAMPAIGN_H5.equals(dataViewEnumType)) {
            return new ListCampaignH5Parse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if ("campaigninfo_bypackagecampaign".equals(reportName)) {// 分包推广活动详情单独处理
            return new ListCampaignParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else {
            return new ListTransNameParse().parse(reportListResult, appid, loginAcount.getId(), null, reportName, isSearchText, null);
        }
    }


    /**
     * 列表报表处理
     *
     * @param reportListResult
     * @param dataViewEnumType
     * @return
     * @throws IOException
     */
    public ReportListResult doListReport(ReportListResult reportListResult, DataViewEnumType dataViewEnumType, Long appid,
                                         Account loginAcount, List<String> viewColumns, String reportName, List<String> fillCampids,
                                         boolean isSearchText, List<String> searchIds, Long cid,  Map<String, String> conditions)
            throws IOException, JSONException {
        return new ListBDKeywordParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null, cid, conditions);
    }

}
