package com.reyun.report;

import com.reyun.dic.DataViewEnumType;
import com.reyun.model.Account;
import com.reyun.model.ReportListResult;
import com.reyun.report.parse.ListBDKeywordParse;
import com.reyun.report.parse.ListChannelAdvertisingParse;
import com.reyun.report.parse.ListTransNameParse;
import org.json.JSONException;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public class ChannelAdvertisingReportResultBuilder {

    /**
     * 列表报表处理
     *
     * @param reportListResult
     * @param dataViewEnumType
     * @return
     * @throws IOException
     */
    public ReportListResult doListReport(ReportListResult reportListResult, DataViewEnumType dataViewEnumType, Long appid,
                                         Account loginAcount, List<String> viewColumns, String reportName, List<String> fillCampids,
                                         boolean isSearchText, List<String> searchIds, Map<String, String> conditions)
            throws IOException {
        if ("advertisinginfo_byadgroup".equals(reportName)) {
            return new ListChannelAdvertisingParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if ("advertisinginfo_byadplan".equals(reportName)) {
            return new ListChannelAdvertisingParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if ("advertisinginfo_byadcreative".equals(reportName)) {
            return new ListChannelAdvertisingParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else if ("advertisinginfo_cash_day".equals(reportName)) {
            List<Object> columnkey = reportListResult.getColumnkey();
            if(columnkey.contains("adshow_num")){
                columnkey.remove("adshow_num");
                List<String> name = reportListResult.getName();
                if(name != null && name.contains("unknown")){
                    while(name.contains("unknown")){
                        name.remove("unknown");
                    }
                }
            }

            ReportListResult result = new ListChannelAdvertisingParse().parseSimple(reportListResult, appid, loginAcount, viewColumns, reportName);
            return result;
        }else if ("adsenseinfo_byadgroup".equals(reportName)||"adsenseinfo_byadcreative".equals(reportName)|| "adsenseinfo_byadtype".equals(reportName)||"adsenseinfo_byadplan".equals(reportName)||"adsenseinfo_byadid".equals(reportName)) {
            if("adsenseinfo_byadid".equals(reportName) || "adsenseinfo_byadtype".equals(reportName)){
                viewColumns = setViewColumns(viewColumns);
            }
            if(viewColumns.contains("install_num")){
                viewColumns.remove("install_num");
                if(!viewColumns.contains("num_install")){
                    viewColumns.add("num_install");
                }
            }
            return new ListChannelAdvertisingParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        } else {
            return new ListTransNameParse().parse(reportListResult, appid, loginAcount.getId(), null, reportName, isSearchText, null);
        }
    }

    private List<String> setViewColumns(List<String> viewColumns) {
        viewColumns = new ArrayList<>();
        viewColumns.add("adid");
        viewColumns.add("adv_name");
        viewColumns.add("cid");
        viewColumns.add("cash_income");
        viewColumns.add("install_show");
        viewColumns.add("install_click");
        viewColumns.add("cash_income_d0");
        viewColumns.add("cash_income_d1");
        viewColumns.add("cash_income_d2");
        viewColumns.add("cash_income_d3");
        viewColumns.add("cash_income_d4");
        viewColumns.add("cash_income_d5");
        viewColumns.add("cash_income_d6");
        viewColumns.add("cash_income_d7");
        return viewColumns;
    }


    /**
     * 列表报表处理
     *
     * @param reportListResult
     * @param dataViewEnumType
     * @return
     * @throws IOException
     */
    public ReportListResult doListReport(ReportListResult reportListResult, DataViewEnumType dataViewEnumType, Long appid,
                                         Account loginAcount, List<String> viewColumns, String reportName, List<String> fillCampids,
                                         boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions)
            throws IOException, JSONException {
        return new ListBDKeywordParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null, cid, conditions);
    }


}
