package com.reyun.report;

import com.reyun.dic.DataViewEnumType;
import com.reyun.model.Account;
import com.reyun.model.ReportListResult;
import com.reyun.report.parse.*;
import org.json.JSONException;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public class RemarketingReportResultBuilder
{

    /**
     * 列表报表处理
     *
     * @param reportListResult
     * @param dataViewEnumType
     * @return
     * @throws IOException
     */
    public ReportListResult doListReport(ReportListResult reportListResult, DataViewEnumType dataViewEnumType, Long appid,
                                         Account loginAcount, List<String> viewColumns, String reportName, List<String> fillCampids,
                                         boolean isSearchText, List<String> searchIds, Map<String, String> conditions)
              {
        if ("marketinginfo_bychannel".equals(reportName)) {
            return new RemarketingParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
        }else if("marketinginfo_bydate".equals(reportName)){
            return new RemarketingDateParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);

        }else if("marketinginfo_bysubpackagecampaign".equals(reportName)){
            //ListPackageCampaignParse
            return new RemarketingPackageCampaignParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids,conditions);
        }else if(DataViewEnumType.CAMPAIGN.equals(dataViewEnumType)){
            return new RemarketingCampaignParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids,null,conditions);
        }else if(DataViewEnumType.CAMPAIGNGROUP.equals(dataViewEnumType)){
            return new RemarketingCampaignGroupParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids,null,conditions);
        }else if (DataViewEnumType.SUBACCOUNT.equals(dataViewEnumType)) {
            return new RemarketingSubAccountParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null);
        }else {
            return new ListTransNameParse().parse(reportListResult, appid, loginAcount.getId(), null, reportName, isSearchText, null);
        }
    }


    /**
     * 列表报表处理
     *
     * @param reportListResult
     * @param dataViewEnumType
     * @return
     * @throws IOException
     */
    public ReportListResult doListReport(ReportListResult reportListResult, DataViewEnumType dataViewEnumType, Long appid,
                                         Account loginAcount, List<String> viewColumns, String reportName, List<String> fillCampids,
                                         boolean isSearchText, List<String> searchIds, Long cid,  Map<String, String> conditions)
            throws IOException, JSONException {
        return new ListBDKeywordParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, null, cid, conditions);
    }

}
