package com.reyun.report;

import com.reyun.dic.DataViewEnumType;
import com.reyun.model.Account;
import com.reyun.model.ReportListResult;
import com.reyun.report.roi.ListRoiByCampaignParse;
import com.reyun.report.roi.ListRoiByChannelParse;
import com.reyun.report.roi.ListRoiByDayParse;
import com.reyun.report.roi.ListRoiByIntervalParse;

import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public class RoiReportResultBuilder {
	/**
	 * 列表报表处理
	 *
	 * @param reportListResult
	 * @param dataViewEnumType
	 * @return
	 * @throws IOException
	 */
	public ReportListResult doListReport(ReportListResult reportListResult, DataViewEnumType dataViewEnumType, Long appid, Account loginAcount, List<String> viewColumns, String reportName,  Map<String,String> conditions, List<String> fillCampids, boolean isSearchText, List<String> searchIds) throws IOException {
		if ("roi_bycampaign".equals(reportName)) {
			reportListResult = new ListRoiByCampaignParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
		} else if ("roi_byds".equals(reportName)) {//下钻报表
			reportListResult = new ListRoiByDayParse().parse(reportListResult, appid, loginAcount.getId(), reportName, conditions);
		}else if("roi_bychannel".equals(reportName)){
			reportListResult = new ListRoiByChannelParse().parse(reportListResult, appid, loginAcount.getId(), viewColumns, reportName, isSearchText, isSearchText ? searchIds : fillCampids);
		}else if("roi_byinterval".equals(reportName)){
			reportListResult = new ListRoiByIntervalParse().parse(reportListResult, conditions);
		}
		return reportListResult;
	}
}
