package com.reyun.report.parse;

import com.reyun.context.AppUtils;
import com.reyun.dic.RoleEnumType;
import com.reyun.model.*;
import com.reyun.report.AbstractListReportParse;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.AuthRepository;
import com.reyun.repository.CampaignRepository;
import com.reyun.repository.RoleAuthRepository;
import com.reyun.service.AuthService;
import com.reyun.service.ChannelService;
import com.reyun.util.ValidateUtil;
import org.apache.commons.collections.map.HashedMap;
import org.json.JSONException;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ASMDetailParse
        extends AbstractListReportParse
{
    private CampaignRepository campaignRepository = AppUtils.getApplicationContext().getBean(CampaignRepository.class);
    private ChannelService channelService = AppUtils.getApplicationContext().getBean(ChannelService.class);
    private AccountRepository accountRepository = AppUtils.getApplicationContext().getBean(AccountRepository.class);
    private RoleAuthRepository roleAuthRepository = AppUtils.getApplicationContext().getBean(RoleAuthRepository.class);
    private AuthRepository authRepository = AppUtils.getApplicationContext().getBean(AuthRepository.class);

    private final String ams = "sads";

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds)
    {
        List<Map<String,Object>> valList = reportResult.getVal();
        List<Map<String,Object>> res = new LinkedList<>();
        boolean b = hasAuth(account, app);
        if(b){
            Map<String, String> nameMap = new HashMap<>();
            List<Long> idList = new ArrayList<>();
            if(ValidateUtil.isValid(valList)) {
                for (Map<String, Object> map : valList) {
                    idList.add((Long)map.get("cid"));
                }
                List<Channel> channelList = channelService.listChannelByIds(idList);
                if(ValidateUtil.isValid(channelList)){
                    for(Channel ch : channelList){
                        nameMap.put(ch.getId().toString(), ch.getName());
                    }
                }
            }

            if(ValidateUtil.isValid(valList)) {
                for (Map<String, Object> map : valList) {
                    map.put("search_ads_receive_datetime",parseDate((Long)map.get("search_ads_receive_datetime")));
                    map.put("ins_datetime",parseDate((Long)map.get("ins_datetime")));
                    map.put("matching_datetime",parseDate((Long)map.get("matching_datetime")));
                    map.put("cid", nameMap.get(map.get("cid").toString()));
                    res.add(map);
                }
            }
        }

        reportResult.setVal(res);
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    private String parseDate(Long time){
        String res = "";
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = new Date(time);
        res = simpleDateFormat.format(date);
        return res;
    }
    private boolean hasAuth(Long account, Long app){
        boolean flag = false;
        Account one = accountRepository.findOne(account);
        RoleAuth roleAuth = roleAuthRepository.findOne(one.getRoleCategory());
        if (one.getIsSuperUser() || roleAuth.getRoleCategory().equals(RoleEnumType.MANAGER.getKey())
                || (one.getRoleCategory().equals(RoleEnumType.SUB_APP_MANAGER.getKey()) && null != authRepository.findAuthByAccountAndApp(one.getId(), app))) {
            flag = true;
        }else{
            try{
                Channel SearchAds = channelService.findByUniqueName(ams);
                List<Campaign> list = campaignRepository.findAsmDataAuthCampaignListWithoutCreate(account, app, SearchAds.getId());
                if(ValidateUtil.isValid(list)){
                    flag = true;
                }else{
                    flag = false;
                }
            } catch (Exception e){

            }
        }
        return flag;
    }
    @Override
    protected String firstTotalRowNeedReplaceId()
    {
        return "cid";
    }
}