package com.reyun.report.parse;

import com.reyun.context.AppUtils;
import com.reyun.dic.RoleEnumType;
import com.reyun.model.*;
import com.reyun.report.AbstractListReportParse;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.AuthRepository;
import com.reyun.repository.CampaignRepository;
import com.reyun.repository.RoleAuthRepository;
import com.reyun.service.ChannelService;
import com.reyun.util.ValidateUtil;
import org.apache.commons.collections.map.HashedMap;
import org.json.JSONException;

import java.util.*;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ASMParse
        extends AbstractListReportParse {
    private CampaignRepository campaignRepository = AppUtils.getApplicationContext().getBean(CampaignRepository.class);
    private ChannelService channelService = AppUtils.getApplicationContext().getBean(ChannelService.class);
    private AccountRepository accountRepository = AppUtils.getApplicationContext().getBean(AccountRepository.class);
    private RoleAuthRepository roleAuthRepository = AppUtils.getApplicationContext().getBean(RoleAuthRepository.class);
    private AuthRepository authRepository = AppUtils.getApplicationContext().getBean(AuthRepository.class);

    private final String ams = "sads";

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) {
        List<Map<String, Object>> valList = reportResult.getVal();
        List<Map<String, Object>> res = new LinkedList<>();
        Map<String, Object> total = new HashedMap();
        total.put("ds", "汇总");
        total.put("isall0", false);
        total.put("num", 0L);
        boolean b = hasAuth(account, app);
        if(b){
            if (ValidateUtil.isValid(valList)) {
                Map<String, Object> mapVal = new TreeMap<String, Object>();
                for (Map<String, Object> map : valList) {
                    total.put("num", (Long) map.get("num") + (Long) total.get("num"));
                    if ((map.get("num")).toString().equals("0")) {
                        map.put("isall0", true);
                    } else {
                        map.put("isall0", false);
                    }
                    mapVal.put(map.get("ds").toString(),map);
                }

                Map<String, Object> map2 = sortMapByKey(mapVal);
                Set<String> keySet = map2.keySet();
                for(String ds : keySet){
                    res.add((Map)map2.get(ds));
                }
            }
        }
        res.add(0, total);
        reportResult.setVal(res);
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    private boolean hasAuth(Long account, Long app){
        boolean flag = false;
        Account one = accountRepository.findOne(account);
        RoleAuth roleAuth = roleAuthRepository.findOne(one.getRoleCategory());
        if (one.getIsSuperUser() || roleAuth.getRoleCategory().equals(RoleEnumType.MANAGER.getKey())
                || (one.getRoleCategory().equals(RoleEnumType.SUB_APP_MANAGER.getKey()) && null != authRepository.findAuthByAccountAndApp(one.getId(), app))) {
            flag = true;
        }else{
            try{
                Channel SearchAds = channelService.findByUniqueName(ams);
                List<Campaign> list = campaignRepository.findAsmDataAuthCampaignListWithoutCreate(account, app, SearchAds.getId());
                if(ValidateUtil.isValid(list)){
                    flag = true;
                }else{
                    flag = false;
                }
            } catch (Exception e){

            }
        }
            return flag;
    }



    @Override
    protected String firstTotalRowNeedReplaceId() {
        return "cid";
    }

    /**
     * 使用 Map按key进行排序
     *
     * @param map
     * @return
     */
    public static Map<String, Object> sortMapByKey(Map<String, Object> map) {
        if (map == null || map.isEmpty()) {
            return null;
        }
        Map<String, Object> sortMap = new TreeMap<String, Object>(new MapKeyComparator());
        sortMap.putAll(map);
        return sortMap;
    }


}

//比较器类
class MapKeyComparator implements Comparator<String> {
    public int compare(String str1, String str2) {
        return str2.compareTo(str1);
    }
}