package com.reyun.report.parse;

import com.google.common.collect.Lists;
import com.reyun.model.ReportChartResult;
import com.reyun.report.AbstractChartReportParse;

import java.util.Arrays;
import java.util.List;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public class ChartAvgParse extends AbstractChartReportParse {

    @Override
    public ReportChartResult parse(ReportChartResult reportResult, Long app, Long account, String reportName) {
        Object total_f1 = null;
        Object total_f2 = null;
        List<Object[]> vals = Lists.newArrayList();


        int loopNameSize = reportResult.getName().size();
        Object[] businessData = null;
        //是否包含行业数据
        if (reportResult.getVal().size() % 2 > 0) {
            Object[] lastData = reportResult.getVal().get(reportResult.getVal().size()-1);
            businessData = Arrays.copyOf(lastData,lastData.length,lastData.getClass());
            loopNameSize = reportResult.getName().size() - 1;
        }

        for (int i = 0; i < loopNameSize; i++) {
            final Object[] objectf1 = reportResult.getVal().get(i * 2);
            final Object[] objectf2 = reportResult.getVal().get(i * 2 + 1);
            if (objectf1 == null || objectf1.length == 0) {
                reportResult.getSubval().add(0);
                continue;
            }

            if (objectf1[0] instanceof Long) {
                total_f1 = total_f1 == null ? 0 : total_f1;
                total_f2 = total_f2 == null ? 0 : total_f2;
                Long[] f1 = Arrays.copyOf(objectf1, objectf1.length, Long[].class);
                Long[] f2 = Arrays.copyOf(objectf2, objectf2.length, Long[].class);

                Double[] f3Vals = new Double[f1.length];
                for (int j = 0; j < f1.length; j++) {
                    f3Vals[j] = divide(f1[j], f2[j]);
                }
                vals.add(f3Vals);
                reportResult.getSubval().add(divide(plus(f1), plus(f2)));

                total_f1 = Long.parseLong(String.valueOf(total_f1)) + plus(f1);
                total_f2 = Long.parseLong(String.valueOf(total_f2)) + plus(f2);
            } else if (objectf1[0] instanceof Double) {
                total_f1 = total_f1 == null ? 0d : total_f1;
                total_f2 = total_f2 == null ? 0d : total_f2;

                Double[] f1 = Arrays.copyOf(objectf1, objectf1.length, Double[].class);
                Double[] f2 = Arrays.copyOf(objectf2, objectf2.length, Double[].class);

                Double[] f3Vals = new Double[f1.length];
                for (int j = 0; j < f1.length; j++) {
                    f3Vals[j] = divide(f1[j], f2[j]);
                }
                vals.add(f3Vals);
                reportResult.getSubval().add(divide(plus(f1), plus(f2)));

                total_f1 = (Double) total_f1 + plus(f1);
                total_f2 = (Double) total_f2 + plus(f2);
            }
        }
        reportResult.setVal(vals);

        if (total_f1 instanceof Long) {
            total_f1 = total_f1 == null ? 0 : total_f1;
            total_f2 = total_f2 == null ? 0 : total_f2;

            reportResult.setSubtotalval(divide((Long) total_f1, (Long) total_f2));
        } else if (total_f1 instanceof Double) {
            total_f1 = total_f1 == null ? 0d : total_f1;
            total_f2 = total_f2 == null ? 0d : total_f2;

            reportResult.setSubtotalval(divide((Double) total_f1, (Double) total_f2));
        }

        //插入行业数据
        if (null != businessData) {
            reportResult.getVal().add(businessData);
        }

        return reportResult;
    }
}
