package com.reyun.report.parse;

import com.reyun.model.ReportChartResult;
import com.reyun.report.AbstractChartReportParse;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;
import java.util.Arrays;

/**
 * Created by nolan on 19/12/2016.
 * description:
 */
public class ChartSumParse extends AbstractChartReportParse {

    private static Logger logger  = LoggerFactory.getLogger(ChartSumParse.class);

    @Override
    public ReportChartResult parse(ReportChartResult reportResult, Long app, Long account, String reportName) {
        Object totalVal = null;
        for (int i = 0, n = reportResult.getName().size(); i < n; i++) {
            final Object[] original = reportResult.getVal().get(i);
            if (original == null || original.length == 0) {
                reportResult.getSubval().add(0l);
                continue;
            }


            if (original[0].getClass().isAssignableFrom(Long.class)) {
                totalVal = totalVal == null ? 0l : totalVal;

                Long[] longValue = null;

                try{
                   longValue = Arrays.copyOf(original, original.length, Long[].class);
                }catch (Exception e){
                     logger.info("ChartSumParse parse:{} ",e);
                }

                long totalItem = plus(longValue);
                reportResult.getSubval().add(totalItem);

                totalVal = (Long) totalVal + totalItem;
            } else if (original[0].getClass().isAssignableFrom(Double.class)) {
                totalVal = totalVal == null ? 0d : totalVal;

                for (int j = 0; j < original.length; j++) {
                    original[j] = Double.valueOf(String.valueOf(original[j]));
                }
                double totalItem = plus(Arrays.copyOf(original, original.length, Double[].class));
                reportResult.getSubval().add(totalItem);

                totalVal = BigDecimal.valueOf((Double) totalVal + totalItem).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
            }
        }
        reportResult.setSubtotalval(totalVal);
        return reportResult;
    }
}
