package com.reyun.report.parse;

import com.reyun.model.Channel;
import com.reyun.model.ReportChartResult;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import org.json.JSONException;
import org.jsoup.helper.StringUtil;

import java.util.*;

/**
 * @author liyin
 * @description
 * @date
 */
public class DurationListParse extends AbstractListReportParse {

    private static Map<String, Map> RATE_MAP_NAMES = new HashMap<>();
    private static Map<String, Map<Integer, int[]>> TOP5_CHART_RATE_MAP_NAMES = new HashMap<>();
    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    public ReportChartResult parseByChart(ReportChartResult reportListResult, Map<String, String> conditions, String reportName) {

        List<String> keys = reportListResult.getKey();
        List<String> names = reportListResult.getName();
        //table补齐全0表头数据
        this.fillInAllTheZeros(reportListResult,reportName,conditions);
        this.getTotalRow(reportListResult, keys.size(), names.size(),  conditions, reportName);
        return reportListResult;
    }

    private void getTotalRow(ReportChartResult reportListResult, int keylength, int namelength,
                              Map<String, String> conditions, String reportName) {


        List<Object[]> datas = reportListResult.getVal();

        List<Object[]> datas_new = new ArrayList<>();

        for (int i = 0; i < namelength; i++) {

            // 计算汇总数据
            Object[] row = datas.get(i);
            Object[] row_new = new Object[keylength+1];

            Long total = 0L;

            for (int j = 0; j < keylength; j++) {
                if(j<row.length){
                    total += Long.parseLong(row[j]==null?"0":row[j].toString());
                    row_new[j + 1] = row[j]==null?0:Long.parseLong(row[j].toString());
                }else{
                    row_new[j + 1] = 0;
                }

            }

            row_new[0] = total;
            datas_new.add(row_new);
        }



        reportListResult.setVal(datas_new);
        reportListResult.getKey().add(0, "汇总");

    }

    private void fillInAllTheZeros(ReportChartResult result,String reportName,Map<String, String> conditions){
        if(reportName.endsWith("_bydate")) {
            // todo 日期顺序 和下面的0值生成的顺序
            //日期的key合并
            if (!result.getKey().contains(conditions.get("startdate"))) {
                result.getKey().add(conditions.get("startdate"));
            }
            if (conditions.containsKey("duration_dates") && !StringUtil.isBlank(conditions.get("duration_dates"))) {
                String[] duration_dates = conditions.get("duration_dates").split(",");
                for (String duration_date : duration_dates) {
                    if (!result.getKey().contains(duration_date)) {
                        result.getKey().add(duration_date);
                    }
                }

            }
        }else if(reportName.endsWith("_bychannel")){
            if(conditions.containsKey("duration_cid") &&!StringUtil.isBlank(conditions.get("duration_cid"))){
                List<Long> cids = new ArrayList<>();
                String[] duration_cids = conditions.get("duration_cid").split(",");
                List<String> cidsStr = Arrays.asList(duration_cids);
                for (String cid : cidsStr) {
                    cids.add(Long.parseLong(cid));
                }
                final List<Channel> channels = channelService.listChannelByIds(cids);
                if(cids.contains(-1L)){
                    Channel channel = new Channel();
                    channel.setId(-1L);
                    channel.setName("自然量");
                    channels.add(channel);
                }
                for (Channel channel : channels) {
                    if(!result.getKey().contains(channel.getName())) {
                        result.getKey().add(channel.getName());
                    }
                }
            }

        }
    }
}
