package com.reyun.report.parse;

import com.reyun.context.AppUtils;
import com.reyun.model.Campaign;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.repository.CampaignRepository;
import com.reyun.util.ValidateUtil;
import org.json.JSONException;

import java.text.DecimalFormat;
import java.util.*;

public class FakeByCampaignParse extends AbstractListReportParse {

    private CampaignRepository campaignRepository = AppUtils.getApplicationContext().getBean(CampaignRepository.class);

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) {
        List<Map<String, Object>> valList = reportResult.getVal();
        List<Map<String, Object>> res = new LinkedList<>();

        Map<String, String> nameMap = new HashMap<>();
        List<String> idList = new ArrayList<>();
        if (ValidateUtil.isValid(valList)) {
            nameMap.put("_default_", "自然量");
            for (Map<String, Object> map : valList) {
                if ((map.get("campaignid") instanceof String)) {
                    idList.add((String) map.get("campaignid"));
                }
            }
            List<Campaign> campaigns = null;
            if (idList.size() != 0) {
                campaigns = campaignRepository.findByCampaignid(idList, app);
            }
            if (ValidateUtil.isValid(campaigns)) {
                for (Campaign cm : campaigns) {
                    nameMap.put(cm.getCampaignid(), cm.getName());
                }
            }
        }
        Map<String, Object> totalMap = new HashMap<>();
        totalMap.put("campaignid", "汇总");
        totalMap.put("num_click", 0L);
        totalMap.put("num_black", 0L);
        totalMap.put("rate_click", 0);

        totalMap.put("num_install", 0L);
        totalMap.put("num_install_valid", 0L);
        totalMap.put("num_install_black", 0L);
        totalMap.put("rate_install", 0);

        totalMap.put("num_install_black_deviceid", 0L);
        totalMap.put("num_total_install_black", 0);

        totalMap.put("level1", 0);
        totalMap.put("level2", 0);
        totalMap.put("level3", 0);
        totalMap.put("level45", 0);
        totalMap.put("level67", 0);
        totalMap.put("num_install_fake", 0);


        if (ValidateUtil.isValid(valList)) {
            for (Map<String, Object> map : valList) {
                map.put("campaignid", nameMap.get(map.get("campaignid").toString()) == null ? map.get("campaignid").toString() :
                        nameMap.get(map.get("campaignid").toString()));
                totalMap.put("num_click", Long.parseLong(totalMap.get("num_click").toString()) + Long.parseLong(map.get("num_click").toString()));
                totalMap.put("num_black", Long.parseLong(totalMap.get("num_black").toString()) + Long.parseLong(map.get("num_black").toString()));

                totalMap.put("num_install", Long.parseLong(totalMap.get("num_install").toString()) + Long.parseLong(map.get("num_install").toString()));
                totalMap.put("num_install_valid", Long.parseLong(totalMap.get("num_install_valid").toString()) + Long.parseLong(map.get("num_install_valid").toString()));
                totalMap.put("num_install_black", Long.parseLong(totalMap.get("num_install_black").toString()) + Long.parseLong(map.get("num_install_black").toString()));

                totalMap.put("num_install_black_deviceid", Long.parseLong(totalMap.get("num_install_black_deviceid").toString()) + Long.parseLong(map.get("num_install_black_deviceid").toString()));
                totalMap.put("num_total_install_black", Long.parseLong(totalMap.get("num_total_install_black").toString()) + Long.parseLong(map.get("num_total_install_black").toString()));

                totalMap.put("level1", Long.parseLong(totalMap.get("level1").toString()) + Long.parseLong(map.get("level1").toString()));
                totalMap.put("level2", Long.parseLong(totalMap.get("level2").toString()) + Long.parseLong(map.get("level2").toString()));
                totalMap.put("level3", Long.parseLong(totalMap.get("level3").toString()) + Long.parseLong(map.get("level3").toString()));
                totalMap.put("level45", Long.parseLong(totalMap.get("level45").toString()) + Long.parseLong(map.get("level45").toString()));
                totalMap.put("level67", Long.parseLong(totalMap.get("level67").toString()) + Long.parseLong(map.get("level67").toString()));
                totalMap.put("num_install_fake", Long.parseLong(totalMap.get("num_install_fake").toString()) + Long.parseLong(map.get("num_install_fake").toString()));
                res.add(map);
            }
        }
        long num_click = Long.parseLong(totalMap.get("num_click").toString());
        long num_black = Long.parseLong(totalMap.get("num_black").toString());

        long num_install = Long.parseLong(totalMap.get("num_install").toString());
        long num_install_black = Long.parseLong(totalMap.get("num_total_install_black").toString());
        if (num_click != 0L && num_black != 0L) {
            double v = num_black * 100.0 / num_click;
            DecimalFormat df = new DecimalFormat("#0.00");
            totalMap.put("rate_click", df.format(v));
        }

        if (num_install != 0L && num_install_black != 0L) {
            double v = num_install_black * 100.0 / num_install;
            DecimalFormat df = new DecimalFormat("#0.00");
            totalMap.put("rate_install", df.format(v));
        }
        res.add(0, totalMap);
        reportResult.setVal(res);
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    public ReportListResult parse(ReportListResult reportResult, Long app){

        List<Map<String, Object>> valList = reportResult.getVal();

        Map<String, String> nameMap = new HashMap<>();
//        List<String> idList = new ArrayList<>();
        Set<String> idSet  = new HashSet<>();
        if (ValidateUtil.isValid(valList)) {
            nameMap.put("_default_", "自然量");
            for (Map<String, Object> map : valList) {
                if ((map.get("campaignid") instanceof String)) {
//                    idList.add((String) map.get("campaignid"));

                    idSet.add((String) map.get("campaignid"));
                }
            }
            List<Campaign> campaigns = null;
            if (idSet.size() != 0) {
                campaigns = campaignRepository.findByCampaignid(idSet, app);
            }
            if (ValidateUtil.isValid(campaigns)) {
                for (Campaign cm : campaigns) {
                    nameMap.put(cm.getCampaignid(), cm.getName());
                }
            }
        }


        return getMapTotalData(reportResult,"campaignid",nameMap);
    }

    @Override
    protected String firstTotalRowNeedReplaceId() {
        return "campaignid";
    }
}
