package com.reyun.report.parse;

import com.alibaba.fastjson.JSON;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.common.collect.Lists;
import com.reyun.context.AppUtils;
import com.reyun.model.Account;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.repository.AccountRepository;
import com.reyun.service.AuthService;
import com.reyun.service.ChannelService;
import com.reyun.service.ReportService;
import com.reyun.util.ValidateUtil;
import org.json.JSONException;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 15/02/2017.
 * description:
 */
public class ListBDKeywordParse extends AbstractListReportParse {
    private String firstTotalRowColumnKey = "";
    private ReportService reportService = AppUtils.getApplicationContext().getBean(ReportService.class);
    private AccountRepository authService = AppUtils.getApplicationContext().getBean(AccountRepository.class);

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) {
				/*if (reportResult.getColumnkey() != null && reportResult.getColumnkey().size() > 0){
			viewColumns = Lists.newArrayList();
			for (Object tmpKey : reportResult.getColumnkey()) {
				if (tmpKey.equals("campaignid") || tmpKey.equals("creative") || tmpKey.equals("kwid")) {
					continue;
				}
				viewColumns.add(String.valueOf(tmpKey));
			}
		}*/
        List<Map<String, Object>> sourceResult = reportResult.getVal();
        List<Map<String, Object>> newSourceResult = new ArrayList<>();
        if (sourceResult != null && sourceResult.size() != 0) {
            for (Map<String, Object> num : sourceResult) {
                newSourceResult.add(super.calculateRate(num));
            }
        }
        reportResult.setVal(newSourceResult);

        //
        Account rootAccount = authService.findOne(account);

        if ("bd_bycampaign".equals(reportName)) {
            reportResult.getColumnkey().set(0, "campaignname");

            firstTotalRowColumnKey = "campaignid";
            if (viewColumns.contains("dupnum_reged_mon")) {
                viewColumns.remove("dupnum_reged_mon");
                viewColumns.add("dupnum_reg_mon");
            }
            List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);

            newResult = parseTotal(newResult, app, account, "bd_bycampaign_sum", conditions);

            reportResult.setVal(super.transCampaignNameAddName(newResult, app, account));
        } else if ("bd_bycreative".equals(reportName)) {
            reportResult.getColumnkey().set(0, "creativename");

            firstTotalRowColumnKey = "creative";
            if (viewColumns.contains("dupnum_reged_mon")) {
                viewColumns.remove("dupnum_reged_mon");
                viewColumns.add("dupnum_reg_mon");
            }
            List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);

            newResult = parseTotal(newResult, app, account, "bd_bycreative_sum", conditions);

            reportResult.setVal(super.transKeywordAndCreativeName(newResult, false, cid,rootAccount));
        } else if ("bd_bykwid".equals(reportName)) {
            reportResult.getColumnkey().set(0, "keywordname");

            firstTotalRowColumnKey = "kwid";
            if (viewColumns.contains("dupnum_reged_mon")) {
                viewColumns.remove("dupnum_reged_mon");
                viewColumns.add("dupnum_reg_mon");
            }
            List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);

            newResult = parseTotal(newResult, app, account, "bd_bykwid_sum", conditions);

            reportResult.setVal(super.transKeywordAndCreativeName(newResult, true, cid,rootAccount));
        }
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        List<Map<String, Object>> sourceResult = reportResult.getVal();
        List<Map<String, Object>> newSourceResult = new ArrayList<>();
        if (sourceResult != null && sourceResult.size() != 0) {
            for (Map<String, Object> num : sourceResult) {
                newSourceResult.add(super.calculateRate(num));
            }
        }
        reportResult.setVal(newSourceResult);

        Account rootAccount = authService.findOne(account);

        if ("bd_bycampaign".equals(reportName)) {
            reportResult.getColumnkey().set(0, "campaignname");

            firstTotalRowColumnKey = "campaignid";
            if (viewColumns.contains("dupnum_reged_mon")) {
                viewColumns.remove("dupnum_reged_mon");
                viewColumns.add("dupnum_reg_mon");
            }
            List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);

            reportResult.setVal(super.transCampaignNameAddName(newResult, app, account));
        } else if ("bd_bycreative".equals(reportName)) {
            reportResult.getColumnkey().set(0, "creativename");

            firstTotalRowColumnKey = "creative";
            if (viewColumns.contains("dupnum_reged_mon")) {
                viewColumns.remove("dupnum_reged_mon");
                viewColumns.add("dupnum_reg_mon");
            }
            List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);

            reportResult.setVal(super.transKeywordAndCreativeName(newResult, false, cid,rootAccount));
        } else if ("bd_bykwid".equals(reportName)) {
            reportResult.getColumnkey().set(0, "keywordname");

            firstTotalRowColumnKey = "kwid";
            if (viewColumns.contains("dupnum_reged_mon")) {
                viewColumns.remove("dupnum_reged_mon");
                viewColumns.add("dupnum_reg_mon");
            }
            List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);

            reportResult.setVal(super.transKeywordAndCreativeName(newResult, true, cid,rootAccount));
        }
        return reportResult;
    }

    @Override
    protected String firstTotalRowNeedReplaceId() {
        return firstTotalRowColumnKey;
    }

    private List<Map<String, Object>> parseTotal(List<Map<String, Object>> result, Long app, Long account, String reportName, Map<String, String> conditions) {
        List<Map<String, Object>> newResult = Lists.newArrayList();

        Account one = authService.findOne(account);
        try {
            Object report = reportService.report(app, reportName, one, conditions);
            ReportListResult listResult = null;
            ReportListResult reportListResult = new ObjectMapper().configure(DeserializationFeature.USE_LONG_FOR_INTS, true).readValue(report.toString(), ReportListResult.class);
            List<Map<String, Object>> val = reportListResult.getVal();
            if (ValidateUtil.isValid(val) && ValidateUtil.isValid(val.get(0))) {
                Map<String, Object> map = val.get(0);
                if (reportName.equals("bd_bycampaign_sum")) {
                    map.put("campaignid", "汇总");
                    map.put("campaignname", "汇总");
                    map.put("isall0", false);
                    map.put("istotal", true);
                } else if (reportName.equals("bd_bykwid_sum")) {
                    map.put("kwid", "汇总");
                    map.put("keywordname", "汇总");
                    map.put("isall0", false);
                    map.put("istotal", true);
                } else if (reportName.equals("bd_bycreative_sum")) {
                    map.put("creative", "汇总");
                    map.put("isall0", false);
                    map.put("creativename", "汇总");
                    map.put("istotal", true);
                }
                newResult.add(map);
                for (Map<String, Object> m : result) {
                    if (m.containsKey("istotal") && (m.get("istotal").toString()).equals("true")) {

                    } else {
                        newResult.add(m);
                    }
                }
                return newResult;
            }
//            System.out.println("~~~~~~~~~~~~~~" + report.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }
        return result;
    }
}
