package com.reyun.report.parse;

import com.google.common.base.Function;
import com.google.common.collect.Maps;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import org.json.JSONException;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ListCampaignDateParse extends AbstractListReportParse {
	
    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) {

        if(reportName.equals("wx_campaigninfo_byds")){
            List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);
            reportResult.setVal(super.transChannelName(newResult, app, account));
            reportResult.getVal().get(0).put("ds","汇总");
            return reportResult;
        }

        final List<Map<String,Object>> valList = reportResult.getVal();
    	Map<String,Map<String,Object>> valMap = Maps.uniqueIndex(valList, new Function<Map<String,Object>, String>() {
            @Override
            public String apply(Map<String,Object> map) {
                return map.get("ds").toString();
            }
        });
        
    	final Set<String> keyList = valMap.keySet();
        
        Map<String, Object> totalResult = new HashMap<>();
        
        List<Map<String, Object>> values = new ArrayList<>();
        
        for (String key : keyList) {
        	Map<String, Map<String, Object>> result = super.aggregateBySingleDimension(key, valMap, totalResult);
        	Map<String, Object> tmpResultValue = result.get("single");
        	values.add(tmpResultValue);
        	totalResult = result.get("total");
        }
        
        totalResult.put("ds", "汇总");
        totalResult = super.calculateRate(totalResult);
        totalResult.put("isall0", false);
       /* try {
            if (null != viewColumns) {
                if (viewColumns.contains("perticket")) {
                    String deviceStr = totalResult.get("num_device").toString();
                    if ("0".equals(deviceStr)) {
                        totalResult.put("amt_perticket", 0.0);
                    } else {
                        double amt_order = Double.parseDouble(totalResult.get("amt_order").toString());
                        long device = Long.parseLong(deviceStr);
                        totalResult.put("amt_perticket", String.format("%.2f", amt_order / device));
                    }
                }
                if (viewColumns.contains("pay_perticket")) {
                    String deviceStr = totalResult.get("num_pay_device").toString();
                    if ("0".equals(deviceStr)) {
                        totalResult.put("amt_pay_perticket", 0.0);
                    } else {
                        double amt_order = Double.parseDouble(totalResult.get("amt_pay_order").toString());
                        long device = Long.parseLong(deviceStr);
                        totalResult.put("amt_pay_perticket", String.format("%.2f", amt_order / device));
                    }
                }
                if (viewColumns.contains("rate_pay")) {
                    String deviceStr = totalResult.get("num_device").toString();
                    if ("0".equals(deviceStr)) {
                        totalResult.put("rate_pay_order", 0.0);
                    } else {
                        long num_pay_device = Long.parseLong(totalResult.get("num_pay_device").toString());
                        long device = Long.parseLong(deviceStr);
                        totalResult.put("rate_pay_order", String.format("%.2f", num_pay_device * 100.0 / device));
                    }
                }
            }
        }catch (Exception e){

        }*/
        values.add(0, totalResult);
    	
    	reportResult.setVal(values);
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }
}
