package com.reyun.report.parse;

import com.reyun.model.Account;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.util.ValidateUtil;
import org.json.JSONException;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ListChannelAdvertisingParse
        extends AbstractListReportParse {
    /*private String reportName;
    private String firstRow;*/
    /*@Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds)
    {
        if (isSearchText) {
            setDefaultValue(reportResult, searchIds);
        }
        reportResult.setVal(super.transChannelAdvertisinginName(reportResult.getVal(), app, account));
        this.reportName=reportName;
        List<Map<String, Object>> newResult = super.calFirstTotalRow(reportResult, viewColumns);
        reportResult.setVal(newResult);
        return reportResult;
    }*/

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns,
                                  String reportName, boolean isSearchText, List<String> dataIds) {
        if (isSearchText) {
            setDefaultValue(reportResult, dataIds);
        }
        removeKey(reportResult, reportName);
        Map<String, Object> totalResult = new HashMap<>();
        List<Map<String, Object>> values = new ArrayList<>();
        List<Map<String, Object>> val = reportResult.getVal();
        if (ValidateUtil.isValid(val)) {
            for (Map<String, Object> map : val) {
                setUpperCaseAAUS(map);
                for (String s : map.keySet()) {
                    if(s.startsWith("cash_income") || s.startsWith("activation_cost")){
                        Object income_data = map.get(s);
                        if (income_data.getClass().isAssignableFrom(Double.class)) {
                            map.put(s, BigDecimal.valueOf((double) map.get(s)).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue());
                        } else {
                            map.put(s, BigDecimal.valueOf((long) map.get(s)).setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue());
                        }
                    }else if(s.startsWith("AAUS")){
                        Object aaus = map.get(s);
                        if(Long.valueOf(0).equals(aaus)){
                            map.put(s,new Double("0.0"));
                        }
                    }
                }
                Map<String, Map<String, Object>> result = super.advertisingByDimension(map, viewColumns, totalResult);
                Map<String, Object> tmpResultValue = result.get("single");
                values.add(tmpResultValue);
            }
        }

        //翻译名字,补全全零数据
        reportResult.setVal(super.transChannelAdvertisinginName(values, app, account));
        //统计汇总
        reportResult.setVal(super.calFirstTotalRow(reportResult, viewColumns));

        return reportResult;
    }

    private void setUpperCaseAAUS(Map<String,Object> map) {
        for (int i = 0; i <8 ; i++) {
            String key = "aaus" + i;
            if(map.containsKey(key)){
                map.put(key.toUpperCase(),map.get(key));
                map.remove(key);
            }
        }
    }

    private void removeKey(ReportListResult reportResult, String reportName) {
        String row;
        List<String> name = reportResult.getName();
        if(name != null && name.contains("unknown")){
            while(name.contains("unknown")){
                name.remove("unknown");
            }
        }
        List<Object> columnkey = reportResult.getColumnkey();
        if (columnkey != null) {
            if (!"adsenseinfo_byadid".equals(reportName)&&columnkey.contains("adid")) columnkey.remove("adid");
            if ("advertisinginfo_byadgroup".equals(reportName)||"adsenseinfo_byadgroup".equals(reportName)) {
                row = "adgroup_id";
                if (columnkey.contains(row)) columnkey.remove(row);
            } else if ("advertisinginfo_byadplan".equals(reportName)||"adsenseinfo_byadplan".equals(reportName)) {
                row = "adplan_id";
                if (columnkey.contains(row)) columnkey.remove(row);
            } else if ("advertisinginfo_byadcreative".equals(reportName)||"adsenseinfo_byadcreative".equals(reportName)) {
                row = "adcreative_id";
                if (columnkey.contains(row)) columnkey.remove(row);
            }
        }
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId() {
        return "name";
    }

    public ReportListResult parseSimple(ReportListResult reportResult, Long appid, Account loginAcount, List<String> viewColumns, String reportName) {
        //简单统计汇总
        List<String> totalCalKeys = Arrays.asList("income_all", "num_impression", "num_click", "ds");
        List<Map<String, Object>> values = super.calFirstTotalRowSimple(reportResult, viewColumns, totalCalKeys, reportName, "ds");
        return reportResult;
    }


    public static void main(String[] args) {
        System.out.println(0.0923 * 100);
    }
}
