package com.reyun.report.parse;

import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.util.DateUtil;
import com.reyun.util.ViewColumnDependUtil;
import org.json.JSONException;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ListChannelDateParse extends AbstractListReportParse
{

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds)
    {
        if (isSearchText) {
            setDefaultValue(reportResult, searchIds);
        }
        reportResult.setVal(super.transChannelName(reportResult.getVal(), app, account));
//        List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);
//        reportResult.setVal(newResult);
        final List<Map<String, Object>> valueList = reportResult.getVal();
        for (Map<String, Object> valMap : valueList) {
            for (String viewColumn : viewColumns) {
                if (viewColumn.toLowerCase().equals("duration")) {
                    valMap.put(viewColumn, DateUtil.formatCaseTime(Long.valueOf(valMap.get(viewColumn)==null?"0":valMap.get(viewColumn).toString())));
                }
                Collection<String> linkfields = ViewColumnDependUtil.getRateDependFields(viewColumn);
                if (linkfields != null && linkfields.size() > 0) {
                    Object[] objects = linkfields.toArray();
                    String[] linkfield = Arrays.copyOf(objects, objects.length, String[].class);
                    final Object f1 = valMap.get(linkfield[0]);
                    if (viewColumn.toLowerCase().startsWith("avg_time")) {
                        valMap.put(viewColumn, divideAvgTime(Long.valueOf(String.valueOf(f1.toString())), Long.valueOf(String.valueOf(valMap.get(linkfield[1])))));
                    }
                }
            }
        }
        reportResult.setVal(valueList);
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId()
    {
        return "cid";
    }
}