package com.reyun.report.parse;

import com.reyun.model.ReportListResult;
import com.reyun.model.Scene;
import com.reyun.report.AbstractListReportParse;
import org.json.JSONException;

import java.util.List;
import java.util.Map;

public class ListSceneParse extends AbstractListReportParse
{

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds)
    {
        if (isSearchText) {
            setDefaultValue(reportResult, searchIds);
        }
        List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);
        reportResult.setVal(super.transChannelName(newResult, app, account));
        List<Map<String, Object>> val = reportResult.getVal();

        for(Map<String, Object> map:val){
            String sceneid = (String)map.get("sceneid");
            Scene scene = sceneRepository.findBySceneId(sceneid);
            if(scene!=null){
                map.put("sceneid",scene.getSceneComment());
            }
            map.put("orisceneid",sceneid);
        }
        reportResult.setVal(val);
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId()
    {
        return "sceneid";
    }
}
