package com.reyun.report.parse;

import com.alibaba.fastjson.JSON;
import com.google.common.base.Function;
import com.google.common.base.Strings;
import com.google.common.collect.Maps;
import com.reyun.model.*;
import com.reyun.report.AbstractListReportParse;
import com.reyun.util.StringUtil;
import com.reyun.util.ValidateUtil;
import net.sf.json.JSONArray;
import org.json.JSONException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class ListThirdAccountParse extends AbstractListReportParse {

    private static final Logger logger = LoggerFactory.getLogger(ListThirdAccountParse.class);
    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns,
                                  String reportName, boolean isSearchText, List<String> dataIds) {


        if (isSearchText) {
            setDefaultValue(reportResult, dataIds);
        }
        Map<String,Map<String,Object>> valMap = Maps.newHashMap();

        List<Object> rs = campaignRepository.findThirdAccountByAppChannel(app, 5305L);
        HashMap<String, String> nameMap = new HashMap<>();

        if(ValidateUtil.isValid(rs)){
            for (Object ob : rs) {
                JSONArray jsonA = JSONArray.fromObject(ob);
                String key = jsonA.getString(0);
                String value = jsonA.getString(1);
                if (!(StringUtil.isEmpty(value) || value=="null")) {
                    nameMap.put(key,value);
                }
            }
        }
        List<Map<String, Object>> val = reportResult.getVal();
        if(!CollectionUtils.isEmpty(nameMap)&&!CollectionUtils.isEmpty(val)){
            for (String s : nameMap.keySet()) {
                for (Map<String, Object> va : val) {
                    if(va.containsKey("sp_account_number")&&va.get("sp_account_number").equals(s)){
                        va.put("sp_account_number",nameMap.get(s));
                        break;
                    }
                }
            }
        }
        //翻译名字,补全全零数据
       // reportResult.setVal(super.transCampaignName(mapList, app, account));
        //统计汇总
        reportResult.setVal(super.calFirstTotalRow(reportResult, viewColumns));

        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId()
    {
        return "sp_account_number";
    }
}
