package com.reyun.report.parse;

import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import org.json.JSONException;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * Created by nolan on 19/01/2017.
 * description:
 */
public class ListTransNameParse extends AbstractListReportParse {

    private String reportName;

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) {

        this.setReportName(reportName);
        if (isReplaceLableKey(reportName)) {
            if (isRPCampaign(reportName)) {
                reportResult.setVal(transCampaignName(reportResult.getVal(), app, account));
            } else if (isRPCampaignGroup(reportName)) {
                reportResult.setVal(transCampaignGroupName(reportResult.getVal(), app, account));
            } else if (isRPChannel(reportName)) {
                reportResult.setVal(transChannelName(reportResult.getVal(), app, account));
            }
        }

        if (reportName.equals("delay_install_bycampaign") || reportName.equals("delay_click_bycampaign")) {
            List<String> keys = reportResult.getColumnkey().stream().map(v -> v == null ? "" : v.toString()).collect(Collectors.toList());
            reportResult.setVal(super.calFirstTotalRow(reportResult, keys));
        }


        super.createColumByReplace(reportResult);
        return reportResult;
    }

    @Override
    protected String firstTotalRowNeedReplaceId() {
        if ("channelinfo_order_bychannel".equals(getReportName()) || "channelinfo_bychannel".equals(getReportName())) {
            return "channelname";
        } else if ("delay_click_bycampaign".equals(reportName) || "delay_install_bycampaign".equals(reportName)) {
            return "campaignid";
        }
        return "";
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    public String getReportName() {
        return reportName;
    }

    public void setReportName(String reportName) {
        this.reportName = reportName;
    }
}
