package com.reyun.report.parse;

import com.reyun.model.PackageSubCampaign;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.util.ValidateUtil;
import org.apache.commons.lang.StringUtils;
import org.json.JSONException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.*;

/**
 * Created by nolan on 18/01/2017.
 * description:
 */
public class RemarketingPackageCampaignParse extends AbstractListReportParse {

    private static final Logger logger = LoggerFactory.getLogger(RemarketingPackageCampaignParse.class);

    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns,
                                  String reportName, boolean isSearchText, List<String> dataIds,Map<String,String> condtions) {

        List<Map<String,Object>> valList = reportResult.getVal();
        List<Map<String,Object>> res = new LinkedList<>();
        List<String> idList = new ArrayList<>();
        if(ValidateUtil.isValid(valList)){
            for(Map<String,Object> map : valList){
                if(map.containsKey("campaignid") && null != map.get("campaignid"))
                idList.add(map.get("campaignid").toString());
            }
        }
        Map<String, String> nameMap = new HashMap<>();
        nameMap.put("_default_", "其他");
        String pcampId = condtions.get("parent_campaignid");

        if(ValidateUtil.isValid(idList)){
            List<PackageSubCampaign> list ;
            if(condtions.containsKey("del_flag")){
                list = packageSubCampaignRepository.listSubCampaignByCampaignidAndPrarentAndDelFlag(idList,pcampId,condtions.get("del_flag").equals("true")?true:false);
            }else{
                list = packageSubCampaignRepository.listSubCampaignAllByCampaignidAndPrarent(idList,pcampId);
            }
            for(PackageSubCampaign sub : list){
                if(condtions.containsKey("searchtxt")) {
                    if(sub.getName().contains(condtions.get("searchtxt"))){
                        nameMap.put(sub.getCampaignid(), sub.getName());
                    }
                }else{
                    nameMap.put(sub.getCampaignid(), sub.getName());
                }
            }
        }


        if(ValidateUtil.isValid(valList)){
            for(Map<String,Object> map : valList){
                if(map.containsKey("campaignid") && null != map.get("campaignid")){
                    map = super.calculateRate(map);
                    String name  = nameMap.get(map.get("campaignid"));

                    if(!StringUtils.isEmpty(name)){
                        map.put("campaignid", name );
                        if(ValidateUtil.isValid(map.get("campaignid"))){
                            res.add(map);
                        }
                    }

                }

            }
        }
        reportResult.setVal(res);
        reportResult.setVal(super.calFirstTotalRow(reportResult, viewColumns));
        return reportResult;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) throws JSONException {
        return null;
    }

    @Override
    protected String firstTotalRowNeedReplaceId()
    {
        return "campaignid";
    }
}
