package com.reyun.report.parse;

import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.ReportChartResult;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.util.Constant;
import com.reyun.util.HttpClientUtil;
import org.json.JSONException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * @author liyin
 * @description
 * @date
 */
public class TerminalListParse extends AbstractListReportParse {

    private static final Logger logger = LoggerFactory.getLogger(TerminalListParse.class);
    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds) throws JSONException {
        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {

        return null;
    }

    @Override
    public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
        return null;
    }

    public ReportChartResult parseByList(ReportChartResult reportResult, App app, Account account, String reportName, Map<String, String> conditions) {

        try {
            conditions.put("viewtype","none");
            String url = Constant.reportUrl + "/api/trackingio/"+reportName+"_sum/" + app.getAppkey();
            String responseJson = HttpClientUtil.doHttpPostRequest(url, "trackingio", conditions);
            ReportChartResult result = new ObjectMapper().configure(DeserializationFeature.USE_LONG_FOR_INTS, true).readValue(responseJson, ReportChartResult.class);
            List<Object[]> val = result.getVal();
            List<Object[]> val1 = reportResult.getVal();
            List<Object[]> val_new = new ArrayList<>();
            if(val1!=null && val1.size()>0){
                for (int i = 0; i < val.size(); i++) {
                    Object[] objects = val.get(i);
                    Object[] objects1 = val1.get(i);
                    Object[] objects2 = new Object[objects1.length+1];
                    objects2[0] = objects[0];
                    for (int j = 0; j < objects1.length; j++) {
                        objects2[j+1] = objects1[j];
                    }
                    val_new.add(objects2);
                }
            }else{
                val_new = val;
            }
            List<String> key = result.getKey();
            reportResult.setVal(val_new);
            reportResult.getKey().add(0,"汇总");
        } catch (IOException e) {
            logger.error("终端属性报表查询错误>>>>",e);
        }
        return reportResult;
    }
}
