package com.reyun.report.roi;

import com.google.common.collect.Lists;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.util.ValidateUtil;
import org.json.JSONException;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * Created by nolan on 15/02/2017.
 * description:
 */
public class ListRoiByCampaignParse extends AbstractListReportParse
{

	@Override
	public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> dataIds)
	{
		if (isSearchText) {
			setDefaultValue(reportResult, dataIds);
		}

		reportResult.getColumnkey().set(0, "campaignname");
		if (reportResult.getColumnkey() != null && reportResult.getColumnkey().size() > 0){
			viewColumns = Lists.newArrayList();
			for (Object tmpKey : reportResult.getColumnkey()) {
				if (tmpKey.equals("campaignname")) {
					continue;
				}

				viewColumns.add(String.valueOf(tmpKey));
			}
		}

		List<Map<String, Object>> newResult = calFirstTotalRow(reportResult, viewColumns);
		List<Map<String, Object>> res = new LinkedList<>();
		if(ValidateUtil.isValid(newResult)){
			for(int i =0; i < newResult.size(); i++){
				Map<String, Object> map = newResult.get(i);
				if("汇总".equals(map.get("campaignid"))){
					if((map.get("num_ins").toString()).equals("0.0")){
						map.put("amt_arpu","0");
					}else{
						map.put("amt_arpu",(map.get("num_ins").toString()).equals("0") ? 0d : String.format("%.2f", (Double)map.get("amt_amount") / Long.parseLong(map.get("num_ins").toString())));
					}
					if((map.get("num_pay").toString()).equals("0.0")){
						map.put("amt_arppu","0");
					}else{
						map.put("amt_arppu",(map.get("num_pay").toString()).equals("0") ? 0d : String.format("%.2f",(Double)map.get("amt_amount") / Long.parseLong(map.get("num_pay").toString())));
					}

					res.add(map);
				}else{
					res.add(map);
				}


			}

		}
		reportResult.setVal(super.transCampaignNameAddName(res, app, account));
		return reportResult;
	}

	@Override
	public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
		return null;
	}

	@Override
	public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
		return null;
	}

	@Override
	protected String firstTotalRowNeedReplaceId()
	{
		return "campaignid";
	}
}
