package com.reyun.report.roi;

import com.google.common.collect.Lists;
import com.reyun.context.AppUtils;
import com.reyun.model.Channel;
import com.reyun.model.ReportListResult;
import com.reyun.report.AbstractListReportParse;
import com.reyun.service.ChannelService;
import com.reyun.util.ValidateUtil;
import org.apache.commons.collections.map.HashedMap;
import org.json.JSONException;

import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by nolan on 15/02/2017.
 * description:
 */
public class ListRoiByChannelParse extends AbstractListReportParse
{
	protected ChannelService channelService = AppUtils.getApplicationContext().getBean(ChannelService.class);

	@Override
	public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> dataIds)
	{

		List<Map<String, Object>> newResult = reportResult.getVal();
		List<Long> idList = new ArrayList<>();
		for(Map<String, Object> map : newResult){
			String cid = map.get("cid").toString();
			Long id = Long.parseLong(cid);
			idList.add(id);
		}

		Map<Long, String> nameMap = new HashMap<>();
		if(ValidateUtil.isValid(idList)){
			List<Channel> channelList = channelService.listChannelByIds(idList);
			nameMap.put(-1L, "自然量");
			if(ValidateUtil.isValid(channelList)){
				for(Channel ch : channelList){
					nameMap.put(ch.getId(), ch.getName());
				}
			}
		}

		List<Map<String, Object>> res = new LinkedList<>();
		Map<String, Object> mapTotal = new HashMap<>();
		mapTotal.put("dupnum_click_day",0L);
		mapTotal.put("num_ins",0L);
		mapTotal.put("num_click",0L);
		mapTotal.put("dupnum_reg",0L);
		mapTotal.put("num_pay",0L);
		mapTotal.put("dupnum_click_all",0L);
		mapTotal.put("amt_amount",0d);
		for(Map<String, Object> map : newResult){
			String cid = map.get("cid").toString();
			Long id = Long.parseLong(cid);
			mapTotal.put("dupnum_click_day",Long.parseLong(map.get("dupnum_click_day").toString()) + (Long)mapTotal.get("dupnum_click_day"));
			mapTotal.put("num_ins",Long.parseLong(map.get("num_ins").toString()) + (Long)mapTotal.get("num_ins"));
			mapTotal.put("num_click",Long.parseLong(map.get("num_click").toString()) + (Long)mapTotal.get("num_click"));
			mapTotal.put("dupnum_reg",Long.parseLong(map.get("dupnum_reg").toString()) + (Long)mapTotal.get("dupnum_reg"));
			mapTotal.put("num_pay",Long.parseLong(map.get("num_pay").toString()) + (Long)mapTotal.get("num_pay"));
			mapTotal.put("dupnum_click_all",Long.parseLong(map.get("dupnum_click_all").toString()) + (Long)mapTotal.get("dupnum_click_all"));
			mapTotal.put("amt_amount",Double.parseDouble(map.get("amt_amount").toString()) + (Double)mapTotal.get("amt_amount"));
			if(nameMap.containsKey(id)){
				map.put("cid", nameMap.get(id));
				map.put("id",id);
			}
			res.add(map);
		}
		mapTotal.put("amt_arpu",((Long)mapTotal.get("num_ins")).equals(0L) ? 0d : String.format("%.2f", (Double)mapTotal.get("amt_amount") / (Long)mapTotal.get("num_ins")));
		mapTotal.put("amt_arppu",((Long)mapTotal.get("num_pay")).equals(0L) ? 0d : String.format("%.2f", (Double)mapTotal.get("amt_amount") / (Long)mapTotal.get("num_pay")));
		mapTotal.put("rate_pay",((Long)mapTotal.get("num_ins")).equals(0L) ? 0d : String.format("%.2f", (Long)mapTotal.get("num_pay") * 100.0 / (Long)mapTotal.get("num_ins")));
		mapTotal.put("cid","汇总");

		Double amount = Double.valueOf(mapTotal.get("amt_amount").toString());
		mapTotal.put("amt_amount", new java.text.DecimalFormat("#0.00").format(amount));

		res.add(0,mapTotal);
		reportResult.setVal(res);
		return reportResult;
	}

	@Override
	public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid, Map<String, String> conditions) throws JSONException {
		return null;
	}

	@Override
	public ReportListResult parse(ReportListResult reportResult, Long app, Long account, List<String> viewColumns, String reportName, boolean isSearchText, List<String> searchIds, Long cid) throws JSONException {
		return null;
	}

	@Override
	protected String firstTotalRowNeedReplaceId()
	{
		return "cid";
	}
}
