package com.reyun.repository;

import com.reyun.model.AccountFunctionAuth;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by zy on 2019/12/27.
 */
@Transactional
public interface AccountFunctionAuthRepository extends JpaRepository<AccountFunctionAuth, Long> {

    @Query(value = "select * from account_function_auth where account=?1", nativeQuery = true)
    List<AccountFunctionAuth> getByAccount(Long account);
    @Transactional
    @Modifying
    @Query(value = "delete from account_function_auth where account=?1 and menu = ?2", nativeQuery = true)
    int close(Long account, String menu);

    @Query(value = "select * from account_function_auth where account=?1 and menu = ?2 limit 1", nativeQuery = true)
    AccountFunctionAuth getByAccountAndMenu(Long account,String menu);
}
