package com.reyun.repository;

import com.reyun.model.AccountRestrict4Web;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by song on 2018/2/12.
 */
@Transactional
public interface AccountRestrict4WebRepository extends JpaRepository<AccountRestrict4Web, Long> {
    @Query(value = "select * from account_restrict4web where account_id=?1 and del_flag is not true", nativeQuery = true)
    AccountRestrict4Web findByAccountId(Long account);

    @Query(value = "select * from account_restrict4web where account_id=?1 and del_flag is  true", nativeQuery = true)
    AccountRestrict4Web findByAccountDelFlag(Long account);

    @Query(value = "delete from account_restrict4web where id = ?1",nativeQuery = true)
    @Transactional
    @Modifying
    int deleteById(Long id);
}
