package com.reyun.repository;

import com.reyun.model.AdsAccount;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author: zhangyao
 * @create: 2019-07-08 15:45
 **/
@Transactional
public interface AdsAccountRepository extends JpaRepository<AdsAccount,Long> {



    //permission  0:正常；1:账户停用 ， 2:密码更新
    @Modifying
    @Transactional
    @Query(value = "update ads_account set permission=?2 where id = ?1", nativeQuery = true)
    int updatePermissionById(Long id, int permission);

    @Query(value = "select * from ads_account  where account = ?1", nativeQuery = true)
    AdsAccount findByAccount(Long id);

    @Query(value = "select * from ads_account  where token = ?1", nativeQuery = true)
    AdsAccount getByToken(String token);
}
