package com.reyun.repository;

import com.google.api.ads.adwords.axis.v201702.cm.Ad;
import com.reyun.model.AdvancedFunctionApply;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * Created by sunhao on 18/5/17.
 * 高级功能申请DAO
 */
public interface AdvancedFunctionApplyRepository extends JpaRepository<AdvancedFunctionApply, Long> {

    @Query(value = "select * from advanced_function_apply where root_parent=?1 and status = 1 limit 1", nativeQuery = true)
    AdvancedFunctionApply findNormalByAccount(Long rootParent);

    @Query(value = "select * from advanced_function_apply where root_parent=?1 and function_menu = ?2", nativeQuery = true)
    AdvancedFunctionApply findByRootAccount(Long rootParent,String functionMenu);

    @Query(value = "select * from advanced_function_apply where account=?1 and function_menu = ?2", nativeQuery = true)
    AdvancedFunctionApply findByAccount(Long accountid,String functionMenu);//用此方法的时候是为了查询本账号的付费记录（如果不是特殊需要最好用findByRootAccount）

    @Query(value = "select * from advanced_function_apply where  function_menu = ?1 and now() > past_date and status <> 0", nativeQuery = true)
    List<AdvancedFunctionApply> findInVaildData(String functionMenu);

    @Query(value = "select  * from advanced_function_apply where function_menu = ?1 and status <> 0 and DATE_FORMAT(past_date, \"%Y-%m-%d\") = ?2", nativeQuery = true)
    List<AdvancedFunctionApply> findToExpireData(String functionMenu, String time);

    @Transactional
    @Modifying
    @Query(value = "update advanced_function_apply set warn_time = warn_time + 1 where id = ?1 and warn_time < ?2", nativeQuery = true)
    int addWarnTime(long id, int warnTime);



}
