package com.reyun.repository;

import com.reyun.model.AdvertisingBinduser;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigInteger;
import java.util.List;

/**
 * Created by zy on 2019/12/27.
 */
@Transactional
public interface AdvertisingBinduserRepository extends JpaRepository<AdvertisingBinduser, Long> {


    @Query(value = "select count(*) from advertising_binduser where root_account=?1 and app = ?2", nativeQuery = true)
    BigInteger getCount(Long rootParent, Long app);
    @Query(value = "select * from advertising_binduser where root_account=?1 and app = ?2", nativeQuery = true)
    List<AdvertisingBinduser> list(Long rootParent, Long app);
    @Query(value = "select * from advertising_binduser where app=?1 and user_id = ?2 limit 1", nativeQuery = true)
    AdvertisingBinduser getByUserId(Long app, String userId);
    @Query(value = "select * from advertising_binduser where status is true ", nativeQuery = true)
    List<AdvertisingBinduser> findByStatus();
    @Query(value = "select * from advertising_binduser where app=?1 and secure_key = ?2 limit 1", nativeQuery = true)
    AdvertisingBinduser getBySecure_key(Long app, String secureKey);
    @Query(value = "SELECT appkey,GROUP_CONCAT(distinct secure_key) FROM `advertising_binduser` a LEFT JOIN app b ON a.app = b.id WHERE type_name = ?1 and STATUS IS TRUE GROUP BY app", nativeQuery = true)
    List<Object[]> findByTypeAndStatus(String type);
    @Query(value = "SELECT appkey,GROUP_CONCAT(distinct secure_key) FROM `advertising_binduser` a LEFT JOIN app b ON a.app = b.id WHERE a.id=?1 GROUP BY app", nativeQuery = true)
    List<Object[]> findByTypeAndStatusAndId(Long id);

    AdvertisingBinduser findByApp(long l);
}
