package com.reyun.repository;

import com.reyun.model.AppDeepLink;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigInteger;
import java.util.List;

/**
 * @author liyin
 * @description
 * @date
 */

public interface AppDeepLinkRepository extends JpaRepository<AppDeepLink,Long> {

    @Query(value = "select * from app_deep_link where link_id = ?1", nativeQuery = true)
    AppDeepLink findOneByLinkId(String linkId);

    @Query(value = "select * from app_deep_link where appid = ?1", nativeQuery = true)
    AppDeepLink findOneByAppId(Long id);

    @Query(value = "select * from app_deep_link where link_id = ?2 and appid != ?1", nativeQuery = true)
    AppDeepLink findDeepLinkNotOwnAppByLinkId(Long appid, String value);

    @Query(value = "select * from app_deep_link where  appid = ?1", nativeQuery = true)
    AppDeepLink findOneByAppidId(Long appid);

    @Query(value = "select adl.*,a.name as app_name,a.appkey as app_key  from app_deep_link adl LEFT join app a on adl.appid=a.id where  adl.account_id = ?1", nativeQuery = true)
    List<AppDeepLink> selectDeepLinksByAccount(Long id);

    @Query(value = "select appid from app_deep_link where  account_id = ?1", nativeQuery = true)
    List<BigInteger> selectDeepLinkAppIds(Long rootParent);

    @Query(value = "select * from app_deep_link where  appid = ?1", nativeQuery = true)
    AppDeepLink findDeepLinkByAppId(Long appid);
}
