package com.reyun.repository;

import com.reyun.model.AbTest;
import com.reyun.model.BlacklistApplication;
import com.reyun.model.BlacklistTime;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by sunhao on 17/9/21.
 * 测试查询
 */
public interface BlacklistApplicationRepository extends JpaRepository<BlacklistApplication,Long> {

    @Query(value = "select * from blacklist_application where parent_account = ?1 AND menu='fake' limit 1", nativeQuery = true)
    BlacklistApplication findByParent(Long account);

    @Query(value = "select * from blacklist_application where parent_account = ?1 and status > 0 AND menu='fake' limit 1", nativeQuery = true)
    BlacklistApplication findByParentAndPast(Long account);

    @Query(value = "select * from blacklist_application where account_id = ?1 and status > 0 AND menu='fake'", nativeQuery = true)
    BlacklistApplication findByAccount(Long account);

    @Query(value = "select * from blacklist_application where account_id = ?1 and status = 0 AND menu='fake'", nativeQuery = true)
    BlacklistApplication findByAccountAndJustApply(Long account);

    @Query(value = "select * from blacklist_application where  past_date> ?1 and  status > 0 AND menu='fake'", nativeQuery = true)
    List<BlacklistApplication> findAllnotPast(String pastFive);

    @Query(value = "select * from blacklist_application where parent_account = ?1 AND menu='arouse' limit 1", nativeQuery = true)
    BlacklistApplication findByParentAndArouse(Long account);

    @Query(value = "select * from blacklist_application where parent_account = ?1 AND menu=?2 limit 1", nativeQuery = true)
    BlacklistApplication findByParent(Long rootParent, String menu);
}
