package com.reyun.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import com.reyun.model.CallbackCustomize;


public interface CallbackCustomizeRepository extends JpaRepository<CallbackCustomize, Long> {

	Iterable<CallbackCustomize> findByAccount(Long id);
	
	Iterable<CallbackCustomize> findByApp(Long id);
	
	CallbackCustomize findByName(String name);
	
	@Query(value = "select * from callback_customize c where c.account=?1 and c.app=?2 and c.name =?3 and del_flag is not true", nativeQuery = true)
	CallbackCustomize findByNameAndAccount(Long account,Long app, String name);

	@Query(value = "select * from callback_customize c where c.name=?1 and c.app=?2", nativeQuery = true)
	CallbackCustomize findByNameAndApp(String name, Long appid);
	
	@Query(value = "select c.id, c.`name` as callbackname, c.active, c.what, c.updatetime, a.`name` as appname,ch.`name` as channelname, c.app, c.channel, c.url, c.all_data, case when c.what in ('install','reged','loggedin','payment') then null else (select effect_point.`name` from callback_customize,effect_point where callback_customize.what=effect_point.codename and callback_customize.app=effect_point.app )  end as pointname from callback_customize c, app a, channel ch where c.account=?1 and c.channel=ch.id and c.app=a.id", nativeQuery = true)
	List<Object[]> findByAccount4Web(Long id);

	
	@Query(value = "select c.id, c.`name` as callbackname, c.active, c.what, c.updatetime, a.`name` as appname,ch.`name` as channelname, c.app, c.channel, c.url, c.all_data, case when c.what in ('install','reged','loggedin','payment') then null else (select effect_point.`name` from callback_customize,effect_point where callback_customize.what=effect_point.codename and callback_customize.app=effect_point.app )  end as pointname,c.successcode, c.successkey, c.successvalue from callback_customize c, app a, channel ch where c.id=?1 and c.channel=ch.id and c.app=a.id", nativeQuery = true)
	Object[] findOne4Web(Long id);

	@Query(value = "select * from callback_customize  where account = ?1 and app = ?2 and channel = ?3 and what = ?4", nativeQuery = true)
	CallbackCustomize find(Long accountid, Long app, Long channelid, String what);
	
	@Query(value = "select * from callback_customize where account = ?1 and app = ?2 and del_flag is not true order by modify_time desc", nativeQuery = true)
	List<CallbackCustomize> listByAccount(Long account,Long app);

	@Query(value = "select * from callback_customize where app = ?1 and del_flag is not true order by modify_time desc", nativeQuery = true)
	List<CallbackCustomize> listByApp(Long app);
	
	@Query(value = "select * from callback_customize where channel = ?1 and del_flag is not true", nativeQuery = true)
	List<CallbackCustomize> listByChannel(Long channel);

	@Query(value = "select * from callback_customize where channel = ?1 and app = ?2 and del_flag is not true", nativeQuery = true)
	List<CallbackCustomize> findByChannelAndApp(Long channel, Long app);

	@Query(value = "select * from callback_customize where channel = ?1 and what = ?2  and app = ?3 and del_flag is not true", nativeQuery = true)
	List<CallbackCustomize> findByChannelAndEvent(Long channelId, String what, Long app);

}
