package com.reyun.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import com.reyun.model.CamCamgroupMap;

public interface CamCamgroupMapRepository extends JpaRepository<CamCamgroupMap, Long>{
	
	@Query(value="select campaign from cam_camgroup_map where camp_group=?1",nativeQuery = true)
	List<Long> findCampaignByGroup(Long camp_group);

    @Query(value="select campaign from cam_camgroup_map where camp_group in ?1",nativeQuery = true)
    List<Long> findCampaignByGroup(List<Long> groupIdList);
	
	@Query(value="select * from cam_camgroup_map where campaign in ?1",nativeQuery = true)
	List<CamCamgroupMap> listAllByCampaignIds(Iterable<Long> campaignIds);
	
	@Query(value="select * from cam_camgroup_map where camp_group in ?1",nativeQuery = true)
	List<CamCamgroupMap> listAllByCampaignGroupIds(List<Long> campaignIds);
	
	@Query(value="select * from cam_camgroup_map where  camp_group=?1",nativeQuery = true)
	List<CamCamgroupMap> listAllByGroupId(Long camp_group);
	
	@Query(value="select * from cam_camgroup_map where campaign=?1",nativeQuery = true)
	List<CamCamgroupMap> listCamCampMapByCamp(Long campaign);

	@Query(value="select * from cam_camgroup_map where camp_group in ?1",nativeQuery = true)
	List<CamCamgroupMap> listCamCampMapByIds(Iterable<Long> groupids);
}
