package com.reyun.repository;

import com.reyun.model.CampaignWechatAccount;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface CampaignWeChatAccountRepository extends JpaRepository<CampaignWechatAccount,Long>{

    @Modifying
    @Transactional
    @Query(value = "update campaign_wechat_account set mpaccesstoken = ?2,modify_time=?3 where id = ?1", nativeQuery = true)
    void updateTokenAndDateById(Long id, String mptoken, String currentDateStr);


    @Query(value = "select * from campaign_wechat_account where mpappid = ?1 and root_account_id = ?2 ", nativeQuery = true)
    CampaignWechatAccount findByMpappid(String mpappid, Long root_account_id);

    @Modifying
    @Transactional
    @Query(value = "update campaign_wechat_account set mpaccess_token_url = ?1,mpappsecret=?2,modify_time=?4 where id = ?3", nativeQuery = true)
    void updateAccessTokenUrlAndMpappsecretById(String mpaccess_token_url, String mpappsecret, Long id, String currentDateStr);

    @Query(value = "select t1.appkey,t1.campaignid,t1.user_action_set_id,t2.mpaccesstoken from campaign_wechat_link t1 join campaign_wechat_account t2 on t1.mpappid=t2.mpappid where t1.status=0", nativeQuery = true)
    List<Object[]> findAllSynDDB();
}
