package com.reyun.repository;

import com.reyun.model.CampaignWechatLink;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface CampaignWeChatLinkRepository extends JpaRepository<CampaignWechatLink,Long> {


    @Query(value = "select * from campaign_wechat_link where user_action_set_id=?1",nativeQuery = true)
    CampaignWechatLink findByUserActionSetId(String s);

    @Transactional
    @Modifying
    @Query(value = "update campaign_wechat_link SET status=?2 where campaignid=?1", nativeQuery = true)
    void updateStatusByCampaignId(String campaignid, int i);

    @Query(value = "select * from campaign_wechat_link where campaignid=?1",nativeQuery = true)
    CampaignWechatLink findByCampaignId(String campaignid);

    @Query(value = "select * from campaign_wechat_link where mpappid=?1",nativeQuery = true)
    List<CampaignWechatLink> findByMpAappId(String mpappid);
}
