package com.reyun.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import com.reyun.model.ChannelIntegrate;

/**
 * 渠道集成
 */
public interface ChannelIntegrateRepository extends JpaRepository<ChannelIntegrate, Long> {

	@Query(value = "select * from channel_integrate where channel=?1 and what=?2", nativeQuery = true)
	ChannelIntegrate findByChannelAndWhat(Long channel, String what);

	@Query(value = "select * from channel_integrate where channel=?1", nativeQuery = true)
	List<ChannelIntegrate> findByChannel(Long channel);

	@Query(value = "select * from channel_integrate where channel=?1 order by sort", nativeQuery = true)
	List<ChannelIntegrate> findByChannelSort(Long channel);
}
