package com.reyun.repository;

import com.reyun.model.ChannelParam;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by mxq on 2017/9/11.
 */
@Transactional
public interface ChannelParamRepository extends JpaRepository<ChannelParam, Long> {

    @Query(value="select * from channel_param where app = ?1 and cid = ?2",nativeQuery=true)
    ChannelParam findByAppCid(long app, long cid);

    @Query(value="select * from channel_param where account = ?1",nativeQuery=true)
    List<ChannelParam> findByAccount(long account);

    @Query(value="select * from channel_param where app = ?1",nativeQuery=true)
    List<ChannelParam> findByApp(long app);

    @Query(value="select * from channel_param where app = ?1 and channel_num <> whole_channel_num and channel_num <> 0",nativeQuery=true)
    List<ChannelParam> findDiffByApp(long app);

    @Query(value="select * from channel_param where app = ?1 and channel_num <> whole_channel_num and channel_num = 0",nativeQuery=true)
    List<ChannelParam> findDiffAndClosedByApp(long app);

    @Transactional
    @Modifying
    @Query(value = "delete from channel_param where app = ?1", nativeQuery = true)
    void deleteByApp(Long account);


    @Query(value = "select DISTINCT(a.imp_attribute) from (select * from channel_param where account=?1 and imp_attribute is not NULL) a", nativeQuery = true)
    List<Boolean> findImpAttributeStatus(Long account);

    @Transactional
    @Modifying
    @Query(value = "update channel_param set imp_attribute=?1 where app=?2", nativeQuery = true)
    void updateImpAttributeStatus(Boolean status,Long accountId);


    @Transactional
    @Modifying
    @Query(value = "update channel_param set blacklist_status   = 1,device_black_status = 1,whole_blacklist_status =1,whole_device_black_status =1,blacklist_level=1,whole_level=1,channel_num=5,whole_channel_num  = 5 where account in (?1)",nativeQuery = true)
    int updateAutoOpenBlack(List<String> accountIds);

    @Query(value="select * from channel_param where app = ?1 ",nativeQuery=true)
    List<ChannelParam> findByapp(Long app);

    @Transactional
    @Modifying
    @Query(value = "update channel_param set backflow_attr_num   = ?2 , modify_account = ?3,modify_time = ?4 where app = ?1",nativeQuery = true)
    int updateBackflowAttrNum(Long app, Integer backflowAttrNum, Long loginAccount,String date);
}
