package com.reyun.repository;

import com.reyun.model.ChannelAccountLinkApp;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.List;

/**
 * Created by mxq on 17/7/11.
 */
public interface ChannnelAccountLinkAppRepository
        extends JpaRepository<ChannelAccountLinkApp, Long>
{

    List<ChannelAccountLinkApp> findByLinkUserId(long channelAccount);

    List<ChannelAccountLinkApp> findByAccountId(String accountid);

    List<ChannelAccountLinkApp> findByAppkeyIn(List<String> appkeys);

    @Query(value = "select create_user from channel_account_link_app where  appkey = ?1 and  account_id = ?2", nativeQuery = true)
    BigInteger findByAppkeyAndAccountid(String appkey, String accountId);

    @Query(value = "select * from channel_account_link_app where  link_user_id in ?1", nativeQuery = true)
    List<ChannelAccountLinkApp> findByLinkUserIds(List<Long> ids);

    @Query(value = "select * from channel_account_link_app where  link_user_id = ?1", nativeQuery = true)
    List<ChannelAccountLinkApp> findByLinkUserId(Long linkUserId);


    @Query(value = "select * from channel_account_link_app where  create_user in ?1", nativeQuery = true)
    List<ChannelAccountLinkApp> findByCreateUser(List<Long> accountIds);

    @Query(value = "select calp.* from channel_account_link_app calp, channel_account ca where ca.channel=5303 and ca.id=calp.link_user_id and appkey=?1 and test_success=1 and ca.status is true", nativeQuery = true)
    List<ChannelAccountLinkApp> findByAppkey(String appKey);

    @Query(value = "select distinct a.user_action_set_id from channel_account_link_app a join channel_account b on a.link_user_id = b.id where b.status = 1 and b.past_status = 0 and b.unique_name = 'adwords'", nativeQuery = true)
    List<String> findLinkIds();
    @Query(value = "select a.* from channel_account_link_app a join channel_account b on a.link_user_id = b.id where b.status = 1 and b.past_status = 0 and b.unique_name = 'adwords'", nativeQuery = true)
    List<ChannelAccountLinkApp> findAllByAdwordsAndChannelAccount();

    @Modifying
    @Query(value = "update channel_account_link_app c set c.test_success = 0  where c.user_action_set_id in ?1", nativeQuery = true)
    int updateStatus(List<String> linkids);

    @Query(value = "select * from channel_account_link_app where link_user_id in (select id from channel_account where root_account = ?1 and channel =?2 and past_status = 0 and status = 1 ) ", nativeQuery = true)
    List<ChannelAccountLinkApp> findAllLinkAppByAccount(Long rootParent, Long cid);

    @Query(value = "select count(*) from channel_account_link_app where user_action_set_id =?1",nativeQuery = true)
    BigDecimal findCountByLinkId(String userActionSetId);

    @Query(value = "select GROUP_CONCAT(DISTINCT account_id) from channel_account_link_app where link_user_id =?1",nativeQuery = true)
    String getStringByChannelAccountId(Long id);

    @Query(value="select a.* from channel_account_link_app a left join app p on a.appkey = p.appkey left join auth au on au.app = p.id where a.link_user_id = ?1 and au.account = ?2 and au.account is not null",nativeQuery=true)
    List<ChannelAccountLinkApp> findWithSubManagerByLinkUserId(long linkId, Long accountId);
}
