package com.reyun.repository;

import com.reyun.model.Crowd;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface CrowdRepository extends JpaRepository<Crowd, Long> {

    @Query(value = "select * from crowd where root_account = ?1 ", nativeQuery = true)
    List<Crowd> findByAccount(Long rootParent);

    @Query(value = "select * from crowd where status = ?1 ", nativeQuery = true)
    List<Crowd> findNotCompleteOrder(Integer status);

    @Query(value = "select * from crowd where root_account = ?1 order by id limit 1", nativeQuery = true)
    Crowd findFirstOrder(Long rootParent);
}
