package com.reyun.repository;

import com.reyun.model.DeviceWhiteList;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface DeviceWhiteListRepository extends JpaRepository<DeviceWhiteList,Long>{

    @Query(value = "select * from device_white_list where account_id = ?1 and device_name=?2 and platform=?3", nativeQuery = true)
    List<DeviceWhiteList> findByAccountAndName(Long accountId, String deviceName,String platform);

    @Query(value = "select * from device_white_list where account_id = ?1 and idfa=?2 and platform=?3", nativeQuery = true)
    List<DeviceWhiteList> findByAccountAndIdfa(Long accountId, String idfa,String platform);

    @Query(value = "select * from device_white_list where account_id = ?1 and imei=?2 and platform=?3", nativeQuery = true)
    List<DeviceWhiteList> findByAccountAndImei(Long accountId, String imei,String platform);

    @Query(value = "select * from device_white_list where account_id = ?1 and oaid=?2 and platform=?3", nativeQuery = true)
    List<DeviceWhiteList> findByAccountAndOaid(Long accountId, String oaid,String platform);

    @Query(value = "select * from device_white_list where account_id = ?1 and android_id=?2 and platform=?3", nativeQuery = true)
    List<DeviceWhiteList> findByAccountAndAndroidId(Long accountId, String AndroidId,String platform);

    @Query(value = "select * from device_white_list where account_id = ?1", nativeQuery = true)
    List<DeviceWhiteList> findByAccount(Long rootParent);
}
