package com.reyun.repository;

import com.reyun.model.DownloadInfo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by nolan on 04/01/2017.
 * description:
 */
@Repository
public interface DownloadInfoRepository extends JpaRepository<DownloadInfo, Long> {
    List<DownloadInfo> findByAccountAndDownloadtype(Long account, String downloadtype);

    @Query(value = "select a from DownloadInfo a where a.app = ?1 and a.account = ?2 and a.downloadtype = ?3")
    List<DownloadInfo> find(Long app, Long accountid, String downloadtype);

    @Query(value = "select a from DownloadInfo a where a.app = ?1 and status<>'invalid' order by create_time desc")
    List<DownloadInfo> findByApp(Long app);
    
    @Query(value = "select a from DownloadInfo a where a.app = ?1 and a.account = ?2  and status<>'invalid' order by create_time desc")
    List<DownloadInfo> findByAccountAndApp(Long app, Long accountid);

    @Query("select count(a) from DownloadInfo a where a.account = :account and a.app = :app and a.downloadtype = :downloadtype and a.divtype = :divtype and a.startdate = :startdate and a.enddate = :enddate")
    long exist(@Param("account") Long account, @Param("app") Long app, @Param("downloadtype") String downloadType, @Param("divtype") String divType, @Param("startdate") String startDate, @Param("enddate") String endDate);

    @Query("select count(a) from DownloadInfo a where a.account = :account and filename = :filename and downloadtype= :downloadtype")
    long exist(@Param("account") Long account, @Param("filename") String filename, @Param("downloadtype") String downloadtype);

    @Modifying
    @Query("update DownloadInfo t set t.status = :status where t.id = :id")
    void update(@Param("id") Long id, @Param("status") String status);

    @Query(value = "select * from download_info where filename = ?2 and account = ?1 and downloadtype = ?3",nativeQuery = true)
    DownloadInfo findByDtype(Long account, String filename, String downloadtype);
}
