package com.reyun.repository;

import com.reyun.model.ExternalDownload;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * Created by sunhao on 17/4/7.
 */
public interface ExternalDownloadRepository  extends JpaRepository<ExternalDownload,Long>{


    @Query(value = "select * from external_download where app_key = ?1 and file_name in ?2 limit 1",nativeQuery = true)
    ExternalDownload findDownloadInfoByFileName(String appKey, List<String> fileName);

    @Transactional
    @Modifying
    @Query(value = "update external_download set download_ip = ?1,download_time = ?2,download_count = ifnull(download_count,0)+1 where id = ?3 ", nativeQuery = true)
    int updateDownloadInfo(String ip, Date downloadTime, Long id);
}
