package com.reyun.repository;

import com.reyun.model.GdtPlan;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
@Transactional
public interface GdtPlanRepository extends JpaRepository<GdtPlan,Long> {

    @Query(value = "select feedbackURL from gdt_plan ",nativeQuery = true)
    List<String> findAllurl();

    @Query(value = "update gdt_plan set plan=?1 where root_account = ?2",nativeQuery = true)
    @Modifying
    @Transactional
    int updatePlanByRootAccount(int plan, Long rootParent);

    @Query(value = "select * from gdt_plan where root_account = ?1 limit 1",nativeQuery = true)
    GdtPlan getGdtlanByRootAccount(Long rootParent);

    @Query(value = "select * from gdt_plan where appKey = ?1 limit 1",nativeQuery = true)
    GdtPlan getGdtPlanByAppkey(String appkey);

    @Query(value = "delete from gdt_plan where appKey = ?1",nativeQuery = true)
    @Modifying
    @Transactional
    void deleteByAppkey(String appkey);

    @Query(value = "select * from gdt_plan where root_account = ?1 and feedbackURL=?2 limit 1",nativeQuery = true)
    GdtPlan findByRootAccountAndUrl(Long rootParent, String shortUrl);

    @Query(value = "update gdt_plan set plan=?1 where id = ?2",nativeQuery = true)
    @Modifying
    @Transactional
    int updatePlanById(int plan, int id);

    @Query(value = "update gdt_plan set url_scheme=?1 where id = ?2",nativeQuery = true)
    @Modifying
    @Transactional
    void updateUrlSchemeById(String url_scheme, int id);

    @Query(value = "update gdt_plan set subscribes=?1 where id = ?2",nativeQuery = true)
    @Modifying
    @Transactional
    void updateSubscribesById(boolean subscribes, int id);

    @Query(value = "select * from gdt_plan where appKey = ?1 and plan = ?2 and subscribes = ?3 limit 1",nativeQuery = true)
    GdtPlan getGdtPlanByAppkeyAndPlanAndSubscribes(String appkey, int plan,boolean subscribes);
}
