package com.reyun.repository;

import com.reyun.model.IqiyiCampaign;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by zy on 2020/03/03.
 */
@Transactional
public interface IqiyiCampaignRepository extends JpaRepository<IqiyiCampaign, Long> {

    @Modifying
    @Transactional
    @Query(value = "delete from iqiyi_campaign where campaignid =?1 ", nativeQuery = true)
    int deleteByCampaignid(String campaignid);

    @Query(value = "select * from iqiyi_campaign where campaignid = (select campaignid from package_sub_campaign where parent = ?1 AND NAME = '爱奇艺模糊归因' limit 1)   ",nativeQuery = true)
    IqiyiCampaign getByParent(Long id);

    @Modifying
    @Transactional
    @Query(value = "update iqiyi_campaign set advertiserid = ?2 where campaignid = (select campaignid from package_sub_campaign where parent = ?1 AND NAME = '爱奇艺模糊归因' limit 1)", nativeQuery = true)
    int updateAdvertisidByParent(Long id,String advertisid);

    @Modifying
    @Transactional
    @Query(value = "delete from iqiyi_campaign where campaignid = (select campaignid from package_sub_campaign where parent = ?1 AND NAME = '爱奇艺模糊归因' limit 1)", nativeQuery = true)
    int deleteByParent(Long id);
}
