package com.reyun.repository;

import com.reyun.model.KeywordsCreative;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.math.BigInteger;
import java.util.List;

/**
 * Created by sunhao on 17/3/22.
 */
public interface KeywordsCreativeRepository extends JpaRepository<KeywordsCreative, Long> {

    @Query(value = "select * from  keywords_creative where channel_id = ?1 and data_Type = ?2 and key_id = ?3", nativeQuery = true)
    KeywordsCreative findKeywordsCreativeByKey(Long channelId, String dataType, String keyId);

    @Query(value = "select * from  keywords_creative where channel_id = ?1 and data_Type = ?2 and key_id in ?3", nativeQuery = true)
    List<KeywordsCreative> findKeywordsCreativesByKey(Long channelId, String dataType, List<String> keyId);

    @Query(value = "select * from keywords_creative where channel_id = ?1", nativeQuery = true)
    List<KeywordsCreative> listKeywordCreativeByChannel(Long channelId);

    @Query(value = "select * from  keywords_creative where channel_id in ?1 and data_Type in ?2 and key_id in ?3", nativeQuery = true)
    KeywordsCreative findKeywordsCreativeByKeys(List<Long> channelId, List<String> dataType, List<String> keyId);

    public void batchInsert(List<KeywordsCreative> list);

    @Query(value = "select * from  keywords_creative where channel_id in ?1 and account_id=?2", nativeQuery = true)
    List<KeywordsCreative> findBaiDuAndSouGou(List<Integer> integers, Long rootAccount);

    @Query(value = "select * from  keywords_creative where account_id = ?1 and channel_id = ?2 and key_id = ?3 and data_Type = ?4", nativeQuery = true)
    KeywordsCreative findByKeywordsId(Long rootAccount, Long cid, String keywordId, String keywords);

    @Query(value = "select * from  keywords_creative where account_id = ?1 and channel_id = ?2 and value = ?3 and data_Type = ?4", nativeQuery = true)
    KeywordsCreative findByKeywordsChina(Long rootAccount, Long cid, String keywordIdChina, String keywords);

    @Query(value = "select * from  keywords_creative where account_id = ?1 and channel_id = ?2 and key_id = ?3 and data_Type = ?4", nativeQuery = true)
    KeywordsCreative findByCreativeId(Long rootAccount, Long cid, String creativeId, String creative);

    @Query(value = "select * from  keywords_creative where account_id = ?1 and channel_id = ?2 and value = ?3 and data_Type = ?4", nativeQuery = true)
    KeywordsCreative findByCreativeChina(Long rootAccount, Long cid, String creativeIdChina, String creative);

    @Query(value = "select * from  keywords_creative where channel_id = ?1 and data_Type = ?2 and key_id in ?3 and account_id in ?4", nativeQuery = true)
    List<KeywordsCreative> findKeywordsCreativesByAccountKey(Long cid, String dataType, List<String> keyidList, List<BigInteger>  root_account_id);

}
