package com.reyun.repository;

import com.reyun.model.Channel;
import com.reyun.model.LinkMetaData;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Set;

@Transactional
public interface LinkMetaDataRepository extends JpaRepository<LinkMetaData, Long> {
	
	@Query(value = "select unique_name from link_meta_data where create_account=?1 and appkey = ?2", nativeQuery = true)
	List<String> findChannelByCreateAccount(Long account, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and unique_name = ?2 and appkey = ?3", nativeQuery = true)
	List<LinkMetaData> findLinkUserIdByChannel(Long account, String channel, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and unique_name = ?2 and link_user_id = ?3 and appkey = ?4", nativeQuery = true)
	List<LinkMetaData> findPlanByLinkUser(Long account, String channel, Long linkUser, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and unique_name = ?2 and link_user_id = ?3 and plan = ?4 and appkey = ?5", nativeQuery = true)
	List<LinkMetaData> findCampaignIdByPlan(Long account, String channel, Long linkUser, String plan, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and appkey = ?2", nativeQuery = true)
	List<LinkMetaData> findlink_user_idByCreateAccount(Long account, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and appkey = ?2", nativeQuery = true)
	List<LinkMetaData> findPlanByCreateAccount(Long account, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and appkey = ?2", nativeQuery = true)
	List<LinkMetaData> findCampaignidByCreateAccount(Long account, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and unique_name = ?2 and appkey = ?3", nativeQuery = true)
	List<LinkMetaData> findPlanByChannel(Long account, String uniqueName, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and unique_name = ?2 and link_user_id = ?3 and appkey = ?4", nativeQuery = true)
	List<LinkMetaData> findCampaignIdByChannelAccount(Long account, String channel, Long linkUser, String appkey);

	@Query(value = "select * from link_meta_data where create_account=?1 and unique_name = ?2 and appkey = ?3", nativeQuery = true)
	List<LinkMetaData> findCampaignIdByPlan(Long account, String channel, String appkey);

	@Query(value = "select * from link_meta_data where status='false'", nativeQuery = true)
	List<LinkMetaData> findByStatus();
}
