package com.reyun.repository;

import com.reyun.model.LogoDic;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface LogoDicRepository extends JpaRepository<LogoDic, Long> {


	@Query(value = "select * from logo_dic where parent_id = (select id from logo_dic where dic_key = ?1)",nativeQuery = true)
	List<LogoDic> findLogoDicData(String domain);

	@Query(value = "select * from logo_dic where dic_key in ?2 and type = 1 and parent_id = ?1 ",nativeQuery = true)
    List<LogoDic> getEailSubjectOnLogo(String regSource, List<String> key);

	@Query(value = "select * from logo_dic where  type = 0 and parent_id = ?1 ",nativeQuery = true)
	List<LogoDic> getChannelNodeUrl(String regSource);

	@Query(value = "select dic_content from logo_dic where  type = 0 and parent_id = ?1 and dic_key = ?2 ",nativeQuery = true)
    String findDicNodeURL(int regSource, Long id);
}
