package com.reyun.repository;

import com.reyun.model.Onelink;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.math.BigInteger;
import java.util.List;

public interface OnelinkRepository extends JpaRepository<Onelink, Long> {

    @Query(value = "select * from onelink c where main_app = ?1 and del_flag is not true", nativeQuery = true)
    List<Onelink> findByMainApp(Long app);

    @Query(value = "select * from onelink c where main_app in ?1 and del_flag is not true", nativeQuery = true)
    List<Onelink> findByMainApps(List<Long> apps);

    @Query(value = "select * from onelink c where (android_app = ?1 or ios_app = ?1) and del_flag is not true", nativeQuery = true)
    List<Onelink> findByApp(Long app);

    @Query(value = "select c.surl from onelink c", nativeQuery = true)
    List<String> findAllSurl();

    @Query(value = "select * from onelink c where awssuccess = false and del_flag is not true", nativeQuery = true)
    List<Onelink> findByDDb();

    @Query(value = "select count(*) from onelink where (android_campaignl = ?1 or ios_campaignl = ?1) and del_flag is not true ",nativeQuery = true)
    BigInteger countOnelinkByCampaign(Long campaignId);

    @Query(value = "select * from onelink where android_campaignl in ?1 or ios_campaignl in  ?1 and del_flag is not true ",nativeQuery = true)
    List<Onelink> onelinkInCampaign(List<Long> campaignIds);
}
