package com.reyun.repository;

import com.reyun.model.OpenApi;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

@Transactional
public interface OpenApiRepository extends JpaRepository<OpenApi, Long> {

    @Modifying
    @Transactional
    @Query(value = "delete from open_api where appkey = ?1", nativeQuery = true)
    int delByAppkey(String appkey);

    @Query(value = "select *  from open_api where appkey = ?1 and refresh_token = ?2", nativeQuery = true)
    OpenApi getByAppidAndRefreshToken(String appid, String refresh_token);

    @Query(value = "select *  from open_api where appkey = ?1 and access_token = ?2 and access_token_expires>=?3", nativeQuery = true)
    OpenApi findappkeyAndaccessToken(String appkey, String access_token , Date date);
}
