package com.reyun.repository;

import com.reyun.model.Account;
import com.reyun.model.Region;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigInteger;
import java.util.Date;
import java.util.List;

/**
 * 注意：is_show = true 为可以展示， = false 不能用于展示
 */
@Transactional
public interface RegionRepository extends JpaRepository<Region, Long> {

    @Query(value = "select * from region where level = 1 and is_show = true order by region_index", nativeQuery = true)
    List<Region> getAllRootRegion();


    @Query(value = "select * from region where root_node = ?1  and is_show = true order by region_index", nativeQuery = true)
    List<Region> getChildRegion(Long rootNode);

}
