package com.reyun.repository;

import com.reyun.model.ReportToken;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

public interface ReportTokenRepository extends JpaRepository<ReportToken, Long> {

    @Modifying
    @Transactional
    @Query(value = "delete from report_token where appid = ?1", nativeQuery = true)
    int delByAppid(String appkey);

    @Query(value = "select *  from report_token where appid = ?1 and refresh_token = ?2", nativeQuery = true)
    ReportToken getByAppidAndRefreshToken(String appid, String refresh_token);
}
