package com.reyun.repository;

import com.reyun.model.RoleAuthDetail;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by sunhao on 17/6/7.
 * Desc:权限详情DAO
 */
@Transactional
public interface RoleAuthDetailRepository extends JpaRepository<RoleAuthDetail,Long>{

    @Query(value = "select * from role_auth_detail where role_id = ?1", nativeQuery = true)
    List<RoleAuthDetail> findDetailByRole(Long roleId);

    @Query(value = "select * from role_auth_detail where role_id = ?1 and (view is true or edit is true)", nativeQuery = true)
    List<RoleAuthDetail> findValidDetailByRole(Long roleId);

    @Query(value = "select DISTINCT t2.* from role_auth_detail t2  left join role_auth_detail t1 on t1.role_id=t2.role_id and t1.auth = t2.parent_auth \n" +
            "where t1.role_id is null and t2.parent_auth is not null and t2.parent_auth != ''", nativeQuery = true)
    List<RoleAuthDetail> findByNeedAddFirstMenu();
}
