package com.reyun.repository;

import com.reyun.model.Scene;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface SceneRepository extends JpaRepository<Scene, Long> {

    @Query(value = "select * from scene where scene_id = ?1", nativeQuery = true)
    Scene findBySceneId(String sceneid);

    @Query(value = "select scene_id from scene where scene_comment like %?1%", nativeQuery = true)
    List<String> findLikeSceneId(String search);
}
