package com.reyun.repository;

import com.reyun.model.AbTest;
import com.reyun.model.SdkEvent;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by song on 2018/2/1.
 */
public interface SdkEventRepository extends JpaRepository<SdkEvent,Long>{

    @Query(value = "select * from sdk_event where appkey=?1", nativeQuery = true)
    List<SdkEvent> findAll(String appkey);

    @Query(value = "select event_name from sdk_event where appkey=?1", nativeQuery = true)
    List<String> findAllName(String appkey);

    @Query(value = "select event_name from sdk_event where appid=?1", nativeQuery = true)
    List<String> findAllNameByAppid(Long appid);

    @Query(value = "select * from sdk_event where appkey=?1 AND event_alias=?2", nativeQuery = true)
    SdkEvent findByEventAliasAndAppkey(String appkey, String eventAlias);

    @Query(value = "select * from sdk_event where event_name=?1 AND appid=?2", nativeQuery = true)
    SdkEvent findByEventNameAndAppid(String eventName,Long appid);


    @Query(value = "select * from sdk_event where appid=?1", nativeQuery = true)
    List<SdkEvent> findAllByAppid(Long appid);
}
