package com.reyun.repository;

import com.reyun.model.ServeridBackflow;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Transactional
public interface ServeridBackflowRepository extends JpaRepository<ServeridBackflow, Long> {

    @Query(value = "select * from serverid_backflow where root_account = ?1 and app = ?2 order by create_time desc", nativeQuery = true)
    List<ServeridBackflow> findAByRootAccount(Long rootAccount,Long app);

    @Query(value = "select * from serverid_backflow where app = ?1", nativeQuery = true)
    List<ServeridBackflow> findAByApp(Long app);

    @Query(value = "select * from serverid_backflow where server_name = ?1 and app = ?2 limit 1", nativeQuery = true)
    ServeridBackflow getByServerName(String serverName,Long app);

    @Query(value = "select * from serverid_backflow where server_id = ?1 and app = ?2 limit 1", nativeQuery = true)
    ServeridBackflow getByServerId(String serverId,Long app);

    @Transactional
    @Modifying
    @Query(value = "update Account set status = 1 where id = ?1")
    int enable(Long account);

}
