package com.reyun.repository;

import com.reyun.model.SubCampaignExport;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * Created by sunhao on 17/5/24.
 * desc:子活动导出表DAO
 */
public interface SubCampaignExportRepository extends JpaRepository<SubCampaignExport, Long> {


    @Query(value = "select * from sub_campaign_export where app_id = ?1 and status != 'invalid' order by create_time desc ", nativeQuery = true)
    List<SubCampaignExport> listByApp(Long appId);

    @Query(value = "select * from sub_campaign_export where app_id = ?1 and create_account = ?2 and status != 'invalid' order by create_time desc ", nativeQuery = true)
    List<SubCampaignExport> listByAccountAndApp(Long appId, Long accountId);

    @Transactional
    @Modifying
    @Query(value = "update sub_campaign_export set  status = ?2  where id = ?1 ", nativeQuery = true)
    int updateStatus(Long id, String status);

    @Transactional
    @Modifying
    @Query(value = "update sub_campaign_export set download_account = ?1 ,download_ip = ?2,download_time = ?3 where id = ?4", nativeQuery = true)
    int updateDownloadInfo(Long accountId, String ip, Date date, Long exportId);
}
