package com.reyun.repository;

import com.reyun.model.SubChannelRename;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by song on 2018/1/23.
 */
@Transactional
public interface SubChannelRenameRepository extends JpaRepository<SubChannelRename, Long> {

    @Query(value = "select * from sub_channel_rename where sub_channel=?1 and cid=?2 and appid=?3 and del_flag is FALSE ", nativeQuery = true)
    SubChannelRename findByCidAndSubChannel(String subChannel, Long cid,Long appid);

    @Query(value = "select * from sub_channel_rename where sub_channel_name=?1 and cid=?2 and appid=?3 and del_flag is FALSE ", nativeQuery = true)
    SubChannelRename findByCidAndSubChannelChName(String sub_channel_name, Long cid,Long appid);

    @Query(value = "select sub_channel from sub_channel_rename where sub_channel_name like %?1% and cid=?2 and appid=?3 and del_flag is FALSE ", nativeQuery = true)
    List<String> findByCidAndLikeSubChannelChName(String sub_channel_name, Long cid,Long appid);

    @Query(value = "select * from sub_channel_rename where del_flag is FALSE and appid=?1 order by id DESC ", nativeQuery = true)
    List<SubChannelRename> findAllSubChannel(Long appid);

    @Query(value = "select * from sub_channel_rename where cid=?1 and appid=?2 and del_flag is FALSE order by id DESC ", nativeQuery = true)
    List<SubChannelRename> findByChannelId(Long cid,Long appid);

    @Query(value = "select * from sub_channel_rename where id=?1", nativeQuery = true)
    SubChannelRename findById(Long id);

    @Transactional
    @Modifying
    @Query(value = "update sub_channel_rename set del_flag = TRUE where id = ?1", nativeQuery = true)
    int deleteSubChannel(Long id);
}
