package com.reyun.repository;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.reyun.model.SystemParam;
@Transactional
public interface SystemParamRepository extends JpaRepository<SystemParam, Long> {
	
	@Query(value="select * from system_param where account = ?1",nativeQuery=true)
	SystemParam findByAccount(Long account);

	@Transactional
	@Modifying
	@Query(value = "update system_param set imp_is_attribute=?1 where app=?2", nativeQuery = true)
	void updateImpAttributeStatus(Boolean status,Long app);

	@Query(value="select * from system_param where app = ?1",nativeQuery=true)
	SystemParam findByApp(Long app);
}
