package com.reyun.repository;

import com.reyun.model.ThirdAccountAuth;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface ThirdAccountAuthRepository extends JpaRepository<ThirdAccountAuth,Long> {

    @Query(value = "select * from third_account_auth where third_account =?1 and account=?2 limit 1", nativeQuery = true)
    ThirdAccountAuth getThirdAccount(String thirdAccount,Long account);

    @Modifying
    @Transactional
    @Query(value = "delete from third_account_auth where account =?1 ", nativeQuery = true)
    int deleteByAccount(Long id);

    @Query(value = "select * from third_account_auth where third_account =?1", nativeQuery = true)
    List<ThirdAccountAuth> findThirdAccountByThirdAccount(String thirdAccount);

    @Query(value = "select count(*) from third_account_auth where third_account =?1", nativeQuery = true)
    int containsThirdAccount(String thirdAccount);

    @Query(value = "select third_account from third_account_auth where third_account in ?1 and account = ?2", nativeQuery = true)
    List<String> findByThirdAccountAndAccount(List<String> spAccountNumber, Long accountid);
}
