package com.reyun.repository;

import com.reyun.model.UserViewColumn;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by nolan on 28/12/2016.
 * description:
 */
public interface UserViewColumnRepository extends JpaRepository<UserViewColumn, Long> {

    @Query(value = "select a from UserViewColumn a where a.account = ?1 and app = ?2")
    UserViewColumn findByAccount(Long accountid, Long app);

    @Query(value = "select a from UserViewColumn a where a.account = ?1 and app = ?2  and menu = ?3")
    UserViewColumn findByAccountMenu(Long accountid, Long app, String menu);

    @Query(value = "select a from UserViewColumn a where a.account = ?1")
    List<UserViewColumn> findByAccount(Long accountid);

    @Query(value = "select * from user_view_column a where a.account = ?1 and menu = ?2 and app is null order by id limit 1", nativeQuery = true)
    UserViewColumn findByAccountOne(Long accountid, String menu);
}
