package com.reyun.repository;

import com.reyun.model.Account;
import com.reyun.model.WxApp;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigInteger;
import java.util.Date;
import java.util.List;

@Transactional
public interface WxAppRepository extends JpaRepository<WxApp, Long> {

    WxApp findByAppid(String appid);

    @Query(value = "select * from  wx_app where ctime > ?1 and flag = 0 and push_time < ?2", nativeQuery = true)
    List<WxApp> getAllYesWxApps(String yestorday, int syncTime);

    @Query(value = "select * from  wx_app where  flag = 0 and push_time < ?1", nativeQuery = true)
    List<WxApp> getAllWxApps(int syncTime);

    @Transactional
    @Modifying
    @Query(value = "update wx_app set flag = 1,push_time = push_time + 1,utime = ?2 where id = ?1", nativeQuery = true)
    int updateToSuccess(Long id, Date utime);

    @Transactional
    @Modifying
    @Query(value = "update wx_app set push_time = push_time + 1, utime = ?2 where id = ?1", nativeQuery = true)
    int updateToFailed(Long id, Date utime);

}
