package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.AdvancedFunctionRenew;
import com.reyun.model.AdvancedFunctionApply;

/**
 * Created by sunhao on 18/5/17.
 * 高级功能申请service
 */
public interface AdvancedFunctionApplyService {

    /**
     * 添加高级服务申请
     *
     * @param account               账号
     * @param advancedFunctionApply 申请内容
     * @return advancedFunctionApply
     */
    AdvancedFunctionApply addApply(Account account, AdvancedFunctionApply advancedFunctionApply);

    /**
     * 列出账号下的申请
     *
     * @param account 账号
     * @return AdvancedFunctionApply
     */
    AdvancedFunctionApply listApplyByAccount(Account account);

    /**
     * 添加续订
     *
     * @param account 续订账号
     * @return AdvancedFunctionRenew
     */
    AdvancedFunctionRenew addRenewApply(Account account, AdvancedFunctionRenew advancedFunctionRenew);
}
