package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.Category;
import com.reyun.model.ChannelWangyan;

import java.io.IOException;
import java.util.List;
import java.util.Map;

public interface AppService {

    List<App> listAuthAppByAccount(Account account, Long subAccountId);

    List<App> listAppByAccount(Long account);

    List<App> listAppByAccountForMobile(Long accountId) throws IOException;
	
    List<Category> listCategory();

	App findById(Long id);
	
	App create(App app,Long accountId);
	
	App update(App app,Long account);
	
	App delete(Long id,Long account);
	
	App enable(Long id,Long account);
	
	App forbidden(Long id,Long account);
	
	Boolean validName(String name);
	
	Boolean validAppleId(Long account,String appleId);
	
	Boolean validName(Long account,String name);

    void syncAppDebugStatus(App app);

    void updateSort(Account account, Long appBefore, Long appAfter);

	void sort(Account account, Integer isAsc);

    Boolean haveLinkApp(Long id);

    List<App> syncAppBundleInfo(List<App> apps);

    Map<String,Object> tipRemind(Long id, Account loginAccount);

    Object todayCloseTip(Long id);

    Object checkBundleidAndSycDDb(String bundleid);

    App getByAppidAndToken(String appid, String appsecret);

    List findDownlist(Long id);

     void putWangyan(ChannelWangyan channelWangyan, App app, long account);
}
