package com.reyun.service;

import com.reyun.model.*;

import java.util.List;
import java.util.Map;

public interface AuthService {

    RoleAuth getMenuAthByRole(Account loginAccount, Long roleId, String lanType);

    List<RoleAuth> getAllCustomRoleList(Account loginAccount);

    Account getChannelAccountInfoByEmail(Account loginAccount, String email);

    Account getSubAccountInfo(Long subAccountId);

    Account getSubAccountAuthById(Long subAccountId);

    Account getSubAccountById(Account loginAccount, Long subAccountId);

    List<Account> getAuthorizedSubAndChannelAccount(Account loginAccount, Long appId);

    List<Account> getAllActiveSubAccount(Account loginAccount);

    List<Account> getAllDisableSubAccount(Account loginAccount);

    List<Account> getAllActiveChannelAccount(Account loginAccount);

    List<Account> getAllDisableChannelAccount(Account loginAccount);

    int enableSubAccountById(Account loginAccount, Long subAccountId);

    int disableSubAccountById(Account loginAccount, Long subAccountId);

    int enableChannelAccountById(Account loginAccount, Long channelAccountId);

    int disableChannelAccountById(Account loginAccount, Long channelAccountId);

    RoleAuth getRoleAuthById(Long roleId);

    Account createSubAccount(Account loginAccount, Account subAccount,  RoleAuth roleAuth , String lanType);

    Account modifySubAccount(Account loginAccount, Account subAccount, RoleAuth roleAuth);

    Account createChannelAccount(Account loginAccount, Account subAccount, String lanType);

    Account modifyChannelAccount(Account loginAccount, Account subAccount);

    RoleAuth createCustomRole(Account loginAccount, RoleAuth roleAuth);

    RoleAuth modifyCustomRole(Account loginAccount, RoleAuth roleAuth);

    int deleteCustomRole(Account loginAccount, Long roleId);

    boolean deleteInactivateSubAccount(Long subAccountId);

    boolean checkCustomRoleName(Account loginAccount, String roleName, Long roleId);

    boolean checkCustomRoleNumber(Account loginAccount);

    boolean checkSubMangerNumber(Account loginAccount);

    boolean checkUpdateSubMangerNumber(Account loginAccount, Account updateAccount);

    boolean checkEmailExists(String email);

    List<String> checkCustomRoleAccount(Long roleId);

    boolean isNature(Long account, Long app);

    boolean isOriginAccountPast(Long account);

    Account findRootParentAccount(Long childAccountId);

    Auth findAuth(Long account, Long app);

    Account check(String email);

    List<Channel> getUsedChannelByAccountAndApp(Long account, Long app);

    List<Campaign> getAuthCampaignListByAccount(Long accountId, Long appId);

    List<Long> getAuthChannelList(Long account);

    List<Channel> getAuthChannelListByApp(Long accountId, Long appId);

    List<Long> getAuthCampaignList(Long account, Long app);

    List<Long> getAuthCampaignListByDelflag(Long accountId, Long app, String delflag_condition);

    Map<Long, Map<String, Campaign>> getAllCampaignByParentAccount(Long accountId, Long appId);

    Map<Long, Map<String, Campaign>> getAllCampaignByParentAccount(Long accountId, Long appId,boolean forReport);

    List<Long> findAuthAppListByAccount(Long accountId);

    boolean sendSubAccountActivateEmail(Account loginAccount, Account subAccount, String lanType);

    boolean sendChannelAccountAuthEmail(Account loginAccount, Account subAccount, String lanType);

    void createOrUpdateChannelRemark(Long loginAccountId, Long channelAccountId, String remark);

    //TEMP DEAL
    boolean dealWithOldAuth();

    boolean saveAuthAndDataAuth(List<Auth> authList, RoleAuth roleAuth, Account saveAccount, Long loginAccountId, List<DataAuth> dataAuthList);

    boolean modifySubAccountAuth(Account loginAccount, Account subAccount, RoleAuth roleAuth);

    int updateAuthConfig(Long id, Boolean status);

    boolean isNeedAuthConfig(Long roleCategory);

    public boolean saveChannelAuthAndDataAuth(List<Auth> authList, Account loginAccount, Account channelAccount);

    public void dealWithOldRoleDetail();

    public boolean checkChannelEmailExists(String email);

    Map<String,Object> findGuangDianTongChannel(Long appId , long cid);

    List<Channel> getAuthChannelListByAppIngnorDel(Long id, Long appId);

    List<String> getAuthCampaignIdListByAccount(Long accountId, Long appId);

    List<Map<String,Object>> findGdtThirdAccount(Long appId,Long account);

    Map<String,Object> findGuangDianTongChannelByRole(Long appId, long cid, Long id);

    List<String> getAuthCampaignIdListByAccount(Long accountId, Long appId, int type);

    List<Campaign> getAuthCampaignListLimit(Account id, String name, Long appid, Map jsond, int limit);

    List<Object[]> getCampaignIdsByAuth(Account account, App app);

    boolean checkRoleTempCategory(Account account);
}
