package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.ChannelAccount;
import com.reyun.model.RecycleChannelAccount;
import com.reyun.util.ResultModel;
import org.json.JSONException;

import javax.servlet.http.HttpServletRequest;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;

/**
 * Created by mxq on 2017/7/11.
 */
public interface ChannelAccountService {

    boolean simulationLogin(ChannelAccount resource);

    boolean validAlias(String alias, long account);

    List<Long> getLinkAccounts(long account);

    ChannelAccount create(ChannelAccount resource, long account);

    ChannelAccount update(ChannelAccount resource, long account);

    ChannelAccount delete(long id, long account);

    ChannelAccount enable(long id, long account);

    List<ChannelAccount> find(Account account, long cid);

    ChannelAccount getGDTTokenAndSave(HttpServletRequest request, String autnCode, String qq, Account account) throws JSONException;

    int getJRTTTokenAndSave(HttpServletRequest request, String autnCode, String loginAccountid,String alias) throws JSONException;

    ChannelAccount authorize(ChannelAccount resource, long account);

    void deleteAuthorize(String qq);

    ChannelAccount alias(ChannelAccount resource, long account);

    boolean validQQ(String qq, Long account);

    boolean validAccountId(String accountId, Long account);

    List<ChannelAccount> findValidByUniqueName(String uniqueName);

    ChannelAccount findById(Long id);

    Optional<List<ChannelAccount>> findByStatusTrue();

    List<ChannelAccount> listByAccounts(List<Long> accounts);

    boolean checkAlias(String alias);

    ChannelAccount getByAlias(String alias);

    List<ChannelAccount> findLinkedApp(Account loginAccount, long cid);


    void refreshAcessToken(Long id, String accessToken, Long accessTokenExpire, String refreshToken, Long refreshTokenExpire);

    boolean updatePlan(Account account, int plan ,String cip,String shortUrl);

    int checkPlan(Account loginAccount);

    Map findChannelAccountCount(Account loginAccount, Map<String, String> channleids);

    Object channellist(Account loginAccount);

    Object getToutiaoAccessToken(Long appId, String secret, String grantType, String authCode,String alias, Account loginAccount);

    void putToutiaoAdvertiserByManager(String access_token ,Long advertiser_id ,HashMap<String, String> resultMap);

    Map<String, Object> checkToutiaoNum(Account loginAccount);

    boolean createByBaidu(ChannelAccount resource, Long id);

    boolean updateByBaidu(ChannelAccount resource, Long id);

    boolean createByKuaishou(ChannelAccount resource, Long id);

    boolean updateByKuaishou(ChannelAccount resource, Long id);

    boolean createByWeixinMP(String state, String authorization_code,Account loginAccount);

    ChannelAccount getByAliasAndChannelTrue(String alias, long channel);

    boolean renewalDeepLink(Account loginAccount, String feedbackurl, String urlScheme, String state);

    boolean renewalSubscribes(Account loginAccount, String feedbackurl, String state);
     HashMap<String, String> getToutiaoName(Long appId, String secret, String access_token);
}
