package com.reyun.service;

import com.alibaba.fastjson.JSONObject;
import com.reyun.model.Account;
import com.reyun.model.ChannelAccount;
import com.reyun.model.RecycleChannel;
import com.reyun.model.RecycleChannelAccount;

import java.util.List;

/**
 * Created by sunhao on 18/5/16.
 * 回本分析interface
 */
public interface RecycleAnalysisService {

    /**
     * 获取所有开启回本分析的渠道
     */
    List<RecycleChannel> listEnableChannel(int type, String lanType);

    /**
     * 列出已添加的回本渠道账号
     */
    List<RecycleChannelAccount> listAccountByAccount(Account account);

    /**
     * 添加渠道账号
     */
    RecycleChannelAccount addRecycleChannelAccount(Account account, Long app, RecycleChannelAccount recycleChannelAccount);

    /**
     * 添加渠道账号
     */
    RecycleChannelAccount addGdtChannelAccount(Account account, RecycleChannelAccount recycleChannelAccount);

    /**
     * 停用渠道账号
     */
    Boolean disableRecycleChannelAccount(String userName, String channelAccountId, Long cid);

    /**
     * 启用渠道账号
     */
    Boolean enableRecycleChannelAccount(String userName, String channelAccountId, Long cid);


    /**
     * 修改渠道账号信息
     */
    RecycleChannelAccount modifyRecycleChannelAccount(RecycleChannelAccount recycleChannelAccount);

    /**
     * 查看回本分析功能是否开通
     */
    JSONObject hasRecycleFunctionOpen(Account account);

    /**
     * 列出应用渠道账号的列表
     */
    List<ChannelAccount> listApplyChannelAccount(Account account, Long cid);

    /**
     * 查询渠道账号的详细信息
     */
    List<RecycleChannelAccount> listChannelAccountInfo(Long app, Account account, Boolean enable);

    /**
     * 校验普通账户回本渠道限制
     */
    Boolean checkChannelNumberLimit(Account account);

    /**
     * 验证今日头条是否授权成功
     */
    RecycleChannelAccount findJRTTToken(Long rootAccountid,Long cid,String accountid);

    /**
     * 今日头条连接测试
     */
    boolean testJRTTToken(Long rootAccountid,Long cid,String accountid);

    /**
     * 授权成功保存渠道别名
     */
    boolean successJRTTAouth(Long rootAccountid,Long cid,String accountid,String channelalias);

    /**
     *爬虫相关授权保存账号密码
     */
    boolean saveSpiderAccountAndPassword(String accountid,String channelalias,String password,String mccid,String mcuniquename,String type,Account account);

    /**
     * 爬虫相关授权账号唯一校验
     */
    Long checkSpiderAccount(String accountid,Account account);
}
