package com.reyun.service;

import com.reyun.model.Account;
import com.reyun.model.RecycleChannel;
import com.reyun.model.RecycleChannelAccount;
import com.reyun.util.ResultModel;

/**
 * 处理回本分析的新渠道
 */
public interface RecycleHandleService {

    /**
     * 测试授权渠道，是否成功
     */
    ResultModel authChannel(RecycleChannelAccount recycleChannelAccount, Account account,RecycleChannel recycleChannel);

    /**
     * @param recycleChannelAccount
     * @return  校验接口参数是否完整
     */
    boolean checkAuthParam(RecycleChannelAccount recycleChannelAccount);


    /**
     * 添加渠道账号(如果存在则修改--不同的渠道可能处理方式不同))
     * unique_account不同的渠道不同（api渠道为channel_account_id,爬虫为username）
     */
    RecycleChannelAccount addRecycleChannelAccount(Account account, RecycleChannelAccount recycleChannelAccount,RecycleChannel recycleChannel);


    /**
     * 校验普通账户回本渠道限制(不同渠道的限制可能不同)
     */
    Boolean checkChannelNumberLimit(Account account);

    /**
     * @param recycleChannelAccount
     * @return 添加验证的凭证(不同的渠道存储不同，广点通与今日头条存储在token,uc头条存储在login_license)
     */
    ResultModel addLoginLicense(RecycleChannelAccount recycleChannelAccount);

    /**
     * @param recycleChannelAccount
     * @return 获取验证的凭证
     */
    ResultModel getLoginLicense(RecycleChannelAccount recycleChannelAccount);


    /**
     * @param recycleChannelAccount
     * @return  针对某些渠道存在手机验证码验证，发送验证码的接口
     */
    ResultModel sendVcode(RecycleChannelAccount recycleChannelAccount);

    /**
     * @param recycleChannelAccount
     * @return 手机验证登陆接口
     */
    ResultModel phoneVerify(RecycleChannelAccount recycleChannelAccount, Account account,RecycleChannel recycleChannel);

    /**
     * @param recycleChannelAccount
     * @return 问题验证登陆接口
     */
    ResultModel questionVerify(RecycleChannelAccount recycleChannelAccount, Account account,RecycleChannel recycleChannel);
}
