package com.reyun.service.impl;


import com.reyun.model.Account;
import com.reyun.model.MenuAuthDetail;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.MenuAuthRepositry;
import com.reyun.service.AccountService;
import com.reyun.util.Constant;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.Cookie;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class AccountServiceImpl implements AccountService {

    @Autowired
    AccountRepository accountRepository;

    @Autowired
    MenuAuthRepositry menuAuthRepositry;


    final String resName[] = {"热云数据", "新华频媒", "热云数据", "热云数据", "热云数据", "热云数据"};
    final String resNameEn[] = {"TrackingIO", "新华频媒", "TrackingIO", "TrackingIO", "TrackingIO", "TrackingIO"};

    @Override
    public Account getRootAccountData(Account account, Account rootAccount) {
        if (rootAccount != null) {
            return rootAccount;
        }
        if (account == null) {
            account = new Account();
            account.setRegSource(0);
            return account;
        }
        return account.getRootParent().equals(account.getId()) ? account : accountRepository.findOne(account.getRootParent());
    }

    @Override
    public String getAccountSoureceName(Account account, Account rootAccount, int en_type) {
        int sourceNum = getRootAccountData(account, rootAccount).getRegSource();
        if (en_type == 0) {
            return resName[sourceNum];
        } else {
            return resNameEn[sourceNum];
        }

    }

    @Override
    public String getCookieData(Cookie[] cookies, String name) {
        if (null != cookies && name != null) {
            for (Cookie cookie : cookies) {
                if (cookie.getName().equals(name)) {
                    return cookie.getValue();
                }
            }
        }
        return null;
    }


    @Override
    public String getDomainStr(Cookie[] cookies, String name) {
        String domain = getCookieData(cookies, name);
        if (StringUtils.isEmpty(domain)) {
                domain = Constant.getDomainStr();
        }
        if (domain.startsWith("www") || domain.startsWith("track") || domain.startsWith("feilixin")) {
            domain = domain.substring(domain.indexOf(".") + 1);
        }
        return domain;
    }

    @Override
    public Account findOne(Long account) {

        return accountRepository.findOne(account);
    }


    @Override
    public Map<String, String> getAuthReportNames() {
        List<MenuAuthDetail> reportMenus = menuAuthRepositry.findAll();
        Map<String, String> datas = new HashMap<>();
        for (MenuAuthDetail detail : reportMenus) {
            if (!StringUtils.isEmpty(detail.getReportAuthURLs())) {
                Arrays.asList(detail.getReportAuthURLs().split(",")).forEach(v -> {
                    datas.put(v, "1");
                });
            }
        }
        return datas;
    }

    @Override
    public String emailCheck(String email) {
        if(StringUtils.isEmpty(email)){
            return "";
        }
        return accountRepository.findEmailByEmail(email);
    }

    public static void main(String[] args) {
        String url = "http://localhost:8080/CarsiLogCenter_new/idpstat.jsp?action=idp.sptopn";

//        String part1 = url.split("//")[1];
//        String part2 = part1.split("/")[0];
//        String part3 = part2.substring(part2.indexOf("."));
//
//        System.out.println(part3);

        System.out.println("www.trackingio.com".substring("www.trackingio.com".indexOf(".") + 1));
    }
}
