package com.reyun.service.impl;

import com.reyun.model.*;
import com.reyun.repository.*;
import com.reyun.service.AuthService;
import com.reyun.service.ChannelParamService;
import com.reyun.service.ChannelService;
import com.reyun.util.DateUtil;
import com.reyun.util.ValidateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

import java.math.BigDecimal;
import java.util.*;

/**
 * Created by mxq on 2017/9/11.
 */
@Service
@Transactional
public class ChannelParamServiceImpl implements ChannelParamService {

    @Autowired
    DefaultChannelParamRepository defaultChannelParamRepository;

    @Autowired
    AuthService authService;

    @Autowired
    ChannelParamRepository channelParamRepository;

    @Autowired
    ChannelService channelService;

    @Autowired
    AccountRepository accountRepository;

    @Autowired
    SystemParamRepository systemParamRepository;

    @Autowired
    AppRepository appRepository;

    @Autowired
    PreorderParamRepository preorderParamRepository;

    @Override
    public Object update(boolean isdefault, boolean isall, ChannelParam resourse, Long loginAccount, String type, String validFunction) {
        Account impRootAccount = authService.findRootParentAccount(loginAccount);
        List<ChannelParam> paramList = new ArrayList<>();
        Object result = null;
        List<DefaultChannelParam> defaultList = defaultChannelParamRepository.findAll();
        Map<String, Integer> defaultMap = new HashMap<>();
        for (DefaultChannelParam param : defaultList) {
            defaultMap.put(param.getParamKey(), param.getParamValue());
        }

        SystemParam rootAccountSystemParam = systemParamRepository.findByApp(resourse.getApp());
        Boolean accountAttribute;
        if (rootAccountSystemParam == null) {
            accountAttribute = false;
        } else {
            accountAttribute = rootAccountSystemParam.getImpIsAttribute() == null ? false : rootAccountSystemParam.getImpIsAttribute();
        }

        if (isall) {
            List<ChannelParam> channelParamList = channelParamRepository.findByapp(resourse.getApp());
            Map<Long, ChannelParam> map = new HashMap<>(channelParamList.size());
            if (ValidateUtil.isValid(channelParamList)) {
                for (ChannelParam pa : channelParamList) {
                    map.put(pa.getCid(), pa);
                }
            }
            channelParamRepository.deleteByApp(resourse.getApp());
            ChannelParam defaultParam = findDefault();
            List<Long> channelList = authService.getAuthChannelList(impRootAccount.getRootParent());
            if (isdefault) {
                List<ChannelParam> list = new ArrayList<>();
                if ("valid".equals(type)) {
                    for (Long cid : channelList) {
                        ChannelParam param = new ChannelParam();
                        param.setApp(resourse.getApp());
                        param.setAccount(impRootAccount.getRootParent());
                        param.setModifyTime(new Date());
                        param.setModifyAccount(loginAccount);
                        param.setCid(cid);
                        param.setCiDay(defaultParam.getCiDay());
                        param.setBlacklistLevel(defaultParam.getBlacklistLevel());
                        param.setBlacklistStatus(defaultParam.getBlacklistStatus());
                        param.setChannelNum(defaultParam.getChannelNum());
                        param.setImpAttribute(accountAttribute);
                        param.setWholeBlacklistStatus(param.getBlacklistStatus());
                        param.setWholeChannelNum(param.getChannelNum());
                        param.setWholeLevel(param.getBlacklistLevel());
                        param.setWholeDeviceBlackStatus(param.getDeviceBlackStatus());
                        if (map.containsKey(cid)) {
                            ChannelParam channelParam = map.get(cid);
                            param.setBlacklistLevel(channelParam.getBlacklistLevel());
                            param.setBlacklistStatus(channelParam.getBlacklistStatus());
                            param.setChannelNum(channelParam.getChannelNum());
                            param.setAttrCfg(channelParam.getAttrCfg());
                        }
                        list.add(param);
                    }
                } else if ("black".equals(type)) {
                    for (Long cid : channelList) {
                        ChannelParam param = new ChannelParam();
                        param.setApp(resourse.getApp());
                        param.setAccount(impRootAccount.getRootParent());
                        param.setModifyTime(new Date());
                        param.setModifyAccount(loginAccount);
                        param.setCid(cid);
                        param.setCiDay(defaultParam.getCiDay());
                        param.setBlacklistLevel(defaultParam.getBlacklistLevel());
                        param.setBlacklistStatus(defaultParam.getBlacklistStatus());
                        param.setChannelNum(defaultParam.getChannelNum());
                        param.setWholeBlacklistStatus(param.getBlacklistStatus());
                        param.setWholeChannelNum(param.getChannelNum());
                        param.setWholeLevel(param.getBlacklistLevel());
                        param.setWholeDeviceBlackStatus(param.getDeviceBlackStatus());
                        if (map.containsKey(cid)) {
                            ChannelParam channelParam = map.get(cid);
                            param.setCiDay(channelParam.getCiDay());
                            param.setAttrCfg(channelParam.getAttrCfg());
                        }
                        list.add(param);
                    }
                }
                paramList = channelParamRepository.save(list);
            } else {
                resourse.setAccount(impRootAccount.getRootParent());
                resourse.setModifyTime(new Date());
                resourse.setModifyAccount(loginAccount);
                List<ChannelParam> list = new ArrayList<>();
                if ("valid".equals(type)) {
                    for (Long cid : channelList) {
                        ChannelParam param = new ChannelParam();
                        param.setApp(resourse.getApp());
                        param.setAccount(impRootAccount.getRootParent());
                        param.setModifyTime(new Date());
                        param.setModifyAccount(loginAccount);
                        param.setCid(cid);
                        param.setCiDay(resourse.getCiDay());
                        param.setImpAttribute(accountAttribute);
                        param.setWholeBlacklistStatus(param.getBlacklistStatus());
                        param.setWholeChannelNum(param.getChannelNum());
                        param.setWholeLevel(param.getBlacklistLevel());
                        param.setWholeDeviceBlackStatus(param.getDeviceBlackStatus());
                        if (resourse.getAttrCfg() != null) {
                            param.setAttrCfg(resourse.getAttrCfg());
                        } else {
                            param.setAttrCfg(defaultParam.getAttrCfg());
                        }

                        if (map.containsKey(cid)) {
                            ChannelParam channelParam = map.get(cid);
                            param.setBlacklistLevel(channelParam.getBlacklistLevel());
                            param.setBlacklistStatus(channelParam.getBlacklistStatus());
                            //2018-07-04 zxy 修改归因匹配点击时间时候，设备防作弊状态被置空了，现把原状态赋值过来
                            param.setDeviceBlackStatus(channelParam.getDeviceBlackStatus());
                            param.setChannelNum(channelParam.getChannelNum());
                            param.setAttrCfg(channelParam.getAttrCfg());
                        } else {
                            resourse.setBlacklistLevel(defaultParam.getBlacklistLevel());
                            resourse.setBlacklistStatus(defaultParam.getBlacklistStatus());
                            resourse.setChannelNum(defaultParam.getChannelNum());
                            resourse.setDeviceBlackStatus(defaultParam.getDeviceBlackStatus());
                        }
                        list.add(param);
                    }
                } else if ("black".equals(type)) {
                    for (Long cid : channelList) {
                        ChannelParam param = new ChannelParam();
                        param.setApp(resourse.getApp());
                        param.setAccount(impRootAccount.getRootParent());
                        param.setModifyTime(new Date());
                        param.setModifyAccount(loginAccount);
                        param.setCid(cid);
                        param.setBlacklistLevel(resourse.getBlacklistLevel());
                        param.setBlacklistStatus(resourse.getBlacklistStatus());
                        param.setDeviceBlackStatus(resourse.getDeviceBlackStatus());
                        param.setChannelNum(defaultMap.get(resourse.getBlacklistLevel().toString()));
                        param.setWholeBlacklistStatus(param.getBlacklistStatus());
                        param.setWholeChannelNum(param.getChannelNum());
                        param.setWholeLevel(param.getBlacklistLevel());
                        param.setWholeDeviceBlackStatus(param.getDeviceBlackStatus());
                        if (map.containsKey(cid)) {
                            ChannelParam channelParam = map.get(cid);
                            param.setCiDay(channelParam.getCiDay());
                            param.setAttrCfg(channelParam.getAttrCfg());
                        } else {
                            param.setCiDay(defaultParam.getCiDay());
                        }
                        list.add(param);
                    }
                }
                paramList = channelParamRepository.save(list);
            }
            result = "success";
        } else {
            if (isdefault) {
                if ("valid".equals(type)) {
                    if (null == resourse.getId()) {
                        ChannelParam channelParam = findDefault();
                        channelParam.setCid(resourse.getCid());
                        channelParam.setAccount(impRootAccount.getRootParent());
                        channelParam.setModifyTime(new Date());
                        channelParam.setModifyAccount(loginAccount);
                        channelParam.setApp(resourse.getApp());
                        ChannelParam save = channelParamRepository.save(channelParam);
                        result = save;
                    } else {
                        ChannelParam defaultChannelParam = findDefault();
                        ChannelParam channelParam = channelParamRepository.findByAppCid(resourse.getApp(), resourse.getCid());
                        if ("validDay".equals(validFunction)) {
                            channelParam.setCiDay(defaultChannelParam.getCiDay());
                        } else if ("validType".equals(validFunction)) {
                            channelParam.setAttrCfg(defaultChannelParam.getAttrCfg());
                        }
                        channelParam.setModifyTime(new Date());
                        channelParam.setModifyAccount(loginAccount);
                        channelParam.setApp(resourse.getApp());

                        ChannelParam save = channelParamRepository.save(channelParam);
                        result = save;
                    }
                } else {
                    if (null == resourse.getId()) {
                        ChannelParam channelParam = findDefaultByBlack();
                        channelParam.setCid(resourse.getCid());
                        channelParam.setAccount(impRootAccount.getRootParent());
                        channelParam.setModifyTime(new Date());
                        channelParam.setModifyAccount(loginAccount);
                        channelParam.setApp(resourse.getApp());
                        ChannelParam save = channelParamRepository.save(channelParam);
                        result = save;
                    } else {
                        ChannelParam defaultChannelParam = findDefaultByBlack();
                        ChannelParam channelParam = channelParamRepository.findByAppCid(resourse.getApp(), resourse.getCid());
                        channelParam.setBlacklistLevel(defaultChannelParam.getBlacklistLevel());
                        channelParam.setBlacklistStatus(defaultChannelParam.getBlacklistStatus());
                        channelParam.setChannelNum(defaultChannelParam.getChannelNum());
                        channelParam.setDeviceBlackStatus(defaultChannelParam.getDeviceBlackStatus());
                        channelParam.setModifyTime(new Date());
                        channelParam.setModifyAccount(loginAccount);
                        channelParam.setApp(resourse.getApp());
                        channelParam.setAttrCfg(0);
                        ChannelParam save = channelParamRepository.save(channelParam);
                        result = save;
                    }
                }
            } else {
                ChannelParam channelParam = channelParamRepository.findByAppCid(resourse.getApp(), resourse.getCid());
                if (null != channelParam) {
                    resourse.setId(channelParam.getId());
                    if (resourse.getAttrCfg() == null) resourse.setAttrCfg(channelParam.getAttrCfg());
                } else {
                    ChannelParam defaultChannelParam = findDefault();
                    if (resourse.getAttrCfg() == null) resourse.setAttrCfg(defaultChannelParam.getAttrCfg());
                    if (resourse.getCiDay() == null) resourse.setCiDay(defaultChannelParam.getCiDay());
                }
                resourse.setChannelNum(defaultMap.get(resourse.getBlacklistLevel().toString()));
                resourse.setAccount(impRootAccount.getRootParent());
                resourse.setModifyTime(new Date());
                resourse.setModifyAccount(loginAccount);
                ChannelParam save = channelParamRepository.save(resourse);
                result = save;
            }
        }

        //更新account状态，是否全渠道
        if (isall) {
            if ("valid".equals(type)) {
                impRootAccount.setAllChannelValidMatch(true);
            }
            if ("black".equals(type)) {
                impRootAccount.setAllChannelBlackMatch(true);
            }
        } else {
            if ("valid".equals(type)) {
                impRootAccount.setAllChannelValidMatch(false);
            }
            if ("black".equals(type)) {
                impRootAccount.setAllChannelBlackMatch(false);
            }
        }
        accountRepository.save(impRootAccount);
        return result;
    }

    @Override
    public ChannelParam findOne(Long cid, Long loginAccount, Long app) {
        //Account rootAccount = authService.findRootParentAccount(loginAccount);
        ChannelParam channelParam = channelParamRepository.findByAppCid(app, cid);
        if (null == channelParam) {
            channelParam = findDefault();
        }
        return channelParam;
    }

    @Override
    public ChannelParam findDefault() {
        ChannelParam result = new ChannelParam();
        List<DefaultChannelParam> list = defaultChannelParamRepository.findAll();
        Map<String, Integer> map = new HashMap<>();
        for (DefaultChannelParam param : list) {
            map.put(param.getParamKey(), param.getParamValue());
        }

        result.setBlacklistLevel(-1);
        result.setBlacklistStatus(false);
        result.setChannelNum(map.get("-1"));
        result.setCiDay(map.get("ci_day"));
        result.setAttrCfg(0);
//        result.setInstallDay(map.get("install_day"));
//        result.setClickDay(map.get("click_day"));
//        result.setCheatStatus(true);
//        result.setCilag(map.get("cilag"));
//        result.setNormalInstall(map.get("normal_install"));
//        result.setNormalClick(map.get("normal_click"));
        return result;
    }

    @Override
    public ChannelParam findDefaultByBlack() {
        ChannelParam result = new ChannelParam();
        List<DefaultChannelParam> list = defaultChannelParamRepository.findAll();
        Map<String, Integer> map = new HashMap<>();
        for (DefaultChannelParam param : list) {
            map.put(param.getParamKey(), param.getParamValue());
        }
        result.setBlacklistLevel(1);
        result.setBlacklistStatus(true);
        result.setChannelNum(map.get("1"));
        result.setCiDay(map.get("ci_day"));
        result.setDeviceBlackStatus(false);
        result.setAttrCfg(0);
        return result;
    }

    @Override
    public ChannelParam find(Long loginAccount, Long app) {
        ChannelParam result = findDefault();
        App appModel = appRepository.findOne(app);
        Account rootAccount = authService.findRootParentAccount(loginAccount);
        result.setAllChannelValidMatch(null == rootAccount.getAllChannelValidMatch() ? true : rootAccount.getAllChannelValidMatch());
        result.setAllChannelBlackMatch(null == rootAccount.getAllChannelBlackMatch() ? true : rootAccount.getAllChannelBlackMatch());
        //result.setAllChannelFakeMatch(null == rootAccount.getAllChannelFakeMatch() ? true : rootAccount.getAllChannelFakeMatch());
        List<ChannelParam> paramList = channelParamRepository.findByApp(app);
        if (ValidateUtil.isValid(paramList)) {
            result.setBlacklistLevel(paramList.get(0).getWholeLevel());
            result.setBlacklistStatus(paramList.get(0).getWholeBlacklistStatus() == null ? false : paramList.get(0).getWholeBlacklistStatus());
            result.setChannelNum(paramList.get(0).getWholeChannelNum());
            result.setDeviceBlackStatus(paramList.get(0).getWholeDeviceBlackStatus());
        } else {
            List<DefaultChannelParam> list = defaultChannelParamRepository.findAll();
            Map<String, Integer> map = new HashMap<>();
            for (DefaultChannelParam param : list) {
                map.put(param.getParamKey(), param.getParamValue());
            }
            result.setBlacklistLevel(1);
            result.setBlacklistStatus(false);
            result.setChannelNum(map.get("1"));
            result.setDeviceBlackStatus(false);
        }
        if (!result.getAllChannelBlackMatch()) {
            List<ChannelParam> diffList = channelParamRepository.findDiffByApp(app);
            List<Long> cidList = new ArrayList<>();
            Map<Long, Integer> channelLevel = new HashMap<>();
            if (ValidateUtil.isValid(diffList))
                for (ChannelParam cp : diffList) {
                    cidList.add(cp.getCid());
                    channelLevel.put(cp.getId(), cp.getBlacklistLevel());
                }
            if (cidList.size() > 0) {
                List<Channel> channelList = channelService.listChannelByIds(cidList);
                List<String> channelLevelMapList = new ArrayList<>();
                for (Channel ch : channelList) {
                    channelLevelMapList.add(ch.getName());
                }
                result.setChannelLevel(channelLevelMapList);
            } else {
                result.setAllChannelBlackMatch(true);
            }
            //显示被关闭的
            List<ChannelParam> diffClosedList = channelParamRepository.findDiffAndClosedByApp(app);
            List<Long> cidClosedList = new ArrayList<>();
            if (ValidateUtil.isValid(diffClosedList))
                for (ChannelParam cp : diffClosedList) {
                    cidClosedList.add(cp.getCid());
                }
            if (cidClosedList.size() > 0) {
                List<Channel> channelList = channelService.listChannelByIds(cidClosedList);
                List<String> channelLevelMapList = new ArrayList<>();
                for (Channel ch : channelList) {
                    channelLevelMapList.add(ch.getName());
                }
                result.setChannelLevelClosed(channelLevelMapList);
            }
        }

        if (result.getAllChannelValidMatch()) {
            if (ValidateUtil.isValid(paramList)) {
                result.setCiDay(paramList.get(0).getCiDay());
            }
        }

        //预约归因相关
        result.setOnlineDate(appModel.getOnlineDate());
        if (result.getOnlineDate() == null) {
            result.setOnlineDate("");
            return result;
        }
        PreorderParam preorderParam = preorderParamRepository.findByAppId(app);
        result.setPriority(preorderParam == null ? 1 : preorderParam.getPriority());
        result.setDeadLineDays(preorderParam == null ? 2 : preorderParam.getDeadLineDays());

        return result;
    }

    @Override
    public Object updateImpression(ChannelParam resourse, Long loginAccount) {
        Account rootAccount = authService.findRootParentAccount(loginAccount);
        ChannelParam save1 = null;
        if (resourse.getId() != null) {
            ChannelParam one = channelParamRepository.findOne(resourse.getId());
            one.setImpAttribute(resourse.getImpAttribute());
            save1 = channelParamRepository.save(one);
        } else {
            resourse.setAccount(rootAccount.getId());
            save1 = channelParamRepository.save(resourse);
        }

        //List<Boolean> impAttributeStatus = channelParamRepository.findImpAttributeStatus(rootAccount.getId());
        SystemParam save = null;
        SystemParam byApp = systemParamRepository.findByApp(resourse.getApp());
        if (byApp != null) {
            byApp.setImpIsAttribute(resourse.getImpAttribute());
            save = systemParamRepository.save(byApp);
        }
        return save1;
    }

    @Override
    public Object backflowAttrNum(Long app, Integer backflowAttrNum, Long loginAccount) {
        ChannelParam resourse = new ChannelParam();
        resourse.setApp(app);
        List<ChannelParam> byApp = channelParamRepository.findByApp(app);
        if (CollectionUtils.isEmpty(byApp)) {
            this.update(true, true,resourse, loginAccount, "valid","");
        }
        String date = DateUtil.format(new Date());
        int i = channelParamRepository.updateBackflowAttrNum(app, backflowAttrNum, loginAccount, date);
        return i > 0;
    }

    @Override
    public Object getBackflowAttrNum(Long app) {

        List<ChannelParam> byApp = channelParamRepository.findByApp(app);
        if (byApp.size() > 0) {
            return byApp.get(0).getBackflowAttrNum();
        }
        return 604800;
    }

    @Override
    public Boolean updateImp(Long cid, Boolean impStatus, Long accountid, Long app) {
        ChannelParam cp = channelParamRepository.findByAppCid(app, cid);
        if (cp == null) {
            cp = new ChannelParam();
            cp.setAccount(accountid);
            cp.setImpAttribute(impStatus);
            cp.setCid(cid);
            cp.setApp(app);
            cp.setAttrCfg(0);

        } else {
            cp.setImpAttribute(impStatus);
        }
        channelParamRepository.save(cp);
        return true;
    }

    @Override
    public Object updatePreorder(PreorderParam resourse, Account account) {

        PreorderParam preorderParam = preorderParamRepository.findByAppId(resourse.getAppId());

        if (preorderParam == null) {
            preorderParam = new PreorderParam();
            preorderParam.setAppId(resourse.getAppId());
            preorderParam.setAccountId(account.getId());
            preorderParam.setCreateTime(new Date());
        } else {
            preorderParam.setPriority(resourse.getPriority());
            preorderParam.setDeadLineDays(resourse.getDeadLineDays());
            preorderParam.setUpdateTime(new Date());
        }

        boolean defaulteParam = new Integer(1).equals(resourse.getDefaultValue()) ? true : false;

        //新增或无传值时或恢复默认时  设置默认值
        if (preorderParam.getDeadLineDays() == null || defaulteParam) {
            preorderParam.setDeadLineDays(2);//默认 2天
        }
        if (preorderParam.getPriority() == null || defaulteParam) {
            // 1 预约归因 0 常规归因
            preorderParam.setPriority(1);//默认预约归因
        }
        preorderParamRepository.save(preorderParam);

        return preorderParam;
    }

    public static void main(String[] args) {
        Double a = 1.09d;
        Long b = 1L;
        System.out.println(a instanceof Number);
        System.out.println(b instanceof Number);
        System.out.println(new BigDecimal(((Number) a).longValue()).setScale(0, BigDecimal.ROUND_HALF_UP));

    }


}
