package com.reyun.service.impl;

import com.beust.jcommander.internal.Lists;
import com.reyun.dic.ChannelEnumType;
import com.reyun.dic.RoleEnumType;
import com.reyun.model.*;
import com.reyun.repository.*;
import com.reyun.service.AdwordsService;
import com.reyun.service.AppService;
import com.reyun.service.ChannelAccountService;
import com.reyun.service.ChannnelAccountLinkAppService;
import com.reyun.util.DynamoDBUtil;
import com.reyun.util.HttpClientUtil;
import com.reyun.util.HttpUtil;
import com.reyun.util.NoSQLDBUtil;
import com.reyun.util.ValidateUtil;
import net.sf.json.JSONArray;
import org.apache.commons.collections.map.HashedMap;
import org.apache.commons.lang.text.StrSubstitutor;
import org.json.JSONException;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by sunhao on 17/3/1.
 */
@Service
public class ChannnelAccountLinkAppServiceImpl
        implements ChannnelAccountLinkAppService {
    private static Logger logger = LoggerFactory.getLogger(ChannnelAccountLinkAppServiceImpl.class);
    @Autowired
    private ChannnelAccountLinkAppRepository channnelAccountLinkAppRepository;
    @Autowired
    private ChannelAccountRepository channelAccountRepository;
    @Autowired
    private AppRepository appRepository;
    @Autowired
    private ChannelRepository channelRepository;
    @Autowired
    private GdtPlanRepository gdtPlanRepository;
    @Autowired
    private AppService appService;
    @Autowired
    private ChannelAccountService channelAccountService;
    @Autowired
    private AdwordsService adwordsService;

    public static void main(String[] args)
            throws JSONException, IOException {
//        ChannnelAccountLinkAppServiceImpl c = new ChannnelAccountLinkAppServiceImpl();
//        ChannelAccountLinkApp m = new ChannelAccountLinkApp();
//
//        m.setAccountId("5682282");
//        //m.setToken("58e4c9cebb582c2225e80c133b7fa014");
//        m.setUserActionSetId("1226942477");
//        m.setAppType("ios");
//        m.setThirdAppId("1226942477");
//        Map<String, String> userId = c.createUserId(m);
//        System.out.println(userId);

        long timestamp = new Date().getTime() / 1000;
        Map<String, String> map = new HashMap<String, String>();
        map.put("access_token", "11eecd81b73dee01359719313ed0359d");
        map.put("timestamp", timestamp + "");
        map.put("nonce", UUID.randomUUID().toString().replace("-", ""));
        StrSubstitutor sub = new StrSubstitutor(map);
        String url = "https://api.e.qq.com/v1.0/user_action_sets/add?access_token=${access_token}&timestamp=${timestamp}&nonce=${nonce}";
        url = sub.replace(url);

        net.sf.json.JSONObject data = new net.sf.json.JSONObject();
        data.put("account_id", "5682282");
        data.put("type", "IOS");
        data.put("mobile_app_id", "1226942477");
        data.put("name", "真三国卧龙传");
        data.put("description", "真三国卧龙传");

        Map<String, String> resultMap = new HashedMap();
        String result = HttpUtil.getInstance().gdtAttribution(data.toString(), url, 800);
        JSONObject res = new JSONObject(result);
        int code = res.getInt("code");
        String msg = res.getString("message");
        resultMap.put("code", code + "");
        resultMap.put("msg", msg);

        if (code == 0) {
            JSONObject resData = res.getJSONObject("data");
            String user_action_set_id = resData.getString("user_action_set_id");
            resultMap.put("data", user_action_set_id);
        }
    }

    public List<ChannelAccountLinkApp> findByCreateUser(List<Long> accountids) {
        return this.channnelAccountLinkAppRepository.findByCreateUser(accountids);
    }

    @Override
    public List<ChannelAccountLinkApp> findByChannelAccount(Account account, long channelAccount) {
        List<ChannelAccountLinkApp> channnelAccountLinkAppList = new ArrayList<>();

        if (account.getRoleCategory() != null && account.getRoleCategory().equals(RoleEnumType.SUB_APP_MANAGER.getKey())) {
            channnelAccountLinkAppList = channnelAccountLinkAppRepository.findWithSubManagerByLinkUserId(channelAccount,account.getId());
        } else {
            channnelAccountLinkAppList = channnelAccountLinkAppRepository.findByLinkUserId(channelAccount);
        }

        if(channnelAccountLinkAppList.size()==0){
            return channnelAccountLinkAppList;
        }

        List<App> apps = appService.listAppByAccount(account.getId());
        List<String> authAppkeyList = new ArrayList<>();
        if (ValidateUtil.isValid(apps)) {
            for (App a : apps) {
                authAppkeyList.add(a.getAppkey());
            }
        }

        List<ChannelAccountLinkApp> result = new ArrayList<>();
        if (ValidateUtil.isValid(channnelAccountLinkAppList)) {
            List<String> appkeyList = new ArrayList<>();
            for (ChannelAccountLinkApp ca : channnelAccountLinkAppList) {
                appkeyList.add(ca.getAppkey());
            }
            List<App> appList = appRepository.findByAppkeys(appkeyList);
            Map<String, String> map = new HashMap<>();
            for (App app : appList) {
                map.put(app.getAppkey(), app.getName());
            }

            ChannelAccount channelAccountObj = channelAccountRepository.findOne(channelAccount);

            for (ChannelAccountLinkApp ca : channnelAccountLinkAppList) {

                ca.setAppName(map.get(ca.getAppkey()));

                if (channelAccountObj != null && "gdt".equals(channelAccountObj.getUniqueName())) {
                    this.dealGdtPlan(ca);
                }

                if (authAppkeyList.contains(ca.getAppkey())) {
                    ca.setHaveAuth(true);
                } else {
                    ca.setHaveAuth(false);
                }
                result.add(ca);
            }
        }
        return result;
    }

    /**
     * 广点通 方案二 处理
     *
     * @param ca
     */
    private void dealGdtPlan(ChannelAccountLinkApp ca) {
        GdtPlan gdtPlanByAppkey = this.gdtPlanRepository.getGdtPlanByAppkey(ca.getAppkey());
        if (gdtPlanByAppkey == null) {
            for (int i = 0; i < 6; i++) {
                try {
                    Thread.sleep(3000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                gdtPlanByAppkey = this.gdtPlanRepository.getGdtPlanByAppkey(ca.getAppkey());
                if (gdtPlanByAppkey != null) {
                    break;
                }
            }
        }
        ca.setFeedbackurl(gdtPlanByAppkey == null ? "短链生成中..." : gdtPlanByAppkey.getFeedbackURL());
    }

    @Override
    public ChannelAccountLinkApp save(ChannelAccountLinkApp resource, Long account) {
        resource.setCreateTime(new Date());
        resource.setCreateUser(account);
        ChannelAccountLinkApp save = channnelAccountLinkAppRepository.save(resource);
        ChannelAccount channelAccount = channelAccountRepository.findOne(save.getLinkUserId());
        //广电通的投放账号id挪到的了绑定应用的时候
        if (5305L == channelAccount.getChannel()) {
            List<App> apps = appRepository.findValidAppByRootParent(channelAccount.getRootAccount());
            channelAccount.setThirdAccountCode(save.getAccountId());
            NoSQLDBUtil.putMarketingapi(channelAccount, apps, true,
                    new ChannelAccountServiceImpl().apiMap.get(channelAccount.getChannel()));
        }
        return save;
    }

    @Override
    public Map<String, String> valid(ChannelAccountLinkApp resource)
            throws JSONException, IOException {
        ChannelAccount channelAccount = channelAccountRepository.findOne(resource.getLinkUserId());

        long timestamp = new Date().getTime() / 1000;
        Map<String, String> map = new HashMap<String, String>();
        map.put("access_token", channelAccount.getAccessToken());
        map.put("timestamp", timestamp + "");
        map.put("nonce", UUID.randomUUID().toString().replace("-", ""));

        JSONArray jsonArray = new JSONArray();

        net.sf.json.JSONObject json = new net.sf.json.JSONObject();
        json.put("account_id", resource.getAccountId());

        net.sf.json.JSONObject data = new net.sf.json.JSONObject();
        data.put("user_action_set_id", resource.getUserActionSetId());
        data.put("action_time", timestamp + "");
        data.put("action_type", "ACTIVATE_APP");
        data.put("action_param", new net.sf.json.JSONObject());

        net.sf.json.JSONObject userid = new net.sf.json.JSONObject();
        if (resource.getAppType().toUpperCase().contains("OS")) {
            userid.put("hash_idfa", "c4ca4238a0b923820dcc509a6f75849b");
        } else {
            userid.put("hash_imei", "c4ca4238a0b923820dcc509a6f75849b");
        }

        data.put("user_id", userid);
        jsonArray.add(data);

        json.put("actions", jsonArray);

        StrSubstitutor sub = new StrSubstitutor(map);
        //String url = "https://api.e.qq.com/v1.0/user_actions/add?access_token=${access_token}&timestamp=${timestamp}&nonce=${nonce}";
        String url = "https://api.e.qq.com/v1.1/user_actions/add?access_token=${access_token}&timestamp=${timestamp}&nonce=${nonce}";
        url = sub.replace(url);

        String result = HttpUtil.getInstance().gdtAttribution(json.toString(), url, 800);
        JSONObject res = new JSONObject(result);
        Integer code = res.getInt("code");
        String message = res.getString("message");
        Map<String, String> resMap = new HashMap<>();
        resMap.put("code", code.toString());
        resMap.put("message", message);
        return resMap;
    }

    @Override
    public void reValid(List<ChannelAccountLinkApp> list)
            throws IOException, JSONException {
        List<ChannelAccountLinkApp> saveList = new ArrayList<>();
        for (ChannelAccountLinkApp linkApp : list) {
            Map<String, String> map = valid(linkApp);
            boolean valid = "0".equals(map.get("code")) ? true : false;
            if (valid) {
                linkApp.setTestSuccess(true);
                saveList.add(linkApp);
            } else {
                linkApp.setTestSuccess(false);
                saveList.add(linkApp);
            }
        }
        channnelAccountLinkAppRepository.save(saveList);
    }

    @Override
    public void delete(Long id) {
        ChannelAccountLinkApp linkApp = this.channnelAccountLinkAppRepository.findOne(id);
        if (this.channelAccountRepository.findOne(linkApp.getLinkUserId()).getChannel() == 5305L) {
            GdtPlan gdtPlan = gdtPlanRepository.getGdtPlanByAppkey(linkApp.getAppkey());
            if (gdtPlan != null) {
                this.gdtPlanRepository.deleteByAppkey(gdtPlan.getAppkey());
            }
        }
        channnelAccountLinkAppRepository.delete(id);
    }

    @Override
    public List<App> listApp2Manager(Account loginAccount, Long linkUserId, String unique_name, boolean checkManager) {
        Channel channel = channelRepository.findByUniqueName(unique_name);
        if (channel == null) {
            logger.error("{}渠道不存在", unique_name);
            return null;
        }

        //1. 查询当前用用户指定渠道授权应用列表
        List<App> authAppList;
        if (loginAccount.getRoleCategory().equals(RoleEnumType.CUSTOM_AUTH.getKey()) || loginAccount.getRoleCategory().equals(RoleEnumType.CUSTOM_ROLE.getKey())
                || (checkManager && loginAccount.getRoleCategory().equals(RoleEnumType.SUB_APP_MANAGER.getKey()))) {
            authAppList = appRepository.listApps(loginAccount.getId(), channel.getId());
        } else {
            authAppList = appService.listAppByAccount(loginAccount.getId());
        }
        authAppList = authAppList.stream().filter(app -> !app.getIsDebug() && !"H5".equals(app.getPlatform())).collect(Collectors.toList());


        //2. 查询已绑定过的应用列表
        List<ChannelAccountLinkApp> alreadyLinkAppList = Lists.newArrayList();
        if (ChannelEnumType.GDT.getUniqueName().equals(unique_name)) {
            List<ChannelAccount> channelAccountList = channelAccountRepository.findByRootAccount(loginAccount.getRootParent(), unique_name);
            List<Long> linkUserIds = channelAccountList.stream().map(ChannelAccount::getId).collect(Collectors.toList());
            alreadyLinkAppList = channnelAccountLinkAppRepository.findByLinkUserIds(linkUserIds);
        } else if (ChannelEnumType.ADWORDS.getUniqueName().equals(unique_name)) {
            alreadyLinkAppList = channnelAccountLinkAppRepository.findByLinkUserId(linkUserId);
        }

        //3. 数据过滤
        List<String> alreadyAppkeys = alreadyLinkAppList.stream().map(ChannelAccountLinkApp::getAppkey).collect(Collectors.toList());
        return authAppList.stream().filter(app -> {
            return !alreadyAppkeys.contains(app.getAppkey());
        }).collect(Collectors.toList());
    }

    @Override

    public List<App> listApp(Account loginAccount, Long linkuserid, String unique_name) {
        return listApp2Manager(loginAccount, linkuserid, unique_name, false);
    }

    @Override
    public Map<String, String> createUserId(ChannelAccountLinkApp resource)
            throws IOException, JSONException {
        ChannelAccount channelAccount = channelAccountRepository.findOne(resource.getLinkUserId());

        long timestamp = new Date().getTime() / 1000;
        Map<String, String> map = new HashMap<String, String>();
        map.put("access_token", channelAccount.getAccessToken());
        map.put("timestamp", timestamp + "");
        map.put("nonce", UUID.randomUUID().toString().replace("-", ""));
        StrSubstitutor sub = new StrSubstitutor(map);
        //String url = "https://api.e.qq.com/v1.0/user_action_sets/add?access_token=${access_token}&timestamp=${timestamp}&nonce=${nonce}";
        String url = "https://api.e.qq.com/v1.1/user_action_sets/add?access_token=${access_token}&timestamp=${timestamp}&nonce=${nonce}";
        url = sub.replace(url);
        //logger.info(url);

        net.sf.json.JSONObject data = new net.sf.json.JSONObject();
        data.put("account_id", resource.getAccountId());
        data.put("type", resource.getAppType().toUpperCase());
        data.put("mobile_app_id", resource.getThirdAppId());
        data.put("name", resource.getAppName());
        data.put("description", resource.getAppName());

        Map<String, String> resultMap = new HashedMap();
        String result = HttpUtil.getInstance().gdtAttribution(data.toString(), url, 800);
        JSONObject res = new JSONObject(result);
        int code = res.getInt("code");
        String msg = res.getString("message");
        resultMap.put("code", code + "");
        resultMap.put("msg", msg);

        if (code == 0) {
            JSONObject resData = res.getJSONObject("data");
            String user_action_set_id = resData.getString("user_action_set_id");
            resultMap.put("data", user_action_set_id);
        } else {
            String response = getUserId(resource);
            //System.out.println(response);
            JSONObject rs = new JSONObject(response);
            int code2 = rs.getInt("code");
            String msg2 = rs.getString("message");
            if (rs.has("data")) {
                JSONObject data2 = rs.getJSONObject("data");
                org.json.JSONArray list = data2.getJSONArray("list");
                if (null != list && list.length() > 0) {
                    for (int i = 0; i < list.length(); i++) {
                        JSONObject object = list.getJSONObject(i);
                        if (object.has("mobile_app_id")) {
                            String mobile_app_id = object.getString("mobile_app_id");
                            if (resource.getThirdAppId().equals(mobile_app_id)) {
                                resultMap.put("code", code2 + "");
                                resultMap.put("msg", msg2);
                                resultMap.put("data", object.getString("user_action_set_id"));
                            }
                        }
                        /*if(object.has("user_action_set_id")){
                            resultMap.put("code", code2 + "");
                            resultMap.put("msg", msg2);
                            resultMap.put("data", object.getString("user_action_set_id"));
                        }*/
                    }
                }
            }
        }
        return resultMap;
    }

    @Override
    public String getUserId(ChannelAccountLinkApp resource) {
        ChannelAccount channelAccount = channelAccountRepository.findOne(resource.getLinkUserId());
        long timestamp = new Date().getTime() / 1000;
        Map<String, String> map = new HashMap<String, String>();
        map.put("access_token", channelAccount.getAccessToken());
        map.put("timestamp", timestamp + "");
        map.put("nonce", UUID.randomUUID().toString().replace("-", ""));
        map.put("account_id", resource.getAccountId());
        map.put("mobile_app_id", resource.getThirdAppId());
        StrSubstitutor sub = new StrSubstitutor(map);
        //v1.0
        /*String url = "https://api.e.qq.com/v1.0/user_action_sets/get?access_token=${access_token}&" +
                "timestamp=${timestamp}&nonce=${nonce}&account_id=${account_id}";*/
        //v1.1
        /*String url = "https://api.e.qq.com/v1.1/user_action_sets/get?access_token=${access_token}&" +
                "timestamp=${timestamp}&nonce=${nonce}&account_id=${account_id}&mobile_app_id=${mobile_app_id}";*/
        String url = "https://api.e.qq.com/v1.1/user_action_sets/get?access_token=${access_token}&" +
                "timestamp=${timestamp}&nonce=${nonce}&account_id=${account_id}&fields=%5B%22mobile_app_id%22%5D";
        url = sub.replace(url);

        String res = HttpClientUtil.doHttpGetRequest(url, "");
        return res;
    }

    @Override
    public boolean checkName(ChannelEnumType channelEnumType, String fieldKey, String fieldValue, Long channelAccountId, Long loginAccountId) {
        List<Long> accountIds = this.channelAccountService.getLinkAccounts(loginAccountId);
        if (ChannelEnumType.ADWORDS.equals(channelEnumType)) {
            List<ChannelAccountLinkApp> channelAccountLinkApps = this.channnelAccountLinkAppRepository.findByCreateUser(accountIds);
            if ("linkid".equals(fieldKey)) {
                return channelAccountLinkApps.stream()
                        .filter(channelAccountLinkApp -> channelAccountLinkApp.getUserActionSetId() != null && channelAccountLinkApp.getUserActionSetId().equals(fieldValue))
                        .count() == 0;
            }
        } else if (ChannelEnumType.GDT.equals(channelEnumType)) {
        }
        return false;
    }

    public void autoCheckLinkValid() {
        List<ChannelAccountLinkApp> all = this.channnelAccountLinkAppRepository.findAllByAdwordsAndChannelAccount().stream().filter(linkApp -> {
            return !adwordsService.isValid(linkApp.getUserActionSetId(), linkApp.getAppType());
        }).collect(Collectors.toList());
        /*List<String> validLinkIds = this.channnelAccountLinkAppRepository.findLinkIds()
                .stream().filter(s -> {
                    return !adwordsService.isValid(s,null);
                }).collect(Collectors.toList());*/
        List<String> validLinkIds = new ArrayList<>();
        for (ChannelAccountLinkApp app : all) {
            validLinkIds.add(app.getUserActionSetId());
        }
        if (validLinkIds.size() > 0) {
            this.channnelAccountLinkAppRepository.updateStatus(validLinkIds);
        }
    }
}
