package com.reyun.service.impl;

import com.alibaba.fastjson.JSON;
import com.reyun.model.Account;
import com.reyun.model.Monitor;
import com.reyun.repository.AccountRepository;
import com.reyun.service.ClickMonitorService;
import com.reyun.util.DateUtil;
import com.reyun.util.MessageQueueUtil;
import com.reyun.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.*;

@Service
public class ClickMonitorServiceImpl implements ClickMonitorService {
    @Autowired
    private AccountRepository accountRepository;
    @Autowired
    JdbcTemplate jdbcTemplate;
    static Map<String, Object> map = new HashMap();
    static {
        map.put("reyun", null);
        map.put("home", null);
        map.put("register", null);
        map.put("login", null);
        map.put("demolist", null);
        map.put("dashboard", null);
        map.put("realtime", null);
        map.put("channeleffect", null);
        map.put("campaigninfo", null);
        map.put("keyword", null);
        map.put("effectevaluate", null);
        map.put("roi", null);
        map.put("packageinfo", null);
        map.put("asmeffectevaluate", null);
        map.put("attribute", null);
        map.put("logtool", null);
        map.put("logexport", null);
        map.put("logdump", null);
        map.put("report", null);
        map.put("subcampaign", null);
        map.put("campaign", null);
        map.put("campgroup", null);
        map.put("datacb", null);
        map.put("customevent", null);
        map.put("fake", null);
        map.put("channel", null);
        map.put("systemparam", null);
        map.put("deviceManage", null);
        map.put("userinfo", null);
        map.put("auth", null);
        map.put("authrole", null);
        map.put("doc", null);
    }

    public ClickMonitorServiceImpl() {
    }

    public boolean recordClick(String email, String menu, String type, String ip, String data, String clickToken, String totalCount) {
        if (!map.containsKey(menu)) {
            //logger.info("false !!! menu:" + menu);
            return false;
        } else {
            Account account;
            if (StringUtil.isEmpty(email)) {
                account = new Account();
                account.setEmail("unknown");
                account.setRootParent(-1L);
            } else {
                account = this.accountRepository.findAccountByEmail(email);
            }


            if (account == null) {
                return false;
            } else {
                String today = DateUtil.format(new Date());
                if ("operate".equals(type)&&!StringUtil.isEmpty(data)) {
                    List<Monitor> monitors = JSON.parseArray(data, Monitor.class);
                    if (!CollectionUtils.isEmpty(monitors)) {
                        for (Monitor monitor : monitors) {
                            String dataStr = this.buildString(type, today, account.getEmail(), account.getRootParent(),
                                    clickToken, ip, menu, monitor.getName(), monitor.getCount());
                            MessageQueueUtil.putRecord("tkioweb-monitor", dataStr);
                        }
                        return true;
                    }
                } else if ("pv".equals(type)) {
                    String s = this.buildString(type, today, account.getEmail(), account.getRootParent(), clickToken, ip, menu, "_default_", totalCount);
                    MessageQueueUtil.putRecord("tkioweb-monitor",s);
                    return true;
                }
                return false;
            }
        }
    }

    private String buildString(String type,String today,String email,Long rootParent ,String clickToken,String ip,String menu,String clickName,String totalCount){
        StringBuffer flag = new StringBuffer();
        flag.append(type).append("\t")
            .append(today).append("\t")
            .append(email).append("\t")
            .append(rootParent).append("\t")
            .append(clickToken).append("\t")
            .append(ip).append("\t")
            .append(menu).append("\t")
            .append(clickName).append("\t")
            .append(totalCount).append("\n");
        //System.out.println(flag.toString());
        return flag.toString();
    }

}
