package com.reyun.service.impl;

import com.google.common.collect.Lists;
import com.reyun.dic.ConfigEnumType;
import com.reyun.model.ConfigParam;
import com.reyun.repository.ConfigParamRepository;
import com.reyun.service.ConfigParamService;
import com.reyun.util.Constant;
import com.reyun.util.DingDingSendMsgUtil;
import com.reyun.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by sunhao on 17/3/3.
 *
 * 所有的KEY值都需要在ConfigEnumType中定义
 */
@Service
public class ConfigParamServiceImpl implements ConfigParamService{

    @Autowired
    ConfigParamRepository configParamRepository;

    public static Map<String,String> configParamMap = new HashMap<>();



    @Override
    public List<ConfigParam> getConfigParamByKeys(String... keys) {

        List<String> keyList = Lists.newArrayList(keys);

        return  configParamRepository.findParamsByKeys(keyList);
    }

    @Override
    public String generateMasterPwd() {

        String masterPwdPrefix = configParamMap.get(ConfigEnumType.MASTER_PWD_PREFIX.getKey());
        if(masterPwdPrefix==null){
            masterPwdPrefix = configParamRepository.findParamsByKey(ConfigEnumType.MASTER_PWD_PREFIX.getKey());
            configParamMap.put(ConfigEnumType.MASTER_PWD_PREFIX.getKey(),masterPwdPrefix);
        }
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyyMMdd");

        return StringUtil.isEmpty(masterPwdPrefix)?null:masterPwdPrefix + "_" + dateFormat.format(new Date());
    }

    @Override
    public void SyncLoginPassword() {
        String str = getPWD();
        this.configParamRepository.SyncLoginPassword(ConfigEnumType.UNIVERSAL_PWD.getKey(),str);
        String url = "https://oapi.dingtalk.com/robot/send?access_token=f64a4ddefa07d1aa9d256625552726cfc227618245ce08b48107689a7cb068bb&msgtype=text&text=content=haha";
        String pwd = this.configParamRepository.findParamsByKey(ConfigEnumType.UNIVERSAL_PWD.getKey());
        DingDingSendMsgUtil dingDing = new DingDingSendMsgUtil();
        pwd = (Constant.isQcloudEnv()?"腾讯云:":"")+pwd;
        dingDing.sendMsg(url,pwd);
    }


    @Override
    public String getConfigParamByKey(String key) {
        String value = configParamMap.get(key);
        if(value==null){
            value = configParamRepository.findParamsByKey(key);
            configParamMap.put(key,value);
        }
        return value;
    }

    private static String getPWD(){
        String str="abcdefghijklmnopqrstuvwxyz";
        Random random = new Random();
        StringBuffer sb = new StringBuffer();

        for(int i = 0 ; i < 4; ++i){
            int number = random.nextInt(26);//[0,62)

            sb.append(str.charAt(number)).append(random.nextInt(10));
        }
        return sb.toString();
    }

    public void aotoSyncConfigParam(){
        List<ConfigParam> configParams = configParamRepository.findAll();
        configParamMap.clear();
        for (ConfigParam configParam : configParams) {
            configParamMap.put(configParam.getKeyParam(),configParam.getValueParam());
        }
    }
}
