package com.reyun.service.impl;

import com.reyun.model.Account;
import com.reyun.model.AccountRestrict4Web;
import org.springframework.stereotype.Service;

import java.math.BigInteger;

@Service
public class PackageFlowService {


    //当前套餐已使用流量( 判断时候包含流量包流量)
    public BigInteger getUsedTrackFlow(AccountRestrict4Web restrict4Web, Account account) {

        restrict4Web = fillNullValue(restrict4Web);

        BigInteger used = restrict4Web.getTrackTotalFlow().add(restrict4Web.getIncrementFlow());
        if (restrict4Web.getPackageFlowId() != null && restrict4Web.getPackageFlowId().intValue() != -1) {
            //用户开通流量包

            //流量包已使用流量
            BigInteger packageFlowUsed = restrict4Web.getPackageTotalFlow().add(restrict4Web.getPackageIncrementFlow());

            if (packageFlowUsed.doubleValue() >= restrict4Web.getPackageLimit().doubleValue()) {
                //流量包流量已用尽
                //新合同时 已使用流量包
                BigInteger packageModifyUseFlow = restrict4Web.getPackageContractTotalFlow().add(restrict4Web.getPackageIncrementContractFlow());
                if (account.getNewContract() && account.getModifyPricelevelTime() != null) {
                    //新合同流量包处理
                    //上一合同已使用的流量包
                    BigInteger oldPackageFlow = packageFlowUsed.subtract(packageModifyUseFlow);

                    if (oldPackageFlow.doubleValue() < restrict4Web.getPackageLimit().doubleValue()) {
                        //上一合同未使用完流量包
                        //本合同可使用的流量包流量
                        BigInteger cuseFlow = restrict4Web.getPackageLimit().subtract(oldPackageFlow);
                        used = used.subtract(cuseFlow);
                    }

                    //上一合同已使用完流量包 不需要减去流量包流量

                } else {
                    //同一合同 流量包使用完时 减去流量包套餐流量（超出的流量计算到普通流量）
                    used = used.subtract(restrict4Web.getPackageLimit());
                }

            } else {
                //流量包未使用完 时
                used = used.subtract(restrict4Web.getPackageContractTotalFlow().compareTo(BigInteger.ZERO) > 0 ?
                        restrict4Web.getPackageContractTotalFlow() : restrict4Web.getPackageTotalFlow())
                        .subtract(restrict4Web.getPackageIncrementFlow());
            }

        }

        if (used.doubleValue() < 0) {
            used = BigInteger.ZERO;
        }

        return used;
    }

    public BigInteger getPackageFlowUsed(AccountRestrict4Web restrict4Web, Account account) {
        restrict4Web = fillNullValue(restrict4Web);
        BigInteger packageUsedFlowAll = restrict4Web.getPackageTotalFlow().add(restrict4Web.getPackageIncrementFlow());
        return packageUsedFlowAll.doubleValue() >= restrict4Web.getPackageLimit().doubleValue()
                ? restrict4Web.getPackageLimit() : packageUsedFlowAll;

    }

    public AccountRestrict4Web fillNullValue(AccountRestrict4Web restrict4Web) {
        if (restrict4Web.getIncrementFlow() == null) {
            restrict4Web.setIncrementFlow(BigInteger.ZERO);
        }
        if (restrict4Web.getPackageIncrementFlow() == null) {
            restrict4Web.setPackageIncrementFlow(BigInteger.ZERO);
        }
        if (restrict4Web.getPackageIncrementContractFlow() == null) {
            restrict4Web.setPackageIncrementContractFlow(BigInteger.ZERO);
        }
        return restrict4Web;
    }

}
