package com.reyun.service.impl;

import com.reyun.model.Account;
import com.reyun.model.LifeCycleApps;
import com.reyun.model.SystemParam;
import com.reyun.repository.*;
import com.reyun.service.SystemParamService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

@Service
@Transactional
public class SystemParamServiceImpl implements SystemParamService {

    @Autowired
    SystemParamRepository systemParamRepository;

    @Autowired
    ChannelParamRepository channelParamRepository;

    @Autowired
    AccountRepository accountRepository;

    @Autowired
    LifeCycleAppsRepository lifeCycleAppsRepository;

    @Autowired
    AppRepository appRepository;

    @Override
    public SystemParam update(SystemParam resource, Long account) {
        SystemParam set = systemParamRepository.findOne(resource.getId());
        if (resource.getCiDay() != 0) {
            set.setCiDay(resource.getCiDay());
        }
        if (resource.getCilag() != 0) {
            set.setCilag(resource.getCilag());
        }
        if (resource.getClickDay() != 0) {
            set.setClickDay(resource.getClickDay());
        }
        if (resource.getInstallDay() != 0) {
            set.setInstallDay(resource.getInstallDay());
        }
        if (resource.getNormalclick() != 0) {
            set.setNormalclick(resource.getNormalclick());
        }
        if (resource.getNormalinstall() != 0) {
            set.setNormalinstall(resource.getNormalinstall());
        }
        if (resource.getArouseDay() != 0) {
            set.setArouseDay(resource.getArouseDay());
        }
        if (resource.getApp() != 0) {
            set.setApp(resource.getApp());
        }


        if (resource.getImpIsAttribute() != null) {
            set.setImpIsAttribute(resource.getImpIsAttribute());
            channelParamRepository.updateImpAttributeStatus(resource.getImpIsAttribute(), resource.getApp());
        }
        set.setModifyAccount(resource.getModifyAccount());
        set.setModifyTime(new Date());

        return systemParamRepository.save(set);
    }

    @Override
    public SystemParam find(Long account, Long app) {

        SystemParam systemParam = systemParamRepository.findByApp(app);

        if (systemParam == null) {
            return create(account, true, app);
        }

        return systemParam;
    }


    public SystemParam create(Long account, boolean tosave, Long app) {

        SystemParam systemParam = new SystemParam();
        systemParam.setAccount(getRootParent(account));
        systemParam.setCiDay(604800);
        systemParam.setCilag(5);
        systemParam.setClickDay(30);
        systemParam.setInstallDay(30);
        systemParam.setNormalclick(30);
        systemParam.setNormalinstall(30);
        systemParam.setPubDate(new Date());
        systemParam.setArouseDay(30);
        systemParam.setApp(app);
        if (tosave) {
            return systemParamRepository.save(systemParam);
        }
        return systemParam;

    }

    public Long getRootParent(Long account) {

        Account accountOne = accountRepository.findOne(account);
        return accountOne.getRootParent();

    }

    @Override
    public LifeCycleApps setLifeCycle(LifeCycleApps lifeCycleApps, Account loginAccount) {

        LifeCycleApps apps = lifeCycleAppsRepository.findByAppId(lifeCycleApps.getAppid());
        if (!loginAccount.getId().equals(loginAccount.getRootParent())) {
            loginAccount = accountRepository.findOne(loginAccount.getRootParent());
        }

        if (apps == null) {
            
            lifeCycleApps.setAppid(appRepository.findOne(Long.parseLong(lifeCycleApps.getAppid())).getAppkey());
            lifeCycleApps.setCreateTime(new Date());
            lifeCycleApps.setRootAccont(loginAccount.getId());
            lifeCycleApps = lifeCycleAppsRepository.save(lifeCycleApps);

        } else {
            apps.setLossPhaseDays(lifeCycleApps.getLossPhaseDays());
            apps.setSilentPhaseDays(lifeCycleApps.getSilentPhaseDays());
            lifeCycleAppsRepository.save(apps);
            lifeCycleApps = apps;

        }
        return lifeCycleApps;
    }

    @Override
    public LifeCycleApps findLifeCycleByApp(String app, Account loginAccount) {
        return lifeCycleAppsRepository.findByAppId(app);
    }
}
