package com.reyun.task;


import com.reyun.model.SystemParam;
import com.reyun.repository.ChannelParamRepository;
import com.reyun.repository.ConfigParamRepository;
import com.reyun.repository.SystemParamRepository;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.Arrays;
import java.util.List;

@Service
public class AutoOpenBlackTmpTask {

    Logger logger = LoggerFactory.getLogger(AutoOpenBlackTmpTask.class);
    private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE*1 / 1000;

    @Autowired
    private ChannelParamRepository channelParamRepository;


    @Autowired
    private ConfigParamRepository configParamRepository;


    public void run() {


        if (RedisUtilNew.getInstance().tryLock("AutoOpenBlackTmpTask", EXPIRE_PERIOD) != null) {

            String ids = configParamRepository.findParamsByKey("black_open_specile_account");

            if (!StringUtils.isEmpty(ids)) {
                List<String> accountIds = Arrays.asList(ids.split(","));
                int rows = channelParamRepository.updateAutoOpenBlack(accountIds);
                logger.info("black opened {} datas",rows);


            }
        }else{
            logger.info("black opened run by other");
        }



    }

}
