package com.reyun.task;

import com.reyun.service.CampaignService;
import com.reyun.service.impl.CampaignServiceImpl;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @author liyin
 * @description
 * @date
 */
public class AutoRefreshWeChatMPToken {
    private static Logger logger = LoggerFactory.getLogger(AutoRefreshWeChatMPToken.class);
    private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_SECOND * 5 / 1000;

    @Autowired
    CampaignService campaignService;

    public void run() {
        if (RedisUtilNew.getInstance().tryLock("trackingioAutoRefreshToken#3", EXPIRE_PERIOD) != null) {
            logger.info("微信MP同步token......");
            campaignService.autoRefreshWeChatMPToken();
            logger.info("微信MP同步token结束......");
        }
    }
}
