package com.reyun.task;

import com.reyun.model.App;
import com.reyun.repository.AppRepository;
import com.reyun.service.AppService;
import com.reyun.util.Constant;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.joda.time.DateTime;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * Created by sunhao on 17/7/5.
 * desc:定时同步同步失败的APP测试模式
 */
public class AutoSyncAppDebugStatus {

    private static Logger logger = LoggerFactory.getLogger(AutoSyncAppDebugStatus.class);
    private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE * 1 / 1000;

    @Autowired
    private AppRepository appRepository;

    @Autowired
    private AppService appService;

    public void run() {
        logger.info("同步APP测试模式服务................//Begin, 执行时间: {}", DateTime.now());

        if (RedisUtilNew.getInstance().tryLock(Constant.appDebugTask, EXPIRE_PERIOD) != null) {

            List<App> appList = appRepository.findNotSyncAppDebug();

            logger.info("同步APP数量:{}",appList.size());

            //循环同步
            if (!CollectionUtils.isEmpty(appList)) {
                for (App app : appList) {

                    logger.info("正在同步APP:{}",app.getAppkey());

                    appService.syncAppDebugStatus(app);
                }
            }

        } else {
            logger.info("正在执行中......");
        }
        logger.info("同步APP测试模式服务................//End");
    }
}
