package com.reyun.task;

import com.reyun.service.SmSearchService;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.joda.time.DateTime;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by sunhao on 17/3/24.
 * description:自动同步神马关键字和创意
 */
@Service
public class AutoSyncShenMaKeywordsTask {

    private static Logger logger = LoggerFactory.getLogger(AutoSyncSurlTask.class);
    private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE * 1 / 1000;

    @Autowired
    private SmSearchService smSearchService;

    public void run(){

        logger.info("同步神马关键词和创意................//Begin, 执行时间: {}", DateTime.now());

        if (RedisUtilNew.getInstance().tryLock("AutoSyncShenMaKeywordsTask", EXPIRE_PERIOD) != null) {
            smSearchService.task();
        } else {
            logger.info("AutoSyncShenMaKeywordsTask正在执行中......");
        }

        logger.info("同步神马关键词和创意................//End");
    }
}
