package com.reyun.task;

import com.reyun.service.ConfigParamService;
import com.reyun.util.Constant;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * Created by zy on 2019-01-09
 * desc:定时同步登录万能密码,并发送钉钉群
 */
public class AutoSyncUniversalLoginPassword {

    private static Logger logger = LoggerFactory.getLogger(AutoSyncUniversalLoginPassword.class);
    private static int EXPIRE_PERIOD = 1200;

    @Autowired
    ConfigParamService configParamService;

    public void run() {
        if(!"true".equals(Constant.mailProd)){
            logger.info("非AWS不同步登录万能密码......");
            return;
        }
        if (RedisUtilNew.getInstance().tryLock("trackingioUniversalLoginPassword", EXPIRE_PERIOD) != null) {
            logger.info("同步登录万能密码......");
            try {
                configParamService.SyncLoginPassword();
            } catch (Exception e) {
                logger.error("同步登录万能密码出错......");
                e.printStackTrace();
            }
            logger.info("同步登录万能密码结束......");
        } else {
            logger.info("同步登录万能密码, 正在处理......");
        }
    }
}
