package com.reyun.task;

import com.reyun.service.ChannnelAccountLinkAppService;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.joda.time.DateTime;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by mxq on 17/5/27.
 * description:自动onelink短链
 */
@Service
public class CheckChannelAccountLinkAppTask
{

    private static Logger logger = LoggerFactory.getLogger(CheckChannelAccountLinkAppTask.class);
    private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE * 1 / 1000;

    @Autowired
    private ChannnelAccountLinkAppService channnelAccountLinkAppService;

    public void run(){

        logger.info("实时同步检查ChannelAccoutLinkApp................//Begin, 执行时间: {}", DateTime.now());

        if (RedisUtilNew.getInstance().tryLock("autoCheckLinkValid", EXPIRE_PERIOD) != null) {
            channnelAccountLinkAppService.autoCheckLinkValid();

            RedisUtilNew.getInstance().releaseLock("autoCheckLinkValid");
        } else {
            logger.info("正在执行中......");
        }

        logger.info("实时同步ChannelAccoutLinkApp...............//End");
    }
}
