package com.reyun.task;

import com.reyun.service.impl.OnelinkService;
import com.reyun.util.Constant;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.joda.time.DateTime;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by mxq on 17/5/27.
 * description:自动onelink短链
 */
@Service
public class OnelinkSurlTask {

    private static Logger logger = LoggerFactory.getLogger(OnelinkSurlTask.class);
    private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE * 1 / 1000;

    @Autowired
    private OnelinkService onelinkService;

    public void run() {

        logger.info("实时同步onelink短链................//Begin, 执行时间: {}", DateTime.now());

        if ((RedisUtilNew.getInstance().tryLock("OnelinkSurlTask", EXPIRE_PERIOD) != null) && "true".equals(Constant.mailProd)) {
            //线上环境检查短链 并发送邮件（防止测试环境发送邮件 导致邮件api邮件数量暴增）
            onelinkService.taskSurlToDDb();
        } else {
            logger.info("正在执行中......");
        }

        logger.info("实时同步onelink短链...............//End");
    }
}
