package com.reyun.task;

import com.reyun.service.CampaignService;
import com.reyun.util.RedisUtilNew;
import org.apache.commons.lang.time.DateUtils;
import org.joda.time.DateTime;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by nolan on 09/02/2017.
 * description:
 */
@Service
public class OnlineAppSyncDingDingAndEmailMSGTask {
	private static Logger logger = LoggerFactory.getLogger(OnlineAppSyncDingDingAndEmailMSGTask.class);
	private static int EXPIRE_PERIOD = (int) DateUtils.MILLIS_PER_MINUTE * 1 / 1000;

	@Autowired
	private CampaignService campaignService;

	public void run() {
		logger.info("App自动上线内部钉钉&客户Email提示................//Begin, 执行时间: {}", DateTime.now());
		if (RedisUtilNew.getInstance().tryLock("OnlineAppSyncDingDingAndEmailMSGTask", EXPIRE_PERIOD) != null) {
			campaignService.doOnlineAppSyncDingDingAndEmailMSGTask();
		} else {
			logger.info("正在执行中......");
		}
		logger.info("App自动上线内部钉钉&客户Email提示................//End");
	}
}
