package com.reyun.taskexecute;

import com.reyun.util.Constant;
import com.reyun.util.DateUtil;
import com.reyun.util.SendCommonPostMail;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

/**
 * 发送申请邮件
 */
public class SendApplyEmailThread extends Thread {

    protected Logger logger = LoggerFactory.getLogger(SendApplyEmailThread.class);

    private final static String LARRY_EMAIL = "sunhao@reyun.com";

    private String company;
    private String email;
    private String phone;
    private Boolean renew;

    public SendApplyEmailThread(String company, String email, String phone, Boolean renew) {
        this.company = company;
        this.email = email;
        this.phone = phone;
        this.renew = renew;
    }


    @Override
    public void run() {

        String subject = "TrackingIo申请回本分析";

        StringBuilder content = new StringBuilder();
        content.append("<!doctype html> <html><head></head><body> ")
                .append("Larry：</br>")
                .append("在")
                .append(DateUtil.getCurrentDateStr())
                .append("收到 ")
                .append(company)
                .append(" 账号为:")
                .append(email)
                .append("提交的回本分析")
                .append(renew ? "续订申请" : "开通申请")
                .append(",联系方式为:")
                .append(phone)
                .append(",请反馈至销售同学进行后续跟进。或至Office快速开通")
                .append("<a href=\"").append(Constant.adminUrl).append("\">").append(Constant.adminUrl).append("</a>")
                .append("</body></html>");

        List<String> list = new ArrayList<>();
        list.add(LARRY_EMAIL);
        list.add("wangpeiyang@reyun.com");
        list.add("yangfei@reyun.com");

        try {

            //MailUtils.sendHtmlEmail(subject, content.toString(), list);
            SendCommonPostMail.sendMailReuse(list, subject, content.toString(),null,null);
        } catch (Exception e) {
            logger.error("send apply email error:", e);
        }
    }
}

