package com.reyun.util;

/**
 * Created by nolan on 15/11/2016.
 * description:
 */
public class ReportTokenModel {

    /**
     * 返回码
     */
    private int status;

    /**
     * 返回结果描述
     */
    private String msg;


    /**
     * 返回内容
     */
    private Object data;

    public ReportTokenModel(int code, String msg) {
        this.status = code;
        this.msg = msg;
        this.data = "";
    }

    public ReportTokenModel(int code, String msg, Object content) {
        this.status = code;
        this.msg = msg;
        this.data = content;
    }

    public ReportTokenModel(ResultStatus status) {
        this.status = status.getCode();
        this.msg = status.getMessage();
        this.data = "";
    }

    public ReportTokenModel(ResultStatus status, Object content) {
        this.status = status.getCode();
        this.msg = status.getMessage();
        this.data = content;
    }

    public static ReportTokenModel OK(Object content) {
        return new ReportTokenModel(ResultStatus.REPORT_TOKEN_SUCCESS, content);
    }

    public static ReportTokenModel OK() {
        return new ReportTokenModel(ResultStatus.REPORT_TOKEN_SUCCESS);
    }

    public static ReportTokenModel ERROR(ResultStatus error) {
        return new ReportTokenModel(error);
    }

    public static ReportTokenModel ERROR(String error) {
        return new ReportTokenModel(-50001,error);
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }


    public Object getData() {
        return data;
    }

    public void setData(Object data) {
        this.data = data;
    }

}