package com.reyun.util;

/**
 * Created by nolan on 15/11/2016.
 * description:
 */
public class ResultModel {

    /**
     * 返回码
     */
    private int code;

    /**
     * 返回结果描述
     */
    private String message;
    
    /*
     * 错误信息的英文描述
     */
    private String enmsg;

    /**
     * 返回内容
     */
    private Object content;

    public ResultModel(int code, String message) {
        this.code = code;
        this.message = message;
        this.content = "";
    }

    public ResultModel(int code, String message, Object content) {
        this.code = code;
        this.message = message;
        this.content = content;
    }

    public ResultModel(ResultStatus status) {
        this.code = status.getCode();
        this.message = status.getMessage();
        this.content = "";
        this.enmsg = status.getEnmsg();
    }

    public ResultModel(ResultStatus status, Object content) {
        this.code = status.getCode();
        this.message = status.getMessage();
        this.content = content;
        this.enmsg = status.getEnmsg();
    }

    public static ResultModel OK(Object content) {
        return new ResultModel(ResultStatus.SUCCESS, content);
    }

    public static ResultModel OK() {
        return new ResultModel(ResultStatus.SUCCESS);
    }

    public static ResultModel ERROR(ResultStatus error) {
        return new ResultModel(error);
    }

    public static ResultModel ERROR(String error) {
        return new ResultModel(-50001,error);
    }

    public int getCode() {
        return code;
    }

    public String getMessage() {
        return message;
    }

    public Object getContent() {
        return content;
    }

    public void setContent(Object content) {
    	this.content = content;
    }
    
    public void convertEn() {
    	if(this.enmsg != null && !this.enmsg.equals("")) {
    		this.message = this.enmsg;
    	}
    }
}