package com.reyun.util;

/**
 * Created by nolan on 15/11/2016.
 * description:
 */
public enum ResultStatus {

    SUCCESS(200, "成功", "Success"),
    FAILED(-200, "失败", "failure"),
    NUMBER_LIMIT(-300, "超过限定值,无法添加", "Cannot add more than the limit"),
    NETWORK_ERROR(404, "网络异常", "Network anomaly"),
    PARAM_INVALID(-1000, "参数错误", "Parameter error"),
    USERNAME_OR_PASSWORD_ERROR(-1001, "用户名或密码错误", "Wrong user name or password"),
    USERNAME_LOGIN_EXPIRE(-1002, "用户登陆失效", "User login failed"),
    USERNAME_AUTH_ERRO(1030, "未授权的请求", "User login failed"),
    SUB_ACCOUNT_DISABLE(-1003, "子帐号已禁用", "Sub account is disabled"),
    ORIGINAL_ACCOUNT_DISABLE(-1004, "主体帐号已禁用", "The main account has been disabled"),
    ACCOUNT_BUSINESS_EXPIRE(-1005, "主帐号已过期", "The main account has expired"),
    ACCOUNT_NOT_CONFIRM(-1006, "帐号待审核", "The account is to be audited"),
    APP_DEL(-1007, "应用已被删除", "The application has been deleted"),
    AUTH_ACCOUNT_BUSINESS_EXPIRE(-1008, "授权帐号已过期", "The authorized account has expired"),
    ONELINK_OCCUPY(-1009, "onelink占用推广活动", "The onelink's campaign is occupied"),
    ACCOUNT_NOT_ACTIVATE(-1010, "账号未激活", "The account is not installed"),
    USER_NOT_AUTH(-2000, "功能未授权", "The function has not been authorized"),
    CAMPAIGN_CREATEING(-3000, "推广活动正在创建中, 请勿重复提交", "The campaign is being created. Please do not submit again."),
    ID_NOT_EXIST(-4000, "对应ID的记录不存在", "The corresponding record does not exist."),
    EXPORT_DATA_EXIST(-5000, "导出记录已存在", "The export record already exists"),
    EXPORT_DATA_BYTESIZE_LARGE(-5002, "导出日志文件大于100MB,请重新选择", "empty"),
    EXPORT_PHYSICALNUMBER_LARGE(-5007, "单文件数据量超过2000条，请分批上传", "empty"),
    EXPORT_FILE_EXIST(-5001, "导出文件不存在", "The export file does not exist"),
    RECORD_EXIST(-6000, "记录已存在,请勿重复提交", "The record already exists. Please do not submit again"),
    NAME_EXIST(-6001, "名称已存在", "The name already exists"),
    CHANNELNAME_EXIST(-6004, "该邮箱已在系统内被创建为其他角色的账号，不可再创建为渠道账号。", "The mailbox has been created as the account for another role and can no longer be created as a partner account."),
    EVENT_NULL(-6002, "事件为空", "The event is empty"),
    FILE_TYPE_ERROR(-6003, "文件格式错误", "File format error"),
    KEY_WORDS_TITLE_ERRO(-6005, "模板标题错误"),
    KEY_WORDS_ID_ERRO(-6006, "关键字ID或创意ID只能是数字"),

    CAMPAIGN_OCCUPY(-1010, "推广活动占用渠道", "The campaign occupies the partner"),
    CUSTOMIZE_CALLBACK_EXIST(-1011, "此app在本渠道下已经创建有自定义回调", "This has created a custom callback under this partner."),
    CUSTOMIZE_CALLBACK_NOTEXIST(-1011, "此app在本渠道下未创建有自定义回调", "This has created a custom callback under this partner."),


    NAME_NULL(-1101, "名称为空", "The name is empty"),
    NAME_INVAILD(-1102, "名称不合法", "The name is illegal"),
    CAMPAIGN_NOT_MATCH_APP(-1103, "推广活动与应用不匹配", "The campaign does not match the application."),
    SURL_NULL(-1105, "短链为空", "Campaign is empty"),
    CAMPAIGN_NULL(-1106, "推广活动不存在", "Campaign does not exist"),
    CAMPAIGN_EXISTS(-1107, "此分包渠道的活动已存在", "The campaign in this sub-partner already exists."),
    CAMPAIGN_REPEAT(-1008, "批量创建推广活动时名称重复", "The name is duplicated when creating the campaign in batches"),

    MSG_SMS_OUTOFTIME(-4001, "验证码过时，重新获取", "Verification code has expired. Please get again."),
    MSG_SMS_REQUESTTIMES(-4002, "今天请求验证码次数过多", "Too many requests for verification code today."),
    MSG_SMS_IPREQUESTTIMES(-4003, "IP地址请求过多", "Too many address requests"),
    MSG_SMS_IPERROR(-4004, "未知ip达到峰值", "Unknown reaches peak"),
    MSG_SMS_WRONG(-4005, "验证码不正确", "The verification code is incorrect."),

    CHANNELACCOUNT_NOEXIST(-5001, "渠道帐号不存在", "Channel account does not exist"),
    CHANNEL_ALIASNAME_EXIST(-5002, "该名称系统已存在", "The name system already exists."),
    CHANNEL_NAME_EXIST(-5002, "渠道名称已存在", "The name system already exists."),
    CHANNELACCOUNT_EXIST(-5003, "该账号ID已创建投放账号，不可重复创建", "The release account has been created in the account and can not be created repeatedly."),
    CHANNEL_LINKID_NOEXIST(-5004, "link_id不存在", "link_id does not exist"),
    CHANNEL_LINKID_EXIST_WITHAPP(-5006, "link_ID已被其他应用绑定，请重新输入", "link_id does not exist"),//未翻译
    CHANNEL_NUMBER_LIMIT(-5005, "渠道个数超过限制", "The number of partners exceeds the limit."),

    COMMON_IP_EXISTS(-7000, "公共ip已存在", "The public ip already exists"),
    ADWORDS_LINKID_FAIL(-5005, "awards 链接错误", "awards linked fail"),
    EXP_INVALID(11000, "自定义表达式错误", "Custom expression error"),
    CHANNEL_CAMPAIGN_NOTDEL(11001, "渠道下该产品的推广活动未删除", "The campaign of the product has not been deleted under the partner"),

    PACKAGE_SUB_CAMPAIGN_REPEAT(20001, "同一个活动下的子活动名称重复", "The sub-campaign name is duplicated under the same campaign"),
    RECYCLE_CHANNEL_NOT_EXIST(30001, "回本分析的渠道不存在", "The partner of breakeven analysis does not exist"),
    RECYCLE_ACCOUNT_NOT_OPEN(30002, "回本分析功能没有开通该渠道", "The partner is not opened in the breakeven analysis function"),
    RECYCLE_USERNAME_NOT_UNIQUE(30003, "账号已绑定", "The account has been bound"),
    RECYCLE_CHANNELALIAS_NOT_UNIQUE(30004, "账号别名已绑定", "The account alias has been bound"),
    RECYCLE_CHANNELACCOUNT_NOT_EXIST(30005, "账号账号不存在", "The account does not exist."),
    RECYCLE_ACCOUNT_NEED_PHOEN_AUTH(30006, "回本分析渠道需要手机验证", "The breakeven analysis partner needs mobile phone verification"),
    RECYCLE_ACCOUNT_NEED_QUESTION_AUTH(30007, "回本分析渠道需要答题验证", "The breakeven analysis partner needs answer verification."),
    RECYCLE_ACCOUN_DATA_NOT_EXIST(30008, "回本分析对应的账号数据找不到", "The account data corresponding to the breakeven analysis cannot be found."),
    ECYCLE_ACCOUN_DATA_ADD_FAIL(30009, "回本分析账号添加失败", "Failed to add the breakeven analysis account"),
    ECYCLE_ACCOUN_NO_NEED_WARN(30010, "回本分析付费账户不需要提醒", "The payment account of the breakeven analysis does not need reminder."),
    ECYCLE_ACCOUN_ALREADY_OPEN(30011, "回本分析已经存在开通记录", "The opening record of the breakeven analysis already exists."),
    MENU_APPLY_ERRO(30012, "服务申请错误", "empty"),
    MENU_APPLY_ALREAD(30013, "该服务已申请,请等待审核", "empty"),
    DEMO_EMAIL_CODE_EXPIRED(-40001, "验证码已过期", "empty"),
    DEMO_EMAIL_APPLY_EXIST(-40003, "请勿重复申请", "empty"),
    DEMO_EMAIL_CODE_ERROR(-40002, "验证码不正确", "empty"),
    FILE_EMPFFTY(-40003, "文件不能为空", "empty"),
    SHEET_TITLE_ERRO(-40004, "文件表头配置错误", ""),
    REPORT_TOKEN_ERROR(410, "校验失败", ""),
    REPORT_TOKEN_FAILURE(411, "已失效", ""),
    REPORT_TOKEN_OUT(412, "标识获取次数超限", ""),
    REPORT_REQUEST_OUT(240, "查询次数受限", ""),
    REPORT_TOKEN_SUCCESS(200, "ok", "Success"),;

    /**
     * 返回码
     */
    private int code;

    /**
     * 返回结果描述
     */
    private String message;

    /**
     * 错误信息的英文(国际化用)
     */
    private String enmsg;

    ResultStatus(int code, String message) {
        this.code = code;
        this.message = message;
    }

    ResultStatus(int code, String message, String enmsg) {
        this.code = code;
        this.message = message;
        this.enmsg = enmsg;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public String getEnmsg() {
        return this.enmsg;
    }

    public void setEnmsg(String enmsg) {
        this.enmsg = enmsg;
    }
}