package com.reyun.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.datasource.DriverManagerDataSource;

import java.sql.*;
import java.util.List;


/**
 * 数据库工具类
 * @author ruijie liruijie0603@126.com
 * @date 2014-11-28
 */
public class TkioStreamDBUtil {
	private final static Logger logger = LoggerFactory.getLogger(TkioStreamDBUtil.class);

	private static TkioStreamDBUtil dbUtil;

	private String driverClass = "";
	private String url = "";
	private String username = "";
	private String password = "";

	private TkioStreamDBUtil() {
		driverClass = Constant.dbdriver;
		url = Constant.tkiostreamdatasourceurl;
		username = Constant.tkiostreamdatasourceusername;
		password = Constant.tkiostreamdatasourcepassword;
	}

	private TkioStreamDBUtil(String type) {
		driverClass = Constant.dbdriver;
		url = "jdbc:mysql://tkio.cma5jkozme68.rds.cn-north-1.amazonaws.com.cn:3306/trackingio?characterEncoding=utf-8";
		username = "trackingio";
		password = "trackingio";
	}

	public static TkioStreamDBUtil newInstance() {
		if (dbUtil == null) {
			dbUtil = new TkioStreamDBUtil();
		}
		return dbUtil;
	}

	public static TkioStreamDBUtil newInstanceTrack() {
		dbUtil = new TkioStreamDBUtil("tack");
		return dbUtil;
	}

	public Connection getConn() {
		Connection conn = null;
		try {
			Class.forName(driverClass);
			conn = DriverManager.getConnection(url, username, password);
		} catch (ClassNotFoundException e) {
			logger.error(e.getMessage(), e);
		} catch (SQLException e) {
			logger.error(e.getMessage(), e);
		}
		
		return conn;
	}
	

	
	public ResultSet query(String sql) {
		Connection conn = getConn();
		Statement statement = null;
		ResultSet rs = null;
		try {
			statement = conn.createStatement();
			rs = statement.executeQuery(sql);
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return rs;
	}
	public void release(ResultSet rs,PreparedStatement pstmt, Connection conn) {
		try {
			if (rs != null) {
				rs.close();
				rs = null;
			}
		} catch (SQLException e) {
			logger.error(e.getMessage(), e);
		} finally {
			try {
				if (pstmt != null) {
					pstmt.close();
					pstmt = null;
				}
			} catch (SQLException e) {
				logger.error(e.getMessage(), e);
			} finally {
				try {
					if (conn != null) {
						conn.close();
						conn = null;
					}
				} catch (SQLException e) {
					logger.error(e.getMessage(), e);
				}
			}
		}
	}

	public JdbcTemplate getTkioJdbcTemplate(){
		DriverManagerDataSource dataSource = new DriverManagerDataSource();
		//加载数据库驱动
		dataSource.setDriverClassName(driverClass);
		dataSource.setUrl(url);
		dataSource.setUsername(username);
		dataSource.setPassword(password);
		return new JdbcTemplate(dataSource);
	}
}
