package com.reyun.util.http;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.reyun.util.IOUtil;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpMethodBase;
import org.apache.commons.httpclient.NameValuePair;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.Map;

/**
 * description:
 *
 * @author nolan
 * @date 31/08/2017
 */
public abstract class AbstractHttpSupport {
    protected HttpMethodBase httpMethodBase;

    public AbstractHttpSupport(HttpMethodBase httpMethodBase) {
        this.httpMethodBase = httpMethodBase;
    }


    public AbstractHttpSupport withHeader(String name, String value) {
        this.httpMethodBase.addRequestHeader(name, value);
        return this;
    }

    public AbstractHttpSupport withParamers(NameValuePair[] paramer) {
        this.httpMethodBase.setQueryString(paramer);
        return this;
    }

    public String toResultAsString() {
        this.httpMethodBase.releaseConnection();

        HttpClient httpClient = new HttpClient();
        ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
        try {
            httpClient.executeMethod(this.httpMethodBase);
            IOUtil.copy(this.httpMethodBase.getResponseBodyAsStream(), byteArrayOutputStream);
        } catch (IOException e) {
            e.printStackTrace();
        }
        return new String(byteArrayOutputStream.toByteArray());
    }

    public Map toResultAsMap() {
        try {
            return new ObjectMapper().readValue(toResultAsString(), Map.class);
        } catch (IOException e) {
            return null;
        }
    }

    public <T> T toResult(Class<T> klass) {
        try {
            return new ObjectMapper().readValue(toResultAsString(), klass);
        } catch (IOException e) {
            return null;
        }
    }
}


