(function() {
    'use strict';

    angular.module("app")
        .factory("ToolService", ["$rootScope", "$timeout", "UtilService", "$filter", "$location", "HttpService", toolservice]);

    function toolservice($rootScope, $timeout, UtilService, $filter, $location, HttpService) {
        var service = {},
            that = $rootScope,
            rootmenu = { "dash": $filter('translate')("仪表盘"), "admonitor": $filter('translate')("报表"),"monetization": $filter('translate')("流量变现"),"lifecycle": $filter('translate')("用户生命周期"), "tool": $filter('translate')("工具"), "export": $filter('translate')("数据导出"), "promotionManagement": $filter('translate')('推广管理'),"config": $filter('translate')('配置'), "server": $filter('translate')("高级服务") },
            menu = {
                "dashboard": $filter('translate')("总览"),
                "realtime": $filter('translate')("实时"),
                "campaigninfo": $filter('translate')("推广活动详情"),
                "remarketing":$filter('translate')("再营销活动详情"),
                "advertisinginfo":$filter('translate')("投放广告详情"),
                "funnelinfo":$filter('translate')("事件转化漏斗"),
                "keyword": $filter('translate')("SEM推广详情"),
                "channeleffect": $filter('translate')("渠道效果对比"),
                "attribute": $filter('translate')("归因查询"),
                "effectevaluate": $filter('translate')("激活延迟分析"),
                "roi": $filter('translate')("注收比"),
                "campaign": $filter('translate')("推广活动管理"),
                "campgroup": $filter('translate')("推广活动组管理"),
                "datacb": $filter('translate')("推广回调管理"),
                "logexport": $filter('translate')("日志导出"),
                "logdump": $filter('translate')("日志地址"),
                "logtool": $filter('translate')("日志流"),
                "report": $filter('translate')("下载报表"),
                "subcampaign": $filter('translate')("子活动导出"),
                "app": $filter('translate')("产品中心"),
                "auth": $filter('translate')("成员管理"),
                "authrole": $filter('translate')("权限管理"),
                "channel": $filter('translate')("渠道管理"),
                "systemparam": $filter('translate')("推广参数管理"),
                "packageinfo": $filter('translate')("分包推广详情"),
                "asmeffectevaluate": $filter('translate')("ASM延迟归因"),
                "fakepage": $filter('translate')("防作弊卫士"),
                "fakedec": $filter('translate')("指标详情"),
                "fake": $filter('translate')("数据汇总"),
                "subchannel": $filter('translate')("子渠道管理"),
                "customevent": $filter('translate')("埋点管理"),
                "castaccount": $filter('translate')("投放账号"),
                "customchannel": $filter('translate')("自定义渠道管理"),
                "dataCallback": $filter('translate')("数据回调"),
                "addDataCallback": $filter('translate')("新建回调"),
                "channelmanage": $filter('translate')("渠道管理"),
                "deeplink": $filter('translate')("Deeplink参数配置"),
                "useroverview": $filter('translate')("用户概览"),
                "channeloverview": $filter('translate')("渠道概览"),
                "refluxanalysis": $filter('translate')("回流分析"),
                "lifesettings": $filter('translate')("生命周期设置"),
                "terminalattributes": $filter('translate')("终端属性"),
                "adsenseinfo": $filter('translate')("投放广告"),
                "admobinfo": $filter('translate')("变现广告")


            };
        service.setName = function(name) {
            that.name = name;
        }
        service.getName = function() {
                return that.name;
            }
            /*service.isDemoUser = function(){
                return (UtilService.getCookie("ryioUname") == 'demo@reyun.com');
            }*/
        service.isUser = function(userEmail) {
            return UtilService.getCookie("ryioUname") === userEmail;
        }
        service.getChannelCampaignList = function() {
            var list = [
                { id: "channel", name: $filter('translate')("渠道") },
                { id: "campgroup", name: $filter('translate')("活动组") },
                { id: "campaign", name: $filter('translate')("活动") }
            ];
            return UtilService.cloneJSON(list);
        }
        service.getPackTypeList = function() {
            var list = [
                { id: "all", name: $filter('translate')("全部") },
                { id: "APPMARKET", name: $filter('translate')("分包") },
                { id: "ADVERTISING", name: $filter('translate')("分链接") }
            ];
            return UtilService.cloneJSON(list);
        }
        service.getadvPackTypeList = function() {
            var list = [
                { id: "all", name: $filter('translate')("全部") },
                { id: "ADVERTISING", name: $filter('translate')("分链接") },
                { id: "APPMARKET", name: $filter('translate')("分包分链接") }
            ];
            return UtilService.cloneJSON(list);
        }
        service.getDeviceTypeList = function() {
                var list = [
                    { id: "device", name: $filter('translate')("按设备看") },
                    { id: "user", name: $filter('translate')("按账号看") }
                ];
                return UtilService.cloneJSON(list);
            }
            /**
             * [getChannelCampaignUrl description]
             * @param  type
             * @param  appid
             * @param cid 渠道ID
             * @return
             */
        service.getChannelCampaignParams = function(type, appid, cid) {
                var url = "",
                    txt = "";
                if (type == 'channel') { //渠道
                    url = appid + "/channel/findall?delflag=1";
                    txt = $filter('translate')("渠道");
                } else if (type == 'campgroup') { //活动组
                    url = appid + "/campgroup/findall";
                    txt = $filter('translate')("活动组");
                } else if (type == 'campbychannel') { //应用渠道下的活动
                    url = appid + "/campaign/findbychannel?channelid=" + cid;
                    txt = $filter('translate')("活动");
                } else {
                    url = appid + "/campaign/findall";
                    txt = $filter('translate')("活动");
                }
                return {
                    url: url,
                    txt: txt
                };
            }
            /**
             * [getParams description]
             * @param  {[type]} obj  一般为$scope
             * @param  {[type]} flag  1:有渠道、活动组、活动筛选
             * @return {[type]}      [description]
             */
        service.getParams = function(obj, flag) {
            var params = { appid: obj.appid };
            if (obj.date) {
                params.startdate = obj.date.startDate;
                params.enddate = obj.date.endDate;
            }
            if (flag && flag == 1 && obj.typeInfoIds != "" && obj.typeInfoIds != -1) {
                {
                    switch (obj.typeId) {
                        case "campgroup":
                            params.cgroupid = obj.typeInfoIds;
                            break;
                        case "campaign":
                            params.campaignid = obj.typeInfoIds;
                            break;
                        case "channel":
                        default:
                            params.cid = obj.typeInfoIds;
                            break;
                    }
                }
            }
            return params;
        }
        service.getOneColors = function() {
            return ["#1fb9e9"];
        }
        service.getTwoColors = function() {
            return ["#1fb9e9", "#f8a20f"];
        }
        service.getThreeColors = function() {
            return ["#1fb9e9", "#f8a20f", "#8e6eb6"];
        }
        service.getSixColors = function() {
            return ["#1fb9e9", "#f8a20f", "#8e6eb6", "#9cc272", "#f36e55", "#00b37f"];
        }
        service.getTenColors = function() {
            return ["#1fb9e9", "#f8a20f", "#00b37f", "#f36e55", "#5c9eff", "#fccc01", "#9cc272", "#ec407a", "#8e6eb6", "#cddc39"];
        }
        service.getToday = function() {
            return {
                startDate: UtilService.getDay(0),
                endDate: UtilService.getDay(0)
            }
        }
        service.getYesDay = function() { 
            return {
                startDate: UtilService.getDay(-1),
                endDate: UtilService.getDay(-1)
            }
        }
        service.getTomorrowDay = function() { 
            return {
                startDate: UtilService.getDay(1),
                endDate: UtilService.getDay(1)
            }
        }
        service.getLastDays = function(d, flag) {
            if (angular.isUndefined(flag)) { //默认最大显示昨天
                flag = -1;
            } else {
                if (d > 0) {
                    d -= 1;
                } else {
                    d += 1;
                }
            }

            return {
                startDate: UtilService.getDay(d),
                endDate: UtilService.getDay(flag)
            }
        }
        service.getLastWeeks = function(d) {
            var w = UtilService.getNowWeekNum(),
                date = new Date(),
                year = date.getFullYear();

            var range = { end: year + UtilService.getStr(w) },
                pd = d + w + 1;
            if (pd > 0) {
                range.start = year + UtilService.getStr(pd);
            } else {
                var pr = UtilService.getYearWeekCount(year - 1);
                range.start = (year - 1) + UtilService.getStr(pr + pd);
            }
            return range;
        }
        service.getLastMonths = function(d) {
            var date = new Date(),
                year = date.getFullYear(),
                month = date.getMonth() + 1;

            var range = { end: year + UtilService.getStr(month) },
                pm = month + d + 1;
            if (pm > 0) {
                range.start = year + UtilService.getStr(pm);
            } else {
                range.start = (year - 1) + UtilService.getStr(12 + pm);
            }
            return range;
        }

        service.getStringTypes = function() {
            return [
                { "id": "=", "name": "=" },
                { "id": "!=", "name": "≠" },
                { "id": "in", "name": "in", "more": true },
                { "id": "not in", "name": "not in", "more": true }
            ]
        }
        service.getNumberTypes = function() {
            return [
                { "id": ">", "name": ">" },
                { "id": ">=", "name": ">=" },
                { "id": "=", "name": "=" },
                { "id": "<=", "name": "<=" },
                { "id": "<", "name": "<" },
                { "id": "between", "name": "between", "both": true }
            ]
        }

        //loading加载
        service.showLoading = function() {
            document.getElementById("sysLoad").style.display = "block";
        }
        service.hideLoading = function() {
                document.getElementById("sysLoad").style.display = "none";
            }
            //显示灰色背景
        service.showAlp = function() {
            document.getElementById("alpLoad").style.display = "block";
        }
        service.hideAlp = function() {
            document.getElementById("alpLoad").style.display = "none";
        }

        //删除等操作提示
        service.showTips = function(msg, time) {
            service.hideLoading();
            var t = 1200;
            if (msg.length > 10) {
                t = 2000;
            }
            time = time || t;
            $rootScope.operShow = true;
            $rootScope.operMsg = msg;
            $timeout(function() {
                service.hideTips();
            }, time);
        }
        service.hideTips = function() {
            $rootScope.operShow = false;
            $rootScope.operMsg = "";
        }

        service.getMenuTip = function(name) {
            var tip = $rootScope.currentPageTips[name];
            if (!tip) {
                tip = $filter('translate')("无");
            }
            return tip;
        }

        service.getMenuTipNew = function(name, desc) {
            var tip = desc
            if (name){
                tip = $rootScope.currentPageTips[name];
                if (!tip) {
                    tip = $filter('translate')("无");
                }
            }
            return tip;
        }

        //计算漏斗数据格式
        service.getFunnelData = function(fdata, chartKey, chartKeyName) {
            var rmd = new Date().getTime();
            if (angular.isUndefined(fdata)) {
                fdata = {};
            }
            var users = [],
                rates = [],
                marks = [],
                preu = -1;
            chartKeyName.filter(function(key) {
                var u = fdata[key],
                    r = fdata['rate_' + key];
                u = angular.isUndefined(u) ? 0 : u;
                r = angular.isUndefined(r) ? 0 : r;
                users.push(u);
                rates.push(r);

                if (preu > -1) {
                    if (preu == 0) {
                        marks.push(0);
                    } else {
                        marks.push(UtilService.decimal2(u / preu * 100));
                    }
                }
                preu = u;
            });

            var data = {
                val: [rates, users],
                trans4last: marks,
                key: chartKey,
                rmd: ++rmd
            };
            var rateData = data.val[0],
                rateData1 = [],
                preRate = 0;
            for (var i = 0; i < rateData.length; i++) {
                var r = preRate - rateData[i];
                if (preRate > 0) {
                    // r = r / preRate  * preRate;
                } else {
                    r = 0;
                }
                rateData1.push(r); //转化率
                preRate = rateData[i];
            }
            data.val.splice(1, 0, rateData1);

            return data;
        }

        service.noDataChart = function() {
                var rmd = new Date().getTime();
                return {
                    val: [],
                    trans4last: [],
                    key: [],
                    rmd: ++rmd,
                    name: []
                };
            }
            /**
             *
             * @param  {[type]} type   funnel:漏斗
             *                         customretention:自定义留存
             *                         detailcustomretention:自定义留存明细,
             *                         commonretention:固定留存
             *                         eventstats:事件
             *                         normal:普通
             */
        service.getChartConditions = function(name, reportname, params, type, id) {
                if (UtilService.isNullStr(type)) { type = "normal"; }

                var appid = params.appid,
                    newparams = UtilService.cloneJSON(params);
                var subType = params.viewtype || "";
                delete newparams.appid;
                var condition = {
                    reportName: reportname,
                    conditions: JSON.stringify(newparams),
                    functionType: type,
                    subType: subType,
                    app: appid,
                    name: name
                };
                if (!UtilService.isNullStr(id)) {
                    condition.functionId = id;
                }
                return condition;
            }
            //计算字节长度
        service.getByteLen = function(col) {
                var templen = 0;
                for (var i = 0; i < col.length; i++) {
                    var a = col.charAt(i);
                    if (a.match(/[a-zA-Z\u4e00-\u9fa5]/) != null) {
                        templen += 2;
                    } else {
                        templen += 1;
                    }
                }
                return templen;
            }
            //计算table列宽
        service.getTableColsWidth = function(cols, flag, count, noleft) {
            var colsStyle = [];
            var leftw = noleft ? 50 : ($rootScope.unfoldFlag ? 90 : 230);
            var tablew = flag ? (($(document).width() - 10 - leftw) / (count ? count : 2) - (count == 3 ? 48 : 45)) : ($(document).width() - leftw),
                colsw = 0;
            var specialCols = $filter('translate')("推广活动,推广活动组,渠道,子渠道,子账号,关键字,创意,付费激活周期,广告位,计划,流量来源,广告组,广告计划,广告创意");
            angular.forEach(cols, function(col) {
                var templen = service.getByteLen(col);
                var colw = specialCols.indexOf(col) > -1 ? 240 : col == $filter('translate')("日期") ? (flag != 'day' ? 160 : 90) : col == $filter('translate')('分组') ? 150 : (8 * templen + (flag ? 13 : 27));
                if (col === $filter('translate')('点击作弊激活总数')) colw += 20;
                if (col === $filter('translate')('投放账号ID')) colw += 30;
                if (col === $filter('translate')('广告组ID')) colw += 60;
                
                var colStyle = { 'width': colw + 'px', 'max-width': colw + 'px' };
                colsw += colw;
                colsStyle.push(colStyle);

            });
            if (colsw < tablew) {
                // var leftw = $rootScope.unfoldFlag?90:$rootScope.unfoldFlag==false?230:270;
                // tablew = $(window).width()-leftw;
                // if(flag){
                //     tablew = (tablew-10)/2-45;
                // }
                var diffw = tablew - 2 - colsw,
                    collen = colsStyle.length,
                    coldiffw = (diffw - 12 * collen) / collen;
                angular.forEach(colsStyle, function(col) {
                    var ocolw = parseInt(col.width.slice(0, -2));
                    col.width = col['max-width'] = Math.round(ocolw + coldiffw) + 'px';
                });
            }
            return colsStyle;
        }

        service.getCMidInfo = function() {
            var cid = localStorage.getItem("rytf_cid"),
                campaignid = localStorage.getItem("rytf_campid");

            if (UtilService.isNullStr(cid)) {
                cid = -1;
                campaignid = '_default_';
            }
            return {
                cid: cid,
                campaignid: campaignid
            };
        }
        service.getRoleName = function() {
            if ($rootScope.isSuper) {
                return $filter('translate')("主账号");
            } else if ($rootScope.isManage) {
                return $filter('translate')("管理员");
            } else if ($rootScope.isAppManage) {
                return $filter('translate')("子应用管理员");
            } else if ($rootScope.isChannelU) {
                return $filter('translate')("渠道账号");
            } else {
                return $filter('translate')("自定义权限");
            }
        }
        service.getUser = function() {
            var u = localStorage.getItem("ry_user");

            if (UtilService.isNullStr(u)) {
                return {};
            } else {
                return JSON.parse(u);
            }
        }

        //菜单报送数据
        service.getMenuSubmitData = function(submenu) {
                if ($rootScope.pagePath == "userinfo") return;
                var cmids = service.getCMidInfo();
                var company = service.getUser().company;
                if (UtilService.isNullStr(company)) {
                    company = "";
                }

                var appkey = "",
                    appcategory = "",
                    appname = "",
                    rootmenukey;
                if ($rootScope.appInstance) {
                    appkey = $rootScope.appInstance.appkey;
                    appcategory = $rootScope.appInstance.appGenreName;
                    appname = $rootScope.appInstance.name;
                }
                if (!submenu || submenu == '') { submenu = menu[$rootScope.pagePath]; }
                for (var m in that.menus) {
                    if (that.menus[m].indexOf($rootScope.pagePath) > -1) {
                        rootmenukey = m;
                    }
                }
                var params = {
                    appid: UtilService.getTKAppkey(),
                    who: UtilService.getCookie("ryioUname"),
                    what: "pageview",
                    context: {
                        rootmenu: rootmenu[rootmenukey], //菜单分类
                        menu: menu[$rootScope.pagePath], //当前菜单
                        submenu: submenu, //子菜单-看单
                        sessionid: UtilService.getCookie("JSESSIONID"),

                        user_appkey: appkey, //所选APP的id,
                        appcategory: appcategory, //应用类型  中文名
                        appname: appname, //应用名称
                        rolename: service.getRoleName(),
                        company: company,

                        "_cid": cmids.cid,
                        "_campaignid": cmids.campaignid,
                        "_apptype": "wap",

                        email: UtilService.getCookie("ryioUname"),
                        _deviceid: UtilService.randDeviceId(), //设备ID
                        operatesystem: UtilService.operatorSystem(), //操作系统  _ryos
                        browser: UtilService.getBrowser() //浏览器类型
                    }
                };
                $.post(UtilService.getLogRoot() + "/receive/tkio/event", JSON.stringify(params));
            }
            //功能报送数据
        service.getOperSubmitData = function(opername) {
                var appkey = "",
                    appcategory = "",
                    appname = "";
                if ($rootScope.appInstance) {
                    appkey = $rootScope.appInstance.appkey;
                    appcategory = $rootScope.appInstance.appGenreName;
                    appname = $rootScope.appInstance.name;
                }

                var cmids = service.getCMidInfo();
                var company = service.getUser().company;
                if (UtilService.isNullStr(company)) {
                    company = "";
                }

                var params = {
                    appid: UtilService.getTKAppkey(),
                    who: UtilService.getCookie("ryioUname"),
                    what: "operation",
                    context: {
                        menu: menu[$rootScope.pagePath], //菜单分类
                        opername: opername, //操作名字

                        email: UtilService.getCookie("ryioUname"),
                        user_appkey: appkey, //所选APP的id,
                        appcategory: appcategory, //应用类型  中文名
                        appname: appname, //应用名称
                        rolename: service.getRoleName(),
                        company: company,

                        "_cid": cmids.cid,
                        "_campaignid": cmids.campaignid,
                        "_apptype": "wap",

                        _deviceid: UtilService.randDeviceId(), //设备ID
                        operatesystem: UtilService.operatorSystem(), //操作系统  _ryos
                        browser: UtilService.getBrowser() //浏览器类型
                    }
                };
                $.post(UtilService.getLogRoot() + "/receive/tkio/event", JSON.stringify(params));
            }
            //自定义报送
        service.sendWhatEvtData = function(what, jsonparams) {
            var appkey = "",
                appcategory = "",
                appname = "";
            if ($rootScope.appInstance) {
                appkey = $rootScope.appInstance.appkey;
                appcategory = $rootScope.appInstance.appGenreName;
                appname = $rootScope.appInstance.name;
            }

            var cmids = service.getCMidInfo();
            var company = service.getUser().company;
            if (UtilService.isNullStr(company)) {
                company = "";
            }

            var params = {
                appid: UtilService.getTKAppkey(),
                who: UtilService.getCookie("ryioUname"),
                what: what,
                context: {
                    email: UtilService.getCookie("ryioUname"),
                    user_appkey: appkey, //所选APP的id,
                    appcategory: appcategory, //应用类型  中文名
                    appname: appname, //应用名称
                    rolename: service.getRoleName(),
                    company: company,

                    "_cid": cmids.cid,
                    "_campaignid": cmids.campaignid,
                    "_apptype": "wap",

                    _deviceid: UtilService.randDeviceId(), //设备ID
                    operatesystem: UtilService.operatorSystem(), //操作系统  _ryos
                    browser: UtilService.getBrowser() //浏览器类型
                }
            };
            if (jsonparams) {
                for (var k in jsonparams) {
                    params.context[k] = jsonparams[k];
                }
            }

            $.post(UtilService.getLogRoot() + "/receive/tkio/event", JSON.stringify(params));
        }

        //自定义报送
        service.sendWhatEvtData = function(what, jsonparams) {
            var appkey = "",
                appcategory = "",
                appname = "";
            if ($rootScope.appInstance) {
                appkey = $rootScope.appInstance.appkey;
                appcategory = $rootScope.appInstance.appGenreName;
                appname = $rootScope.appInstance.name;
            }

            var cmids = service.getCMidInfo();
            var company = service.getUser().company;
            if (UtilService.isNullStr(company)) {
                company = "";
            }

            var params = {
                appid: UtilService.getTKAppkey(),
                who: UtilService.getCookie("ryioUname"),
                what: what,
                context: {
                    email: UtilService.getCookie("ryioUname"),
                    user_appkey: appkey, //所选APP的id,
                    appcategory: appcategory, //应用类型  中文名
                    appname: appname, //应用名称
                    rolename: service.getRoleName(),
                    company: company,

                    "_cid": cmids.cid,
                    "_campaignid": cmids.campaignid,
                    "_apptype": "wap",

                    _deviceid: UtilService.randDeviceId(), //设备ID
                    operatesystem: UtilService.operatorSystem(), //操作系统  _ryos
                    browser: UtilService.getBrowser() //浏览器类型
                }
            };
            if (jsonparams) {
                for (var k in jsonparams) {
                    params.context[k] = jsonparams[k];
                }
            }

            $.post(UtilService.getLogRoot() + "/receive/tkio/event", JSON.stringify(params));
        }

        /**
         * params接收页面发来数据
         */
        
        $.get("https://myip.ipip.net/", function(data, status) { //获取用户的外网ip
            if (status == "success") {
                var str = data;
                var startIndex = str.indexOf("IP：");
                var endIndex = str.indexOf("来自于：");
                if (startIndex != -1 && endIndex != -1) {
                    str = str.substring(startIndex + 3, endIndex).trim();
                }
            }
            var scip = str ;
            UtilService.setCookie("cip", scip, 7);
        })



        var params = []
        var paramsMap = {}
            //埋点接口 获取用户pv、uv 、页面按钮点击数
        service.sendBehaviorUv = function(action) {
            service.sendBehavior(null, null, action);
        }
        service.sendBehavior = function(type, menu, action) {
            if (!type || type == "") {
                type = "operate"
            }
            if (!menu) {
                var ui = $location.url();
                var url = $location.absUrl();
                var url2 = url.substring(url.lastIndexOf("/") + 1);
                var surl = url2.substring(0, url2.indexOf("\."));
                if (ui.indexOf("?") != -1) {
                    ui = ui.substring(0, ui.indexOf("\?"));
                }
                menu = ui.substring(ui.lastIndexOf("/") + 1) || surl;
            }
            var key = menu + "-" + type + "-" + action;
            var totalCount = paramsMap[key] || 0;
            if (totalCount == 0) {
                params.push({
                    menu: menu,
                    type: type,
                    action: action
                })
                paramsMap[key] = 1;
            } else {
                paramsMap[key] = totalCount + 1;
            }
            // service.sendBehaviorExec()
        }
        var sendParams = []
        var sendParamsMap = {}
        service.sendBehaviorExec = function() {
            if (params.length != 0) {
                sendParams = params;
                sendParamsMap = paramsMap
                params = [];
                paramsMap = {};
                var cip = UtilService.getCookie("cip") || "";
                var uid = UtilService.getCookie("ryioUid");
                var email = "";
                if (uid) { //uid为空退出状态
                    email = UtilService.getCookie("ryioUname");
                }
                var sendData = [];
                for (var i in sendParams) {
                    var item = sendParams[i];
                    var totalCount = sendParamsMap[item.menu + "-" + item.type + "-" + item.action] || 0
                    if (totalCount > 0) {
                        item.cip = cip;
                        item.email = email;
                        if (item.type == "pv") {
                            item.totalCount = totalCount;
                            sendData.push(item);
                        } else {
                            var isHave = false;
                            for (var s in sendData) {
                                var d = sendData[s];
                                if (d.type == item.type && d.menu == item.menu) {
                                    d.data.push({ "name": item.action, "count": totalCount })
                                    isHave = true;
                                    break;
                                }
                            }
                            if (!isHave) {
                                item.data = [{ "name": item.action, "count": totalCount }]
                                delete item.action;
                                sendData.push(item)
                            }
                        }

                    }
                }
                for (var i in sendData) {
                    var item = sendData[i];
                    item.data = JSON.stringify(item.data);
                    // console.log(JSON.stringify(item))
                    $.post("/api/ClickMonitor/click", item, function(data) {

                    })
                }
            }

        }

        setInterval(function() {
            service.sendBehaviorExec()
        }, 10000)

        service.sendBehavior("pv");
        service.detailSort = function(data) {
                /**
                 *  sysType:系统类型
                 *  tagCount：标签数量1(<5),2(>=5) 取字段tag_cnt_mark
                 *  mark：设备新旧标志 1新设备 2旧设备 取字段：new_mark
                 * @type {string[]}
                 */
                var sysType = ['iOS', 'Android'],
                    tagCount = [1, 2],
                    mark = [1, 2];
                var retList = [];
                for (var i = 0; i < sysType.length; i++) {
                    for (var j = 0; j < tagCount.length; j++) {
                        for (var y = 0; y < mark.length; y++) {
                            // var isOk = false;
                            for (var z = 0; z < data.length; z++) {
                                var item = data[z];
                                if (item.platform === sysType[i] && item.tag_cnt_mark === tagCount[j] && item.new_mark === mark[y]) {
                                    // item.priceNew = service.countPrice(item);
                                    retList.push(item);
                                    // isOk = true;
                                    continue;
                                }
                            }
                            // !isOk && retList.push([]);
                        }
                    }
                }
                return retList;
            }
            /**
             *
             * @param item
             * @returns {number}
             */
        service.countPrice = function(item) {
                var hobby = item.hobbyLabel,
                    pay = item.payLabel,
                    weights = item.weights;
                var priceList = [];
                var sysType = ['iOS', 'Android'],
                    tagCount = [1, 2],
                    mark = [1, 2];
                for (var i = 0; i < sysType.length; i++) {
                    for (var j = 0; j < tagCount.length; j++) {
                        for (var y = 0; y < mark.length; y++) {
                            priceList.push(service.charges(tagCount[j], hobby, pay, weights, sysType[i], mark[y]));
                        }
                    }
                }
                return priceList;
            }
            /**
             *
             * @param num 标签数量
             * @param isBase 是否兴趣
             * @param isPay 是否付费&活跃
             * @param isWei 是否兴趣偏好
             * @param sys 系统类型
             * @param newOld 新旧值
             * @returns {number}
             */
        service.charges = function(num, isBase, isPay, isWei, sys, newOld) {
                var price = 0,
                    sysType = ['iOS', 'Android'],
                    pricesAll = [
                        [0.4, 1.0, 0.6],
                        [0.8, 1.0, 0.6]
                    ], //价格表：第一个为标签数<5单价,第二个为标签数>=5时单价。
                    mark = [1, 2];
                var prices = pricesAll[num - 1];
                isBase && (price += prices[0]);
                isPay && (price += prices[1]);
                isWei && (price += prices[2]);
                (sys == sysType[0]) && (price *= 1.2);
                (newOld == mark[1]) && (price *= 0.2);
                return Math.ceil(price * 100) / 100;
            }
            /**
             *  取一个对象的属性集合
             * @param obj
             * @returns {Array}
             */
        service.getKeys = function(obj) {
                var keys = [];
                for (var k in obj) {
                    if (obj.hasOwnProperty(k)) {
                        keys.push(k);
                    }
                }
                return keys;
            }
            /**
             *  取一个对象的属性值集合
             * @param obj
             * @returns {Array}
             */
        service.getValues = function(obj) {
            var values = [];
            try {
                if (typeof obj == 'string') {
                    obj = JSON.parse(obj);
                }
                for (var k in obj) {
                    if (obj.hasOwnProperty(k)) {
                        values.push(obj[k]);
                    }
                }
            } catch (e) {
                console.error("JSON解析字符串出现错误。");
            }
            return values;
        }

        /*service.confirmDelete = function(item,url,message){
            var modalInstance = $uibModal.open({
                templateUrl : '/template/common/delete.html',
                controller : deleteCtrl,
                resolve : {
                    item : function() {
                        return item;
                    },
                    url:function(){
                        return url;
                    },
                    message:function(){
                        return message;
                    }
                }
            });
            modalInstance.result.then(function(result){
                console.log(result);

            },function(reason){
                console.log(reason);
            });
        }*/

        return service;
    }
})();