(function() {
    'use strict';

    angular.module('app')
        .run(['$rootScope', '$state', '$stateParams', 'UtilService', '$templateCache', '$location', '$window', 'ToolService', 'HttpService', 'DateService', '$timeout', '$interval', "$translateCookieStorage", "$translate", "$filter",
            function($rootScope, $state, $stateParams, UtilService, $templateCache, $location, $window, ToolService, HttpService, DateService, $timeout, $interval, $translateCookieStorage, $translate, $filter) {
                if ($rootScope.allowBehavior == 'false') {
                    $scope.goPage('collect.nopower');
                }
                //获取菜单权限
                $.ajaxSettings.async = false;
                $.get('/api/account/authmenus', function(data) {
                    if (data && data.code == 200) {
                        $rootScope.permissionMenus = data.content;
                        $rootScope.notice = data.content.notice.has_auth;
                        $rootScope.document = data.content.document.has_auth;
                    }
                }, "json")
                $.ajaxSettings.async = true;
                $rootScope.$state = $state;
                $rootScope.$stateParams = $stateParams;
                $rootScope.isSuper = $.cookie("ryioIsSuper") == 'true' || $.cookie("ryioIsSuper") == true;
                $rootScope.allowBehavior = $.cookie("ryioAllowBehavior");
                var ryioRole = $.cookie("ryioRole");
                if (ryioRole && ryioRole == '1') { //管理员
                    $rootScope.isManage = true;
                } else if (ryioRole && ryioRole == '2') { //子应用管理员
                    $rootScope.isAppManage = true;
                } else if (ryioRole && ryioRole == '5') { //渠道账号
                    $rootScope.isChannelU = true;
                } else if ((ryioRole && ryioRole == '3') || ryioRole && ryioRole == '4') { //自定义权限和自定义角色
                    $rootScope.isCustomUser = true;
                }
                $rootScope.isall = $rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage;
                if ($rootScope.isall) { //管理员账号跳转该路径
                    $rootScope.firstMeau = '/collect/dashboard';
                    

                } else { //子账号获取账号菜单原先列表
                    var auths = {},
                        needLogin = false;
                    try {
                        // auths = JSON.parse($.cookie("ryioUauth"));
                        auths = JSON.parse(window.localStorage.getItem("ryioUauth")); //账户下，所有产品的页面权限。
                        needLogin = angular.isArray(auths); //旧子账号重新登录获取权限
                    } catch (e) {
                        needLogin = true;
                    }
                    if (needLogin == true) {
                        UtilService.setCookie("ryioUid", "");
                        sessionStorage.setItem("limitInfo", "")
                        window.location.href = "login.html";
                    }
                    for (var k in auths) {
                        auths[k].roleAuthDetailList.push({
                            auth: "campgroup",
                            edit: true,
                            parentAuth: "manage",
                            sort: 112,
                            view: true
                        });
                        auths[k].roleAuthDetailList.push({
                            auth: "userinfo",
                            edit: true,
                            parentAuth: "manage",
                            sort: 111,
                            view: true
                        });
                        auths[k].roleAuthDetailList.push({
                            auth: "app",
                            edit: true,
                            parentAuth: "manage",
                            sort: 120,
                            view: true
                        });
                        //非渠道账号增加channel
                        if (!$rootScope.isChannelU) {
                            auths[k].roleAuthDetailList.push({
                                auth: "channel",
                                edit: true,
                                parentAuth: "manage",
                                sort: 119,
                                view: true
                            });
                        };
                        if (!$rootScope.isChannelU) {
                            auths[k].roleAuthDetailList.push({
                                auth: "customchannel",
                                edit: true,
                                parentAuth: "manage",
                                sort: 1119,
                                view: true
                            });
                        };
                        //高级服务 在所有用户中增加该菜单
                        auths[k].roleAuthDetailList.push({
                            auth: "advancedServices",
                            edit: true,
                            parentAuth: "manage",
                            sort: 121,
                            view: true
                        });
                        //高级服务 在所有用户中增加该菜单
                        auths[k].roleAuthDetailList.push({
                            auth: "crowdAnalysisGuide",
                            edit: true,
                            parentAuth: "manage",
                            sort: 121,
                            view: true
                        });

                        //创意ID批量管理页面 在自定义权限账户中增加权限
                        auths[k].roleAuthDetailList.push({
                            auth: "ckBatchManage",
                            edit: true,
                            parentAuth: "manage",
                            sort: 122,
                            view: true
                        });

                        //创意ID批量上传页面 在自定义权限账户中增加权限
                        auths[k].roleAuthDetailList.push({
                            auth: "ckBatchUpload",
                            edit: true,
                            parentAuth: "manage",
                            sort: 123,
                            view: true
                        });
                        auths[k].roleAuthDetailList.push({
                            auth: "accountauth",
                            edit: true,
                            parentAuth: "manage",
                            sort: 123,
                            view: true
                        });

                        auths[k].roleAuthDetailList.push({
                            auth: "deviceManage",
                            edit: true,
                            parentAuth: "manage",
                            sort: 124,
                            view: true
                        });
                        
                        
                        // if(!$rootScope.isChannelU && !$rootScope.isCustomUser){
                        //     //配置添加菜单：渠道管理
                        //     auths[k].roleAuthDetailList.push({
                        //         auth: "channelmanage",
                        //         edit: true,
                        //         parentAuth: "config",
                        //         sort: 127,
                        //         view: true
                        //     });
                        // }
                        if($rootScope.isAppManage){
                            //配置添加菜单：渠道管理
                            auths[k].roleAuthDetailList.push({
                                auth: "channelmanage",
                                edit: true,
                                parentAuth: "config",
                                sort: 127,
                                view: true
                            });
                            auths[k].roleAuthDetailList.push({
                                auth: "fakedec",
                                edit: true,
                                parentAuth: "senior",
                                sort: 125,
                                view: true
                            });
                            auths[k].roleAuthDetailList.push({
                                auth: "fakepage",
                                edit: true,
                                parentAuth: "senior",
                                sort: 126,
                                view: true
                            });
                            
                            //配置添加菜：Deeplink参数配置
                                auths[k].roleAuthDetailList.push({
                                    auth: "deeplink",
                                    edit: true,
                                    parentAuth: "config",
                                    sort: 129,
                                    view: true
                            });
                            //配置添加菜：埋点管理
                            auths[k].roleAuthDetailList.push({
                                auth: "customevent",
                                edit: true,
                                parentAuth: "config",
                                sort: 128,
                                view: true
                            });
                             //配置添加菜：埋点管理
                             auths[k].roleAuthDetailList.push({
                                auth: "remarketing",
                                edit: true,
                                parentAuth: "admonitor",
                                sort: 130,
                                view: true
                            });
                        }
                        auths[k].roleAuthDetailList.sort(function(a, b) {
                            return a.sort > b.sort ? 1 : -1;
                        });
                    }
                    $rootScope.roleAuth = auths;
                }
                var userID = UtilService.getCookie("ryioUid");
                
                //判断投放广告详情是否显示
                var getAdvInfo = function(){
                    var adUrl = HttpService.getInfo("mng/auth/getAuth?account="+userID+"");
                    adUrl.then(function(data){
                        if(data && data.code == "200"){
                            $rootScope.showAdvertisinginfo = false;
                            $rootScope.showMonetizationInfo = false;
                            $rootScope.showServeridbackflow = false;
                            $rootScope.showDataCallback = false;
                            
                        }else{
                            $rootScope.showAdvertisinginfo = data.advertisinginfo;
                            $rootScope.showMonetizationInfo = data.monetization;
                            $rootScope.showServeridbackflow = data.serveridbackflow;
                            $rootScope.showDataCallback = data.dataCallback;
                        }
                    })
                }
                getAdvInfo();

                var flowPM = HttpService.getInfo("mng/accountRestrict/find/" + userID);
                var flowMonitoring = function() {
                    var f = HttpService.getInfoByUrl("/api/login/limit/flow/tip");
                    f.then(function(data) {
                        $rootScope.trafficReminderShow = data.show;
                        $rootScope.trafficReminderTip = data.tip || '';
                        $rootScope.trackAll = parseInt(data.track_limit / 1000); //track总量
                        $rootScope.trackUsed = parseInt(data.track_flow_total / 1000); //track用量
                        $rootScope.trackSurplus = parseInt($rootScope.trackAll - $rootScope.trackUsed); //track剩余
                        if ($rootScope.trackLimit != -1 && $rootScope.trackSurplus <= 0 && !$rootScope.isChannelU && !$rootScope.flowRestrict) {
                            window.location.href = "index.html#/collect/expiration";
                            return false;
                        }
                    })
                };
                var queryFlow = function() {
                    flowPM.then(function(data) {
                        $rootScope.flowName = data.packageName; //套餐名称
                        $rootScope.flowLevel = data.priceLevel; //套餐级别
                        if (data.flowRestrict == true) { //是否是受限用户  true是
                            $rootScope.flowRestrict = false;
                        } else {
                            $rootScope.flowRestrict = true;
                        }
                        /*if ($rootScope.flowLevel <= 4 || $rootScope.flowLevel >= 14) {
                          $rootScope.byflow = true;
                        } else {
                          $rootScope.byflow = false;
                        }  //小于4大于等于14是流量用户，大于是包年*/
                        $rootScope.trackLimit = data.trackLimit;
                        if (data.trackLimit != -1) {
                            flowMonitoring();
                            $interval(function() {
                                flowMonitoring();
                            }, 300000)
                            $rootScope.byflow = true; //有限流量用户
                        } else {
                            $rootScope.byflow = false; //无限流量用户
                        }
                        $rootScope.trackAll = parseInt(data.trackLimit / 1000); //track总量
                        $rootScope.trackPercentRel = data.trackRemainPercent;
                        $rootScope.trackPercent = (1 - data.trackRemainPercent); //track使用百分比

                        $rootScope.trackUsed = parseInt(data.trackTotalFlow / 1000); //track用量
                        $rootScope.trackRemainDay = parseInt(data.trackRemainingDays); //track能用天数
                        $rootScope.trackAlert = data.trackFlowNotified; //track用量提醒
                        $rootScope.trackDateAlert = data.trackPastTimeNotified; //track到期提醒

                        $rootScope.packageLimit = parseInt(data.packageLimit / 1000); //抖音 总流量
                        $rootScope.packageTotalFlow = parseInt(data.packageTotalFlow / 1000); //抖音 已使用流量
                        $rootScope.packageFlowId = data.packageFlowId; //抖音 流量包id
                        $rootScope.packagePercent = data.packageFlowPercent; //抖音流量包使用百分比

                        $rootScope.showPackageFlow = false
                        if(data.packageFlowId && data.packageFlowId != -1){
                            $rootScope.showPackageFlow = true
                            $rootScope.showpackageLimit = '+ 流量包'
                        }


                        // $rootScope.userPastDate = data.pastDate; //过期时间
                        $rootScope.userPastDate = UtilService.getCookie("ryioPastDate"); //过期时间
                        var todayDate = DateService.getToday().startDate; //今天日期
                        $rootScope.pastLong = DateService.getDaysNum($rootScope.userPastDate, todayDate);
                        if (!$rootScope.isSuper && !$rootScope.isChannelU && ($rootScope.pastLong < 0 ||
                                // ($rootScope.behaviorAuth && $rootScope.trackPercentRel <= 0 &&
                                // $rootScope.ioPercentRel <= -0.05 && !$rootScope.flowRestrict) ||
                                ($rootScope.trackPercentRel <= 0 && !$rootScope.flowRestrict))) {
                            var lgPM = HttpService.getInfo("login/logout", {});
                            lgPM.then(function(data) {
                                HttpService.logOutCookie();
                            });
                        }
                    });
                }
                userID && queryFlow();
                // var speMenus = ["app","auth","userinfo","channel","smresult","product","systemparam"];
                var speMenus = ["userinfo", "smresult", "product", "nopower", "expiration","remarketing"];//不需要判断权限的页面
                $rootScope.isaptest = -1;
                
                $rootScope.$on('$stateChangeStart', function(event, next, o, current) {
                  
                    var name = next.name,
                        nextMenu = name.substring(name.indexOf(".") + 1),
                        idd = nextMenu.indexOf("Detail");
                    if (nextMenu == "noaccess") {
                        return false;
                    }
                    var curname = current.name,
                        curMenu = curname.substring(curname.indexOf(".") + 1);
                    if (curname == '' && (nextMenu == 'nopower')) {
                        window.location.href = "index.html";
                        return false;
                    }
                    var mname = nextMenu ? nextMenu : curMenu;
                    if(mname == "dashboard"){
                        $rootScope.showDashboardTip = true;
                        var flag = localStorage.getItem('OfflineTip');
                        $rootScope.showOfflineTip = flag == 'show'? true : false;

                    }else{
                        $rootScope.showDashboardTip = false;
                        $rootScope.showOfflineTip = false;
                    }
                    var nextDo = function() {
                        var isUnfoldFlag = UtilService.getCookie("unfoldFlag");
                        if (isUnfoldFlag) {
                            $rootScope.unfoldFlag = isUnfoldFlag == "false" ? false : true;
                        }
                        document.getElementById("sysLoad").style.display = "none";
                        document.getElementById("alpLoad").style.display = "none";
                        if (idd > -1) {
                            nextMenu = nextMenu.substring(0, idd);
                        }

                        var submenu = "",
                            submenuDir = {
                                'subcampaignlist': $filter('translate')("子活动"),
                                'onelink': "onelink",
                                'subpackage': $filter('translate')('分包推广'),
                                'downloadurl': $filter('translate')("下载地址管理"),
                                'activityevent': $filter('translate')("虚拟事件"),
                                'subchannel': $filter('translate')("子渠道管理")
                            };
                        if (nextMenu == 'subcampaignlist' || nextMenu == 'onelink' || nextMenu == 'downloadurl' || nextMenu == 'subpackage' || nextMenu == 'subchannel') {
                            submenu = nextMenu;
                            nextMenu = 'campaign';
                        } else if (nextMenu == 'channelAdd' || nextMenu == 'channelSm' || nextMenu == 'channelAdwords') {
                            nextMenu = 'channel';
                        } else if (nextMenu == 'activityevent') {
                            submenu = nextMenu;
                            nextMenu = 'event';
                        } else if (nextMenu == 'authpower') {
                            nextMenu = 'auth';
                        }
                        var web = $rootScope.isweb && $rootScope.webHideMenus.indexOf(nextMenu) > -1;
                        if (nextMenu == '' || nextMenu == 'collect' || web) {
                            if (!$rootScope.firstMeau) {
                                var firstApp = getFirstApp($rootScope.roleAuth);
                                if (firstApp) {
                                    $timeout(function() {
                                        if (!$rootScope.appid) { //首次进入页面已经存在appid时不执行。
                                            $rootScope.$broadcast("mngappTo", firstApp);
                                            $state.go("collect.dashboard");
                                        }
                                    }, 200);
                                } else {
                                    HttpService.logOutCookie();
                                }

                            } else {
                                $location.path($rootScope.firstMeau);
                            }
                            return false;
                        } else if (nextMenu == 'systemparam' && $rootScope.demoU) {

                        } else if (speMenus.indexOf(nextMenu) > -1) {

                        } else if (!$rootScope.isSuper && $rootScope.curRoleAuth && !$rootScope.hasTheMenu(nextMenu)) {
                            var firstMeau = $rootScope.firstMeau,
                                nowmenu = firstMeau.substring(firstMeau.lastIndexOf("/") + 1);
                            $location.path($rootScope.firstMeau);
                            if (nowmenu == $rootScope.pagePath) {
                                $window.location.reload();
                            }
                            return false;
                        }

                        if (speMenus.indexOf(nextMenu) > -1) {
                            $rootScope.backReport = true;
                        } else {
                            $rootScope.backReport = false;
                        }
                        if (nextMenu == 'product' || (nextMenu == 'userinfo' && curMenu == 'product')) {
                            $rootScope.preStatus = true;
                        } else {
                            $rootScope.preStatus = false;
                        }
                        $(".rightWrap").scrollTop(0);
                        //判断流量到期或用尽
                        if ($rootScope.trackLimit != -1 && $rootScope.trackSurplus < 0 && !$rootScope.isChannelU && !$rootScope.flowRestrict) {
                            nextMenu = 'expiration';
                            $rootScope.pagePath = nextMenu;
                            window.location.href = "index.html#/collect/expiration";
                            return false;
                        }
                        $rootScope.pagePath = nextMenu;

                        //是第一次登陆点击显示提示
                        var curUU = ToolService.getUser();
                        if (!curUU.notFirstLogin && ['campaigninfo', 'keyword', 'packageinfo'].indexOf(nextMenu) > -1) {
                            $rootScope.clickshowWin = true;
                        } else {
                            $rootScope.clickshowWin = false;
                        }

                        //看单的子菜单已经报送
                        if (nextMenu == 'fake') {
                            if ($rootScope.fakeType == 1 || $rootScope.fakeType == 2) {
                                ToolService.getMenuSubmitData($filter('translate')("开通防作弊功能"));
                            } else if ($rootScope.fakeType == 3) {
                                ToolService.getMenuSubmitData($filter('translate')("防作弊功能过期"));
                            } else {
                                ToolService.getMenuSubmitData($filter('translate')("未开通防作弊功能"));
                            }
                        } else if (['nopower', 'expiration'].indexOf(nextMenu) == -1) {
                            ToolService.getMenuSubmitData(submenuDir[submenu]);
                        }

                    }
                    if (angular.isDefined($rootScope.byflow)) {
                        if (!$rootScope.limitInfo) {
                            $timeout(function() {
                                nextDo();
                            }, 200);
                        } else {
                            nextDo();
                        }
                    } else {
                        flowPM.then(function() {
                            if (!$rootScope.limitInfo) {
                                $timeout(function() {
                                    nextDo();
                                }, 200);
                            } else {
                                nextDo();
                            }
                        });
                    }

                    //页面权限
                    if ($rootScope.permissionMenus) {
                        var menusKey = next.name.substring(name.indexOf(".") + 1);
                        $translateCookieStorage.put('selectMenu', menusKey);
                        if (menusKey == 'fakedec') {
                            //防作弊卫士下的'指标详情'和'数据汇总'都根据'数据汇总'在office系统是否有权限判断
                            menusKey = 'fake'
                        }
                        var hasMenu = $rootScope.permissionMenus.hasOwnProperty(menusKey);
                        var permiss = hasMenu ? $rootScope.permissionMenus[menusKey].has_auth : true;
                        if (!permiss && hasMenu) {
                            $rootScope.hasPermission = true; //没权限
                            //  event.preventDefault();
                        } else {
                            $rootScope.hasPermission = false
                        }
                    } else {
                        $rootScope.hasPermission = false
                    }
                });



                //清除页面缓存
                var stateChangeSuccess = $rootScope.$on('$stateChangeSuccess', stateChangeSuccess);

                function stateChangeSuccess($rootScope) {
                    $templateCache.removeAll();
                }


                function getFirstApp(obj) {
                    for (var key in obj) {
                        if (key) {
                            return key;
                        }
                    }
                }
                //
                $rootScope.setLang = function(langKeyNum) {
                    var langKey = 'en_US';
                    switch (langKeyNum) {
                        case 0:
                            langKey = 'en_US';
                            $translateCookieStorage.put('lang', "en");
                            break;
                        case 1:
                            langKey = 'zh_CN';
                            $translateCookieStorage.put('lang', 'zh');
                            break;

                    }
                    $translate.use(langKey);
                    $rootScope.getLang();
                }
                $rootScope.setRegion = function(region) {
                        $translateCookieStorage.put('region', region);
                    }
                    //地区默认值
                $rootScope.getRegion = function(region) {
                        return $translateCookieStorage.get("region");
                    }
                    //
                $rootScope.getLang = function() {
                    var ret = 'zh_CN';
                    if ($translateCookieStorage.get('lang') == 'en') {
                        ret = 'en_US';

                    } else if ($translateCookieStorage.get('lang') == null || $translateCookieStorage.get('lang') == 'zh') {
                        ret = 'zh_CN';
                        $translateCookieStorage.put('lang', 'zh');
                    }
                    $rootScope.lang = $translateCookieStorage.get('lang') || 'zh';
                    return ret;
                }
                $rootScope.getLang();
                //

            }
        ])
        /*捕获异常*/
        .config(["$provide", function($provide) {
            $provide.decorator("$exceptionHandler", ['$delegate', function($delegate) {
                return function(exception, cause) {
                    document.getElementById("sysLoad").style.display = "none";
                    if (String(exception).indexOf("$compile:tpload") == -1) {
                        $delegate(exception, cause);
                    }
                }
            }])
        }])
        // .factory('permissions', function ($rootScope) {
        //   页面权限
        //   var permissionList;
        //   return {
        //     setPermissions: function(permissions) {
        //       $rootScope.$broadcast('permissionsChanged')
        //     },
        //     hasPermission: function (permission) {
        //       if(permission){
        //       }
        //     }
        //  };
        // })
        .factory('httpInterceptor', ["$translateCookieStorage", function($translateCookieStorage) {
            var timestampMarker = {
                request: function(config) {
                    var token = $.cookie("ryioToken");
                    config.headers.Authorization = token;
                    config.headers.lang = $translateCookieStorage.get("lang") || 'zh';
                    config.headers.menu = $translateCookieStorage.get("selectMenu") || 'default';
                    config.requestTimestamp = new Date().getTime();
                    config.headers.region = $translateCookieStorage.get("region") || 'ALL'; // 地区对应的报表查询
                    config.timeout = 6000 * 10;
                    return config;
                },
                response: function(response) {
                    response.config.responseTimestamp = new Date().getTime();
                    return response;
                }
            };
            return timestampMarker;
        }])
        /*设置请求header*/
        .config(["$httpProvider", function($httpProvider) {
            $httpProvider.interceptors.push('httpInterceptor');
        }])
        .provider("lang", function() {
            return {
                $get: function() {
                    return {
                        getLang: function() {

                        },
                    };
                }
            }
        })
        .config(["$translateProvider", "$translateCookieStorageProvider", function($translateProvider, $translateCookieStorageProvider) {
            $translateProvider.useStaticFilesLoader({
                prefix: './data/translate/',
                suffix: '.json'
            });

            function getLang() {
                var get = $translateCookieStorageProvider.$get().get,
                    ret = "zh_CN";
                if (get("lang") && get("lang") == "en") {
                    ret = "en_US";
                } else if (get("lang") && get("lang") == 'zh') {
                    ret = "zh_CN";
                }
                return ret;
            }
            $translateProvider.preferredLanguage(getLang());
            $translateProvider.useCookieStorage();
        }]);

})();