(function() {
    var tempVersion = new Date().getTime();

    angular.module("app")
        .directive("flipInfo", ["$filter", "$translate", flipInfo])
        .directive("flipInfoDy", ["$filter", flipInfoDy])
        .directive("pagingQuery", ["ArrayConstant", pagingQuery])
        .directive("selectList", ["ToolService", selectList])
        .directive("selectListBtn", ["ToolService", "$filter", selectListBtn])
        .directive("selectTList", selectTList)
        .directive("selectMoreList", ["$filter", "ToolService", selectMoreList])
        .directive("selectMoreListBtn", ["$filter", "ToolService", selectMoreListBtn])
        .directive("selectParams", ["ToolService", selectParams])
        .directive("delTip", ["$filter", delTip])
        .directive("wincrmTip", ["$filter", wincrmTip])
        .directive("okcrmTip", ['ToolService', okcrmTip])
        .directive("okStyle", ['ToolService', okStyle])
        .directive("stopEvent", stopEvent)
        .directive("minChart", ["OptionService", "$window", "$timeout", "HttpService", "UtilService", "ToolService", "$rootScope", "$filter", "$translate", minChart])
        .directive("maxChart", ["OptionService", "$window", "$timeout", "HttpService", "UtilService", "ToolService", "$rootScope", "$filter", "$translate", maxChart])
        .directive("exportButton", ["HttpService", "UtilService", "ToolService", "$rootScope", "$filter", "$translate", exportButton])
        .directive("ngEnter", ngEnter)
        .directive("popTip", popTip)
        .directive("isLoading", isLoading)
        .directive("dateRange", ["ToolService", "UtilService", "ArrayConstant", "$filter", "$translate", dateRange])
        .directive("selectChannel", ["$state", "$rootScope", "HttpService", "$filter", selectChannel])
        .directive("numberTxt", numberTxt)
        .directive("integerTxt", integerTxt)
        .directive("fixHeader", ["$timeout", fixHeader])
        .directive("helpTip", ["ToolService", "$rootScope", helpTip])
        .directive("helpWinTip", ["ToolService", "$rootScope", "$filter", helpWinTip])
        .directive("noData", [noData])
        .directive("customEvent", ["UtilService", "ToolService", "$timeout", "HttpService", "$rootScope", "$filter", customEvent])
        .directive("fileModel", ["$parse", fileModel])
        .directive("searchGroup", ["$filter", "ToolService", searchGroup])
        .directive("bigTable", ["$timeout", "$compile", bigTable])
        .directive("dragOrder", [dragOrder])
        .directive("noticenews", ["HttpService", "$rootScope", "ToolService", "$timeout", "$state", noticenews])
        .directive("noPermission", ["HttpService", "$rootScope", "ToolService", "$timeout", "$filter", noPermission])
        .directive("checkboxGroup", [checkboxGroup])
        .directive("dragDrop", [dragDrop])
        .directive("dragDropSort", [dragDropSort])
        .directive("qrcode", ["$timeout", qrCode]) //生成二维码指令。
    ;

    function delTip($filter) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/delwin.html?r=' + tempVersion,
            transclude: true,
            scope: {
                delfn: "&",
                status: "=",
                okTitle: "@",
                disabledtime: "="
            },
            link: function($scope, el) {
                var a;
                $scope.$watch('disabledtime', function(n, o) {
                    $scope.disabledtime1 = $scope.disabledtime;
                    if (!$scope.disabledtime) {
                        $scope.disabledtime1 = 0
                    } else {
                        a = setInterval(function() {
                            $scope.disabledtime1--;
                            if ($scope.disabledtime1 <= 0) {
                                $scope.disabledtime = 0;
                                clearInterval(a)
                            }
                            $scope.$apply()
                        }, 1000)
                    }
                });
                $scope.btnname = $scope.okTitle ? $scope.okTitle : "确定"
                $scope.hideWin = function() {
                    $scope.status = false;
                    if ($scope.disabledtime) {
                        $scope.disabledtime = 0;
                        clearInterval(a)
                    }
                }
            }
        }
    }

    function wincrmTip($filter) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/wincrm.html?r=' + tempVersion,
            transclude: true,
            scope: {
                okfn: "&",
                nofn: "&",
                title: "@",
                status: "=",
                okTitle: "@",
                noTitle: "@"
            },
            link: function($scope, el) {
                if (angular.isUndefined($scope.okTitle)) {
                    $scope.okTitle = $filter('translate')("确定");
                }
                if (angular.isUndefined($scope.noTitle)) {
                    $scope.noTitle = $filter('translate')("取消");
                }
                $scope.hideWin = function() {
                    $scope.status = false;
                    $scope.nofn();
                }
                $scope.crmWin = function() {
                    $scope.status = false;
                    $scope.okfn();
                }
            }
        }
    }

    function okcrmTip(ToolService) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/okcrm.html?r=' + tempVersion,
            transclude: true,
            scope: {
                title: "@",
                status: "=",
                okfn: "&"
            },
            link: function($scope, el) {
                $scope.$watch("status", function(n) {
                    if (angular.isDefined(n) && n == true) {
                        ToolService.showAlp();
                    }
                });
                $scope.crmWin = function() {
                    $scope.status = false;
                    ToolService.hideAlp()
                    $scope.okfn();
                }
            }
        }
    }

    function okStyle(ToolService) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/okstyle.html?r=' + tempVersion,
            transclude: true,
            scope: {
                title: "@",
                status: "=",
                okfn: "&"
            },
            link: function($scope, el) {
                $scope.$watch("status", function(n) {
                    if (angular.isDefined(n) && n == true) {
                        ToolService.showAlp();
                    }
                });
                $scope.crmWin = function() {
                    $scope.status = false;
                    ToolService.hideAlp()
                    $scope.okfn();
                }
            }
        }
    }

    function stopEvent() {
        return {
            restrict: "A",
            link: function($scope, el) {
                jQuery(el).on("click", function(event) {
                    event.stopPropagation();
                });
            }
        }
    };

    function selectList(ToolService, $filter) {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: '/template/common/select.html?r=' + tempVersion,
            scope: {
                customTitle: "@",
                meauInfo: '=', //列表数据
                meauName: "=", //初始name，eg:请选择 
                meauId: "@", //select的id
                meauId2: "=", //动态ID
                meauData: "=", //初始选择的id值
                meauRefresh: "=", //强制刷新下拉框 //meauRefresh：子页面更改appid，通过事件流更改该值，表头产品列表刷新显示。
                keyname: "@", //显示名
                keyid: "@", //传递ID
                meauNull: "=", //置空
                meauRed: "=", //红色框
                nosearch: "@", //为true，强制不显示搜索框
                operationSel: "=", //当前sel可否操作
                iconType: "@", //true箭头白色
                meauSpe: "=",
                meauDis: "=",
                searchTextId: "=",
                showDownId: "=",
                meauPlaceholder: "@"
            },
            link: function($scope, $element) {
                $scope.selme = false;
                $scope.meauId = $scope.meauId || $scope.meauId2;

                //type 如果type=1是上报事件 如果type=2是不上报
                $scope.clickMeau = function(meau, type) {
                    if (type == 1) {
                        ToolService.sendBehaviorUv($scope.customTitle);
                    }

                    if (!$scope.operSel || meau[$scope.keyid] == 'pie' && $scope.meauSpe) {
                        if (meau[$scope.keyid] == 'pie' && $scope.meauSpe) {
                            ToolService.showTips($filter('translate')("饼状图只适用于有分组的事件分析。"));
                        } else {
                            ToolService.showTips($filter('translate')("当前选择框不可操作。"));
                        }
                        return;
                    }
                    $scope.currentInfo = meau;
                    $scope.selName = meau[$scope.keyname];
                    $scope.selId = meau[$scope.keyid];
                    $scope.meauRed = false;
                    $scope.$emit($scope.meauId, { info: meau })

                }

                $scope.onSearch = function(searchlitxt) {
                        $scope.$emit($scope.searchTextId, searchlitxt)
                    }
                    //  $scope.clickSearch
                $scope.$watch("operationSel", function(n) {
                    if (angular.isUndefined($scope.operationSel)) {
                        $scope.operSel = true;
                    } else {
                        $scope.operSel = n;
                    }
                });

                $scope.showsearch = $scope.nosearch != 'true';
                if (angular.isUndefined($scope.keyname)) {
                    $scope.keyname = "name";
                }
                if (angular.isUndefined($scope.keyid)) {
                    $scope.keyid = "id";
                }
                $scope.showMenu = function() {
                    if ($scope.meauDis) return;
                    $scope.selme = !$scope.selme;
                    $scope.$emit($scope.showDownId, $scope.searchlitxt)

                }
                $scope.update = function() {
                    if ($scope.meauInfo && angular.isDefined($scope.meauData) && $scope.meauData != -1) {
                        var temp = $scope.meauInfo.filter(function(item) {
                            return item[$scope.keyid] == $scope.meauData;
                        });
                        if (temp.length > 0) {
                            $scope.clickMeau(temp[0], 2);
                        } else {
                            $scope.selName = $scope.meauName;
                            $scope.selId = "";
                        }
                    } else {
                        $scope.selName = $scope.meauName;
                        $scope.selId = "";
                    }
                }
                $scope.$watch("meauData+meauName+meauRefresh", function() {
                    $scope.update();
                });
                $scope.$watch("meauNull", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.selName = $scope.meauName;
                        $scope.selId = "";
                    }
                });
                $scope.$watch("meauInfo", function() {
                    $scope.update();
                }, true);
            }
        }
    };
    //下拉超出500条的时候用
    function selectListBtn(ToolService, $filter) {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: '/template/common/selectBtn.html?r=' + tempVersion,
            scope: {
                meauInfo: '=', //列表数据
                meauName: "=", //初始name，eg:请选择 
                searchTotal: "=", //计算表格的total
                meauId: "@", //select的id
                meauId2: "=", //动态ID
                meauData: "=", //初始选择的id值
                meauRefresh: "=", //强制刷新下拉框
                keyname: "@", //显示名
                keyid: "@", //传递ID
                meauNull: "=", //置空
                meauRed: "=", //红色框
                nosearch: "@", //为true，强制不显示搜索框
                operationSel: "=", //当前sel可否操作
                iconType: "@", //true箭头白色
                meauSpe: "=",
                meauDis: "=",
                searchTextId: "=",
                showDownId: "=",
                customTitle: "@",
                filterfn: "&",
                initTxt: "=",
                initf5: "=",
                list: "=",
                tipMsg: "=",
                clearTxtId: "="
            },
            link: function($scope, $element) {
                $scope.selme = false;
                $scope.meauId = $scope.meauId || $scope.meauId2;
                $scope.clickMeau = function(meau) {
                    ToolService.sendBehaviorUv($scope.customTitle);
                    if (!$scope.operSel || meau[$scope.keyid] == 'pie' && $scope.meauSpe) {
                        if (meau[$scope.keyid] == 'pie' && $scope.meauSpe) {
                            ToolService.showTips("饼状图只适用于有分组的事件分析。");
                        } else {
                            ToolService.showTips("当前选择框不可操作。");
                        }
                        return;
                    }

                    $scope.currentInfo = meau;
                    $scope.selName = meau[$scope.keyname];
                    $scope.selId = meau[$scope.keyid];
                    $scope.meauRed = false;
                    $scope.$emit($scope.meauId, { info: meau })
                }

                $scope.onSearch = function(searchli) {
                    $scope.$emit($scope.searchTextId, searchli)
                }
                if (!$scope.tipMsg) {
                    $scope.tipMsg = $filter('translate')("输入搜索关键词");
                }

                $scope.query = function() {
                    if ($scope.preTxt == $scope.srhTxt) {
                        return false;
                    }
                    $scope.filterfn({ txt: $scope.srhTxt });
                    $scope.preTxt = $scope.srhTxt;
                }
                $scope.$watch("initTxt+initf5+list", function() {
                    $scope.srhTxt = $scope.preTxt = $scope.initTxt || "";
                });

                $scope.doNull = function() {
                        $scope.searchli = "";
                        $scope.query();
                        $scope.$emit($scope.clearTxtId, "clearTxtId")
                    }
                    //  $scope.clickSearch
                $scope.$watch("operationSel", function(n) {
                    if (angular.isUndefined($scope.operationSel)) {
                        $scope.operSel = true;
                    } else {
                        $scope.operSel = n;
                    }
                });

                $scope.showsearch = $scope.nosearch != 'true';
                if (angular.isUndefined($scope.keyname)) {
                    $scope.keyname = "name";
                }
                if (angular.isUndefined($scope.keyid)) {
                    $scope.keyid = "id";
                }
                $scope.showMenu = function() {
                    if ($scope.meauDis) return;
                    $scope.selme = !$scope.selme;
                    $scope.$emit($scope.showDownId, $scope.searchlitxt)
                }

                $scope.update = function() {
                        if ($scope.meauInfo && angular.isDefined($scope.meauData) && $scope.meauData != -1) {
                            if ($scope.searchTotal) {
                                if ($scope.searchTotal.data.length >= 500) {
                                    $scope.showBtn = true
                                    $scope.showSer = false
                                } else {
                                    $scope.showBtn = false
                                    $scope.showSer = true
                                }
                            }

                            var temp = $scope.meauInfo.filter(function(item) {
                                return item[$scope.keyid] == $scope.meauData;
                            });
                            if (temp.length > 0) {
                                $scope.clickMeau(temp[0]);
                            } else {
                                $scope.selName = $scope.meauName;
                                $scope.selId = "";
                            }
                        } else {
                            $scope.selName = $scope.meauName;
                            $scope.selId = "";
                        }

                    }
                    //  $scope.$watch("meauData+meauName+meauRefresh",function(){					
                $scope.$watchGroup(['meauData', 'meauName', 'meauRefresh', 'searchTotal'], function(n, o) {
                    $scope.update();
                });
                $scope.$watch("meauNull", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.selName = $scope.meauName;
                        $scope.selId = "";
                    }
                });
                $scope.$watch("meauInfo", function() {
                    $scope.showBtn = false
                    $scope.showSer = true
                    $scope.update();
                }, true);
            }
        }
    };
    //有分类间隔线的下拉框
    function selectTList() {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: '/template/common/selectT.html?r=' + tempVersion,
            scope: {
                meauInfo: '=', //列表数据
                meauName: "=", //初始name，eg:请选择
                meauId: "@", //select的id
                meauId2: "=", //动态ID
                meauData: "=", //初始选择的id值
                meauType: "=",
                meauRefresh: "=", //强制刷新下拉框
                keyname: "@", //显示名
                keyid: "@", //传递ID
                meauNull: "=", //置空
                meauRed: "=", //红色框
                meauTypekey: "@",
                meauTypename: "@",
                operationSel: "=" //当前sel可否操作
            },
            link: function($scope, $element) {
                if (angular.isDefined($scope.meauTypekey)) {
                    $scope.typeKey = eval($scope.meauTypekey);
                    $scope.typeName = eval($scope.meauTypename);
                }
                $scope.$watch("operationSel", function(n) {
                    if (angular.isUndefined($scope.operationSel)) {
                        $scope.operSel = true;
                    } else {
                        $scope.operSel = n;
                    }
                });
                $scope.selme = false;
                $scope.meauId = $scope.meauId || $scope.meauId2;
                $scope.clickMeau = function(meau) {
                    if (!$scope.operSel) { return false; }

                    $scope.selName = meau[$scope.keyname];
                    $scope.selId = meau[$scope.keyid];
                    $scope.meauRed = false;
                    $scope.$emit($scope.meauId, { info: meau })
                }

                if (angular.isUndefined($scope.keyname)) {
                    $scope.keyname = "name";
                }
                if (angular.isUndefined($scope.keyid)) {
                    $scope.keyid = "id";
                }
                $scope.$watch("meauData+meauName+meauRefresh+meauInfo", function() {
                    if ($scope.meauInfo && angular.isDefined($scope.meauData) && $scope.meauData != -1) {
                        var temp = $scope.meauInfo.filter(function(item) {
                            return item[$scope.keyid] == $scope.meauData && (item.type == $scope.meauType || !$scope.meauType);
                        });
                        if (temp.length > 0) {
                            $scope.clickMeau(temp[0]);
                        } else {
                            $scope.selName = $scope.meauName;
                        }
                    } else {
                        $scope.selName = $scope.meauName;
                    }
                });

                $scope.haslist = function(type) {
                    if (!$scope.meauInfo) { return false; }

                    var bol = false;
                    for (var i = 0; i < $scope.meauInfo.length; i++) {
                        if ($scope.meauInfo[i].type == type || $scope.meauInfo[i].dimensionType == type) {
                            bol = true;
                            break;
                        }
                    }
                    return bol;
                }
                $scope.$watch("searchlitxt", function(n) {
                    if (angular.isUndefined(n) || !n) { return false; }
                    $scope.virtual = "";
                    $scope.nature = "";
                    $scope.meauInfo.filter(function(item) {
                        if (angular.uppercase(item.name).indexOf(angular.uppercase(n)) > -1 && item.type == "virtual") {
                            $scope.virtual = item.type;
                        }
                        if (angular.uppercase(item.name).indexOf(angular.uppercase(n)) > -1 && item.type == "nature") {
                            $scope.nature = item.type;
                        }
                    });
                });
            }
        }
    };

    //多选
    function selectMoreList($filter, ToolService) {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: '/template/common/selectmore.html?r=' + tempVersion,
            scope: {
                meauInfo: '=', //列表数据
                meauName: "=", //初始name，eg:请选择
                meauId: "@", //select的id
                meauData: "=", //初始选择的id值
                meauRefresh: "=", //强制刷新下拉框
                keyname: "@", //显示名
                keyid: "@", //传递ID
                meauRed: "=", //红色框
                meauDis: "=",
                meauNull: "=", //置空
                isshowconfirm: "@",
                searchActiveId: "=",
                showDownId: "=",
                customTitle: "@",
                maxSelectNum: "@",
            },
            link: function($scope, $element) {
                $scope.ischeckall = false;
                $scope.selme = false;

                if (angular.isUndefined($scope.keyname)) {
                    $scope.keyname = "name";
                }
                if (angular.isUndefined($scope.keyid)) {
                    $scope.keyid = "id";
                }

                $scope.clickMeau = function(meau) {
                    $scope.meauRed = false;
                    var idx = $scope.selIDS.indexOf(meau[$scope.keyid]);
                    if ($scope.selIDS.length == 2 && idx == -1 && $scope.keyid == 'itemCode') return;
                    if (idx > -1) {
                        $scope.selIDS.splice(idx, 1);
                        $scope.selNames.splice(idx, 1);
                        $scope.ischeckall = false;
                    } else {
                        $scope.selIDS.push(meau[$scope.keyid]);
                        $scope.selNames.push(meau[$scope.keyname]);
                    }
                }
                $scope.onSearch = function(searchlitxt) {
                    $scope.$emit($scope.searchActiveId, searchlitxt)
                }
                $scope.okSelect = function() {
                    if($scope.maxSelectNum&&!isNaN($scope.maxSelectNum)&&$scope.selIDS.length>$scope.maxSelectNum){
                        ToolService.showTips($filter('translate')("最大选择数量不能超过"+$scope.maxSelectNum));
                        return false;
                    }
                    ToolService.sendBehaviorUv($scope.customTitle);
                    $scope.$emit($scope.meauId, { info: $scope.selIDS.join(",") });
                    $scope.selme = false;
                }
                $scope.$watch("selme", function() {
                    if (!$scope.selme && ($scope.keyid == 'eventName' || $scope.keyid == 'itemCode') && $scope.selIDS) {
                        $scope.$emit($scope.meauId, { info: $scope.selIDS.join(",") });
                    }
                });
                $scope.showMenu = function() {
                    if ($scope.meauDis) return;
                    $scope.selme = true;
                    $scope.$emit($scope.showDownId, $scope.searchlitxt)

                }
                $scope.$watch("meauData+meauName+meauRefresh+meauInfo", function() {
                    $scope.selIDS = [];
                    $scope.selNames = [];
                    $scope.ischeckall = false;
                    if ($scope.meauInfo && angular.isDefined($scope.meauData) && $scope.meauData != -1 &&
                        typeof($scope.meauData) == 'string') {
                        var arr = $scope.meauData.split(",");
                        var temp = $scope.meauInfo.filter(function(item) {
                            return item[$scope.keyid] ? arr.indexOf(item[$scope.keyid].toString()) > -1 : false;
                        });
                        if (temp.length > 0) {
                            angular.forEach(temp, function(item) {
                                $scope.clickMeau(item);
                            })
                        } else {
                            $scope.selName = $scope.meauName;
                        }
                        if (temp.length == $scope.meauInfo.length) {
                            $scope.ischeckall = true;
                            $scope.selName = $scope.meauName;
                        }
                    } else {
                        $scope.selName = $scope.meauName;
                    }
                });

                $scope.$watch("meauNull", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.selNames = [];
                        $scope.selIDS = [];
                        $scope.ischeckall = false;
                        $scope.selName = $scope.meauName;
                        $scope.ischeckseldall = false;
                    }
                });

                $scope.checkAll = function() {
                        $scope.ischeckall = !$scope.ischeckall;
                        $scope.meauInfo.filter(function(meau) {
                            var idx = $scope.selIDS.indexOf(meau[$scope.keyid]);
                            if (!$scope.ischeckall && idx > -1) {
                                $scope.selIDS.splice(idx, 1);
                                $scope.selNames.splice(idx, 1);
                            }

                            if ($scope.ischeckall && idx == -1) {
                                $scope.selIDS.push(meau[$scope.keyid]);
                                $scope.selNames.push(meau[$scope.keyname]);
                            }
                        });
                    }
                    //全选搜索结果
                $scope.checkSelectedAll = function() {
                    $scope.ischeckseldall = !$scope.ischeckseldall;
                    if ($scope.ischeckseldall) {
                        var searchResult = $filter("filterList")($scope.meauInfo, $scope.searchlitxt, $scope.keyname);
                        searchResult.filter(function(meau) {
                            var idx = $scope.selIDS.indexOf(meau[$scope.keyid]);
                            /* if(!$scope.ischeckseldall && idx>-1){
                            	 $scope.selIDS.splice(idx,1);
                            	 $scope.selNames.splice(idx,1);
                             }*/
                            if ($scope.ischeckseldall && idx == -1) {
                                $scope.selIDS.push(meau[$scope.keyid]);
                                $scope.selNames.push(meau[$scope.keyname]);
                            }
                        });
                    } else {
                        $scope.selIDS = [];
                        $scope.selNames = [];
                    }
                }
            }
        }
    };

    //多选超出500条活动显示
    function selectMoreListBtn($filter, ToolService) {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: '/template/common/selectMoreBtn.html?r=' + tempVersion,
            scope: {
                meauInfo: '=', //列表数据
                meauName: "=", //初始name，eg:请选择
                meauId: "@", //select的id
                meauData: "=", //初始选择的id值
                meauRefresh: "=", //强制刷新下拉框
                keyname: "@", //显示名
                keyid: "@", //传递ID
                meauRed: "=", //红色框
                meauDis: "=",
                isshowconfirm: "@",
                searchActiveId: "=",
                showDownId: "=",
                searchTotal: "=",
                filterfn: "&",
                initTxt: "=",
                initf5: "=",
                list: "=",
                tipMsg: "=",
                clearTxtId: "=",
                showSearchBtn: "=",
                customTitle: "@"
            },
            link: function($scope, $element) {
                $scope.ischeckall = false;
                $scope.selme = false;

                if (angular.isUndefined($scope.keyname)) {
                    $scope.keyname = "name";
                }
                if (angular.isUndefined($scope.keyid)) {
                    $scope.keyid = "id";
                }

                $scope.clickMeau = function(meau) {
                    $scope.meauRed = false;
                    var idx = $scope.selIDS.indexOf(meau[$scope.keyid]);
                    if ($scope.selIDS.length == 2 && idx == -1 && $scope.keyid == 'itemCode') return;
                    if (idx > -1) {
                        $scope.selIDS.splice(idx, 1);
                        $scope.selNames.splice(idx, 1);
                        $scope.ischeckall = false;
                    } else {
                        $scope.selIDS.push(meau[$scope.keyid]);
                        $scope.selNames.push(meau[$scope.keyname]);
                    }
                }
                $scope.onSearch = function(searchli) {
                    $scope.$emit($scope.searchActiveId, searchli)
                }

                if (!$scope.tipMsg) {
                    $scope.tipMsg = $filter('translate')("输入搜索关键词");
                }

                $scope.query = function() {
                    if ($scope.preTxt == $scope.srhTxt) {
                        return false;
                    }
                    $scope.filterfn({ txt: $scope.srhTxt });
                    $scope.preTxt = $scope.srhTxt;
                }
                $scope.$watch("initTxt+initf5+list", function() {
                    $scope.srhTxt = $scope.preTxt = $scope.initTxt || "";
                });

                $scope.doNull = function() {
                    $scope.searchli = "";
                    $scope.query();
                    $scope.$emit($scope.clearTxtId, "clearTxtId")
                }

                $scope.okSelect = function() {
                    ToolService.sendBehaviorUv($scope.customTitle);
                    $scope.$emit($scope.meauId, { info: $scope.selIDS.join(",") });
                    $scope.selme = false;
                }
                $scope.$watch("selme", function() {
                    if (!$scope.selme && ($scope.keyid == 'eventName' || $scope.keyid == 'itemCode') && $scope.selIDS) {
                        $scope.$emit($scope.meauId, { info: $scope.selIDS.join(",") });
                    }
                });
                $scope.showMenu = function() {
                    if ($scope.meauDis) return;
                    $scope.selme = true;
                    $scope.$emit($scope.showDownId, $scope.searchlitxt)

                }

                $scope.$watchGroup(['meauData', 'meauName', 'meauRefresh', 'meauInfo', 'searchTotal'], function(n) {
                    $scope.selIDS = [];
                    $scope.selNames = [];
                    $scope.ischeckall = false;
                    if ($scope.meauInfo && angular.isDefined($scope.meauData) && $scope.meauData != -1 &&
                        typeof($scope.meauData) == 'string') {
                        var arr = $scope.meauData.split(",");
                        var temp = $scope.meauInfo.filter(function(item) {
                            return item[$scope.keyid] ? arr.indexOf(item[$scope.keyid].toString()) > -1 : false;
                        });
                        if (temp.length > 0) {
                            angular.forEach(temp, function(item) {
                                $scope.clickMeau(item);
                            })
                        } else {
                            $scope.selName = $scope.meauName;
                        }
                        if (temp.length == $scope.meauInfo.length) {
                            $scope.ischeckall = true;
                            $scope.selName = $scope.meauName;
                        }
                    } else {
                        $scope.selName = $scope.meauName;
                    }

                    //  //判断总条数是否大于500
                    //  if($scope.searchTotal){
                    // 	 if($scope.searchTotal.data.length >= 500){
                    // 		 $scope.showBtn = true
                    // 	  }else{
                    // 		  $scope.showBtn = false
                    // 		 $scope.showSer = true
                    // 	  }
                    //   }
                });

                $scope.checkAll = function() {
                        $scope.ischeckall = !$scope.ischeckall;
                        $scope.meauInfo.filter(function(meau) {
                            var idx = $scope.selIDS.indexOf(meau[$scope.keyid]);
                            if (!$scope.ischeckall && idx > -1) {
                                $scope.selIDS.splice(idx, 1);
                                $scope.selNames.splice(idx, 1);
                            }

                            if ($scope.ischeckall && idx == -1) {
                                $scope.selIDS.push(meau[$scope.keyid]);
                                $scope.selNames.push(meau[$scope.keyname]);
                            }
                        });
                    }
                    //全选搜索结果
                $scope.checkSelectedAll = function() {
                    $scope.ischeckseldall = !$scope.ischeckseldall;
                    if ($scope.ischeckseldall) {
                        var searchResult = $filter("filterList")($scope.meauInfo, $scope.searchlitxt, $scope.keyname);
                        searchResult.filter(function(meau) {
                            var idx = $scope.selIDS.indexOf(meau[$scope.keyid]);
                            /* if(!$scope.ischeckseldall && idx>-1){
                            	 $scope.selIDS.splice(idx,1);
                            	 $scope.selNames.splice(idx,1);
                             }*/
                            if ($scope.ischeckseldall && idx == -1) {
                                $scope.selIDS.push(meau[$scope.keyid]);
                                $scope.selNames.push(meau[$scope.keyname]);
                            }
                        });
                    } else {
                        $scope.selIDS = [];
                        $scope.selNames = [];
                    }
                }
            }
        }
    };

    //多选
    function selectParams(ToolService, $filter) {
        return {
            restrict: 'E',
            replace: true,
            templateUrl: '/template/common/selectparams.html?r=' + tempVersion,
            scope: {
                meauInfo: '=', //列表数据
                meauName: "=", //初始name，eg:请选择
                meauId: "@", //select的id
                meauRefresh: "="
            },
            link: function($scope, $element) {
                $scope.selme = false;
                $scope.secondSel = false;
                $scope.showSelWin = function() {
                    $scope.selme = true;
                    if ($scope.selId) {
                        $scope.secondSel = true;
                    }
                }
                $scope.clickMeau = function(meau) {
                    var w = $($element).find(".optionList:eq(0)").width();
                    if ($scope.selId != meau.id) {
                        $scope.secIDS = [];
                        $scope.secKeys = [];
                    }
                    $scope.selId = meau.id;
                    $scope.selN = meau.name;
                    $scope.evtType = meau.type;

                    $scope.secondSel = true;
                    $scope.secondList = meau.value;
                    $scope.secKeyList = meau.key;
                    $scope.secondStyle = { left: w + "px" }
                }
                $scope.clickSecMeau = function(v, midx) {
                    var idx = $scope.secIDS.indexOf(v);
                    if (idx > -1) {
                        $scope.secIDS.splice(idx, 1);
                        if ($scope.secKeyList) {
                            $scope.secKeys.splice(idx, 1);
                        }
                    } else {
                        $scope.secIDS.push(v);
                        if ($scope.secKeyList) {
                            $scope.secKeys.push($scope.secKeyList[midx]);
                        }
                    }
                }
                $scope.okSelect = function() {
                    var pv = "";
                    if ($scope.selId && $scope.selId != "") {
                        var pas = {};

                        if ($scope.secIDS.length == 0 || $scope.secIDS.length > 10) {
                            ToolService.showTips($filter('translate')("请选择10个以内对比属性值"));
                            return false;
                        }
                        if ($scope.secKeyList) {
                            pas[$scope.selId] = $scope.secKeys.join(",");
                        } else {
                            pas[$scope.selId] = $scope.secIDS.join(",");
                        }

                        pas.type = $scope.evtType;
                        pv = JSON.stringify(pas);

                        // $scope.selName = $scope.selN + "=" + $scope.secIDS.join(",");
                        $scope.selName = $scope.selN;
                    } else {
                        $scope.selName = $scope.meauName;
                    }
                    $scope.$emit($scope.meauId, { info: pv, name: $scope.selN });

                    $scope.selme = false;
                    $scope.secondSel = false;
                }
                $scope.$watch("meauName+meauInfo+meauRefresh", function() {
                    if ($scope.meauInfo) {
                        $scope.secIDS = [];
                        $scope.secondList = [];
                        $scope.selId = "";
                        $scope.secondSel = false;
                    }
                    $scope.selName = $scope.meauName;
                });

                angular.element(document).on("click", function() {
                    $scope.$apply(function() {
                        $scope.selme = false;
                        $scope.secondSel = false;
                    });
                });
            }
        }
    };

    //分页
    function flipInfo($filter, $translate) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/flipinfo.html?r=' + tempVersion,
            scope: {
                listInfo: "=", //数据数组
                listData: "=", //表格total
                searchTxt: "=", //搜索值
                searchName: "@", //匹配字段
                listKey: "@", //列表key，用于同一个页面多个翻页区分
                searchKey: "=", //匹配字段,scope动态
                listRefresh: "=", //排序跳转到第一页
                lang: "="
            },
            link: function($scope, el) {
                $scope.everyId = "everyId";
                // $scope.initData = function(){
                /*$translate("每页X条",{X:10}).then(function(tran){
                	console.log();
				}).then(function(){
					return $translate("每页X条",{X:10});
				})*/
                ;
                $scope.everyList = [
                    { "id": 10, "name": $filter('translate')("每页X条", { X: 10 }) },
                    { "id": 20, "name": $filter('translate')("每页X条", { X: 20 }) },
                    { "id": 30, "name": $filter('translate')("每页X条", { X: 30 }) },
                    { "id": 50, "name": $filter('translate')("每页X条", { X: 50 }) },
                    { "id": 100, "name": $filter('translate')("每页X条", { X: 100 }) },
                ];
                $scope.minNum = $scope.everyInit = $scope.everyList[0].id;
                // }

                $scope.$on($scope.everyId, function(e, msg) {
                    var num = msg.info.id;
                    if (num == 'all') {
                        $scope.everyNum = $scope.listInfo.length;
                    } else {
                        $scope.everyNum = num;
                    }
                });

                $scope.page = {};
                $scope.$watchGroup(['listInfo', 'everyNum', 'listData'], function(n) {
                    if (angular.isDefined($scope.listInfo)) {
                        var totalLen = 0;
                        var totalNum = 0;
                        if (angular.isDefined($scope.searchTxt) && $scope.searchTxt != '') {
                            totalLen = $scope.filterCurList.length;
                        } else {
                            totalLen = $scope.listInfo.length;
                        }

                        if (totalLen >= 1000 && $scope.listData) {
                            totalNum = $scope.listData.total
                        } else {
                            totalNum = totalLen;
                        }
                        // $scope.refreshInfos(totalLen);

                        $scope.morePage(totalNum, totalLen);
                    }
                });

                //模糊搜索的时候，重新记录翻页数据
                $scope.$watch("searchTxt", function(n) {
                    if (angular.isDefined(n) && $scope.listInfo) {
                        $scope.searchN = $scope.searchName || $scope.searchKey;
                        if (angular.isDefined($scope.searchN)) {
                            $scope.searchNames = $scope.searchN.split(",");
                        }
                        var infos = $scope.listInfo.filter(function(item) {
                            var has = false;
                            for (var i = $scope.searchNames.length - 1; i >= 0; i--) {
                                if (item[$scope.searchNames[i]] && angular.uppercase(String(item[$scope.searchNames[i]])).indexOf(angular.uppercase(n)) > -1) {
                                    has = true;
                                    break;
                                }
                            }
                            return has;
                        });
                        $scope.filterCurList = infos;

                        var totalLen = infos.length;
                        var totalNum = 0;
                        if (totalLen == 1000 && $scope.listData) {
                            totalNum = $scope.listData.total
                        } else {
                            totalNum = totalLen;
                        }
                        $scope.morePage(totalNum, infos.length);
                    };
                });

                $scope.refreshInfos = function(totalLen) {

                        $scope.morePage(totalLen, totalLen)
                    }
                    /**
                     * totalNum: 设置页面显示总条数
                     * totalNum2: 计算分页总条数
                     */
                $scope.morePage = function(totalNum, totalNum2) {
                    var emitnum = $scope.everyNum ? $scope.everyNum : $scope.everyInit;
                    $scope.page.totals = totalNum; //总条数
                    $scope.page.totalpages = Math.ceil(totalNum2 / emitnum); //总页数
                    $scope.isShowTip = totalNum != totalNum2;
                    $scope.page.curpage = 1; //当前页
                    $scope.sendData();
                }

                $scope.goto = function(flag, p) {
                    switch (flag) {
                        case 0: //跳转
                            $scope.page.curpage = p;
                            break;
                        case 2: //上一页
                            if ($scope.page.curpage > 1) {
                                $scope.page.curpage--;
                            }
                            break;
                        case 3: //下一页
                            if ($scope.page.curpage < $scope.page.totalpages) {
                                $scope.page.curpage++;
                            }
                            break;
                        case 4: //末页
                            $scope.page.curpage = $scope.page.totalpages;
                            break;
                        case 5: //跳转
                            if ($scope.gonum != '' && angular.isNumber($scope.gonum) && $scope.gonum <= $scope.page.totalpages) {
                                $scope.page.curpage = $scope.gonum;
                            } else {
                                $scope.gonum = '';
                            }
                            break;
                        default:
                            break;
                    }
                    $scope.sendData();
                }

                $scope.$watch("page.curpage", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.gonum = n;
                    }
                });
                $scope.$watch("listRefresh", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.goto(0, 1);
                    }
                });

                $scope.sendData = function() {
                    var start = ($scope.page.curpage - 1) * $scope.everyNum - 1;
                    var end = $scope.page.curpage * $scope.everyNum;

                    $scope.$emit("flipinfo", { start: start, end: end, listkey: $scope.listKey, pagen: $scope.everyNum });
                }

                $scope.$watch("lang", function(n, o) {
                    if (n && o && n !== o) {
                        $scope.everyList = [
                            { "id": 10, "name": $filter('translate')("每页X条", { X: 10 }) },
                            { "id": 20, "name": $filter('translate')("每页X条", { X: 20 }) },
                            { "id": 30, "name": $filter('translate')("每页X条", { X: 30 }) },
                            { "id": 50, "name": $filter('translate')("每页X条", { X: 50 }) },
                            { "id": 100, "name": $filter('translate')("每页X条", { X: 100 }) },
                        ];
                        $scope.minNum = $scope.everyInit = $scope.everyList[0].id;
                    }
                });
            }
        }
    }

    //动态分页
    function flipInfoDy($filter) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/flipinfody.html?r=' + tempVersion,
            scope: {
                totalNum: "=", //总条数
                listKey: "@", //列表key，用于同一个页面多个翻页区分
                listRefresh: "=" //排序跳转到第一页
            },
            link: function($scope, el) {
                $scope.everyId = "everyId";
                $scope.everyList = [
                    { "id": 20, "name": $filter('translate')("每页") + 20 + $filter('translate')("条") },
                    { "id": 50, "name": $filter('translate')("每页") + 50 + $filter('translate')("条") },
                    { "id": 100, "name": $filter('translate')("每页") + 100 + $filter('translate')("条") }
                ];
                $scope.minNum = $scope.everyInit = $scope.everyList[0].id;
                $scope.$on($scope.everyId, function(e, msg) {
                    var num = msg.info.id;
                    if (num == 'all') {
                        $scope.everyNum = $scope.totalNum;
                    } else {
                        $scope.everyNum = num;
                    }
                });

                $scope.page = {};
                $scope.$watch("totalNum+everyNum+listRefresh", function(n) {
                    if (angular.isDefined($scope.totalNum)) {
                        $scope.refreshInfos($scope.totalNum - 1);
                    }
                });

                $scope.refreshInfos = function(totalLen) {
                    var emitnum = $scope.everyNum ? $scope.everyNum : $scope.everyInit;
                    $scope.page.totals = totalLen; //总条数
                    $scope.page.totalpages = Math.ceil($scope.page.totals / emitnum); //总页数
                    $scope.page.curpage = 1; //当前页

                    $scope.sendData();
                }

                $scope.goto = function(flag, p) {
                    var dis = false;
                    switch (flag) {
                        case 0: //跳转
                            if ($scope.page.curpage == p) {
                                dis = true;
                            }
                            $scope.page.curpage = p;
                            break;
                        case 2: //上一页
                            if ($scope.page.curpage == 1) {
                                dis = true;
                            }
                            if ($scope.page.curpage > 1) {
                                $scope.page.curpage--;
                            }
                            break;
                        case 3: //下一页
                            if ($scope.page.curpage == $scope.page.totalpages || $scope.page.totalpages <= 1) {
                                dis = true;
                            }
                            if ($scope.page.curpage < $scope.page.totalpages) {
                                $scope.page.curpage++;
                            }
                            break;
                        case 4: //末页
                            if ($scope.page.curpage == $scope.page.totalpages) {
                                dis = true;
                            }
                            $scope.page.curpage = $scope.page.totalpages;
                            break;
                        case 5: //跳转
                            if ($scope.gonum != '' && angular.isNumber($scope.gonum) && $scope.gonum <= $scope.page.totalpages) {
                                if ($scope.page.curpage == $scope.gonum) {
                                    dis = true;
                                }
                                $scope.page.curpage = $scope.gonum;
                            } else {
                                $scope.gonum = '';
                            }
                            break;
                        default:
                            break;
                    }
                    if (!dis) {
                        $scope.sendData();
                    }
                }

                $scope.$watch("page.curpage", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.gonum = n;
                    }
                });

                $scope.sendData = function() {
                    $scope.$emit("flipinfo", { current: $scope.page.curpage, pagenum: $scope.everyNum, listkey: $scope.listKey });
                }
            }
        }
    }

    /**
     * 后台分页查询
     * page:{
     *
     *
     * }
     */
    function pagingQuery(ArrayConstant) {
        return {
            restrict: "E",
            replace: false,
            templateUrl: 'template/common/pagingQuery.html?r=' + tempVersion,
            scope: {
                page: "=", //分页的相关信息，当前页（curPage），页容量（pageSize），总页数（totalPage），总条数（totals）
            },
            link: function($scope, el) {
                //初始化page，如果为空。
                !$scope.page && ($scope.page = {});

                //下拉框ID
                $scope.selectId = "selectId";
                //下拉选项
                $scope.selectList = ArrayConstant.pagingQueryList;

                $scope.page.pageSize = $scope.selectInit = $scope.selectList[0].id; //下拉选项 页容量默认值
                $scope.page.curPage = $scope.curPageNum = 1; //当前页数默认值

                $scope.goPageNum = function() {
                        var num = $scope.curPageNum;
                        if (num > 0 && num < $scope.page.totalPage) {
                            $scope.page.curPage = num;
                        } else if (num < 0) {
                            $scope.page.curPage = $scope.curPageNum = 1;
                        } else if (num > $scope.page.totalPage) {
                            $scope.page.curPage = $scope.curPageNum = $scope.page.totalPage;
                        } else {
                            $scope.page.curPage = $scope.curPageNum = 1;
                        }
                    }
                    //向前翻页
                $scope.forward = function() {
                        if ($scope.page.curPage > 1 && $scope.page.curPage <= $scope.page.totalPage) {
                            $scope.page.curPage--;
                            $scope.curPageNum = $scope.page.curPage;
                        }
                    }
                    //向后翻页
                $scope.backward = function() {
                        if ($scope.page.curPage > 0 && $scope.page.curPage < $scope.page.totalPage) {
                            $scope.page.curPage++;
                            $scope.curPageNum = $scope.page.curPage;
                        }
                    }
                    //监听页容量下拉框值变化
                $scope.$on($scope.selectId, function(e, msg) {
                    $scope.page.pageSize = msg.info.id;
                });

                $scope.$watch('page.pageSize+page.totals', function() {
                    $scope.page.pageSize && $scope.page.totals && ($scope.page.totalPage = Math.ceil($scope.page.totals / $scope.page.pageSize));
                }, true);

            }
        }

    }



    var exportTips = "导出成功，请到数据导出-下载报表处进行下载",
        expTimeTips = "请1分钟后再点",
        expLimitTime = 1000 * 60;

    function minChart(OptionService, $window, $timeout, HttpService, UtilService, ToolService, $rootScope, $filter, $translate) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/chart.html?r=' + tempVersion,
            scope: {
                customTitle: "@",
                chartTitle: "@", //图描述标题
                chartData: "=", //图数据
                chartType: "@", //图类型
                chartTp: "=",
                chartConfig: "=",
                chartLoading: "=",
                chartResize: "@", //yes需要重新resize
                chartCondition: "=",
                chartBack: "=", //回传显示数值,
                isChartShow: "=", //判断是图表还是表格
                tableData: "=", //表格数据 
                searchKeyWord: "=", //搜索表格第一列
                orderIconShow: "=", //是否显示排序
                showPercent:"="//MTTI趋势洞察显示百分百

            },
            link: function($scope, el) {
                var chartInstance = echarts.init($(el).find(".chartInfo").get(0));

                $scope.$watch("chartLoading", function() {
                    if ($scope.chartLoading == true) {
                        // chartInstance.showLoading();
                    }
                });
                var predate = 0;
                $scope.$watch("chartData", function() {
                    if (angular.isUndefined($scope.chartData)) {
                        return false;
                    }
                    predate = 0;
                    $scope.chartType = $scope.chartTp || $scope.chartType;
                    var options = null;
                    if ($scope.chartType == 'funnel') {
                        var bw = $(el).find(".chartInfo").width();
                        $scope.chartConfig.barwidth = bw;
                    }

                    // if(angular.isDefined($scope.chartTp)){ 
                    chartInstance.clear();
                    // }
                    if ($scope.chartType == 'pie') {
                        options = OptionService.getPieOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                    } else if ($scope.chartType == 'map') {
                        options = OptionService.getMapOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                    } else {
                        options = OptionService.getOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                    }
                    if ($scope.chartType == 'funnel' && $scope.chartConfig.barwidth == 0) {

                    } else {
                        chartInstance.setOption(options);
                        var bw = $(el).find(".chartInfo").width();
                        if ($scope.chartResize && $scope.chartResize == 'yes') {
                            chartInstance.resize();
                        } else if (bw == 0) {
                            $timeout(function() {
                                chartInstance.resize();
                            }, 500);
                        }
                    }

                    $timeout(function() {
                        if ($scope.chartType == 'funnel' && $scope.chartConfig.barwidth == 0) {
                            var bw = $(el).find(".chartInfo").width();
                            $scope.chartConfig.barwidth = bw;
                            options = OptionService.getOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                            chartInstance.setOption(options);
                        }
                        chartInstance.resize();
                    }, 200);
                    chartInstance.hideLoading();
                    angular.element($window).bind('resize', function() {
                        chartInstance.resize();
                    });
                    //菜单伸缩
                    $scope.$on("conentresize", function() {
                        $timeout(function() {
                            chartInstance.resize();
                        }, 50);
                    });
                }, true);
                if (!$scope.tableData) {
                    $scope.tableData = $scope.chartData;
                }
                
                $scope.keyMap = {}
                $scope.$watch("tableData", function(n,o) {
                    if(n && n == o ){
                        return false;
                    }
                   
                    if (!angular.isUndefined($scope.tableData)) {
                            for(k in $scope.tableData.key){
                                $scope.keyMap[$scope.tableData.key[k]] = k 
                            }
                        
                        $scope.tableDataAll = JSON.parse(JSON.stringify($scope.tableData));
                        $scope.initPercents($scope.tableDataAll,$scope.tableDataAll.name);
                    }
                    $timeout(function() {
                        chartInstance.resize();
                    }, 100);
                })
              
                $scope.isChart = true;
                $scope.isChartShow = true
                
                $scope.changeChart = function(bol, name) {
                    ToolService.sendBehaviorUv($scope.customTitle + name);
                    if (!$scope.tableData) {
                        $scope.tableData = $scope.chartData;
                    }
                    // 数据备份
                        // $scope.tableDataAll = JSON.parse(JSON.stringify($scope.tableData));
                        if($scope.tableDataAll){
                            $scope.initPercents($scope.tableDataAll,$scope.tableDataAll.name);
                        }
                    $scope.isChart = bol;
                    $scope.isChartShow = bol;
                    if (bol) {
                        $timeout(function() {
                            chartInstance.resize();
                        }, 100);
                    }
                    $scope.$emit($scope.elementInfo, {name:name,title:$scope.customTitle})
                }
                

                //有导出权限
                $rootScope.$watch("limitInfo", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.iscanExport = $rootScope.showMenu('export') && $rootScope.limitInfo.platformExport == true;
                    }
                });
                //表格排序
                var orderBy = $filter('orderBy'),
                    rmd = new Date().getTime();
                $scope.sortCol = "";
                $scope.order = function(p, index, reverse) {
                    if (reverse) {
                        reverse = "desc"
                    }
                    var predicate = JSON.parse(JSON.stringify($scope.tableData));
                    UtilService.sortArray2(predicate.val, predicate.key, index, reverse);
                    $scope.sortCol = predicate.val[index];
                    var _tempTableData = orderBy(predicate, predicate, reverse);
                    $scope.tableDataAll = $scope.initPercents(_tempTableData,predicate.name);
                    $scope.keyMap = {}
                    for(k in $scope.tableDataAll.key){
                        $scope.keyMap[$scope.tableDataAll.key[k]] = k 
                    }
                    $scope.listf5 = ++rmd;
                    $scope.fixrefresh = ++rmd;
                };
                $scope.initPercents=function(_tempTableData,title){
                    var percents = []
                    title.filter(function(n, i){
                        // 找出需要追加%的列
                        if (n && n.indexOf("占比")!=-1){
                            percents.push(i);
                        }else if($scope.showPercent){ //MTTI趋势洞察追加%
                            percents.push(i);
                        }
                    })
                    for (var iIndex = 0; iIndex < percents.length; iIndex++) {
                        var rowItem = _tempTableData.val[percents[iIndex]];
                        for(var jIndex in rowItem){
                            if(rowItem[jIndex] == 0 || rowItem[jIndex] && (rowItem[jIndex]).toString().indexOf("%")==-1){
                                rowItem[jIndex] = rowItem[jIndex]+"%";
                            }
                        }
                    }
                    return _tempTableData;
                }

                $scope.exportData = function() {
                    ToolService.sendBehaviorUv($scope.customTitle + "_export");
                    if ($scope.chartCondition && $scope.chartCondition.name) {
                        var names = $scope.chartCondition.name.split('-');
                        if (names.length > 1) $scope.chartCondition.curName = $translate.instant(names[1]);
                    }
                    var nowdate = new Date().getTime();
                    if (predate > 0) {
                        if (nowdate - predate <= expLimitTime) {
                            predate = nowdate;
                            ToolService.showTips($filter('translate')(expTimeTips));
                            return false;
                        }
                    }
                    predate = nowdate;
                    ToolService.showLoading();
                    var expPM = HttpService.postInfo("mng/export/report/" + $scope.chartCondition.app + "/generatefile", $scope.chartCondition);
                    expPM.then(function(data) {
                        ToolService.hideLoading();
                        ToolService.showTips($filter('translate')(exportTips));
                        TrackingIO.download();
                    });
                }
            }
        }
    }
    function maxChart(OptionService, $window, $timeout, HttpService, UtilService, ToolService, $rootScope, $filter, $translate) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/maxchart.html?r=' + tempVersion,
            scope: {
                customTitle: "@",
                chartTitle: "@", //图描述标题
                chartData: "=", //图数据
                chartType: "@", //图类型
                chartTp: "=",
                chartConfig: "=",
                chartLoading: "=",
                chartResize: "@", //yes需要重新resize
                chartCondition: "=",
                chartBack: "=", //回传显示数值,
                isChartShow: "=", //判断是图表还是表格
                tableData: "=", //表格数据 
                searchKeyWord: "=", //搜索表格第一列
                orderIconShow: "=", //是否显示排序
                showPercent:"="//MTTI趋势洞察显示百分百

            },
            link: function($scope, el) {
                var chartInstance = echarts.init($(el).find(".chartInfo").get(0));

                $scope.$watch("chartLoading", function() {
                    if ($scope.chartLoading == true) {
                        // chartInstance.showLoading();
                    }
                });
                var predate = 0;
                $scope.$watch("chartData", function() {
                    if (angular.isUndefined($scope.chartData)) {
                        return false;
                    }
                    predate = 0;
                    $scope.chartType = $scope.chartTp || $scope.chartType;
                    var options = null;
                    if ($scope.chartType == 'funnel') {
                        var bw = $(el).find(".chartInfo").width();
                        $scope.chartConfig.barwidth = bw;
                    }

                    // if(angular.isDefined($scope.chartTp)){
                    chartInstance.clear();
                    // }
                    if ($scope.chartType == 'pie') {
                        options = OptionService.getPieOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                    } else if ($scope.chartType == 'map') {
                        options = OptionService.getMapOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                    } else {
                        options = OptionService.getOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                    }
                    if ($scope.chartType == 'funnel' && $scope.chartConfig.barwidth == 0) {

                    } else {
                        chartInstance.setOption(options);
                        var bw = $(el).find(".chartInfo").width();
                        if ($scope.chartResize && $scope.chartResize == 'yes') {
                            chartInstance.resize();
                        } else if (bw == 0) {
                            $timeout(function() {
                                chartInstance.resize();
                            }, 500);
                        }
                    }

                    $timeout(function() {
                        if ($scope.chartType == 'funnel' && $scope.chartConfig.barwidth == 0) {
                            var bw = $(el).find(".chartInfo").width();
                            $scope.chartConfig.barwidth = bw;
                            options = OptionService.getOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
                            chartInstance.setOption(options);
                        }
                        chartInstance.resize();
                    }, 200);
                    chartInstance.hideLoading();
                    angular.element($window).bind('resize', function() {
                        chartInstance.resize();
                    });
                    //菜单伸缩
                    $scope.$on("conentresize", function() {
                        $timeout(function() {
                            chartInstance.resize();
                        }, 50);
                    });
                }, true);
                if (!$scope.tableData) {
                    $scope.tableData = $scope.chartData;
                }
                
                $scope.keyMap = {}
                $scope.$watch("tableData", function(n,o) {
                    if(n && n == o ){
                        return false;
                    }
                   
                    if (!angular.isUndefined($scope.tableData)) {
                            for(k in $scope.tableData.key){
                                $scope.keyMap[$scope.tableData.key[k]] = k 
                            }
                        
                        $scope.tableDataAll = JSON.parse(JSON.stringify($scope.tableData));
                        $scope.initPercents($scope.tableDataAll,$scope.tableDataAll.name);
                    }
                    $timeout(function() {
                        chartInstance.resize();
                    }, 100);
                })
              
                $scope.isChart = true;
                $scope.isChartShow = true
                
                $scope.changeChart = function(bol, name) {
                    ToolService.sendBehaviorUv($scope.customTitle + name);
                    if (!$scope.tableData) {
                        $scope.tableData = $scope.chartData;
                    }
                    // 数据备份
                        // $scope.tableDataAll = JSON.parse(JSON.stringify($scope.tableData));
                        if($scope.tableDataAll){
                            $scope.initPercents($scope.tableDataAll,$scope.tableDataAll.name);
                        }
                    $scope.isChart = bol;
                    $scope.isChartShow = bol;
                    if (bol) {
                        $timeout(function() {
                            chartInstance.resize();
                        }, 100);
                    }
                }
                

                //有导出权限
                $rootScope.$watch("limitInfo", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.iscanExport = $rootScope.showMenu('export') && $rootScope.limitInfo.platformExport == true;
                    }
                });
                //表格排序
                var orderBy = $filter('orderBy'),
                    rmd = new Date().getTime();
                $scope.sortCol = "";
                $scope.order = function(p, index, reverse) {
                    if (reverse) {
                        reverse = "desc"
                    }
                    var predicate = JSON.parse(JSON.stringify($scope.tableData));
                    UtilService.sortArray2(predicate.val, predicate.key, index, reverse);
                    $scope.sortCol = predicate.val[index];
                    var _tempTableData = orderBy(predicate, predicate, reverse);
                    $scope.tableDataAll = $scope.initPercents(_tempTableData,predicate.name);
                    $scope.keyMap = {}
                    for(k in $scope.tableDataAll.key){
                        $scope.keyMap[$scope.tableDataAll.key[k]] = k 
                    }
                    $scope.listf5 = ++rmd;
                    $scope.fixrefresh = ++rmd;
                };
                $scope.initPercents=function(_tempTableData,title){
                    var percents = []
                    title.filter(function(n, i){
                        // 找出需要追加%的列
                        if (n && n.indexOf("占比")!=-1){
                            percents.push(i);
                        }else if($scope.showPercent){ //MTTI趋势洞察追加%
                            percents.push(i);
                        }
                    })
                    for (var iIndex = 0; iIndex < percents.length; iIndex++) {
                        var rowItem = _tempTableData.val[percents[iIndex]];
                        for(var jIndex in rowItem){
                            if(rowItem[jIndex] == 0 || rowItem[jIndex] && (rowItem[jIndex]).toString().indexOf("%")==-1){
                                rowItem[jIndex] = rowItem[jIndex]+"%";
                            }
                        }
                    }
                    return _tempTableData;
                }

                $scope.exportData = function() {
                    ToolService.sendBehaviorUv($scope.customTitle + "_export");
                    if ($scope.chartCondition && $scope.chartCondition.name) {
                        var names = $scope.chartCondition.name.split('-');
                        if (names.length > 1) $scope.chartCondition.curName = $translate.instant(names[1]);
                    }
                    var nowdate = new Date().getTime();
                    if (predate > 0) {
                        if (nowdate - predate <= expLimitTime) {
                            predate = nowdate;
                            ToolService.showTips($filter('translate')(expTimeTips));
                            return false;
                        }
                    }
                    predate = nowdate;
                    ToolService.showLoading();
                    var expPM = HttpService.postInfo("mng/export/report/" + $scope.chartCondition.app + "/generatefile", $scope.chartCondition);
                    expPM.then(function(data) {
                        ToolService.hideLoading();
                        ToolService.showTips($filter('translate')(exportTips));
                        TrackingIO.download();
                    });
                }
            }
        }
        // return {
        //     restrict: "E",
        //     replace: true,
        //     templateUrl: '/template/common/maxchart.html?r=' + tempVersion,
        //     scope: {
        //         chartTitle: "@", //图描述标题
        //         chartData: "=", //图数据
        //         chartType: "@", //图类型
        //         chartTp: "=",
        //         chartConfig: "=",
        //         chartLoading: "="
        //     },
        //     link: function($scope, el) {
        //         var chartInstance = echarts.init($(el).find(".chartInfo").get(0));

        //         $scope.$watch("chartLoading", function() {
        //             if ($scope.chartLoading == true) {
        //                 // chartInstance.showLoading();
        //             }
        //         });

        //         $scope.$watch("chartData", function() {
        //             if (angular.isUndefined($scope.chartData)) {
        //                 return false;
        //             }

        //             $scope.chartType = $scope.chartTp || $scope.chartType;
        //             var options = null;
        //             if ($scope.chartType == 'funnel') {
        //                 var bw = $(el).find(".chartInfo").width();
        //                 $scope.chartConfig.barwidth = bw;
        //             }

        //             // if(angular.isDefined($scope.chartTp)){
        //             chartInstance.clear();
        //             // }
        //             if ($scope.chartType == 'pie') {
        //                 options = MaxService.getPieOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
        //             } else if ($scope.chartType == 'map') {
        //                 options = MaxService.getMapOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
        //             } else {
        //                 options = MaxService.getOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
        //             }

        //             if ($scope.chartType == 'funnel' && $scope.chartConfig.barwidth == 0) {} else {
        //                 chartInstance.setOption(options);

        //             }

        //             $timeout(function() {
        //                 if ($scope.chartType == 'funnel' && $scope.chartConfig.barwidth == 0) {

        //                     var bw = $(el).find(".chartInfo").width();
        //                     $scope.chartConfig.barwidth = bw;
        //                     options = MaxService.getOption($scope.chartData, $scope.chartType, $scope.chartConfig || {});
        //                     chartInstance.setOption(options);
        //                 }
        //                 chartInstance.resize();
        //             }, 200);
        //             chartInstance.hideLoading();

        //             angular.element($window).bind('resize', function() {
        //                 chartInstance.resize();
        //             });
        //         }, true);
        //     }
        // }
    }
    //列表导出
    function exportButton(HttpService, UtilService, ToolService, $rootScope, $filter, $translate) {
        return {
            restrict: "E",
            transclude: true,
            replace: true,
            templateUrl: '/template/common/export.html?r=' + tempVersion, 
            scope: {
                exportCondition: "=",
                showTipDesc: "=",
                customTitle: "@",
                exportTitle: "="
            },
            link: function($scope, el) {
                $scope.style1 = { "float": "right", "margin-top": "11px", "margin-right": "10px" };
                var predate = 0;
                $scope.$watch("exportCondition", function(n, o) {
                    predate = 0;
                });
                $scope.exportData = function() {
                    ToolService.sendBehaviorUv($scope.customTitle);
                    if ($scope.exportCondition && $scope.exportCondition.name) {
                        var name = "";
                        if ($scope.exportCondition.name.indexOf('-') > -1) {
                            var names = $scope.exportCondition.name.split('-');
                            if (names.length > 1) name = names[0] + "-" + $translate.instant(names[1]);
                        } else {
                            name = $translate.instant($scope.exportCondition.name);
                        }
                        $scope.exportCondition.curName = name;
                    }
                    var nowdate = new Date().getTime();
                    if (predate > 0) {
                        if (nowdate - predate <= expLimitTime) {
                            predate = nowdate;
                            ToolService.showTips($filter('translate')(expTimeTips));
                            return false;
                        }
                    }
                    predate = nowdate;
                    var ssubType = $scope.exportCondition.subType

                    $scope.$emit("showTipDesc", { subType: ssubType })
                    var expPM = HttpService.postInfo("mng/export/report/" + $scope.exportCondition.app + "/generatefile", $scope.exportCondition);
                    ToolService.showLoading();
                    expPM.then(function(data) {
                        ToolService.hideLoading();
                        if (($scope.exportCondition.exportCampaign && $scope.exportCondition.exportCampaign == true) || ($scope.exportCondition.exportChannel && $scope.exportCondition.exportChannel == true)) {} else {
                            ToolService.showTips($filter('translate')(exportTips));
                        }
                        TrackingIO.download();
                    });
                }

                //有导出权限
                $rootScope.$watch("limitInfo", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.iscanExport = $rootScope.showMenu('export') && $rootScope.limitInfo.platformExport == true;
                    }
                });
            }
        }
    }

    function ngEnter() {
        return function(scope, element, attrs) {
            element.bind("keydown keypress", function(event) {
                if (event.which === 13) {
                    scope.$apply(function() {
                        scope.$eval(attrs.ngEnter);
                    });

                    event.preventDefault();
                }
            });
        };
    }

    function selectChannel($state, $rootScope, HttpService, $filter) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/channel.html?r=' + tempVersion,
            scope: {
                channelList: "=", //渠道列表
                appOs: "=", //游戏操作类型
                type: "=", //是否为H5类型
                sendMsgId: "@" //接收消息
            },
            link: function($scope, el) {
                $scope.rangeList = ['A~G', 'H~N', 'O~T', 'U~Z', '0~9'];
                $scope.rangeMap = {
                    'A~G': 'abcdefg',
                    'H~N': 'hijklmn',
                    'O~T': 'opqrst',
                    'U~Z': 'uvwxyz',
                    '0~9': '0123456789'
                };
                $scope.isSuper = $rootScope.isSuper;

                if ($scope.appOs == 4) {
                    $scope.channType = null;
                } else {
                    //$scope.channType = "hottest";
                    $scope.channType = "ry_coop"; //默认选中‘常规渠道’
                }

                $scope.category = 'ADVERTISING';
                // $scope.isEst = 'hottest';
                $scope.letter = "";

                $scope.popchannellist = false;
                angular.element(el).parent().bind("click", function() {
                    $scope.$broadcast("popchannel", {});
                    $scope.$apply();
                });

                $scope.$on("popchannel", function() {
                    $scope.popchannellist = true;
                });

                $scope.$watch("appOs", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.appplattype = n;
                    }
                });

                $scope.changeType = function(type) {
                    $scope.channType = type;
                    $scope.category = 'ADVERTISING';
                    // $scope.category = 'hottest';
                    $scope.letter = "";
                };

                $scope.isRangeItemShow = function(rangeItem) {
                    // return true
                    var f1 = $filter('charfilter')($scope.curChannelList, $scope.rangeMap[rangeItem])
                    // var f2 = $filter('filter')(f1, { name: $scope.channelfilter })
                    var f2 = $filter('filterList')(f1, $scope.channelfilter, 'name,alias')
                    var f3 = $filter('orderBy')(f2, 'firstchar')
                    return f3.length > 0
                };

                $scope.$watch("channType+appplattype+channelList+category", function(n) {
                    if (angular.isDefined($scope.channelList) && angular.isDefined($scope.appplattype) && angular.isDefined($scope.category)) {
                        //选择最新标签时，获取参考日期（一个月前）
                        if ($scope.channType == 'newest') {
                            var d = new Date();
                            d.setMonth(d.getMonth() - 1);
                        }

                        if ($scope.appplattype == 2) { //android
                            if ($scope.channType != 'ry_bd') {
                                $scope.curChannelList = $scope.channelList.filter(function(channel) {
                                    return channel.osAndroid && channel.category == $scope.category && ($scope.channType == 'hottest' ? channel.hotest : ($scope.channType == 'newest' ? (channel.createTime > d.getTime() && channel.type !== null) : (channel.type == $scope.channType)));
                                });
                            } else {
                                $scope.curChannelList = $scope.channelList.filter(function(channel) {
                                    return channel.type == $scope.channType && channel.osAndroid;
                                });
                            }
                        } else if ($scope.appplattype == 1) { //ios
                            $scope.curChannelList = $scope.channelList.filter(function(channel) {
                                return channel.osIos && channel.category == 'ADVERTISING' && ($scope.channType == 'hottest' ? channel.hotest : ($scope.channType == 'newest' ? (channel.createTime > d.getTime() && channel.type !== null) : (channel.type == $scope.channType)));
                            });

                        } else if ($scope.appplattype == 4) { //小程序
                            $scope.curChannelList = $scope.channelList.filter(function(channel) {
                                // return channel.type == $scope.channType && channel.osWeb &&(($scope.channType=='ry_coop' && $scope.isEst=='hottest')? channel.hotest:(($scope.channType=='ry_coop' && $scope.isEst=='newest') ? channel.createTime >d.getTime():true));
                                return channel.osWeixin && ($scope.channType == 'hottest' ? channel.hotest : ($scope.channType == 'newest' ? channel.createTime > d.getTime() : (channel.type == $scope.channType)));
                            });
                        } else if ($scope.appplattype == 5) { //媒体自建站
                            $scope.curChannelList = $scope.channelList.filter(function(channel) {
                                return (channel.osWeb && ($scope.channType == 'hottest' ? channel.hotest : ($scope.channType == 'newest' ? (channel.createTime > d.getTime() && channel.type !== null) : $scope.channType=='ry_coop'?false: (channel.type == $scope.channType))))||($scope.channType=='ry_coop' && channel.osSelfbuilt);
                            });
                        } else { //其他
                            $scope.curChannelList = $scope.channelList.filter(function(channel) {
                                return channel.osWeb && ($scope.channType == 'hottest' ? channel.hotest : ($scope.channType == 'newest' ? (channel.createTime > d.getTime() && channel.type !== null) : (channel.type == $scope.channType)));
                            });
                        }

                        //当选最新标签时，对过滤后的渠道集合进行排序，根据createTime
                        $scope.channType == 'newest' && $scope.curChannelList.sort(function(item1, item2) {
                            return item2.createTime - item1.createTime;
                        });
                        //当最热的渠道为空时，切换到常规渠道。
                        /*if($scope.channType=='hottest' &&($scope.curChannelList.length==0)){
                            $scope.channType='ry_coop';
						}*/
                    }

                });


                $scope.clickChannel = function(channel) {
                        if ($scope.sendMsgId == undefined || $scope.sendMsgId == "") {
                            $scope.sendMsgId = "curchannel";
                        }
                        $scope.$emit($scope.sendMsgId, { info: channel });
                        $scope.curchid = channel.id;
                        $scope.popchannellist = false;
                    }
                    //跳转到渠道管理
                $scope.goChannel = function() {
                    if ($scope.appOs == 4) {
                        $state.go("collect.customchannel", { aid: 'custom' });
                    } else {
                        $state.go("collect.customchannel");
                    }
                }

                $scope.setLetter = function(rangeName) {
                    $scope.rangeName = rangeName;
                    if ($scope.letter != $scope.rangeMap[rangeName]) {
                        $scope.letter = $scope.rangeMap[rangeName];
                    }
                }

                /*$scope.setEst = function(val){
                    $scope.isEst = ($scope.isEst && $scope.isEst==val)?'':val;
				}*/
            }
        };
    }

    function popTip() {
        return {
            restrict: "E",
            transclude: true,
            replace: true,
            template: '<div class="opIcon p" ng-mouseleave="showtip=false" style="height:30px;"><span ng-transclude  ng-click="clickTip()"></span><div class="poptips" ng-show="showtip"><div class="poparrow"></div>{{tipinfo}}</div></div>',
            scope: {
                tipinfo: "="
            },
            link: function($scope, el) {
                $scope.showtip = false;

                $scope.clickTip = function() {
                    ToolService.sendBehavior()
                    $scope.showtip = !$scope.showtip;
                }
            }
        }
    }

    function isLoading() {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/loading.html?r=' + tempVersion,
            scope: {
                doLoading: "="
            },
            link: function($scope, el) {
                $scope.myLoading = false;
                $scope.$watch("doLoading", function(n) {
                    if (angular.isDefined(n)) {
                        $scope.myLoading = n;
                    }
                });
            }
        }
    }

    function noData() {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/nodata.html?r=' + tempVersion,
            scope: {

            },
            link: function($scope, el) {

            }
        }
    }

    function dateRange(ToolService, UtilService, ArrayConstant, $filter, $translate) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/daterange.html?r=' + tempVersion,
            scope: {
                nodrange: "@",
                noToday: "@",
                datekey: "@",
                maxRange: "@",
                defaultFlag: "@",
                lang: "="
            },
            link: function($scope, el) {
                if (angular.isUndefined($scope.nodrange)) {
                    $scope.nodrange = false;
                }

                // if(ToolService.isUser(ArrayConstant.demoEmail)){
                // 	$scope.nodrange = true;
                // }

                if (angular.isUndefined($scope.noToday)) {
                    $scope.noToday = true;
                } else {
                    $scope.noToday = $scope.noToday != 'false' && $scope.noToday != false;
                }

                if (angular.isUndefined($scope.datekey)) {
                    $scope.datekey = "curdate";

                }


                var today = ToolService.getToday(),
                    yesDay = ToolService.getYesDay();
                var countN = 0
                $scope.changeDate = function(flag) {
                    switch (flag) {
                        case 'today':
                            $scope.subfix = "hour";
                            $scope.mydate = today;
                            break;
                        case 'yesday':
                            $scope.subfix = "hour";
                            $scope.mydate = yesDay;
                            break;
                        case 'd7':
                            $scope.subfix = "ds";
                            $scope.mydate = ToolService.getLastDays(-7, 0);
                            break;
                        case 'd14':
                            $scope.subfix = "ds";
                            $scope.mydate = ToolService.getLastDays(-14, 0);
                            break;
                        case 'd30':
                            $scope.subfix = "ds";
                            $scope.mydate = ToolService.getLastDays(-30, 0);
                            break;
                        default:
                            $scope.subfix = "ds";
                            break;
                    }
                    $scope.timeflag = flag;
                    UtilService.setCookie("dataFlag", flag, 1); //记录用户筛选过行为 

                    if (countN > 0) {
                        ToolService.sendBehaviorUv(flag);
                    } else {
                        countN = countN + 1
                    }

                }

                $scope.maxDay = 0;
                //获取缓存日期开始

                var cookieStartDate = UtilService.getCookie("cookieStartDate");
                var cookieEndDate = UtilService.getCookie("cookieEndDate");


                if (cookieStartDate && cookieEndDate && $scope.noToday != true) {
                    var cookieDateFlag = UtilService.getCookie("cookieDateFlag");
                    $scope.mydate = { startDate: cookieStartDate, endDate: cookieEndDate, dateflag: cookieDateFlag };
                    $scope.changeDate(cookieDateFlag)
                } else if ($scope.noToday == true) {
                    var cookieDateFlag = UtilService.getCookie("cookieDateFlag");
                    $scope.mydate = { startDate: cookieStartDate, endDate: cookieEndDate, dateflag: cookieDateFlag };
                    $scope.changeDate('yesday');
                    $scope.maxDay = -1;
                } else if ($scope.defaultFlag) {
                    $scope.changeDate($scope.defaultFlag);
                } else {
                    $scope.changeDate('today');
                }


                $scope.myrangeday = $scope.maxRange;
                $scope.$on("dateCustos", function(e, msg) {
                    UtilService.setCookie("dataFlag", "defaul", 1);
                    if (msg.startDate == msg.endDate && msg.startDate == today.startDate) {
                        $scope.timeflag = "today";
                        $scope.subfix = "hour";
                    } else if (msg.startDate == msg.endDate && msg.startDate == yesDay.startDate) {
                        $scope.timeflag = "yesday";
                        $scope.subfix = "hour";
                    } else {
                        $scope.timeflag = msg.dateflag;
                        $scope.subfix = "ds";
                    }
                    $scope.mydate = msg;

                });

                $scope.$watch("{mydate:mydate,lang:lang}", function(n, o) {
                    if (angular.isDefined($scope.mydate)) {
                        if (!$scope.mydate.dateflag) {
                            $scope.mydate.dateflag = $scope.timeflag;
                        }
                        $scope.datestr = $scope.mydate.startDate + $translate.instant("至") + $scope.mydate.endDate;
                        UtilService.setCookie("cookieStartDate", $scope.mydate.startDate, 1);
                        UtilService.setCookie("cookieEndDate", $scope.mydate.endDate, 1);
                        UtilService.setCookie("cookieDateFlag", $scope.mydate.dateflag, 1);
                        $scope.$emit($scope.datekey, { date: $scope.mydate, subfix: $scope.subfix, timeflag: $scope.timeflag })
                    }
                }, true);
            }
        }
    }

    //输入框只能输入数字和小数点
    function numberTxt() {
        return {
            restrict: "A",
            link: function($scope, el) {
                el.bind("keydown", function(event) {
                        event = window.event || event;
                        if ((event.keyCode >= 48 && event.keyCode <= 57) || (event.keyCode >= 96 && event.keyCode <= 105) || event.keyCode == 8 || event.keyCode == 190) {

                        } else {
                            event.preventDefault();
                        }
                    })
                    .bind("input propertychange", function() {
                        // var v = $(el).val().replace(/[^\x00-\x80A-Za-z]/gi,"");
                        // $(el).val(v);
                    });
            }
        }
    }
    //输入框只能输入数字
    function integerTxt() {
        return {
            restrict: "A",
            link: function($scope, el) {
                el.bind("keydown", function(event) {
                        event = window.event || event;
                        if ((event.keyCode >= 48 && event.keyCode <= 57) || (event.keyCode >= 96 && event.keyCode <= 105) || event.keyCode == 8) {

                        } else {
                            event.preventDefault();
                        }
                    })
                    .bind("input propertychange", function() {
                        /*var v = $(el).val().replace(,"");
                        if($(el).val().test());*/
                        if (/\D/g.test($(el).val())) {
                            $scope.$emit("noNumber", '');
                        }
                    });
            }
        }
    }

    function helpTip(ToolService, $rootScope) {
        return {
            restrict: "E",
            replace: true,
            scope: { 
                name: "@",
                decTitle: "@",
                dname: "=",
                dn2: "=",
                hidx: "@",
                red: "="
            },
            templateUrl: '/template/common/helptip.html?r=' + tempVersion,
            link: function($scope, el) {
                $scope.showtip = false;
                var hidx = $scope.hidx ? $scope.hidx : 2;
                $scope.spanStyle = { "z-index": hidx };

                var now = $(el).find(".helpTipWrap"),
                    zIdx = Number($(el).parent().css("z-index"));
                now.hide();
                $scope.showTip = function() {
                    ToolService.sendBehaviorUv($scope.decTitle)
                    zIdx = Number($(el).parent().css("z-index"));
                    if (angular.isNumber(zIdx)) {
                        $(el).parent().css("z-index", zIdx + 1);
                    }
                    $(".helpTipWrap").not(now).parent().parent().css("z-index", zIdx);
                    $(".helpTipWrap").not(now).hide().animate({ opacity: 0 });
                    now.show().animate({ opacity: 1 }, 100, 'linear');
                }
                angular.element(document).on("click", function() {
                    if (angular.isNumber(zIdx)) {
                        now.parent().parent().css("z-index", zIdx);
                    }
                    now.animate({ opacity: 0 }).hide();
                });

                $scope.$watch('name+dname+dn2', function(n) {
                    var name = $scope.name ? $scope.name : $scope.dname;
                    if (angular.isDefined($scope.dn2)) {
                        name += $scope.dn2;
                    }

                    if (angular.isDefined(name)) {
                        $scope.tipname = name;
                        $scope.tipcontent = ToolService.getMenuTip($scope.tipname);
                    }
                });

                $rootScope.$watch("currentPageTips", function() {
                    $scope.tipcontent = ToolService.getMenuTip($scope.tipname);
                });
            }
        }
    }

    function helpWinTip(ToolService, $rootScope, $filter) {
        return {
            restrict: "E",
            scope: {
                name: "@",
                dname: "=",
                zIndex: "=",
                titlev: "@",
                helpw: "@",
                customTitle: "@"
            },
            replace: true,
            template: '<span ng-click="showTip()" title="{{titlev}}" stop-event></span>',
            link: function($scope, el) {
                angular.element(document).on("click", function() {
                    $("#winTC").hide();
                });
                $scope.showTip = function() {
                    ToolService.sendBehaviorUv($scope.customTitle);
                    var name = $scope.name ? $scope.name : $scope.dname;

                    var offset = $(el).offset(),
                        left = offset.left,
                        top = offset.top
                    h = $(el).innerHeight(),
                        w = $(el).innerWidth(),
                        winWidth = $(window).width();

                    top = Math.ceil(top + h);

                    var cssStyle = { top: top, 'display': 'block', opacity: 1 },
                        winObj = $("#winTC");
                    if ($scope.zIndex) {
                        winObj.css("z-index", $scope.zIndex);
                    }
                    if ($scope.helpw) {
                        winObj.css("width", $scope.helpw + "px");
                    } else {
                        winObj.css("width", "200px");
                    }
                    if ($(el).hasClass("rightTip")) {
                        winObj.addClass("rightPosition");
                        left = Math.ceil(left - winObj.innerWidth() + w);
                    } else {
                        winObj.removeClass("rightPosition");
                    }
                    if (winWidth - left < 200) {
                        winObj.addClass("rightPosition");
                        left = Math.ceil(left - winObj.innerWidth() + w);
                    }
                    cssStyle.left = left;
                    winObj.html(ToolService.getMenuTipNew(name,$scope.titlev)).css(cssStyle);
                }
            }
        }
    }

    /*固定首行or首列*/
    function fixHeader($timeout) {
        return {
            restrict: "A",
            scope: {
                titleName: "=", //动态表头列表
                fixFirtd: "@", //固定首列
                fixList: "=" //列表数据
            },
            link: function($scope, el) {

                var obj = $(el),
                    p = obj.parent(),
                    fixTd = 0,
                    firTds = null,
                    zidx = 1;
                //固定首列
                if (angular.isDefined($scope.fixFirtd)) {
                    fixTd = Number($scope.fixFirtd);
                    zidx = 2;
                }
                //固定首行
                $scope.$watch("titleName", function() {
                    $timeout(function() {
                        obj.find("thead th").css({ "position": "relative", "z-index": zidx });
                        p.scroll(function() {
                            var t = $(this).scrollTop();
                            if (t > 5) { t--; }
                            obj.find("thead th").css({ "top": t + "px" });
                        });

                    });
                });

                //固定首列
                if (fixTd > 0) {
                    $scope.$watch("fixList", function() {
                        $timeout(function() {
                            firTds = obj.find("tr td:nth-child(" + fixTd + ")");
                            firTds.css({ "position": "relative", "z-index": 1 });
                            p.scroll(function() {
                                var l = $(this).scrollLeft();
                                if (l > 5) { l -= 2; }
                                firTds.css({ "left": l + "px" });
                            });
                        });
                    });
                }
            }
        }
    };

    //看单事件
    function customEvent(UtilService, ToolService, $timeout, HttpService, $rootScope, $filter) {
        return {
            restrict: "E",
            replace: true,
            templateUrl: '/template/common/custom.html?r=' + tempVersion,
            scope: {
                type: "=", //报表类型，1事件分析，2留存分析，3漏斗分析
                eventList: "=", //事件列表
                oldInfo: "=" //初始化事件详情
            },
            link: function($scope, el) {
                var rmd = new Date().getTime();
                $scope.$watch("oldInfo", function(e) {
                    if (angular.isDefined($scope.oldInfo)) {
                        if ($scope.type == 'eventstats') {
                            $scope.changeEvent(null, $scope.oldInfo);
                        } else {
                            $scope.eventInfo = [], evts = [], evtvals = [];

                            $scope.oldInfo.filter(function(item) {
                                var temp = { event: item.event, param: [] };
                                var pppm = UtilService.cloneJSON(item.params);
                                pppm.filter(function(pm) {
                                    temp.param.push(pm.attr);
                                });
                                evts.push(item.event);
                                evtvals.push(temp);
                            });
                            ToolService.showLoading();
                            var evtprofilePM = HttpService.getInfo($rootScope.appid + "/event/find/param?names=" + evts.join(",") + "&params=" + JSON.stringify(evtvals));
                            evtprofilePM.then(function(pros) {
                                pros.filter(function(evt) {
                                    for (var i = 0; i < $scope.eventList.length; i++) {
                                        if (evt.eventName == $scope.eventList[i].eventName) {
                                            $scope.eventList[i].profiles = evt.profiles;
                                            break;
                                        }
                                    }
                                });
                                $scope.oldInfo.filter(function(e) {
                                    e.oldparams = UtilService.cloneJSON(e.params);
                                    delete e.params;
                                    $scope.addEvent(e);
                                });
                                ToolService.hideLoading();
                            });
                        }
                    }
                });

                $scope.$on("eventId", function(e, msg) {
                    $scope.changeEvent(msg.info);
                });
                $scope.initEvent = function() {
                    $scope.eventinitname = "全部事件";
                    $scope.eventInit = 0 - rmd;

                    $scope.event = {};
                    $scope.propertyList = [];
                    $scope.sumtypeList = [];
                }
                $scope.changeEvent = function(event, obj) {

                        if (obj) { //编辑查找
                            $scope.initEvent();
                            $scope.eventinitname = obj.event;
                            $scope.properinitname = obj.viewField;

                            var nowEvents = $scope.eventList.filter(function(item) {
                                return item.eventName == obj.event;
                            });
                            if (nowEvents.length > 0) {
                                event = nowEvents[0];
                                $scope.eventinitname = event.eventNameAlias;
                                $scope.evnullevent = false;
                            } else {
                                $scope.evnullevent = true;
                            }
                        }
                        $scope.event = {
                            id: "evt_" + rmd,
                            params: [],
                            paramsList: [],
                            relation: "and"
                        }

                        if (!UtilService.isNullStr(event)) {
                            $scope.eventId = event.eventName;
                            $scope.eventstatsEvtName = event.eventNameAlias;

                            var setattr = function() {
                                $scope.propertyList = event.firstLevelAttr;
                                $scope.sumtypeList = event.secondLevelAttr;
                                $scope.event.paramsList = event.profiles;
                            }
                            if (event.secondLevelAttr) {
                                setattr();
                            } else {
                                var evtvals = [],
                                    temp = { event: $scope.eventId, param: [] };
                                if (obj) {
                                    obj.params.filter(function(pitem) {
                                        temp.param.push(pitem.attr);
                                    });
                                    evtvals.push(temp);
                                }

                                ToolService.showLoading();
                                var evtprofilePM = HttpService.getInfo($rootScope.appid + "/event/find/param?names=" + $scope.eventId + "&params=" + JSON.stringify(evtvals));
                                evtprofilePM.then(function(pros) {
                                    pros.filter(function(evt) {
                                        for (var i = 0; i < $scope.eventList.length; i++) {
                                            if (evt.eventName == $scope.eventList[i].eventName) {
                                                $scope.eventList[i].profiles = evt.profiles;
                                                $scope.eventList[i].firstLevelAttr = evt.firstLevelAttr;
                                                $scope.eventList[i].secondLevelAttr = evt.secondLevelAttr;
                                                break;
                                            }
                                        }
                                    });
                                    setattr();
                                    ToolService.hideLoading();
                                });
                            }
                        }

                        if (obj) {
                            $scope.event.relation = obj.relation;
                            $timeout(function() {
                                $scope.propertyInit = obj.viewField;
                                $scope.prorefresh = ++rmd;

                                $scope.event.secondval = obj.fieldOperate;
                                if (obj.fieldOperate != '') {
                                    $scope.event.second = true;
                                    $scope.suminitname = obj.fieldOperate;
                                }
                                obj.params.filter(function(pitem) {
                                    pitem.attrMatch = false;
                                    $scope.addEventParams($scope.event, pitem);
                                });
                            });
                        } else {
                            $scope.propertyInit = $scope.propertyList[0].attr;
                            $scope.prorefresh = ++rmd;
                        }
                    }
                    //属性
                $scope.$on("propertyId", function(e, msg) {
                    $scope.event.proId = msg.info.attr;
                    $scope.event.sumId = "";
                    if (msg.info.type != 'default') {
                        $scope.event.second = true;
                        if ($scope.event.secondval) {
                            $scope.sumtypeInit = $scope.event.secondval;
                            delete $scope.event.secondval;
                        } else {
                            $scope.sumtypeInit = $scope.sumtypeList[0].attr;
                        }
                    } else {
                        $scope.sumtypeInit = "";
                        $scope.event.second = false;
                    }
                });
                //属性聚合形式
                $scope.$on("sumtypeId", function(e, msg) {
                    $scope.event.sumId = msg.info.attr;
                });

                $scope.getEventNum = function() {
                    if (!$scope.eventInfo) { return 20; }

                    var es = $scope.eventInfo.filter(function(item) {
                        return item.show != false;
                    });
                    return es.length;
                }
                $scope.setEventSteps = function() {
                    if (!$scope.eventInfo) { return 20; }

                    var idx = -1;
                    var len = $scope.eventInfo.length;
                    $scope.eventInfo.filter(function(item, i) {
                        if (item.show != false) {
                            idx++;
                            item.steps = [$filter('translate')('一'), $filter('translate')('二'), $filter('translate')('三'), $filter('translate')('四'), $filter('translate')('五'), $filter('translate')('六'), $filter('translate')('七'), $filter('translate')('八'), $filter('translate')('九'), $filter('translate')('十')][idx];
                            item.style = { 'z-index': len - i };
                        }
                    });
                }
                $scope.addEvent = function(obj) {

                    rmd++;
                    var temp = { id: "evt_" + rmd, eventid: "event_" + rmd, relation: "and" };

                    if (obj) {
                        for (var k in obj) {
                            temp[k] = obj[k];
                        }
                        temp.eventinit = obj.event;
                        temp.eventinitname = obj.event;
                        temp.params = [];

                        var evts = $scope.eventList.filter(function(item) {
                            return item.eventName == obj.event;
                        });
                        if (evts.length == 0) {
                            temp.nullevent = true;
                            if (temp.oldparams) {
                                temp.oldparams.filter(function(pm) {
                                    $scope.addEventParams(temp, pm);
                                });
                                delete temp.oldparams;
                            }
                        }
                    }
                    (function(temp) {
                        $scope.$on(temp.eventid, function(e, msg) {
                            temp.params = [];
                            temp.event = msg.info.eventName;
                            temp.evtname = msg.info.eventNameAlias;
                            temp.nullevent = false;

                            var setparams = function() {
                                temp.paramsList = msg.info.profiles;
                                if (temp.oldparams) {
                                    temp.oldparams.filter(function(item) {
                                        $scope.addEventParams(temp, item);
                                    });
                                    delete temp.oldparams;
                                }
                            }
                            if (angular.isArray(msg.info.profiles)) {
                                setparams(msg.info.profiles);
                            } else {
                                var proPM = HttpService.getInfo($rootScope.appid + "/event/find/param?names=" + temp.event);
                                proPM.then(function(data) {
                                    msg.info.profiles = data[0].profiles;
                                    setparams();
                                });
                            }

                        });
                    })(temp);

                    $scope.eventInfo.push(temp);
                    $scope.setEventSteps();
                }
                $scope.removeEvent = function(event) {
                    if ($scope.getEventNum() <= 2 && $scope.type == 'funnel') {
                        ToolService.showTips($filter('translate')("漏斗步骤不能少于2步"));
                        return false;
                    }

                    for (var i = 0; i < $scope.eventInfo.length; i++) {
                        if ($scope.eventInfo[i].id == event.id) {
                            $scope.eventInfo[i].show = false;
                            break;
                        }
                    }
                    $scope.setEventSteps();
                }
                $scope.changeRel = function(event) {
                    event.relation = event.relation == 'and' ? "or" : 'and';
                }
                $scope.getEventParamsNum = function(event) {
                    if (!event.params) { return 5; }

                    var eps = event.params.filter(function(item) {
                        return item.show != false;
                    });
                    return eps.length;
                }
                $scope.addEventParams = function(event, obj) {
                    if (!event.params || $scope.getEventParamsNum(event) >= 3) { return false; };
                    rmd++;
                    var tempparam = { id: "pam_" + rmd, pid: event.id };
                    if (obj) {
                        for (var k in obj) {
                            tempparam[k] = obj[k];
                        }
                    }
                    event.params.push(tempparam);
                }
                $scope.removeEventParams = function(event, param) {
                    for (var i = 0; i < event.params.length; i++) {
                        if (event.params[i].id == param.id) {
                            event.params[i].show = false;
                            break;
                        }
                    }
                }
                $scope.$on("event", function(e, msg) {
                    if ($scope.type == 'eventstats') {
                        var params = $scope.event.params;
                        for (var j = 0; j < params.length; j++) {
                            if (params[j].id == msg.id) {
                                params[j] = msg;
                                break;
                            }
                        }
                    } else {
                        for (var i = 0; i < $scope.eventInfo.length; i++) {
                            if ($scope.eventInfo[i].id == msg.pid) {
                                var params = $scope.eventInfo[i].params;
                                for (var j = 0; j < params.length; j++) {
                                    if (params[j].id == msg.id) {
                                        params[j] = msg;
                                        break;
                                    }
                                }
                            }
                        }
                    }
                });

                $scope.okSave = function() {
                    var hasNull = false;
                    var eventInfo = [],
                        myEvents = [];

                    $scope.eventInfo.filter(function(item) {
                        if (item.show != false) {
                            var temp = { event: item.event, relation: item.relation, params: [], eventMatch: true };
                            if (UtilService.isNullStr(item.event) || item.nullevent == true) {
                                item.nullevent = true;
                                hasNull = true;
                            } else {
                                item.nullevent = false;
                                item.params.filter(function(pm) {
                                    if (pm.show != false) {
                                        var pms = {};
                                        for (var k in pm) {
                                            if (k != 'id' && k != 'pid') {
                                                if (k != 'value') {
                                                    pms[k] = pm[k];
                                                } else {
                                                    pms[k] = pm[k].join(",");
                                                }
                                                if (UtilService.isNullStr(pm[k])) {
                                                    $scope.$broadcast(pm.id, "null");
                                                    hasNull = true;
                                                }
                                            }
                                        }
                                        temp.params.push(pms);
                                    }
                                });
                            }
                            eventInfo.push(temp);
                            myEvents.push(item.evtname);
                        }
                    });
                    if (!hasNull && eventInfo.length > 0) {
                        $scope.$emit("matchok", { info: eventInfo, names: myEvents });
                    } else {
                        ToolService.showTips($filter('translate')("信息没填全或数据有误，请检查11"));
                    }
                }

                $scope.eventSave = function() {
                    if (!$scope.event.params) { return false; }
                    var hasNull = false;
                    var eventInfo = { event: $scope.eventId, relation: $scope.event.relation, params: [] };
                    eventInfo.viewField = $scope.event.proId;
                    if ($scope.event.second) { //有二级选项
                        eventInfo.fieldOperate = $scope.event.sumId;
                    } else {
                        eventInfo.fieldOperate = "";
                    }
                    $scope.event.params.filter(function(pm) {
                        if (pm.show != false) {
                            if (UtilService.isNullStr(pm.attr)) {
                                $scope.$broadcast(pm.id, "error");
                                hasNull = true;
                            }
                            var pms = {};
                            for (var k in pm) {
                                if (k != 'id' && k != 'pid') {
                                    if (k != 'value') {
                                        pms[k] = pm[k];
                                    } else {
                                        pms[k] = pm[k].join(",");
                                    }
                                    if (UtilService.isNullStr(pm[k])) {
                                        $scope.$broadcast(pm.id, "error");
                                        hasNull = true;
                                    }
                                }
                            }
                            eventInfo.params.push(pms);
                        }
                    });
                    if (hasNull || !$scope.eventId) {
                        ToolService.showTips($filter('translate')("信息没填全或数据有误，请检查22"));
                    } else {
                        $scope.$emit("matchok", { info: eventInfo, names: [$scope.eventstatsEvtName] });
                    }
                }
            }
        }
    }

    //文件上传
    function fileModel($parse) {
        return {
            restrict: 'A',
            scope: {

            },
            link: function(scope, element, attrs) {
                var model = $parse(attrs.fileModel);
                var modelSetter = model.assign;

                element.bind('change', function() {
                    var val = angular.element(element).val();
                    if (val == '') { return false; }

                    scope.$apply(function() {
                        var myFile = element[0].files;
                        if (attrs.multiple) {
                            modelSetter(scope, element[0].files);
                        } else {
                            modelSetter(scope, element[0].files[0]);
                            myFile = element[0].files[0];
                        }
                        scope.$emit("myFile", myFile);
                        angular.element(element).val("");
                    });
                });
            }
        };
    }

    //文件上传
    function searchGroup($filter, ToolService) {
        return {
            restrict: 'E',
            replace: true,
            scope: {
                filterfn: "&",
                initTxt: "=",
                initf5: "=",
                list: "=",
                tipMsg: "=",
                lang: "=",
                cleanEvent: "=",
                customTitle: "@"
            },
            templateUrl: '/template/common/searchGroup.html?r=' + tempVersion,
            link: function($scope, element, attrs) {
                $scope.s_width = { "width": "250px" };
                if (!$scope.tipMsg) {
                    $scope.tipMsg = $filter('translate')("输入搜索关键词");
                }
                $scope.query = function() {
                    ToolService.sendBehaviorUv($scope.customTitle);
                    if ($scope.preTxt == $scope.srhTxt) {
                        return false;
                    }
                    $scope.filterfn({ txt: $scope.srhTxt });
                    $scope.preTxt = $scope.srhTxt;
                }
                $scope.$watch("initTxt+initf5+list", function() {
                    $scope.srhTxt = $scope.preTxt = $scope.initTxt || "";
                });
                $scope.$watch("lang", function() {

                    }),
                    $scope.$on($scope.cleanEvent, function(event,param) {
                        // $scope.srhTxt = "";
                        $scope.doNull()
                    });

                $scope.doNull = function() {
                    $scope.srhTxt = "";
                    $scope.query();
                }
            }
        };
    }
    //固定表格
    function bigTable($timeout, $compile) {
        return {
            restrict: 'A',
            replace: true,
            scope: {
                fixedCol: "@", //固定列数
                fixedRow: "@", //固定列数
                fixChange: "=", //列表变化，翻页排序等，只需要更新滑动条即可
                infoList: "=", //列表数据
                initf5: "=", //初始化列表,一般是数据列表重新查询
                noScroll: "@",
                noAllScroll: "@",
                noEmpty: "="
            },
            link: function($scope, element) {
                var tableSpline = $(element).find(".tableSpline"),
                    tableHeader = $(element).find(".tableHeader"),
                    tableInfo = $(element).find(".tableInfo");
                var copyColWrap = $(element).find(".copyColWrap"),
                    copyTable = copyColWrap.find("table");

                var totalLeft = 0,
                    infoh = 0,
                    isEmpty = false,
                    before = 0,
                    after = 0,
                    preLeft = 0;
                var helpTip = $(".helpTipWrap");
                if (tableSpline.length == 0) {
                    $(element).append("<div class='tableSpline'></div>");
                    tableSpline = $(element).find(".tableSpline");
                }
                if (copyColWrap.length == 0) {
                    $(element).prepend("<div class='copyColWrap'><table></table></div>");
                    copyColWrap = $(element).find(".copyColWrap");
                    copyTable = copyColWrap.find("table");
                    if ($scope.noAllScroll) {
                        copyColWrap.css({ "max-height": "233px", "top": "35px" });
                    }
                }
                if ($scope.fixedRow == 2) {
                    copyColWrap.css({ "top": "87px" });
                }

                var init = function() {
                    totalLeft = 1; //1像素边框
                    tableHeader.scrollLeft(0);
                    tableInfo.scrollLeft(0);
                    tableInfo.scrollTop(0);
                    infoh = tableInfo.find("table").height();
                    for (var i = 0; i < $scope.fixedCol; i++) {
                        totalLeft += tableHeader.find("#title_" + i).parent().width();
                    }
                    tableSpline.css({ "left": totalLeft });
                    $(element).find(".tableHeader th:lt(" + $scope.fixedCol + ")").css("left", "0px");
                    preLeft = 0;
                }
                var updateBar = function() {
                    var info = tableInfo.find("table"),
                        header = tableHeader.find("table");

                    if ($scope.noEmpty) {
                        isEmpty = false;
                    } else {
                        isEmpty = $scope.infoList && $scope.infoList.length == 0;
                    }

                    var headerw = header.css("width"),
                        headerh = header.css("height"),
                        tableH = info.find("tbody").height(),
                        headH = header.height();

                    var trlast = tableInfo.find("table tr:last");
                    if (isEmpty) {
                        if (trlast.length == 0) {
                            info.append("<tr></tr>")
                        }
                        // info.width(headerw);
                        info.height(infoh == 0 ? headerh : infoh);
                        tableSpline.height(headerh);
                    } else {
                        tableInfo.find("table").width('');
                        tableInfo.find("table").height('');

                        var tsh = headH + tableH,
                            maxh = $(element).height();
                        tableSpline.height(tsh > maxh ? maxh : tsh);

                        if (!trlast.html()) trlast.remove();
                    }

                    tableInfo.perfectScrollbar("update");
                    tableInfo.scrollLeft(preLeft); //此行代码是为了兼容火狐浏览器
                    tableInfo.scrollTop(0);
                }
                var updateFixTds = function() {
                    copyTable.html("");
                    if (!isEmpty) {
                        tableInfo.find("tr").each(function(i) {
                            copyTable.append("<tr></tr>");

                            var lastTr = copyTable.find("tr:last-child");
                            for (var c = 0; c < $scope.fixedCol; c++) {
                                lastTr.append($(this).children("td:eq(" + c + ")").clone(true));
                                //首列带有click下钻特殊处理
                                if (c == 0) {
                                    //这里单独指compile列里面的div，是因为列上很多时候有ng-repeat
                                    var Tds = lastTr.find("td");
                                    Tds.each(function() {
                                        var hm = $(this).find("div").html();
                                        $(this).html(
                                            $compile($(this).clone(true))($scope.$parent)
                                        );
                                        $(this).find("div").html(hm);
                                    });
                                }
                            }
                        });
                    }
                }
                $scope.$watch("initf5", function(n) {
                    if (angular.isDefined(n)) {
                        tableSpline.hide();
                        copyTable.html("");
                        var timer = $timeout(function() {
                            init();
                        }, 50);
                        timer.then(function() {
                            $timeout.cancel(timer);
                        });
                    }
                });
                $scope.$watch("fixChange", function(n) {
                    if (angular.isDefined(n) && $scope.infoList) {
                        copyTable.html("");
                        var timer = $timeout(function() {
                            updateBar();
                            updateFixTds();
                        }, 100);
                        timer.then(function() {
                            $timeout.cancel(timer);
                        });
                    }
                });

                $scope.$on("conentresize", function() {
                    tableInfo.perfectScrollbar("update");
                    tableInfo.scrollLeft(0);
                    tableInfo.scrollTop(0);
                    tableSpline.hide();
                    // updateBar();
                });

                var before = 0;
                tableInfo.scroll(function(e) {
                    helpTip.hide();

                    var target = e.target,
                        left = target.scrollLeft;
                    preLeft = left;
                    tableHeader.scrollLeft(left);

                    var cellCss = {
                        "position": "relative",
                        "left": left,
                        "-webkit-overflow-scroll": "touch"
                    };

                    $(element).find(".tableHeader th:lt(" + $scope.fixedCol + ")").each(function(i) {
                        $(this).css(cellCss);
                    });

                    if (left > 0) {
                        tableSpline.show();
                    } else {
                        tableSpline.hide().css('-webkit-overflow-scroll', 'auto');
                    }
                    after = $(this).scrollTop();
                    copyColWrap.scrollTop(after);
                    if ($scope.noAllScroll) { return; }
                    if (before > after) {
                        if (after < 200 && !$scope.noScroll)
                            $(".rightWrap").scrollTop(after);
                    } else {
                        if (!$scope.noScroll) {
                            if (after >= tableInfo.find("table").height() - tableInfo.height() && this.scrollTop > 0)
                                $(".rightWrap").scrollTop(this.scrollHeight);
                        } else {
                            $(".rightWrap").scrollTop($(".rightWrap").scrollTop() + this.scrollHeight);
                        }
                    }
                    before = after;
                });

                $(".rightWrap").scroll(function() {
                    helpTip.hide();
                });
                tableInfo.perfectScrollbar();
            }
        };
    }

    //拖拽排序
    var sourceId = 0;

    function dragOrder($parse) {
        return {
            restrict: 'A',
            scope: {
                dragId: "=",
                dragflag: '@'
            },
            link: function($scope, element, attrs) {
                element.attr("draggable", true);

                angular.element(element).on("dragstart", function(event) {
                    sourceId = $scope.dragId;
                });
                angular.element(element).on("dragover", function(event) {
                    event.preventDefault();
                });
                angular.element(element).on("drop", function(event) {
                    var replaceDom = $(this),
                        info = JSON.parse(replaceDom.attr("drag-info"));
                    event.preventDefault();
                    if (sourceId != info.id) {
                        $scope.$emit("dragorder", { id: sourceId, index: info.orderindex, flag: $scope.dragflag });
                    }
                });
            }
        };
    }

    function dragDrop() {
        return {
            restrict: 'A',
            scope: {
                ddList: '=',
                ddItem: '@',
            },
            link: function(scope, element, attrs) {
                element.attr("draggable", true);
                var ddItemIds = getIds();
                angular.element(element).on("dragstart", function(event) {
                    var dragIndex = ddItemIds.indexOf(JSON.parse(scope.ddItem).id);
                    event.dataTransfer.setData("txt", dragIndex);
                    // element.html("");
                    // console.log(element[0].parentElement.removeChild(element[0]));
                });
                angular.element(element).on("dragover", function(event) {
                    event.preventDefault();
                    var dragIndex = ddItemIds.indexOf(JSON.parse(scope.ddItem).id);
                    console.log(dragIndex);
                    // var newEle = element[0].cloneNode(true);
                    // console.log(newEle);
                    // element[0].parentElement.insertBefore(newEle,element[0]);
                });

                /*angular.element(element).on("dragleave",function(event){
                    event.preventDefault();
                    var dragIndex = ddItemIds.indexOf(JSON.parse(scope.ddItem).id);
                    console.log("dragleave:"+dragIndex);
                });*/

                angular.element(element).on("dragenter", function(event) {
                    event.preventDefault();
                    // var dragIndex = ddItemIds.indexOf(JSON.parse(scope.ddItem).id);

                    var dragIndex = event.dataTransfer.getData("txt");
                    console.log("dragenter：" + dragIndex);
                });

                angular.element(element).on("drop", function(event) {
                    event.preventDefault();
                    var dragIndex = event.dataTransfer.getData("txt");
                    console.log(dragIndex);
                    var dropIndex = ddItemIds.indexOf(JSON.parse(scope.ddItem).id);
                    /*console.log(scope.ddList.map(function(item){
                        return item.id;
                    }));*/
                    scope.$apply(function() {
                        var dragItems = scope.ddList.splice(dragIndex, 1);
                        scope.ddList.splice(dropIndex, 0, dragItems[0]);
                    });
                    /*console.log(scope.ddList.map(function(item){
                        return item.id;
                    }));*/
                });

                scope.$watch("ddList", function() {
                    // console.log('aaaaa');
                    ddItemIds = getIds();
                }, true);

                function getIds() {
                    return scope.ddList.map(function(item) {
                        return item.id;
                    });
                }

            }
        }
    }

    /**
     * 拖动排序指令
     * 基于Sortable
     * 需在拖动集合的元素上加上drag-drop-sort sort-event 属性
     * 在要拖动的元素上加上data-id属性和sortable-item类
     * @returns {{restrict: string, scope: {sortEvent: string}, link: link}}
     */
    function dragDropSort() {
        return {
            restrict: 'A',
            scope: {
                sortEvent: '@', //拖拽结束以后触发父类事件
                ddList: '=', //对页面右上角下拉产品进行排序
            },
            link: function(scope, element, attrs) {
                Sortable.create(element[0], {
                    group: {
                        name: 'ddsD',
                        pull: true, // 子元素是否可以被移除
                        put: true, // 是否可以被移入新元素
                    },
                    animation: 150,
                    scroll: false,
                    setData: function( /** DataTransfer */ dataTransfer, /** HTMLElement*/ dragEl) {
                        // dataTransfer.setData('Text', dragEl.textContent); // `dataTransfer` object of HTML5 DragEvent
                        // console.log(dragEl);
                    },

                    onStart: function( /**Event*/ evt) {
                        evt.oldIndex; // element index within parent
                        // console.log(evt.item.getAttribute('data-id'));
                    },
                    onEnd: function( /**Event*/ evt) {

                        // evt.oldIndex;  // element's old index within old parent
                        // evt.newIndex;
                        var newIndex = evt.newIndex,
                            oldIndex = evt.oldIndex;
                        // console.log(evt.newIndex,evt.oldIndex);
                        if (newIndex != oldIndex) {
                            var dragChils = Array.prototype.slice.call(evt.to.children).filter(function(item) {
                                return item.className.indexOf('sortable-item') > -1;
                            });
                            var leng = dragChils.length,
                                dragId = evt.to.children[newIndex].getAttribute('data-id'),
                                insertAfterId = evt.to.children[newIndex < oldIndex ? newIndex + 1 : newIndex - 1].getAttribute('data-id');
                            scope.$emit(scope.sortEvent, [dragId, insertAfterId]);
                            scope.updateList(dragId, insertAfterId, newIndex < oldIndex, newIndex > oldIndex && newIndex == leng - 1);
                        }

                    },

                    // Element is dropped into the list from another list
                    onAdd: function( /**Event*/ evt) {
                        // same properties as onEnd
                        // console.log(evt.item.getAttribute('data-id'));
                    },

                    // Changed sorting within list
                    onUpdate: function( /**Event*/ evt) {
                        // same properties as onEnd
                        // console.log(evt.item.getAttribute('data-id'));
                    },

                    // Called by any change to the list (add / update / remove)
                    onSort: function( /**Event*/ evt) {
                        // same properties as onEnd
                        // console.log(evt);
                    },

                    // Element is removed from the list into another list
                    onRemove: function( /**Event*/ evt) {
                        // same properties as onEnd
                        // console.log(evt.item.getAttribute('data-id'));
                    },

                    // Attempt to drag a filtered element
                    onFilter: function( /**Event*/ evt) {
                        var itemEl = evt.item; // HTMLElement receiving the `mousedown|tapstart` event.
                        // console.log(evt.item.getAttribute('data-id'));
                    },

                    // Event when you move an item in the list or between lists
                    onMove: function(evt, originalEvent) {
                        // Example: http://jsbin.com/tuyafe/1/edit?js,output
                        evt.dragged; // dragged HTMLElement
                        evt.draggedRect; // TextRectangle {left, top, right и bottom}
                        evt.related; // HTMLElement on which have guided
                        evt.relatedRect; // TextRectangle
                        originalEvent.clientY; // mouse position
                        // return false; — for cancel
                        // console.log(evt.dragged,evt.related);
                    },

                    // Called when creating a clone of element
                    onClone: function(evt) {
                        var origEl = evt.item;
                        var cloneEl = evt.clone;
                        // console.log(evt.item.getAttribute('data-id'));
                    },

                });

                /**
                 * 拖动元素后更新数据集合的顺序
                 * @param dragId 拖拽的元素id
                 * @param insertAfterId 向前拖，新位置后的元素；向后拖，新位置前的元素。
                 * @param isForward 是否向前拖
                 * @param isLast 新位置是否是最后一个。
                 */
                scope.updateList = function(dragId, insertAfterId, isForward, isLast) {
                    var ddIdList = scope.ddList && scope.ddList.map(function(item) {
                        return item.id;
                    });
                    var dragIdIndex = ddIdList.indexOf(parseInt(dragId)),
                        dragIdAfterIndex = ddIdList.indexOf(parseInt(insertAfterId))

                    if (dragIdIndex > -1 && dragIdAfterIndex > -1) {
                        var idsInsertAfterId = ddIdList.indexOf(parseInt(insertAfterId));
                        if (isForward) { //向前移动
                            scope.$apply(function() {
                                var dragItems = scope.ddList.splice(dragIdIndex, 1);
                                scope.ddList.splice(idsInsertAfterId, 0, dragItems[0]);
                            });
                        } else if (!isForward) { //向后移动
                            !isLast && (dragIdAfterIndex += 1); //不是最后一个时
                            scope.$apply(function() {
                                var dragItems = scope.ddList.splice(dragIdIndex, 1);
                                if (!isLast) {
                                    scope.ddList.splice(idsInsertAfterId, 0, dragItems[0]);
                                } else {
                                    scope.ddList.push(dragItems[0]);
                                }
                            });
                        }

                    }
                }
            }
        }
    }

    //消息
    function noticenews(HttpService, $rootScope, ToolService, $timeout, $state) {
        return {
            restrict: 'E',
            replace: true,
            scope: {

            },
            templateUrl: '/template/common/noticenews.html?r=' + tempVersion,
            link: function($scope, element, attrs) {
                $scope.isLookList = false;
                $scope.isDetail = false;
                $scope.isClickNew = false
                $scope.queryNotice = function() {
                    var noticePM = HttpService.getInfo("notice/findDeploy", {});
                    noticePM.then(function(data) {

                        $scope.list = data;
                        if (data) {
                            $scope.noreadList = $scope.list.filter(function(item) {
                                return item.isRead != true;
                            })
                            if ($scope.noreadList && $scope.noreadList.length > 0) {
                                var ryioUid = $.cookie("ryioUid");
                                var cacheId = localStorage.getItem("noreadId" + ryioUid);
                                var dataId = $scope.noreadList[0].id;
                                if (cacheId == dataId) {
                                    $scope.isClickNew = false
                                } else {
                                    $scope.isClickNew = true
                                }

                            }
                            $scope.newShow = true;
                            $timeout(function() {
                                $scope.newShow = false
                            }, 4000)
                        }

                    });
                    $timeout($scope.queryNotice, 1000 * 60 * 3);

                }
                $scope.queryNotice();
                // 显示消息
                $scope.changeLookShow = function() {
                    if ($rootScope.notice) {
                        $scope.isLookList = !$scope.isLookList;
                        $scope.isDetail = false;
                        $(".newsInfoWrap").css('display', 'none');

                        //缓存最新的未读消息id
                        if ($scope.noreadList && $scope.noreadList.length > 0) {
                            var id = $scope.noreadList[0].id;
                            var ryioUid = $.cookie("ryioUid");
                            localStorage.setItem("noreadId" + ryioUid, id);
                            $scope.isClickNew = false
                        }
                    } else {
                        $state.go('collect.notice')
                    }

                }

                $scope.curNoticeInfo = {};
                $scope.clickNotice = function(news) {
                    if (!news.isRead) {
                        HttpService.postInfo("notice/saveReadLog/" + news.id, {});
                    }
                    ToolService.sendWhatEvtData("readnotice", { noticeid: news.id, noticetitle: news.title });

                    news.isRead = true;
                    $scope.curNoticeInfo = news;
                    $scope.isDetail = true;

                    $scope.noreadList = $scope.list.filter(function(item) {
                        return item.isRead != true;
                    })
                }

                $scope.backList = function() {
                    $scope.isDetail = false;
                }

                angular.element(document).on("click", function() {
                    $scope.$apply(function() {
                        $scope.isLookList = false;
                    });
                });
            }
        };
    }

    function checkboxGroup() {
        return {
            restrict: 'E',
            scope: {
                list: '@', //待选数组
                selectedList: '=', //已选数组
                max: '@', //最大可选条数
                key: '@', //唯一值字段
            },
            templateUrl: '/template/common/checkboxgroup.html?r=' + tempVersion,
            link: function($scope, element, attrs) {
                var key = $scope.key;
                $scope.listJson = angular.fromJson($scope.list);
                // $scope.selectedItem = {};
                $scope.filterListJson = filterListJson();
                $scope.selectedItemIds = [];

                $scope.selectedThis = function(e, item) {
                    var isActive = e.target.classList.contains('active'),
                        index = $scope.selectedItemIds.indexOf(item[key]);
                    if (!isActive && index == -1 && (!$scope.max || ($scope.max && $scope.selectedList.length < $scope.max))) {
                        $scope.selectedList.push(item);
                        ($scope.selectedItemIds.indexOf(item[key]) == -1) && $scope.selectedItemIds.push(item[key]);
                    } else if (isActive && index > -1) {
                        $scope.selectedList.splice(index, 1);
                        ($scope.selectedItemIds.indexOf(item[key]) > -1) && $scope.selectedItemIds.splice(index, 1);
                    }
                }

                $scope.$watch("{searchWord:searchWord,list:list}", function() {
                    $scope.listJson = angular.fromJson($scope.list);
                    $scope.filterListJson = filterListJson();
                }, true);

                $scope.$watch("selectedList", function() {
                    $scope.selectedItemIds = $scope.selectedList.map(function(item) {
                        return item[key];
                    });
                }, true);

                function filterListJson() {
                    return $scope.listJson.filter(function(item) {
                        if ($scope.searchWord) {
                            return item.name.indexOf($scope.searchWord) > -1;
                        } else {
                            return true;
                        }
                    });
                }

                $scope.cancelSelected = function(item) {
                    var index = $scope.selectedItemIds.indexOf(item[key]);
                    (index) > -1 && $scope.selectedList.splice(index, 1);
                    document.querySelector("ul li input[value='" + item.value + "']").checked = false;
                }
            }
        }

    }

    /**
     * 生成二维码
     * @param $timeout
     * @returns {{restrict: string, scope: {url: string}, link: link}}
     */
    function qrCode($timeout) {
        return {
            restrict: 'A',
            scope: {
                url: '='
            },
            link: function($scope, element, attrs) {
                // console.log(element,$scope.url);
                var qr = new QRCode(element[0], {
                    width: 60,
                    height: 60
                });
                qr.makeCode($scope.url);
                // element[0].childer.src = "";
                $timeout(function() {
                    console.log(element[0].children[1].src);
                    var src = element[0].children[1].src;
                    element[0].nextElementSibling.href = src;
                    element[0].nextElementSibling.download = 'aaa.png';
                }, 200);
                // console.log(element[0].nextElementSibling);
            }
        }
    }

    function noPermission(HttpService, $rootScope, ToolService, $timeout, $filter) {
        return {
            restrict: 'AE',
            // transclude: {
            // 	desc:'noPermissionDesc',
            // 	modaltitle:'noPermissionTitle'
            // },
            scope: {
                pagePath: '=',
                desc: '=',
            },
            templateUrl: '/template/common/noPermission.html?r=' + tempVersion,
            link: function($scope, element, attrs) {
                $scope.more = function() {
                    window.open('http://docs.trackingio.com/' + $scope.desc.help_page)
                };
                $scope.openModal = function() {
                    $scope.modalShow = true
                };
                $scope.$watch('pagePath', function(n) {
                    $scope.menuId = $rootScope.permissionMenus[$scope.pagePath] ? $rootScope.permissionMenus[$scope.pagePath].menuid : '';
                });
                $scope.save = function() {
                    var verPar = {
                        linkPhone: {
                            key: 'cellphone',
                            val: $scope.linkPhone
                        },
                        linkUser: {
                            key: 'isNull',
                            val: $scope.linkUser
                        },
                    }
                    $scope.tip = formJudge(verPar);
                    if ($scope.tip.succ != true) {
                        ToolService.showTips($filter('translate')("信息没填全或数据格式有误，请检查"));
                        return false;
                    }
                    if ($scope.pagePath && $scope.menuId) {
                        $scope.request()
                    } else {
                        $scope.modalShow = false;
                        $timeout(function() {
                            $scope.save()
                        }, 500)
                    }
                };
                $scope.request = function() {
                    var params = {
                        menuName: $scope.pagePath,
                        linkPhone: $scope.linkPhone,
                        linkUser: $scope.linkUser,
                        menuId: $scope.menuId,
                    };
                    var noPermissionPM = HttpService.postInfo("account/authapply", params);
                    noPermissionPM.then(function(data) {
                        if (data.accoutId) {
                            ToolService.showTips($filter('translate')("提交成功"));
                        } else {
                            ToolService.showTips($filter('translate')(data.message));
                        }
                        $scope.modalShow = false;
                    })
                }
            }
        }
    }
})();