(function () {
    angular.module("app.collect")
        .controller("admobinfoCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "$timeout", "$filter", "$translate", "$state", "$http","UtilService", admobinfoCtrl]);

    function admobinfoCtrl($rootScope, $scope, HttpService, ToolService, $timeout, $filter, $translate, $state, $http, UtilService) {
        $scope.report = false;
        $scope.initLoading = function () {
            $scope.campListLoading = true;
        };
        $scope.initLoading();
        $scope.$on('curdate', function (e, msg) {
            $scope.date = msg.date;
        });

        //平台筛选
        $scope.getAdIncome = function(){
            var incomePM = HttpService.getInfo("mng/advertising/platform");
            incomePM.then(function(data){
                var data2 = JSON.parse(JSON.stringify(data));
                data2.unshift({id:'',name:$filter('translate')('选择变现平台')});
                for(var i in data){
                    var item = data[i]
                    item.cid = item.id;
                }
                $scope.channelFilterData = data.filter(function(item){
                    return item.id != 'topon' && item.id != 'adtiming'
                });
                $scope.AdIncomeInit= $scope.incomeId = data2[0].id;
                $scope.AdIncomeList = data2.filter(function(item){
                    return item.id != 'topon' && item.id != 'vungle' && item.id != 'adtiming'
                });;

                $scope.AdIncomeInit1= $scope.incomeId1 = data2[0].id;
                $scope.AdIncomeList1 = data2.filter(function(item,index){
                    return item.id=='' || item.id=='csj' || item.id=='topon' || item.id == 'adtiming'
                });
            })
        }
        $scope.getAdIncome();


        $scope.$on('AdIncomeId', function (e, msg) {
            $scope.incomeId= msg.info.id;
        });

        $scope.showBtn = true;
        $scope.addMore = function () {
            $scope.showBtn = !$scope.showBtn;
            $scope.activeCidList = []

        }
        $scope.okSelect = function () {
            $scope.showBtn = !$scope.showBtn;
            if($scope.activeCidList.length == 0){
                $scope.activeCidList = ['all']
            }
            if($scope.menuLevel == '4') {
                $scope.queryAdMngReport()
            } else {
                $scope.queryReport();
            }
        }
        $scope.cancel = function () {
            $scope.showBtn = !$scope.showBtn;
            if($scope.showBtn){
                // 单选
                $scope.activeCidList = ['all']
            }else{
                $scope.activeCidList = [] 
            }
        }

        //变现收入管理
        $scope.menuLevel = '1';
        $scope.uploadXlsFile = function(){
            $scope.menuLevel = '3';
            $scope.resetUpload();
        }

        $scope.resetUpload = function(){
            $scope.AdIncomefresh = ++rmd;
            $scope.eventNameInit = '选择变现平台';
            $scope.uploadType = 'noupload';
            $scope.uploadname ='';
        }
        //文件未上传状态
        $scope.uploadType = 'noupload';
        //选择文件
        $scope.$on("myFile",function(e,file){
            if(!$scope.incomeId){
                ToolService.showTips($filter('translate')("请先选择变现平台"));
                return false;
            }
            var name = file.name;
            var subIdx = name.lastIndexOf(".") + 1, subTxt = name.substring(subIdx);
            if (subTxt == 'xls' || subTxt == 'xlsx'|| subTxt == 'csv') {
                // var size = file.size;
                    $scope.uploadname = name;
                    $scope.uploadType = 'inupload';
                    $scope.uploadData = file;
            }
            else{
                ToolService.showTips($filter('translate')("仅支持excel"));
                return false;
            }
        });
         //上传
    $scope.uploadFile = function(){
        if(!$scope.incomeId){
            ToolService.showTips($filter('translate')("请先选择变现平台"));
            return false;
        }
        if($scope.uploadType != 'inupload'){
            ToolService.showTips($filter('translate')("请先上传文件"));
            return false;
        }
        var channelId = $scope.incomeId,appid  = UtilService.getCookie("ryioLastApp");//从cookie中取出产品id
        if(!channelId || !appid){
            ToolService.showTips($filter('translate')("渠道或者产品信息没有取到。"));
            return false;
        }
        var fd = new FormData();
        fd.append('file', $scope.uploadData);
        ToolService.showLoading();
        $http({
            method: 'POST',
            url: "api/mng/advertising/upload/" + channelId + "/" + appid,
            data: fd,
            headers: { 'Content-Type': undefined },
            transformRequest: angular.identity
        })
            .success(function (data) {
                if(data.code == 200){
                    data = data.content;
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("上传成功"));
                    $scope.goPagelevel();

                }else{
                    ToolService.showTips(data.message);
                }
                
            })
            .error(function (data) {
                $scope.uploadType = 'noupload';
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("网络超时，请重新上传"));
            });
    }
        // 激活人渠道cid
        $scope.activeCidList = ['all']
        $scope.checkAllChannel = function(flag){
            var itemIndex = $scope.activeCidList.indexOf("all");
            if ($scope.showBtn) {
                // 单选
                $scope.activeCidList = ['all']
                if($scope.menuLevel == '4') {
                    $scope.queryAdMngReport()
                } else {
                    $scope.queryReport();
                }
            } else {
                // 多选
                if (itemIndex != -1){
                    $scope.activeCidList = []
                }else{
                    $scope.activeCidList = ['all']
                    var channelLen = $scope.channelFilterData.length;
                    for (var i = 0; i < channelLen; i++){
                        var item = $scope.channelFilterData[i];
                        var iIndex = $scope.activeCidList.indexOf(item.cid);
                        if (iIndex == -1){
                            $scope.activeCidList.push(item.cid);
                        }
                    }
                }
            }
        }
        $scope.selectChannel = function (item) {
            if ($scope.showBtn) {
                // 单选
                $scope.activeCidList = [item.cid]
                if($scope.menuLevel == '4') {
                    $scope.queryAdMngReport()
                } else {
                    $scope.queryReport();
                }
            }else{
                // 多选
                var itemIndex = $scope.activeCidList.indexOf(item.cid);
                if(itemIndex != -1){
                    // 取消
                    $scope.activeCidList.splice(itemIndex, 1);
                    var allIndex = $scope.activeCidList.indexOf('all');
                    if (allIndex != -1){
                        $scope.activeCidList.splice(allIndex, 1);
                    }
                }else{
                    // 选中
                    $scope.activeCidList.push(item.cid);
                    var fals = true;
                    var channelLen = $scope.channelFilterData.length;
                    for (var i = 0; i < channelLen; i++){
                        var item = $scope.channelFilterData[i];
                        if ($scope.activeCidList.indexOf(item.cid) == -1){
                            fals = false;
                            break;
                        }
                    }
                    if (fals){
                        $scope.activeCidList.push('all');
                    }
                }
            }
            if($scope.selectFlag != "adcreative"){
                $scope.currentReports = null;
                $scope.allSubInfo = [];
            }
        }

        
        $scope.$watch("packageID", function(n) {
            if (angular.isDefined(n) && $scope.infoList && $scope.isandroid) { 
                $scope.queryReport(false, false);
            }
        });

        var selectFlagIndex = 0;
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
            $scope.MainSuper = true;
        } else {
            $scope.MainSuper = false;
        }
        $scope.$on("conentresize", function () {
            if ($scope.campList) $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);

        });
        $scope.clickBase = function (obj) {
            if (obj.isedit == false) { return false; }
            if (obj.fieldcode == 'rate_add_daily' && obj.ischeck == false) {
                $scope.baseList.filter(function (value) {
                    if (value.fieldcode == 'num_payer_new_user' && value.ischeck == false) {
                        value.ischeck = true;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            } else if (obj.fieldcode == 'num_payer_new_user' && obj.ischeck == true) {
                $scope.baseList.filter(function (value) {
                    if (value.fieldcode == 'rate_add_daily' && value.ischeck == true) {
                        value.ischeck = false;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            }
            obj.ischeck = !obj.ischeck;
            if (obj.status == 0) {
                obj.status = 1
            } else {
                obj.status = 0
            }
        }
        $scope.checkAll = function (type) {
            if (!$scope.baseList) { return false; }

            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function (item) {
                if (item.type == type && item.isedit) {
                    if (item.ischeck == bol) {
                        if (item.status == 0) {
                            item.status = 1
                        } else {
                            item.status = 0
                        }
                        item.ischeck = !bol;
                    }

                }
            });
        }
        $scope.hasCheckAll = function (type) {
            if (!$scope.baseList) { return false; }
            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }

        $scope.hasType = function (type) {
            if (!$scope.baseList) { return false; }

            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type) {
                    count = 1;
                    break;
                }
            }
            return count > 0;
        }
        $scope.cleanEvent = "cleanEvent"
        $scope.change = function (title){
            //向子级作用域广播cleanEvent事件
            $scope.$broadcast($scope.cleanEvent);
       };
        //关闭
        $scope.closeArouseTip = function () {
            $scope.arouseTips = false;
            var url = "login/arouse_tips";
            var closePM = HttpService.postInfo(url);
            closePM.then(function (data) {
                $rootScope.arouseTips = false;
            });
        }
        $scope.showBaseWin = function () {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function (flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function (item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function () {
            ToolService.sendBehaviorUv("okBase");
            $scope.queryReport();
            var url = "/campaign/viewcolumn/admobinfo?viewcolumn=";
            var vcol = [];
            $scope.baseList.filter(function (item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            var updatePM = HttpService.postInfo($scope.appid + url + vcol.join(","), {});
            updatePM.then(function (data) { });
            $scope.hideDialog(-1);
        }
        $scope.selectFlag = "adgroup";
        $scope.scenesHide = false;
        $scope.changeSelectFlag = function (flag) {
            ToolService.sendBehaviorUv(flag);
            if ($scope.selectFlag != flag) {
                $scope.infofalg = false;
                $scope.currentReports = null;
                $scope.allSubInfo = [];
            }
            $scope.selectFlag = flag;
            selectFlagIndex++;
            $scope.filterTxt = "";
            $scope.nameleve1 = ""
            $scope.nameleve2 = ""
            $scope.change();
        }

        $scope.packList = ToolService.getadvPackTypeList();
        $scope.packageInit = $scope.packList[0].id;
        $scope.$on("packid", function (e, msg) {
            $scope.packageID = msg.info.id;
        });


        $scope.$on('flipinfo', function (e, msg) {
            if (msg.listkey == 'admng') {
                $scope.flipPage1 = msg;
                $scope.fixrefresh1 = ++rmd;
            } else {
                $scope.flipPage = msg;
                $scope.fixrefresh = ++rmd;
            }
        });
        $scope.showZero = false;
        $scope.listRefresh = 1;

        $scope.queryReport = function(){
            ToolService.showLoading();
            var params = ToolService.getParams($scope);
            var qReport = "advertisinginfo_cash_day"
            params.datatype = 'list';
            params.viewtype = 'date';
            params.func = 'advertisinginfo';
            params.viewcolumn = $scope.getViewColumns();
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }
            if($scope.activeCidList.indexOf("all") == -1 && $scope.activeCidList.length>0){
                params.plat_type_v = $scope.activeCidList.join(',');
            }
            bxPM = HttpService.getReportData(qReport, params);
            
            var condiParams = '';
            condiParams && (params = condiParams);
            params.showall0 = $scope.showZero;
            $scope.campListLoading = false;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("流量变现-变现广告"), qReport, params);
            bxPM.then(function(data){
                $scope.campListLoading = false;
                $scope.campCashList = $scope.campList = data;
                $scope.infoListTotal = data.val[0];
                $scope.campAllList = data.val.slice(1);
                $scope.campNoZeroList = $scope.campAllList.filter(function (item, index) {
                    return item.isall0 == false;
                });
                if ($scope.showZero) {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
                $scope.$broadcast("conentresize", true);
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
                ToolService.hideLoading();
            })

        }
        //请求路径后缀
        function getSubFix(flag) {
            var subfix = flag;
            return subfix;
        }

        $scope.getViewColumns = function () {
            var vcol = [];
            $scope.baseList && $scope.baseList.filter(function (item) {
                if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention'))) {
                    //没有付费权限，不能查看付费
                } else if (item.type == 'base' && item.fieldcode == 'wake_num' && $rootScope.arouseStatus != 2) {
                    //没有唤醒权限，不能查看付费
                } else {
                    if (item.ischeck == true) {
                        vcol.push(item.fieldcode);
                    }
                }
            });
            return vcol.join(",");
        }

        $scope.filterByTxt = function (txt) {
            $scope.filterTxt = txt;
            $scope.queryReport()
        }

        // 显示全0数据
        $scope.clickZero = function () {
            ToolService.sendBehaviorUv("clickZero");
            $scope.showZero = !$scope.showZero;
            reCrateListCondition($scope.listCondition);
            if ($scope.showZero) {
                $scope.infoList = $scope.campAllList;
            } else {
                $scope.infoList = $scope.campNoZeroList;
            }
            $scope.fixrefresh = ++rmd;
        }

        /**
         * 重新生成‘导出’参数，添加‘显示全0数据’的值进去
         * @param listCondition
         */
        function reCrateListCondition(listCondition) {
            var isOk = false;
            if (listCondition && listCondition.conditions) {
                var cond = JSON.parse(listCondition.conditions);
                if (cond) {
                    cond.showall0 = $scope.showZero;
                    listCondition.conditions = JSON.stringify(cond);
                    isOk = true;
                }
            }
            if (!isOk) {
                ToolService.showTips("");
            }
        }

        var fixChange = true,
            orderBy = $filter('orderBy'),
            rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function (predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.listRefresh = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("appid", function () {
            $scope.allSubInfo = [];
            $scope.currentReports = null;
        });

        $scope.$watch("date.startDate+date.endDate", function () {
            if ($scope.allSubInfo && $scope.allSubInfo.length > 0) {
                $scope.allSubInfo.pop()
            }
        });
        var oldappid = "";
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,selectFlag:selectFlag,lang:lang}", function (n, o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)) { return false; }
            if (!$scope.baseList || oldappid != $scope.appid) {
                //指标列表
                var basePM = HttpService.getInfo($scope.appid + "/campaign/viewcolumn/findall/admobinfo");
                basePM.then(function (data) {
                    $scope.baseList = data;
                    $scope.sdkList = data.filter(function (item) {
                        return item.type == 'sdkevent';
                    });
                    $scope.sdkeventNew = data.filter(function (item) {
                        return item.type == 'sdkevent_new';
                    });
                    $scope.queryReport()

                });
            }else {
                $scope.queryReport()
            }

            oldappid = $scope.appid;
            //语言切换
            if (n.lang && o.lang && n.lang !== o.lang) {
                init();
            }
            if (n.appid != o.appid) {
                $scope.allSubInfo = [];
                $scope.currentReports = null;
            }
        }, true);

        $scope.goPagelevel = function() {
            $scope.menuLevel = '2';
            $scope.queryReport();
        }

        $scope.$watch("appid", function () {
            if ($scope.appid) {
                $scope.industory = $scope.appInstance.industory;
                $scope.getAccountCount();
                $scope.getAccountList();
            }
        });


        //数据上传  绑定变现账号
        $scope.bindAccountObj = {
            csj: {
                inputname1: 'user_id',
                inputname2: 'secure_key',
                tip: '请与您的穿山甲BD联系获取user_id、secure_key'
            },
            topon: {
                inputname1: '账号名称',
                inputname2: 'publisher_key',
                tip: 'TopOn后台账号信息页可查看帐号名称、publisher_key'
            },
            adtiming: {
                inputname1: '用户名',
                inputname2: 'API Key',
                tip: '在AdTiming的Reporting页面即可复制Reporting API Key'
            }
        }
        $scope.accountCount = 0;
        $scope.getAccountCount = function() {
            var countPM = HttpService.getInfo("mng/advertising/binduser/count?app="+$scope.appid);
            countPM.then(function (data) {
                if(data.content==0){
                    $scope.accountCount = data.content
                }else{
                    $scope.accountCount = data
                }
                
            });
        }
        $scope.accountList = [];
        $scope.getAccountList = function() {
            $scope.accountListLoading = true;
            var listPM = HttpService.getInfo("mng/advertising/binduser/list?app="+$scope.appid);
            listPM.then(function (data) {
                $scope.accountListLoading = false;
                $scope.accountList = data;
            });
        }
        $scope.AdIncome1fresh = 0;
        $scope.$on('AdIncomeId1', function (e, msg) {
            $scope.incomeId1= msg.info.id;
        });
        $scope.addAcount = function() {
            $scope.AdIncomeInit1 = $scope.incomeId1 = '';
            $scope.user_id = '';
            $scope.secure_key = '';
            $scope.AdIncome1fresh++
            ToolService.showAlp();
            $scope.addstatus = true;
            $scope.editAccountId = '';
            $scope.tip = {};
        }
        $scope.closeAdd = function() {
            ToolService.hideAlp();
            $scope.addstatus = false;
        }
        $scope.saveAccount = function() {
            var verPar = {
                incomeId1: {
                    key: 'isNull',
                    val: $scope.incomeId1
                },
                user_id: {
                    key: 'isNull',
                    val: $scope.user_id+''
                },
                secure_key: {
                    key: 'isNull',
                    val: $scope.secure_key+''
                }
            };
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var params = {
                typeName: $scope.incomeId1,
                userId: $scope.user_id,
                secureKey: $scope.secure_key,
                app: $scope.appid,
            }
            $scope.editAccountId ? params.id = $scope.editAccountId : '';
            ToolService.showLoading();
            var savePM = HttpService.postInfo("mng/advertising/binduser/save",params);
            savePM.then(function (data) {
                ToolService.hideLoading();
                if(data.message){
                    ToolService.showTips(data.message)
                }else{
                    $scope.closeAdd();
                    $scope.showAccountList();
                    $scope.getAccountList();
                    $scope.getAccountCount();
                }
            });
        }
        $scope.showAccountList = function() {
            ToolService.showAlp();
            $scope.accountListstatus = true;
        }
        $scope.closeList = function() {
            ToolService.hideAlp();
            $scope.accountListstatus = false;
        }
        $scope.delAccount = function(id) {
            $scope.delStatus = true;
            $scope.delAccountId = id;
        }
        $scope.delAccountSure = function() {
            ToolService.showLoading();
            var statusPM = HttpService.getInfo("mng/advertising/binduser/delete?id="+$scope.delAccountId);
            statusPM.then(function (data) {
                ToolService.hideLoading();
                $scope.getAccountCount();
                $scope.getAccountList();
            });
        }
        $scope.changeAccountStatus = function(info) {
            var params = {
                id: info.id,
                status: !info.status
            }
            ToolService.showLoading();
            var statusPM = HttpService.postInfo("mng/advertising/binduser/openandclose",params);
            statusPM.then(function (data) {
                ToolService.hideLoading();
                $scope.getAccountList();
            });
        }
        $scope.editAccount = function(info) {
            $scope.AdIncomeInit1 = $scope.incomeId1 = info.typeName;
            $scope.user_id = info.userId;
            $scope.secure_key = info.secureKey;
            $scope.editAccountId = info.id;
            $scope.AdIncome1fresh++;
            $scope.incomeId1name = $scope.getIncomeName(info.typeName)
            $scope.accountListstatus = false;
            $scope.addstatus = true;
        }
        $scope.getIncomeName = function(id) {
            return id?$scope.AdIncomeList1&&$scope.AdIncomeList1.filter(function(item){
                return item.id == id
            })[0].name:''
        }

        //同步
        $scope.$on('synchronizedate',function(e,msg){
            $scope.synchronizedate = msg;
        });
        $scope.$watch("synchronizedate",function(){
            if(angular.isDefined($scope.synchronizedate)){
                $scope.synchronizedatestr = $scope.synchronizedate.startDate + $filter('translate')("至") + $scope.synchronizedate.endDate;
            }
        });
        $scope.synchronize = function(id) {
            $scope.synchronizedate = ToolService.getToday();
            $scope.accountListstatus = false;
            $scope.synchronizeModalStatus = true;
            $scope.synchronizeId = id;
        }
        $scope.closeSynchronizeModal = function() {
            ToolService.hideAlp();
            $scope.synchronizeModalStatus = false;
        }
        $scope.saveSynchronize = function() {
            $scope.closeSynchronizeModal();
            ToolService.showLoading();
            var params = {
                id: $scope.synchronizeId,
                startDate: $scope.synchronizedate.startDate,
                endDate: $scope.synchronizedate.endDate,
            }
            var statusPM = HttpService.getInfo("mng/advertising/syncdata",params);
            statusPM.then(function (data) {
                ToolService.hideLoading();
                ToolService.showTips("正在同步，请稍后查看数据变化",3000)
            });
        }

        //广告位管理
        $scope.adtypefresh = 0;
        $scope.getAdtypeList = function() {
            var adPM = HttpService.getInfo('mng/advertising/adrename/list');
            adPM.then(function(data){
                // var data2 = JSON.parse(JSON.stringify(data));
                data.unshift({id:'',name:$filter('translate')('请选择广告类型')});
                $scope.adtypeList = data;
                $scope.adtypeInit = $scope.adType =  '';
            })
        }
        $scope.getAdtypeList();
        $scope.$on('adtype', function (e, msg) {
            $scope.adType= msg.info.id;
            $scope.adTypeName = msg.info.name;
        });
        $scope.adMng = function() {
            $scope.menuLevel='4';
            $scope.showBtn = true;
            $scope.activeCidList = ['all'];
            $scope.queryAdMngReport();
        }
        $scope.goBack = function() {
            $scope.menuLevel='1';
            $scope.showBtn = true;
            $scope.activeCidList = ['all'];
            $scope.queryReport();
        }
        $scope.queryAdMngReport = function(){
            var params = ToolService.getParams($scope);
            delete params.startdate
            delete params.enddate
            var qReport = "advertisinginfo_adname_rename"
            params.datatype = 'list';
            if($scope.activeCidList.indexOf("all") == -1 && $scope.activeCidList.length>0){
                params.adplatform = $scope.activeCidList.join(',');
            }
            $scope.adMngListLoading = true;

            adMngPM = HttpService.getReportData(qReport, params);
            adMngPM.then(function(data){
                $scope.adMngListLoading = false;
                $scope.campList1 = data;
                $scope.infoList1 = data.val;
                $scope.$broadcast("conentresize", true);
                $scope.initrefresh1 = ++rmd;
                $scope.fixrefresh1 = ++rmd;
                $scope.sortCol1 = "";
            })

        }
        $scope.order1 = function (predicate, reverse) {
            $scope.sortCol1 = predicate;
            $scope.infoList1 = orderBy($scope.infoList1, predicate, reverse);
            $scope.listf5_1 = ++rmd;
            // $scope.listRefresh = ++rmd;
            $scope.fixrefresh1 = ++rmd;
        };
        $scope.adEditModal = false;
        $scope.editAdMng = function(info) {
            $scope.adappkey = info.appid;
            $scope.platform = info.adplatform;
            $scope.adplatformNname = info.adplatform_name;
            $scope.adid = info.adid;
            $scope.adName = info.ad_name;
            $scope.adtypeInit = $scope.adType = info.ad_type;
            $scope.adTypeName = info.ad_type_name;
            $scope.adtypefresh++
            ToolService.showAlp();
            $scope.adEditModal = true;
            $scope.tip = {};
        }
        $scope.saveAdMng = function() {
            var verPar = {
                adType: {
                    key: 'isNull',
                    val: $scope.adType+''
                },
                adName: {
                    key: 'isNull',
                    val: $scope.adName+''
                }
            };
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var params = {
                adid: $scope.adid,
                platform: $scope.platform,
                adName: $scope.adName,
                adTypeName: $scope.adTypeName,
                adType: $scope.adType,
                appid: $scope.adappkey,
            }
            ToolService.showLoading();
            var savePM = HttpService.postInfo("mng/advertising/adrename/save",params);
            savePM.then(function (data) {
                console.log(data)
                ToolService.hideLoading();
                if(data.code != 200){
                    ToolService.showTips(data.message)
                }else{
                    ToolService.showTips('编辑成功')
                    $scope.closeAdModal();
                    $scope.queryAdMngReport();
                }
            });
        }
        $scope.closeAdModal = function() {
            $scope.adEditModal = false;
            ToolService.hideAlp();
        }
    }
})();