(function () {
    angular.module("app.collect")
        .controller("advertisinginfoCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "$timeout", "$filter", "$translate", "$state", "$http","UtilService", advertisinginfoCtrl]);

    function advertisinginfoCtrl($rootScope, $scope, HttpService, ToolService, $timeout, $filter, $translate, $state, $http, UtilService) {
        $scope.report = false;
        $scope.initLoading = function () {
            $scope.campListLoading = true;
        };
        $scope.initLoading();
        $scope.$on('curdate', function (e, msg) {
            $scope.date = msg.date;
        });
        $scope.getAdChannel = function(){
            var adPM = HttpService.getInfo("mng/channel/findChannelAdvertising");
            adPM.then(function(data){
                $scope.channelFilterData = data;
            })
        }
        $scope.getAdIncome = function(){
            var incomePM = HttpService.getInfo("mng/advertising/platform");
            incomePM.then(function(data){
                var data2 = JSON.parse(JSON.stringify(data));
                data2.unshift({id:'',name:$filter('translate')('选择变现平台')});
                for(var i in data){
                    var item = data[i]
                    item.cid = item.id;
                }
                $scope.incomeData = data;
                $scope.AdIncomeInit= $scope.incomeId = data2[0].id;
                $scope.AdIncomeList = data2;
            })
        }
        $scope.getAdChannel();
        $scope.getAdIncome();


        $scope.$on('AdIncomeId', function (e, msg) {
            $scope.incomeId= msg.info.id;
        });

        $scope.showBtn = true;
        $scope.addMore = function () {
            $scope.showBtn = !$scope.showBtn;
            $scope.activeCidList = []

        }

        $scope.okSelect = function () {
            $scope.showBtn = !$scope.showBtn;
            if($scope.activeCidList.length == 0){
                $scope.activeCidList = ['all']
            }
            if($scope.incomeManagement){
                $scope.queryReport();
            }else{
                $scope.query(false, false);
            }
            
            
        }
        $scope.cancel = function () {
            $scope.showBtn = !$scope.showBtn;
            if($scope.showBtn){
                // 单选
                $scope.activeCidList = ['all']
            }else{
                $scope.activeCidList = [] 
            }
        }

        $scope.getAdvertiseridLists = function(){
            var params = {
                startdate: $scope.date.startDate,
                enddate: $scope.date.endDate,
                datatype: 'list',
                appid: $scope.appid
            }
            params[$scope.selectFlag+'_id'] = 1
            $scope.advertiseridLists = []
            var adPM = HttpService.getInfo("mng/advertising/advertiserid/list",params);
            adPM.then(function(data){
                var adlist = data;
                adlist.forEach(function(value){
                    if (value == -1) {
                        $scope.advertiseridLists.push({
                            id: -1,
                            name: '未绑定'
                        })
                    } else {
                        $scope.advertiseridLists.push({
                            id: value,
                            name: value
                        })
                    }
                })
                
            })
        }
        
        $scope.advertiseridInits = '不筛选投放账号'
        $scope.$on("advertiserids", function(e, msg) {
            $scope.advertiserids = msg.info;
            $scope.query(false, false);
        });

        //变现收入管理
        $scope.incomeManagement = false;
        $scope.menuLevel = '1';
        $scope.addManage = function(){
            $scope.incomeManagement = true;
            $scope.menuLevel = '2';
            $scope.queryReport();

        }
        $scope.uploadXlsFile = function(){
            $scope.menuLevel = '3';
            $scope.resetUpload();
        }

        $scope.resetUpload = function(){
            $scope.AdIncomefresh = ++rmd;
            $scope.eventNameInit = '选择变现平台';
            $scope.uploadType = 'noupload';
            $scope.uploadname ='';
        }
        //文件未上传状态
        $scope.uploadType = 'noupload';
        //选择文件
        $scope.$on("myFile",function(e,file){
            if(!$scope.incomeId){
                ToolService.showTips($filter('translate')("请先选择变现平台"));
                return false;
            }
            var name = file.name;
            var subIdx = name.lastIndexOf(".") + 1, subTxt = name.substring(subIdx);
            if (subTxt == 'xls' || subTxt == 'xlsx'|| subTxt == 'csv') {
                // var size = file.size;
                    $scope.uploadname = name;
                    $scope.uploadType = 'inupload';
                    $scope.uploadData = file;
            }
            else{
                ToolService.showTips($filter('translate')("仅支持excel"));
                return false;
            }
        });
         //上传
    $scope.uploadFile = function(){
        if(!$scope.incomeId){
            ToolService.showTips($filter('translate')("请先选择变现平台"));
            return false;
        }
        if($scope.uploadType != 'inupload'){
            ToolService.showTips($filter('translate')("请先上传文件"));
            return false;
        }
        var channelId = $scope.incomeId,appid  = UtilService.getCookie("ryioLastApp");//从cookie中取出产品id
        if(!channelId || !appid){
            ToolService.showTips($filter('translate')("渠道或者产品信息没有取到。"));
            return false;
        }
        var fd = new FormData();
        fd.append('file', $scope.uploadData);
        ToolService.showLoading();
        $http({
            method: 'POST',
            url: "api/mng/advertising/upload/" + channelId + "/" + appid,
            data: fd,
            headers: { 'Content-Type': undefined },
            transformRequest: angular.identity
        })
            .success(function (data) {
                if(data.code == 200){
                    data = data.content;
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("上传成功"));
                    $scope.goPagelevel();

                }else{
                    ToolService.showTips(data.message);
                }
                
            })
            .error(function (data) {
                $scope.uploadType = 'noupload';
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("网络超时，请重新上传"));
            });
    }
        // 激活人渠道cid
        $scope.activeCidList = ['all']
        $scope.checkAllChannel = function(flag){
            var itemIndex = $scope.activeCidList.indexOf("all");
            if ($scope.showBtn) {
                // 单选
                $scope.activeCidList = ['all']
                if(flag == 1){
                    $scope.query(false, false);
                }else{
                    $scope.queryReport();
                }
            } else {
                // 多选
                if (itemIndex != -1){
                    $scope.activeCidList = []
                }else{
                    $scope.activeCidList = ['all']
                    var channelLen = $scope.channelFilterData.length;
                    for (var i = 0; i < channelLen; i++){
                        var item = $scope.channelFilterData[i];
                        var iIndex = $scope.activeCidList.indexOf(item.cid);
                        if (iIndex == -1){
                            $scope.activeCidList.push(item.cid);
                        }
                    }
                }
            }
        }
        $scope.selectChannel = function (item,flag) {
            if ($scope.showBtn) {
                // 单选
                $scope.activeCidList = [item.cid]
                if(flag == 1){
                    $scope.query(false, false);
                }else{
                    $scope.queryReport();
                }
            }else{
                // 多选
                var itemIndex = $scope.activeCidList.indexOf(item.cid);
                if(itemIndex != -1){
                    // 取消
                    $scope.activeCidList.splice(itemIndex, 1);
                    var allIndex = $scope.activeCidList.indexOf('all');
                    if (allIndex != -1){
                        $scope.activeCidList.splice(allIndex, 1);
                    }
                }else{
                    // 选中
                    $scope.activeCidList.push(item.cid);
                    var fals = true;
                    var channelLen = $scope.channelFilterData.length;
                    for (var i = 0; i < channelLen; i++){
                        var item = $scope.channelFilterData[i];
                        if ($scope.activeCidList.indexOf(item.cid) == -1){
                            fals = false;
                            break;
                        }
                    }
                    if (fals){
                        $scope.activeCidList.push('all');
                    }
                }
            }
            if($scope.selectFlag != "adcreative"){
                $scope.currentReports = null;
                $scope.allSubInfo = [];
            }
        }

        
        $scope.$watch("packageID", function(n) {
            if (angular.isDefined(n) && $scope.infoList && $scope.isandroid) { 
                $scope.query(false, false);
            }
        });

        var selectFlagIndex = 0;
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
            $scope.MainSuper = true;
        } else {
            $scope.MainSuper = false;
        }
        $scope.$on("conentresize", function () {
            if ($scope.campList) $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);

        });
        $scope.clickBase = function (obj) {
            if (obj.isedit == false) { return false; }
            if (obj.fieldcode == 'rate_add_daily' && obj.ischeck == false) {
                $scope.baseList.filter(function (value) {
                    if (value.fieldcode == 'num_payer_new_user' && value.ischeck == false) {
                        value.ischeck = true;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            } else if (obj.fieldcode == 'num_payer_new_user' && obj.ischeck == true) {
                $scope.baseList.filter(function (value) {
                    if (value.fieldcode == 'rate_add_daily' && value.ischeck == true) {
                        value.ischeck = false;
                        if (value.status == 0) {
                            value.status = 1
                        } else {
                            value.status = 0
                        }
                    }
                })
            }
            obj.ischeck = !obj.ischeck;
            if (obj.status == 0) {
                obj.status = 1
            } else {
                obj.status = 0
            }
        }
        $scope.checkAll = function (type) {
            if (!$scope.baseList) { return false; }

            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function (item) {
                if (item.type == type && item.isedit) {
                    if (item.ischeck == bol) {
                        if (item.status == 0) {
                            item.status = 1
                        } else {
                            item.status = 0
                        }
                        item.ischeck = !bol;
                    }

                }
            });
        }
        $scope.hasCheckAll = function (type) {
            if (!$scope.baseList) { return false; }
            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }

        $scope.hasType = function (type) {
            if (!$scope.baseList) { return false; }

            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type) {
                    count = 1;
                    break;
                }
            }
            return count > 0;
        }
        $scope.cleanEvent = "cleanEvent"
        $scope.change = function (title){
            //向子级作用域广播cleanEvent事件
            $scope.$broadcast($scope.cleanEvent);
       };
        //关闭
        $scope.closeArouseTip = function () {
            $scope.arouseTips = false;
            var url = "login/arouse_tips";
            var closePM = HttpService.postInfo(url);
            closePM.then(function (data) {
                $rootScope.arouseTips = false;
            });
        }
        $scope.showBaseWin = function () {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function (flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function (item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function () {
            ToolService.sendBehaviorUv("okBase");
            $scope.query(true, null);
            var url = "/campaign/viewcolumn/advertisinginfo?viewcolumn=";
            var vcol = [];
            $scope.baseList.filter(function (item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            var updatePM = HttpService.postInfo($scope.appid + url + vcol.join(","), {});
            updatePM.then(function (data) { });
            $scope.hideDialog(-1);
        }
        $scope.selectFlag = "adgroup";
        $scope.scenesHide = false;
        $scope.changeSelectFlag = function (flag) {
            ToolService.sendBehaviorUv(flag);
            if ($scope.selectFlag != flag) {
                $scope.infofalg = false;
                $scope.currentReports = null;
                $scope.allSubInfo = [];
            }
            $scope.selectFlag = flag;
            selectFlagIndex++;
            $scope.filterTxt = "";
            $scope.nameleve1 = ""
            $scope.nameleve2 = ""
            $scope.change();
        }

        $scope.packList = ToolService.getadvPackTypeList();
        $scope.packageInit = $scope.packList[0].id;
        $scope.$on("packid", function (e, msg) {
            $scope.packageID = msg.info.id;
        });


        $scope.$on('flipinfo', function (e, msg) {
            $scope.flipPage = msg;
            $scope.fixrefresh = ++rmd;
        });

        var flagNames;
        function init() {
            flagNames = {
                "adgroup": $translate.instant("广告组"),
                "adplan": $translate.instant("广告计划"),
                "adcreative": $translate.instant("广告创意")
            };
        }
        init();
        $scope.showZero = false;
        $scope.listRefresh = 1;

        /**
         * hasTotal:true/false  
         */
        $scope.query = function (flag, hasTotal) {
            var _flagNum = selectFlagIndex;
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            params.viewtype = $scope.selectFlag;
            params.func = "advertisinginfo";
            if($scope.isandroid) {
                params.campaigninfo_appmarket = $scope.packageID;
            }
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = encodeURIComponent($scope.filterTxt);
            }
            var listPM = null,
                currentInfo = {},
                qReport = "",
                eptName = flagNames[$scope.selectFlag];
            subTitle = $scope.subchannelList

            if ($scope.currentReports && $scope.currentReports != null && $scope.currentReports.key) {
                params[$scope.currentReports.key] = $scope.currentReports.val;
                params[$scope.currentReports.key1] = $scope.currentReports.val1;
                currentInfo = UtilService.cloneJSON($scope.currentReports);
            } else if ($scope.selectFlag == 'adgroup') {
                $scope.allSubInfo = [];
                currentInfo = {
                    report: "advertisinginfo_byadgroup"
                }
                $scope.currentReports = currentInfo;
            } else if ($scope.selectFlag == 'adplan') {
                $scope.allSubInfo = [];
                currentInfo = {
                    report: "advertisinginfo_byadplan"
                }
                $scope.currentReports = currentInfo;
            } else if ($scope.selectFlag == 'adcreative') {
                $scope.allSubInfo = [];
                currentInfo = {
                    report: "advertisinginfo_byadcreative"
                }
                $scope.currentReports = currentInfo;
            }

            if (!flag || $scope.allSubInfo.length == 0) {
                $scope.allSubInfo.push(currentInfo);
            }

            qReport = $scope.currentReports.report;
            if($scope.activeCidList.indexOf("all") == -1 && $scope.activeCidList.length>0){
                params.cid = $scope.activeCidList.join(',');
            }
            if($scope.activeCidList.indexOf("all") == -1 && $scope.activeCidList.length==1 && $scope.showBtn && $scope.menuLevel=='1' && $scope.advertiserids){
                params.advertiserid = $scope.advertiserids
            }
            params.viewcolumn = $scope.getViewColumns();
            var condiParams = '';
            $scope.listTotal = undefined;
            if (hasTotal) return;
            listPM = HttpService.getReportData(qReport, params);
            condiParams && (params = condiParams);
            params.showall0 = $scope.showZero;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("投放广告详情") + "-" + eptName, qReport, params);
            $scope.campListLoading = true;
            listPM.then(function (data) {
                if (_flagNum != selectFlagIndex) { //防止频繁点击分析维度，出现页面加载数据不对
                    return false;
                }
                $scope.campList = data;
                if ($scope.selectFlag != 'subaccount') {
                    $scope.infoListTotal = data.val[0];
                    $scope.campAllList = data.val.slice(1);
                } else {
                    $scope.campAllList = data.val;
                }
                $scope.campNoZeroList = $scope.campAllList.filter(function (item, index) {
                    return item.isall0 == false;
                });
                if ($scope.showZero || $scope.selectFlag == 'bdkeyword') {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
                $scope.campListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.searchTxt = "";
                if ($scope.isSubChannel()) {
                    if (fixChange) {
                        $scope.fixrefresh = ++rmd;
                    } else {
                        $scope.initrefresh = ++rmd;
                        $scope.fixrefresh = ++rmd;
                    }
                    fixChange = true;
                } else {
                    $scope.sortCol = "";
                    $scope.initrefresh = ++rmd;
                    $scope.fixrefresh = ++rmd;
                }
            });

        }

        $scope.queryReport = function(){
            ToolService.showLoading();
            var params = ToolService.getParams($scope);
            var qReport = "advertisinginfo_cash_day"
            params.datatype = 'list';
            params.viewtype = 'date';
            params.func = 'advertisinginfo';
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = encodeURIComponent($scope.filterTxt);
            }
            if($scope.activeCidList.indexOf("all") == -1 && $scope.activeCidList.length>0){
                params.plat_type_v = $scope.activeCidList.join(',');
            }
            bxPM = HttpService.getReportData(qReport, params);
            
            var condiParams = '';
            condiParams && (params = condiParams);
            params.showall0 = $scope.showZero;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("投放广告详情") + "-变现收入", qReport, params);

            bxPM.then(function(data){
                $scope.campCashList = $scope.campList = data;
                $scope.infoListTotal = data.val[0];
                $scope.campAllList = data.val.slice(1);
                $scope.campNoZeroList = $scope.campAllList.filter(function (item, index) {
                    return item.isall0 == false;
                });
                if ($scope.showZero) {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
                $scope.$broadcast("conentresize", true);
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
                ToolService.hideLoading();
            })

        }
        //请求路径后缀
        function getSubFix(flag) {
            var subfix = flag;
            return subfix;
        }

        $scope.getViewColumns = function () {
            var vcol = [];
            $scope.baseList && $scope.baseList.filter(function (item) {
                if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention')) || ((item.type == 'sdkevent' || item.type == 'sdkevent_new') && !$scope.showDataModel('event'))) {
                    //没有付费权限，不能查看付费
                } else if (item.type == 'base' && item.fieldcode == 'wake_num' && $rootScope.arouseStatus != 2) {
                    //没有唤醒权限，不能查看付费
                } else {
                    if (item.ischeck == true) {
                        vcol.push(item.fieldcode);
                    }
                }
            });
            return vcol.join(",");
        }


        $scope.isSubChannel = function () {
            return $scope.currentReports && ($scope.currentReports.report == "advertisinginfo_byadplan" || $scope.currentReports.report == "advertisinginfo_byadcreative");
        }

        $scope.filterByTxt = function (txt) {
            $scope.filterTxt = txt;
            if($scope.incomeManagement){
                $scope.queryReport()
            }else{
                $scope.query(true, false);
            }   
        }
        $scope.iscanSub = function () {
            return $scope.allSubInfo.length <= 3 && !$scope.incomeManagement;
        }
        $scope.itemLeve1 = {}
        $scope.goList = function(){
            if($scope.nameleve2){
                $scope.nameleve2 ="";
                if ($scope.nameleve1){
                    $scope.selectFlag = 'adgroup'
                    $scope.clickSub($scope.itemLeve1)
                }else{
                    $scope.changeSelectFlag('adgroup')
                }
            }else{
                $scope.nameleve1 ="";
                $scope.changeSelectFlag('adgroup')
            }
            // $scope.query(false, false);
        }
        $scope.searchGroupInitf5 = 0;
        $scope.clickSub = function (info, obj) {
            if (!info) {
                var target = obj.target, data = target.getAttribute('data');
                info = $.parseJSON(data);
            }
            $scope.nextID = info.id;
            if (info.istotal && !$scope.incomeManagement) { return; }
            $scope.filterTxt = "";
            $scope.searchGroupInitf5++;
            $scope.curinfo = info;
            $scope.isDetail = true;
            $scope.isInfoTotal = info.cid;
            var hasTotal = true;
            if ($scope.selectFlag == 'adgroup') {
                $scope.currentReports = {
                    report: "advertisinginfo_byadplan",
                    title: info[$scope.campList.columnkey[0]],
                    key: 'adgroup_id',
                    val: info.adgroup_id,
                    curInfo: info,
                    key1:'cid',
                    val1:info.channel
                }
                hasTotal = false
                if (hasTotal) {
                    fixChange = false;
                }
                $scope.itemLeve1 = info;
                $scope.nameleve1= info.name;
                $scope.nameleve2 ="";
                $scope.selectFlag = 'adplan';
            } else if ($scope.selectFlag == 'adplan') {
                $scope.currentReports = {
                    report: "advertisinginfo_byadcreative",
                    title: info[$scope.campList.columnkey[0]],
                    key: 'adplan_id',
                    val: info.adplan_id,
                    key1:'cid',
                    val1:info.channel
                }
                hasTotal = false
                if (hasTotal) {
                    fixChange = false;
                }
                $scope.nameleve2= info.name;
                $scope.selectFlag = 'adcreative'
            }
        }

        // 显示全0数据
        $scope.clickZero = function () {
            ToolService.sendBehaviorUv("clickZero");
            $scope.showZero = !$scope.showZero;
            reCrateListCondition($scope.listCondition);
            if ($scope.showZero) {
                $scope.infoList = $scope.campAllList;
            } else {
                $scope.infoList = $scope.campNoZeroList;
            }
            $scope.fixrefresh = ++rmd;
        }

        /**
         * 重新生成‘导出’参数，添加‘显示全0数据’的值进去
         * @param listCondition
         */
        function reCrateListCondition(listCondition) {
            var isOk = false;
            if (listCondition && listCondition.conditions) {
                var cond = JSON.parse(listCondition.conditions);
                if (cond) {
                    cond.showall0 = $scope.showZero;
                    listCondition.conditions = JSON.stringify(cond);
                    isOk = true;
                }
            }
            if (!isOk) {
                ToolService.showTips("");
            }
        }

        var fixChange = true,
            orderBy = $filter('orderBy'),
            rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function (predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.listRefresh = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("appid", function () {
            $scope.allSubInfo = [];
            $scope.currentReports = null;
        });

        $scope.$watch("date.startDate+date.endDate", function () {
            if ($scope.allSubInfo && $scope.allSubInfo.length > 0) {
                $scope.allSubInfo.pop()
            }
        });
        var oldappid = "";
        $scope.advertiseridReshs = 0
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,selectFlag:selectFlag,lang:lang}", function (n, o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)) { return false; }
            if (!$scope.baseList || oldappid != $scope.appid) {
                //指标列表
                var basePM = HttpService.getInfo($scope.appid + "/campaign/viewcolumn/findall/advertisinginfo");
                basePM.then(function (data) {
                    $scope.baseList = data;
                    $scope.sdkList = data.filter(function (item) {
                        return item.type == 'sdkevent';
                    });
                    $scope.sdkeventNew = data.filter(function (item) {
                        return item.type == 'sdkevent_new';
                    });
                    
                    if($scope.incomeManagement){
                        $scope.queryReport()
                    }else{
                        $scope.query(false, false);
                    }

                });
            }else {
                if($scope.incomeManagement){
                    $scope.queryReport()
                }else{
                    $scope.query(false, false);
                }
            }
            $scope.advertiserids = ''
            $scope.advertiseridReshs++
            $scope.getAdvertiseridLists()
            oldappid = $scope.appid;
            //语言切换
            if (n.lang && o.lang && n.lang !== o.lang) {
                init();
            }
            if (n.appid != o.appid) {
                $scope.allSubInfo = [];
                $scope.currentReports = null;
            }
        }, true);

        $scope.goPagelevel = function() {
            $scope.menuLevel = '2';
            $scope.queryReport();
        }

        $scope.$watch("appid", function () {
            if ($scope.appid) {
                $scope.industory = $scope.appInstance.industory;
            }
        });
    }
})();