(function () {
    angular.module("app.collect")
        .controller("channeleffectCtrl", ["$scope", "HttpService", "ToolService", "UtilService", "$filter", channeleffectCtrl]);

    function channeleffectCtrl($scope, HttpService, ToolService, UtilService, $filter) {
        $scope.initLoading = function () {
            $scope.baseLoading = true;
            $scope.activerateLoading = true;
            $scope.retentionLoading = true;
            $scope.clickLoading = true;
            $scope.installLoading = true;
            $scope.installrateLoading = true;
            $scope.regeditLoading = true;
            $scope.deviceLoading = true;
            $scope.paymentLoading = true;
            $scope.uvLoading = true;
            $scope.ipLoading = true;
            $scope.channeltopLoading = true;
        };
        $scope.initLoading();
        var color2 = ["#f8a20f", "#9cc272"],
            color3 = ["#52aff1", "#f8a20f", "#9cc272"],
            // color5 = ["#5ab3f0","#97cdf3","#ffaa18","#f4d49b","#9cc272"];
            color5 = ["#5c6bc0", "#50bd3e", "#cddc39", "#fb7f0b", "#fec107"];
        var rmd = new Date().getTime();

        $scope.order = {
            base: 0,
            activerate: 0,
            retention: 0,
            h5base: 0,
            newuser: 0,
            flow: 0,
            ecbase: 0,
            conversion: 0,
            basic: 0,
            bounce: 0,
            flow: 0
        };
        $scope.changeOrder = function (name, index) {
            ToolService.sendBehaviorUv(name+index);
            $scope.order[name] = index;
        }

        $scope.$on('curdate', function (e, msg) {
            $scope.date = msg.date;
            $scope.timeflag = msg.timeflag;
            $scope.subfix = msg.subfix;
        });

        $scope.packList = ToolService.getPackTypeList();
        $scope.packageInit = $scope.packList[0].id;
        $scope.$on("packid", function (e, msg) {
            $scope.packageID = msg.info.id;
        });

        //基础数据TOP5
        $scope.queryBase = function () {
            var params = ToolService.getParams($scope);
            params.datatype = 'chart';
            params.func = 'channeleffect';
            var ordercol = $scope.order[$scope.nowReports[($scope.industory == 'ec' &&  (!$scope.iswg && !$scope.isweb)) ? 10 : 0].orderby];
            if (ordercol > 0) {
                params.orderby = $scope.nowReports[($scope.industory == 'ec' && (!$scope.iswg && !$scope.isweb)) ? 10 : 0].orderkey[ordercol];
            }

            if ($scope.packageID != 'all' && $scope.isandroid) {
                params.channelcategory = $scope.packageID;
            }
            $scope.baseConfig = { color: color3, barwidth: 10 };
            if($scope.industory == 'ec' && $scope.isweb){
                var basePM = HttpService.getReportData($scope.nowReports[0].name, params);
            }else{
                var basePM = HttpService.getReportData($scope.nowReports[($scope.industory == 'ec' && !$scope.iswg) ? 10 : 0].name, params);
                
            }
            $scope.baseLoading = true;
            basePM.then(function (data) {
                $scope.baseData = data;
                $scope.baseLoading = false;
                if($scope.industory=='ec' && $scope.isweb){
                    $scope.baseDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[0].title,$scope.nowReports[0].name,params);

                }else{
                    $scope.baseDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[($scope.industory=='ec' && !$scope.iswg)?10:0].title,$scope.nowReports[($scope.industory=='ec' && !$scope.iswg)?10:0].name,params);
                    
                }
            });
        }

        //激活率TOP5
        $scope.queryInstallrate = function () {
            var params = {
                startdate: $scope.date.startDate,
                enddate: $scope.date.endDate,
                appid: $scope.appid,
                datatype: 'chart'
            }
            params.func = 'channeleffect';
            // if($scope.order.activerate>0){
            //     params.orderby = ['click',"install"," income"][$scope.order.activerate];
            // }

            if ($scope.packageID != 'all' && $scope.isandroid) {
                params.channelcategory = $scope.packageID;
            }

            $scope.activerateConfig = { color: color2, ispercent: ($scope.isweb ? false : true), barwidth: 10 };
            var activeratePM = HttpService.getReportData($scope.nowReports[1].name, params);
            $scope.activerateLoading = true;
            activeratePM.then(function (data) {
                $scope.activerateData = data;
                $scope.activerateLoading = false;
                $scope.activerateDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[1].title,$scope.nowReports[1].name,params);
            });
        }
        //转化TOP5
        $scope.queryConversion = function () {
            if (!$scope.showDataModel('pay')) { return false; }
            var params = {
                startdate: $scope.date.startDate,
                enddate: $scope.date.endDate,
                appid: $scope.appid,
                datatype: 'chart'
            }
            params.func = 'channeleffect';
            var ordercol = $scope.order[$scope.nowReports[11].orderby];
            if (ordercol > 0) {
                
                params.orderby = $scope.nowReports[11].orderkey[ordercol];
            }   
            if ($scope.packageID != 'all' && $scope.isandroid) {
                params.channelcategory = $scope.packageID;
            }

            $scope.conversionConfig = { color: color3, barwidth: 10 };

            var conversionPM = HttpService.getReportData($scope.nowReports[11].name, params);
            $scope.conversionLoading = true;
            conversionPM.then(function (data) {
                $scope.conversionData = data;
                $scope.conversionLoading = false;

                $scope.conversionDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[11].title,$scope.nowReports[11].name,params);
            });
        }
        //留存TOP5
        $scope.queryRetention = function () {
            if (!$scope.showDataModel($scope.nowReports[2].orderby) && !$scope.isweb) { return false; }
            var params = {
                startdate: $scope.date.startDate,
                enddate: $scope.date.endDate,
                appid: $scope.appid,
                datatype: 'chart'
            }
            params.func = 'channeleffect';
            var ordercol = $scope.order[$scope.nowReports[2].orderby];
            if (ordercol > 0) {
                params.orderby = $scope.nowReports[2].orderkey[ordercol];
            }
            if ($scope.packageID != 'all' && $scope.isandroid) {
                params.channelcategory = $scope.packageID;
            }

            $scope.retentionConfig = { color: color3, barwidth: 10, ispercent: ($scope.isweb ? false : true) };
            var retentionPM = HttpService.getReportData($scope.nowReports[2].name, params);
            $scope.retentionLoading = true;
            retentionPM.then(function (data) {
                $scope.retentionData = data;
                $scope.retentionLoading = false;

                $scope.retentionDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[2].title,$scope.nowReports[2].name,params);
            });
        }

        $scope.$watch("date.startDate+date.endDate+order.base+appid+order.h5base+order.ecbase", function (n) {
            if (angular.isDefined($scope.appid) && angular.isDefined($scope.date)) {
                // $scope.nowReports = $scope.isweb?moveReports:moveReports;
                $scope.nowReports = $scope.isweb ? webReports : ($scope.iswx || $scope.iswg) ? wxReports : $scope.isSelfBuilt ? selfBuiltReports : moveReports;
                $scope.industory = $scope.appInstance.industory;
                $scope.queryBase();
            }
        });
        $scope.$watch("date.startDate+date.endDate+order.activerate+appid+order.newuser", function (n) {
            if (angular.isDefined($scope.appid) && angular.isDefined($scope.date)) {
                $scope.queryInstallrate();
            }
        });
        $scope.$watch("date.startDate+date.endDate+order.retention+appid+order.flow",function(n){
            if(angular.isDefined($scope.appid) && angular.isDefined($scope.date)){
              if($scope.industory!='ec' || $scope.industory == 'ec' && $scope.isweb){
                $scope.queryRetention();
              }
            }
        });
        $scope.$watch("date.startDate+date.endDate+appid+order.conversion", function (n) {
            if (angular.isDefined($scope.appid) && angular.isDefined($scope.date)
                && $scope.industory == 'ec' && $scope.showDataModel('order') && !$scope.iswg) {
                    // $scope.industory == 'ec'&& !$scope.isweb
                $scope.queryConversion();
            }
        });

        var opacity = 0.1;
        $scope.query = function () {
            var params = {
                startdate: $scope.date.startDate,
                enddate: $scope.date.endDate,
                appid: $scope.appid,
                datatype: 'chart'
            }
            params.func = 'channeleffect';
            if ($scope.packageID != 'all' && $scope.isandroid) {
                params.channelcategory = $scope.packageID;
            }

            if(!$scope.iswx && !$scope.iswg){

                   //点击趋势
                   $scope.clickConfig = {color:color5,opacity:opacity,isstack:true};
                     var clickPM = HttpService.getReportData($scope.nowReports[3].name+$scope.subfix,params);
                   $scope.clickLoading = true;
                     clickPM.then(function(data){
                          $scope.clickData = data;
                        $scope.clickLoading = false;

                        $scope.clickDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[3].title,$scope.nowReports[3].name+$scope.subfix,params);
                     });

                    //激活趋势
                    $scope.installConfig = {color:color5,opacity:opacity,isstack:true};
                        var installPM = HttpService.getReportData($scope.nowReports[4].name+$scope.subfix,params);
                        $scope.installLoading = true;
                        installPM.then(function(data){
                            $scope.installData = data;
                            $scope.installLoading = false;

                            $scope.installDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[4].title,$scope.nowReports[4].name+$scope.subfix,params);
                    });


                //激活率趋势
                var sub = $scope.timeflag == 'yesday' && $scope.isweb ? "ds" : $scope.subfix;
                $scope.installrateConfig = { color: color5, opacity: opacity, isstack: true, ispercent: ($scope.isweb ? false : true) };
                var installratePM = HttpService.getReportData($scope.nowReports[5].name + sub, params);
                $scope.installrateLoading = true;
                installratePM.then(function (data) {
                    $scope.installrateData = data;
                    $scope.installrateLoading = false;
                    $scope.installrateDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[5].title,$scope.nowReports[5].name+sub,params);
                });

                if ($scope.industory == 'ec' && !$scope.isweb) {    //H5产品不区分模板
                    if ($scope.showDataModel('order')) {
                        //订单趋势
                        $scope.orderConfig = { color: color5, opacity: opacity, isstack: true };
                        var orderPM = HttpService.getReportData($scope.nowReports[12].name + $scope.subfix, params);
                        $scope.orderLoading = true;
                        orderPM.then(function(data){
                              $scope.orderData = data;
                              $scope.orderLoading = false;

                              $scope.orderDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[12].title,$scope.nowReports[12].name+$scope.subfix,params);
                        });
                        //下单设备趋势
                        $scope.odeviceConfig = { color: color5, opacity: opacity, isstack: true };
                        var odevicePM = HttpService.getReportData($scope.nowReports[13].name + $scope.subfix, params);
                        $scope.odeviceLoading = true;
                        odevicePM.then(function(data){
                              $scope.odeviceData = data;
                              $scope.odeviceLoading = false;

                              $scope.odeviceDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[13].title,$scope.nowReports[13].name+$scope.subfix,params);
                        });
                    }
                    if ($scope.showDataModel('pay')) {
                        //订单总额趋势
                        $scope.amtConfig = { color: color5, opacity: opacity, isstack: true };
                        var amtPM = HttpService.getReportData($scope.nowReports[14].name + $scope.subfix, params);
                        $scope.amtLoading = true;
                        amtPM.then(function(data){
                              $scope.amtData = data;
                              $scope.amtLoading = false;
                              $scope.amtDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[14].title,$scope.nowReports[14].name+$scope.subfix,params);
                        });
                        //客单价趋势
                        $scope.ticketConfig = { color: color5, opacity: opacity, isstack: true };
                        var ticketPM = HttpService.getReportData($scope.nowReports[15].name + $scope.subfix, params);
                        $scope.ticketLoading = true;
                        ticketPM.then(function (data) {
                            $scope.ticketData = data;
                            $scope.ticketLoading = false;

                              $scope.ticketDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+$scope.nowReports[15].title,$scope.nowReports[15].name+$scope.subfix,params);
                        });
                        //付费率趋势
                        $scope.rateConfig = { color: color5, opacity: opacity, isstack: true };
                        var ratePM = HttpService.getReportData($scope.nowReports[16].name + $scope.subfix, params);
                        $scope.rateLoading = true;
                        ratePM.then(function (data) {
                            $scope.rateData = data;
                            $scope.rateLoading = false;                            
                            $scope.rateDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-") + $scope.nowReports[16].title, $scope.nowReports[16].name + $scope.subfix, params);
                        });
                    }
                } else {
                    //注册趋势
                    $scope.regeditConfig = { color: color5, opacity: opacity, isstack: true };
                    var regeditPM = HttpService.getReportData($scope.nowReports[6].name + $scope.subfix, params);
                    $scope.regeditLoading = true;
                    regeditPM.then(function (data) {
                        $scope.regeditData = data;
                        $scope.regeditLoading = false;

                        $scope.regeditDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-") + $scope.nowReports[6].title, $scope.nowReports[6].name + $scope.subfix, params);
                    });
                    if ($scope.showDataModel('pay')) {
                        //付费设备数趋势
                        $scope.deviceConfig = { color: color5, opacity: opacity, isstack: true };
                        var devicePM = HttpService.getReportData($scope.nowReports[7].name + $scope.subfix, params);
                        $scope.deviceLoading = true;
                        devicePM.then(function (data) {
                            $scope.deviceData = data;
                            $scope.deviceLoading = false;

                            $scope.deviceDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-") + $scope.nowReports[7].title, $scope.nowReports[7].name + $scope.subfix, params);
                        });

                        //收入趋势
                        $scope.paymentConfig = { color: color5, opacity: opacity, isstack: true };
                        var paymentPM = HttpService.getReportData($scope.nowReports[8].name + $scope.subfix, params);
                        $scope.paymentLoading = true;
                        paymentPM.then(function (data) {
                            $scope.paymentData = data;
                            $scope.paymentLoading = false;

                            $scope.paymentDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-") + $scope.nowReports[8].title, $scope.nowReports[8].name + $scope.subfix, params);
                        });
                    }
                }
                if ($scope.isweb) { //h5
                    //h5 UV趋势
                    $scope.uvConfig = { color: color5, opacity: opacity, isstack: true };
                    var uvPM = HttpService.getReportData($scope.nowReports[10].name + $scope.subfix, params);
                    $scope.uvLoading = true;
                    uvPM.then(function (data) {
                        $scope.uvData = data;
                        $scope.uvLoading = false;

                        $scope.uvDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-") + $scope.nowReports[10].title, $scope.nowReports[10].name + $scope.subfix, params);
                    });

                    //h5 IP趋势
                    $scope.ipConfig = { color: color5, opacity: opacity, isstack: true };
                    // console.log($scope.subfix)
                    var ipPM = HttpService.getReportData($scope.nowReports[11].name + $scope.subfix, params);
                    $scope.ipLoading = true;
                    ipPM.then(function (data) {
                        $scope.ipData = data;
                        $scope.ipLoading = false;
                        $scope.ipDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-") + $scope.nowReports[11].title, $scope.nowReports[11].name + $scope.subfix, params);
                    });
                }


            } else {

                whenWX($scope, params, $scope.nowReports);
            }

            //渠道数据详情
            var byparams = UtilService.cloneJSON(params);
            byparams.datatype = "list";
            var index = ($scope.industory == 'ec' && !$scope.iswg && !$scope.isweb)? 17 : 9;
            if ($scope.nowReports[index]) {
                var channeltopPM = HttpService.getReportData($scope.nowReports[index].name, byparams);
                $scope.channeltopLoading = true;
                channeltopPM.then(function (data) {
                    $scope.channeltopList = data;
                    $scope.infoList = data.val;
                    $scope.channeltopLoading = false;
                    $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                    $scope.channeltopListCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比")+"-"+$scope.nowReports[index].title,$scope.nowReports[index].name,byparams);
                    $scope.initrefresh = ++rmd;
                    $scope.fixrefresh = ++rmd;
                });
            }
        }
        //当微信小程序时，页面数据项请求数据
        function whenWX(scope, params, reports) {
            var wxData = {};
            reports.forEach(function (item) {
                var filed = item.retFiled;
                if (item.type == 'top') {
                    wxData[filed + 'Config'] = { color: color5, opacity: opacity, isstack: true };
                    var pm = HttpService.getReportData(item.type == 'top' ? (item.name + $scope.subfix) : item.name, params);
                    wxData[filed + 'Loading'] = true;
                    pm.then(function (data) {
                        data.rmd = ++rmd;
                        wxData[filed+'Data'] = data;
                        wxData[filed+'Loading'] = false;
                        wxData[filed+'DataCondition'] = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+item.title,item.type=='top'? (item.name+$scope.subfix):item.name,params);
                    });
                } else if (item.type == 'overview') {
                    scope.order[filed] = 0;
                    scope['query' + filed] = createFun($scope, item, wxData);
                    scope.$watch("date.startDate+date.endDate+order." + filed + "+appid", function (n) {
                        if (angular.isDefined(scope.appid) && angular.isDefined(scope.date)) {
                            scope['query' + filed]();
                        }
                    });
                }
            });
            scope.wxData = wxData;

            //激活趋势
            $scope.installConfig = { color: color5, opacity: opacity, isstack: true };
            var installPM = HttpService.getReportData("channelinfo_install_top5_by" + $scope.subfix, params);
            $scope.installLoading = true;
            installPM.then(function (data) {
                $scope.installData = data;
                $scope.installLoading = false;

                $scope.installDataCondition = ToolService.getChartConditions($filter('translate')("渠道效果对比-激活趋势"),'channelinfo_install_top5_by'+$scope.subfix,params);
            });
        }
        //返回数据总览的查询函数
        function createFun(scope, item, wxData) {
            return function () {
                var params = ToolService.getParams(scope), filed = item.retFiled;
                Object.assign(params, { datatype: 'chart', func: 'channeleffect' });
                var ordercol = $scope.order[item.orderby];
                if (ordercol > 0 || ordercol === 0) {
                    params.orderby = item.orderkey[ordercol];
                }
                wxData[filed+'Config'] = {color:color3,barwidth:10};
                var basePM = HttpService.getReportData(item.name,params);
                wxData[filed+'Loading']  = true;
                basePM.then(function(data){
                    wxData[filed+'Data'] = data;
                    wxData[filed+'Loading'] = false;
                    wxData[filed+'DataCondition'] = ToolService.getChartConditions($filter('translate')("渠道效果对比-")+item.title,item.name,params);
                });
            }
        }

        $scope.$on("conentresize", function () {
            if ($scope.channeltopList) $scope.colsStyle = ToolService.getTableColsWidth($scope.channeltopList.name);
        });
        var orderBy = $filter('orderBy');
        $scope.sortCol = "";
        $scope.orderCol = function (predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("packageID", function (n) {
            if (angular.isDefined(n) && $scope.infoList && $scope.isandroid) {
                $scope.queryBase();
                // $scope.isweb &&
                $scope.queryInstallrate();
                if ($scope.industory == 'ec' && $socpe.showDataModel('order')) {
                   
                    $scope.queryConversion();
                } else {
                   
                    $scope.queryRetention();
                }
                $scope.query();
            }
        });
        var webReports = [{
            name: "h5_channel_top5_basic",   // web端
            title: "基础TOP5",
            orderby: "h5base",
            orderkey: ['click', "register", "income"],
            ordername: ["点击", "注册", "收入"]
        },
        {
            name: "h5_channel_top5_newuser",
            title: "新增独立访客TOP5",
            orderby: "newuser",
            ordername: ["新增独立访客"]
        },
        {
            name: "h5_channel_top5_flow",
            title: "流量TOP5",
            orderby: "flow",
            orderkey: ['pv', "uv", "ip"],
            ordername: ["PV", "UV", "IP"]
        },
        {
            name: "h5_channel_top5_click_by",
            title: "点击趋势"
        },
        {
            name: "h5_channel_top5_pv_by",
            title: "PV趋势"
        },
        {
            name: "h5_channel_top5_newuser_by",
            title: "新增独立访客趋势"
        },
        {
            name: "h5_channel_top5_reged_by",
            title: "注册趋势"
        },
        {
            name: "h5_channel_top5_payer_by",
            title: "付费人数趋势"
        },
        {
            name: "h5_channel_top5_amount_by",
            title: "收入趋势"
        },
        {
            name: "h5_channel_detail_list",
            title: "渠道效果对比-渠道数据详情"
        },
        {
            name: "h5_channel_top5_uv_by",
            title: "UV趋势"
        },
        {
            name: "h5_channel_top5_ip_by",
            title: "IP趋势"
        }];

        //移动端
        var moveReports = [{
            name: "channelinfo_base_top5_bychannel",
            title: "基础TOP5",
            orderby: "base",
            orderkey: ['click', "install", "income"],
            ordername: ["点击", "激活", "收入"]
        },
        {
            name: "rate_channelinfo_install_top5_bychannel",
            title: "激活率TOP5",
            orderby: "activerate",
            ordername: ["激活率"]
        },
        {
            name: "rate_channelinfo_retention_top5_bychannel",
            title: "留存TOP5",
            orderby: "retention",
            orderkey: ['d1', "d3", "d7"],
            ordername: ["次留", "三留", "七留"]
        },
        {
            name: "channelinfo_click_top5_by",
            title: "点击趋势"
        },
        {
            name: "channelinfo_install_top5_by",
            title: "激活趋势"
        },
        {
            name: "rate_channelinfo_install_top5_by",
            title: "激活率趋势"
        },
        {
            name: "channelinfo_reged_top5_by",
            title: "注册趋势"
        },
        {
            name: "channelinfo_payer_top5_by",
            title: "付费设备数趋势"
        },
        {
            name: "channelinfo_amount_top5_by",
            title: "收入趋势"
        },
        {
            name: "channelinfo_bychannel",
            title: "渠道效果对比-渠道数据详情"
        },
        {
            name: "channelinfo_amt_top5_bychannel",
            title: "基础TOP5",
            orderby: "ecbase",
            orderkey: ['click', "install", "order"],
            ordername: ["点击", "激活", "订单"]
        },
        {
            name: "channelinfo_ticket_top5_bychannel",
            title: "转化TOP5",
            orderby: "conversion",
            orderkey: ['amt_pay_order', "ticket", "rate_pay"],
            ordername: ["金额", "客单价", "付费率"]
        },
        {
            name: "channelinfo_order_top5_by",
            title: "支付订单趋势"
        },
        {
            name: "channelinfo_device_top5_by",
            title: "支付设备趋势"
        },
        {
            name: "channelinfo_amt_top5_by",
            title: "支付总额趋势"
        },
        {
            name: "channelinfo_ticket_top5_by",
            title: "支付客单价趋势"
        },
        {
            name: "channelinfo_rate_top5_by",
            title: "订单付费率趋势"
        },
        {
            name: "channelinfo_order_bychannel",
            title: "渠道效果对比-渠道数据详情"
        }];
        var selfBuiltReports = [{
            name: "channelinfo_base_top5_bychannel",
            title: "基础TOP5",
            orderby: "base",
            orderkey: ['click', "install", "income"],
            ordername: ["点击", "表单", "收入"]
        },
            {
                name: "rate_channelinfo_install_top5_bychannel",
                title: "转换率TOP5",
                orderby: "activerate",
                ordername: ["转换率"]
            },
            {
                name: "rate_channelinfo_retention_top5_bychannel",
                title: "留存TOP5",
                orderby: "retention",
                orderkey: ['d1', "d3", "d7"],
                ordername: ["次留", "三留", "七留"]
            },
            {
                name: "channelinfo_click_top5_by",
                title: "点击趋势"
            },
            {
                name: "channelinfo_install_top5_by",
                title: "表单趋势"
            },
            {
                name: "rate_channelinfo_install_top5_by",
                title: "转换率趋势"
            },
            {
                name: "channelinfo_reged_top5_by",
                title: "注册趋势"
            },
            {
                name: "channelinfo_payer_top5_by",
                title: "付费设备数趋势"
            },
            {
                name: "channelinfo_amount_top5_by",
                title: "收入趋势"
            },
            {
                name: "channelinfo_bychannel",
                title: "渠道效果对比-渠道数据详情"
            },
            {
                name: "channelinfo_amt_top5_bychannel",
                title: "基础TOP5",
                orderby: "ecbase",
                orderkey: ['click', "install", "order"],
                ordername: ["点击", "表单", "订单"]
            },
            {
                name: "channelinfo_ticket_top5_bychannel",
                title: "转化TOP5",
                orderby: "conversion",
                orderkey: ['amt_pay_order', "ticket", "rate_pay"],
                ordername: ["金额", "客单价", "付费率"]
            },
            {
                name: "channelinfo_order_top5_by",
                title: "支付订单趋势"
            },
            {
                name: "channelinfo_device_top5_by",
                title: "支付设备趋势"
            },
            {
                name: "channelinfo_amt_top5_by",
                title: "支付总额趋势"
            },
            {
                name: "channelinfo_ticket_top5_by",
                title: "支付客单价趋势"
            },
            {
                name: "channelinfo_rate_top5_by",
                title: "订单付费率趋势"
            },
            {
                name: "channelinfo_order_bychannel",
                title: "渠道效果对比-渠道数据详情"
            }];
        var wxReports = [               //微信
            { name: "wx_channel_top5_basic", title: "基础TOP5", orderby: "basic", orderkey: ['num_click', "register", "income"], ordername: ["访问次数", "新增用户", "收入"], type: 'overview', retFiled: 'basic' },
            { name: "wx_channel_top5_bounce", title: "跳出率趋势", orderby: "bounce", orderkey: ['bounce'], ordername: ["跳出率"], type: 'overview', retFiled: 'bounce' },
            // {name:"wx_channel_top5_flow",title:"流量top5",orderby:"flow",orderkey:['pv',"uv"],ordername:["PV","UV"],type:'overview',retFiled:'flow'},
            { name: "wx_channel_top5_click_by", title: "访问次数", type: 'top', retFiled: 'click' },
            { name: "wx_channel_top5_newuser_by", title: "新增用户", type: 'top', retFiled: 'newuser' },
            // {name:"wx_channel_top5_pv_by",title:"PV",type:'top',retFiled:'pv'},
            // {name:"wx_channel_top5_uv_by",title:"UV",type:'top',retFiled:'uv'},
            { name: "wx_channel_top5_reged_by", title: "注册趋势", type: 'top', retFiled: 'reged' },
            { name: "wx_channel_top5_payer_by", title: "付费用户趋势", type: 'top', retFiled: 'payer' },
            { name: "wx_channel_top5_amount_by", title: "收入趋势", type: 'top', retFiled: 'amount' },
        ];

        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,lang:lang}",function(n,o){
            if(angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)){return false;}
            if($scope.iswx || $scope.iswg){
                if($scope.iswx){
                    if(wxReports[2].name!='wx_channel_top5_flow'){
                        wxReports.splice(2,0,{name:"wx_channel_top5_flow",title:"流量top5",orderby:"flow",orderkey:['pv',"uv"],ordername:["PV","UV"],type:'overview',retFiled:'flow'});
                        if(wxReports[2].name!='wx_channel_top5_pv_by'){
                            wxReports.splice(5,0,{name:"wx_channel_top5_pv_by",title:"PV",type:'top',retFiled:'pv'},{name:"wx_channel_top5_uv_by",title:"UV",type:'top',retFiled:'uv'});
                        }
                    }
                }
                if ($scope.iswg) {
                    if (wxReports[2].name == 'wx_channel_top5_flow') {
                        wxReports.splice(2, 1);
                        if (wxReports[4].name == 'wx_channel_top5_pv_by') {
                            wxReports.splice(5, 2);
                        }
                    }
                }
                $scope.nowReports = wxReports;
                $scope.industory = $scope.appInstance.industory;
            }
            $scope.query();
        },true);
    }
})();
