(function() {
    angular.module("app.collect")
        .controller("channelmanageCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$stateParams", "$timeout", "$location", "$filter", "$translate", channelmanageCtrl])
        .controller("channelAddCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$filter", "$translate", channelAddCtrl])
        .controller("channelSmCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelSmCtrl])
        .controller("channelAdwordsCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", channelAdwordsCtrl]);

    function channelmanageCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $stateParams, $timeout, $location, $filter, $translate) {
        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.demoU) {
            $rootScope.editPower = true;
        } else {
            $rootScope.editPower = false;
        }
        $scope.$watch("fakeType", function(n) {
            if ($rootScope.fakeType == 1 || $rootScope.fakeType == 2) {
                $scope.hasBlacklist = true;
            } else {
                $scope.hasBlacklist = false;
            }
        });

        $scope.clickShowList = [
            { id: 1, name: $translate.instant("是") },
            { id: 0, name: $translate.instant("否") }
        ];
        $scope.$on("clickShow", function(e, msg) {
            $scope.clickShow = msg.info.id;
        });
        $scope.saveShow = function() {
            var savePM = HttpService.putInfo("mng/systemparam/updateimp?status=" + ($scope.clickShow == 1 ? true : false)+"&app="+$scope.appid);
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($translate.instant("修改成功")) 
            });
        }
        $scope.getSystemparam = function(){
            var infoPM = HttpService.getInfo("mng/systemparam/"+$scope.appid+"/find");
            ToolService.showLoading();
            infoPM.then(function(data) {
                ToolService.hideLoading();
                $scope.clickShow = $scope.clickShowInit = data.impIsAttribute == true ? 1 : 0;
            });
        }
        
        var type = $stateParams.aid;
        var customType = $stateParams.pageid;
        if (!UtilService.isNullStr(type) && type != 'adwords' && type != 'smsearch' && type != 'gdt') {
            $scope.channType = type;
        } else {
            $scope.channType = 'ry_coop';
        }
        if(customType && customType == 'custom'){
            $scope.channType = 'custom';
        }
        if (angular.isDefined(type) && type != null) {
            if (type == 5) {
                $scope.pageFlag = 5;
            }
        }


        $scope.sendEve = function() {
            ToolService.sendBehaviorUv("search");
        }

        $scope.pageFlag = 1; //2渠道账号列表 3新建渠道账号
        $scope.filterTypeList = function(type) {
            ToolService.sendBehaviorUv(type);
            $scope.channType = type;
            $rootScope.channeluniqueName = 'normal';
            $rootScope.thirdtab = { 'ry_coop': $translate.instant('常规渠道'), 'custom': $translate.instant('自定义渠道'), 'ry_bd': $translate.instant('SEM渠道') }[type];
            $scope.query();
        }


        $scope.$on("deviceId", function(e, msg) {
            $scope.seeFlag = msg.info.id;

            if ($scope.customList && $scope.channType == 'custom') {
                $scope.filterList();
            }
        });

        $scope.query = function(bol) {
            var url = '';
            if ($scope.channType == 'custom') {
                url = "mng/channel/find";
                if ($scope.customList && !bol) {
                    $scope.filterList();
                    return;
                }
            } else {
                url = "mng/channel/find/unown?delflg=1";
                if ($scope.coopList && !bol) {
                    $scope.filterList();
                    return;
                }
            }
            ToolService.showLoading();
            var channelPM = HttpService.getInfo(url);
            channelPM.then(function(data) {
                ToolService.hideLoading();
                // $scope.clickShow = $scope.clickShowInit = data.impIsAttribute==true ? 1 : 0;//归因数据
                if ($scope.channType == 'custom') {
                    $scope.customList = data;
                    $scope.filterList();
                } else {
                    $scope.coopList = data;
                    if ($scope.channelType == 'ry_coop') {
                        $scope.channelList = $scope.coopList.filter(function(item) {
                            return item.type == 'ry_bd';
                        });
                    } else {
                        $scope.channelList = $scope.coopList.filter(function(item) {
                            return item.type == 'ry_coop';
                        });
                    }
                }
                $scope.filterList();
                //$scope.channelList = data;
            });


        }
        $scope.filterList = function() {
            if ($scope.channType == 'custom') {
                $scope.channelList = [];
                if($scope.customList.length>0){
                    $scope.channelList = $scope.customList.filter(function(item) {
                        if (item.name == "优酷" || item.name == "优酷GD") {
                            return false;
                        }
                        return item.delFlag != true;
                    });
                }
            } else {
                ToolService.showLoading();
                $scope.channelList = $scope.coopList.filter(function(item) {
                    if (item.name == "优酷" || item.name == "优酷GD") {
                        return false;
                    }
                    if ($scope.channType == "ry_bd") {
                        return item.type == $scope.channType;
                    } else {
                        return item.type == $scope.channType && item.category == 'ADVERTISING';
                    }
                    return true;    
                });
                ToolService.hideLoading();
            }
        }
       

        var curfilpPage = null,
            rmd = new Date().getTime();
        $scope.$on('flipinfo', function(e, msg) {
            if (msg.listkey == 'account') {
                $scope.flipPage2 = msg;
            } else if (msg.listkey == 'public') {
                $scope.flipPage = msg;
                $scope.flipChange = ++rmd;
            } else {
                $scope.flipPage3 = msg;
            }
        });

        $scope.doRemove = function(info) {
            ToolService.sendBehaviorUv("doRemove");
            $scope.delId = info.id;
            $scope.delInfo = info;
            ToolService.showLoading();
            var prePM = HttpService.getInfo("mng/channel/delete/valid/" + $scope.delId);
            prePM.then(function(data) {
                ToolService.hideLoading();
                if (angular.isNumber(data) && data > 0) {
                    $scope.delflagStatus = 2;
                    $scope.campnum = data;
                } else {
                    $scope.delflagStatus = 1;
                }
                $scope.delstatus = true;
            });
        }
        $timeout(function() {
            var clipboard = new Clipboard('.copyBtnUrl');
            clipboard.on('success', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制成功"));
                });
            });
            clipboard.on('error', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制失败"));
                });
            });
        }, 200);
        $scope.removeInfo = function() {
            if ($scope.delflagStatus == 2) {
                $scope.delstatus = false;
                return false;
            }
            var removePM = HttpService.deleteInfo("mng/channel/delete/" + $scope.delId);
            ToolService.showLoading();
            $scope.delstatus = 0;
            removePM.then(function(data) {
                ToolService.hideLoading();

                ToolService.showTips($translate.instant("停用成功"))
                $scope.query(true);
                $rootScope.operSubmitData($translate.instant("停用"));
            });
        }
        $scope.enableInfo = function(info) {
            ToolService.sendBehaviorUv("enableInfo");
            var enablePM = HttpService.putInfo("mng/channel/enable/" + info.id);
            ToolService.showLoading();
            enablePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($translate.instant("启用成功"))
                $scope.query(true);
                $rootScope.operSubmitData($translate.instant("启用"));
            });
        }

        $scope.gopage = function(info) {
            ToolService.sendBehaviorUv("create");
            if (angular.isDefined(info)) {
                $state.go("collect.channelDetail", { aid: info });
            } else {
                $state.go("collect.channelDetail");
            }
        }

        $scope.goGdt = function(info, flag) {
            ToolService.sendBehaviorUv("goGdt");
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && flag != 10) {
                info.step = flag;
                $state.go("collect.channelAdd", { aid: info });
            } else {
                $state.go("collect.channelAdd");
            }
        }

        //查询广点通、adwords、神马有没有绑定账号
        $scope.bindChannelList = function() {
            var par = {
                gdt: "5305",
                adwords: "5303",
                smsearch: "5337"
            }
            ToolService.showLoading();
            var searchPM = HttpService.postInfo("mng/channelaccount/findcount", par);
            searchPM.then(function(data) {
                ToolService.hideLoading();
                $scope.showGdtBtn = data.gdt;
                $scope.showadwordsNtn = data.adwords;
                $scope.showsmsearchNtn = data.smsearch;

            })
        }
        $scope.bindChannelList();
    
            //汉字、数字、字母、下划线，下划线 
        $scope.checkAliasName = function(aliasName) {
            var reg = /^([a-z_A-Z-.+0-9\u4e00-\u9fa5]+)$/gi;
            if (!reg.test(aliasName) || aliasName == undefined) {
                return false;
            }
            return true;
        }
        $scope.strlen = function(str) {
                var len = 0;
                for (var i = 0; i < str.length; i++) {
                    var c = str.charCodeAt(i);
                    //单字节加1
                    if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
                        len++;
                    } else {
                        len += 2;
                    }
                }
                return len;
            }
            //修改别名
        $scope.editAlias = function(info) {
            $scope.curEditId = info.id;
            info.salias = info.alias;
        }
        $scope.saveAlias = function(info) {
            if (info.alias == info.salias) {
                $scope.curEditId = -1;
                return false;
            }
            if (info.salias == '') {
                ToolService.showTips($filter('translate')("不能为空"));
                return false;
            } else {
                $scope.salias = info.salias;
                $scope.checkreAlias($scope.salias);
                var parmas = {
                    alias: $scope.salias,
                    rebate: 0,
                    id: info.id
                };
                if ($scope.checkAlias == true) {

                    var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.salias);
                    packPM.then(function(data) {
                        if (data.content == false) { //为true时说明名称已经存在
                            ToolService.showLoading();
                            var saveUpdataPM = HttpService.putInfo("mng/channelaccount/alias", parmas);
                            saveUpdataPM.then(function(data) {
                                ToolService.hideLoading();
                                ToolService.showTips($filter('translate')("修改成功"));
                            })
                            $scope.checkAlias = true;
                            info.alias = info.salias;
                            $scope.curEditId = -1;

                        } else {
                            ToolService.showTips($filter('translate')("该渠道账号别名已经被占用"));
                            $scope.checkAlias = false;
                        }
                    });
                }
            }
        }

        $scope.checkreAlias = function() {
            $scope.checkAlias = false;
            var checkAlias = $scope.checkAliasName($scope.salias);
            if (checkAlias == false) {
                ToolService.showTips($filter('translate')("请输入8位以内的中英文、数字、下划线或英文横线"));
                return false;
            }
            var strlen = $scope.strlen($scope.salias)
            if (strlen > 16) {
                ToolService.showTips($filter('translate')("请输入8位以内的中英文、数字、下划线或英文横线"));
                return false;
            } else {
                if ($scope.salias == "" || $scope.salias == undefined) {
                    return false;
                } else {
                    $scope.checkAlias = true
                }

            }
        }



        $scope.loginuserName = UtilService.getCookie("ryioUname");
        $scope.goSm = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && !flag) {
                $state.go("collect.channelSm", { aid: info });
            } else {
                $state.go("collect.channelSm");
            }
        }

        $scope.goAdwords = function(info, flag) {
            if (info && flag == 10) {
                $rootScope.curChannel = info;
            }
            if (angular.isDefined(info) && flag != 10) {
                info.step = flag;
                $state.go("collect.channelAdwords", { aid: info });
            } else {
                $state.go("collect.channelAdwords");
            }
        }

        $scope.goSub = function(info, flag) {
            ToolService.sendBehaviorUv("goSub");
            $rootScope.curChannel = info;
            if (flag) {
                $scope.pageFlag = 3;
            } else {
                $scope.backFlag(2);
            }
            $scope.userType = 'authorize';

        }
        $scope.backFlag = function(flag) {
            $scope.pageFlag = flag;
            if (flag == 2) {
                if ($scope.curChannel == undefined) {
                    var subPM = HttpService.getInfo("mng/channelaccount/find/" + $scope.twoListID);
                } else {
                    var subPM = HttpService.getInfo("mng/channelaccount/find/" + $scope.curChannel.id);
                }
                ToolService.showLoading();
                subPM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.accountList = data;
                });
            }
            if (flag == 1) {
                $scope.filterTypeList($scope.channType);
                $state.go("collect.channelmanage", { aid: 'ry_coop' });
            }
            if ($scope.pageFlag == 5) {
                $state.go("collect.channelmanage", { aid: 'ry_coop' });


            }
        }
        $scope.appsListInit = "全部应用"
        $scope.authorizeList = function(type) {
            $scope.curEditId = -1;
            $scope.userType = type;
            $scope.accountList = [];
            if (type == 'authorize') {
                $scope.backFlag(2);
            } else {
                var authorizeID = "";
                if ($scope.curChannel == undefined) {
                    authorizeID = $scope.twoListID;
                } else {
                    authorizeID = $scope.curChannel.id;
                }
                var thirdAcount = 0
                if($scope.acountInfoId){
                    thirdAcount = $scope.acountInfoId;
                }
                // var campPM = HttpService.getInfo(0 + "/campaign/findallthird/" + authorizeID);
                var campPM = HttpService.getInfo(thirdAcount + "/campaign/findthirdback/" + authorizeID);
                ToolService.showLoading();
                campPM.then(function(data) {
                    ToolService.hideLoading();
                    data.apps.unshift({ id: "0", name: $scope.appsListInit });
                    $scope.accountList = data.accounts;
                    if(thirdAcount == 0){
                        $scope.appsListInfo = JSON.parse(JSON.stringify(data.apps))
                    }
                });
            }
        }
        var acountNum = 0;
        $scope.$on("appsListid", function(e, msg) {
            $scope.acountInfoId =  msg.info.id
            acountNum=acountNum+1
            if(acountNum>0){
                $scope.authorizeList();
                $scope.userType = 'backReturn';
            }
            
        })

        $scope.editName = function(info) {
            $scope.curEditId = info.id;
            info.thirdAccountAlias = info.name;
        }
        $scope.saveName = function(info) {
            if (info.name == info.thirdAccountAlias) {
                $scope.curEditId = -1;
                return false;
            }
            if (info.thirdAccountAlias == '') {
                ToolService.showTips($translate.instant("不能为空"));
                return false;
            }
            var verPar = {
                thirdAccountAlias: {
                    key: 'spcname1',
                    val: info.thirdAccountAlias,
                    txt: $translate.instant("支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内")
                }
            };

            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ == true) {
                ToolService.showLoading();
                var authorizeID = "";
                if ($scope.curChannel == undefined) {
                    authorizeID = $scope.twoListID;
                } else {
                    authorizeID = $scope.curChannel.id;
                }
                var namePM = HttpService.putInfo("mng/campaign/" + authorizeID + "/alteralias?thirdAccountAlias=" + info.thirdAccountAlias + "&thirdAccount=" + $scope.curEditId);
                namePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data) {
                        ToolService.showTips($translate.instant("修改成功"));
                        info.name = info.thirdAccountAlias;
                        $scope.curEditId = -1;
                    } else {
                        ToolService.showTips($translate.instant("名称重复"));
                    }
                });
            } else {
                ToolService.showTips($scope.tip.thirdAccountAlias.txt);
            }

        }

        if (($rootScope.channeluniqueName != "normal" && $rootScope.channeluniqueName != undefined && window.location.href.indexOf('channel') > -1) || type == 'adwords' || type == 'gdt' || type == 'smsearch') {
            $scope.userType = "authorize";
            if (type == 'adwords' || type == 'gdt' || type == 'smsearch') {
                $rootScope.channeluniqueName = type;
            }
            $scope.$watch("appid", function(n) {
                if (angular.isDefined(n)) {
                    var gdtPM = HttpService.getInfo($scope.appid + "/channel/find/" + $rootScope.channeluniqueName);
                    gdtPM.then(function(data) {
                        ToolService.hideLoading();
                        $scope.gdtData = data;
                        $scope.gdtDataId = data.id;
                        $scope.gdtName = data.name;
                        $scope.gdtUrl = data.nodeUrl;
                    });
                }
            });
            $scope.$watch("gdtDataId", function(n) {
                var stype = $stateParams.aid;
                if (angular.isDefined(n)) {
                    if (type == 5) {
                        $scope.pageFlag = 5;
                    } else {
                        $scope.pageFlag = 2;

                    }
                    var subPM = HttpService.getInfo("mng/channelaccount/find/" + $scope.gdtDataId);
                    ToolService.showLoading();
                    subPM.then(function(data) {
                        ToolService.hideLoading();
                        $scope.accountList = data;
                    });
                }
            });
            //$rootScope.channeluniqueName = 'normal';
        }

        $scope.openUrl = function(url) {
            if (url == "http://doc.trackingio.com/qu-dao-shi-yong-shuo-ming/guang-dian-901a-lao-mo-shi.html") {
                url = $rootScope.docDomain+"广点通-MarketingAPI.html";
            }
            window.open(url);
        }

        $scope.isdetail = false;
        $scope.isAcountDetail = false;
        $scope.showDetails = function(info) {
            $scope.showDetailsInfo = info;
            $scope.channelAlias = info.alias;
            var listPM = null;
            listPM = HttpService.getInfo("mng/channelaccount/app/find/" + info.id);
            listPM.then(function(data) {
                $scope.detailInfo = data;
            });
            ToolService.showAlp();
            $scope.isdetail = true;
            angular.element(document).on("click", function() {
                $scope.$apply(function() {
                    $scope.hideDetails();
                });
            });
        }
        $scope.showAcountDetails = function(info) {
            $scope.showDetailsInfo = info;
            $scope.channelAliasName = info.name;
            ToolService.showLoading();
            var listPM = null;
            listPM = HttpService.getInfo("0/campaign/thirdback/applist/" + info.id);
            listPM.then(function(data) {
                ToolService.hideLoading();
                $scope.acountDetailInfo = data;
            });
            ToolService.showAlp();
            $scope.isAcountDetail = true;
            angular.element(document).on("click", function() {
                $scope.$apply(function() {
                    $scope.hideDetails();
                });
            });
        }

        $scope.hideDetails = function() {
            ToolService.hideAlp();
            $scope.isdetail = false;
            $scope.isAcountDetail = false;

        }

        $scope.changeAccoutStatus = function(info, flag) {
                var url = "",
                    txt = "";
                if (flag == 1) {
                    url = "mng/channelaccount/forbidden/" + info.id;
                    txt = $translate.instant("停用成功");
                } else {
                    url = "mng/channelaccount/enable/" + info.id;
                    txt = $translate.instant("启用成功");
                }

                var enablePM = HttpService.putInfo(url);
                ToolService.showLoading();
                enablePM.then(function(data) {
                    $scope.twoListID = data.channel;
                    ToolService.hideLoading();
                    ToolService.showTips(txt)
                    $scope.backFlag(2);
                });
            }
            /*var oldname = "";
            $scope.subDetail = {};
            $scope.goSubDetail = function(info){
                $scope.pageFlag = 3;
                $scope.tip = {};
                if(info){//编辑
                    $scope.subDetail = info;
                    $scope.channelname = info.name;
                    $scope.channelpwd = info.password;
                    $scope.channeluname = oldname = info.alias;
                    $scope.channelRebate = info.rebate;
                }
                else{
                    $scope.subDetail = {};
                    $scope.channelname = "";
                    $scope.channelpwd = "";
                    $scope.channeluname = oldname = "";
                    $scope.channelRebate = "";
                }
            }*/
            //判断名称是否存在
        $scope.existName = function(flag) {
            if ($scope.judgeNameChange(oldname, $scope.channeluname)) {
                ToolService.showLoading();
                var namePM = HttpService.getInfo("mng/channelaccount/valid", { name: $scope.channeluname });
                namePM.then(function(data) {
                    if (!$scope.tip) {
                        $scope.tip = {};
                    }
                    ToolService.hideLoading();
                    if (data != true) { //存在
                        $scope.tip = {
                            channeluname: {
                                status: true,
                                txt: $translate.instant("渠道账号别名已存在")
                            }
                        }
                    } else {
                        $scope.tip = {
                            channeluname: {
                                status: false
                            }
                        }
                        if (flag && flag == 1) {
                            $scope.saveChannelUser();
                        }
                    }
                });
            } else {
                $scope.tip = {
                    channeluname: {
                        status: false
                    }
                }
                if (flag && flag == 1) {
                    $scope.saveChannelUser();
                }
            }
        }
        $scope.saveChannelUser = function() {
            var par = {
                name: $scope.channelname,
                password: $scope.channelpwd,
                alias: $scope.channeluname,
                rebate: $scope.channelRebate,
                channel: $scope.curChannel.id
            };
            var verPar = {
                channelname: {
                    key: 'isNull',
                    val: $scope.channelname
                },
                channelpwd: {
                    key: 'isNull',
                    val: $scope.channelpwd
                },
                channeluname: {
                    key: 'username',
                    val: $scope.channeluname,
                    txt: $translate.instant('支持16位内汉字或32位内字母数字')
                }
            }

            $scope.tip = formJudge(verPar);
            if (!UtilService.isNullStr($scope.channelRebate)) {
                if (!angular.isNumber($scope.channelRebate) || Number($scope.channelRebate) < 0 || Number($scope.channelRebate) > 100) {
                    $scope.tip.succ = false;
                    $scope.tip.channelRebate = {
                        status: true,
                        txt: $translate.instant("填写数值过大或过小（取值范围[0.01-100]）")
                    }
                } else {
                    $scope.tip.channelRebate = {};
                }
            } else {
                $scope.tip.channelRebate = {};
            }

            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }

            var savePM = null,
                txtTips = $translate.instant("添加成功");
            if ($scope.subDetail.id != null) {
                par.id = $scope.subDetail.id;
                savePM = HttpService.putInfo("mng/channelaccount/update", par);
                txtTips = $translate.instant("修改成功");
            } else {
                savePM = HttpService.postInfo("mng/channelaccount/create", par);
            }
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (!data.id) {
                    ToolService.showTips($translate.instant("账号或密码错误，请检查更新后重新创建"));
                } else {
                    ToolService.showTips(txtTips);
                    $scope.backFlag(2);
                }
            });
        }

        var init = function() {
            $scope.dayList = [
                // { id: 999, name: $translate.instant("未设置") },
                { id: 300, name: 5 + $translate.instant("分钟") },
                { id: 900, name: 15 + $translate.instant("分钟") },
                { id: 1800, name: 30 + $translate.instant("分钟") },
                { id: 3600, name: 1 + $translate.instant("小时") },
                { id: 7200, name: 2 + $translate.instant("小时") },
                { id: 10800, name: 3 + $translate.instant("小时") },
                { id: 21600, name: 6 + $translate.instant("小时") },
                { id: 43200, name: 12 + $translate.instant("小时") },

                { id: 86400, name: $translate.instant("1天") },
                { id: 172800, name: 2 + $translate.instant("天") },
                { id: 259200, name: 3 + $translate.instant("天") },
                { id: 345600, name: 4 + $translate.instant("天") },
                { id: 432000, name: 5 + $translate.instant("天") },
                { id: 518400, name: 6 + $translate.instant("天") },
                { id: 604800, name: 7 + $translate.instant("天") },
                { id: 1296000, name: 15 + $translate.instant("天") },
                { id: 2592000, name: 30 + $translate.instant("天") },
                { id: 5184000, name: 60 + $translate.instant("天") },
                { id: 7776000, name: 90 + $translate.instant("天") },
                { id: 10368000, name: 120 + $translate.instant("天") }
            ];
            $scope.dayList1 = [
                //5分钟、15分钟、30分钟， 1小时、3小时、6小时、12小时，1、2、3、4、5、6、7、15、30天 （换算成秒）
                { id: 300, name: 5 + $translate.instant("分钟") },
                { id: 900, name: 15 + $translate.instant("分钟") },
                { id: 1800, name: 30 + $translate.instant("分钟") },
                { id: 3600, name: 1 + $translate.instant("小时") },
                { id: 7200, name: 2 + $translate.instant("小时") },
                { id: 10800, name: 3 + $translate.instant("小时") },
                { id: 21600, name: 6 + $translate.instant("小时") },
                { id: 43200, name: 12 + $translate.instant("小时") },

                { id: 86400, name: $translate.instant("1天") },
                { id: 172800, name: 2 + $translate.instant("天") },
                { id: 259200, name: 3 + $translate.instant("天") },
                { id: 345600, name: 4 + $translate.instant("天") },
                { id: 432000, name: 5 + $translate.instant("天") },
                { id: 518400, name: 6 + $translate.instant("天") },
                { id: 604800, name: 7 + $translate.instant("天") },
                { id: 1296000, name: 15 + $translate.instant("天") },
                { id: 2592000, name: 30 + $translate.instant("天") },
                { id: 5184000, name: 60 + $translate.instant("天") },
                { id: 7776000, name: 90 + $translate.instant("天") },
                { id: 10368000, name: 120 + $translate.instant("天") }

            ];
            $scope.deviceList = [
                { id: 1, name: $translate.instant("已启用") },
                { id: 2, name: $translate.instant("已停用") }
            ];
            $scope.appointmentAttributionList =
            [{ id: 1, name: $translate.instant("1天") },
            { id: 2, name: 2 + $translate.instant("天") },
            { id: 3, name: 3 + $translate.instant("天") },
            { id: 4, name: 4 + $translate.instant("天") },
            { id: 5, name: 5 + $translate.instant("天") },
            { id: 6, name: 6 + $translate.instant("天") },
            { id: 7, name: 7 + $translate.instant("天") }]
            $scope.attributionPriorityList =[{ id: 0, name: $translate.instant("常规点击优先归因")},{ id: 1, name: $translate.instant("预约点击优先归因") }]
        }
        init();
        $scope.deviceInit = $scope.deviceList[0].id;
        //预约归因有效期、归因优先级
        $scope.appointmentAttributionInit = $scope.appointmentAttributionList[0].id;
        $scope.attributionPriorityInit = $scope.attributionPriorityList[0].id;

        //归因
        $scope.impAttributeList = [
            { id: true, name: $translate.instant("是") },
            { id: false, name: $translate.instant("否") }
        ];

        $scope.$on("appointmentAttributionId", function(e, msg) {
            $scope.appointmentAttribution = msg.info.id;
        });
        $scope.$on("attributionPriorityId", function(e, msg) {
            $scope.attributionPriority = msg.info.id;
        });

        $scope.$on("ciDay", function(e, msg) {
            $scope.ciDay = msg.info.id;
        });
        $scope.$on("ciDayOne", function(e, msg) {
            $scope.ciDayOne = msg.info.id;
        });
        $scope.$on("impAttribute", function(e, msg) {
            $scope.impAttribute = msg.info.id;
        });
        $scope.cheatList1 = [
            { id: 0, name: $translate.instant("严格") },
            { id: 1, name: $translate.instant("普通") },
            { id: 2, name: $translate.instant("宽松") }
        ];
        $scope.$on("cheatOne", function(e, msg) {
            $scope.cheatOne = msg.info.id;
        });
        //全渠道设置
        var rmd = new Date().getTime();
        var currentTime =new Date().Format('yyyy-MM-dd');
        $scope.allSet = function() {
            ToolService.sendBehaviorUv("allSet");
            $scope.pageFlag = 3;
            $scope.queryAllSet()
        }
        $scope.queryAllSet = function(){
            var allPM = HttpService.getInfo("mng/channelparam/find/black/"+$scope.appid);
            ToolService.showLoading();
            allPM.then(function(data) {
                ToolService.hideLoading();
                $scope.allData = data.allChannelValidMatch;
                if ($scope.allData == false) {
                    $scope.ciDayInit = 604800;   
                                    
                } else {
                    $scope.ciDayInit = data.ciDay ;
                }
                $scope.appointmentAttributionInit = data.deadLineDays;
                $scope.attributionPriorityInit = data.priority;
                $scope.onlineDateVal = data.onlineDate
                if(data.onlineDate && currentTime>data.onlineDate){// 当前日期>预计上线日期  选项置灰不可选
                    $scope.showOnlineDate = true;
                }else{
                    $scope.showOnlineDate = false;
                }
                $scope.datafresh2 = ++rmd;
                $scope.datafresh1 = ++rmd;
            });
        }
        //天、小时、分钟、转换 为秒
        function SecondToDate(msd) {
            var time =msd
            if (null != time && "" != time) {
                if (time > 60 && time < 60 * 60) {
                    time = parseInt(time / 60.0) + "分钟"
                }
                else if (time >= 60 * 60 && time < 60 * 60 * 24) {
                    time = parseInt(time / 3600.0) + "小时"
                } else if (time >= 60 * 60 * 24) {
                    time = parseInt(time / 3600.0/24) + "天"
                }
                else {
                    time = parseInt(time) + "秒";
                }
            }
            return time;
        }
        $scope.saveAllSet = function(id, flag) {
                //应用全渠道限制
                // if ($scope.ciDay == 999 && id == 0 && flag == "valid") {
                //     return false;
                // }

                var isall = true;
                if (id == 1) {
                    var isdefault = true;
                } else {
                    var isdefault = false;
                }
                var par = {};
                // if ($scope.ciDay == 999 && flag == "valid") {
                //     par.blacklistStatus = $scope.blackType
                // }
                if ($scope.ciDay != 999 && flag == "valid") {
                    par.ciDay = $scope.ciDay;
                    par.app = $scope.appid;

                }
                if(flag == "preorder"){
                    if($scope.showOnlineDate){
                        return false
                    }
                    par.deadLineDays = $scope.appointmentAttribution;
                    par.priority = $scope.attributionPriority;
                    par.defaultValue = id;
                    par.appId = $scope.appid;
                }
                var allsavePM = HttpService.putInfo("mng/channelparam/update/" + flag + "?isall=" + isall + "&isdefault=" + isdefault, par);
                ToolService.showLoading();
                allsavePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data == 'success') {
                        ToolService.showTips($translate.instant("保存成功"));
                    }
                    if (flag == 'black') {
                        $scope.allBlack = true;
                    } else {
                        $scope.allData = true;
                    }
                    if (id == 1) {
                        $scope.allSet();
                    }
                });
            }
            //渠道单独设置
        var oneSetId = 0;
        $scope.oneSet = function(info) {
            ToolService.sendBehaviorUv("oneSet");
            $scope.pageFlag = 4;
            $scope.channelParam = info;
            // var onePM = HttpService.getInfo("mng/channelparam/find/" + info.id);
            var onePM = HttpService.getInfo("mng/channelparam/find/" + info.id+"/"+$scope.appid);
            ToolService.showLoading();
            onePM.then(function(data) {
                ToolService.hideLoading();
                oneSetId = data.id;
                $scope.winciDayOne = $scope.ciDayOneInit = data.ciDay;
                $scope.winciDayOne = SecondToDate($scope.winciDayOne);
                $scope.blackOneType = data.blacklistStatus;
                $scope.deviceBlackStatus = data.deviceBlackStatus;
                // $scope.cheatOne = $scope.wincheatOne = $scope.cheatOneInit = data.blacklistLevel;
                $scope.wincheatOne = data.blacklistLevel;
                $scope.wholeChannelNum = data.wholeChannelNum;
                $scope.attrCfg = data.attrCfg;
                // if (data.blacklistLevel == -1) {
                //     $scope.cheatOne = $scope.cheatOneInit = 1;
                // }
                $scope.impAttributeInit = (data.impAttribute ? true : false);
            });
        }

        $scope.blackClick = function(id) {
            if (id == 1) {
                $scope.modalBlackOneType = true;
                // if ($scope.wincheatOne = -1) {
                //     $scope.cheatOne = $scope.wincheatOne = $scope.cheatOneInit = 1;
                // }
            } else {
                $scope.modalBlackOneType = false;
            }
        }
        $scope.deviceBlackStatusClick = function(id) {
            if (id == 1) {
                $scope.modalDeviceBlackStatus = true;
            } else {
                $scope.modalDeviceBlackStatus = false;
            }
        }

        $scope.saveOne = function(id, flag) {
            // if($rootScope.demoU){return false;}
            var isall = false;
            if (id == 1) {
                var isdefault = true;
            } else {
                var isdefault = false;
            }
            var par = {
                id: oneSetId,
                cid: $scope.channelParam.id,
                ciDay: $scope.ciDayOne,
                blacklistStatus: flag == 'black'?$scope.modalBlackOneType:$scope.blackOneType,
                wholeChannelNum: $scope.wholeChannelNum,
                impAttribute: $scope.impAttribute,
                deviceBlackStatus: flag == 'black'?($scope.modalDeviceBlackStatus ? true : false):$scope.deviceBlackStatus ? true : false
            };
            if (isdefault) {
                if (flag === "impression") {
                    par.impAttribute = isdefault = false;
                }
                if (flag === "black") {
                    par.deviceBlackStatus = isdefault = false;
                }
                if (flag == 'valid') {
                    var validFunction = 'validDay'
                } else if (flag == 'attrWay') {
                    var validFunction = 'validType'
                }
            }

            if (par.blacklistStatus == true || par.deviceBlackStatus == true) {
                par.blacklistLevel =  flag == 'black'?$scope.cheatOne:$scope.wincheatOne;
            } else {
                par.blacklistLevel = -1;
            }
           
            if(flag === "attrWay" ){
                flag = "valid";
                if(id == 1){
                    par.attrCfg =  0;
                    $scope.attrCfg = 0
                }else{
                    par.attrCfg = $scope.attrCfg;
                }
            }
            par.app = $scope.appid;
            if (isdefault && (flag == 'valid' || flag == 'attrWay')) {
                var url = "mng/channelparam/update/" + flag + "?isall=" + isall + "&isdefault=" + isdefault + '&validFunction='+ validFunction
            } else {
                var url = "mng/channelparam/update/" + flag + "?isall=" + isall + "&isdefault=" + isdefault
            }
            var onesavePM = HttpService.putInfo(url, par);
            ToolService.showLoading();
            onesavePM.then(function(data) {
                ToolService.hideLoading();
                $scope.closeWin();
                ToolService.showTips($translate.instant("保存成功，修改后第二天零点生效。"));
                oneSetId = data.id;
                $scope.winciDayOne = $scope.ciDayOneInit = data.ciDay;
                $scope.winciDayOne = SecondToDate($scope.winciDayOne);
                $scope.blackOneType = data.blacklistStatus;
                $scope.deviceBlackStatus = data.deviceBlackStatus;
                // $scope.cheatOne = $scope.wincheatOne = $scope.cheatOneInit = data.blacklistLevel;
                $scope.wincheatOne = data.blacklistLevel;
                $scope.impAttributeInit = data.impAttribute;
                $scope.attrCfg = data.attrCfg;
            });
        }

        $scope.closeWin = function() {
            $scope.winFlag = 1;
            ToolService.hideAlp();
        }

        //数据有效期设置
        $scope.setData = function() {
                ToolService.sendBehaviorUv("setData");
                ToolService.showAlp();
                $scope.winFlag = 2;
            }
            //黑名单设置
        $scope.setBlock = function() {
            ToolService.showAlp();
            $scope.winFlag = 3;
            $scope.modalDeviceBlackStatus = $scope.deviceBlackStatus;
            $scope.modalBlackOneType = $scope.blackOneType;
            if ($scope.wincheatOne == -1) {
                $scope.cheatOne = $scope.cheatOneInit = 1;
            } else {
                $scope.cheatOne = $scope.cheatOneInit = $scope.wincheatOne
            }

        }
        //归因方式设置
        $scope.setAttrWay = function() {
            ToolService.showAlp();
            $scope.winFlag = 5;
        }
            //展示归因设置
        $scope.setAttr = function() {
            ToolService.showAlp();
            $scope.winFlag = 4;
        }
        $scope.createChannel = function(){
            if($scope.editPower){
                $state.go("collect.channelDetail", { aid: "channelManage" }); 
            }
            if($rootScope.isAppManage){
                ToolService.showTips("子应用管理员没有权限创建");
            }
            
        }

        $scope.$watch("{appid:appid,lang:lang}", function(n, o) {
            if (angular.isUndefined($scope.appid)) {
                return false;
            }
            $scope.getSystemparam()
            $scope.query();
            $scope.queryAllSet();
            if (n && o && n != o) {
                init();
                if($scope.channelParam && $scope.pageFlag == 4){
                    $scope.oneSet($scope.channelParam);
                }

            }
        });
    }

    function channelAddCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $filter, $translate) {
        if ($rootScope.isSuper || $rootScope.isManage) {
            $scope.editPower = true;
        } else {
            $scope.editPower = false;
        }

        $rootScope.channeluniqueName = 'gdt';
        $scope.stepflag = 0; //1、2、3步
        $scope.step1 = 'normal'; //第一步   normal   failure  success
        var editInfo = $stateParams.aid;
        if (angular.isDefined(editInfo) && editInfo != null) {
            infoId = $scope.id = editInfo.id;
            if (editInfo.step == 1) {
                $scope.stepflag = 1;
            }
        }

        /*else{
            $scope.hasEnable = true;
        }*/
        var oldname = "";
        var oldthirdAccountCode = "";
        var oldalias = "";
        $scope.pastStatus = false;
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.state = oldname = editInfo.name;
                $scope.accountid = oldthirdAccountCode = editInfo.thirdAccountCode;
                $scope.rebate = parseFloat(editInfo.rebate);
                $scope.alias = oldalias = editInfo.alias;
                $scope.pastStatus = editInfo.pastStatus;
                $scope.step1 = 'success';

            } else {
                $scope.rebate = 0;
            }
        };
        $scope.init();
        if ($scope.id == undefined) {
            $scope.flag = 1;
        } else {
            $scope.flag = 0;
        }


        $scope.gotoGdtList = function(info, flag) {
            $scope.bindingList();
            $scope.pageFlag = flag;
            $state.go("collect.channelmanage", { aid: $scope.pageFlag });
        }
        $scope.bindingList = function() {
            ToolService.showLoading();
            var tablePM = HttpService.getInfo("mng/channelaccount/findLinkedApp/5305");
            tablePM.then(function(data) {
                ToolService.hideLoading();
                $scope.channelAddList = data.filter(function(item) {
                    if (item.feedbackurl == "暂无") {
                        item.showCope = false;
                        item.feedbackurl = "暂无"
                    } else {
                        item.showCope = true;
                        item.feedbackurl = "http://uri6.com/tkio/" + item.feedbackurl + "?noredirect=true"
                    }

                    return true;
                });
            });
        }

        $scope.cancel = function() {
            if ($scope.empowerType == true) {
                var savePM = null;
                savePM = HttpService.deleteInfo("mng/channelaccount/delete/authorize/" + $scope.flag + "/" + $scope.state);
                savePM.then(function(data) {
                    $state.go("collect.channelmanage", { aid: 'ry_coop' });
                });
            } else {
                $state.go("collect.channelmanage", { aid: 'ry_coop' });
            }

        }
        $scope.saveZero = function() {
            $scope.nextStep();
        }
        $scope.setStep = function(stepflag) {
            $scope.stepflag = stepflag;
        }
        $scope.nextStep = function() {
            $scope.stepflag = $scope.stepflag + 1;
        }
        $scope.lastStep = function() {
                $scope.stepflag = $scope.stepflag - 1;
                $scope.checkAlias = false;
            }
            //弹窗
        $scope.openDialog = function() {
            if ($rootScope.doMainType == 0) {
                window.open($rootScope.docDomain+"广点通-MarketingAPI.html");
            } else if ($rootScope.doMainType == 1) {
                window.open($rootScope.otherCompanyInfo.gdtDocUrl)
            }
        }

        $scope.empower = function() {
            $scope.aliasID = $scope.aliasID;
            $scope.promiseF().then(function() {
                    var par = {
                        state: $scope.state,
                        accountid: $scope.accountid
                    };
                    var verPar = {
                        state: {
                            key: 'num',
                            val: par.state,
                            txt: $translate.instant('合法性为仅支持输入数字，长度不限')
                        },
                        accountid: {
                            key: 'num',
                            val: par.accountid,
                            txt: $translate.instant('合法性为仅支持输入数字，长度不限')
                        }
                    }
                    $scope.tip = formJudge(verPar);
                    if ($scope.tip.succ != true) {
                        ToolService.showTips($scope.formTipMsg);
                        return false;
                    }
                    if($rootScope.redirectNewDoman){
                        window.open("https://developers.e.qq.com/oauth/authorize?client_id=1106237187&redirect_uri=http://www.trackingio.com/api/mng/channelaccount/code&state=" + $scope.state);
                    }else{
                        //腾讯云
                        window.open("https://developers.e.qq.com/oauth/authorize?client_id=1110744256&redirect_uri=http://tweb.trackingio.com/api/mng/channelaccount/code&state=" + $scope.state);
                    }
                    $scope.empowerType = true;
                })
        }

        $scope.empowerError = function() {
            $scope.empowerType = false;
        }

        $scope.empowerOK = function() {
            var savePM = null;
            savePM = HttpService.getInfo("mng/channelaccount/valid/qq?qq=" + $scope.state);
            savePM.then(function(data) {
                $scope.empowerType = false;
                if (data == true) {
                    $scope.step1 = 'success';
                    $scope.accountAuthorization();
                } else {
                    $scope.step1 = 'failure';
                }
            });
        }

        $scope.powerAgain = function() {
                $scope.step1 = 'normal';
            }
            // $scope.checkQQ = true;
        $scope.exixtQQ = function() {
                // $scope.checkQQ = true;
                if (oldname == $scope.state) {
                    $scope.checkQQ = false;
                } else {
                    if ($scope.state == "" || $scope.state == undefined) {}
                    var packPM = HttpService.getInfo("mng/channelaccount/valid/qq?qq=" + $scope.state);
                    return packPM.then(function(data) {
                        if (data.content == false) {
                            $scope.checkQQ = false;
                            $scope.tip = {
                                state: {
                                    status: false,
                                    txt: ''
                                }
                            };
                        } else {
                            $scope.checkQQ = true;
                            $scope.tip = {
                                state: {
                                    status: true,
                                    txt: $translate.instant('该渠道账号已被授权，如果需要对该账号重新授权，请到对应账号进行修改。')
                                }
                            };
                        }
                    });
                }
            }
            // $scope.checkID = true;
        $scope.exixtID = function() {
            // $scope.checkID = true;
            if (oldthirdAccountCode == $scope.accountid) {
                $scope.checkID = false;
            } else {
                if ($scope.accountid == "" || $scope.accountid == undefined) {
                    return false;
                }
                var packPM = HttpService.getInfo("mng/channelaccount/valid/accountid?accountid=" + $scope.accountid);
                packPM.then(function(data) {
                    if (data.content == false) {
                        $scope.checkID = false;
                        $scope.tip = {
                            accountid: {
                                status: false,
                                txt: ''
                            }
                        };
                    } else {
                        $scope.checkID = true;
                        $scope.tip = {
                            accountid: {
                                status: true,
                                txt: $translate.instant('该账号id已被绑定到其他渠道账号，请到对应账号进行修改')
                            }
                        };
                    }
                });
            }
        }

        $scope.accountAuthorization = function() {
            var par = {
                name: $scope.state,
                thirdAccountCode: $scope.accountid
            };
            var savePM = null;
            savePM = HttpService.postInfo("mng/channelaccount/authorize", par);
            savePM.then(function(data) {
                $scope.aliasID = data.id;
            });
        }

        $scope.saveOne = function() {
            $scope.saveTwo();
            $scope.nextStep();
        }

        //汉字、数字、字母、下划线，下划线 
        $scope.checkAliasName = function(aliasName) {
            var reg = /^([a-z_A-Z-.+0-9\u4e00-\u9fa5]+)$/gi;
            if (!reg.test(aliasName) || aliasName == undefined) {
                return false;
            }
            return true;
        }
        $scope.strlen = function(str) {
                var len = 0;
                for (var i = 0; i < str.length; i++) {
                    var c = str.charCodeAt(i);
                    //单字节加1
                    if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
                        len++;
                    } else {
                        len += 2;
                    }
                }
                return len;
            }
            //第二步
        $scope.saveTwo = function() {
            if ($scope.checkAlias == undefined || $scope.checkAlias == false) {
                $scope.exixtAlias();
            }
            if ($scope.checkAlias == false) {
                return false;
            }
            if ($scope.aliasID == null || $scope.aliasID == undefined || $scope.aliasID == "") {
                $scope.aliasID = $scope.id
            }
            var parmas = {
                alias: $scope.alias,
                rebate: $scope.rebate,
                id: $scope.aliasID
            };

            var verParmas = {
                alias: {
                    key: 'isNull',
                    val: $scope.alias
                }
            }
            $scope.tip = formJudge(verParmas);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }

            if ($scope.checkAlias == true) {
                var savePM = null;
                savePM = HttpService.putInfo("mng/channelaccount/alias", parmas);
                savePM.then(function(data) {
                    if (data.id != null) {
                        $scope.createID = data.id;
                    }
                });

            }
        }
        $scope.promiseF = function() {
            return new Promise(function(resolve, reject) {
                var checkAlias = $scope.checkAliasName($scope.alias);
                if (checkAlias == false) {
                    $scope.tip = {
                        alias: {
                            status: true,
                            txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                        }
                    };
                    return false;
                }
                var strlen = $scope.strlen($scope.alias)
                if (strlen > 16) {
                    $scope.tip = {
                        alias: {
                            status: true,
                            txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                        }
                    };
                    return false;
                }
                if (oldalias == $scope.alias) {
                    $scope.checkAlias = true;
                    if (oldname == $scope.state) {
                        $scope.checkQQ = false;
                        if (oldthirdAccountCode == $scope.accountid) {
                            $scope.checkID = false;
                            resolve();
                        } else {
                            if ($scope.accountid == "" || $scope.accountid == undefined) {
                                return false;
                            }
                            var packPM = HttpService.getInfo("mng/channelaccount/valid/accountid?accountid=" + $scope.accountid);
                            packPM.then(function(data) {
                                if (data.content == false) {
                                    $scope.checkID = false;
                                    $scope.tip = {
                                        accountid: {
                                            status: false,
                                            txt: ''
                                        }
                                    };
                                    resolve();
                                } else {
                                    $scope.checkID = true;
                                    $scope.tip = {
                                        accountid: {
                                            status: true,
                                            txt: $translate.instant('该账号id已被绑定到其他渠道账号，请到对应账号进行修改')
                                        }
                                    };
                                }
                            });
                        }
                    } else {
                        if ($scope.state == "" || $scope.state == undefined) {
                            return false;
                        }
                        var packPM = HttpService.getInfo("mng/channelaccount/valid/qq?qq=" + $scope.state);
                        packPM.then(function(data) {
                            if (data.content == false) {
                                $scope.checkQQ = false;
                                $scope.tip = {
                                    state: {
                                        status: false,
                                        txt: ''
                                    }
                                };
                                if (oldthirdAccountCode == $scope.accountid) {
                                    $scope.checkID = false;
                                    resolve();
                                } else {
                                    if ($scope.accountid == "" || $scope.accountid == undefined) {
                                        return false;
                                    }
                                    var packPM = HttpService.getInfo("mng/channelaccount/valid/accountid?accountid=" + $scope.accountid);
                                    packPM.then(function(data) {
                                        if (data.content == false) {
                                            $scope.checkID = false;
                                            $scope.tip = {
                                                accountid: {
                                                    status: false,
                                                    txt: ''
                                                }
                                            };
                                            resolve()
                                        } else {
                                            $scope.checkID = true;
                                            $scope.tip = {
                                                accountid: {
                                                    status: true,
                                                    txt: $translate.instant('该账号id已被绑定到其他渠道账号，请到对应账号进行修改')
                                                }
                                            };
                                        }
                                    });
                                }
                            } else {
                                $scope.checkQQ = true;
                                $scope.tip = {
                                    state: {
                                        status: true,
                                        txt: $translate.instant('该渠道账号已被授权，如果需要对该账号重新授权，请到对应账号进行修改。')
                                    }
                                };
                            }
                        });
                    }
                } else {
                    if ($scope.alias == "" || $scope.alias == undefined) {
                        return false;
                    }
                    var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.alias);
                    // var packPM = HttpService.getInfo("mng/channelaccount/valid?name="+$scope.alias);
                    packPM.then(function(data) {
                        if (data.content == false) { //为true时说明名称已经存在
                            $scope.checkAlias = true;
                            $scope.tip = {
                                alias: {
                                    status: false,
                                    txt: ''
                                }
                            };
                            if (oldname == $scope.state) {
                                $scope.checkQQ = false;
                                if (oldthirdAccountCode == $scope.accountid) {
                                    $scope.checkID = false;
                                    resolve();
                                } else {
                                    if ($scope.accountid == "" || $scope.accountid == undefined) {
                                        return false;
                                    }
                                    var packPM = HttpService.getInfo("mng/channelaccount/valid/accountid?accountid=" + $scope.accountid);
                                    packPM.then(function(data) {
                                        if (data.content == false) {
                                            $scope.checkID = false;
                                            $scope.tip = {
                                                accountid: {
                                                    status: false,
                                                    txt: ''
                                                }
                                            };
                                            resolve()
                                        } else {
                                            $scope.checkID = true;
                                            $scope.tip = {
                                                accountid: {
                                                    status: true,
                                                    txt: $translate.instant('该账号id已被绑定到其他渠道账号，请到对应账号进行修改')
                                                }
                                            };
                                        }
                                    });
                                }
                            } else {
                                if ($scope.state == "" || $scope.state == undefined) {
                                    return false;
                                }
                                var packPM = HttpService.getInfo("mng/channelaccount/valid/qq?qq=" + $scope.state);
                                packPM.then(function(data) {
                                    if (data.content == false) {
                                        $scope.checkQQ = false;
                                        $scope.tip = {
                                            state: {
                                                status: false,
                                                txt: ''
                                            }
                                        };
                                        if (oldthirdAccountCode == $scope.accountid) {
                                            $scope.checkID = false;
                                            resolve();
                                        } else {
                                            if ($scope.accountid == "" || $scope.accountid == undefined) {
                                                return false;
                                            }
                                            var packPM = HttpService.getInfo("mng/channelaccount/valid/accountid?accountid=" + $scope.accountid);
                                            packPM.then(function(data) {
                                                if (data.content == false) {
                                                    $scope.checkID = false;
                                                    $scope.tip = {
                                                        accountid: {
                                                            status: false,
                                                            txt: ''
                                                        }
                                                    };
                                                    resolve();
                                                } else {
                                                    $scope.checkID = true;
                                                    $scope.tip = {
                                                        accountid: {
                                                            status: true,
                                                            txt: $translate.instant('该账号id已被绑定到其他渠道账号，请到对应账号进行修改')
                                                        }
                                                    };
                                                }
                                            });
                                        }
                                    } else {
                                        $scope.checkQQ = true;
                                        $scope.tip = {
                                            state: {
                                                status: true,
                                                txt: $translate.instant('该渠道账号已被授权，如果需要对该账号重新授权，请到对应账号进行修改。')
                                            }
                                        };
                                    }
                                });
                            }
                        } else {
                            $scope.tip = {
                                alias: {
                                    status: true,
                                    txt: $translate.instant('该渠道账号别名已经被占用')
                                }
                            };
                        }
                    });
                }
            })
        }
        $scope.exixtAlias = function() {
            $scope.checkAlias = false;
            var checkAlias = $scope.checkAliasName($scope.alias);
            if (checkAlias == false) {
                $scope.tip = {
                    alias: {
                        status: true,
                        txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                    }
                };
                return false;
            }

            var strlen = $scope.strlen($scope.alias)
            if (strlen > 16) {
                $scope.tip = {
                    alias: {
                        status: true,
                        txt: '请输入8位以内的中英文、数字、下划线或英文横线'
                    }
                };
                return false;
            }


            if (oldalias == $scope.alias) {
                $scope.checkAlias = true;
            } else {
                if ($scope.alias == "" || $scope.alias == undefined) {
                    return false;
                }
                var packPM = HttpService.getInfo("mng/channelaccount/valid/checkAlias?alias=" + $scope.alias);
                // var packPM = HttpService.getInfo("mng/channelaccount/valid?name="+$scope.alias);
                packPM.then(function(data) {
                    if (data.content == false) { //为true时说明名称已经存在
                        $scope.checkAlias = true;
                        $scope.tip = {
                            alias: {
                                status: false,
                                txt: ''
                            }
                        };
                    } else {
                        $scope.tip = {
                            alias: {
                                status: true,
                                txt: $translate.instant('该渠道账号别名已经被占用')
                            }
                        };
                    }
                });
            }
        }

        //第三步
        var rmd = new Date().getTime();
        $scope.productList = function() {
                var savePM = null;
                if ($scope.createID == null || $scope.createID == undefined) {
                    $scope.createID = $scope.id;
                }
                //savePM = HttpService.getInfo("mng/channelaccount/app/list?accountid="+$scope.accountid);
                savePM = HttpService.getInfo("mng/channelaccount/" + $scope.createID + "/app/list?linkuserid=" + $scope.createID + "&unique_name=gdt");
                savePM.then(function(data) {
                    $scope.dayList = data;
                    $scope.appnameInit = data[0].id;
                    $scope.$on("appname", function(e, msg) {
                        $scope.appname = msg.info.id;
                        $scope.appType = msg.info.platform;
                        $scope.appkey = msg.info.appkey;
                        if ($rootScope.channeluniqueName = 'gdt') {
                            $scope.isOpenGdtCampaign(5305, $scope.appname); //广点通ID
                        }
                    });
                });
                $scope.datafresh = ++rmd;
            }
            /**
             * 判断产品下是否有启动的‘广点通’推广活动
             * @param channelId
             * @param appId
             */
        $scope.isOpenGdtCampaign = function(channelId, appId) {
            var pm = HttpService.getInfo("mng/campaign/checkCamValid?channelid=" + channelId + "&appid=" + appId);
            pm.then(function(data) {
                // data.activeCampaign = true;
                $scope.activeCampaign = data.activeCampaign;
            });
        }

        $scope.tableList = function() {
            var savePM = null;
            if ($scope.createID == null || $scope.createID == undefined) {
                $scope.createID = ($scope.id ? $scope.id : $scope.aliasID);
            }
            savePM = HttpService.getInfo("mng/channelaccount/app/find/" + $scope.createID);
            savePM.then(function(data) {
                $scope.tableData = data;
            });
        }




        $scope.$watch("stepflag", function(n) {
            if (angular.isDefined(n)) {
                if ($scope.stepflag == 1) {
                    $scope.tableList(); //回显绑定的产品

                }
            }
        });

        //监测appname
        $scope.$watch("appname", function(n) {
            $scope.nodata();
        });

        $scope.nodata = function() {
            $scope.createType = 'noadd';
            $scope.thirdAppId = "";
            $scope.userActionSetId = "";
            $scope.tip = {
                thirdAppId: {
                    status: false
                }
            };
        }

        $scope.addType = false;
        $scope.addProduct = function() {
            if ($scope.createType == "inadd" || $scope.createType == "erroradd" || $scope.createType == "openadd") {
                ToolService.showTips($translate.instant("请先完成当前产品测试，再添加下一个产品。"));
            } else {
                $scope.userActionSetIdTxt = $translate.instant("点击右侧按钮获取行为数据源ID");
                $scope.createType = "openadd";
                $scope.addType = true;
                $scope.productList();
            }
        }
        $scope.closeProduct = function() {
            $scope.addType = false;
            $scope.nodata();
        }

        //获取行为数据源ID
        $scope.getDmpCode = function() {
            var par = {
                thirdAppId: $scope.thirdAppId,
                linkUserId: $scope.createID,
                appName: $scope.appname,
                appType: $scope.appType,
                accountId: $scope.accountid,
                // channelid:5305,
            };
            var verPar = {
                thirdAppId: {
                    key: 'isNull',
                    val: par.thirdAppId
                }
            }
            if (!$scope.id) {
                par.channelid = 5305;
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = null;
            ToolService.showLoading();
            savePM = HttpService.postInfo("mng/channelaccount/userid/create", par);
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (data.data != null || data.data != undefined) {
                    $scope.userActionSetId = data.data;
                    $scope.userActionSetIdTxt = "";
                } else {
                    $scope.tip = {
                        thirdAppId: {
                            status: true,
                            txt: data.msg || data.message
                        }
                    };
                }
            });
        }
        $scope.$on('appname', function(e, msg) {
            $scope.data = msg.info;
            $scope.app = $scope.data.id;
            $scope.name = $scope.data.name;
            $scope.platform = $scope.data.platform;
            $scope.url = $scope.data.url;
        });
        //生产feedback URL       
        $scope.createGdtUrl = function() {
            var par = {
                app: $scope.app,
                batchNumber: 1,
                channel: "5305",
                holderids: "",
                name: $scope.name,
                os: $scope.platform,
                url: $scope.url
            };
            urlPM = HttpService.postInfo("mng/campaign/" + $scope.app + "/creategdt", par);
            urlPM.then(function(data) {
                if (data.length > 0) {
                    $scope.surlList = data[0].surl;
                    $scope.surl = "http://uri6.com/tkio/" + $scope.surlList + "?noredirect=true"
                }
            })
        }


        //noadd未添加  openadd打开弹窗     inadd添加中    okadd添加成功    erroradd添加失败
        $scope.createType = "noadd";

        //连接测试
        $scope.testDmp = function() {
            var par = {
                thirdAppId: $scope.thirdAppId,
                appName: $scope.appname,
                appkey: $scope.appkey,
                userActionSetId: $scope.userActionSetId,
                linkUserId: $scope.createID,
                appType: $scope.appType,
                accountId: $scope.accountid
            };
            var verPar = {
                thirdAppId: {
                    key: 'isNull',
                    val: $scope.thirdAppId
                },
                userActionSetId: {
                    key: 'isNull',
                    val: $scope.userActionSetId
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = null;
            $scope.createType = "inadd";
            savePM = HttpService.postInfo("mng/channelaccount/app/create", par);
            savePM.then(function(data) {
                if (data.code == 0) {
                    $scope.createType = "okadd";
                    $scope.tableList();
                    $scope.closeProduct();
                    $scope.createGdtUrl();
                } else {
                    $scope.createType = "erroradd";
                    $scope.failureText = data.message;
                }
            });
        }



        //删除
        $scope.deletePro = function(obj) {
            $scope.delstatus = true;
            $scope.delId = obj.id;
        }
        $scope.removeInfo = function() {
            var removePM = HttpService.deleteInfo("mng/channelaccount/delete/app/" + $scope.delId);
            ToolService.showLoading();
            removePM.then(function(data) {
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($translate.instant("删除成功"));
                $scope.tableList();
            });
        }

        //保存
        $scope.save = function() {
                $state.go("collect.channelmanage", { aid: 'ry_coop' });
            }
            //转到推广活动管理
        $scope.goCampaign = function() {
            // $scope.$parent.appid = $scope.appname;
            $scope.$emit("mngappTo", $scope.appname);
            $state.go("collect.campaign");
        }

        //
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
                $scope.userActionSetIdTxt = $translate.instant("点击右侧按钮获取行为数据源ID");
            }
        });
    }

    function channelSmCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        $rootScope.channeluniqueName = 'smsearch';
        var editInfo = $stateParams.aid;
        if (angular.isDefined(editInfo) && editInfo != null) {
            var infoId = $scope.id = editInfo.id;
        }

        var oldalias = "";
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.alias = oldalias = editInfo.alias;
                $scope.name = editInfo.name;
                $scope.password = editInfo.password;
                //pastStatus   false为授权成功
                if (editInfo.pastStatus == false) {
                    $scope.step1 = 'success';
                } else {
                    $scope.step1 = 'failure';
                }
            }
        };
        $scope.init();

        var channelID = "";
        $scope.$watch("appid", function(n) {
            if (angular.isDefined(n)) {
                var gdtPM = HttpService.getInfo($scope.appid + "/channel/find/smsearch");
                gdtPM.then(function(data) {
                    ToolService.hideLoading();
                    channelID = data.id;
                });
            }
        });

        $scope.cancel = function() {
            $state.go("collect.channelmanage", { aid: 'ry_bd' });
        }

        $scope.exixtName = function() {
            if (oldalias == $scope.alias) {
                $scope.checkName = true;
            } else {
                if ($scope.alias == "" || $scope.alias == undefined) {
                    return false;
                }
                ToolService.showLoading();
                var packPM = HttpService.getInfo("mng/channelaccount/valid?name=" + $scope.alias);
                packPM.then(function(data) {
                    ToolService.hideLoading();
                    if (data == true) {
                        $scope.checkName = true;
                        $scope.tip = {
                            alias: {
                                status: false,
                                txt: ''
                            }
                        };
                    } else {
                        $scope.checkName = false;
                        $scope.tip = {
                            alias: {
                                status: true,
                                txt: $translate.instant('该账号别名已存在，请更换。')
                            }
                        };
                    }
                });
            }
        }
        $scope.empowerType = false;
        $scope.empower = function() {
            if ($scope.checkName == false) {
                return false;
            }
            var par = {
                channel: channelID,
                alias: $scope.alias,
                name: $scope.name,
                password: $scope.password
            };
            var verPar = {
                alias: {
                    key: 'isNull',
                    val: par.alias
                },
                name: {
                    key: 'isNull',
                    val: par.name
                },
                password: {
                    key: 'isNull',
                    val: par.password
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            ToolService.showLoading();
            var savePM = null;
            if ($scope.id != null) {
                par.id = $scope.id;
                savePM = HttpService.putInfo("mng/channel/account/update", par);
            } else {
                savePM = HttpService.postInfo("mng/channel/account/create", par);
            }
            savePM.then(function(data) {
                ToolService.hideLoading();
                $scope.empowerType = true;
                $scope.id = $scope.empowerID = data.id;
                window.open("https://e.sm.cn/auth/appAuthorize/authorizationRequest?response_type=code&state=" + $scope.empowerID + "&scope=1,2&redirect_uri=http://www.trackingio.com/api/third/getToken&client_id=434&client_secret=3e1bdcb210290c0668566e414373c8c3");
            });
        }
        $scope.failureAlert = false;
        $scope.empowerOK = function() {
            var savePM = null;
            savePM = HttpService.getInfo("mng/channel/account/checkstatus?id=" + $scope.empowerID);
            savePM.then(function(data) {
                $scope.empowerType = false;
                if (data == true) {
                    $scope.step1 = 'success';
                    ToolService.showTips($translate.instant("授权成功"));
                    $scope.cancel();
                } else {
                    $scope.step1 = 'failure';
                    $scope.failureAlert = true;
                }
            });
        }

        $scope.empowerError = function() {
            $scope.empowerType = false;
            $scope.pastStatus = true;
        }

        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
            }
        });
    }

    function channelAdwordsCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate) {
        if ($rootScope.isSuper || $rootScope.isManage) {
            $rootScope.editPower = true;
        } else {
            $rootScope.editPower = false;
        }
        $scope.stepflag = 1;

        $rootScope.channeluniqueName = 'adwords';
        var editInfo = $stateParams.aid;
        if (angular.isDefined(editInfo) && editInfo != null) {
            var infoId = $scope.id = editInfo.id;
            if (editInfo.step == 2) {
                $scope.stepflag = 2;
            }
        }
        var oldname = "";
        var oldthirdAccountCode = "";
        var oldalias = "";
        $scope.pastStatus = false;
        $scope.init = function() {
            if (angular.isDefined(editInfo) && editInfo != null) {
                $scope.name = oldname = editInfo.name;
                $scope.thirdAccountCode = oldthirdAccountCode = editInfo.thirdAccountCode;
                $scope.alias = oldalias = editInfo.alias;
            }
        };
        $scope.init();

        $scope.cancel = function() {
            $state.go("collect.channelmanage", { aid: 'ry_coop' });
        }

        var channelID = "";
        $scope.$watch("appid", function(n) {
            if (angular.isDefined(n)) {
                var gdtPM = HttpService.getInfo($scope.appid + "/channel/find/adwords");
                gdtPM.then(function(data) {
                    ToolService.hideLoading();
                    channelID = data.id;
                });
            }
        });

        //弹窗
        $scope.openDialog = function() {
            if ($rootScope.doMainType == 0) {
                window.open($rootScope.docDomain+"Adwords.html");
            } else if ($rootScope.doMainType == 1) {
                window.open($rootScope.otherCompanyInfo.adwordsDocUrl)
            }
        }

        $scope.saveOne = function() {
            //$scope.stepflag = 2;
            var par = {
                channel: channelID,
                alias: $scope.alias,
                name: $scope.name,
                thirdAccountCode: $scope.thirdAccountCode
            };
            var verPar = {
                alias: {
                    key: 'spcname',
                    max: 40,
                    val: $scope.alias,
                    txt: $translate.instant("含非法字符或过长（支持输入汉字、大小写字母、数字、下划线、中划线，长度限制40字符以内）")
                },
                name: {
                    key: 'isNull',
                    val: $scope.name
                },
                thirdAccountCode: {
                    key: 'isNull',
                    val: $scope.thirdAccountCode
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            var savePM = null;
            if ($scope.id != null) {
                par.id = $scope.id;
                savePM = HttpService.putInfo("mng/channel/account/update", par);
            } else {
                savePM = HttpService.postInfo("mng/channel/account/create", par);
            }
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (data.code == -5002) {
                    $scope.tip = {
                        alias: {
                            status: true,
                            txt: data.message
                        }
                    };
                } else if (data.code == -5003) {
                    $scope.tip = {
                        thirdAccountCode: {
                            status: true,
                            txt: data.message
                        }
                    };
                } else {
                    $scope.createID = $scope.aliasID = data.id;
                    $scope.stepflag = $scope.stepflag + 1;
                }
            });
        }

        $scope.lastStep = function() {
            $scope.stepflag = $scope.stepflag - 1;
        }


        var rmd = new Date().getTime();
        var currentAccountId = UtilService.getCookie("ryioUid");
        var rootParentDl = UtilService.getCookie("rootParent");
        $scope.productList = function() {
            var savePM = null;
            if ($scope.createID == null || $scope.createID == undefined) {
                $scope.createID = $scope.id;
            }
            //应用列表
            savePM = HttpService.getInfo("mng/channelaccount/" + $scope.createID + "/app/list?linkuserid=" + $scope.createID + "&unique_name=adwords");
            savePM.then(function(data) {
                $scope.dayListALL = data;
                $scope.dayList = $scope.dayListALL.filter(function(item) {
                    return item.platform == 'iOS' || ((currentAccountId=='19059'||rootParentDl=='19059')?item.platform == 'Android':false);//滴滴用户及子账号可以看见Android 其他不可以
                })
                $scope.appnameInit = $scope.dayList[0].id;
                $scope.$on("appname", function(e, msg) {
                    $scope.appname = msg.info.id;
                    $scope.appType = msg.info.platform;
                    $scope.appkey = msg.info.appkey;
                });
            });
            $scope.datafresh = ++rmd;
        }

        //已保存产品列表  adwords
        $scope.tableList = function() {
            var savePM = null;
            if ($scope.createID == null || $scope.createID == undefined) {
                $scope.createID = $scope.id;
            }
            savePM = HttpService.getInfo("mng/channelaccount/app/find/" + $scope.createID);
            savePM.then(function(data) {
                $scope.tableData = data;
            });
        }

        $scope.$watch("stepflag", function(n) {
            if (angular.isDefined(n)) {
                if ($scope.stepflag == 2) {
                    $scope.tableList();
                }
            }
        });

        //监测appname
        $scope.$watch("appname", function(n) {
            $scope.nodata();
        });
        $scope.nodata = function(num) {
            if (num == 1) {
                $scope.createType = 'noadd';
            }
            $scope.userActionSetId = "";
            $scope.tip = {
                userActionSetId: {
                    status: false,
                    txt: ''
                }
            };
        }

        //添加和关闭
        $scope.addType = false;
        $scope.addProduct = function() {
            if ($scope.createType == "inadd" || $scope.createType == "erroradd" || $scope.createType == "openadd") {
                ToolService.showTips($translate.instant("请先完成当前产品测试，再添加下一个产品。"));
            } else {
                $scope.createType = "openadd";
                $scope.addType = true;
                $scope.productList();
            }
        }
        $scope.closeProduct = function() {
            $scope.addType = false;
            $scope.nodata(1);
        }

        //检测linkid
        /*$scope.checkLinkID = false;
        $scope.exixtLinkId = function(){
            var par = {
                linkUserId: $scope.createID,
                channel: channelID,
                fieldkey: 'linkid',
                fieldvalue: $scope.userActionSetId
            };
            var verPar = {
                fieldvalue: {
                    key: 'isNull',
                    val: par.fieldvalue
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                return false;
            }
            var packPM = HttpService.getInfo("mng/channelaccount/109/app/checkname",par);
            packPM.then(function(data){
                ToolService.hideLoading();
                if(data == true){
                    $scope.checkLinkID = true;
                    $scope.tip = {
                        userActionSetId:{
                            status:false,
                            txt:''
                        }
                    };
                }else{
                    $scope.checkLinkID = false;
                    $scope.tip = {
                        userActionSetId:{
                            status:true,
                            txt:$translate.instant('该LinkID已存在，请更换。')
                        }
                    };
                }
            });
        }*/

        //noadd未添加  openadd打开弹窗     inadd添加中    okadd添加成功    erroradd添加失败
        $scope.createType = "noadd";
        //连接测试
        $scope.testDmp = function() {
            /*if($scope.checkLinkID == false){
                return false;
            }*/
            var par = {
                appName: $scope.appname,
                appkey: $scope.appkey,
                userActionSetId: $scope.userActionSetId,
                linkUserId: $scope.createID,
                appType: $scope.appType
            };
            var verPar = {
                userActionSetId: {
                    key: 'isNull',
                    val: par.userActionSetId
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = null;
            $scope.createType = "inadd";
            savePM = HttpService.postInfo("mng/channelaccount/" + $scope.createID + "/app/create", par);
            savePM.then(function(data) {
                if (data.id != undefined) {
                    $scope.createType = "okadd";
                    // $scope.checkLinkID = false;
                    $scope.tableList();
                    $scope.closeProduct();
                } else {
                    $scope.createType = "erroradd";
                    $scope.failureText = data.message;
                }
            });
        }

        //删除
        $scope.deletePro = function(obj) {
            $scope.delstatus = true;
            $scope.delId = obj.id;
        }
        $scope.removeInfo = function() {
            var removePM = HttpService.deleteInfo("mng/channelaccount/delete/app/" + $scope.delId);
            ToolService.showLoading();
            removePM.then(function(data) {
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($translate.instant("删除成功"));
                $scope.tableList();
            });
        }

        //保存
        $scope.save = function() {
                if ($scope.createType == "openadd") {
                    ToolService.showTips($translate.instant("请先完成当前产品测试"));
                } else if ($scope.createType == "erroradd") {
                    ToolService.showTips($translate.instant("link_ID有误，请重新测试"));
                } else {
                    $state.go("collect.channelmanage", { aid: 'ry_coop' });
                }
            }
            /**
             * 语言切换
             */
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
            }
        });
    }
})();