(function(){
    angular.module("app.collect")
        .controller("costrecoveryCtrl",["$scope","HttpService","ToolService","UtilService","$filter",costrecoveryCtrl]);

    function costrecoveryCtrl($scope,HttpService,ToolService,UtilService,$filter){
    	$scope.date = ToolService.getLastDays(-7);
        $scope.$on("dateCustos",function(e,msg){
            $scope.date = msg;
        });
        $scope.$watch("date",function(){
            if(angular.isDefined($scope.date)){
                $scope.datestr = $scope.date.startDate + $filter('translate')("至") + $scope.date.endDate;
            }
        });
        var rmd = new Date().getTime();
        $scope.timeFlag = 'day';
        $scope.changeTimeFlag = function(flag){
            $scope.timeFlag = flag;
        }
        $scope.channelinitname = $filter('translate')("不筛选渠道");
        $scope.$on("cid",function(e,msg){
            $scope.channelid = msg.info.uniqueName;
            $scope.refreshList(1);
            $scope.refreshList(2);
            $scope.refreshList(3);
            
            if($scope.changeInfoFlag == 1){
                $scope.infochange = ++rmd;
            }
        });

        $scope.accountinitname = $filter('translate')("不筛选渠道账号");
        $scope.$on("acid",function(e,msg){
            $scope.accountid = msg.info.channelAccountId;
            $scope.refreshList(2);
            $scope.refreshList(3);
            if($scope.changeInfoFlag == 2){
                $scope.infochange = ++rmd;
            }
        });

        $scope.planinitname = $filter('translate')("不筛选计划");
        $scope.$on("pid",function(e,msg){
            $scope.planid = msg.info.plan;
            $scope.refreshList(3);
            if($scope.changeInfoFlag == 3){
                $scope.infochange = ++rmd;
            }
        });

        $scope.campaigninitname = $filter('translate')("不筛选推广活动");
        $scope.$on("campid",function(e,msg){
            $scope.campaignid = msg.info.campaignid;
            if($scope.changeInfoFlag == 4){
                $scope.infochange = ++rmd;
            }
        });

        $scope.refreshList = function(flag){
            if(flag == 1){
                if($scope.accountAllList){
                    $scope.accountList = $scope.accountAllList.filter(function(item){
                        return item.uniqueName == $scope.channelid || $scope.channelid == -1;
                    });
                    $scope.accountList.unshift({channelAccountId:-1,channelAccountName:$filter('translate')('不筛选渠道账号')});
                    $scope.accountinit = ++rmd;
                }
                $scope.accountid = $scope.accountinitid = -1;
            }
            else if(flag == 2){
                if($scope.planAllList){
                    $scope.planList = $scope.planAllList.filter(function(item){
                        return (item.uniqueName == $scope.channelid || $scope.channelid == -1) 
                        && (item.channelAccountId == $scope.accountid || $scope.accountid == -1);
                    });
                    $scope.planList.unshift({plan:$filter('translate')('不筛选计划')});
                    $scope.planinit = ++rmd;
                }
                $scope.planid = $scope.planinitid = $filter('translate')('不筛选计划');
            }
            else if(flag == 3){
                if($scope.campaignAllList){
                    $scope.campaignList = $scope.campaignAllList.filter(function(item){
                        return (item.uniqueName == $scope.channelid || $scope.channelid == -1) 
                                && (item.channelAccountId == $scope.accountid || $scope.accountid == -1)
                                && (item.plan == $scope.planid || $scope.planid == $filter('translate')('不筛选计划'));
                    });
                    $scope.campaignList.unshift({campaignid:-1,campaignName:$filter('translate')('不筛选推广活动')});
                    $scope.campinit = ++rmd;
                }
                $scope.campaignid = $scope.campaigninitid = -1;
            }
        }
        $scope.getList = function(flag){
            switch (flag) {
                case 1:
                    if($scope.channelList!=null){return false;}
                    var channelPM = HttpService.getInfo("costrecovery/"+$scope.appid+"/param/channel");
                    ToolService.showLoading();
                    channelPM.then(function(data){
                        ToolService.hideLoading();
                        $scope.channelList = data;
                        $scope.channelList.unshift({uniqueName:-1,channelName:$filter('translate')('不筛选渠道')});
                        $scope.channelinit = ++rmd;
                        $scope.channelid = $scope.channelinitid = -1;
                    });
                    break;
                case 2:
                    if($scope.accountList!=null){return false;}
                    var accountPM = HttpService.getInfo("costrecovery/"+$scope.appid+"/param/channelaccount");
                    ToolService.showLoading();
                    accountPM.then(function(data){
                        ToolService.hideLoading();
                        $scope.accountAllList = data;
                        $scope.refreshList(1);
                    });
                    break;
                case 3:
                    if($scope.planList!=null){return false;}
                    var planPM = HttpService.getInfo("costrecovery/"+$scope.appid+"/param/plan");
                    ToolService.showLoading();
                    planPM.then(function(data){
                        ToolService.hideLoading();
                        $scope.planAllList = data;
                        $scope.refreshList(2);
                    });
                    break;
                case 4:
                    if($scope.campaignList!=null){return false;}
                    var campaignPM = HttpService.getInfo("costrecovery/"+$scope.appid+"/param/campaign");
                    ToolService.showLoading();
                    campaignPM.then(function(data){
                        ToolService.hideLoading();
                        $scope.campaignAllList = data;
                        $scope.refreshList(3);
                    });
                    break;
                default:
                    break;
            }
            $scope.changeInfoFlag = flag;
        }

        $scope.init = function(){
            $scope.channelList = null;
            $scope.channelid = $scope.channelinitid = -1;
            $scope.channelinit = ++rmd;

            $scope.accountList = null;
            $scope.accountid = $scope.accountinitid = -1;
            $scope.accountinit = ++rmd;

            $scope.planList = null;
            $scope.planid = $scope.planinitid = $filter('translate')('不筛选计划');
            $scope.planinit = ++rmd;

            $scope.campaignList = null;
            $scope.campaignid = $scope.campaigninitid = -1;
            $scope.campinit = ++rmd;
        }

        $scope.$on('flipinfo',function(e,msg){
            $scope.flipPage = msg;
            $scope.fixrefresh = ++rmd;
        });
        $scope.query = function(){
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            params.func = 'costrecovery';

            var url = "recovery";
            if($scope.timeFlag != 'day'){
                url += "_by" + $scope.timeFlag;
            }
            if($scope.channelid!=-1){
                params.uniquename = $scope.channelid;
            }
            if($scope.accountid!=-1){
                params.channelaccountid = $scope.accountid;
            }
            if($scope.planid!=$filter('translate')('不筛选计划')){
                params.plan = $scope.planid;
            }
            if($scope.campaignid!=-1){
                params.campaignid = $scope.campaignid;
            }
            
            var clickPM = HttpService.getReportData(url,params);
            $scope.infoListLoading = true;
            clickPM.then(function(data){
                $scope.costList = data;
                $scope.infoList = $scope.costList.val;

                $scope.infoListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.listCondition = ToolService.getChartConditions($filter('translate')("回本分析"),url,params);
                $scope.sortCol = "";
                
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
            });
        }
        var orderBy = $filter('orderBy');
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("appid",function(n){
            if(angular.isDefined($scope.appid)){
                $scope.init();
            }
        });
        $scope.$watch("appid+date.startDate+date.endDate+timeFlag+infochange+lang",function(n){
            if(angular.isDefined($scope.appid) && angular.isDefined($scope.date)){
                $scope.query();
            }
        });
    }
})();