angular.module("app.collect").controller("deeplinkCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state","$location", "$translate", "$filter", deeplinkCtrl]);

function deeplinkCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $location, $translate, $filter) {
    var olddomain = "";
    $scope.locationHost = true
    if($location.host() == "tweb.trackingio.com"){
        $scope.locationHost = false;
    }
    //配置
    $scope.configure = function (info) {
        ToolService.showLoading();
        $scope.tip = {};
        // $scope.isFlag = info.platform;
        // $scope.appid = info.id;
        // $scope.isDeepLink = info.isDeepLink
        var echoPM = HttpService.getInfo("mng/deeplink/" + $scope.appid + "/echoDeepLink");
        echoPM.then(function (data) {
            ToolService.hideLoading();
            $scope.mydomain = data.linkId;
            $scope.appIDprefix = data.appIdPrefix;
            $scope.bundleID = data.bundleId;
            $scope.packageName = data.packageName;
            $scope.sha256 = data.sha256;
            $scope.echoId = data.id;
        })
    }
    //关闭
    $scope.closeAdd = function () {
        ToolService.hideAlp();
        $scope.addstatus = false;
        $scope.stopActive = false;
    }
   
    $scope.save = function () {
                if ($scope.domainHas) {
                    $scope.tip.mydomain = {
                        status: true,
                        txt: $filter('translate')("该子域已被占用，请尝试使用其他子域")
                    }
                    return false;
                }
                var par = {
                    appid: $scope.appid,
                    flag: $scope.isFlag,
                    linkId: $scope.mydomain,
                    appIdPrefix: $scope.appIDprefix,
                    bundleId: $scope.bundleID,
                    packageName: $scope.packageName,
                    sha256: $scope.sha256,
                };
                if ($scope.echoId) {
                    par.id = $scope.echoId;
                }
                var verPar = {
                    mydomain: {
                        key: 'mydomain',
                        val: $scope.mydomain,
                        txt: $filter('translate')("只支持 英文、数字、-，长度限制26字符以内")
                    }
                };
        
                if ($scope.isFlag == "iOS") {
                    verPar.appIDprefix = {
                        key: 'isNull',
                        val: $scope.appIDprefix,
                    };
                    verPar.bundleID = {
                        key: 'isNull',
                        val: $scope.bundleID,
                    };
                }
                if ($scope.isFlag == "Android") {
                    verPar.sha256 = {
                        key: 'isNull',
                        val: $scope.sha256,
                    };
                    verPar.packageName = {
                        key: 'isNull',
                        val: $scope.packageName,
                    };
                }
                $scope.tip = formJudge(verPar);
        
                if($scope.tip.succ == true){
                    ToolService.showLoading();
                    var editPM = HttpService.postInfo("mng/deeplink/editAppDeepLink", par);
                    editPM.then(function (data) {
                        ToolService.hideLoading();
                        $scope.configure();
                        ToolService.showTips($filter('translate')("您的Deeplink参数配置已完成，请前往“推广活动管理”页面继续使用Deeplink功能。"));
                    })
                }
           
        // });
    }

    //校验唯一 子域
    // $scope.SchemeHas = false;
    $scope.domainHas = false;
    $scope.checkDomain = function () {
        if ($scope.judgeNameChange(olddomain, $scope.mydomain)) {
            savePM = HttpService.getInfo("mng/campaign/" + 0 + "/" + $scope.appid + "/checkDeepLink?name=" + $scope.mydomain);
            savePM.then(function (data) {
                $scope.tip = {};
                if (data.content == false) {
                    $scope.tip = {
                        mydomain: {
                            status: true,
                            txt: $filter('translate')("该子域已被占用，请尝试使用其他子域")
                        }
                    }
                    $scope.domainHas = true;
                } else {
                    $scope.tip.mydomain = {
                        status: false
                    };
                    $scope.domainHas = false;
                }
            })
        }
    }



    $scope.$on('flipinfo', function (e, msg) {
        $scope.flipPage = msg;
    });

    $scope.closeWin = function (flag) {
        $scope.wantDelete = false;
        ToolService.hideAlp();
    }


    

  
    $scope.isdetail = false;
    $scope.showDetails = function (info) {
        ToolService.sendBehaviorUv("showDetails");
        $scope.detailInfo = info;
        ToolService.showAlp();
        $scope.isdetail = true;
        angular.element(document).on("click", function () {
            $scope.$apply(function () {
                $scope.hideDetails();
            });
        });
    }

    $scope.hideDetails = function () {
        ToolService.hideAlp();
        $scope.isdetail = false;
    }
    $scope.$watch("{appid:appid,lang:lang}",function(n,o){
        if (angular.isUndefined($scope.appid)) {
            return false;
        }     
        $scope.isFlag = $rootScope.appInstance.platform;
        $scope.configure()
            // if (n && o && n != o) {
            //     $scope.configure()
            // }
    },true);
}