(function(){
    angular.module("app.collect")
        .controller("deviceCtrl",["$scope","HttpService","ToolService","$filter","UtilService",deviceCtrl]);

    function deviceCtrl($scope,HttpService,ToolService,$filter,UtilService){

    	$scope.$on('curdate',function(e,msg){
            $scope.date = msg.date;
        });

        $scope.selname = {
        	"model":{
        		name:$filter('translate')("设备型号"),
        		color:["#6dc7be"],
        		charttype:"bar"
        	},
        	"os":{
        		name:$filter('translate')("系统版本"),
        		color:["#6dc7be"],
        		charttype:"bar"
        	},
        	"network":{
        		name:$filter('translate')("网络类型"),
        		color:["#6ed0dc","#009be0","#ffbf4b","#ff830f","#abc450","#dddddd"],
        		charttype:"pie",
        		istop:false
        	},
        	"resolution":{
        		name:$filter('translate')("分辨率"),
        		color:["#6dc7be"],
        		charttype:"bar"
        	},
        	"region":{
        		name:$filter('translate')("地域分布"),
        		color:["#6dc7be"],
        		charttype:"bar"
        	}
        };
        $scope.selflag='model';

        var seltypename = ['install','dau','startup'];
        $scope.seltype = 0;
        $scope.androidtype = 0;
        $scope.operatorstype=0;

        $scope.idfaconfig = {color:['#dddddd',"#5fb5f1"]}
        $scope.operatorsconfig = {color:["#6ed0dc","#009be0","#ffbf4b","#dddddd"]};
        $scope.mapConfig = {};

        $scope.query = function(){
        	var params = ToolService.getParams($scope);
            params.datatype = "list";

        	// android情况 型号-设备品牌
        	$scope.androidlistInfoLoading = true;
        	$scope.androidtopLoading = true;
        	if($scope.isandroid && $scope.selflag=='model'){
                var myparams = UtilService.cloneJSON(params);
                myparams.ismanufacturer = 1;
        		var androidPM = HttpService.getReportData("device_by"+$scope.selflag, myparams);
	        	androidPM.then(function(data){
	        		$scope.androidlistInfo = data;
	        		$scope.androidlistInfoLoading = false;
	        		$scope.androidsortCol = "";
	        		$scope.getChartData($scope.androidlistInfo,$scope.androidtype,1);
	        	});
        	}

        	$scope.listInfoLoading = true;
        	$scope.topLoading = true;
        	var queryPM = HttpService.getReportData("device_by"+$scope.selflag, params);
        	queryPM.then(function(data){
        		$scope.listInfo = data;
        		$scope.listInfoLoading = false;
        		$scope.sortCol = "";
                if($scope.selflag=='region'){
                    $scope.mapLoading = true;
                }
        		$scope.getChartData($scope.listInfo,$scope.seltype);
        	});

        	//ios情况 系统  越狱情况和idfa
        	// if($scope.isios && $scope.selflag=='os'){
	        // 	$scope.breakLoading = true;
	        // 	var breakPM = HttpService.getReportData("device_break", params);
	        // 	breakPM.then(function(data){
	        // 		$scope.breakData = data;
	        // 		$scope.breakLoading = false;
	        // 	});

	        // 	$scope.idfaLoading = true;
	        // 	var idfaPM = HttpService.getReportData("device_idfa", params);
	        // 	idfaPM.then(function(data){
	        // 		$scope.idfaData = data;
	        // 		$scope.idfaLoading = false;
	        // 	});
        	// }

        	//网络-运营商
        	if($scope.selflag=='network'){
        		$scope.operatorsListLoading = true;
	        	$scope.operatorstopLoading = true;
	        	var operatorsPM = HttpService.getReportData("device_bycarrier", params);
	        	operatorsPM.then(function(data){
	        		$scope.operatorsList = data;
	        		$scope.operatorsPieList = data;
	        		$scope.operatorsListLoading = false;
	        		$scope.operatorssortCol = "";
	        		$scope.getChartData($scope.operatorsList,$scope.operatorstype,2);
	        	});
        	}
        }

        var orderBy = $filter('orderBy');
        $scope.sortCol = "";
        $scope.androidsortCol = "";
        $scope.operatorssortCol = "";
        $scope.order = function(predicate, reverse,flag) {
        	if(angular.isDefined(flag) && flag == 1){
        		$scope.androidsortCol = predicate;
            	$scope.androidlistInfo.val = orderBy($scope.androidlistInfo.val, predicate, reverse);
        	}
        	if(angular.isDefined(flag) && flag == 2){
        		$scope.operatorssortCol = predicate;
            	$scope.operatorsList.val = orderBy($scope.operatorsList.val, predicate, reverse);
        	}
        	else{
        		$scope.sortCol = predicate;
            	$scope.listInfo.val = orderBy($scope.listInfo.val, predicate, reverse);
        	}
        };

        //flag 1:普通  2:android-设备品牌  3:网络-运营商
        $scope.getChartData = function(info,type,flag){
        	var data = orderBy(info.val, info.columnkey[type+1], true);
        	var name = info.name[type+1],key = [],mydata = [];

        	var kn = info.columnkey[0],nk = info.columnkey[type+1];
        	data.filter(function(item){
        		key.push(item[kn]);
        		mydata.push(item[nk]);
        	});

        	$scope.topConfig = {color:$scope.chartconfig.color,legend:false,isbartext:true};
        	var chartData = {};
        	if($scope.chartconfig.istop != false){
        		chartData = {
	        		name : [name],
	        		key: key.slice(0,10),
	        		val : [mydata.slice(0,10)]
	        	};
        	}
        	else{
				chartData = {
	        		name : [name],
	        		key: key,
	        		val : [mydata]
	        	};
        	}

        	if(angular.isDefined(flag) && flag == 1){
        		$scope.androidtopData = chartData;
        		$scope.androidtopLoading = false;
        	}
        	else if(angular.isDefined(flag) && flag == 2){
        		$scope.operatorstopData = chartData;
        		$scope.operatorstopLoading = false;
        	}
        	else{
        		$scope.topData = chartData;
        		$scope.topLoading = false;

        		if($scope.selflag=='region'){
        			$scope.mapData = {
        				name : [name],
        				key : key,
        				val:[mydata]
	        		}
                    $scope.mapLoading = false;
        		}
        	}
        }
        $scope.$watch("seltype",function(){
        	if(angular.isDefined($scope.appid) && angular.isDefined($scope.listInfo)){
        		$scope.getChartData($scope.listInfo,$scope.seltype);
        	}
        });
        //android切换
        $scope.$watch("androidtype",function(){
        	if(angular.isDefined($scope.appid) && angular.isDefined($scope.androidlistInfo)){
        		$scope.getChartData($scope.androidlistInfo,$scope.androidtype,1);
        	}
        });
        //运营商
        $scope.$watch("operatorstype",function(){
        	if(angular.isDefined($scope.appid) && angular.isDefined($scope.operatorsList)){
        		$scope.getChartData($scope.operatorsPieList,$scope.operatorstype,2);
        	}
        });

        $scope.$watch("appid+selflag+date.startDate+date.endDate+lang",function(){
        	if(angular.isDefined($scope.appid) && angular.isDefined($scope.date)){
        		$scope.chartconfig = $scope.selname[$scope.selflag];
        		$scope.query();
        	}
        });
    }
})();