(function() {
    angular.module("app.collect")
        .controller("keywordCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "$timeout", "$filter", "UtilService", keywordCtrl]);

    function keywordCtrl($scope, $rootScope, HttpService, ToolService, $timeout, $filter, UtilService) {
        $scope.initLoading = function() {
            $scope.campListLoading = true;
        };
        $scope.initLoading();
        $scope.$on('curdate', function(e, msg) {
            $scope.date = msg.date;
        });

        $scope.listf5 = 1;
        var fixChange = true,
            rmd = new Date().getTime();
        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;
            if (msg.current && msg.pagenum) {
                if (!$scope.infoList) { fixChange = false; }
                $scope.query();
            }

        });
        $scope.$on("conentresize", function() {
            $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);
        });
        $scope.query = function(hasTotal) {
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            params.viewtype = "bdkeyword";
            params.func = "campaigninfo";

            var listPM = null,
                currentInfo = {},
                qReport = "campaigninfo_bypackagecampaign",
                eptName = $filter('translate')('日期');
            var vcol = [];
            $scope.baseList.filter(function(item) {
                if (item.ischeck == true) {
                    if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention'))) {
                        //没有付费权限，不能查看付费
                    } else if (item.type == 'base' && item.fieldcode == 'wake_num' && $rootScope.arouseStatus != 2) {
                        //没有唤醒权限，不能查看付费
                    } else {
                        vcol.push(item.fieldcode);
                    }
                }
            });
            params.viewcolumn = vcol.join(",");

            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }

            var listPM = null,
                currentInfo = {};
            if ($scope.currentReports && $scope.currentReports != null && $scope.currentReports.key) {
                params[$scope.currentReports.key] = $scope.currentReports.val;
                if ($scope.currentReports.key1) {
                    params[$scope.currentReports.key1] = $scope.currentReports.val1;
                }
                currentInfo = UtilService.cloneJSON($scope.currentReports);
            } else {
                if (hasTotal) {
                    $scope.allSubInfo = [];
                }

                currentInfo = {
                    title: $filter('translate')('数据详情'),
                    report: "bd_bycampaign"
                }
                $scope.currentReports = currentInfo;
            }
            if (hasTotal) {
                $scope.allSubInfo.push(currentInfo);
                $scope.sortCol = "";
                var totalPM = HttpService.getReportData($scope.currentReports.report + "_count/number", params);

                totalPM.then(function(data) {
                    var total = 0;
                    if (angular.isDefined(data.content)) {
                        total = data.content;
                    } else {
                        total = data;
                    }

                    var preTotal = total + 1; //加1是为了total==0的时候不触发watch
                    if ($scope.listTotal == preTotal) {
                        ++$scope.listf5;
                    } else {
                        $scope.listTotal = preTotal;
                    }
                });
            } else {
                params.pageIndex = $scope.flipPage.current - 1;
                params.pageNumber = $scope.flipPage.pagenum;

                if ($scope.sortCol != '') {
                    params.orderby = $scope.sortCol;
                    params.isdesc = $scope.isDesc;
                }

                listPM = HttpService.getReportData($scope.currentReports.report, params);

                var condiParams = UtilService.cloneJSON(params);
                delete condiParams.pageIndex;
                delete condiParams.pageNumber;
                $scope.listCondition = ToolService.getChartConditions($filter('translate')("SEM推广详情") + "-" + $scope.currentReports.title, $scope.currentReports.report, condiParams);

                $scope.campListLoading = true;
                listPM.then(function(data) {
                    /*$scope.campList = data;
                    $scope.infoList = data.val;*/

                    $scope.campList = data;
                    $scope.campAllList = data.val;
                    $scope.campNoZeroList = $scope.campAllList.filter(function(item) {
                        return item.isall0 == false;
                    });

                    if ($scope.showZero) {
                        $scope.infoList = $scope.campAllList;
                    } else {
                        $scope.infoList = $scope.campNoZeroList;
                    }

                    $scope.campListLoading = false;

                    $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                    if (fixChange) {
                        $scope.fixrefresh = ++rmd;
                    } else {
                        $scope.initrefresh = ++rmd;
                        $scope.fixrefresh = ++rmd;
                    }
                    fixChange = true;
                });
            }
        }
        $scope.filterByTxt = function(txt) {
            $scope.filterTxt = txt;
            fixChange = false;
            $scope.query();
        }
        $scope.iscanSub = function() {
            return $scope.allSubInfo.length != 3;
        }
        $scope.keywordFlag = "kwid"; //ceative,kwid
        $scope.changeKeyword = function(flag) {
            $scope.keywordFlag = flag;

            $scope.currentReports = $scope.allSubInfo[0];
            var preInfo = $scope.allSubInfo.slice(-1)[0];
            $scope.allSubInfo = $scope.allSubInfo.slice(0, 1);

            $scope.clickSub(preInfo);
        }
        $scope.clickSub = function(info, obj) {
            if (!info) {
                var target = obj.target,
                    data = target.getAttribute('data');
                info = $.parseJSON(data);
            }
            if (info.istotal) return;
            $scope.filterTxt = "";
            if ($scope.iscanSub()) {
                if (info.campaignid) {
                    $scope.currentReports = {
                        report: "bd_by" + $scope.keywordFlag,
                        title: info[$scope.campList.columnkey[0]],
                        key: 'campaignid',
                        val: info.campaignid,
                        curInfo: info
                    }
                } else if (info.report) {
                    $scope.currentReports = info;
                    $scope.currentReports.report = "bd_by" + $scope.keywordFlag;
                } else {
                    var bd = $scope.keywordFlag == 'creative' ? "kwid" : 'creative';

                    var preRe = $scope.currentReports;
                    $scope.currentReports = {
                        report: "bd_by" + bd,
                        title: info[$scope.campList.columnkey[0]],
                        key: $scope.keywordFlag,
                        val: info[$scope.keywordFlag],
                        key1: preRe.key,
                        val1: preRe.val
                    }
                }
                fixChange = false;
                $scope.query(true);
            }
        }
        $scope.preSub = function(idx) {
            if ($scope.allSubInfo.length - 1 == idx) { return false; }

            $scope.currentReports = $scope.allSubInfo[idx];
            $scope.allSubInfo = $scope.allSubInfo.slice(0, idx);
            fixChange = false;
            $scope.query(true);
        }

        var orderBy = $filter('orderBy');
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.isDesc = reverse;
            // $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.query();
        };
        $scope.$watch("appid", function() {
            $scope.allSubInfo = [];
            $scope.currentReports = null;
            $scope.industory = $scope.appInstance ? $scope.appInstance.industory : '';
        });
        $scope.$watch("date.startDate+date.endDate", function() {
            if ($scope.allSubInfo.length > 0) {
                $scope.allSubInfo.pop()
            }
        });
        var oldappid = "";
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid}", function(n, o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)) { return false; }

            /* if(n.lang && o.lang && n.lang!==o.lang){
                 $scope.currentReports = null;
             }*/
            if (!$scope.baseList || oldappid != $scope.appid) {
                //指标列表
                var basePM = HttpService.getInfo($scope.appid + "/campaign/viewcolumn/findall/campaign");
                basePM.then(function(data) {
                    for (var i = 0; i < data.length; i++) {
                        if (data[i].fieldcode=='num_impression' || data[i].fieldcode == 'rate_click') {
                            data.splice(i, 1);
                        }
                        // if(data[i].fieldcode=='num_impression' ){
                        //     data[i].fieldname = $filter('translate')('展示总数');
                        // }
                    }

                    $scope.baseList = data;
                    fixChange = false;
                    $scope.query(true);
                });
            } else {
                fixChange = false;
                $scope.query(true);
            }
            oldappid = $scope.appid;
        }, true);

        $scope.clickZero = function() {
            ToolService.sendBehaviorUv("clickZero");
            $scope.showZero = !$scope.showZero;

            if ($scope.showZero) {
                $scope.infoList = $scope.campAllList;
            } else {
                $scope.infoList = $scope.campNoZeroList;
            }

        }

        $scope.clickBase = function(obj) {
            if (obj.isedit == false) { return false; }
            obj.ischeck = !obj.ischeck;
            if (obj.status == 0) {
                obj.status = 1
            } else {
                obj.status = 0
            }
        }
        $scope.checkAll = function(type) {
            if (!$scope.baseList) { return false; }

            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function(item) {
                if (item.type == type && item.isedit) {
                    if (item.ischeck == bol) {
                        if (item.status == 0) {
                            item.status = 1
                        } else {
                            item.status = 0
                        }
                        item.ischeck = !bol;
                    }
                }
            });
        }
        $scope.hasCheckAll = function(type) {
            if (!$scope.baseList) { return false; }

            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }

        $scope.hasType = function(type) {
            if (!$scope.baseList) { return false; }

            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type) {
                    count = 1;
                    break;
                }
            }
            return count > 0;
        }

        $scope.showBaseWin = function() {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function(flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function(item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function() {
            ToolService.sendBehaviorUv("okBase");
            $scope.query();
            var vcol = [];
            $scope.baseList.filter(function(item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            var updatePM = HttpService.postInfo($scope.appid + "/campaign/viewcolumn/campaign?viewcolumn=" + vcol.join(","), {});
            updatePM.then(function(data) {});
            $scope.hideDialog(-1);
        }

    }
})();