(function() {
    angular.module("app.collect")
        .controller("lifesettingsCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "$filter", lifesettingsCtrl]);

    function lifesettingsCtrl($scope, $rootScope, HttpService, ToolService, $filter) {
        /**
         * 语言切换
         */
        $scope.$watch("{appid:appid,lang:lang}", function(n, o) {
            if (angular.isUndefined($scope.appid)) {
                return false;
            }
            $scope.querySP();
            if(n && o && n!==o){
                $scope.initData();
            }
        });
        // $scope.LifecycleHandel = true;
        $scope.querySP = function() {
            var infoPM = HttpService.getInfo("mng/systemparam/lifecycle/find/"+$scope.appid);
            ToolService.showLoading();
            infoPM.then(function(data) {
                ToolService.hideLoading();
                if(data.content === null) {
                    $scope.silenceDay = $scope.silenceDayInit = 15;
                    $scope.outflowDay = $scope.outflowDayInit = 60;
                    // $scope.LifecycleHandel = false;
                } else {
                    $scope.id = data.id;
                    $scope.silenceDay = $scope.silenceDayInit = data.silentPhaseDays;
                    $scope.outflowDay = $scope.outflowDayInit = data.lossPhaseDays;
                }
                
                
            });
            var infoPM1 = HttpService.getInfo("mng/channelparam/getBackflowAttrNum?app="+$scope.appid);
            ToolService.showLoading();
            infoPM1.then(function(data) {
                ToolService.hideLoading();
                $scope.refluxanalysisDay = $scope.refluxanalysisDayInit = data;
            });
        }
        

        $scope.initData = function() {
            $scope.silenceDayList = [
                { id: 3, name: "3" + $filter('translate')("天") },
                { id: 7, name: "7" + $filter('translate')("天") },
                { id: 15, name: "15" + $filter('translate')("天(默认)") },
                { id: 30, name: "30" + $filter('translate')("天") }
            ];

            $scope.outflowDayList = [
                { id: 7, name: "7" + $filter('translate')("天") },
                { id: 15, name: "15" + $filter('translate')("天") },
                { id: 31, name: "31" + $filter('translate')("天") },
                { id: 60, name: "60" + $filter('translate')("天(默认)") },
                { id: 90, name: "90" + $filter('translate')("天") }
            ];

            $scope.refluxanalysisDayList = [
                { id: 43200, name: "12" + $filter('translate')("小时") },
                { id: 86400, name: "1" + $filter('translate')("天") },
                { id: 172800, name: "2" + $filter('translate')("天") },
                { id: 259200, name: "3" + $filter('translate')("天") },
                { id: 345600, name: "4" + $filter('translate')("天") },
                { id: 432000, name: "5" + $filter('translate')("天") },
                { id: 518400, name: "6" + $filter('translate')("天") },
                { id: 604800, name: "7" + $filter('translate')("天(默认)") },
                { id: 1296000, name: "15" + $filter('translate')("天") },
                { id: 2592000, name: "30" + $filter('translate')("天") },
                { id: 5184000, name: "60" + $filter('translate')("天") },
                { id: 7776000, name: "90" + $filter('translate')("天") },
                { id: 10368000, name: "120" + $filter('translate')("天") },
            ]
        }

        $scope.initData();

        $scope.$on("silenceDay", function(e, msg) {
            $scope.silenceDay = msg.info.id;
        });
        $scope.$on("outflowDay", function(e, msg) {
            $scope.outflowDay = msg.info.id;
        });
        $scope.$on("refluxanalysisDay", function(e, msg) {
            $scope.refluxanalysisDay = msg.info.id;
        });




        $scope.setDefault = function(flag) {
            ToolService.sendBehaviorUv("setDefault");
            $scope.defaultStatus = true;
            $scope.setDoflag = flag;
        }

        var rmd = new Date().getTime();
        $scope.defaultData = function() {
            if($scope.setDoflag == 1) {
                $scope.silenceDayInit = 15;
                $scope.silenceDay = 15;
                $scope.outflowDayInit = 60;
                $scope.outflowDay = 60;
                $scope.datafresh = ++rmd;
            } else if($scope.setDoflag == 2) {
                $scope.refluxanalysisDay = 604800;
                $scope.refluxanalysisDayInit = 604800;
                $scope.excepfresh = ++rmd;
            }
            
            $scope.defaultStatus = false;
            $scope.save($scope.setDoflag);
        };
        $scope.save = function(flag) {
            ToolService.sendBehaviorUv("save");
            if(flag == 1) {
                if($scope.outflowDay<=$scope.silenceDay){
                    ToolService.showTips($filter('translate')("流失阶段周期设置天数”必须大于”沉默阶段周期设置天数"))
                    return;
                }
                var par = {
                    appid:$scope.appid,
                    silentPhaseDays: $scope.silenceDay,
                    lossPhaseDays: $scope.outflowDay
                }
                var url = "mng/systemparam/lifecycle/setting"
            } else {
                var par = {
                    app:$scope.appid,
                    backflowAttrNum: $scope.refluxanalysisDay
                }
                var url = "mng/channelparam/update/backflowAttrNum"
            }

            var savePM = HttpService.postInfo(url, par);
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("修改成功"))
            });
        }
        
    }

})();