(function(){
    angular.module("app.collect")
        .controller("logdumpCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$filter",exportCtrl]);

    function exportCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$filter){
    	$scope.query = function(){
            ToolService.showLoading()
            var addrPM = HttpService.getInfo("mng/export/"+$scope.appid+"/geturl");
            addrPM.then(function(data){
                $scope.addrList = data;
                ToolService.hideLoading();

                var clipboard = new Clipboard('.copyBtn');
                clipboard.on('success', function(e) {
                    $scope.$apply(function(){
                        ToolService.showTips($filter('translate')("复制成功"));
                    });
                });
                clipboard.on('error', function(e) {
                    $scope.$apply(function(){
                        ToolService.showTips($filter('translate')("复制失败"));
                    });
                });
            });
    	}

        $scope.$watch("appid+lang",function(n){
            if(angular.isDefined($scope.lang)){
                $scope.query();
            }
        });

        //启用停用
        $scope.onOff = function(){
            ToolService.sendBehaviorUv("onOff");
            var url = "mng/app/enable/"+$scope.appid,tipmsg = $filter('translate')("启用成功");
            if($scope.appInstance.regedbutton == true){
                url = "mng/app/forbidden/"+$scope.appid;
                tipmsg = $filter('translate')("停用成功");
            }
            var userPM = HttpService.putInfo(url,{});
            ToolService.showLoading();
            userPM.then(function(data){
                ToolService.hideLoading();
                ToolService.showTips(tipmsg);
                if(tipmsg == $filter('translate')('停用成功')){
                    $scope.appInstance.regedbutton = false;
                }else{
                    $scope.appInstance.regedbutton = true;
                }
                $scope.$emit("f5Applist",true);
            });
        }
        $scope.downTips = function(){
            // if($rootScope.demoU){return false;}
            ToolService.showTips($filter('translate')("当前开关已关闭，不可下载，请打开后第二天10点以后重试"));
        }
        $scope.downFile = function(type){
            ToolService.sendBehaviorUv("downFile");
            // if($rootScope.demoU){return false;}
            var json = {};
                json[$filter('translate')("激活")]="install";
                json[$filter('translate')("注册")]="reged";
                json[$filter('translate')("点击")]="click";
                json[$filter('translate')("防作弊拦截点击")]='blacklist';
                json[$filter('translate')("防作弊拦截激活")]='fake';
                json[$filter('translate')("付费")]='pay';
                json[$filter('translate')("登录")]="loggedin";

            var downPM =  HttpService.downFile("external/export?downloadType="+json[type]+"&token="+$scope.appInstance.token);
            downPM.then(function(data){
                if(data.code==-1){
                    ToolService.showTips($filter('translate')("文件不存在"));
                }else{
                    $rootScope.operSubmitData($filter('translate')("下载"));
                }
            });
        }
    }
})();
