(function() {
    angular.module("app.collect")
        .controller("logexportCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$filter","DateService", "$translate", exportCtrl]);

    function exportCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $filter, DateService, $translate) {
        $scope.UserId = $.cookie("ryioUid");
        var specialAccount = UtilService.getCookie("specialUname");
        var specialEmail = UtilService.getCookie("regEmail");

        $scope.isSpecialAccount = specialAccount == "false" ? false : true;
        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;
        });

        $scope.$on("typelistId", function(e, msg) {
            $scope.typeInfoId = msg.info.id;
        });

        $scope.$on("exportClickid", function(e, msg) {
            $scope.exportClickOn = msg.info.id;
        });
        $scope.$on("exportDayid", function(e, msg) {
            $scope.exportDayOn = msg.info.id;
        });
        $scope.campaignInit = "all";
        $scope.getTypeData = function(flag) {
            $scope.typeInfoId = -1;
            var url = "";
            if (angular.isDefined(flag)) {
                $scope.typeInfoname = $filter('translate')("请选择用户群");
                url = "mng/usergroup/find/" + $scope.appid;
            } else if($scope.exportModuleid == "advertisinginfo" && $scope.exportRangeId == "channel"){
                $scope.typeInfoname = $filter('translate')("请选择渠道");
                url = 'mng/advertising/adchannel/settings';
            } else {
                var urlparms = ToolService.getChannelCampaignParams($scope.exportRangeId, $scope.appid);
                $scope.typeInfoname = $filter('translate')("请选择") + urlparms.txt;
                url = urlparms.url;
                //更换带分包渠道的接口
                /*if(urlparms.txt == "渠道"){
                    url = "";
                }*/
            }
            if ($scope.exportRangeId == "campaign") {
                ToolService.showLoading();
                var campaignUrl = '';
                if($scope.exportModuleid == "remarketing"){
                    campaignUrl = $scope.appid + "/campaign/remarketing/dropdown"
                } else {
                    campaignUrl = $scope.appid + "/campaign/dropdown"
                }
                listPM = HttpService.getInfo(campaignUrl);
                listPM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.campaignListTotal = data;
                    var data = data.data;
                    $scope.typeInfoListAll = $scope.typeInfoList = data;
                    data.filter(function(item) {});
                    $scope.typeInfoList = data;
                    $scope.campaignListAll = data;
                });

            } else {
                $scope.typeInfoList = [];
                var listPM = HttpService.getInfo(url);
                listPM.then(function(data) {
                    if($scope.exportModuleid == "remarketing" && $scope.exportRangeId == "channel"){
                        $scope.typeInfoList = data.filter(function(item){
                            return item.type == 'ry_coop';
                        });
                    } else if ($scope.exportModuleid == "remarketing" && $scope.exportRangeId == "campgroup") {
                        $scope.typeInfoList = data.filter(function(value){
                            return  value.deeplink;
                        });
                    } else {
                        $scope.typeInfoList = data;
                    }
                });

            }

        }

        $scope.clearTxtId = "clearTxtId";
        $scope.$on($scope.clearTxtId, function(event, data) {
            $scope.typeInfoList = $scope.typeInfoListAll
        })

        //超出500条活动查询
        $scope.searchTextId = "searchTextId";
        $scope.$on($scope.searchTextId, function(event, data) {
            if (!data) {
                return false
            }
            var campaignUrl = '';
            if($scope.exportModuleid == "remarketing"){
                campaignUrl = $scope.appid + "/campaign/remarketing/dropdown"
            } else {
                campaignUrl = $scope.appid + "/campaign/dropdown"
            }
            var Pm = HttpService.getInfo(campaignUrl + "?name=" + data);
            Pm.then(function(data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function(item) {
                        // item.uid = item.id;
                        // item.id = item.id;
                    });
                    $scope.typeInfoList = dataList
                }

            });

        });

        $scope.query = function() {
            ToolService.showLoading()
            var listPM = HttpService.getInfo("mng/export/" + $scope.appid + "/findall");
            listPM.then(function(data) {
                $scope.exprotList = data;
                ToolService.hideLoading();
            });
        }

        $scope.doRemove = function(id) {
            ToolService.sendBehaviorUv("doRemove");
            $scope.delstatus = true;
            $scope.delId = id;
        }
        $scope.removeInfo = function() {
            var url = "mng/export/" + $scope.appid + "/delete/" + $scope.delId;
            var removePM = HttpService.deleteInfo(url);
            ToolService.showLoading();
            $scope.delstatus = false;
            removePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("删除成功"))
                $scope.query();
            });
        }
        $scope.downloadEvt = function(info) {
            ToolService.sendBehaviorUv("downloadEvt");
            ToolService.showLoading();
            if (info.status != 'complete') { return false; }
            var id = info.id;

            var pm = HttpService.getInfo("mng/export/" + $scope.appid + "/download/" + id);
            pm.then(function(data) {
                ToolService.hideLoading();
                if (data.content == false) {
                    ToolService.showTips($filter('translate')("导出文件不存在，请等待重新生成"));
                    HttpService.putInfo("mng/export/" + $scope.appid + "/refresh/" + id, {}).then(function(data) {
                        // ToolService.showTips("重新生成导出文件，请等待...");
                        $scope.query();
                    });
                } else {
                    window.open(data)
                    $rootScope.operSubmitData($filter('translate')("下载"));
                }
            });

            /*var downPM = HttpService.getInfo("mng/export/" + $scope.appid + "/checkexist/" + id);
            downPM.then(function (data) {
                ToolService.hideLoading();
                if (data == true) {
                    window.open("/api/mng/export/" + $scope.appid + "/download/" + id)
                    /!*var pm = HttpService.downFile("mng/export/" + $scope.appid + "/download/" + id);
                    pm.then(function (data) {
                        ToolService.hideLoading();
                    });*!/
                    $rootScope.operSubmitData($filter('translate')("下载"));
                }
                else{
                    ToolService.showTips($filter('translate')("导出文件不存在，请等待重新生成"));
                    HttpService.putInfo("mng/export/"+$scope.appid+"/refresh/"+id,{}).then(function(data){
                        // ToolService.showTips("重新生成导出文件，请等待...");
                        $scope.query();
                    });
                }
            });*/
        }

        // $scope.exportTypeList = [
        // 	{id:"install","name":"推广-激活列表"},
        // 	{id:"reged","name":"推广-注册列表"},
        // 	{id:"pay","name":"推广-付费列表"},
        // 	{id:"backflow","name":"推广-回流列表"},
        // 	{id:"usergroup","name":"用户群列表",isgroup:true},
        // 	{id:"order","name":"推广-订单列表"}
        // ];
        // $scope.exportTypeList.splice(3,2);

        // 所属模块下拉列表
        $scope.exportModuleinit = 'campaigninfo';
        $scope.exportModuleList = [
            { id: "campaigninfo", "name": $filter('translate')("推广数据") }
        ]
        $scope.$on('exportModuleid', function(e, msg){
            $scope.exportModuleid = msg.info.id;
            if($scope.exportModuleid == 'campaigninfo') {
                if ($scope.isSpecialAccount && $rootScope.isweb) {
                    $scope.exportTypeList = [{ id: "h5_event", "name": $filter('translate')("自定义事件") }]
                }else if($rootScope.isSelfBuilt){
                    $scope.exportTypeList = [
                        { id: "install", "name": $filter('translate')("表单") },
                        { id: "reged", "name": $filter('translate')("注册") }
                    ]
                } else {
                    $scope.exportTypeList = ($rootScope.iswx || $rootScope.iswg) ? [
                        { id: "launch", "name": $filter('translate')("新增用户") },
                        { id: "register", "name": $filter('translate')("注册列表") },
                        { id: "payment", "name": $filter('translate')("付费列表") },
                    ] : [
                        { id: "install", "name": $filter('translate')("激活") },
                        { id: "reged", "name": $filter('translate')("注册") }
                    ];
                }
                if ($rootScope.isweb && $scope.isSpecialAccount) {
                    // $scope.exportTypeList.splice(1, 0, { id: "fake", name: "防作弊卫士激活" });
                } else {
                    if ($scope.industory == 'ec') {
                        if ($scope.isall || $scope.showDataModel('order')) {
                            $scope.exportTypeList.push({ id: "order", "name": $filter('translate')("订单") });
                        }
                    }
                    if (($scope.isall || $scope.showDataModel('pay')) && !$scope.iswx && !$scope.iswg) {
                        $scope.exportTypeList.push({ id: "pay", "name": $filter('translate')("付费") });
                    }
                    if ($rootScope.isandroid || $rootScope.isios) {
                        $scope.exportTypeList.push({ id: 'loggedin', name: $filter('translate')('登录') });
                    }
                }
                $scope.exportRangelist = [
                    { id: "all", name: $filter('translate')("所有推广数据") },
                    { id: "channel", name: $filter('translate')("指定渠道") },
                    { id: "campgroup", name: $filter('translate')("指定活动组") },
                    { id: "campaign", name: $filter('translate')("指定活动") }
                ];
            } else if($scope.exportModuleid == 'menufake') {
                $scope.exportTypeList = [
                    { id: "fake", name: $filter('translate')("激活") }, 
                    { id: "hijack", name: $filter('translate')("点击劫持分析") }, 
                    { id: "hijackpack", name: $filter('translate')("分包劫持分析") }, 
                    { id: "corpse", name: $filter('translate')("僵尸用户分析") }
                ]
                $scope.exportRangelist = [
                    { id: "all", name: $filter('translate')("所有推广数据") },
                    { id: "channel", name: $filter('translate')("指定渠道") },
                    { id: "campgroup", name: $filter('translate')("指定活动组") },
                    { id: "campaign", name: $filter('translate')("指定活动") }
                ];
            } else if($scope.exportModuleid == 'userLife') {
                $scope.exportTypeList = [
                    { id: "silent", name: $filter('translate')("沉默") },
                    { id: "loss", name: $filter('translate')("流失") },
                    { id: "backflow_channel", name: $filter('translate')("渠道概览 - 回流") }
                ]
                if($scope.permissionMenus.refluxanalysis&&$scope.permissionMenus.refluxanalysis.has_auth){
                    $scope.exportTypeList.push({ id: "backflow_analysis", name: $filter('translate')("回流分析 - 回流") })
                }
                $scope.exportRangelist = [
                    { id: "all", name: $filter('translate')("所有推广数据") },
                    { id: "channel", name: $filter('translate')("指定渠道") },
                    { id: "campaign", name: $filter('translate')("指定活动") }
                ];
            } else if($scope.exportModuleid == 'advertisinginfo') {
                $scope.exportTypeList = [
                    { id: "install", "name": $filter('translate')("激活") },
                    { id: "reged", "name": $filter('translate')("注册") }
                ]
                if ($rootScope.isweb && $scope.isSpecialAccount) {
                    // $scope.exportTypeList.splice(1, 0, { id: "fake", name: "防作弊卫士激活" });
                } else {
                    if (($scope.isall || $scope.showDataModel('pay')) && !$scope.iswx && !$scope.iswg) {
                        $scope.exportTypeList.push({ id: "pay", "name": $filter('translate')("付费") });
                    }
                    if ($rootScope.isandroid || $rootScope.isios) {
                        $scope.exportTypeList.push({ id: 'loggedin', name: $filter('translate')('登录') });
                    }
                }
                $scope.exportRangelist = [
                    { id: "all", name: $filter('translate')("所有广告数据") },
                    { id: "channel", name: $filter('translate')("指定渠道") },
                    // { id: "ad_gfroup", name: $filter('translate')("指定广告组") },
                    // { id: "ad_plan", name: $filter('translate')("指定广告计划") },
                    // { id: "ad_creative", name: $filter('translate')("指定广告创意") }
                ];
            } else if($scope.exportModuleid == 'remarketing') {
                $scope.exportTypeList = [
                    { id: "dp_install", "name": $filter('translate')("调起") },
                    { id: "dp_reg", "name": $filter('translate')("注册") },
                    { id: "dp_lognin", "name": $filter('translate')("登录") },
                ]
                if ($scope.isall || $scope.showDataModel('pay')) {
                    $scope.exportTypeList.push({ id: "dp_pay", "name": $filter('translate')("付费") });
                }
                $scope.exportRangelist = [
                    { id: "all", name: $filter('translate')("所有再营销推广活动") },
                    { id: "channel", name: $filter('translate')("指定渠道") },
                    { id: "campgroup", name: $filter('translate')("指定活动组") },
                    { id: "campaign", name: $filter('translate')("指定活动") }
                ];
            } else if($scope.exportModuleid == 'userengagement') {
                $scope.exportTypeList = [
                    { id: "duration", "name": $filter('translate')("单次使用时长") },
                    // { id: "reged", "name": $filter('translate')("单词App页面浏览时长") }
                ]
                $scope.exportRangelist = [
                    { id: "all", name: $filter('translate')("所有推广数据") },
                    { id: "channel", name: $filter('translate')("指定渠道") },
                    { id: "campgroup", name: $filter('translate')("指定活动组") },
                    { id: "campaign", name: $filter('translate')("指定活动") }
                ];
            }
            $scope.exportTypeinit = $scope.exportTypeList[0].id;
            if (($scope.isall || $scope.showDataModel('isnatureopen'))&&$scope.exportModuleid != 'advertisinginfo'&&$scope.exportModuleid != 'remarketing') {
                $scope.exportRangelist.push({ id: "default", name: $filter('translate')("自然量") });
            }
        })

        /* //‘数据类型’下拉集合
        $scope.getExportTypeList = function() {
            if ($scope.isSpecialAccount && $rootScope.isweb) {
                $scope.exportTypeList = [{ id: "h5_event", "name": $filter('translate')("推广-自定义事件") }]
            }else if($rootScope.isSelfBuilt){
                $scope.exportTypeList = [
                    { id: "install", "name": $filter('translate')("推广-表单列表") },
                    { id: "reged", "name": $filter('translate')("推广-注册列表") }
                ]
            } else {
                $scope.exportTypeList = ($rootScope.iswx || $rootScope.iswg) ? [
                    { id: "launch", "name": $filter('translate')("新增用户") },
                    { id: "register", "name": $filter('translate')("注册列表") },
                    { id: "payment", "name": $filter('translate')("付费列表") },
                ] : [
                    { id: "install", "name": $filter('translate')("推广-激活列表") },
                    { id: "reged", "name": $filter('translate')("推广-注册列表") }
                ];
            }


        }

        $scope.getExportTypeList(); */
        /* if($rootScope.isOpenFakePower){
             $scope.exportTypeList.splice(1,0,{id:"fake",name:"防作弊卫士激活"});
         }*/
        /* $scope.$watch('isOpenFakePower', function(val) {
            if (val && !$rootScope.iswx && !$rootScope.iswg) { //微信小程序没有防作弊页面权限
                $scope.exportTypeList.push({ id: "fake", name: $filter('translate')("防作弊卫士激活") }, { id: "hijack", name: $filter('translate')("防作弊卫士模块-点击劫持分析") }, { id: "hijackpack", name: $filter('translate')("防作弊卫士模块-分包劫持分析") }, { id: "corpse", name: $filter('translate')("防作弊卫士模块-僵尸用户分析") });
            }
        }); */
        $scope.$watch('isOpenFakePower', function(val) {
            if (val && !$rootScope.iswx && !$rootScope.iswg) { //微信小程序没有防作弊页面权限
                if($scope.exportModuleList.find(function(obj) {
                    return obj.id == 'menufake'
                }) == undefined){
                    $scope.exportModuleList.push({ id: "menufake", "name": $filter('translate')("防作弊卫士") })
                }
            } else {
                if($scope.exportModuleList.find(function(obj) {return obj.id == 'menufake'}) != undefined){
                    $scope.exportModuleList.filter(function(obj, index) {
                        if(obj.id == 'menufake'){
                            $scope.exportModuleList.splice(index, 1)
                        }
                    })
                }
            }
        });
        
        $scope.getExportName = function(info) {
            var types = $scope.exportTypeListAll.filter(function(item) {
                return item.id == info.downloadtype;
            });

            if (types.length > 0) {
                if(info.menuType == "campaigninfo"){
                    return $filter('translate')("推广数据")+'_'+types[0].name;
                } else if(info.menuType == "menufake"){
                    return $filter('translate')("防作弊卫士")+'_'+types[0].name;
                } else if(info.menuType == "userLife") {
                    return $filter('translate')("用户生命周期")+'_'+types[0].name;
                } else if(info.menuType == "advertisinginfo") {
                    return $filter('translate')("投放广告详情")+'_'+types[0].name;
                } else if(info.menuType == "remarketing") {
                    return $filter('translate')("再营销")+'_'+types[0].name;
                } else if(info.menuType == "userengagement") {
                    return $filter('translate')("用户参与度")+'_'+types[0].name;
                } else if(!info.menuType) {
                    if(info.downloadtype=="fake"||info.downloadtype=="hijack"||info.downloadtype=="hijackpack"||info.downloadtype=="corpse"){
                        return $filter('translate')("防作弊卫士")+'_'+types[0].name;
                    }else{
                        return $filter('translate')("推广数据")+'_'+types[0].name;
                    }
                }
            } else {
                return "";
            }
        }
        //‘数据类型’选中选项
        $scope.$on("exportTypeid", function(e, msg) {
            $scope.exportTypeId = msg.info.id;
            $scope.selnull = false;
            $scope.clicknull = false;
            $scope.subnull = false; 
            $scope.exportgroup = msg.info.isgroup == true;
            if ($scope.exportgroup) {
                $scope.getTypeData(1);
            }
            if ($scope.exportTypeId == 'hijack') {
                $scope.exportClickname = "选择劫持窗口期"
            }
            if ($scope.exportTypeId == 'corpse') {
                $scope.exportDayname = "选择观察窗口期"
            }
            if ($scope.exportTypeId == 'fake' && $scope.exportRangelist[0].name !== $filter('translate')('所有作弊数据')) {
                // $scope.exportRangelist[0].name = $filter('translate')('所有作弊数据');
                $scope.exportRangelist.splice(0, 1, { id: "all", name: $filter('translate')("所有作弊数据") });
                $scope.exportRangeinit = $scope.exportRangelist[0].id;
            } else if ($scope.exportTypeId != 'fake' && $scope.exportRangelist[0].name === $filter('translate')('所有作弊数据')) {
                // $scope.exportRangelist[0].name = $filter('translate')('所有推广数据');
                $scope.exportRangelist.splice(0, 1, { id: "all", name: $filter('translate')("所有推广数据") });
                $scope.exportRangeinit = $scope.exportRangelist[0].id;
            }
        });

        /* $scope.exportRangelist = [
            { id: "all", name: $filter('translate')("所有推广数据") },
            { id: "channel", name: $filter('translate')("指定渠道") },
            { id: "campgroup", name: $filter('translate')("指定活动组") },
            { id: "campaign", name: $filter('translate')("指定活动") }
        ];
        if ($scope.isall || $scope.showDataModel('isnatureopen')) {
            $scope.exportRangelist.push({ id: "default", name: $filter('translate')("自然量") });
        } */
        $scope.exportClickList = [{ id: "5", name: "小于5秒" }, { id: "15", name: "小于15秒" }, { id: "30", name: "小于30秒" }, { id: "60", name: "小于1分钟" }, { id: "300", name: "小于5分钟" }]
        $scope.exportDayList = [{ id: "1", name: "近一天" }, { id: "3", name: "近三天" }, { id: "7", name: "近七天" }]

        $scope.$on("exportRangeid", function(e, msg) {
            $scope.exportRangeId = msg.info.id;
            if ($scope.exportRangeId != 'all' && $scope.exportRangeId != 'default') {
                $scope.getTypeData();
            }
        });

        $scope.$on("dateCustos", function(e, msg) {
            $scope.date = msg;
        });
        $scope.$watch("date", function(n) {
            if (angular.isDefined($scope.date)) {
                $translate('至').then(function(tran) {
                    $scope.datestr = $scope.date.startDate + tran + $scope.date.endDate;
                }, function(tranId) {
                    $scope.datestr = $scope.date.startDate + tranId + $scope.date.endDate;
                });
            }
        }, true);

        $scope.beginDate = DateService.getDay(-1);
        $scope.$on("beginDate",function(e,msg){
            $scope.beginDate = msg;
        });

        var count = 0;
        $scope.init = function() {
            if (count == 0) {
                $scope.exportTypeinit = $scope.exportTypeList[0].id;
                $scope.exportRangeinit = $scope.exportRangelist[0].id;

                // $scope.exportClickinit = $scope.exportClickList[0].id;
                // $scope.exportDayinit = $scope.exportDayList[0].id;
                $scope.date = ToolService.getLastDays(-7);

            } else {
                $scope.exprefresh = count++;
            }
            count++;
            $scope.selnull = false;
            $scope.clicknull = false;
            $scope.subnull = false;
        }
        $scope.$watch("appid+listflag", function() {
            if (angular.isDefined($scope.appid) && angular.isDefined($scope.listflag)) {
                $scope.query();
                $scope.closeAdd();
            }
        });
        $scope.addExport = function() {
            ToolService.sendBehaviorUv("create");
            ToolService.showAlp();
            $scope.init();
            $scope.addstatus = true;
            $scope.stopActive = false;
        }
        $scope.closeAdd = function() {
            ToolService.hideAlp();
            $scope.addstatus = false;
            $scope.stopActive = false;
        }
        $scope.refreshExport = function(id) {
            var savePM = HttpService.putInfo("mng/export/" + $scope.appid + "/refresh/" + id, {});
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                // ToolService.showTips($filter('translate')("刷新成功"));
                $scope.query();
            }).then(function() {
                return $translate('新建成功')
            }).then(function(tran) {
                ToolService.showTips(tran);
            }, function(tranId) {
                ToolService.showTips(tranId);
            });;
        }
        $scope.save = function() {
            // if($rootScope.demoU){return false;}
            var par = {
                menuType: $scope.exportModuleid,
                downloadtype: $scope.exportTypeId,
                divtype: $scope.exportRangeId,
                busiid: $scope.typeInfoId,
                startdate: $scope.date.startDate,
                enddate: $scope.date.endDate
            }

            //数据范围第二个下拉值为空时，且第一个下拉不是选的所以推广数据、数据类型不是组时，弹出第二下拉为空提醒。
            if ((($scope.exportRangeId != 'all' && $scope.exportRangeId != 'default') || $scope.exportgroup) && $scope.typeInfoId == -1) {
                ToolService.showTips($scope.typeInfoname);
                $scope.selnull = true;
                return false;
            } else if ($scope.exportTypeId == 'hijack' && !$scope.exportClickOn) {
                ToolService.showTips($scope.exportClickname);
                $scope.clicknull = true;
                return false;

            } else if ($scope.exportTypeId == 'corpse' && !$scope.exportDayOn) {
                ToolService.showTips($scope.exportDayname);
                $scope.subnull = true;
                return false;
            } else {
                $scope.selnull = false;
                $scope.clicknull = false;
                $scope.subnull = false;
            }

            if($scope.exportTypeId == 'silent' || $scope.exportTypeId == 'loss') {
                par.startdate = $scope.beginDate;
                par.enddate = $scope.beginDate;
            }
            if ($scope.exportRangeId == 'all') {
                par.busiid = -1;
            }
            if ($scope.exportgroup) {
                delete par.startdate;
                delete par.enddate;
            }
            if ($scope.exportTypeId == 'hijack') {
                par.fakeRange = parseInt($scope.exportClickOn)
            }
            if ($scope.exportTypeId == 'corpse') {
                par.fakeRange = parseInt($scope.exportDayOn);
            }
            var savePM = HttpService.postInfo("mng/export/" + $scope.appid + "/generatefile", par);
            ToolService.showLoading();
            $scope.exportClickOn = '';
            $scope.exportDayOn = '';
            $scope.closeAdd();
            savePM.then(function(data) {
                ToolService.hideLoading();
                if (data.message) {
                    ToolService.showTips(data.message);
                } else {
                    $translate('新建成功').then(function(tran) {
                        ToolService.showTips(tran);
                    }, function(tranId) {
                        ToolService.showTips(tranId);
                    });
                }
                $scope.query();
            }).then(function() {
                return
            });
        }

        $scope.$watch("appid", function(n) {
            if (angular.isDefined($scope.appid)) {
                $scope.closeAdd();
                $scope.query();
                $scope.industory = $scope.appInstance.industory;

                $scope.exportModuleList = [
                    { id: "campaigninfo", "name": $filter('translate')("推广数据") }
                ]
                if ($scope.isOpenFakePower && !$rootScope.iswx && !$scope.iswg) { //微信小程序没有防作弊页面权限
                    $scope.exportModuleList.push({ id: "menufake", "name": $filter('translate')("防作弊卫士") })
                }
                if($scope.isall&&($rootScope.isandroid || $rootScope.isios)&&$scope.permissionMenus.useroverview&&$scope.permissionMenus.useroverview.has_auth&&$scope.permissionMenus.channeloverview&&$scope.permissionMenus.channeloverview.has_auth&&$scope.permissionMenus.lifesettings&&$scope.permissionMenus.lifesettings.has_auth){
                    $scope.exportModuleList.push({ id: "userLife", "name": $filter('translate')("用户生命周期") })
                }
                $scope.exportModuleList.push({ id: "advertisinginfo", "name": $filter('translate')("投放广告详情") })
                if($rootScope.isandroid || $rootScope.isios){
                    if($rootScope.arouseStatus == 2){
                        $scope.exportModuleList.push({ id: "remarketing", "name": $filter('translate')("再营销") })
                    }
                    $scope.exportModuleList.push({ id: "userengagement", "name": $filter('translate')("用户参与度") })
                }
                
                $scope.exportTypeListAll = [
                    { id: "h5_event", "name": $filter('translate')("自定义事件") },
                    { id: "launch", "name": $filter('translate')("新增用户") },
                    { id: "register", "name": $filter('translate')("注册列表") },
                    { id: "payment", "name": $filter('translate')("付费列表") },
                    
                    { id: "reged", "name": $filter('translate')("注册") },
                    { id: "order", "name": $filter('translate')("订单") },
                    { id: "pay", "name": $filter('translate')("付费") },
                    { id: 'loggedin', name: $filter('translate')('登录') },
                    { id: "fake", name: $filter('translate')("激活") },
                    { id: "hijack", name: $filter('translate')("点击劫持分析") },
                    { id: "hijackpack", name: $filter('translate')("分包劫持分析") },
                    { id: "corpse", name: $filter('translate')("僵尸用户分析") },
                    { id: "silent", name: $filter('translate')("沉默") },
                    { id: "loss", name: $filter('translate')("流失") },
                    { id: "backflow_channel", name: $filter('translate')("渠道概览 - 回流") },
                    { id: "backflow_analysis", name: $filter('translate')("回流分析 - 回流") },
                    { id: "dp_install", "name": $filter('translate')("调起") },
                    { id: "dp_reg", "name": $filter('translate')("注册") },
                    { id: "dp_lognin", "name": $filter('translate')("登录") },
                    { id: "dp_pay", "name": $filter('translate')("付费") },
                    { id: "duration", "name": $filter('translate')("单次使用时长") }
                ]
                if($rootScope.isSelfBuilt){
                    $scope.exportTypeListAll.push({ id: "install", "name": $filter('translate')("表单") })
                }else{
                    $scope.exportTypeListAll.push({ id: "install", "name": $filter('translate')("激活") })
                }
                /* $scope.getExportTypeList();

                if ($rootScope.isweb && $scope.isSpecialAccount) {
                    // $scope.exportTypeList.splice(1, 0, { id: "fake", name: "防作弊卫士激活" });
                } else {
                    if ($scope.industory == 'ec') {
                        if ($scope.isall || $scope.showDataModel('order')) {
                            // $scope.exportTypeList.splice(2,1);
                            $scope.exportTypeList.push({ id: "order", "name": $filter('translate')("推广-订单列表") });
                        }
                    }
                    if (($scope.isall || $scope.showDataModel('pay')) && !$scope.iswx && !$scope.iswg) {
                        // $scope.exportTypeList.splice(2,1);
                        $scope.exportTypeList.push({ id: "pay", "name": $filter('translate')("推广-付费列表") });
                    }
                    if ($rootScope.isandroid || $rootScope.isios) {
                        $scope.exportTypeList.push({ id: 'loggedin', name: $filter('translate')('推广-登录列表') });
                    }
                    if ($scope.isOpenFakePower && !$rootScope.iswx && !$scope.iswg) { //微信小程序没有防作弊页面权限
                        
                        $scope.exportTypeList.push({ id: "fake", name: $filter('translate')("防作弊卫士激活") }, { id: "hijack", name: $filter('translate')("防作弊卫士模块-点击劫持分析") }, { id: "hijackpack", name: $filter('translate')("防作弊卫士模块-分包劫持分析") }, { id: "corpse", name: $filter('translate')("防作弊卫士模块-僵尸用户分析") });

                    }

                    $scope.exportTypeinit = $scope.exportTypeList[0].id;
                }

                $scope.exportTypeinit = $scope.exportTypeList[0].id; */
            }
        });

        // $rootScope.demoU && ($scope.newSty = { 'background-position': '-17px -80px' });
    }
})();