(function () {
    angular.module("app.collect")
        .controller("packageinfoCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "$timeout", "$filter", "$translate", "UtilService", "$location", packageinfoCtrl]);

    function packageinfoCtrl($rootScope, $scope, HttpService, ToolService, $timeout, $filter, $translate, UtilService, $location) {
        $scope.initLoading = function () {
            $scope.campListLoading = true;
        };
        $scope.initLoading();
        $scope.isDetail = false;
        $scope.statusList = [{
                id: "all",
                name: $translate.instant("不筛选推广活动状态")
            },
            {
                id: "false",
                name: $translate.instant("已启用推广活动")
            },
            {
                id: "true",
                name: $translate.instant("已停用推广活动")
            }
        ];
        $scope.statusidInit = "all";
        $scope.subchannelInit = "siteId";
        $scope.$on("statusid", function (e, msg) {
            $scope.statusid = msg.info.id;
            if($scope.isDetail == true){
                $scope.clickSubList(infoStr, objStr);
            }else{
                $scope.query();
            }
        });
        $scope.$on('curdate', function (e, msg) {
            $scope.date = msg.date;
        });
        $scope.$on("conentresize", function () {
            if (!$scope.isDetail) {
                $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);
            } else {
                $scope.colsStyle2 = ToolService.getTableColsWidth($scope.packListData.name);
            }
        });

        if ($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage) {
            $scope.MainSuper = true;
        } else {
            $scope.MainSuper = false;
        }

        $scope.clickBase = function (obj) {
            if (obj.isedit == false) {
                return false;
            }

            obj.ischeck = !obj.ischeck;
            if (obj.status == 0) {
                obj.status = 1
            } else {
                obj.status = 0
            }
        }
        $scope.checkAll = function (type) {
            if (!$scope.baseList) {
                return false;
            }

            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function (item) {
                if (item.type == type && item.isedit) {
                    if (item.ischeck == bol) {
                        if (item.status == 0) {
                            item.status = 1
                        } else {
                            item.status = 0
                        }
                        item.ischeck = !bol;
                    }
                }
            });
        }
        $scope.hasCheckAll = function (type) {
            if (!$scope.baseList) {
                return false;
            }
            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }
        $scope.hasType = function (type) {
            if (!$scope.baseList) {
                return false;
            }
            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type) {
                    count = 1;
                    break;
                }
            }
            return count > 0;
        }

        $scope.showBaseWin = function () {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function (flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function (item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function () {
            if (!$scope.isDetail) {
                $scope.query();
            } else {
                $scope.clickSubList(infoStr, objStr);
            }

            var vcol = [];
            $scope.baseList.filter(function (item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            var updatePM = HttpService.postInfo($scope.appid + "/campaign/viewcolumn/campaign?viewcolumn=" + vcol.join(","), {});
            updatePM.then(function (data) {});
            $scope.hideDialog(-1);
        }



        $scope.selectFlag = "date";
        $scope.$on('flipinfo', function (e, msg) {
            if (!$scope.isDetail) {
                $scope.flipPage = msg;
                $scope.fixrefresh = ++rmd;
            } else {
                $scope.flipPage2 = msg;
                $scope.fixrefresh2 = ++rmd;
            }
        });

        $scope.showZero = false;
        $scope.query = function () {
            $scope.isDetail = false;
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            params.viewtype = $scope.selectFlag;
            params.func = "campaigninfo";
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }
            if ($scope.statusid != "all") {
                params.del_flag = $scope.statusid;
            }
            var listPM = null,
                currentInfo = {},
                qReport = "campaigninfo_bypackagecampaign",
                eptName = $filter('translate')('日期');
            var vcol = [];
            if(!$scope.baseList) return false;
            $scope.baseList.filter(function (item) {
                if (item.ischeck == true) {
                    if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention')) || ((item.type == 'sdkevent' || item.type == 'sdkevent_new') && !$scope.showDataModel('event'))) {
                        //没有付费权限，不能查看付费
                    } else if (item.type == 'base' && item.fieldcode == 'wake_num' && $rootScope.arouseStatus != 2) {
                        //没有唤醒权限，不能查看付费
                    } else {
                        vcol.push(item.fieldcode);
                    }
                }
            });
            params.viewcolumn = vcol.join(",");
            listPM = HttpService.getReportData(qReport, params);
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("分包活动详情") + "-" + eptName, qReport, params);

            $scope.campListLoading = true;
            listPM.then(function (data) {
                $scope.campList = data;
                $scope.infoListTotal = {};
                if (data.val[0] && data.val[0].campaignid == $filter('translate')('汇总')) {
                    $scope.infoListTotal = data.val[0];
                    $scope.campAllList = data.val.slice(1);
                } else {
                    $scope.campAllList = data.val;
                }
                $scope.campNoZeroList = $scope.campAllList.filter(function (item) {
                    return item.isall0 == false;
                });

                if ($scope.showZero) {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
                $scope.sortCol = "";
                $scope.campListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                if ($scope.selectFlag != "subaccount") {
                    $scope.searchTxt = "";
                }
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
            });
        }

        $scope.searchGroupInitf5 = 0;
        $scope.filterByTxt = function (txt) {
            $scope.filterTxt = txt;
            if($scope.isDetail){
                $scope.clickSubList(infoStr, objStr);
            }else{
                $scope.query();
            }
            
        }

        $scope.iscanSub = function () {
            var bol = false;
            if ($scope.selectFlag == 'subchannel') {
                bol = $scope.allSubInfo.length != 3;
            }
            return bol
        }

        $scope.preSub = function (idx) {
            if ($scope.allSubInfo.length - 1 == idx) {
                return false;
            }
            $scope.currentReports = $scope.allSubInfo[idx];
            $scope.allSubInfo = $scope.allSubInfo.slice(0, idx);
            $scope.query();
        }
        $scope.clickZero = function () {
            $scope.showZero = !$scope.showZero;
            if ($scope.isDetail) {
                if ($scope.showZero) {
                    $scope.packList = $scope.packAllList;
                } else {
                    $scope.packList = $scope.packNoZeroList;
                }
                return false;
            }

            if ($scope.isandroid && ($scope.selectFlag == 'campaign' || $scope.selectFlag == 'channel')) {
                $scope.doPackFilter();
            } else {
                if ($scope.showZero) {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }
            }
        }

        var orderBy = $filter('orderBy'),
            rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.sortCol2 = "";
        $scope.order = function (predicate, reverse) {
            if (!$scope.isDetail) {
                $scope.sortCol = predicate;
                $scope.infoList = orderBy($scope.infoList, predicate, reverse);
                $scope.listf5 = ++rmd;
                $scope.fixrefresh = ++rmd;
            } else {
                $scope.sortCol2 = predicate;
                $scope.packList = orderBy($scope.packList, predicate, reverse);
                $scope.listf52 = ++rmd;
                $scope.fixrefresh2 = ++rmd;
            }

        };

        $scope.$watch("appid", function () {
            $scope.allSubInfo = [];
            $scope.currentReports = null;
            $scope.industory = $scope.appInstance ? $scope.appInstance.industory : '';
        });
        $scope.$watch("date.startDate+date.endDate", function () {
            if ($scope.allSubInfo.length > 0) {
                $scope.allSubInfo.pop()
            }
        });
        $scope.doPackFilter = function () {
            var myInfoList = [];
            if ($scope.showZero) {
                myInfoList = $scope.campAllList;
            } else {
                myInfoList = $scope.campNoZeroList;
            }
            $scope.infoList = myInfoList.filter(function (item) {
                return (item.ispackchannel == ($scope.packageID == 'APPMARKET')) || $scope.packageID == 'all';
            });
            $scope.fixrefresh = ++rmd;
        }
        var oldappid = "";
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid}", function (n) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date) || !$scope.isandroid) {
                return false;
            }
            if ($scope.isDetail == false) {
                if (!$scope.baseList || oldappid != $scope.appid) {
                    //指标列表
                    var basePM = HttpService.getInfo($scope.appid + "/campaign/viewcolumn/findall/campaign");
                    basePM.then(function (data) {
                        for (var i = 0; i < data.length; i++) {
                            if (data[i].fieldcode == 'num_impression') {
                                data.splice(i, 1);
                            }
                            if (data[i].fieldcode == 'rate_click') {
                                data.splice(i, 1);
                            }
                        }
                        $scope.baseList = data;
                        $scope.sdkList = data.filter(function (item) {
                            return item.type == 'sdkevent';
                        });
                        $scope.sdkeventNew = data.filter(function(item) {
                            return item.type == 'sdkevent_new';
                        });
                        $scope.query();
                    });
                } else {
                    $scope.query();
                }
                oldappid = $scope.appid;
            } else {
                $scope.clickSubList(infoStr, objStr);
            }

        }, true);

        var infoStr = {};
        var objStr = '';
        $scope.clickSubList = function (info, obj,sFlag) {
            if (!info) {
                var target = obj.target,
                    data = target.getAttribute('data');
                info = $.parseJSON(data);
            }
            infoStr = info;
            objStr = obj;
            if (info.campaignid == $filter('translate')('汇总')) {
                return false;
            }
            $scope.listname = info.channelname;
            if(sFlag == '1'){
                $scope.statusidInit = "all";
                $scope.statusid = "all";
                $scope.statusNameInit = $scope.statusList[0].name;
                $scope.exprefresh = ++rmd;
                $scope.filterTxt = '';
                $scope.searchGroupInitf5++
            }
            var qReport = "campaigninfo_bysubpackagecampaign";
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            params.viewtype = 'date';
            params.func = "campaigninfo";
            params.campaignname = info.campaignid;
            params.channelname = info.channelname;
            params.parent_campaignid = info.id;
            if ($scope.statusid != "all") {
                params.del_flag = $scope.statusid;
            }
            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }
            var vcol = [];
            $scope.baseList.filter(function (item) {
                if (item.ischeck == true) {
                    if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention')) || ((item.type == 'sdkevent' || item.type == 'sdkevent_new') && !$scope.showDataModel('event'))) {
                        //没有付费权限，不能查看付费
                    } else if (item.type == 'base' && item.fieldcode == 'wake_num' && $rootScope.arouseStatus != 2) {
                        //没有唤醒权限，不能查看付费
                    } else {
                        vcol.push(item.fieldcode);
                    }
                }
            });
            params.viewcolumn = vcol.join(",");
            $scope.isDetail = true;
            
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("分包子活动详情") + "-" + $filter('translate')("日期"), qReport, params); //更新导出参数
            $scope.campListLoading2 = true;
            var listPM = HttpService.getReportData(qReport, params);
            listPM.then(function (data) {
                /*$scope.campListLoading2 = false;
                $scope.packList = data.val;*/
                $scope.packListData = data;
                $scope.packListTotal = {};
                if (data.val[0] && data.val[0].campaignid == $filter('translate')('汇总')) {
                    $scope.packListTotal = data.val[0];
                    $scope.packAllList = data.val.slice(1);
                } else {
                    $scope.packAllList = data.val;
                }
                $scope.packNoZeroList = $scope.packAllList.filter(function (item) {
                    return item.isall0 == false;
                });

                if ($scope.showZero) {
                    $scope.packList = $scope.packAllList;
                } else {
                    $scope.packList = $scope.packNoZeroList;
                }
                $scope.sortCol2 = "";
                $scope.campListLoading2 = false;
                $scope.colsStyle2 = ToolService.getTableColsWidth(data.name);

                $scope.initrefresh2 = ++rmd;
                $scope.fixrefresh2 = ++rmd;

            });
        }
    }
})();