(function(){
    angular.module("app.collect")
        .controller("potentialusergroupCtrl",["$scope","HttpService","ToolService","UtilService","$filter",potentialusergroupCtrl]);

    function potentialusergroupCtrl($scope,HttpService,ToolService,UtilService,$filter){

    	var colors = ["#dddddd","#6ed0dc","#009be0","#d297ce","#8359a0","#abc450","#42975f","#ffbf4b","#ff830f","#fd9fb4","#e64e59"];
        $scope.maxnum = 11,pieAllData = {};
        $scope.addLabel = function(label,index){
        	if($scope.choiceLabels.length >= $scope.maxnum){return false;}

        	$scope.choiceLabels.push(label);
        	var idx = $scope.choiceColors.length,color = colors[idx],cidx = $scope.choiceColors.indexOf(color);
        	while(cidx>-1){
        		idx ++;
        		idx = idx > 10 ? 1 : idx;
        		color = colors[idx];
        		cidx = $scope.choiceColors.indexOf(color);
        	}
        	$scope.choiceColors.push(color);

        	$scope.choiceData.push(pieAllData.val[0][index]);
            $scope.choiceLabelKeys.push(pieAllData.keyId[index]);

            $scope.refreshPie();
        }
        $scope.removeLabel = function(label,index){
        	if(index<2){return false;}
        	
        	var idx = $scope.choiceLabels.indexOf(label);

        	$scope.choiceLabels.splice(idx,1);
            $scope.choiceLabelKeys.splice(idx,1);
            $scope.choiceColors.splice(idx,1);
        	$scope.choiceData.splice(idx,1);

        	$scope.refreshPie();
        }

        $scope.refreshPie = function(){
        	$scope.labelConfig.color = $scope.choiceColors;
			$scope.labelChartData = {
				name:pieAllData.name,
				key:$scope.choiceLabels,
				val:[$scope.choiceData]
			}
            $scope.queryCategoryTop10($scope.choiceLabelKeys);
        }

        $scope.query = function(){
        	//潜在用户推广来源TOP10
        	$scope.labelConfig = {color:["#6dc7be"],legend:false};
            var params = {appid:$scope.appid};
            params.datatype = "chart";
            //昨天之前两个月
            params.enddate = UtilService.getDay(-1);
            params.startdate =  UtilService.getLastMonthsDate(params.enddate,2);
            
			var channelGroupPM = HttpService.getReportData("decision_potencial_bycategory",params);
            $scope.labelLoading = true;
			var initnum = 2;
            channelGroupPM.then(function(data){
                if(data && data.key && data.key[0]){
                    data.key[0] = $filter('translate')("已获取用户");
                }
				pieAllData = data;
				$scope.choiceLabels = data.key.slice(0,initnum);
                $scope.choiceLabelKeys = data.keyId.slice(0,initnum);
                $scope.choiceColors = colors.slice(0,initnum);
				$scope.choiceData = data.val[0].slice(0,initnum);
				$scope.labelList = data.key;
                $scope.labelLoading = false;
				$scope.refreshPie();
			});

 			//当前用户推广来源TOP10
        	$scope.channelTop2Config = {color:["#9cc272"],legend:false,isbartext:true};
			var channelTop2PM = HttpService.getReportData("channelinstall_top10_bychannel",params);
            $scope.channelTop2Loading = true;
			channelTop2PM.then(function(data){
				$scope.channelTop2Data = data;
                $scope.channelTop2Loading = false;
			});
        };

        $scope.queryCategoryTop10 = function(categoryId)
        {
            var params = {appid:$scope.appid};
            params.datatype = "chart";
            //昨天之前两个月
            params.enddate = UtilService.getDay(-1);
            params.startdate =  UtilService.getLastMonthsDate(params.enddate,2);
            params.categoryid = categoryId.join();

            //潜在用户推广来源TOP10
            $scope.channelTop1Config = {color:["#6dc7be"],legend:false,isbartext:true};
            var channelTop1PM = HttpService.getReportData("decision_potencial_top10_bychannel",params);
            $scope.channelTop1Loading = true;
            channelTop1PM.then(function(data){
                $scope.channelTop1Data = data;
                $scope.channelTop1Loading = false;
            });
        };

        $scope.$watch("appid+lang",function(){
            if(angular.isDefined($scope.appid)){
                $scope.query();
            }
        });
        
    }
})();