(function () {
    angular.module("app.collect")
        .controller("recycleanalysisCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "$timeout", "$filter", "UtilService", recycleanalysisCtrl]);

    function recycleanalysisCtrl($rootScope, $scope, HttpService, ToolService, $timeout, $filter, UtilService) {
        $scope.tabType = 'dataview';
        $scope.initLoading = function () {
            $scope.viewListLoading = true;
            $scope.expendLoading = true;
            $scope.eCPALoading = true;
            $scope.payListLoading = true;
            $scope.roiListLoading = true;
            $scope.recycleListLoading = true;
        };
        $scope.initLoading();
        //查询账户是否需要过期提醒
        $scope.isPass = function(){
           ToolService.showLoading();
           var pm = HttpService.getInfo("mng/recycle/checkadvancepast");
           pm.then(function(data){
               $rootScope.showCover = true;
           }).finally(function(){
               ToolService.hideLoading();
           });
        }

        $scope.isPass();

        $scope.$on('curdate', function (e, msg) {
            $scope.date = msg.date;
        });
        $scope.$on("conentresize", function () {
            $timeout(function () {
                $scope.thw = ($scope.panelw + 40) / ($scope.viewList.name.length - 2) + 'px';
            }, 100);

            if ($scope.tabType == 'dataview') return;
            $scope.colsStyle = ToolService.getTableColsWidth($scope.recycleList.name);
        });
        $scope.changeTab = function (type) {
            this.tabType = type;
            if (type == 'dataview') {
                $scope.queryView();
            } else {
                $scope.queryReport();
            }
        }
        $scope.clickBase = function (obj) {
            if (obj.isedit == false) {
                return false;
            }

            obj.ischeck = !obj.ischeck;
            if (obj.status==0){
                obj.status=1
            } else {
                obj.status=0
            }
        }
        $scope.checkAll = function (type) {
            if (!$scope.baseList) {
                return false;
            }

            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function (item) {
                if (item.type == type && item.isedit) {
                    if(item.ischeck==bol){
                        if (item.status==0){
                            item.status=1
                        } else {
                            item.status=0
                        }
                        item.ischeck = !bol;
                    }
                }
            });
        }
        $scope.hasCheckAll = function (type) {
            if (!$scope.baseList) {
                return false;
            }

            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }

        $scope.showBaseWin = function () {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function (flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function (item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function () {
            ToolService.sendBehaviorUv("okBase");
            $scope.queryReport(true);
            var vcol = [];
            $scope.baseList.filter(function (item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            var updatePM = HttpService.postInfo($scope.appid + "/campaign/viewcolumn/recycleanalysis?viewcolumn=" + vcol.join(","), {});
            updatePM.then(function (data) {
            });
            $scope.hideDialog(-1);
        }
        $scope.selectFlag = "date";
        $scope.changeSelectFlag = function (flag) {
            ToolService.sendBehaviorUv(flag);
            // ToolService.sendBehavior();
            $scope.selectFlag = flag;
            $scope.firstCol = $scope.selectFlag == 'campaign' ? $filter('translate')('推广活动') : ($scope.selectFlag == 'channel' ? $filter('translate')('渠道'):$filter('translate')('详情自然量'))
        }
        $scope.selectAll = function (data, key) {
            var selected = [];
            data.filter(function (item) {
                selected.push(item[key]);
            })
            return selected.join(',');
        }
        $scope.querySelectInfos = function () {
            var channelPM = HttpService.getInfo('mng/recycle/channel/list',{type:1});
            $scope.channelNameInit = $filter('translate')("全部渠道");
            channelPM.then(function (data) {
                $scope.channelList = data;
                $scope.channelidInit = $scope.selectAll(data, 'cid');
            });

            var accountPM = HttpService.getInfo('mng/recycle/account/list');
            $scope.accountNameInit = $filter('translate')("全部投放账号");
            accountPM.then(function (data) {
                $scope.accountList = data;
                $scope.accountidInit = $scope.selectAll(data, 'channelAccountId');
            });
        }

        $scope.selectlistNum = 0;
        $scope.channelidInit = "";
        var current = "";
        $scope.$on("channelid", function (e, msg) {
            current = "channel";
            $scope.resetList();
            $scope.channelid = msg.info;
            $scope.selectlistNum++;
        });
        $scope.accountidInit = "";
        $scope.$on("accountid", function (e, msg) {
            current = "account";
            $scope.resetList();
            $scope.accountid = msg.info;
            $scope.selectlistNum++;
        });

        $scope.resetList = function () {
            if ($scope.tabType == 'dataview') return;
            if ($scope.selectlistNum > 1) {
                var precur = "";
                if ($scope.channelid != '' && current != 'channel') {
                    $scope.channelResh = $scope.selectlistNum;
                    $scope.channelid = "";
                }
                else if ($scope.accountid != '' && current != 'account') {
                    $scope.accountResh = $scope.selectlistNum;
                    $scope.accountid = "";
                }

                //为了等到数据赋值完成再查询
                $timeout(function () {
                    $scope.queryReport();
                }, 100);
            }
        }

        $scope.$watch("tabType", function (n) {
            if (angular.isUndefined(n) || $scope.tabType == 'dataview') {
                return false;
            }
            $scope.selectlistNum = 0;
            $scope.querySelectInfos();
        });

        $scope.$on('flipinfo', function (e, msg) {
            $scope.flipPage = msg;
            $scope.fixrefresh = ++rmd;
        });

        var flagNames;

        function init(){
            flagNames = {
                "date": $filter('translate')("日期"),
                "campaign": $filter('translate')("活动"),
                "channel": $filter('translate')("渠道"),
                "media": $filter('translate')("媒体")
            };
            $scope.listRefresh = 1;
            $scope.statusList = [
                {id: 0, name: $filter('translate')("已启用")},
                {id: 1, name: $filter('translate')("已停用")}
            ];

            $scope.statusInit = $scope.statusList[0].id;

            $scope.tfStatusList = [
                {id: 1, name: $filter('translate')("投放")},
                {id: 0, name: $filter('translate')("非投放")}
            ];
            $scope.tfStatusInit = $scope.tfStatusList[0].id;
        }

        init();

        $scope.$on("statusId",function(e,msg){
            $scope.statusId = msg.info.id;
        });

        $scope.$on("tfStatusId",function(e,msg){
            $scope.tfStatusId = msg.info.id;
        });

        $scope.getFormatNumber = function (num, col) {
            return UtilService.getFormatNumber(num, col, true);
        }

        $scope.canAdd = function (type) {
            return $scope[type + 'channeled_list'].length > 10 ? false : true;
        }

        $scope.initChannel = function (list) {
            return (list.length > 10 ? list.slice(0, 10) : list);
        }

        $scope.changeChannel = function (type, channel) {
            if (!$scope.canAdd(type)) {
                return false;
            }
            var idx = $scope[type + 'channeled_list'].indexOf(channel);
            if (idx > -1) {
                $scope[type + 'channeled_list'].splice(idx, 1);
            }
            else {
                $scope[type + 'channeled_list'].push(channel);
            }
            $scope[type + 'initChannel'] = $scope[type + 'channeled_list'].length == 0 ? $filter('translate')("请选择渠道")
                : $scope.initChannel($scope[type + 'channeled_list']).length + $filter('translate')('个渠道');
            $scope.changeChartData(type);
        }

        $scope.changeChartData = function (type) {
            $scope[type + 'Data'].name = $scope[type + 'channeled_list'];
        }

        $scope.queryView = function () {
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            //总览
            var listPM = HttpService.getReportData('recycle_dashboard_total', params);
            $scope.viewListLoading = true;
            listPM.then(function (data) {
                $scope.viewList = data;
                $scope.viewListLoading = false;
                $scope.thw = ($scope.panelw + 40) / ($scope.viewList.name.length - 2) + 'px';

            });
            params.datatype = 'chart';
            //消费趋势
            $scope.expendConfig = {color: ToolService.getTenColors()};
            var expendPM = HttpService.getReportData('recycle_dashboard_expense_trend', params);
            $scope.expendLoading = true;
            expendPM.then(function (data) {
                $scope.exData = data;
                $scope.exchannelList = data.name;
                $scope.exinitChannel = $scope.initChannel(data.name).length + $filter('translate')('个渠道');
                $scope.exchanneled_list = UtilService.cloneJSON($scope.exchannelList);
                $scope.expendLoading = false;
            });
            //eCPA趋势
            $scope.eCPAConfig = {color: ToolService.getTenColors()};
            var eCPAPM = HttpService.getReportData('recycle_dashboard_ecpa_trend', params);
            $scope.eCPALoading = true;
            eCPAPM.then(function (data) {
                $scope.ecData = data;
                $scope.ecchannelList = data.name;
                $scope.ecinitChannel = $scope.initChannel(data.name).length + $filter('translate')('个渠道');
                $scope.ecchanneled_list = UtilService.cloneJSON($scope.ecchannelList);
                $scope.eCPALoading = false;
            });
            //付费趋势
            $scope.payConfig = {color: ToolService.getTenColors()};
            var payPM = HttpService.getReportData('recycle_dashboard_payment_trend', params);
            $scope.payLoading = true;
            payPM.then(function (data) {
                $scope.payData = data;
                $scope.paychannelList = data.name;
                $scope.payinitChannel = $scope.initChannel(data.name).length + $filter('translate')('个渠道');
                $scope.paychanneled_list = UtilService.cloneJSON($scope.paychannelList);
                $scope.payLoading = false;
            });
            //ROI趋势
            $scope.roiConfig = {color: ToolService.getTenColors()};
            var roiPM = HttpService.getReportData('recycle_dashboard_roi_trend', params);
            $scope.roiLoading = true;
            roiPM.then(function (data) {
                $scope.roiData = data;
                $scope.roichannelList = data.name;
                $scope.roiinitChannel = $scope.initChannel(data.name).length + $filter('translate')('个渠道');
                $scope.roichanneled_list = UtilService.cloneJSON($scope.roichannelList);
                $scope.roiLoading = false;
            });
        }
        $scope.queryReport = function (flag, hasTotal) {
            var params = ToolService.getParams($scope);
            params.datatype = 'list';
            // if ($scope.selectFlag != "campaign") {
                params.viewtype = $scope.selectFlag;
            // }
            params.func = "campaigninfo";

            if ($scope.filterTxt && $scope.filterTxt != '') {
                params.searchtxt = $scope.filterTxt;
            }

            var listPM = null, currentInfo = {}, qReport = "",
                eptName = flagNames[$scope.selectFlag], subfix = "";
            if ($scope.selectFlag == "date") {
                subfix = "ds";
            } else {
                subfix = $scope.selectFlag;
            }

            if ($scope.selectFlag == "date" || $scope.selectFlag == "campaign") {
                if ($scope.channelid) {
                    params.cid = $scope.channelid;
                }
                if ($scope.accountid) {
                    params.accountid = $scope.accountid;
                }
            }

            qReport = "recycle_analysis_by" + subfix;
            var vcol = [];
            $scope.baseList.filter(function (item) {
                if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention'))) {
                    //没有付费权限，不能查看付费
                }
                else {
                    if ($scope.selectFlag == "date" || $scope.selectFlag == "campaign" || $scope.selectFlag == "channel") {
                        if (item.ischeck == true) {
                            vcol.push(item.fieldcode);
                        }
                    } else {
                        if (item.ischeck == true && item.type != "sdkevent") {
                            vcol.push(item.fieldcode);
                        }
                    }
                }
            });
            params.viewcolumn = vcol.join(",");
            params.del_flag  = $scope.statusId ? true:false;
            params.status = $scope.tfStatusId;
            var condiParams = '';
            listPM = HttpService.getReportData(qReport, params);
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("回本分析")+"-" + eptName, qReport, condiParams ? condiParams : params);
            $scope.recycleListLoading = true;
            listPM.then(function (data) {
                $scope.recycleList = data;
                $scope.infoListTotal = data.val[0];
                $scope.infoList = data.val.slice(1);

                $scope.recycleListLoading = false;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.sortCol = "";
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
            });
        }
        var orderBy = $filter('orderBy'), rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function (predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.queryViewColumn = function(){
            //指标列表
            var basePM = HttpService.getInfo($scope.appid + "/campaign/viewcolumn/findall/recycleanalysis");
            basePM.then(function (data) {
                $scope.baseList = data;
                $scope.sdkList = data.filter(function (item) {
                    return item.type == 'sdkevent';
                });
                $scope.changeTab($scope.tabType);
            });
        }
        var oldappid = "";
        $scope.$watch("{startDate:date.startDate,endDate:date.endDate,appid:appid,selectFlag:selectFlag,accountid:accountid,channelid:channelid,tfStatusId:tfStatusId,statusId:statusId,lang:lang}", function (n,o) {
            if (angular.isUndefined($scope.appid) || angular.isUndefined($scope.date)) {
                return false;
            }
            if (!$scope.baseList || oldappid != $scope.appid) {
                $scope.queryViewColumn();
            }
            else {
                $scope.changeTab($scope.tabType);
            }
            oldappid = $scope.appid;
            $scope.isec = $scope.appInstance.industory == 'ec';

            //语言切换
            if(n.lang && o.lang && n.lang!==o.lang){
                init();
                $scope.querySelectInfos();
                $scope.queryViewColumn();
            }
        },true);


        $scope.closePrompt = function(){
            $rootScope.showCover = !$rootScope.showCover;
        }

    }


})();
