(function() {
    angular.module("app.collect")
        .controller("refluxanalysisCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "$timeout", "$filter","DateService", "$translate", refluxanalysisCtrl]);

    function refluxanalysisCtrl($scope, $rootScope, HttpService, ToolService, $timeout, $filter, DateService, $translate) {
        /**
         * 语言切换
         */
        var orderBy = $filter('orderBy'),
            rmd = new Date().getTime();
        
        //时间控件
        var today = ToolService.getToday(),
            yesDay = ToolService.getYesDay();
        $scope.timeflag = 'today';
        $scope.date = today;
        $scope.$on("dateCustos",function(e,msg){
            if (msg.startDate == msg.endDate && msg.startDate == today.startDate) {
                $scope.timeflag = "today";
            } else if (msg.startDate == msg.endDate && msg.startDate == yesDay.startDate) {
                $scope.timeflag = "yesday";
            } else {
                $scope.timeflag = "";
            }
            $scope.date = msg;
        });
        $scope.$watch("date",function(){
            if(angular.isDefined($scope.date)){
                $scope.datestr = $scope.date.startDate + $filter('translate')("至") + $scope.date.endDate;
                if($scope.appid){
                    $scope.query();
                }
            }
        });
        $scope.changeDate = function(flag) {
            if(flag == 'today'){
                $scope.date = ToolService.getToday();
            } else {
                $scope.date = ToolService.getYesDay();
            }
            $scope.timeflag = flag;
        }

        //排序
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };

        $scope.$watch("{appid:appid,lang:lang}", function(n, o) {
            if (angular.isUndefined($scope.appid)) { return false; }
            $scope.querySelectInfos();
            var url = '/campaign/viewcolumn/findall/refluxanalysis'
            if($rootScope.showServeridbackflow){
                url = '/campaign/viewcolumn/findall/serveridbackflow'
            }
            // 获取指标点数据
            var basePM = HttpService.getInfo($scope.appid + url);
            basePM.then(function(data) {
                $scope.baseList = data;
                $scope.sdkList = data.filter(function(item) {
                    return item.type == 'sdkevent';
                });
                $scope.query();
            });
            
            if(n && o && n!==o){
                // $scope.initData();
            }
        });

        //分析维度
        $scope.selectFlag = 'date';
        $scope.changeSelectFlag = function(flag) {
            if($scope.selectFlag != flag) {
                $scope.selectFlag = flag;
                $scope.query();
            }
        }
        // $scope.dimensionList = [
        //     {id:'1',name:$translate.instant("渠道维度")},
        //     {id:'2',name:$translate.instant("活动维度")},
        // ]
        // $scope.dimensionInit = '1';
        // $scope.dimensionId = '1';
        // $scope.$on("dimensionId", function(e, msg) {
        //     console.log(111)
        //     if($scope.dimensionId != msg.info.id){
        //         $scope.dimensionId = msg.info.id
        //         $scope.query();
        //     }
        // });

        // 回流类型
        $scope.backflowList = [
            {id:'all',name:$translate.instant("不筛选回流类型")},
            {id:'1',name:$translate.instant("老服沉睡新服回流")},
            {id:'4',name:$translate.instant("老服沉睡老服回流")},
            {id:'2',name:$translate.instant("新服沉睡新服回流")},
            {id:'3',name:$translate.instant("新服沉睡老服回流")},
        ]
        $scope.backflowInit = $scope.backflowList[0].id
        $scope.$on("backflowId", function(e, msg) {
            $scope.serveridbackflowId = msg.info.id
            $timeout(function() {
                $scope.query();
            }, 100);
        });
        $scope.setBackflow = function() {
            $scope.goPage("collect.serveridbackflow");
        }

        //数据筛选
        $scope.querySelectInfos = function() {
            $translate(["不筛选", "自然量"]).then(function(translations) {
                $scope.initSelects(translations["不筛选"], translations["自然量"]);
            }, function(tranIds) {
                $scope.initSelects(tranIds["不筛选"], tranIds["自然量"]);
            });
        }
        $scope.initSelects = function(noFilter, nat) {
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = noFilter + channelparams.txt;;
            channelPM.then(function(data) {
                if (!(!$rootScope.isall && $rootScope.curRoleAuth && !$rootScope.curRoleAuth.isNatureOpen)) {
                    data.unshift({ id: "-1", name: nat });
                }
                $scope.channelList = data;
            });

            var campaignparams = ToolService.getChannelCampaignParams("campaign", $scope.appid);
            var campaignPM = HttpService.getInfo($scope.appid + "/campaign/dropdown");
            $scope.campaignNameInit = noFilter + campaignparams.txt;;
            campaignPM.then(function(data) {
                $scope.campaignListTotal = data;
                var data = data.data;
                data.unshift({ id: "all", name: $scope.campaignNameInit });
                data.filter(function(item) {
                    item.uid = item.id;
                    item.id = item.campaignid;
                });
                $scope.campaignList = data;
                $scope.campaignListAll = data;
            });
        }

        $scope.selectlistNum = 0;
        $scope.$on("channelid", function(e, msg) {
            $scope.channelid = msg.info;
            $timeout(function() {
                $scope.query();
            }, 100);
            // $scope.selectlistNum++;
        });

        $scope.campaignInit = "all";
        $scope.$on("campaignid", function(e, msg) {
            $scope.campaignid = msg.info.id;
            $timeout(function() {
                $scope.query();
            }, 100);
            // $scope.selectlistNum++;
        });
        $scope.clearTxtId = "clearTxtId";
        $scope.$on($scope.clearTxtId, function(event, data) {
            $scope.campaignList = $scope.campaignListAll
        })

        $scope.searchTextId = "searchTextId";
        $scope.$on($scope.searchTextId, function(event, data) {
            if (!data) {
                return false
            }
            var Pm = HttpService.getInfo($scope.appid + "/campaign/dropdown?name=" + data);
            Pm.then(function(data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function(item) {
                        item.uid = item.id;
                        item.id = item.campaignid;
                    });
                    $scope.campaignList = dataList
                }

            });

        });


        // 状态筛选
        $scope.statusList = [
            { id: "", name: $translate.instant("不筛选推广活动状态") },
            { id: "false", name: $translate.instant("已启用推广活动") },
            { id: "true", name: $translate.instant("已停用推广活动") }
        ];
        $scope.statusidInit = "";
        $scope.$on("statusid", function(e, msg) {
            $scope.statusid = msg.info.id;
            if($scope.appid){
                $scope.query();
            }
        });

        //右侧输入框搜索
        $scope.filterByTxt = function(txt) {
            $scope.filterTxt = txt;
            $scope.query();
        }

        $scope.campListLoading = true;
        $scope.$on("conentresize", function() {
            if ($scope.campList) $scope.colsStyle = ToolService.getTableColsWidth($scope.campList.name);
        });

        // 编辑指标
        $scope.clickBase = function(obj) {
            if (obj.isedit == false) { return false; }
            obj.ischeck = !obj.ischeck;
            if (obj.status == 0) { 
                obj.status = 1
            } else {
                obj.status = 0
            }
        }
        $scope.checkAll = function(type) {
            if (!$scope.baseList) { return false; }

            var bol = $scope.hasCheckAll(type);
            $scope.baseList.filter(function(item) {
                if (item.type == type && item.isedit) {
                    if (item.ischeck == bol) {
                        if (item.status == 0) {
                            item.status = 1
                        } else {
                            item.status = 0
                        }
                        item.ischeck = !bol;
                    }

                }
            });
        }
        $scope.hasCheckAll = function(type) {
            if (!$scope.baseList) { return false; }
            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type && $scope.baseList[i].ischeck != true) {
                    count = 1;
                    break;
                }
            }
            return count == 0;
        }

        $scope.hasType = function(type) {
            if (!$scope.baseList) { return false; }

            var count = 0;
            for (var i = 0; i < $scope.baseList.length; i++) {
                if ($scope.baseList[i].type == type) {
                    count = 1;
                    break;
                }
            }
            return count > 0;
        }
        $scope.showBaseWin = function() {
            ToolService.showAlp();
            $scope.baseWin = true;
        }
        $scope.hideDialog = function(flag) {
            ToolService.hideAlp();
            $scope.baseWin = false;
            if (angular.isUndefined(flag)) {
                $scope.baseList.filter(function(item) {
                    if (item.status == 0) {
                        item.status = 1;
                        item.ischeck = !item.ischeck;
                    }
                });
            }
        }
        $scope.okBase = function() {
            ToolService.sendBehaviorUv("okBase");
            var url = '/campaign/viewcolumn/refluxanalysis?viewcolumn='
            if($rootScope.showServeridbackflow){
                url = '/campaign/viewcolumn/serveridbackflow?viewcolumn='
            }
            var vcol = [];
            $scope.baseList.filter(function(item) {
                item.status = 1;
                if (item.ischeck) {
                    vcol.push(item.fieldcode);
                }
            });
            var updatePM = HttpService.postInfo($scope.appid + url + vcol.join(","), {});
            updatePM.then(function(data) {});
            $scope.hideDialog(-1);
            $scope.query();
        }
        $scope.getViewColumns = function() {
            var vcol = [];
            $scope.baseList && $scope.baseList.filter(function(item) {
                if ((item.type == 'payment' && !$scope.showDataModel('pay')) || (item.type == 'retetion' && !$scope.showDataModel('retention')) || ((item.type == 'sdkevent' || item.type == 'sdkevent_new') && !$scope.showDataModel('event'))) {
                    //没有付费权限，不能查看付费
                } else {
                    if ($scope.selectFlag == "date" || $scope.selectFlag == "campaign" || $scope.selectFlag == "channel" || $scope.selectFlag == "serverid") {
                        if (item.ischeck == true) {
                            vcol.push(item.fieldcode);
                        }
                    } else {
                       
                        if (item.ischeck == true && item.type != "sdkevent" && item.type != "sdkevent_new") {
                            vcol.push(item.fieldcode);
                        }
                    }
                }
            });
            return vcol.join(",");
        }

        $scope.showZero = false;
        $scope.clickZero = function() {
            ToolService.sendBehaviorUv("clickZero");
            $scope.showZero = !$scope.showZero;
            reCrateListCondition($scope.listCondition);
            if ($scope.showZero) {
                $scope.infoList = $scope.campAllList;
            } else {
                $scope.infoList = $scope.campNoZeroList;
            }
        }
        function reCrateListCondition(listCondition) {
            var isOk = false;
            if (listCondition && listCondition.conditions) {
                var cond = JSON.parse(listCondition.conditions);
                if (cond) {
                    cond.showall0 = $scope.showZero;
                    listCondition.conditions = JSON.stringify(cond);
                    isOk = true;
                }
            }
            if (!isOk) {
                ToolService.showTips("");
            }
        }
        //数据列表
        $scope.query = function() {
            var qReport = "";
            var eptName = '';
            var params = ToolService.getParams($scope);
            params.startdate = $scope.date.startDate
            params.enddate = $scope.date.endDate
            params.datatype = 'list'
            params.func = 'refluxanalysis'
            params.viewcolumn = $scope.getViewColumns()
            if($scope.selectFlag == 'channel') {
                qReport = 'refluxanalysis_channel'
                params.viewtype = 'channel'
                eptName = $filter('translate')('渠道');
            } else if($scope.selectFlag == 'date') {
                qReport = 'refluxanalysis_date'
                params.viewtype = 'date'
                eptName = $filter('translate')('日期');
            } else if($scope.selectFlag == 'serverid') {
                qReport = 'refluxanalysis_serverid'
                params.viewtype = 'serverid'
                eptName = $filter('translate')('日期');
            }
             else {
                qReport = 'refluxanalysis_campaign'
                params.viewtype = 'campaign'
                eptName = $filter('translate')('活动');
            }
            if($scope.channelid){
                params.cid = $scope.channelid;
            }
            if($scope.campaignid){
                params.campaignid = $scope.campaignid;
            }
            if($scope.filterTxt){
                params.searchtxt = $scope.filterTxt;
            }
            if($scope.statusid != "") {
                params.del_flag = $scope.statusid;
            }
            if($scope.serveridbackflowId != 'all'){
                params.serverid_backflow_result = $scope.serveridbackflowId
            }
            params.showall0 = $scope.showZero;
            $scope.campListLoading = true;
            $scope.listCondition = ToolService.getChartConditions($filter('translate')("用户生命周期-回流分析") + "-" + eptName, qReport, params);
            var listPM = HttpService.getReportData(qReport, params);
            listPM.then(function(data){
                // ToolService.hideLoading();
                $scope.campListLoading = false;
                $scope.campList = data;
                $scope.infoListTotal = data.val[0];
                $scope.campAllList = data.val.slice(1);
                $scope.campNoZeroList = $scope.campAllList.filter(function(item, index) {
                    return item.isall0 == false;
                });
                // $scope.infoList = $scope.campAllList;
                if ($scope.showZero) {
                    $scope.infoList = $scope.campAllList;
                } else {
                    $scope.infoList = $scope.campNoZeroList;
                }

                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;
            })
        }
        
        //分页
        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;
            $scope.fixrefresh = ++rmd;
        });
    }

})();