(function() {
    angular.module("app.collect")
        .controller("reportCtrl", ["$rootScope", "$scope", "HttpService", "$stateParams", "ToolService", "UtilService", "$filter", exportCtrl]);

    function exportCtrl($rootScope, $scope, HttpService, $stateParams, ToolService, UtilService, $filter) {
        $scope.UserId = $.cookie("ryioUid");
        $scope.query = function() {
            ToolService.showLoading()
            var listPM = HttpService.getInfo("mng/export/report/" + $scope.appid + "/findall");
            listPM.then(function(data) {
                $scope.donwlistData = data;
                ToolService.hideLoading();
            });
        }

        var sinfo = $stateParams.stateinfo;
        if (sinfo == "campaigninfo") {
            $scope.backFlag = 'Setting'
        } else {
            $scope.backFlag = 'downloading';
        }

        $scope.queryReport = function(flag) {
                if (flag) {
                    $scope.backFlag = flag;
                }
                if (angular.isDefined($scope.appid)) {
                    if ($scope.backFlag == 'Setting') {
                        ToolService.showLoading()
                        var setPM = HttpService.getInfo("mng/export/report/" + $scope.appid + "/open/param/list");
                        setPM.then(function(data) {
                            ToolService.hideLoading();
                            $scope.setinglistData = data;

                        })
                    } else if ($scope.backFlag == 'channelSetting') { //下载渠道维度设置
                        ToolService.showLoading()
                        var setPM = HttpService.getInfo("exportgdt/find?app=" + $scope.appid);
                        setPM.then(function(data) {
                            ToolService.hideLoading();
                            $scope.setData = data.status
                        })
                    }
                }

            }
            //下载渠道维度设置接口
        $scope.setChannel = function(status) {
            ToolService.showLoading()
            var setPM = HttpService.getInfo("exportgdt/able?app=" + $scope.appid + "&status=" + status);
            setPM.then(function(data) {
                ToolService.hideLoading();
                $scope.setingChannelData = data;
                $scope.queryReport("channelSetting");
            })
        }
        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage2 = msg;
        });
        $scope.setData = false;
        $scope.setChannelData = function(status) {
            if (status) {
                $scope.setData = status
            } else {
                $scope.setData = false;
            }
            $scope.setChannel($scope.setData)
        }

        $scope.doSetting = function(info) {
            ToolService.sendBehaviorUv("doSetting");
            $scope.setId = info.id;
            $scope.exportName = info.exportName;
            if (info.opened == 0) {
                $scope.setstatus = true;
                $scope.opened = 1
            } else {
                $scope.opened = 0
                $scope.setInfo();
            }
        }
        $scope.setInfo = function() {
            var par = {
                opened: $scope.opened,
                exportName: $scope.exportName,
                id: $scope.setId
            }
            var setItemPM = HttpService.postInfo("mng/export/report/" + $scope.appid + "/open/param", par);
            setItemPM.then(function(data) {
                $scope.setstatus = false;
                $scope.queryReport();
            })

        }
        $scope.doRemove = function(id) {
            ToolService.sendBehaviorUv("doRemove");
            $scope.delstatus = true;
            $scope.delId = id;
        }
        $scope.removeInfo = function() {
            var url = "mng/export/report/" + $scope.appid + "/delete/" + $scope.delId,
                removePM = HttpService.deleteInfo(url);

            ToolService.showLoading();
            $scope.delstatus = false;
            removePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("删除成功"))
                $scope.query();
            });
        }

        //失败刷新
        $scope.downlistRefresh = function(id, flag) {
            if (flag && flag == 1) { //下载刷新
                id = $scope.winID;
            }
            ToolService.showLoading();
            $scope.closeWin();
            HttpService.putInfo("mng/export/report/" + $scope.appid + "/refresh/" + id, {}).then(function(data) {
                $scope.query();
            });
        }
        $scope.closeWin = function() {
                ToolService.hideAlp();
                $scope.wantRefresh = false;
            }
            //下载列表下载文件
        $scope.downlistEvt = function(info) {
            ToolService.sendBehaviorUv("downlistEvt");
            if (info.status != 'complete') { return false; }
            var id = info.id;

            var downPM = HttpService.downFile("mng/export/report/" + $scope.appid + "/download/" + id);
            ToolService.showLoading();
            downPM.then(function(data) {
                ToolService.hideLoading();

                if (data.code == -1) {
                    $scope.wantRefresh = true;
                    $scope.winID = info.id;
                    ToolService.showAlp();
                } else {
                    $rootScope.operSubmitData($filter('translate')("下载"));
                }
            });
        }

        $scope.$watch("appid+lang", function(n) {
            if (angular.isDefined($scope.appid)) {
                $scope.query();
                $scope.queryReport();
            }
        });
    }
})();