(function(){
    angular.module("app.collect")
        .controller("roiCtrl",["$rootScope","$scope","HttpService","ToolService","DateService","$timeout","$filter","UtilService","$location","$anchorScroll","ArrayConstant","$translate",roiCtrl]);

    function roiCtrl($rootScope,$scope,HttpService,ToolService,DateService,$timeout,$filter,UtilService,$location,$anchorScroll,ArrayConstant,$translate){
        $scope.initLoading = function(){
            $scope.roiListLoading = true;
        };
        $scope.initLoading();
        if($rootScope.isSuper || $rootScope.isManage || $rootScope.isAppManage){
            $scope.MainSuper = true;
        }else{
            $scope.MainSuper = false;
        }
        $scope.$on("conentresize",function(){
            $scope.colsStyle = ToolService.getTableColsWidth($scope.roiList.name);
        });
        $scope.isDemo = ToolService.isUser(ArrayConstant.demoEmail);
        if($scope.isDemo){
            $scope.activedate = ToolService.getLastDays(-7);
            $scope.paymentdate = ToolService.getLastDays(-7);
        }else{
            $scope.activedate = ToolService.getLastDays(-1);
            $scope.paymentdate = ToolService.getLastDays(-1);
        }

        //导出提示
        $scope.exportDataAlert = function(){
            ToolService.showTips($filter('translate')("注收比导出功能正在升级，暂时不可用，预计本周六可正常使用。"));
        }

        //控制滚动条
        $scope.gotoDiv = function () {
            $location.hash("installPayDiv");
            $anchorScroll();
        };
        
        $scope.$on('activedate',function(e,msg){
            $scope.activedate = msg;
            $scope.paymentdate = msg;
        });
        $scope.$on('curdate',function(e,msg){
            $scope.activedate = msg.date;
        });
        $scope.$watch("activedate",function(){
            if(angular.isDefined($scope.activedate)){
                $scope.activedatestr = $scope.activedate.startDate + $filter('translate')("至") + $scope.activedate.endDate;
            }
            var install_days = DateService.getDaysNum($scope.activedate.startDate,$scope.activedate.endDate);
            if(install_days < 14){
                $scope.install_intervalInit = 1;
            }else if(install_days >= 14 && install_days < 30){
                $scope.install_intervalInit = 3;
            }else{
                $scope.install_intervalInit = 7;
            }
        });
        
        $scope.$on('paymentdate',function(e,msg){
            $scope.paymentdate = msg;
        });
        $scope.$on('paydate',function(e,msg){
            $scope.paymentdate = msg.date;
        });
        $scope.$watch("paymentdate",function(){
            if(angular.isDefined($scope.paymentdate)){
                $scope.paymentdatestr = $scope.paymentdate.startDate + $filter('translate')("至") + $scope.paymentdate.endDate;
            }
            var payment_days = DateService.getDaysNum($scope.paymentdate.startDate,$scope.paymentdate.endDate);
            if(payment_days < 14){
                $scope.pay_intervalInit = 1;
            }else if(payment_days >= 14 && payment_days < 30){
                $scope.pay_intervalInit = 3;
            }else{
                $scope.pay_intervalInit = 7;
            }
        });

        $scope.TwoList = false;
        $scope.selectFlag = "channel";
        $scope.changeSelectFlag = function(flag){
            ToolService.sendBehaviorUv(flag);
            $scope.selectFlag = flag;
            $scope.searchfreach = ++rmd;
            $scope.filterTxt = "";
            $scope.srhTxt = "";
            $scope.query();
        }

        $scope.timeList = [
            {"id":"relative","name":$filter('translate')("相对时间")},
            {"id":"absolute","name":$filter('translate')("绝对时间")}
        ];

        $scope.$on("timeId",function(e,msg){
            $scope.timeflag = msg.info.id;
        });

        var payList = [];
        if(!$scope.isDemo){
            for(var i=1;i<31;i++){
                payList.push({id:i,name:$filter('translate')("后续付费")+i+$filter('translate')("天")});
            }
            $scope.paymentList = payList;
            $scope.paymentInit = $scope.paymentList[6].id;
        }
        else{
            payList.push({id:1,name:$filter('translate')("后续付费1天")});
            payList.push({id:7,name:$filter('translate')("后续付费")+"7"+$filter('translate')("天")});
            payList.push({id:14,name:$filter('translate')("后续付费")+"14"+$filter('translate')("天")});
            payList.push({id:30,name:$filter('translate')("后续付费")+"30"+$filter('translate')("天")});
            $scope.paymentList = payList;
            $scope.paymentInit = $scope.paymentList[1].id;
        }
        $scope.$on("paymentId",function(e,msg){
            $scope.paymentInval = msg.info.id;
        });

        $scope.querySelectInfos = function(){
            var channelparams = ToolService.getChannelCampaignParams("channel",$scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = $translate.instant("不筛选") + channelparams.txt;
            channelPM.then(function(data){
                //data.unshift({id:"all",name:$scope.channelNameInit});
                $scope.channelList = data;
            });

            var campgroupparams = ToolService.getChannelCampaignParams("campgroup",$scope.appid);
            var campgroupPM = HttpService.getInfo(campgroupparams.url);
            $scope.campgroupNameInit = $translate.instant("不筛选") + campgroupparams.txt;
            campgroupPM.then(function(data){
                data.unshift({id:"all",name:$scope.campgroupNameInit});
                $scope.campgroupList = data;
            });
        }

        $scope.selectlistNum = 0;
        $scope.channelidInit = "all";
        var current = "";
        $scope.$on("channelid",function(e,msg){
            current = "channel";
            $scope.resetList();
            $scope.channelid = msg.info;
            $scope.selectlistNum ++;
            if($scope.channelid == ""){
                $scope.channelid = "all";
            }
        });
        $scope.campgroupInit = "all";
        $scope.$on("campgroupid",function(e,msg){
            current = "campgroup";
            $scope.resetList();
            $scope.campgroupid = msg.info.id;
            $scope.selectlistNum ++;
        });

        $scope.resetList = function(){
            if($scope.selectlistNum>=1){
                var precur = "";
                if($scope.channelid!='all' && current!='channel'){
                    $scope.channelResh = $scope.selectlistNum;
                    $scope.channelid = "all";
                }
                else if($scope.campgroupid!='all' && current!='campgroup'){
                    $scope.campgroupResh = $scope.selectlistNum;
                    $scope.campgroupid = "all";
                }
                //为了等到数据赋值完成再查询
                $timeout(function(){
                    $scope.query();
                },100);
            }
        }




        $scope.$on('flipinfo',function(e,msg){
            if(msg.listkey == 'two'){
                $scope.flipPage2 = msg;
                $scope.fixrefresh2 = ++rmd;
            }
            else{
                $scope.flipPage = msg;
                $scope.fixrefresh = ++rmd;
            }
        });

        $scope.packList = ToolService.getPackTypeList();
        $scope.packageInit = $scope.packList[0].id;
        $scope.$on("packid",function(e,msg){
            $scope.packageID = msg.info.id;
        });

        

        var onePar = {};

        $scope.query = function(){
            var params = {
                appid:$scope.appid,
                install_startdate:$scope.activedate.startDate,
                install_enddate:$scope.activedate.endDate
            };
            params.func = "roi";
            params.datatype = 'list';
            if($scope.filterTxt && $scope.filterTxt!=''){
                params.searchtxt = $scope.filterTxt;
            }

            if(!$scope.isDetail || ($scope.isDetail && $scope.timeflag == 'absolute')){
                params.pay_startdate = $scope.paymentdate.startDate;
                params.pay_enddate = $scope.paymentdate.endDate;
            }
            if($scope.selectFlag == "channel"){
                var report = "roi_bychannel";
            }else{
                var report = "roi_bycampaign";
            }

            if($scope.isDetail){
                report = "roi_byds";
                params.cid = $scope.nextID;
                if($scope.timeflag == 'relative'){
                    params.interval = $scope.paymentInval;
                }
                params.campaignid = $scope.curinfo.campaignid;
            }
            else{

                if($scope.packageID!='all' && $scope.isandroid){
                    params.channelcategory = $scope.packageID;
                }

                if($scope.channelid!='all' && $scope.selectFlag == "channel"){
                    params.cid = $scope.channelid;
                }
                else if($scope.campgroupid!='all' && $scope.selectFlag == "campaign"){
                    params.cgroupid = $scope.campgroupid;
                }
            }
           
            $scope.totalCid = $scope.channelid;

            if($scope.isInfoTotal && $scope.isInfoTotal == "汇总"){
                params.cid = $scope.totalCid;
            }

         
            var listPM = HttpService.getReportData(report, params);
            $scope.roiListLoading = true;
            listPM.then(function(data){
                $scope.TwoList = false;
                $scope.roiList = data;
                if($scope.isandroid){
                    $scope.doPackFilter();
                }else{
                    $scope.infoList = data.val;
                }

                $scope.sortCol = "";
                $scope.roiListLoading = false;

                $scope.initrefresh = ++rmd;
                $scope.fixrefresh = ++rmd;

                $scope.searchTxt = "";
                
                var install_days = DateService.getDaysNum($scope.activedate.startDate,$scope.activedate.endDate);
                //重置下拉时间
                if(install_days <= 6){
                    switch (install_days){
                    case 0:
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")}
                        ];
                        break;
                    case 1:
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")}
                        ];
                        break;
                    case 2:
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")}
                        ];
                        break;
                    case 3:
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")}
                        ];
                        break;
                    case 4:
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")}
                        ];
                        break;
                    case 5:
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")}
                        ];
                        break;
                    case 6:
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")}
                        ];
                        break;
                    }
                }else{
                    if(install_days > 6 && install_days < 14){
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")}
                        ];
                    }else if(install_days >=14 && install_days < 29){
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")},
                            {id:15,name:"15"+$filter('translate')("天")}
                        ];
                    }else{
                        $scope.dayList = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")},
                            {id:15,name:"15"+$filter('translate')("天")},
                            {id:30,name:"30"+$filter('translate')("天")}
                        ];
                    }
                }
                var date1 = 0;
                if(install_days < 14){
                    date1 = 1;
                }else if(install_days >= 14 && install_days < 30){
                    date1 = 3;
                }else{
                    date1 = 7;
                }
                var payment_days = DateService.getDaysNum($scope.paymentdate.startDate,$scope.paymentdate.endDate);
                var date2 = 0;

                //重置下拉时间
                if(payment_days <= 6){
                    switch (payment_days){
                    case 0:
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")}
                        ];
                        break;
                    case 1:
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")}
                        ];
                        break;
                    case 2:
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")}
                        ];
                        break;
                    case 3:
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")}
                        ];
                        break;
                    case 4:
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")}
                        ];
                        break;
                    case 5:
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")}
                        ];
                        break;
                    case 6:
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")}
                        ];
                        break;
                    }
                }else{
                    if(payment_days > 6 && payment_days < 14){
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")}
                        ];
                    }else if(payment_days >=14 && payment_days < 29){
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")},
                            {id:15,name:"15"+$filter('translate')("天")}
                        ];
                    }else{
                        $scope.dayList2 = [
                            {id:1,name:$filter('translate')("1天")},
                            {id:2,name:"2"+$filter('translate')("天")},
                            {id:3,name:"3"+$filter('translate')("天")},
                            {id:4,name:"4"+$filter('translate')("天")},
                            {id:5,name:"5"+$filter('translate')("天")},
                            {id:6,name:"6"+$filter('translate')("天")},
                            {id:7,name:"7"+$filter('translate')("天")},
                            {id:15,name:"15"+$filter('translate')("天")},
                            {id:30,name:"30"+$filter('translate')("天")}
                        ];
                    }
                }
                if(payment_days < 14){
                    date2 = 1;
                }else if(payment_days >= 14 && payment_days < 30){
                    date2 = 3;
                }else{
                    date2 = 7;
                }

                params.install_interval = date1;
                params.pay_interval = date2;
                params.subType = 1;
                onePar = params;
                $scope.colsStyle = ToolService.getTableColsWidth(data.name);
                $scope.listCondition = ToolService.getChartConditions($filter('translate')("注收比"),report,params);
            });
        }

        $scope.dayList = [
            {id:1,name:$filter('translate')("1天")},
            {id:2,name:"2"+$filter('translate')("天")},
            {id:3,name:"3"+$filter('translate')("天")},
            {id:4,name:"4"+$filter('translate')("天")},
            {id:5,name:"5"+$filter('translate')("天")},
            {id:6,name:"6"+$filter('translate')("天")},
            {id:7,name:"7"+$filter('translate')("天")},
            {id:15,name:"15"+$filter('translate')("天")},
            {id:30,name:"30"+$filter('translate')("天")}
        ];
        $scope.dayList2 = [
            {id:1,name:$filter('translate')("1天")},
            {id:2,name:"2"+$filter('translate')("天")},
            {id:3,name:"3"+$filter('translate')("天")},
            {id:4,name:"4"+$filter('translate')("天")},
            {id:5,name:"5"+$filter('translate')("天")},
            {id:6,name:"6"+$filter('translate')("天")},
            {id:7,name:"7"+$filter('translate')("天")},
            {id:15,name:"15"+$filter('translate')("天")},
            {id:30,name:"30"+$filter('translate')("天")}
        ];
        $scope.$on("installDate",function(e,msg){
            $scope.installDate = msg.info.id;
        });
        $scope.$on("payDate",function(e,msg){
            $scope.payDate = msg.info.id;
        });

        $scope.$watch("installDate+payDate",function(n){
            if(angular.isDefined(n)){
                $scope.queryLtst(objStr);  
                        
            }
        });

        var objStr = {};
        $scope.queryLtst = function(obj){
            ToolService.sendBehaviorUv("paidlist");
            objStr = obj;
            $scope.channelCidName = obj.cid;
            $scope.campaignIdName = obj.campaignname;
            $scope.TwoList = true;
            if($scope.appid == undefined){ return false;}
            var params = {
                appid:$scope.appid,
                install_startdate:$scope.activedate.startDate,
                install_enddate:$scope.activedate.endDate
            };
            params.func = "roi";
            params.datatype = 'list';
            if(!$scope.isDetail || ($scope.isDetail && $scope.timeflag == 'absolute')){
                params.pay_startdate = $scope.paymentdate.startDate;
                params.pay_enddate = $scope.paymentdate.endDate;
            }

            params.install_interval = $scope.installDate;
            params.pay_interval = $scope.payDate;

            if($scope.installDate == "" || $scope.installDate == null){
                return false;
            }
            if($scope.payDate == "" || $scope.payDate == null){
                return false;
            }

            var report = "roi_byinterval";
            if($scope.selectFlag == "channel"){
                params.cid = obj.id;
                if(obj.cid == "汇总"){
                    params.cid = $scope.totalCid;       //汇总的时候传cid
                  
                }
            }else{
                if(obj.campaignid != $filter('translate')("汇总")){
                    params.campaignid = obj.campaignid;
                }else{
                    // params.cid=$scope.campgroupid;
                    if($scope.campgroupid != "all"){
                        params.cgroupid=$scope.campgroupid;
                    }
                    params.searchtxt = $scope.filterTxt;
                  
                }
            }
            $scope.chargelistCondition = ToolService.getChartConditions($filter('translate')("注收比"),report,params);
            var listPM = HttpService.getReportData(report, params);
            $scope.installPayLoading = true;
            listPM.then(function(data){
                $scope.installPay = data;
                $scope.installPayList = data.val;
                $scope.installPayLoading = false;

                $scope.gotoDiv();

                $scope.initrefresh2 = ++rmd;
                $scope.fixrefresh2 = ++rmd;
                $scope.colsStyleList = ToolService.getTableColsWidth(data.name);
                onePar.install_interval = $scope.installDate;
                onePar.pay_interval = $scope.payDate;
                onePar.subType = 2;
                if($scope.selectFlag == "channel"){
                    var reportOne = "roi_bychannel";
                    if(obj.cid == "汇总"){
                        var reportOne = "roi_byinterval";
                    }
                }else{
                    var reportOne = "roi_bycampaign";
                    if(obj.campaignid == "汇总"){
                        var reportOne = "roi_byinterval";
                    }
                }
                $scope.installPayListCondition = ToolService.getChartConditions($filter('translate')("注册/付费详情"),reportOne,onePar);
                $scope.chargePayListCondition = ToolService.getChartConditions($filter('translate')("注收比-激活/付费详情"),reportOne,onePar);
            });
        }



        $scope.filterByTxt = function(txt){
            $scope.filterTxt = txt;
            $scope.query(); 
        }
        $scope.clickSub = function(info,obj){
            ToolService.sendBehaviorUv("clickSub");
            if(!info){
                var target = obj.target,data = target.getAttribute('data');
                info = $.parseJSON(data);
            }
            $scope.nextID = info.id;
            if(info.istotal){return;}
            if($scope.isDetail == true){return false;}

            $scope.curinfo = info;
            $scope.curname = info[$scope.roiList.columnkey[0]];
            $scope.isDetail = true;
            $scope.isInfoTotal = info.cid;
            $scope.query();
           
        }
        $scope.preList = function(){
            $scope.isDetail = false;
            $scope.query();
        }
        var orderBy = $filter('orderBy'),rmd = new Date().getTime();
        $scope.sortCol = "";
        $scope.order = function(predicate, reverse) {
            $scope.sortCol = predicate;
            $scope.infoList = orderBy($scope.infoList, predicate, reverse);
            $scope.listf5 = ++rmd;
            $scope.fixrefresh = ++rmd;
        };
        $scope.doPackFilter = function(){
            $scope.infoList = $scope.roiList.val.filter(function(item){
                return (item.ispackchannel == ($scope.packageID == 'APPMARKET')) || $scope.packageID=='all';
            });
            $scope.fixrefresh = ++rmd;
        }
        $scope.$watch("packageID",function(n){
            if(angular.isDefined(n) && $scope.infoList && $scope.isandroid){
                $scope.doPackFilter();
            }
        });

        $scope.$watch("{aStartDate:activedate.startDate,aEndDate:activedate.endDate,startDate:paymentdate.startDate,endDate:paymentdate.endDate,appid:appid,lang:lang}",function(n,o){
            if(angular.isUndefined($scope.appid) || angular.isUndefined($scope.activedate) || angular.isUndefined($scope.paymentdate)){return false;}
            $scope.query();
            if(n.appid){
                $scope.timeInit = $scope.timeList[1].id;
                $scope.isDetail = false;
                $scope.selectlistNum = 0;
                $scope.querySelectInfos();
            }
            //语言切换
            if(n.lang && o.lang && n.lang!==o.lang){
                $scope.activedatestr = $scope.activedate.startDate + $translate.instant("至") + $scope.activedate.endDate;
                $scope.paymentdatestr = $scope.paymentdate.startDate + $translate.instant("至") + $scope.paymentdate.endDate;
                $scope.querySelectInfos();
            }
        },true);

        $scope.$watch("paymentInval+timeflag",function(){
            if($scope.isDetail){
                $scope.query();
            }
        });

    }
})();
