(function() {
    angular.module("app.collect")
        .controller("systemparamCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "$filter", systemparamCtrl]);

    function systemparamCtrl($scope, $rootScope, HttpService, ToolService, $filter) {
        /**
         * 语言切换
         */
        $scope.$watch("{appid:appid,lang:lang}", function(n, o) {
            if (angular.isUndefined($scope.appid)) {
                return false;
            }
            $scope.querySP();
            if(n && o && n!==o){
                $scope.initData();
            }
        });
        $scope.querySP = function() {
            var infoPM = HttpService.getInfo("mng/systemparam/"+$scope.appid+"/find");
            ToolService.showLoading();
            infoPM.then(function(data) {
                ToolService.hideLoading();
                $scope.id = data.id;
                $scope.clickDay = $scope.clickDayInit = data.clickDay;
                $scope.installDay = $scope.installDayInit = data.installDay == -1 ? 0 : data.installDay;
                $scope.ciDay = $scope.ciDayInit = data.ciDay;
                $scope.WakeDay = $scope.WakeDayInit = data.arouseDay ? data.arouseDay : 30;
                $scope.cilag = $scope.cilagInit = data.cilag
                $scope.normalinstall = $scope.normalinstallInit = data.normalinstall;
                $scope.normalclick = $scope.normalclickInit = data.normalclick;
            });
        }
        

        $scope.initData = function() {
            $scope.dayList = [
                { id: 1, name: $filter('translate')("1天") },
                { id: 2, name: "2" + $filter('translate')("天") },
                { id: 3, name: "3" + $filter('translate')("天") },
                { id: 4, name: "4" + $filter('translate')("天") },
                { id: 5, name: "5" + $filter('translate')("天") },
                { id: 6, name: "6" + $filter('translate')("天") },
                { id: 7, name: "7" + $filter('translate')("天") },
                { id: 15, name: "15" + $filter('translate')("天") },
                { id: 30, name: "30" + $filter('translate')("天") }
            ];

            $scope.installDayList = [
                { id: 1, name: $filter('translate')("1天") },
                { id: 2, name: "2" + $filter('translate')("天") },
                { id: 3, name: "3" + $filter('translate')("天") },
                { id: 4, name: "4" + $filter('translate')("天") },
                { id: 5, name: "5" + $filter('translate')("天") },
                { id: 6, name: "6" + $filter('translate')("天") },
                { id: 7, name: "7" + $filter('translate')("天") },
                { id: 15, name: "15" + $filter('translate')("天") },
                { id: 30, name: "30" + $filter('translate')("天") },
                { id: 60, name: "60" + $filter('translate')("天") },
                { id: 90, name: "90" + $filter('translate')("天") },
                { id: 183, name: $filter('translate')("半年(183天)") },
                { id: 365, name: $filter('translate')("一年(365天)") },
                { id: 0, name: $filter('translate')("永久") }
            ];

            $scope.WakeDayList = [
                { id: 1, name: $filter('translate')("1天") },
                { id: 2, name: "2" + $filter('translate')("天") },
                { id: 3, name: "3" + $filter('translate')("天") },
                { id: 4, name: "4" + $filter('translate')("天") },
                { id: 5, name: "5" + $filter('translate')("天") },
                { id: 6, name: "6" + $filter('translate')("天") },
                { id: 7, name: "7" + $filter('translate')("天") },
                { id: 15, name: "15" + $filter('translate')("天") },
                { id: 30, name: "30" + $filter('translate')("天") },
            ];

            $scope.flagList = [
                { id: 1, name: $filter('translate')("小于") + '1' + $filter('translate')("秒") },
                { id: 2, name: $filter('translate')("小于") + '2' + $filter('translate')("秒") },
                { id: 5, name: $filter('translate')("小于") + '5' + $filter('translate')("秒") },
                { id: 10, name: $filter('translate')("小于") + '10' + $filter('translate')("秒") },
                { id: 30, name: $filter('translate')("小于") + '30' + $filter('translate')("秒") },
                { id: 60, name: $filter('translate')("小于") + '60' + $filter('translate')("秒") },
                { id: 120, name: $filter('translate')("小于") + '2' + $filter('translate')("分钟") },
                { id: 180, name: $filter('translate')("小于") + '3' + $filter('translate')("分钟") },
                { id: 240, name: $filter('translate')("小于") + '4' + $filter('translate')("分钟") },
                { id: 300, name: $filter('translate')("小于") + '5' + $filter('translate')("分钟") },
                { id: 360, name: $filter('translate')("小于") + '6' + $filter('translate')("分钟") },
                { id: 420, name: $filter('translate')("小于") + '7' + $filter('translate')("分钟") },
                { id: 480, name: $filter('translate')("小于") + '8' + $filter('translate')("分钟") },
                { id: 540, name: $filter('translate')("小于") + '9' + $filter('translate')("分钟") },
                { id: 600, name: $filter('translate')("小于") + '10' + $filter('translate')("分钟") },
                { id: 999, name: $filter('translate')("无限制") }
            ];

            $scope.normalList = [
                { id: 1, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "1" : "1" + $filter('translate')("个以上") },
                { id: 2, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "2" : "2" + $filter('translate')("个以上") },
                { id: 3, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "3" : "3" + $filter('translate')("个以上") },
                { id: 4, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "4" : "4" + $filter('translate')("个以上") },
                { id: 5, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "5" : "5" + $filter('translate')("个以上") },
                { id: 10, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "10" : "10" + $filter('translate')("个以上") },
                { id: 15, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "15" : "15" + $filter('translate')("个以上") },
                { id: 20, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "20" : "20" + $filter('translate')("个以上") },
                { id: 25, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "25" : "25" + $filter('translate')("个以上") },
                { id: 30, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "30" : "30" + $filter('translate')("个以上") },
                { id: 50, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "50" : "50" + $filter('translate')("个以上") },
                { id: 70, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "70" : "70" + $filter('translate')("个以上") },
                { id: 100, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "100" : "100" + $filter('translate')("个以上") },
                { id: 150, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "150" : "150" + $filter('translate')("个以上") },
                { id: 200, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "200" : "200" + $filter('translate')("个以上") },
                { id: 300, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "300" : "300" + $filter('translate')("个以上") },
                { id: 500, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "500" : "500" + $filter('translate')("个以上") },
                { id: 50000, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "50000" : "50000" + $filter('translate')("个以上") }
            ];
            $scope.normalList2 = [
                { id: 1, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "1" : "1" + $filter('translate')("个以上") },
                { id: 2, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "2" : "2" + $filter('translate')("个以上") },
                { id: 3, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "3" : "3" + $filter('translate')("个以上") },
                { id: 4, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "4" : "4" + $filter('translate')("个以上") },
                { id: 5, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "5" : "5" + $filter('translate')("个以上") },
                { id: 10, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "10" : "10" + $filter('translate')("个以上") },
                { id: 15, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "15" : "15" + $filter('translate')("个以上") },
                { id: 20, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "20" : "20" + $filter('translate')("个以上") },
                { id: 25, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "25" : "25" + $filter('translate')("个以上") },
                { id: 30, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "30" : "30" + $filter('translate')("个以上") },
                { id: 50, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "50" : "50" + $filter('translate')("个以上") },
                { id: 70, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "70" : "70" + $filter('translate')("个以上") },
                { id: 100, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "100" : "100" + $filter('translate')("个以上") },
                { id: 150, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "150" : "150" + $filter('translate')("个以上") },
                { id: 200, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "200" : "200" + $filter('translate')("个以上") },
                { id: 300, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "300" : "300" + $filter('translate')("个以上") },
                { id: 500, name: $rootScope.lang == 'en' ? $filter('translate')("个以上") + "500" : "500" + $filter('translate')("个以上") }
            ];
        }

        $scope.initData();

        $scope.$on("clickDay", function(e, msg) {
            $scope.clickDay = msg.info.id;
        });
        $scope.$on("ciDay", function(e, msg) {
            $scope.ciDay = msg.info.id;
        });

        $scope.$on("installDay", function(e, msg) {
            $scope.installDay = msg.info.id;
        });

        $scope.$on("WakeDay", function(e, msg) {
            $scope.aWakeDay = msg.info.id;
        });


        $scope.$on("cilag", function(e, msg) {
            $scope.cilag = msg.info.id;
        });

        $scope.normalList = [
            { id: 1, name: "1个以上" },
            { id: 2, name: "2个以上" },
            { id: 3, name: "3个以上" },
            { id: 4, name: "4个以上" },
            { id: 5, name: "5个以上" },
            { id: 10, name: "10个以上" },
            { id: 15, name: "15个以上" },
            { id: 20, name: "20个以上" },
            { id: 25, name: "25个以上" },
            { id: 30, name: "30个以上" },
            { id: 50, name: "50个以上" },
            { id: 70, name: "70个以上" },
            { id: 100, name: "100个以上" },
            { id: 150, name: "150个以上" },
            { id: 200, name: "200个以上" },
            { id: 300, name: "300个以上" },
            { id: 500, name: "500个以上" },
            { id: 50000, name: "50000个以上" }
        ];
        $scope.normalList2 = [
            { id: 1, name: "1个以上" },
            { id: 2, name: "2个以上" },
            { id: 3, name: "3个以上" },
            { id: 4, name: "4个以上" },
            { id: 5, name: "5个以上" },
            { id: 10, name: "10个以上" },
            { id: 15, name: "15个以上" },
            { id: 20, name: "20个以上" },
            { id: 25, name: "25个以上" },
            { id: 30, name: "30个以上" },
            { id: 50, name: "50个以上" },
            { id: 70, name: "70个以上" },
            { id: 100, name: "100个以上" },
            { id: 150, name: "150个以上" },
            { id: 200, name: "200个以上" },
            { id: 300, name: "300个以上" },
            { id: 500, name: "500个以上" }
        ];
        $scope.$on("normalinstall", function(e, msg) {
            $scope.normalinstall = msg.info.id;
        });
        $scope.$on("normalclick", function(e, msg) {
            $scope.normalclick = msg.info.id;
        });

        $scope.setDoflag = 0;
        $scope.setDefault = function(flag) {
            ToolService.sendBehaviorUv("setDefault");
            $scope.setDoflag = flag;
            $scope.defaultStatus = true;
        }

        var rmd = new Date().getTime();
        $scope.defaultData = function() {
            var flag = $scope.setDoflag;
            if (flag == 1) {
                $scope.clickDayInit = 30;
                $scope.clickDay = 30;
                $scope.installDayInit = 30;
                $scope.installDay = 30;
                $scope.aWakeDay = $scope.WakeDayInit = 30;
                $scope.ciDayInit = 7;
                $scope.ciDay = 7;
                $scope.datafresh = ++rmd;
            } else if (flag == 2) {
                $scope.cilagInit = 5;
                $scope.cilag = 5;
                $scope.normalinstallInit = 30;
                $scope.normalinstall = 30;
                $scope.normalclickInit = 30;
                $scope.normalclick = 30;
                $scope.excepfresh = ++rmd;
            }
            $scope.defaultStatus = false;
            $scope.save();
        };
        $scope.save = function() {
            ToolService.sendBehaviorUv("save");
            var par = {
                app:$scope.appid,
                clickDay: $scope.clickDay,
                installDay: $scope.installDay == 0 ? -1 : $scope.installDay,
                ciDay: $scope.ciDay,
                cilag: $scope.cilag,
                normalinstall: $scope.normalinstall,
                normalclick: $scope.normalclick,
                id: $scope.id,
                arouseDay: $scope.aWakeDay
            }

            var savePM = HttpService.putInfo("mng/systemparam/update", par);
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("修改成功"))
            });
        }
        
    }

})();