(function () {
    angular.module("app.collect")
        .controller("terminalattributesCtrl", ["$rootScope", "$scope", "HttpService", "UtilService", "ToolService", "DateService", "$filter", "$translate", "$timeout", terminalattributesCtrl]);

    function terminalattributesCtrl($rootScope, $scope, HttpService, UtilService, ToolService, DateService, $filter, $translate, $timeout) {
        $scope.$on('curdate', function (e, msg) {
            $scope.date = msg.date;
        });

        $scope.querySelectInfos = function () {
            $translate(["不筛选", "自然量"]).then(function (translations) {
                $scope.initSelects(translations["不筛选"], translations["自然量"]);
            }, function (tranIds) {
                $scope.initSelects(tranIds["不筛选"], tranIds["自然量"]);
            });
        }

        $scope.initSelects = function (noFilter, nat) {
            var channelparams = ToolService.getChannelCampaignParams("channel", $scope.appid);
            var channelPM = HttpService.getInfo(channelparams.url);
            $scope.channelNameInit = noFilter + channelparams.txt;
            channelPM.then(function (data) {
                if (!(!$rootScope.isall && $rootScope.curRoleAuth && !$rootScope.curRoleAuth.isNatureOpen)) {
                    data.unshift({
                        id: "-1",
                        name: nat
                    });
                }
                $scope.channelList = data;
            });

            var campgroupparams = ToolService.getChannelCampaignParams("campgroup", $scope.appid);
            var campgroupPM = HttpService.getInfo(campgroupparams.url);
            $scope.campgroupNameInit = noFilter + campgroupparams.txt;
            $scope.campgroupInits = noFilter + campgroupparams.txt;
            campgroupPM.then(function (data) {
                data.unshift({
                    id: "all",
                    name: $scope.campgroupNameInit
                });
                $scope.campgroupList = data;
                $scope.campgroupLists = $scope.campgroupList.filter(function (value) {
                    return value.id != 'all'
                });
            });

            var campaignparams = ToolService.getChannelCampaignParams("campaign", $scope.appid);
            var campaignPM = HttpService.getInfo($scope.appid + "/campaign/dropdown");
            $scope.campaignNameInit = noFilter + campaignparams.txt;
            campaignPM.then(function (data) {
                $scope.campaignListTotal = data;
                var data = data.data;
                data.unshift({
                    id: "all",
                    name: $scope.campaignNameInit
                });
                data.filter(function (item) {
                    item.uid = item.id;
                    item.id = item.campaignid;
                });
                $scope.campaignList = data;
                $scope.campaignListAll = data;
            });
        }
        $scope.selectlistNum = 0;
        var current = "";
        $scope.$on("channelid", function (e, msg) {
            current = "channel";
            $scope.resetList();
            $scope.channelid = msg.info;
            $scope.selectlistNum++;
        });

        $scope.campgroupInit = "all";
        $scope.$on("campgroupid", function (e, msg) {
            current = "campgroup";
            $scope.resetList();
            $scope.campgroupid = msg.info.id;
            $scope.selectlistNum++;
        });

        $scope.campaignInit = "all";
        $scope.$on("campaignid", function (e, msg) {
            current = "campaign";
            $scope.resetList();
            $scope.campaignid = msg.info.id;
            $scope.selectlistNum++;
        });

        $scope.clearTxtId = "clearTxtId";
        $scope.$on($scope.clearTxtId, function (event, data) {
            $scope.campaignList = $scope.campaignListAll
        })
        
        $scope.$on($scope.elementInfo, function (e, msg) {
            if(!$scope.isChartShow1 && msg.title == "arealdistribution"){
                $scope.active = "province";
                $scope.singleUseTimeQuery($scope.par)
            }
        })
    
        $scope.searchTextId = "searchTextId";
        $scope.$on($scope.searchTextId, function (event, data) {
            if (!data) {
                return false
            }
            var Pm = HttpService.getInfo($scope.appid + "/campaign/dropdown?name=" + data);
            Pm.then(function (data) {
                if (data && data.data) {
                    var dataList = data.data;
                    dataList.filter(function (item) {
                        item.uid = item.id;
                        item.id = item.campaignid;
                    });
                    $scope.campaignList = dataList
                }

            });

        });
        $scope.resetList = function () {
            if ($scope.selectlistNum >= 1) {
                var precur = "";
                if ($scope.channelid != '' && current != 'channel') {
                    $scope.channelResh = $scope.selectlistNum;
                    $scope.channelid = "";
                } else if ($scope.campgroupid != 'all' && current != 'campgroup') {
                    $scope.campgroupResh = $scope.selectlistNum;
                    $scope.campgroupid = "all";
                } else if ($scope.campaignid != 'all' && current != 'campaign') {
                    $scope.campaignResh = $scope.selectlistNum;
                    $scope.campaignid = "all";
                }

                //为了等到数据赋值完成再查询
                $timeout(function () {
                    $scope.query();
                }, 100);
            }
        }
        $scope.active = "province";
        $scope.clickCity = function (item) {
            $scope.active = item.id;
            $scope.singleUseTimeQuery($scope.par)
        }

        $scope.networkActive = "2";
        $scope.clickNetwork = function (item) {
            $scope.networkActive = item.id;
            $scope.terminalattributesNetworkQuery($scope.par)
        }
        $scope.$watch("date.startDate+date.endDate", function () {
            if (angular.isDefined($scope.date)) {
                $scope.query();
            }
        });
        $scope.$watch("{appid:appid,lang:lang}", function (n, o) {
            if (angular.isUndefined($scope.appid)) {
                return false;
            }
            $scope.querySelectInfos();

            if (n && o && n !== o) {
                $scope.query();
            }
        });

        $scope.report = [{name: 'terminalattributes_province_by',name2: 'terminalattributes_city_by',title: '地域分布',mapCategoryData: [{id: "city",name: "城市"}, {id: "province",name: "省份"}]},
            {name: 'terminalattributes_devicemodel_by',title: '机型分布'},
            {name: 'terminalattributes_osversion_by',title: '操作系统版本分布'},
            {name: 'terminalattributes_network_type_by',name2: 'terminalattributes_carrier_by',title: '网络环境及运营商分布',terminaNetworkList: [{id: "1",name: "网络环境"}, {id: "2",name: "运营商"}]},]
        var color5 = ["#5D9FF0", "#A0E1F5", "#F8A20F", "#FBD799", "#00B37F", "#93DFC9", "#F9593A", "#FCC2B7", "#5F97FB", '#ca8622'];
        var opacity = 0.1;
        $scope.query = function () {
            if (angular.isUndefined($scope.appid)) {
                return false;
            }
            var params = {
                startdate: $scope.date.startDate,
                enddate: $scope.date.endDate,
                appid: $scope.appid,
                datatype: 'chart',
                viewtype: 'chart',
                func: 'terminal'
            }
            if ($scope.channelid != '') {
                params.cid = $scope.channelid;
            } else if ($scope.campgroupid != 'all') {
                params.cgroupid = $scope.campgroupid;
            } else if ($scope.campaignid != 'all') {
                params.campaignid = $scope.campaignid;
            }
            $scope.par = params;
            $scope.singleUseTimeQuery(params)
            $scope.modelDistributionQuery(params)
            $scope.operatingSystemQuery(params)
            $scope.terminalattributesNetworkQuery(params)
        }
       
        $scope.singleUseTimeQuery = function (params) {
            var reportName = $scope.report[0].name2;
            var sTitle = "(城市)";
            if ($scope.active != 'city') {
                reportName = $scope.report[0].name;
                sTitle = "(省份)";
            }
            $scope.singleUseTimeConfig = {
                color: color5,
                opacity: opacity
            };
            var singleUseTimePM = HttpService.getReportData(reportName + 'date', params);
            $scope.singleUseTimeLoading = true;
            singleUseTimePM.then(function (data) {
                $scope.singleUseTimeLoading = false;
                $scope.mapData = data;
            });
            var params1 = JSON.parse(JSON.stringify(params));
            params1.viewtype = 'list'
            var singleUseTimeListPM = HttpService.getReportData(reportName + 'date', params1);
            singleUseTimeListPM.then(function (data) {
                $scope.singleUseTimeTableData = data;
                $scope.singleUseTimeDataCondition = ToolService.getChartConditions($filter('translate')("终端属性-") + $scope.report[0].title + sTitle, reportName + 'date', params1);
            });
        }
        // 机型分布
        $scope.modelDistributionQuery = function (params) {
            var color = ["#1FB9E9"]
            $scope.modelDistributionConfig = {
                color: color,
                opacity: opacity
            };
            var modelDistributionPM = HttpService.getReportData($scope.report[1].name + 'date', params);
            $scope.modelDistributionLoading = true;
            modelDistributionPM.then(function (data) {
                $scope.modelDistributionData = data;
                $scope.modelDistributionLoading = false;
            });
            var params1 = JSON.parse(JSON.stringify(params));
            params1.viewtype = 'list'
            var singleUseTimeListPM = HttpService.getReportData($scope.report[1].name + 'date', params1);
            singleUseTimeListPM.then(function (data) {
                $scope.modelDistributionData2 = data;
                $scope.modelDistributionDataCondition = ToolService.getChartConditions($filter('translate')("终端属性-") + $scope.report[1].title, $scope.report[1].name + 'date', params1);
            });
        }
        // 操作系统
        $scope.operatingSystemQuery = function (params) {
            var color = ["#F8A20F"]
            $scope.operatingSystemConfig = {
                color: color,
                opacity: opacity
            };
            var operatingSystemPM = HttpService.getReportData($scope.report[2].name + 'date', params);
            $scope.modelDistributionLoading = true;
            operatingSystemPM.then(function (data) {
                $scope.operatingSystemData = data;
                $scope.modelDistributionLoading = false;
            });
            var params1 = JSON.parse(JSON.stringify(params));
            params1.viewtype = 'list'
            var operatingSystemListPM = HttpService.getReportData($scope.report[2].name + 'date', params1);
            operatingSystemListPM.then(function (data) {
                $scope.operatingSystemData2 = data;
                $scope.operatingSystemDataCondition = ToolService.getChartConditions($filter('translate')("终端属性-") + $scope.report[2].title, $scope.report[2].name + 'date', params1);
            });
        }
        // 网络环境及运营商分布
        $scope.terminalattributesNetworkQuery = function (params) {
            var color = ["#c27ef3"]

            $scope.networkConfig = {
                color: color,
                opacity: opacity
            };
            var reName = $scope.report[3].name2;
            var stitle = "运营商";
            if ($scope.networkActive != '2') {
                reName = $scope.report[3].name;
                stitle = "网络环境"
            }
            var networkPM = HttpService.getReportData(reName + 'date', params);
            $scope.networkLoading = true;
            networkPM.then(function (data) {
                $scope.networkData = data;
                $scope.networkLoading = false;
            });
            var params1 = JSON.parse(JSON.stringify(params));
            params1.viewtype = 'list'

            var networkListPM = HttpService.getReportData(reName + 'date', params1);
            networkListPM.then(function (data) {
                $scope.networkData2 = data;
                $scope.networkDataCondition = ToolService.getChartConditions($filter('translate')("终端属性-") + stitle, reName + 'date', params1);
            });
        }
    }

})();