(function() {
    angular.module("app.collect")
        .controller("useroverviewCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "$filter","DateService", useroverviewCtrl]);

    function useroverviewCtrl($scope, $rootScope, HttpService, ToolService, $filter, DateService) {
        $scope.dsclickLoading = true;
        $scope.$watch("date.startDate+date.endDate+appid", function (n) {
            if (angular.isDefined($scope.appid)) {
                $scope.getData();
                $scope.getChartData();
            }
        });
        //时间控件
        $scope.beginDate = DateService.getDay(0);
        $scope.timeflag = 'yesday';
        $scope.$on("beginDate",function(e,msg){
            $scope.beginDate = msg;
            if(msg == DateService.getDay(0)){
                $scope.timeflag = 'today';
            } else if (msg == DateService.getDay(-1)) {
                $scope.timeflag = 'yesday';
            }
            $scope.getData();
            $scope.getChartData();
        });
        $scope.changeDate = function(flag) {
            if(flag == 'today'){
                $scope.beginDate = DateService.getDay(0);
            } else {
                $scope.beginDate = DateService.getDay(-1);
            }
            $scope.timeflag = flag;
            $scope.getData();
            $scope.getChartData();
        }


        //生命周期概览
        $scope.getData = function(){
            var qReport = "user_life_cycle_overview";
            var params = ToolService.getParams($scope);
            params.datatype="list";
            params.viewtype = "date";
            params.func="user_life_cycle";
            params.startdate=$scope.beginDate;
            delete params.enddate;
            ToolService.showLoading()
            var listPM = HttpService.getReportData(qReport, params);
            listPM.then(function(data){
                ToolService.hideLoading();
                $scope.dataList = data.val[0];
            })
        }

        //用户趋势
        $scope.getChartData = function(){
            var colors = ["#569AFF","#43D9FF","#30D6AE","#FF9581"];
            $scope.clickConfig = {color:colors,smooth:false,lineWidth:2};
            var params = ToolService.getParams($scope);
            var qReport = "user_life_cycle_month_top";
            params.datatype="chart";
            params.func="user_life_cycle";
            params.startdate=$scope.beginDate;
            params.enddate = $scope.beginDate;
            var listPM = HttpService.getReportData(qReport, params);
            ToolService.showLoading()
            $scope.clickLoading = true;
            listPM.then(function(data){
                ToolService.hideLoading();
                $scope.clickData = data;
                $scope.clickLoading = false;
            })
        }

        $scope.goSettings = function(){
            $scope.goPage("collect.lifesettings");
        }
    }
})();