(function() {
    angular.module("app.home")
        .controller("homeCtrl", ["$scope", "OptionService", "UtilService", "$interval", "HttpService", "$rootScope", "ToolService", "$interval", "$translate", "$filter", "$translateCookieStorage", "$location", homeCtrl]);

    function homeCtrl($scope, OptionService, UtilService, $interval, HttpService, $rootScope, ToolService, $interval, $translate, $filter, $translateCookieStorage, $location) {
        $scope.lang = $translateCookieStorage.get("lang");
       
        //loading加载
        $scope.showLoading = function() {
            document.getElementById("sysLoad").style.display = "block";
        }
        $scope.hideLoading = function() {
            document.getElementById("sysLoad").style.display = "none";
        }
        $rootScope.docDomain = 'http://docs.trackingio.com/'
        if(document.domain == 'tweb.trackingio.com'){
            $rootScope.docDomain = 'http://doc.trackingio.com/' 
        }

        function getQueryVariable(variable)
        {
            var query = window.location.search.substring(1);
            var vars = query.split("&");
            for (var i=0;i<vars.length;i++) {
                var pair = vars[i].split("=");
                if(pair[0] == variable){return pair[1];}
            }
            return(false);
        }
        $scope.activeChannel = getQueryVariable('channel')
        /*
         * 根据域名判断显示logo 
         * doMainType:0 显示trackingio的logo
         * doMainType:1 显示新华频媒的logo
         */
        $rootScope.doMainType = 0;
        $scope.doMain = function() {
            var urltype = $location.host();
            var urlHost = "";
            if (urltype == "hyxd.trackingio.com") {
                urlHost = urltype;
                $rootScope.doMainType = 1;
                UtilService.setCookie("sys_domain", urlHost, 7);
                var otherInfoPM = HttpService.getInfo('logo/dic', { domain: urlHost }, true);
                otherInfoPM.then(function(data) {
                        $rootScope.otherCompanyInfo = data;
                    })
            } else {
                urlHost = urltype;
                $rootScope.doMainType = 0;
                UtilService.setCookie("sys_domain", urlHost, 7);
            }

        }
        $scope.doMain();
        $scope.sendEve = function() {
            ToolService.sendBehaviorUv("home_page");
        }
        $scope.Homename = UtilService.getCookie("ryioUname");
        if ($scope.Homename == undefined || $scope.Homename == null) {
            $scope.Homename = "";
        }
        $scope.HomeId = UtilService.getCookie("ryioUid");
        if ($scope.HomeId == undefined || $scope.HomeId == null) {
            $scope.HomeId = "";
        }
        $scope.Logout = function() {
            ToolService.sendBehaviorUv("Logout");
            HttpService.logOutCookie();
            window.location.href = "home.html";
        }
        $scope.goSet = function() {
            ToolService.sendBehaviorUv("goSet");
            UtilService.setCookie("ryioHome", true);
            window.location.href = "index.html#/manage/userinfo";
        }

        $scope.HomeDemo = function() {
            ToolService.sendBehaviorUv("HomeDemo");
            UtilService.setCookie("ryioDemoapk", 'e31caee07ebedf8c172267e73204802f', 7);
            window.location.href = "demo.html";
        }

        $scope.channelMoreType = true;
        $scope.clickMore = function() {
            $scope.channelMoreType = false;
        }

        $scope.isSuper = $.cookie("ryioIsSuper") == 'true' || $.cookie("ryioIsSuper") == true;
        var ryioRole = $.cookie("ryioRole");
        if (ryioRole && ryioRole == '1') { //管理员
            $scope.isManage = true;
        }

        $scope.companyMoreType = true;
        $scope.companyMore = function() {
            $scope.companyMoreType = false;
        }
        $scope.UserEmail = $.cookie("ryioUname");
        $scope.userNow = function() {
            ToolService.sendBehaviorUv("userNow");
            var status = UtilService.getCookie("ryioStatus");
            var statusPM = HttpService.getInfo("reged/findbyemail?email=" + $scope.UserEmail);
            ToolService.showLoading();
            statusPM.then(function(data) {
                ToolService.hideLoading();
                if (data.status == 1) {
                    if (data.appSize == 0 && data.isChannelPerson == true) {
                        ToolService.showTips($filter('translate')("没有控制权限"));
                        $scope.time = 2000;
                        $one_minute = $interval(function() {
                            $scope.time -= 1000;
                            if ($scope.time == 0) {
                                window.location.href = "login.html";
                            }
                        }, 1000);
                    } else {
                        UtilService.setCookie("ryioStatus", data.status, 7);
                        UtilService.setCookie("ryioPastDate", data.pastDate, 7);
                        if (data.isSuperUser == true) {
                            window.location.href = "index.html#/manage/app";
                        } else {
                            window.location.href = "index.html#/collect/dashboard";
                        }
                    }
                } else {
                    UtilService.setCookie("ryioStatus", data.status, 7);
                    UtilService.setCookie("ryioPastDate", data.pastDate, 7);
                    window.location.href = "index.html#/active/product";
                }
            });
        }

        $scope.goApp = function() {
            ToolService.sendBehaviorUv("goApp");
            window.location.href = "index.html#/manage/app";
        }

        $scope.setLang = function(langKeyNum) {
            var langKey = 'en_US';
            switch (langKeyNum) {
                case 0:
                    langKey = 'en_US';
                    $translateCookieStorage.put('lang', "en");
                    break;
                case 1:
                    langKey = 'zh_CN';
                    $translateCookieStorage.put('lang', 'zh');
                    break;

            }
            $translate.use(langKey);
            $scope.lang = $translateCookieStorage.get("lang");
        }
    }
})();