(function () {
    'use strict';

    angular.module('app', [
        'ui.router',
        'app.home',
        "ngCookies",
        "pascalprecht.translate",
        "ngAnimate"
    ]).config(["$translateProvider","$translateCookieStorageProvider",function($translateProvider,$translateCookieStorageProvider){
        $translateProvider.useStaticFilesLoader({
            prefix: './data/translate/',
            suffix: '.json'
        });
        /*$translateProvider.translations('en',{
            a: 'aVal',
            b:'bVal',
        });
        $translateProvider.translations('zh',{
            a: '啊',
            b:'吧',
        });*/
        function getLang(){
            var get = $translateCookieStorageProvider.$get().get,put = $translateCookieStorageProvider.$get().put,ret = "zh_CN";
            if(get("lang") && get("lang")== "en"){
                ret = "en_US";
            }else if (get("lang") && get("lang") == 'zh'){
                ret = "zh_CN";
            }else{
                put("lang","zh");
            }
            return ret;
        }
        $translateProvider.preferredLanguage(getLang());
        $translateProvider.useCookieStorage();
    }]);

    angular.module('app.home', []);

})();