angular.module("app.manage").controller("accountauthCtrl", ["$scope", "$rootScope", "$stateParams", "ToolService", "HttpService", "$state", "$timeout","$filter", accountauthCtrl])
    .controller("accountauthDetailCtrl", ["$scope", "$rootScope", "$stateParams", "ToolService", "HttpService", "$state", "$timeout", "$interval","$q","$base64","UtilService","$filter",accountauthDetailCtrl]);

/*回本分析授权管理*/

function accountauthCtrl($scope, $rootScope, $stateParams, ToolService, HttpService, $state, $timeout,$filter) {
    //是否是授权成功跳转回来
    if( $stateParams.aid && $stateParams.aid=='succ'){
        ToolService.showTips($filter('translate')('正在同步报表数据，请稍后查看。'));
    }
    $scope.noEditList = ["baiduyuansheng","uctoutiao","toutiao"];
    $scope.showWin = function () {
        if ($scope.dis || !$scope.isall) return;
        $scope.tip = {};
        ToolService.showAlp();
        $scope.isShow = true;
    }

    $scope.hideDialog = function () {
        ToolService.hideAlp();
        $scope.isShow = false;
    }

    $scope.queryList = function (a) {
        if (!sessionStorage.getItem("isShowList")) return;
        $scope.isChannelLimit();
        var status = $scope.statusId != 0 ? '/enable' : '/disable';
        var listPM = HttpService.getInfo('mng/recycle/account/info' + status);
        ToolService.showLoading();
        listPM.then(function (data) {
            $scope.infoList = data;
            ToolService.hideLoading();
        });
    }

    $scope.isChannelLimit = function () {
        var limitPM = HttpService.getInfo('mng/recycle/channel/limit');
        limitPM.then(function (data) {
            $scope.channellimit = data.content;
        });
    }
    $scope.$on('flipinfo', function (e, msg) {
        $scope.flipPage = msg;
    });

    $scope.$watch("{appid:appid,lang:lang}", function (n,o) {
        if (angular.isUndefined(n) ||angular.isUndefined(o) || n==o) {
            return false;
        }
        if(n.lang && o.lang && n.lang!== o.lang){
            $scope.queryList();
            $scope.queryChannelList();
        }else if ($scope.appid && $scope.openService){
            $scope.queryList();
        }
    },true);

    $scope.$watch("openService", function (n,o) {
        if (angular.isUndefined(n) ||angular.isUndefined(o)|| n==o) {
            return false;
        }
        if ($scope.appid && $scope.openService){
            $scope.queryList();
        }
    });

    $scope.apply = function () {
        if($scope.isDisApply)return;
        var params = {
            applierName: $scope.contact,
            applierContact: $scope.phone,
            functionMenu: 'recycleanalysis'
        }
        var verPar = {
            contact: {
                key: 'name',
                val: $scope.contact,
                max: 16
            },
            phone: {
                key: 'cellphone',
                val: $scope.phone
            }
        };
        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ != true) {
            ToolService.showTips($scope.formTipMsg);
            return false;
        }
        $scope.isDisApply = true;
        var applyPM = HttpService.postInfo("mng/recycle/apply", params);
        var msg = $filter('translate')('申请成功');
        ToolService.showLoading();
        applyPM.then(function (data) {
            $scope.isShow = false;
            ToolService.hideAlp();
            ToolService.hideLoading();
            if (data.id) {
                $scope.dis = true;
            } else {
                if (data.code == -200) {
                    msg = $filter('translate')("申请失败");
                } else {
                    msg = data.message;
                }
            }
            ToolService.showTips(msg);

        }).finally(function(){
            $scope.isDisApply = false;
        });
    }

    $scope.queryChannelList = function () {
        var channelPM = HttpService.getInfo('mng/recycle/channel/list');
        channelPM.then(function (data) {
            $rootScope.channelList = data;
            sessionStorage.setItem("accChannelList",JSON.stringify(data));
        });
    }

    $scope.queryList();

    $scope.queryChannelList();


    $scope.enable = function (info) {
        var params = {
            // userName: info.userName,
            // channelAccountId: info.channelAccountId
            uniqueAccount: info.uniqueAccount
        };
        var enablePM = HttpService.getInfo('mng/recycle/account/enable/' + info.cid, params);
        var msg = $filter('translate')('启用成功，数据将在启用1个小时之后更新');
        enablePM.then(function (data) {
            if (data.code == 200) {
                info.status = true;
                ToolService.showTips(msg);
            } else {
                if (data.code == -200) {
                    msg = $filter('translate')("启用失败");
                    ToolService.showTips(msg);
                } else if (data.code == -5005) {
                    $scope.winstatus = true;
                } else {
                    msg = data.message;
                    ToolService.showTips(msg);
                }
            }
        },function(data){
            ToolService.showTips(data.message);
        });
    }
    $scope.disable = function (info) {
        var params = {
            // userName: info.userName,
            // channelAccountId: info.channelAccountId
            uniqueAccount: info.uniqueAccount
        };
        var disablePM = HttpService.getInfo('mng/recycle/account/disable/' + info.cid, params);
        var msg = $filter('translate')('停用成功');
        disablePM.then(function (data) {
            if (data.code == 200) {
                info.status = false;
            } else {
                if (data.code == -200) {
                    msg = $filter('translate')("停用失败");
                } else {
                    msg = data.message;
                }
            }
            ToolService.showTips(msg);
        },function(data){
            ToolService.showTips(data.message);
        });
    }
    $scope.gopage = function (info, flag) {
        if ($scope.dis || !$scope.isall) return;
        if (!info && $scope.channellimit) return;
        if (info) {
            if (info.status == 0) return;
            info.showFlag = flag;
            $state.go("collect.accountauthDetail", {aid: info});
        } else {
            $state.go("collect.accountauthDetail");
        }

    }
    $scope.statusList = [
        {id: 1, name: $filter('translate')("已启用账号")},
        {id: 0, name: $filter('translate')("已停用账号")}
    ];
    $scope.statusInit = $scope.statusList[0].id;
    $scope.$on("statusId", function (e, msg) {
        var old = $scope.statusId;
        $scope.statusId = msg.info.id;
        if(!angular.isUndefined(old) && old!=$scope.statusId){
            $scope.queryList();
        }
    });
    $scope.goback = function () {
        $state.go('collect.advancedServices');
        if (!sessionStorage.getItem("isShowList")) {
            $scope.queryOpenService();
        }
    }
}

function accountauthDetailCtrl($scope, $rootScope, $stateParams, ToolService, HttpService, $state, $timeout, $interval,$q,$base64,UtilService) {

    $scope.resultList = ['success', 'failure'];
    $scope.uniqueNameList = ["gdt","toutiao","uctoutiao","baiduyuansheng"];
    $scope.GDT = $scope.uniqueNameList[0];
    $scope.JRTT = $scope.uniqueNameList[1];
    $scope.UCTT = $scope.uniqueNameList[2];
    $scope.BDYS = $scope.uniqueNameList[3];

    //列表页面查询的渠道列表，从sessionStorage中取出。
    var accChannelList = sessionStorage.getItem("accChannelList");
    if(accChannelList){
        $scope.channelList = JSON.parse(accChannelList);
    }
    var rmd = new Date().getTime();
    $scope.channelInitName = $filter('translate')('请选择渠道');
    $scope.$on("channelId", function (e, msg) {
        if (msg.info.uniqueName == 'gdt' && $scope.channelId != msg.info.cid || ($scope.info ? $scope.info.uniqueName == 'gdt' : false)) {
            $scope.queryAccount(msg.info.cid);
            $scope.isGdt = true;//是否是‘广点通’
            $scope.isTt = false;//是否是‘今日头条’
            $scope.disSubmit = false;//是否禁用‘完成’按钮
        } else if (msg.info.uniqueName == 'toutiao' || ($scope.info && $scope.info.uniqueName == 'toutiao')) {//选择渠道‘今日头条’或者编辑‘今日头条’渠道的数据
            $scope.isGdt = false;
            $scope.isTt = true;
            $scope.accountList = [];
            if ($scope.info && $scope.info.uniqueName == $scope.JRTT) {//今日头条 编辑页面
                $scope.channelAlias = $scope.info.channelAlias;
                $scope.accountId = $scope.info.userName;
            }
        } else {
            $scope.isGdt = false;
            $scope.isTt = false;
            $scope.accountList = [];
        }
        $scope.channelInfo = msg.info;
        $scope.uniqueName = msg.info.uniqueName;
        if($scope.channelId && $scope.channelId !== msg.info.cid){
            $scope.resetForm();
        }
        $scope.channelId = msg.info.cid;
    });
    //表单除‘渠道’外，置空
    $scope.resetForm = function(){
        $scope.accountId = $scope.account = $scope.password = $scope.channelAlias = $scope.authResult = $scope.testResult = undefined;
        $scope.tip = {};
    }

    $scope.queryDetailList = function (info) {
        var params = {
            accountid: info.channelAccountId,
            datatype: 'list'
        }
        /*var appid = UtilService.getCookie("ryioLastApp");
        if(!appid){
            ToolService.showTips("没有取到产品ID！");
            return;
        }*/
        var detailPM = HttpService.getInfo('report/1218/recycle_dashboard_campaign', params);
        ToolService.showLoading();
        detailPM.then(function (data) {
            $scope.detailList = data;
            ToolService.hideLoading();
            $scope.colsStyle = ToolService.getTableColsWidth(data.name, false, 0, true);
        });
    }

    $scope.init = function () {
        var info = $stateParams.aid;
        if (info && info.showFlag == 'edit') {
            $scope.channelInit = info.cid;
            if(info.uniqueName== $scope.UCTT || info.uniqueName== $scope.BDYS){
                $scope.account = info.userName;
                $scope.channelAlias = info.channelAlias;
                $scope.password = info.password;
            }else if(info.uniqueName== $scope.JRTT){
                $scope.accountId = info.userName;
                $scope.channelAlias = info.channelAlias;
            }
        }else if (info && info.showFlag == 'detail') {
            $scope.isDetailList = true;
            $scope.queryDetailList(info);
        }
        // $scope.info = info;
        setTimeout(function(){
            $scope.info = info;
        },200);
    }
    $scope.init();

    $scope.queryAccount = function (cid) {
        var accountPM = HttpService.getInfo('mng/recycle/thirdaccount/list/' + cid);
        accountPM.then(function (data) {
            $scope.accountList = data;
        });
    }

    $scope.$on('flipinfo', function (e, msg) {
        $scope.flipPage = msg;
        $scope.fixrefresh = ++rmd;
    });

    $scope.add = function (info) {
        var params = {
            userName: info.name,
            channelAccountId: info.thirdAccountCode
        };
        var addPM = HttpService.postInfo('mng/recycle/account/add/gdt', params);
        var msg = $filter('translate')('授权成功');
        addPM.then(function (data) {
            if (data.id) {
                info.apply = true;
                ToolService.showTips(msg);
            } else {
                if (data.code == -200) {
                    msg = $filter('translate')('授权失败');
                    ToolService.showTips(msg);
                } else if (data.code == -5005) {
                    $scope.winstatus = true;
                } else {
                    msg = data.message;
                    ToolService.showTips(msg);
                }
            }
        });
    }

    $scope.back = function (flag,isSucc) {
        if (flag && !$scope.channelInit && !$scope.channelId) {
            ToolService.showTips($filter('translate')("请选择渠道"));
            return;
        }
        if ($scope.timeOutTest) {//百度原生，定时任务取消时清除。
            $timeout.cancel($scope.timeOutTest);
        }
        if(isSucc){
            $state.go("collect.accountauth",{aid:"succ"});
        }else{
            $state.go("collect.accountauth");
        }
    }



    //页面表单校验
    function veriParam() {
        var verPar;
        if($scope.uniqueName ==$scope.BDYS){//百度原生
            verPar = {
                account: {
                    key: 'isNull',
                    val: $scope.account,
                },
                password: {
                    key: 'isNull',
                    val: $scope.password,
                },
                channelAlias: {
                    key: 'isNull',
                    val: $scope.channelAlias,
                }}
        }else{
            verPar = {
                channelId: {
                    key: 'isNull',
                    val: $scope.channelId + '',
                },
                accountId: {
                    key: 'num',
                    val: $scope.accountId,
                },
                channelAlias: {
                    key: 'isNull',
                    val: $scope.channelAlias,
                }
            }
        }

        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ != true) {
            ToolService.showTips($scope.formTipMsg);
            return false;
        } else {
            return true;
        }
    }

    //‘点击授权’
    $scope.auth = function () {
        var result = veriParam();
        if (!result) return false;
        $scope.empowerType = true;
        // window.open("http://ad.toutiao.com/openapi/audit/oauth.html?app_id=1601401724412931&state=" + $scope.accountId + "&redirect_uri=http://localhost:9008/api/mng/channelaccount/toutiaocode");
        window.open("https://ad.toutiao.com/openapi/audit/oauth.html?app_id=1601401724412931&state=" + UtilService.getCookie("ryioUid") + "###"+$scope.channelAlias+"&redirect_uri=http%3A%2F%2Fwww.trackingio.com%2Fapi%2Fmng%2Frecycle%2Fjrtt%2Fcb");
    }

    //‘重新授权’
    $scope.reAuth = function () {
        $scope.authResult = '';
        $scope.testResult = '';
    }

    //‘授权完成’按钮触发事件
    $scope.empowerOK = function () {
        var savePM = null;
        savePM = HttpService.getInfo("mng/recycle/jrtt/auth/test/" + $scope.accountId);
        savePM.then(function (data) {
            $scope.authResult = $scope.resultList[0];//验证结果成功‘success’
            $scope.empowerType = false;//关闭弹出页面
        }, function (data) {
            if (data.code === -200) {//失败时，错误码-200
                $scope.authResult = $scope.resultList[1];//验证结果失败‘failure’
                $scope.empowerType = false;//关闭弹出页面
            }
        });
    }

    //‘遇到问题’按钮触发事件
    $scope.empowerError = function () {
        $scope.empowerType = false;//关闭弹出页面，不做其他操作
    }

    //今日头条‘连接测试’
    $scope.requestTestTT = function () {
        var savePM = null;
        savePM = HttpService.getInfo("mng/recycle/jrtt/token/test/" + $scope.accountId);
        savePM.then(function (data) {
            $scope.testResult = $scope.resultList[0];
        }, function (data) {
            if (data.code === -200) {
                $scope.testResult = $scope.resultList[1];
            }
        });
    }

    $scope.save = function () {
        var verPar = {
            account: {
                key: 'isNull',
                val: $scope.account,
            },
            password: {
                key: 'isNull',
                val: $scope.password,
            },
            channelAlias: {
                key: 'isNull',
                val: $scope.channelAlias,
            }
        }
        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ) {
            var savePM = HttpService.getInfo("mng/recycle/spider/save/" + $scope.account +
                "/" + $scope.channelAlias + "/" + $scope.password + "/" + $scope.channelInfo.mcCid +
                "/" + $scope.channelInfo.mcUniqueName + "/" + $scope.channelInfo.uniqueName);
            savePM.then(function (data) {
                $scope.back();
            }, function (data) {
                if (data.code === -200) {
                    this.showMsg($filter('translate')('数据保存失败。'));
                }
            });
        }
    }

    /**
     * 账号唯一性验证
     */
    $scope.verifyAccountChanAli = function () {
        var defered = $q.defer();
        var param = {
            userName: encodeURI(encodeURI($scope.account)),
            channelAlias: encodeURI(encodeURI($scope.channelAlias)),
            cid:$scope.channelId,
        };
        $scope.info && (param.id = $scope.info.id);//修改加id值
        if(!param){
            ToolService.showTip($filter('translate')('参数为空'));
            return false;
        }
        var pm = HttpService.getInfo('mng/recycle/unique/check',param);
        pm.then(function(data){
            defered.resolve(data);
        },function(data){
            ToolService.showTips(data.message);
            if(data.code==30003){//账号重复
                $scope.tip.account = {
                    status:true,
                    txt:data.message
                }
            }else if(data.code==30004){//账号别名重复
                $scope.tip.channelAlias = {
                    status:true,
                    txt:data.message
                }
            }
        });
        return defered.promise;
    }
    //‘连接测试’
    $scope.requestTest = function(){
        if($scope.uniqueName == $scope.JRTT){
            $scope.requestTestTT();
        }else if($scope.uniqueName == $scope.BDYS || $scope.uniqueName == $scope.UCTT){
            $scope.requestTestYuanSheng();
        }
    }

    //百度原生、uc头条连接测试
    $scope.requestTestYuanSheng = function () {
        $scope.testResult = undefined;
        if (!$scope.password) return false;
        var verParam = {
            account: {
                key: 'isNull',
                val: $scope.account,
            },
            password: {
                key: 'isNull',
                val: $scope.password,
            },
            channelAlias: {
                key: 'deviceManage',
                val: $scope.channelAlias,
                max: 20,
                regFlag: false,
                reg: /^[a-zA-Z0-9_\-\u4E00-\u9FA5]{1,20}$/,
                canBeEmpty: false,
                txt:$filter('translate')('支持输入汉字、数字、大小写字母、下划线、中划线，最多20字符。')
            }
        }
        $scope.tip = formJudge(verParam);
        if ($scope.tip.succ) {
            ToolService.showLoading();
            $scope.verifyAccountChanAli().then(function(){
                $scope.ysInTest = true;
                var timeOutTest = $timeout(function () {
                    ToolService.showTips($filter('translate')('连接测试超时，请点击重试'));
                    $scope.ysInTest = false;
                }, 60000),
                    param = {
                    n: $base64.encode(encodeURI($scope.account)),
                    channelAlias: encodeURI(encodeURI($scope.channelAlias)),
                    w: $base64.encode(encodeURI($scope.password)),
                    cid:$scope.channelId,
                };
                $scope.info && (param.id = $scope.info.id);//修改加id值
                ToolService.showLoading();
                var pm = HttpService.getInfo("mng/recycle/auth/"+$scope.uniqueName, param);
                pm.then(function (data) {
                    $timeout.cancel(timeOutTest);
                    // $scope.ysInTest = false;
                    if($scope.uniqueName==$scope.UCTT){//UC头条
                        $scope.back(undefined,1);
                    }else{
                        $scope.testResult = $scope.resultList[0];
                        $scope.ysInTest = false;
                    }
                }, function (data) {
                    $timeout.cancel(timeOutTest);
                    if(data.code==30006){//百度手机验证
                        $scope.result = -1;

                    }else if(data.code==30007){//百度问题验证
                        $scope.result = data.result;
                        $scope.questions = data.questions;
                        $scope.questionInitName = $filter('translate')('请选择问题');
                    }else{
                        ToolService.showTips(data.message);
                        $scope.ysInTest = false;
                        $scope.testResult = $scope.resultList[1];
                    }
                }).finally(function(){
                    ToolService.hideLoading();
                });
            },function(data){
                ToolService.showTips(data.message);
                ToolService.hideLoading();
            });
        }
    }

    //点击发送验证码
    $scope.getVerCode = function () {
        if($scope.second || $scope.second==0){
            return false;
        }
        if(!($scope.tipVerify && $scope.tipVerify.succ)){
            $scope.verifyIphone();
        }
        $scope.isSendCode = true;
        if($scope.tipVerify.succ){
            ToolService.showLoading();
            //发送验证码到手机
            if($scope.uniqueName && $scope.uniqueName==$scope.BDYS){//百度原生
                var pm = HttpService.postInfo("mng/recycle/sendvcode/"+$scope.uniqueName,{
                    n:$base64.encode(encodeURI($scope.account)),
                    w:$base64.encode(encodeURI($scope.password)),
                    loginCheck:JSON.stringify({
                        "type":"1",
                        "mobile":$scope.iphone
                    })
                });
                pm.then(function(data){
                    if(data.code && data.code!=200){
                        ToolService.showTips(data.message);
                    }else{
                        ToolService.hideLoading();
                        if ($scope.second >= 0 || $scope.second === 0) {
                            return false;
                        }
                        $scope.second = 60;
                        $scope.interVerCode = $interval(function () {
                            $scope.second--;
                        }, 1000, 60);
                    }
                },function(data){
                    ToolService.showTips($filter('translate')(data ? data.message:"未知错误"));
                });

            }else{
                ToolService.showTips($filter('translate')('所选渠道为空或不正确'));
            }


        }
    }

    //验证手机号码合法
    $scope.verifyIphone = function(){
        $scope.tipVerify = formJudge({
            iphone: {
                key: 'cellphone',
                val: $scope.iphone,
            },
        });
        if($scope.tipVerify.succ){
            return true;
        }else{
            return false
        }
    }
    //验证“手机验证”和“问题验证”的答案是否合法，并返回提交参数
    $scope.verifyIphoneQuestion = function(){
        var verParam ,param={
            // userName:$scope.account,
            // password:$scope.password
            n: $base64.encode(encodeURI($scope.account)),
            w: $base64.encode(encodeURI($scope.password)),
            cid: $scope.channelId,
            channelAlias: encodeURI(encodeURI($scope.channelAlias))
        };
        if($scope.result==-1){//手机校验
            verParam = {
                iphone: {
                    key: 'cellphone',
                    val: $scope.iphone,
                },
                code:{
                    key:'deviceManage',
                    val:$scope.code,
                    reg:/^\d{6}$/,
                }
            }
            param = Object.assign(param,{
                loginCheck:JSON.stringify({
                    type:"1",//手机验证
                    mobile:$scope.iphone,
                    vcode:$scope.code
                })
            })
        }else if($scope.result==-2){//问题验证
            verParam = {
                questionId:{
                    key: 'isNull',
                    val: $scope.questionId && ($scope.questionId+''),
                },
                answer:{
                    key:'isNull',
                    val: $scope.answer,
                }
            }
            param = Object.assign(param,{
                loginCheck:JSON.stringify({
                    type:"2",//问题验证
                    id:$scope.questionId,
                    question:getQuestion(),
                    answer:$scope.answer
                })
            })
        }
        if(!verParam){
            ToolService.showTip($filter('translate')("参数为空"));
            return false;
        };

        $scope.tipVerify = formJudge(verParam);
        if($scope.tipVerify.succ){
            return param;
        }else{
            return false
        }
    }
    //通过问题id获取问题内容
    $scope.getQuestion = function(id){
        var selectQ = $scope.questions.find(function(item){
            return item.id==$scope.questionId
        });
        if(selectQ){
            return selectQ.question;
        }else{
            return undefined;
        }
    }


    $scope.$watch("second", function (v) {
        if (v === 0 && $scope.interVerCode) {
            $interval.cancel($scope.interVerCode);
            $scope.second = undefined;
        }
    });

    /**
     *手机、问题提交验证
     */
    $scope.submitVerify = function(){
        var param = $scope.verifyIphoneQuestion();
        if(param){
            var url;
            if($scope.result==-1 && $scope.uniqueName==$scope.BDYS){//百度原生
                url = "mng/recycle/phoneverify/"+$scope.uniqueName;
            }else if($scope.result==-2 && $scope.uniqueName==$scope.BDYS){//百度原生
                url = "mng/recycle/questionverify/"+$scope.uniqueName;
            }else{
                ToolService.showTips($filter('translate')("渠道异常"));
                return false;
            }
            ToolService.showLoading();
            // $scope.isSendCode = false;
            var pm = HttpService.postInfo(url,param);
            pm.then(function(data){
                if(!data.code || data.code && data.code==200){
                    $scope.result = undefined;
                    $scope.testResult = $scope.resultList[0];
                    $scope.ysInTest = false;
                    $scope.closePrompt();
                }else{
                    $scope.testResult = $scope.resultList[1];
                    // $scope.ysInTest = false;
                    // $scope.closePrompt();
                    ToolService.showTips(data.message);
                }
            },function(data){
                $scope.testResult = $scope.resultList[1];
                $scope.ysInTest = false;
                $scope.closePrompt();
                ToolService.showTips(data.message);
            }).finally(function(){
                ToolService.hideLoading();
            });
        };

    }

    //‘完成’
    $scope.submit = function(){
        if($scope.uniqueName==$scope.GDT){
            $scope.back(1);
        }else if(($scope.uniqueName==$scope.BDYS || $scope.uniqueName == $scope.UCTT) && $scope.testResult == $scope.resultList[0]) {//百度原生、uc头条测试完成返回
            $scope.back(undefined,1);
        }else{
                var result = veriParam();
                if (!result) return false;
                var savePM = null;
                savePM = HttpService.getInfo("mng/recycle/jrtt/success/" + $scope.accountId + "/" + $scope.channelAlias);
                savePM.then(function (data) {
                    $scope.back(undefined,1);
                }, function (data) {
                    if (data.code === -200) {
                        ToolService.showTips($filter('translate')("数据保存失败。"));
                    }
                });
            // }
        }
    }

    //测试成功时，修改页面项重新连接测试。
    $scope.$watch("account+password+channelAlias",function(){
        if($scope.testResult==$scope.resultList[0]){
            $scope.testResult = undefined;
            $scope.ysInTest = false;
        }
    });
    //
    $scope.closePrompt = function(){
        $scope.result =  $scope.tipVerify = $scope.iphone = $scope.code = $scope.second = $scope.answer = $scope.questionId = undefined;
        $scope.ysInTest = false;
    }

    $scope.$on("questionId",function(e,msg){
        $scope.questionId = msg.info.id;
    });

}
