angular.module("app.manage").controller("advancedServicesCtrl", ["$scope", "$rootScope", "ToolService", "HttpService", "$state", "$timeout", "UtilService", "$filter", advancedServicesCtrl])
    .controller("fakeGuideCtrl", ["$scope", "$rootScope", "ToolService", "HttpService", "UtilService", "$filter", fakeGuideCtrl]);

/**
 * 高级服务控制类
 * @param $scope
 * @param $rootScope
 * @param ToolService
 * @param HttpService
 * @param $state
 * @param $timeout
 * @param UtilService
 * @param $filter
 */
function advancedServicesCtrl($scope, $rootScope, ToolService, HttpService, $state, $timeout, UtilService, $filter) {
    //人群分析灰色上线，可见账号。
    $scope.isCrowd = $scope.loginuserName == 'demoadmin@reyun.com' || $scope.loginuserName == 'trackingio@reyun.com';
    // $scope.isShowRecycle = $scope.loginuserName=='trackingio@reyun.com' || $scope.loginuserName=='1050115484@qq.com';
    //
    $scope.query = function() {
        var powerPM = HttpService.getInfo("crowd/findBlackData");
        powerPM.then(function(data) {
            $scope.data = data;
            $scope.isOpenFake = data.blacklistApplication && (data.blacklistApplication.status == 1 || data.blacklistApplication.status == 2);
            // $scope.blacklistApplication = data.blacklistApplication;
            $scope.isOpenCrowd = data.crowdOrders.length > 0;
        });
    }

    $scope.queryChannelList = function() {
        var channelPM = HttpService.getInfo('mng/recycle/channel/list');
        channelPM.then(function(data) {
            $scope.channelList = data;
        });
    }

    //回本分析模块 近7天累计数据
    $scope.queryRecycleTotal = function() {
        var accountPM = HttpService.getInfo("mng/recycle/account/list");
        accountPM.then(function(data) {
            var aIds = [];
            data.forEach(function(item) {
                item.channelAccountId && aIds.push(item.channelAccountId);
            });
            // if($scope.appid){
            $scope.tdate = ToolService.getLastDays(-7, 0);
            var params = {
                startdate: $scope.tdate.startDate,
                enddate: $scope.tdate.endDate,
                accountid: aIds.join(','),
                datatype: 'list'
            }
            var totalPM = HttpService.getInfo("report/1218/recycle_analysis_total", params);
            totalPM.then(function(data) {
                $rootScope.recycletotal = data;
            });
            // }
        });
    }

    //查询调起模块数据
    $scope.awakenType = 1;
    $scope.isAwakenOn = true;
    $scope.queryAwakenList = function() {
            var awakenPM = HttpService.getInfo("crowd/findArouseData");
            awakenPM.then(function(data) {
                $scope.awakenDate = data;
                //surplusDays   <0 过期
                if (data.hasOwnProperty("num_arouse")) {
                    $scope.num_arouse = data.num_arouse;
                } else {
                    $scope.num_arouse = '-';
                }
                if (data.blacklistApplication) {
                    if (data.blacklistApplication.status == 0) //已申请未开通
                    {
                        $scope.isAwakenOn = true;
                        $scope.awakenType = 0;
                        $scope.fakeText = $filter('translate')("已经收到您的服务开通要求，我们的商务会尽快与您联系");
                    } else {
                        $scope.isAwakenOn = false;
                        $scope.awakenPastDate = data.blacklistApplication.pastDate
                    }
                } else { //未开通调起服务
                    $scope.isAwakenOn = true;
                }
            })

        }
        // $scope.showApp = true;
    $scope.renewService = function() {
        if ($scope.isrecycle) {
            var par = {
                phone: $scope.tell,
                contact: $scope.contact
            };
            var verPar = {
                tell: {
                    key: 'cellphone',
                    val: $scope.tell
                },
                contact: {
                    key: 'isNull',
                    val: $scope.contact
                }
            };
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var savePM = HttpService.postInfo("mng/recycle/apply/renew", par);
            var msg = $filter('translate')("续订服务申请已发送");
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                $scope.showApp = false;
                if (data.id) {
                    $scope.openService.renew = false;
                    $scope.queryOpenService();
                } else {
                    if (data.code == -200) {
                        msg = $filter('translate')("续订服务申请发送失败");
                    } else {
                        msg = data.message;
                    }
                }
                ToolService.showTips(msg);
            });
        } else {
            $scope.saveFake();
        }
    }

    //开通调起服务
    $scope.awakenFlag = false;
    $scope.clickAwaken = function() {
        $scope.awakenFlag = true;
        ToolService.showAlp();
    }
    var userID = UtilService.getCookie("ryioUid");
    $scope.saveAwaken = function() {
        var par = {
            tell: $scope.tell,
            accountId: userID,
            name: $scope.loginuserName,
            menu: 'arouse'
        };
        var verPar = {
            tell: {
                key: 'cellphone',
                val: $scope.tell
            }
        };
        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ != true) {
            ToolService.showTips($scope.formTipMsg);
            return false;
        }
        var savePM = null,
            txtTips = $filter('translate')("获取成功");
        savePM = HttpService.postInfo("mng/fake/create", par);
        ToolService.showLoading();
        savePM.then(function(data) {
            ToolService.hideLoading();
            if (data.code == 200) {
                ToolService.showTips(txtTips);
                $scope.awakenType = 0; //获取成功后改为0
                $rootScope.fakeAlertType = false;
                $scope.fakeText = $filter('translate')("已经收到您的服务开通要求，我们的商务会尽快与您联系");
                $rootScope.operSubmitData($filter('translate')("确定"));
            } else if (data.code == -300) {
                $scope.awakenType = 0; //获取成功后改为0
                $scope.fakeText = $filter('translate')();
            }
        });
    }
    $scope.closeFake = function() {
        $scope.awakenFlag = false;
        ToolService.hideAlp();
    }

    $scope.saveFake = function() {
        var id = $scope.data && $scope.data.blacklistApplication && $scope.data.blacklistApplication.id;
        var renew = $scope.data && $scope.data.blacklistApplication && $scope.data.blacklistApplication.renew;
        var awakenRenew = $scope.awakenDate && $scope.awakenDate.blacklistApplication && $scope.awakenDate.blacklistApplication.renew //true不可续订，false|null的时候可以续订
        var awakenId = $scope.awakenDate && $scope.awakenDate.blacklistApplication && $scope.awakenDate.blacklistApplication.id //true不可续订，false|null的时候可以续订
            // console.log(awakenRenew, awakenId)
        var par = {
            phone: $scope.tell,
        };
        var verPar = {
            tell: {
                key: 'cellphone',
                val: $scope.tell
            }
        };
        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ != true) {
            ToolService.showTips($scope.formTipMsg);
            return false;
        }
        var savePM = null,
            txtTips = $filter('translate')("获取成功");

        if ($scope.isAwaken) {
            id = awakenId;
            if (id && !awakenRenew) {
                savePM = HttpService.getInfo("mng/fake/renew/" + id, par);
                ToolService.showLoading();
                savePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.renew) {
                        ToolService.showTips(txtTips);
                        $scope.showApp = false;
                        $scope.queryAwakenList();

                    } else {
                        ToolService.showTips("出现错误。");
                    }
                });
            } else if (!id) {
                ToolService.showTips("ID值没有取到。");
            } else if (awakenRenew) {
                ToolService.showTips("已经收到您的服务开通要求，请勿重复发送。");
            }
        } else {
            if (id && !renew) {
                savePM = HttpService.getInfo("mng/fake/renew/" + id, par);
                ToolService.showLoading();
                savePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.renew) {
                        ToolService.showTips(txtTips);
                        $scope.showApp = false;
                        $scope.query();
                    } else {
                        ToolService.showTips("出现错误。");
                    }
                });
            } else if (!id) {
                ToolService.showTips("ID值没有取到。");
            } else if (renew) {
                ToolService.showTips("已经收到您的服务开通要求，请勿重复发送。");
            }
        }

    }
    $scope.isAwaken = false;
    $scope.clickApp = function(val, isrecycle, isAwaken) {
        if (isrecycle && (!$scope.openService.isPay || !$scope.openService.renew)) return;
        $scope.tell = "";
        $scope.showApp = val;
        $scope.isrecycle = isrecycle;
        if (isAwaken) {
            $scope.isAwaken = true;
            $scope.tip = {};
        } else {
            $scope.isAwaken = false;
        }
    }


    $scope.authmanage = function() {
        if ($scope.isPast && $scope.openService.isPay || !$scope.isall) return;
        $state.go('collect.accountauth');
    }

    $scope.getFormatNumber = function(num, col) {
        return UtilService.getFormatNumber(num, col, true);
    }


    $scope.showWin = function() {
        if (!$scope.isall) return;
        $scope.tip = {};
        ToolService.showAlp();
        $scope.isShow = true;
    }


    $scope.hideDialog = function() {
        ToolService.hideAlp();
        $scope.isShow = false;
    }


    $scope.apply = function() {
        var params = {
            applierName: $scope.contact,
            applierContact: $scope.phone,
            functionMenu: 'recycleanalysis'
        }
        var verPar = {
            contact: {
                key: 'name',
                val: $scope.contact,
                max: 16
            },
            phone: {
                key: 'cellphone',
                val: $scope.phone
            }
        };
        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ != true) {
            ToolService.showTips($scope.formTipMsg);
            return false;
        }
        var applyPM = HttpService.postInfo("mng/recycle/apply", params);
        var msg = '申请成功';
        ToolService.showLoading();
        applyPM.then(function(data) {
            $scope.isShow = false;
            ToolService.hideAlp();
            ToolService.hideLoading();
            if (data.id) {
                $scope.openService.isApply = false;
            } else {
                if (data.code == -200) {
                    msg = $filter('translate')("申请失败");
                } else {
                    msg = data.message;
                }
            }
            ToolService.showTips(msg);
        });
    }

    $scope.init = function() {
        $scope.queryChannelList();
        $scope.query();
        $scope.queryAwakenList();
        var isOpen = false;
        // $scope.isOpenFake = isOpen;
        $scope.isOpenBack = isOpen;
        // $scope.isOpenCrowd = isOpen;
        if (sessionStorage.getItem('isShowList')) {
            $scope.queryRecycleTotal();
        }
    }

    $scope.init();

    //
    $scope.$watch("lang", function(val, oldVal) {
        if (val && oldVal && val !== oldVal) {
            $scope.init();
        }
    });

}

function fakeGuideCtrl($scope, $rootScope, ToolService, HttpService, UtilService, $filter) {

    //未开通作弊列表
    $scope.getList = function() {
        var listPM = HttpService.getInfo("mng/fake/find/report");
        ToolService.showLoading();
        listPM.then(function(data) {
            ToolService.hideLoading();
            if (data.val && data.val.length > 0) {
                $scope.listFakeMoney = data.val[0].money;
                $scope.listFakeRoi = data.val[0].rate_install;
                if (data.val[0].num_click > 10000) {
                    $scope.listAllClick = (data.val[0].num_click / 10000).toFixed(2) + $filter('translate')("万");
                } else {
                    $scope.listAllClick = data.val[0].num_click
                }
                if (data.val[0].num_install > 10000) {
                    $scope.listAllInstall = (data.val[0].num_install / 10000).toFixed(2) + $filter('translate')("万");
                } else {
                    $scope.listAllInstall = data.val[0].num_install
                }
                if (data.val[0].black > 10000) {
                    $scope.listAllBlack = (data.val[0].black / 10000).toFixed(2) + $filter('translate')("万");
                } else {
                    $scope.listAllBlack = data.val[0].black
                }
            }
        });
    }
    $scope.getList();

    //获取功能
    $scope.getFlag = false;
    $scope.getFake = function() {
        //请求电话号码
        var tellPM = HttpService.getInfo("mng/fake/find/tell");
        ToolService.showLoading();
        tellPM.then(function(data) {
            ToolService.hideLoading();
            if (angular.isObject(data)) {
                $scope.tell = "";
            } else {
                $scope.tell = data;
            }
        });
        $rootScope.operSubmitData($filter('translate')("获取此功能"));
        $scope.tip = {};
        $scope.getFlag = true;
        ToolService.showAlp();
    }
    $scope.closeFake = function() {
        $scope.getFlag = false;
        ToolService.hideAlp();
    }

    var userID = UtilService.getCookie("ryioUid");
    $scope.saveFake = function() {
        var par = {
            tell: $scope.tell,
            accountId: userID,
            name: $scope.loginuserName,
            menu: 'fake'
        };
        var verPar = {
            tell: {
                key: 'cellphone',
                val: $scope.tell
            }
        };
        $scope.tip = formJudge(verPar);
        if ($scope.tip.succ != true) {
            ToolService.showTips($scope.formTipMsg);
            return false;
        }
        var savePM = null,
            txtTips = $filter('translate')("获取成功");
        savePM = HttpService.postInfo("mng/fake/create", par);
        ToolService.showLoading();
        savePM.then(function(data) {
            ToolService.hideLoading();
            if (data.code == 200) {
                ToolService.showTips(txtTips);
                $rootScope.fakeType = 0; //获取成功后改为0
                $rootScope.fakeAlertType = false;
                $scope.fakeText = $filter('translate')("已经收到您的服务开通要求，我们的商务会尽快与您联系");
                $rootScope.operSubmitData($filter('translate')("确定"));
            } else if (data.code == -300) {
                $rootScope.fakeType = 0; //获取成功后改为0
                $scope.fakeText = $filter('translate')();
            }
        });
    }
}