(function () {
    angular.module("app.manage")
        .controller("appCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$timeout", "ArrayConstant", "$filter" ,appCtrl])
        .controller("appDetailCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "UtilService", "DateService", "$q", "$state", "$stateParams", "$filter","$translate", "$timeout", "ArrayConstant", appDetailCtrl]);

    var isLog = false; //标识是否从列表直接进入到调试界面
    function appCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $timeout, ArrayConstant,$filter) {
        $scope.queryApp();

        $scope.isDemo = ToolService.isUser(ArrayConstant.demoEmail);

        if ($rootScope.isDebug == undefined) {
            $rootScope.isDebug = false;
        }

        $scope.getType = function () {
            $rootScope.isDebug = !$rootScope.isDebug;
        }

        $scope.$on('flipinfo', function (e, msg) {
            $scope.flipPage = msg;
        });

        $scope.specialsAppkey = [
            "e31caee07ebedf8c172267e73204802f",
            "f4c6764d10bec9a3c4bd4f79a442a947",
            "022da4f8bd53ac212141bd7fdfa9532d",
            "5eb29a7e239537f4bedef93f8289d1c6",
            "e0b3000ebd3f54b791a405f68d3e520c"
        ];

        $scope.doRemove = function (id) {
            $scope.delstatus = true;
            $scope.delId = id;
        }

        $scope.removeInfo = function () {
            var removePM = HttpService.deleteInfo("mng/app/delete/" + $scope.delId);
            ToolService.showLoading();
            removePM.then(function (data) {
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($filter('translate')("删除成功"))
                $scope.$emit("f5Applist", true);
                $rootScope.operSubmitData($filter('translate')("删除"));
            });
        }

        $timeout(function () {
            var clipboard = new Clipboard('.copyBtn');
            clipboard.on('success', function (e) {
                $scope.$apply(function () {
                    ToolService.showTips($filter('translate')("复制成功")); 
                });
            });
            clipboard.on('error', function (e) {
                $scope.$apply(function () {
                    ToolService.showTips($filter('translate')("复制失败"));
                });
            });
        }, 200);

        //启用停用
        $scope.onOff = function (info) {
            var url = "mng/app/enable/" + info.id,
                tipmsg = $filter('translate')("启用成功");
            if (info.regedbutton) {
                url = "mng/app/forbidden/" + info.id;
                tipmsg = $filter('translate')("停用成功");
            }
            var userPM = HttpService.putInfo(url, {});
            ToolService.showLoading();
            userPM.then(function (data) {
                ToolService.hideLoading();
                ToolService.showTips(tipmsg)
                $scope.$emit("f5Applist", true);
                $rootScope.operSubmitData(tipmsg.slice(0, 2));
            });
        }

        $scope.isShow = function () {
            if (!$scope.appAlllistInfo) {
                return false;
            }

            if ($scope.resultList && $scope.resultList.length > $scope.limitCount) {
                return true;
            } else {
                return false;
            }
        }

        var panelH = $(".rightWrap");
        $(".rightWrap").scroll(function (event) {
            if (panelH.get(0).scrollHeight <= panelH.height()) return;
            var _this = this;
            $timeout(function () {
                if ($scope.isShow() && $scope.filterResult.length > 0) {
                    var viewH = $(_this).height(),//可见高度
                        contentH = $(_this).get(0).scrollHeight,//内容高度
                        scrollTop = $(_this).scrollTop();//滚动高度
                    // alert("height:"+viewH+",scrollHeight:"+contentH+",scrollTop:"+scrollTop);
                    if (scrollTop >= contentH - viewH - 1) { //到达底部100px时,加载新内容
                        $scope.getMore();
                    }
                }
            }, 10);
        });

        $(".rightWrap").on('mousewheel', function (event) {
            if (panelH.get(0).scrollHeight > panelH.height() || event.originalEvent.deltaY <= 0) return;
            // console.log($scope.isShow() && $scope.filterResult.length>0);
            if ($scope.isShow() && $scope.filterResult.length > 0) {
                $timeout(function () {
                    $scope.getMore();
                }, 10);
            }
        });

        $scope.getMore = function () {
            $scope.limitCount += 9;
        }

        $scope.gopage = function (id, flag) {
            if (flag) {
                isLog = true;
            } else {
                isLog = false;
            }
            if (angular.isDefined(id)) {
                $state.go("collect.appDetail", {
                    aid: id
                });
            } else {
                $state.go("collect.appDetail");
            }
        }

        $scope.goReport = function (info, e) {
            if ($(e.target).hasClass('copyBtn')) return;
            if (info.isDebug) return;
            $rootScope.isweb = info.platform == 'H5';
            $('.rightWrap').unbind("scroll");
            $('.rightWrap').unbind("mousewheel");
            $scope.$emit("mngappTo", info.id);
            $state.go("collect.dashboard");
            // $state.go("collect.noaccess");
            $rootScope.onlineDateInfo = info.onlineDate;//预约上线时间 
            var currentTime =new Date().Format('yyyy-MM-dd');
            if($rootScope.onlineDateInfo && currentTime <= $rootScope.onlineDateInfo){// 【预计上线日期】没有值或<=当前日期时，不显示该选项
                $rootScope.showOnlineDates = true;
            }else{
                $rootScope.showOnlineDates = false;
            }
        }

        $scope.$watch("searchTxt", function (n) {
            if (angular.isDefined(n) && n != '') {
                $scope.limitCount = $scope.resultList.length;
            } else {
                $scope.limitCount = 9;
            }
        });

        $scope.$watch("{list:appAlllistInfo,debug:isDebug}", function () {
            /* var newList =  $scope.appAlllistInfo ? $scope.appAlllistInfo.map(function(item){
                 return item.id
             }):[];*/
            $scope.resultList = $scope.appAlllistInfo ? $scope.appAlllistInfo.filter(function (item) {
                return item.isDebug == $scope.isDebug;
            }) : [];
        }, true);

        $scope.sortEvent = "dragDrop";

        $scope.$on($scope.sortEvent, function (e, msg) {
            // console.log(msg);
            if (msg && msg.length == 2 && msg[0] && msg[1]) {
                var pm = HttpService.putInfo("mng/app/update/sort/" + msg[0] + "/" + msg[1]);
                pm.then(function (data) {
                    // console.log(data);
                });
            }
        })

        $scope.sortApp = function () {
            $scope.isAsx = $scope.isAsx ? 0 : 1;
            ToolService.showLoading();
            var Pm = HttpService.putInfo("mng/app/update/sort/" + $scope.isAsx);
            Pm.then(function (data) {
                ToolService.hideLoading();
                if (data.code == 200) {
                    $scope.queryApp();
                }
            });
        }

        $scope.$watch("lang",function(val,oldVal){
            if(val && oldVal && val!==oldVal) {
                $scope.queryApp();
            }
        });

    }

    function appDetailCtrl($scope, $rootScope, HttpService, ToolService, UtilService, DateService, $q, $state, $stateParams, $filter, $translate,$timeout, ArrayConstant) {
        var infoId = $scope.infoId = $scope.id = $stateParams.aid;
        var loginuserName = UtilService.getCookie("ryioUname");
        $scope.platformList = ['iOS', 'Android', 'H5', 'wx', 'wg', 'selfBuilt'];
        $scope.isLog = isLog;
        if (!infoId) {
            $scope.tagType = 'game';
        }

        var initInit = function(){
            $scope.typeinit = $translate.instant('请选择游戏类型');
            $scope.themeinit = $translate.instant('请选择游戏题材');
            $scope.styleinit = $translate.instant('请选择美术风格');
            $scope.firstinit = $translate.instant('请选择应用分类');
            $scope.secondinit = $translate.instant('应用分类-细分分类');
        }
        initInit();
        var boundOldID = "", oldName = "", oldMipAppid;

        var gameTypeId = 38;
        var tagPM = HttpService.getInfo("/dic/findbycampaign");
        tagPM.then(function (data) {
            $scope.tagList = data;
            init();
        });
        $scope.showSelfBuilt = false;
        var selfBuiltPM = HttpService.getInfo("account/getSelfBuilt");
        selfBuiltPM.then(function (data) {
            $scope.showSelfBuilt = data;
        });
        if (!$scope.isLog) {
            var typePM = HttpService.getInfo("mng/app/find/getcategorys");
            typePM.then(function (data) {
                var typeArr = [], gameArr = [];
                data.filter(function (item) {
                    item.name = item.categoryname;
                    if (item.isgame == 1) {
                        gameArr.push(item);
                    } else {
                        typeArr.push(item);
                    }
                });
                $scope.typeList = typeArr;
                $scope.gameList = gameArr;

                $scope.appGenreInit = $scope.typeList[0].categoryid;
                $scope.gameGenreInit = $scope.gameList[0].categoryid;
            });
        }
        $scope.close = function () {
            ToolService.hideAlp();
            $scope.showTip = 0;
        }
        $scope.selectType = function (type, flag) {
            if (!$scope.edit && $scope.debugDays <= 30) return;
            if (flag == 1) {
                $scope.industory = type;
            }
            $scope.tempType = type;
            ToolService.showAlp();
            $scope.showTip = flag;
        }
        $("#industory").on("click", function (e) {
            if (e.stopPropagation)
                e.stopPropagation();
            else
                e.cancelBubble = true;
        });
        $("#tip").on("click", function (e) {
            if (e.stopPropagation)
                e.stopPropagation();
            else
                e.cancelBubble = true;
        });
        $(document).on("click", function () {
            $scope.edit = false;
            $scope.$apply();
        });
        $scope.onLine = -1;
        infoId?$scope.monitor = 1:$scope.monitor = 0;
        $scope.onlineStatus = false;
        $scope.dataStatus = false;
        $scope.timeDisable = false;
        $scope.setLine = function(flag){
            if(!$scope.timeDisable){
                $scope.onLine = flag;
                $scope.monitor = 1;
                if(infoId){
                    if(flag == 1){
                        $scope.monitor = 0;
                        $scope.onlineDateEdit =false
                    }
                    else{
                        $scope.monitor = 1;
                        $scope.onlineDateEdit =true
                    }
                }else{
                    flag == 1?$scope.monitor = 0:$scope.monitor = 1
                }
            }
            
        }
        $scope.setMonitor = function(flag){
            if(!$scope.timeDisable){
                $scope.monitor = flag;
            }
        }
        $scope.beginDate = "请选择日期";
        $scope.$on("beginDate",function(e,msg){
            $scope.beginDate = msg;
        });

      




        $scope.confirm = function () {
            if ($scope.showTip == 1) {
                $scope.stepflag = 2;
            } else {
                $scope.industory = $scope.tempType;
            }
            ToolService.hideAlp();
            $scope.showTip = 0;
        }
        $scope.downloadsdk = function () {
            $rootScope.operSubmitData($filter('translate')("查看并下载SDK"));
        }
        $scope.$on("appGenre", function (e, msg) {
            $scope.showGame = msg.info.categoryid == gameTypeId;
            $scope.appGenre = msg.info.categoryid;
            $scope.appGenreName = msg.info.categoryname;
        });
        $scope.$on("gameGenre", function (e, msg) {
            $scope.gameGenre = msg.info.categoryid;
            $scope.gameGenreName = msg.info.categoryname;
        });
        $scope.$on("typeIds", function (e, msg) {
            $scope.typeIds = msg.info;
        });
        $scope.$on("themeIds", function (e, msg) {
            $scope.themeIds = msg.info;
        });
        $scope.$on("styleIds", function (e, msg) {
            $scope.styleIds = msg.info;
        });
        $scope.filtersecondList = ['040207','040208','040209','040210','040211','040305','040306','040307','040308','040309','040310','040311','040405','040406','040407','040705','040706','040707','040708','040806','040807','040808','040809','040810','040811','040904','040905','041110','041111','041112','041113','041114','041115','041116','041117','041118','041119','041120','041121','041122','041123','041306','041307','041308','041309','041310','041411','041412','041413','041414','041415','041416','041417','041418','041419'];
        $scope.$on("firstId", function (e, msg) {
            $scope.firstId = msg.info.itemCode;
            $scope.tagList.app.filter(function (item) {
                if ($scope.firstId == item.itemCode) {
                    if(infoId){
                        $scope.secondList = item.child
                    } else {
                        $scope.secondList = item.child.filter(function (data) {
                            return $scope.filtersecondList.indexOf(data.itemCode)==-1
                        });
                    }
                }
            });
        });
        $scope.$on("secondId", function (e, msg) {
            $scope.secondId = msg.info.itemCode;
        });
        $scope.ckSync = function () {
            $scope.sync = !$scope.sync;

            if ($scope.sync == true) {
                ToolService.showTips($filter('translate')("所有推广活动的下载地址将同步更新。"), 2000);
            }
        }
        var init = function () {
            if (infoId != null) {//修改的时候id不为空，根据id查询详情。
                if ($scope.isLog) {
                    $scope.stepflag = 4;
                }
                else {
                    $scope.stepflag = 2;
                }
                var editPM = HttpService.getInfo("mng/app/find/" + infoId);
                ToolService.showLoading();
                editPM.then(function (data) {
                    $scope.platform = data.platform;
                    $scope.iswx = data.platform == 'wx';
                    $scope.name = oldName = data.name;
                    $scope.url = data.url;
                    $scope.appkey = data.appkey;
                    $scope.onLine = data.whetherOnline || data.whetherOnline == null ? 1:0;
                    // || data.whetherAppointmentMonitor == null
                    $scope.monitor = data.whetherAppointmentMonitor ? 1:0;
                    $scope.onlineDateEdit = data.onlineDate;
                    $scope.beginDate = data.onlineDate?data.onlineDate:'请选择日期';
                    var currentTime =new Date().Format('yyyy-MM-dd');
                    if(data.onlineDate && currentTime>=data.onlineDate){// 当前日期>预计上线日期，产品已上线，三个选项均不可更改
                        $scope.timeDisable = true;
                    }else{
                        $scope.timeDisable = false;
                    }
                    $scope.industory = data.industory;
                    $scope.debugDays = data.debugDate ? DateService.getDaysNum(new Date().Format('yyyy-MM-dd'), data.debugDate) : 0;
                    // $scope.sync = data.sync;
                    $scope.sync = false;
                    $scope.bundleid = boundOldID = data.bundleid;
                    if($scope.platform == 'Android' && (loginuserName == 'trackingio@webeye.com' || loginuserName == 'trackingio@reyun.com' || $scope.rootParentDl =='38' || $scope.rootParentDl =='27289')){
                        $scope.packageName = data.bundleid
                    }
                    $scope.appTagList = data.appTagList;
                    $scope.mipAppid = oldMipAppid = data.mipAppid;
                    $scope.mipSecret = data.mipSecret;
                    /*$scope.tokenValid = data.tokenValid ;
                    var reg = /{(\d+)\:\"([A-Za-z0-9_-]+)\"}$/;
                    var mess = reg.exec(data.tokenMessage);
                    if(!$scope.tokenValid){
                        if(mess){
                            $scope.tokenMessage = mess[2];
                        }else{
                            $scope.tokenMessage = data.tokenMessage;
                        }
                    }*/
                    var stemp = [], ttemp = [], etemp = [];
                    if (data.tagType == "02") {
                        $scope.appTagList.filter(function (item) {
                            if (item.parentTagId == $scope.tagList.game[0].itemCode) {
                                stemp.push(item.tagId);
                                $scope.typeinitIds = stemp.join(',');
                                $scope.typeIds = stemp.join(',');
                            } else if (item.parentTagId == $scope.tagList.game[1].itemCode) {
                                ttemp.push(item.tagId);
                                $scope.themeinitIds = ttemp.join(',');
                                $scope.themeIds = ttemp.join(',');
                            } else if (item.parentTagId == $scope.tagList.game[2].itemCode) {
                                etemp.push(item.tagId);
                                $scope.styleinitIds = etemp.join(',');
                                $scope.styleIds = etemp.join(',');
                            }
                        });
                        $scope.tagType = "game";
                    } else if (data.tagType == "04") {
                        $scope.secondinitId = $scope.appTagList[0].tagId;
                        $scope.tagList.app.filter(function (p) {
                            if ($scope.appTagList[0].parentTagId == p.itemCode) {
                                $scope.firstinitId = p.itemCode;
                            }
                        });
                        $scope.tagType = "app";
                    } else if (data.tagType == "00") {
                        $scope.tagType = "test";
                    }
                    if ($scope.stepflag == 4) {
                        ToolService.hideLoading();
                        $scope.queryLogInfo();
                    }
                });
                if ($scope.stepflag == 2) {
                    $q.all([typePM, editPM]).then(function (data) {
                        ToolService.hideLoading();
                        var info = data[1];
                        $scope.appGenreInit = info.appGenre;
                        $scope.gameGenreInit = info.gameGenre;
                    });
                }
            } else {
                $scope.stepflag = 1;
                $scope.platform = 'iOS';
                $scope.sync = false;
                $scope.tagList.game[0].child = $scope.tagList.game[0].child.filter(function (data) {
                    return data.itemCode != '020119'
                })
                $scope.tagList.game[2].child = $scope.tagList.game[2].child.filter(function (data) {
                    return data.itemCode != '020715'
                })
                // 过滤app列表 数组中的值不显示
                $scope.filterFirstList = ['0415', '0416', '0417', '0418', '0419', '0420', '0421', '0422', '0423', '0424', '0425', '0426', '0427', '0428', '0429', '0430', '0431']
                $scope.tagList.app = $scope.tagList.app.filter(function (data) {
                    return !$scope.filterFirstList.includes(data.itemCode)
                    // return data.itemCode != '0401'&&data.itemCode != '0402'&&data.itemCode != '0403'&&data.itemCode != '0404'&&data.itemCode != '0405'&&data.itemCode != '0406'&&data.itemCode != '0408'&&data.itemCode != '0409'&&data.itemCode != '0410'&&data.itemCode != '0412'&&data.itemCode != '0413'&&data.itemCode != '0415'&&data.itemCode != '0416'&&data.itemCode != '0418'&&data.itemCode != '0419'&&data.itemCode != '0420'
                })
            }
        }

        $scope.nameHas = false;
        $scope.exixtName = function () {
            if (!$scope.tip) {
                $scope.tip = {};
            }
            if ($scope.judgeNameChange(oldName, $scope.name)) {
                ToolService.showLoading();
                var existPM = HttpService.getInfo("mng/app/validname", {
                    name: $scope.name
                });
                existPM.then(function (data) {
                    ToolService.hideLoading();
                    if (data == true) {
                        $scope.tip.name = {
                            status: true,
                            txt: $filter('translate')("名称已存在")
                        };
                        $scope.nameHas = true;
                    } else {
                        $scope.tip.name = {
                            status: false
                        };
                        $scope.nameHas = false;
                    }
                });
            } else {
                $scope.tip.name = {
                    status: false
                };
                $scope.nameHas = false;
            }
        }

        $scope.bundleHas = false;
        $scope.existBundleid = function (flag) {
            if (!$scope.tip) {
                $scope.tip = {};
            }
            if ($scope.judgeNameChange(boundOldID, $scope.bundleid)) {
                ToolService.showLoading();
                var existPM = HttpService.getInfo("mng/app/valid", {
                    name: $scope.bundleid
                });
                existPM.then(function (data) {
                    ToolService.hideLoading();
                    if (data == true) {
                        $scope.tip.bundleid = {
                            status: true,
                            txt: $filter('translate')("bundleid已存在")
                        };
                        $scope.bundleHas = true;
                    } else {
                        $scope.tip.bundleid = {
                            status: false
                        };
                        $scope.bundleHas = false;
                    }
                });
            } else {
                $scope.tip.bundleid = {
                    status: false
                };
                $scope.bundleHas = false;
            }
        }

        $scope.save = function () {
            if ($scope.nameHas || $scope.bundleHas || $scope.appidHas) {
                return false;
            }
            var appTagList = [],
                isnull = false,
                tag = "00";
            if ($scope.platform!=$scope.platformList[5]) {
                if ($scope.tagType == 'game') {
                    $scope.typenull = !$scope.typeIds;
                    $scope.themenull = !$scope.themeIds;
                    $scope.stylenull = !$scope.styleIds;
                    if ($scope.typenull || $scope.themenull || $scope.stylenull) {
                        isnull = true;
                    } else {
                        tag = "02";
                        $scope.typeIds.split(",").filter(function (item) {
                            appTagList.push({
                                tagId: item
                            });
                        });
                        $scope.themeIds.split(",").filter(function (item) {
                            appTagList.push({
                                tagId: item
                            });
                        });
                        $scope.styleIds.split(",").filter(function (item) {
                            appTagList.push({
                                tagId: item
                            });
                        });
                    }

                } else if ($scope.tagType == 'app') {
                    $scope.firstnull = !$scope.firstId;
                    if ($scope.firstId) {
                        $scope.secondnull = !$scope.secondId;
                    }
                    if ($scope.firstnull || $scope.secondnull) {
                        isnull = true;
                    } else {
                        tag = "04";
                        // $scope.firstId.split(",").filter(function(item){
                        //      appTagList.push({tagId:item});
                        // });
                        $scope.secondId.split(",").filter(function (item) {
                            appTagList.push({tagId: item});
                        });
                    }
                }
            }
            var par = {
                platform: $scope.platform,
                name: $scope.name,
                appGenre: $scope.appGenre,
                sync: $scope.sync,
                url: $scope.url,
                appTagList: appTagList,
                tagType: tag,
                industory: $scope.industory
            };
            if ($scope.appGenre == gameTypeId) {
                par.gameGenre = $scope.gameGenre;
            } else {
                par.gameGenre = -1;
            }

            if(par.platform == 'Android' || par.platform == 'iOS'){
                if($scope.onLine == -1){
                    $scope.onlineStatus = true;
                    // ToolService.showTips("请选择产品是否已上线");
                    return false;
                }else{
                    $scope.onlineStatus = false;
                }
                par.whetherOnline = $scope.onLine == 1 ? true: false;
                if($scope.onLine == 0){
                    par.whetherAppointmentMonitor = $scope.monitor == 1? true:false;
                }else{
                    par.whetherAppointmentMonitor = null;
                    par.onlineDate = null;
                }
                if($scope.monitor == 1 && $scope.onLine == 0){
                    if($scope.beginDate == "请选择日期"){
                        $scope.dataStatus = true;
                        // ToolService.showTips("请选择预计发布日期");
                        return false;
                    }else{
                        $scope.dataStatus = false;
                    }
                    par.onlineDate = $scope.beginDate;
                }
            }

            var verPar = {
                name: {
                    key: 'nameFormat',
                    val: $scope.name
                },
                url: {
                    key: 'url',
                    val: $scope.url,
                    txt: $filter('translate')("以http://或https://开头的合法url")
                }
            };
            // 这个两个账号显示 应用包名
            if($scope.platform == 'Android' && (loginuserName == 'trackingio@webeye.com' || loginuserName == 'trackingio@reyun.com' || $scope.rootParentDl =='38' || $scope.rootParentDl =='27289')){
                par["bundleid"] = $scope.packageName;
                verPar.packageName ={
                    key: 'isNull',
                    val: $scope.packageName,
                }
            }
            if ($scope.platform == 'iOS') {
                par["bundleid"] = $scope.bundleid;
                verPar.bundleid = {
                    key: "bundleid",
                    min: 9,
                    max: 13,
                    val: $scope.bundleid,
                    txt: $filter('translate')('请输入9-13位数字或字母')
                }
            } else if ($scope.platform == $scope.platformList[3] || $scope.platform == $scope.platformList[4]) {
                Object.assign(par, {
                    mipAppid: $scope.mipAppid,
                    mipSecret: $scope.mipSecret,
                });
                Object.assign(verPar, {
                    mipAppid: {
                        key: 'isNull',
                        val: $scope.mipAppid,
                    },
                    mipSecret: {
                        key: 'isNull',
                        val: $scope.mipSecret,
                    }
                });
                delete par.url;
                delete verPar.url;
            }
            /*else if($scope.platform== $scope.platformList[4]){
                          Object.assign(par,{
                              mipAppid:$scope.mipAppid,
                          });
                          Object.assign(verPar,{
                              mipAppid:{
                                  key:'isNull',
                                  val:$scope.mipAppid,
                              },
                          });
                          delete par.url;
                          delete verPar.url;
                      }*/

            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true || isnull) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            if ($scope.platform == $scope.platformList[3]||$scope.platform == $scope.platformList[4]) {
                $scope.verMiniAppidSecret(par);
            } else {
                $scope.execSave(par);
            }
            
        }
        
        /**
         * 执行保存或修改请求
         * @param par
         */
        $scope.execSave = function (par) {
            if ($scope.nameHas || $scope.bundleHas || $scope.appidHas) {
                return false;
            }
            var savePM = null, txtTips = $filter('translate')("添加成功");
            if (infoId != null) {
                par.id = infoId;
                savePM = HttpService.putInfo("mng/app/update", par);
                txtTips = $filter('translate')("修改成功");
            } else {
                savePM = HttpService.postInfo("mng/app/create", par);
            }
            ToolService.showLoading();
            savePM.then(function (data) {
                if (data.code && data.code !== 200) {
                    ToolService.hideLoading();
                    ToolService.showTips(data.message);
                } else if (infoId != null) {
                    ToolService.hideLoading();
                    ToolService.showTips(txtTips);
                    $scope.cancel();
                } else if (data.id) {
                    $scope.$emit("f5Applist", 1);
                    $scope.id = data.id;
                    $scope.name = data.name;
                    $scope.appkey = data.appkey;
                    ToolService.hideLoading();
                    if ($scope.platform==$scope.platformList[5]) {
                        $state.go("collect.app");
                    } else {
                        $scope.stepflag = 3;
                    }
                    $rootScope.operSubmitData($filter('translate')("新建"));
                } else {
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("未知错误"));
                }
            }).catch(function (data) {
                ToolService.hideLoading();
                ToolService.showTips(data.message);
            });
        }

        $scope.cancel = function (flag) {
            if (flag) {
                $rootScope.isDebug = false;
            }
            $scope.$emit("f5Applist", true);
            $state.go("collect.app");
        }

        $scope.changeStep = function () {
            if ($scope.stepflag == 4) {
                $scope.stepflag = 3;
            }
        }

        $scope.deviceList = [{
            'id': 1,
            name: $filter('translate')("全部设备")
        }];
        $scope.deviceInit = $scope.deviceList[0].id;
        $scope.$on("deviceId", function (e, msg) {
            if (msg.info.id == 1) {
                $scope.deviceTxt = "";
            } else {
                $scope.deviceTxt = msg.info.id;
            }
        });

        var getV = function (v) {
            if (UtilService.isNullStr(v)) {
                return "";
            } else {
                return v;
            }
        }
        $scope.queryLogInfo = function () {
            $scope.logFlag = 0;
            ToolService.showLoading();
            var testPM = HttpService.getInfo("mng/app/debug/event/list/" + $scope.id),
                logPM = HttpService.getInfo("mng/app/debug/log/list/" + $scope.id),
                totalPM = HttpService.getInfo("mng/app/debug/device/list/" + $scope.id);

            $scope.hasZeroEvt = 0;
            $q.all([testPM, logPM, totalPM]).then(function (data) {
                $scope.testInfos = data[0];
                $scope.testInfos.filter(function (item) {
                    if ($scope.platform == "H5") {
                        if (['pageview'].indexOf(item.eventName) > -1 && item.eventNumber == 0) {
                            $scope.hasZeroEvt++;
                        }
                    } else if ($scope.platform == "wx" || $scope.platform == "wg") {
                        if (['launch'].indexOf(item.eventName) > -1 && item.eventNumber == 0) {
                            $scope.hasZeroEvt++;
                        }
                    } else if ($scope.paramsList && $scope.platform == $scope.paramsList[3]) {
                        if (['launch', 'pageview'].indexOf(item.eventName) > -1 && item.eventNumber == 0) {
                            $scope.hasZeroEvt++;
                        }
                    } else {
                        if (['startup', 'install'].indexOf(item.eventName) > -1 && item.eventNumber == 0) {
                            $scope.hasZeroEvt++;
                        }
                    }

                });
                var logs = data[1];
                logs.map(function (item) {
                    item.xcontext = JSON.parse(item.xcontext);

                    item.xcontext.osname = getV(item.xcontext._ryos || item.xcontext._os) + '' + getV(item.xcontext._ryosversion);
                    item.xcontext.channel = item.xcontext._campaignid || item.xcontext.channelid;
                    item.deviceId = item.xcontext._deviceid;

                    item._network_type = item.xcontext._network_type || item.xcontext._network;
                    item._model = item.xcontext._model || item.xcontext._devicetype;
                });
                $scope.logInfos = logs;
                $scope.totalInfos = data[2];

                var devList = [{'id': 1, name: $filter('translate')("全部设备")}];
                $scope.totalInfos.filter(function (item) {
                    devList.push({id: item.deviceId, name: item.deviceId});
                });
                $scope.deviceList = devList;
                $rootScope.operSubmitData($filter('translate')("下一步"));
                ToolService.hideLoading();
            });
        }
        $scope.getPlatClass = function (plat) {
            var plat = $filter("lowercase")(plat);
            return {'ios': 'apple', 'android': 'android', 'h5': 'web'}[plat];
        }
        $scope.nextStep = function () {
            $scope.stepflag = 4;
            $scope.queryLogInfo();
        }
        $scope.lookEvents = function (info) {
            $scope.eventDetails = [
                {name: $filter('translate')('时间'), key: 'xwhen'},
                {name: $filter('translate')('设备ID'), key: '_deviceid', second: true},
                {name: 'APPKEY', key: '', value: $scope.appkey},
                {name: $filter('translate')('应用名称'), key: '', value: $scope.name},
                {name: $filter('translate')('分包渠道'), key: 'channel', second: true},
                {name: $filter('translate')('系统'), key: 'osname', second: true},
                {name: $filter('translate')('机型'), key: '_model'},
                {name: $filter('translate')('分辨率'), key: '_resolution', second: true},
                {name: $filter('translate')('网络'), key: '_network_type'},
                {name: $filter('translate')('SDK版本'), key: '_lib_version', second: true},
                {name: $filter('translate')('事件ID'), key: 'xwhat', isevent: true},
                {name: $filter('translate')('事件名称'), key: 'eventName'}
            ];
            $scope.curEvtLogInfo = info;

            $scope.logFlag = 1;
            ToolService.showAlp();
            angular.element(document).on("click", function () {
                $scope.$apply(function () {
                    $scope.hideDetails();
                });
            });
        }
        $scope.commonParams = null;
        $scope.lookParams = function (info) {
            var getEventParams = function () {
                var xcontext = $scope.curEvtLogInfo.xcontext;
                var myparams = [];
                for (var k in xcontext) {
                    var temp = {
                        'name': k,
                        'value': xcontext[k],
                        sortId: 100
                    };
                    if (k.indexOf("_") == 0) {
                        var ccc = $scope.commonParams[k];
                        if (ccc) {
                            temp.name = ccc.alias;
                            temp.sortId = ccc.sortId;
                        }
                        myparams.push(temp);
                    } else {
                        myparams.push(temp);
                    }
                }
                UtilService.sortArray(myparams);
                $scope.paramsList = myparams;
                $scope.logFlag = 2;
            }
            if ($scope.commonParams != null) {
                getEventParams();
            } else {
                ToolService.showLoading();
                var evtPM = HttpService.getInfo("mng/app/debug/find/common");
                evtPM.then(function (data) {
                    ToolService.hideLoading();
                    var json = {};
                    data.filter(function (item) {
                        json[item.param] = item;
                    });
                    $scope.commonParams = json;
                    getEventParams();
                });
            }
        }

        $scope.hideDetails = function () {
            ToolService.hideAlp();
            $scope.logFlag = 0;
        }
        $scope.finisStep = function () {
            ToolService.showLoading();
            var finshPM = HttpService.putInfo("mng/app/debug/complete/" + $scope.id);
            finshPM.then(function (data) {
                // console.log(data);
                $scope.cancel(1);
                $rootScope.operSubmitData($filter('translate')("调试完成"));
            });
        }
        $timeout(function () {
            var clipboard = new Clipboard('.sdkAppid');
            clipboard.on('success', function (e) {
                $scope.$apply(function () {
                    ToolService.showTips($filter('translate')("复制成功"));
                });
            });
            clipboard.on('error', function (e) {
                $scope.$apply(function () {
                    ToolService.showTips($filter('translate')("复制失败"));
                });
            });
        }, 200);
        /**
         * 微信小程序appid校验
         */
        $scope.appidHas = false;
        $scope.existMiniAppid = function () {
            if ($scope.judgeNameChange(oldMipAppid, $scope.mipAppid)) {
                ToolService.showLoading();
                if (!$scope.tip) {
                    $scope.tip = {};
                }
                var pm = HttpService.getInfo("mng/mip/valid", {mipAppid: $scope.mipAppid});
                pm.then(function (data) {
                    ToolService.hideLoading();
                    if (data === true) {
                        $scope.tip.mipAppid = {
                            status: false
                        };
                        $scope.appidHas = false;
                    } else {
                        $scope.tip.mipAppid = {
                            status: true,
                            txt: $filter('translate')("名称已存在")
                        };
                        $scope.appidHas = true;
                        ToolService.showTips($filter('translate')("系统已存在，不可再创建。"));//appkey：XXX。
                    }
                });
            }
        }
        /**
         *
         * @param par
         */
        $scope.verMiniAppidSecret = function (par) {
            ToolService.showLoading();
            var pm = HttpService.postInfo("mng/mip/getToken", {
                "mipAppid": $scope.mipAppid,
                "mipSecret": $scope.mipSecret
            })
            pm.then(function (data) {
                ToolService.hideLoading();
                for (var k in data) {
                    if (k == 200) {
                        Object.assign(par, {accessToken: data[k]});
                        $scope.execSave(par);
                    } else {
                        $scope.setErrorMessage("wx", $filter('translate')("创建失败，appid或appsecret错误，") + data[k]);
                    }
                }
            });
        }
        /**
         * 设置表单某项的错误信息
         * @param key
         * @param error
         */
        $scope.setErrorMessage = function (key, error) {
            if (!$scope.tip) {
                $scope.tip = {};
            }
            $scope.tip[key] = {
                status: true,
                txt: error
            }
        }

        $scope.$watch("lang",function(val,oldVal){
            if(val && oldVal && val!==oldVal) {
                initInit();
            }
        });
        // $scope.isTestUser = ToolService.isUser(ArrayConstant.wxTestEmail) || ToolService.isUser(ArrayConstant.trackIoEmail) || ToolService.isUser(ArrayConstant.wxTestEmail2);
        /**
         * 微信小程序app secret唯一性验证
         */
        /*$scope.existMiniSecret = function(){
            if(!$scope.mipSecret){
                ToolService.showLoading();
                if (!$scope.tip) {
                    $scope.tip = {};
                }
                var pm = HttpService.getInfo("");
                pm.then(function(data){
                    ToolService.hideLoading();
                    if (data == true) {
                        $scope.tip.mipSecret = {
                            status: true,
                            txt: "名称已存在"
                        };
                        ToolService.showTips("系统已存在，不可再创建。appkey：XXX。");
                        // $scope.nameHas = true;
                    } else {
                        $scope.tip.mipSecret = {
                            status: false
                        };
                        // $scope.nameHas = false;
                    }
                });
            }
        }*/
    }
})();
