(function() {
    angular.module("app.manage")
        .controller("authCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$translate", authCtrl])
        .controller("authDetailCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$translate", authDetailCtrl])
        .controller("authpowerCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$translate", authpowerCtrl]);

    function authCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $translate) {
        //判断当前账户是否为demo账户
        $scope.demoUSuper = UtilService.getCookie("ryioUname") == 'demoadmin@reyun.com';
        //alert($scope.demoUSuper)
        var firstLoading = true;
        var init = function() {
            $scope.deviceList = [
                { id: 1, name: $translate.instant("已启用") },
                { id: 2, name: $translate.instant("已停用") }
            ];

            $scope.deviceInit = $scope.deviceList[0].id;

            $scope.roleList = [
                { id: "all", name: $translate.instant("全部角色") },
                { id: 1, name: $translate.instant("管理员") },
                { id: 2, name: $translate.instant("子应用管理员") },
                { id: 3, name: $translate.instant("普通账号") },
                { id: 5, name: $translate.instant("渠道账号") }
            ];

            $scope.roleInit = $scope.roleList[0].id;
        }

        init();
        $scope.sendEve = function() {
            ToolService.sendBehaviorUv("search");
        }

        $scope.$on("deviceId", function(e, msg) {
            $scope.seeFlag = msg.info.id;
            if ($scope.seeFlag == 1) {
                $scope.findName = 'enable';
            } else {
                $scope.findName = 'disable';
            }
            if (firstLoading) {
                firstLoading = false;
            } else {
                $scope.query();
            }
        });

        if (!$rootScope.accountFlag) {
            $rootScope.accountFlag = "account";
        }

        var allInfoList = [];

        $scope.$on("roleId", function(e, msg) {
            $scope.curRoleID = msg.info.id;
            $scope.filterAuthList();
        });

        $scope.filterAuthList = function() {
            if (allInfoList) {
                var id = $scope.curRoleID;
                if (id == 'all') {
                    $scope.authList = allInfoList;
                } else if (id == 3) {
                    $scope.authList = allInfoList.filter(function(item) {
                        return item.roleCategory != 1 && item.roleCategory != 2 && item.roleCategory != 5;
                    });
                } else {
                    $scope.authList = allInfoList.filter(function(item) {
                        return item.roleCategory == id;
                    });
                }
            }
        }

        $scope.query = function(flag) {
            if (flag) {
                $rootScope.accountFlag = flag;
                $rootScope.thirdtab = { 'channel': $translate.instant('渠道账号管理'), 'account': $translate.instant('子账号管理') }[flag];
            }
            if (angular.isUndefined($scope.findName)) {
                return false;
            }

            $scope.authList = [];

            var authPM = HttpService.getInfo("mng/auth/list/" + $scope.findName);
            ToolService.showLoading();
            authPM.then(function(data) {
                ToolService.hideLoading();
                allInfoList = $scope.authList = data;
                $scope.filterAuthList();
            });
        }

        $scope.query();

        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;
        });

        $scope.onUser = function(id) {
            ToolService.showLoading();
            var userPM = HttpService.putInfo("mng/auth/" + id + "/enable");
            userPM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($translate.instant("启用成功"));
                $rootScope.operSubmitData($translate.instant("启用"));
                $scope.query();
            }, function(data) {
                ToolService.hideLoading();
                if (data.code == -300) {
                    ToolService.showTips($translate.instant("管理员权限数量已达上限"));
                }


            });
        }

        $scope.offUser = function(id) {
            ToolService.sendBehaviorUv("offUser");
            var userPM = HttpService.putInfo("mng/auth/" + id + "/disable");
            ToolService.showLoading();
            userPM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($translate.instant("停用成功"));
                $rootScope.operSubmitData($translate.instant("停用"));
                $scope.query();
            })

        }

        $scope.deleteAuth = function(d) {
            ToolService.sendBehaviorUv("deleteAuth");
            $scope.delInfo = d;
            $scope.wantDelete = true;
            ToolService.showAlp();
        }

        $scope.doDelete = function() {
            $scope.closeWin();
            ToolService.showLoading();
            var deletePM = HttpService.deleteInfo("mng/auth/" + $scope.delInfo.id + "/delete");
            deletePM.then(function(data) {
                ToolService.hideLoading();
                if (data) {
                    ToolService.showTips($translate.instant("删除成功"));
                    $scope.query();
                } else {
                    ToolService.showTips($translate.instant("该账号已激活，不支持删除，您可以在右侧操作区对账号进行停用。"));
                }
            });
        }

        $scope.sendEmailAgain = function(send) {
            ToolService.sendBehaviorUv("sendEmailAgain");
            var sendPM = HttpService.postInfo("mng/auth/mail/" + send.id + "/resend");
            ToolService.showLoading();
            sendPM.then(function(data) {
                ToolService.hideLoading();
                send.send = 1;
                ToolService.showTips($translate.instant("发送成功"));
            });
        }

        $scope.closeWin = function(flag) {
            $scope.wantDelete = false;
            ToolService.hideAlp();
        }

        $scope.gopage = function(info) {
            ToolService.sendBehaviorUv("gopage");
            if (angular.isDefined(info)) {
                if (!info.valid) {
                    return false;
                }

                $state.go("collect.authDetail", { aid: info.id });
            } else {
                $state.go("collect.authDetail");
            }
        }

        $scope.givePower = function(info) { //账号信息
            ToolService.sendBehaviorUv("givePower");
            $state.go("collect.authpower", { aid: info.id }); //传参账号id
        }

        $scope.getSuburl = function() {
            var suburl = "";
            if ($rootScope.accountFlag == 'channel') {
                suburl = "/channel";
            }
            return suburl;
        }

        $scope.isdetail = false;
        $scope.showDetails = function(info) {
            ToolService.sendBehaviorUv("showDetails");
            $scope.detailInfo = info;
            ToolService.showAlp();
            $scope.isdetail = true;
            angular.element(document).on("click", function() {
                $scope.$apply(function() {
                    $scope.hideDetails();
                });
            });
        }

        $scope.hideDetails = function() {
            ToolService.hideAlp();
            $scope.isdetail = false;
        }

        $scope.$watch("lang", function(val, oldVal) {
            if (val && oldVal && val !== oldVal) {
                init();
                $scope.query();
            }
        });

    }

    var copyArray = function(arr) {
        return $.extend(true, [], arr);
    }

    function authDetailCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $translate) {

        var infoId = $scope.id = $stateParams.aid;

        $scope.init = function(otherpowers) {
            if (!UtilService.isNullStr(infoId)) {
                ToolService.showLoading();
                var accountPM = HttpService.getInfo("mng/auth/" + infoId + "/find");
                accountPM.then(function(data) {
                    ToolService.hideLoading();

                    $scope.accountInfo = data;
                    $scope.email = $scope.oldEmail = data.email;
                    $scope.name = data.name;
                    $scope.remark = data.remark;
                    $scope.parentRole = data.parentRole;
                    $scope.roleCategory = data.roleCategory;

                });
            } else {
                $scope.email = $scope.oldEmail = "";
                $scope.name = "";
                $scope.remark = "";
                $scope.roleCategory = 0;
            }
        }
        $scope.init();

        $scope.changeRole = function(role) {
            if (infoId) {
                if ($scope.roleCategory == 5) {
                    ToolService.showTips($translate.instant("渠道账号不能修改为其他角色账号"));
                    return false;
                } else if (role == 5) {
                    ToolService.showTips($translate.instant("当前角色账号不能修改为渠道账号"));
                    return false;
                }

                if ($scope.roleCategory > 5 && role == 3) {
                    //普通角色当前点击
                } else {
                    $scope.roleCategory = role;
                }
            } else {
                $scope.roleCategory = role;
            }
        }

        $scope.save = function() {
            var par = {
                "email": $scope.email,
                "name": $scope.name,
                "roleCategory": $scope.roleCategory,
                "remark": $scope.remark
            };
            var verPar = {
                email: {
                    key: "email",
                    val: par.email,
                    nullTxt: $translate.instant("请填写邮箱")
                },
                name: {
                    key: "numLetter",
                    val: par.name,
                    nullTxt: $translate.instant("请填写姓名"),
                    max: 20,
                    txt: $translate.instant("请输入20位以内的中英文或数字")
                }
            };
            if (!UtilService.isNullStr(par.remark)) {
                verPar.remark = {
                    key: 'nameLen',
                    val: par.remark,
                    max: 200,
                    txt: $translate.instant('最多可输入100字')
                }
            }

            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            } else if ($scope.roleCategory == 0) {
                ToolService.showTips($translate.instant("请选择角色"));
                return false;
            }

            var savePM = null;
            if (infoId != null) {
                par.id = infoId;
                savePM = HttpService.putInfo("mng/auth/" + infoId + "/update", par);
            } else {
                savePM = HttpService.postInfo("mng/auth/create", par);
            }
            ToolService.showLoading();
            savePM.then(function(data) {
                if (data.code == -6001) {
                    ToolService.hideLoading();
                    ToolService.showTips($translate.instant("该邮箱已创建"));
                } else if (data.code == -300) {
                    ToolService.hideLoading();
                    ToolService.showTips($translate.instant("管理员权限数量已达上限"));
                    // ToolService.showTips($translate.instant("最多可添加3个管理员"));
                } else if (data.code == -6004) {
                    ToolService.hideLoading();
                    ToolService.showTips(data.message);
                } else {
                    ToolService.hideLoading();
                    if (!infoId) {
                        $rootScope.operSubmitData($translate.instant("新建"));
                        if (($scope.roleCategory == 5 && data.firstSend) || $scope.roleCategory != 5) {
                            $scope.firstchannel = true;
                        } else {
                            $scope.firstchannel = false;
                        }
                        $scope.newID = data.id;
                        $scope.showTipWin();
                    } else {
                        ToolService.showTips($translate.instant("修改成功"));
                        $scope.cancel();
                    }
                }
            }, function(data) {
                if (data.code == -6001) { 
                    ToolService.hideLoading();
                    ToolService.showTips($translate.instant("该邮箱已创建"));
                } else if (data.code == -300) {
                    ToolService.hideLoading();
                    ToolService.showTips($translate.instant("最多可添加3个管理员"));
                } else if (data.code == -6004) {
                    ToolService.hideLoading();
                    ToolService.showTips(data.message);
                }
            });
        }

        $scope.cancel = function() {
            $state.go("collect.auth");
        }

        $scope.winFlag = 0;
        $scope.showTipWin = function() {
            $scope.winFlag = 1;
            ToolService.showAlp();
        }
        $scope.closeWin = function() {
            $scope.winFlag = 0;
            ToolService.hideAlp();
        }
        $scope.doPower = function() {
                $state.go("collect.authpower", { aid: $scope.newID });
            }
            /**
             * 语言切换监听
             */
        $scope.$watch("lang", function(val, oldVal) {
            if (val && oldVal && val !== oldVal) {
                $scope.init();
            }
        });
    }

    function authpowerCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $translate) {
        var infoId = $scope.id = $stateParams.aid; //账号id
        $scope.$watch("applistInfo", function(data) { //对‘产品列表’监听
            if (angular.isDefined(data)) {
                $scope.authapplist = copyArray(data);
                if ($scope.isAppManage && !UtilService.isNullStr(infoId)) {
                    var hasAuthAppsPM = HttpService.getInfo("app/find/" + infoId + "/AuthApp");
                    hasAuthAppsPM.then(function(data) {
                        $scope.init(data);
                    });
                } else {
                    $scope.init();
                }
            }
        });

        var rolePM = null;
        //查找所有的角色
        $scope.queryRoleList = function() {
            rolePM = HttpService.getInfo("mng/auth/role/find");
            rolePM.then(function(data) {
                data.unshift({ id: 3, roleName: $translate.instant('自定义权限') })
                $scope.roleList = data;
            });
        }
        var roleAuthDic = {};
        $scope.changeRole = function(role) {
            var roleId = role.id;
            var set = function() {
                for (var k in $scope.authJSON) {
                    $scope.authJSON[k].payAuth = roleAuthDic[roleId].payAuth;
                    $scope.authJSON[k].retentionAuth = roleAuthDic[roleId].retentionAuth;
                    $scope.authJSON[k].orderAuth = roleAuthDic[roleId].orderAuth;
                    $scope.authJSON[k].arouseAuth = roleAuthDic[roleId].arouseAuth;
                    $scope.authJSON[k].eventAuth = roleAuthDic[roleId].eventAuth;

                    if ($scope.curAuthApp.industory == 'ec') {
                        $scope.authJSON[k].payEnable = $scope.authJSON[k].orderAuth ? true : false;
                        $scope.authJSON[k].payAuth = $scope.authJSON[k].orderAuth ? $scope.authJSON[k].payAuth : false;
                    } else {
                        $scope.authJSON[k].payEnable = true;
                    }
                    $scope.authJSON[k].isNatureOpen = roleAuthDic[roleId].isNatureOpen;
                    $scope.authJSON[k].topAuth = roleAuthDic[roleId].topAuth;
                    $scope.authJSON[k].menus = copyArray(roleAuthDic[roleId].menus);
                }
                $scope.curAuthInfos = $scope.authMenuList = $scope.authJSON[$scope.curAuthApp.id].menus;
            }
            if (roleAuthDic[roleId]) {
                set();
            } else { //当前没有该用户角色的菜单权限时，去后台查询
                var menuPM = HttpService.getInfo("mng/auth/" + roleId + "/findMenu"); //查询用户角色对菜单的权限
                menuPM.then(function(data) {
                    // office用户权限配置 回流分析如果没选中的话 普通成员等需要配置页面权得的用户 在配置权限时不显示回流分析选择框
                    if(!$rootScope.permissionMenus.refluxanalysis || !$rootScope.permissionMenus.refluxanalysis.has_auth){
                        data.roleAuthDetails.forEach(function(temp,i){
                            if(temp.auth == "refluxanalysis"){
                                data.roleAuthDetails.splice(i,1)
                            }
                        })
                    }
                    $scope.authMenuList = $scope.solveMenus(data.roleAuthDetails);
                    roleAuthDic[roleId] = {
                        menus: $scope.authMenuList,
                        payAuth: data.payAuth,
                        retentionAuth: data.retentionAuth,
                        orderAuth: data.orderAuth,
                        isNatureOpen: data.isNatureOpen,
                        topAuth: data.topAuth,
                        arouseAuth: data.arouseAuth || false,
                        eventAuth: data.eventAuth || false
                    }
                    set();
                });
            }
            $scope.roleCategory = roleId;
        }

        $scope.dataAuthList = [
            { id: 'isNatureOpen', name: $translate.instant('自然量'), tips: $translate.instant('勾选后可以查看仪表盘和报表中的自然量数据统计。') },
            { id: 'retentionAuth', name: $translate.instant('留存'), tips: $translate.instant('勾选后可以查看仪表盘和报表中的留存数据统计。') },
            { id: 'orderAuth', name: $translate.instant('订单'), tips: $translate.instant('勾选后可以查看仪表盘和报表中的订单数据统计。') },
            { id: 'payAuth', name: $translate.instant('付费'), tips: $translate.instant('勾选后可以查看仪表盘和报表中与付费相关的数据统计。') },
            { id: 'topAuth', name: $translate.instant('TOP指标'), tips: $translate.instant('勾选后可以查看仪表盘和渠道效果对比中的TOP指标数据统计。') },
            { id: 'arouseAuth', name: $translate.instant('调起'), tips: $translate.instant('勾选后可以查看推广活动详情中的调起数据统计') },
            { id: 'eventAuth', name: $translate.instant('自定义事件'), tips: $translate.instant('勾选后可以查看推广活动详情、投放广告详情、分包推广详情、再营销活动详情、用户生命周期回流分析报表中自定义事件统计') }
        ];

        $scope.init = function(otherpowers) { //otherpowers 新的产品列表
            $scope.dataTips = true;
            $scope.authJSON = {};
            $scope.queryRoleList();
            $q.all([rolePM]).then(function() {
                if (!UtilService.isNullStr(infoId)) {
                    ToolService.showLoading();
                    var accountPM = HttpService.getInfo("mng/auth/" + infoId + "/find"); //infoId 用户ID
                    accountPM.then(function(data) {
                        ToolService.hideLoading();
                        $scope.accountInfo = data;
                        $scope.email = $scope.oldEmail = data.email;
                        $scope.name = data.name;
                        $scope.remark = data.remark;
                        $scope.parentRole = data.parentRole;

                        $scope.roleCategory = data.roleCategory;
                        if ($scope.roleCategory == 2) {
                            $scope.authapplist = copyArray($scope.appAlllistInfo);
                        } else {
                            $scope.authapplist = copyArray($scope.applistInfo);
                        }
                        //产品列表变动时，更新用户下的产品列表
                        if ($scope.isAppManage) {
                            var appids = [];
                            $scope.authapplist.filter(function(item) {
                                appids.push(item.id);
                            });
                            otherpowers.filter(function(item) {
                                if (appids.indexOf(item.id) == -1) {
                                    item.nopower = true; //当前子应用没有该app权限
                                    $scope.authapplist.push(item);
                                }
                            });
                        }

                        var setPower = function() {
                            var authStr = data.authList; //用户下产品的权限列表
                            authStr.filter(function(power) {
                                // office用户权限配置 回流分析如果没选中的话 普通成员等需要配置页面权得的用户 在配置权限时不显示回流分析选择框
                                if((!$rootScope.permissionMenus.refluxanalysis || !$rootScope.permissionMenus.refluxanalysis.has_auth)&&power.roleAuthDetailList){
                                    power.roleAuthDetailList.forEach(function(temp,i){
                                        if(temp.auth == "refluxanalysis"){
                                            power.roleAuthDetailList.splice(i,1)
                                        }
                                    })
                                }
                                var curapp = null;
                                for (var i = 0; i < $scope.authapplist.length; i++) {
                                    var appinfo = $scope.authapplist[i];
                                    if (appinfo.id == power.app) { //列表产品id和查询到的产品
                                        $scope.authapplist[i].ischeck = true;
                                        curapp = appinfo;
                                        break;
                                    }
                                }

                                if (curapp != null) {
                                    $scope.authJSON[power.app] = {
                                        menus: $scope.solveMenus(power.roleAuthDetailList),
                                        appname: curapp.name,
                                        nopower: curapp.nopower,
                                        datas: null,
                                        olddatas: power.dataAuth,
                                        payAuth: power.payAuth,
                                        retentionAuth: power.retentionAuth,
                                        orderAuth: power.orderAuth,
                                        isNatureOpen: power.isNatureOpen,
                                        topAuth: power.topAuth,
                                        arouseAuth: power.arouseAuth || false,
                                        eventAuth: power.eventAuth || false,
                                        createAccount: power.createAccount,
                                        createTime: power.createTime
                                    }
                                }
                            });
                        }
                        setPower();
                        var menuPM = HttpService.getInfo("mng/auth/" + $scope.roleCategory + "/findMenu"); //同上
                        menuPM.then(function(data) {
                            // office用户权限配置 回流分析如果没选中的话 普通成员等需要配置页面权得的用户 在配置权限时不显示回流分析选择框
                            if((!$rootScope.permissionMenus.refluxanalysis || !$rootScope.permissionMenus.refluxanalysis.has_auth)&&data.roleAuthDetails){
                                data.roleAuthDetails.forEach(function(temp,i){
                                    if(temp.auth == "refluxanalysis"){
                                        data.roleAuthDetails.splice(i,1)
                                    }
                                })
                            }
                            $scope.authMenuList = $scope.solveMenus(data.roleAuthDetails);
                            roleAuthDic[$scope.roleCategory] = {
                                menus: $scope.authMenuList,
                                payAuth: data.payAuth,
                                retentionAuth: data.retentionAuth,
                                orderAuth: data.orderAuth,
                                isNatureOpen: data.isNatureOpen,
                                topAuth: data.topAuth,
                                eventAuth: data.eventAuth,
                            }

                            if ($scope.roleCategory > 5) {
                                for (var k in $scope.authJSON) {
                                    $scope.authJSON[k].menus = $scope.authMenuList;
                                }
                            }
                        });

                        switch ($scope.roleCategory) {
                            case 2: //子应用管理员
                                $scope.steps = 1;
                                $scope.maxstep = 1;
                                break;
                            case 3: //自定义权限
                            case 5: //渠道账号
                            default:
                                $scope.steps = 1;
                                $scope.maxstep = 3;
                                break;
                        }

                        $scope.steps = 1;
                        if ($scope.roleCategory == 1) {
                            $scope.steps = 0;
                            $scope.maxstep = 0;
                        } else if ($scope.roleCategory == 2) { //子应用管理员
                            $scope.maxstep = 1;
                        } else { //自定义、渠道账号
                            $scope.maxstep = 3;
                        }
                    });
                    $scope.allcheck = {
                        app: false,
                        camp: false,
                        auth: false
                    };
                }
            });
        }

        //把菜单列表转化成页面显示结构数据
        $scope.menucate = ['dash', 'admonitor','monetization', 'lifecycle', 'tool', 'export','promotionManagement', 'config', 'senior'];
        $scope.solveMenus = function(list) {
            var authMenuList = [];
            $scope.menucate.filter(function(i) {
                authMenuList.push([])
            })
            if (angular.isArray(list)) {
                list.filter(function(item) {
                    var idx = $scope.menucate.indexOf(item.parentAuth);
                    if (idx > -1) {
                        if ((!$scope.limitInfo || !$scope.limitInfo.platformExport) && item.auth == 'logexport') {
                            //母账户没有导出权限，子账户就没有日志导出权限
                        } else if ($rootScope.fakeType != 2 && item.auth == 'fake') {
                            //母账户没有开通防作弊卫士，子账户就没有此功能
                        } else if (item.auth == 'recycleanalysis') { //去掉回本分析

                        } else {
                            authMenuList[idx].push(item);
                        }
                    } else {
                        var idx = $scope.menucate.indexOf(item.auth);
                        if (idx > -1) {
                            authMenuList[idx].unshift(item);
                        }
                    }
                });
            }
            authMenuList.filter(function(root) {
                root.sort(function(a, b) {
                    return a.sort > b.sort ? 1 : -1;
                });
                root.filter(function(item) {
                    if (angular.isArray(item)) {
                        item.sort(function(a, b) {
                            return a.sort > b.sort ? 1 : -1;
                        });
                    }
                    if (item.children) {
                        item.children.sort(function(a, b) {
                            return a.sort > b.sort ? 1 : -1;
                        });
                    }
                });
            });
            return authMenuList;
        }

        $scope.getMenuTips = function() {
            if ($scope.roleCategory == 3 || $scope.roleCategory == 5) {
                return "";
            } else {
                var currole = $scope.roleList.filter(function(item) {
                    return item.id == $scope.roleCategory;
                });
                if (currole.length > 0) {
                    return $translate.instant("您已对该账号应用“") + currole[0].roleName + $translate.instant("”权限模板，不可再做修改")
                } else {
                    return "";
                }
            }
        }

        //flag:1一级，2二级，3三级,4设置编辑
        $scope.checkMenu = function(flag, menu, iii) {
            if ($scope.isAppManage && $scope.curAuthApp.nopower) {
                return false;
            }

            var txtTips = $scope.getMenuTips();
            if (txtTips != '') {
                ToolService.showTips(txtTips);
                return false;
            }

            var bol;
            if (typeof menu == 'boolean') { //权限全选情况下
                bol = menu;
            } else {
                bol = !menu.view;
                $scope.allcheck['auth'] = false;
            }
            var set = function(list) {
                list.filter(function(menu) {
                    if (menu.auth == 'asmeffectevaluate' && !menu.isshow) return;
                    menu.view = bol;
                    menu.edit = bol;
                    if (menu.children) {
                        set(menu.children);
                    }
                });
            }
            if (flag == 1) {
                set($scope.curAuthInfos[iii]);

            } else if (flag == 2) {
                //没有付费，注收比不可选
                if (menu.auth == 'roi' && !$scope.authJSON[$scope.curAuthApp.id].payAuth) {
                    return false;
                }
                if (menu.auth == "asmeffectevaluate" && !menu.isshow) {
                    return false;
                }
                menu.view = bol;
                menu.edit = bol;
                if (menu.children) {
                    set(menu.children);
                }
            } else if (flag == 3) {
                //没有付费，注收比不可选
                if (menu.auth == 'roi' && !$scope.authJSON[$scope.curAuthApp.id].payAuth) {
                    return false;
                }
                menu.view = bol;
                if (!bol) {
                    menu.edit = false;
                }
                if (iii != undefined && iii.view == true) {
                    var falseNum = 0;
                    for (var i = 0; i < iii.children.length; i++) {
                        if (iii.children[i].view == false) {
                            falseNum = falseNum + 1;
                        }
                    }
                    if (falseNum == iii.children.length) {
                        iii.view = false;
                    }
                } else if (iii != undefined && iii.view == false) {
                    var falseNum = 0;
                    for (var i = 0; i < iii.children.length; i++) {
                        if (iii.children[i].view == true) {
                            falseNum = falseNum + 1;
                        }
                    }
                    if (falseNum > 0) {
                        iii.view = true;
                    }
                }
            } else if (flag == 4) {
                if (menu.view) {
                    menu.edit = !menu.edit;
                }
            }
        }
        $scope.checkedCss = function(menu) {
            return $scope.curAuthApp.nopower && $scope.isAppManage && menu.view;
        }
        $scope.menuStyle = function(menu, flag) {
            var css = {},
                cn = 'active';
            if ($scope.isAppManage && $scope.curAuthApp && $scope.curAuthApp.nopower) {
                cn = 'checked';
            }
            if (flag == 1) {
                css[cn] = menu.view && menu.edit;
            } else if (flag == 2) {
                css[cn] = menu.edit;
                css['dis'] = !menu.view;
            } else if (flag == 3) {
                var authObj = {};
                if ($scope.curAuthApp) {
                    authObj = $scope.authJSON[$scope.curAuthApp.id];
                }

                css[cn] = menu.view && ((menu.auth == 'roi' && authObj.payAuth) || menu.auth != 'roi');
                css['dis'] = !authObj.payAuth && menu == 'roi';
            } else {
                css[cn] = menu.view;
            }

            return css;
        }

        $scope.getTips = function(app) {
                if (app.nopower) {
                    return $translate.instant("该应用权限由管理员添加，您无此应用权限");
                } else {
                    return "";
                }
            }
            //全选操作
        $scope.doCheck = function(k) {
                if ((k == 'camp' || k == 'active') && $scope.curCampApp.nopower) {
                    return false;
                }
                if (k == 'auth' && $scope.curAuthApp.nopower) {
                    return false;
                }

                var bol = $scope.allcheck[k] = !$scope.allcheck[k];

                if (k == 'app') { //选择应用时的全选
                    $scope.authapplist.filter(function(item) {
                        if (!item.nopower) {
                            item.ischeck = bol;
                            //选择app初始化数据
                            if (bol && !$scope.authJSON[item.id]) {
                                $scope.authJSON[item.id] = {
                                    menus: copyArray($scope.authMenuList),
                                    appname: item.name,
                                    datas: null,
                                    payAuth: false,
                                    retentionAuth: false,
                                    orderAuth: false,
                                    arouseAuth: false,
                                    isNatureOpen: false,
                                    topAuth: false,
                                    eventAuth: false
                                }
                            } else {
                                if (!bol) {
                                    delete $scope.authJSON[item.id];
                                }
                            }
                        }
                    });
                } else if (k == 'camp') { //选择渠道时的全选
                    $scope.curCampInfos.filter(function(channel) {
                        channel.isall = bol;
                        channel.issingle = false;
                        channel.camps = [];
                        channel.pkgsubcampaign = {}
                    });
                    $scope.setAccountState(bol);
                    if (bol == true) {
                        $scope.curCampApp.allcheck = true;
                        $scope.allcheck['active'] = false;
                        $scope.curCampApp.isHideAll = true;
                        $scope.curCampApp.allActiveCheck = false;
                    } else {
                        $scope.curCampApp.allcheck = false;
                        $scope.curCampApp.isHideAll = false;
                    }
                } else if (k == 'active') { //独立活动的全选
                    $scope.curCampInfos.filter(function(channel) {
                        channel.isall = false;
                        channel.issingle = bol;
                    });
                    if (bol == true) {
                        $scope.curCampApp.allActiveCheck = true;
                    } else {
                        $scope.curCampApp.allActiveCheck = false;
                    }
                } else if (k == 'auth') { //选择权限时的全选
                    $scope.curAuthInfos.filter(function(mm, index) {
                        $scope.checkMenu(1, bol, index);
                    });
                    if (bol == true) {
                        $scope.curAuthApp.allAuth = true;
                    } else {
                        $scope.curAuthApp.allAuth = false;
                    }
                }
            }
            //下一步
        $scope.nextStep = function() {
            if ($scope.emailHas == true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }

            var checkApps = $scope.authapplist.filter(function(item) {
                return item.ischeck == true;
            });
            if (checkApps.length == 0) { 
                ToolService.showTips($translate.instant("请选择应用"));
                return false;
            }
            $scope.checkappLength = checkApps.length; //选中APP个数
            var donext = true;
            if ($scope.steps == 2) {
                for (var app in $scope.authJSON) {
                    var json = $scope.authJSON[app];
                    if (json.olddatas || json.nopower == true) {
                        continue;
                    }
                    var hasnull = false;
                    if (json.datas == null) { //没有点击这个app
                        hasnull = true;
                    } else if (json.datas.length > 0) {
                        hasnull = true;
                        for (var i = 0; i < json.datas.length; i++) {
                            var item = json.datas[i];
                            //判断是否有选择活动的渠道存在
                            let ishassub = false
                            if (item.pkgsubcampaign) {
                                for (let k in item.pkgsubcampaign) {
                                    if (item.pkgsubcampaign[k] && item.pkgsubcampaign[k].length>0) {
                                        ishassub = true
                                        break
                                    }
                                }
                            }
                            if (item.isall || (item.camps && item.camps.length > 0) || item.issingle || ishassub) {
                                hasnull = false;
                                break;
                            }
                        }
                    }
                    if (json.datas) {
                        json.datas.filter(function(channel) {
                            if (channel.uniqueName == 'sads') {
                                json.menus[1].filter(function(menu) {
                                    if (menu.auth == 'asmeffectevaluate') {
                                        menu.isshow = channel.isall ? true : false;
                                        menu.channelName = channel.name;
                                        menu.view = menu.view && !channel.isall ? false : menu.view;
                                    }
                                });
                            }
                        });
                    }
                    if (hasnull) {
                        ToolService.showTips($translate.instant("请选择") + json.appname + $translate.instant("渠道活动"))
                        donext = false;
                        break;
                    }
                }
            }
            if (checkApps.length > 0 && donext) {
                $scope.steps++;

                $scope.selCurrentApp(checkApps[0]);
            }
            $scope.isAllCheck();
        }
        $scope.isAllCheck = function() {
                if ($scope.curCampInfos) {
                    var allChannel = 0,
                        allActive = 0;
                    $scope.curCampInfos.filter(function(channel) {
                        if (channel.isall) {
                            ++allChannel;
                        }
                        if (channel.issingle) {
                            ++allActive;
                        }
                    });
                    if (allChannel == $scope.curCampInfos.length) {
                        $scope.allcheck['camp'] = true;
                        $scope.allcheck['active'] = false;
                        $scope.curCampApp.isHideAll = true;
                    } else {
                        $scope.allcheck['camp'] = false;
                    }
                    if (allActive == $scope.curCampInfos.length) {
                        $scope.allcheck['active'] = true;
                    } else {
                        $scope.allcheck['active'] = false;
                    }
                }
            }
            //上一步
        $scope.preStep = function() {
                $scope.steps--;
            }
            //第一步选择app
        $scope.selectApp = function(app) {
            if (app.ischeck == false) {
                app.allcheck = false;
                $scope.allcheck['app'] = false;
            }
            app.ischeck = true;
            if (!$scope.authJSON[app.id]) {
                $scope.authJSON[app.id] = {
                    menus: copyArray($scope.authMenuList),
                    appname: app.name,
                    datas: null,
                    payAuth: false,
                    retentionAuth: false,
                    orderAuth: false,
                    arouseAuth: false,
                    isNatureOpen: false,
                    topAuth: false,
                    eventAuth: false
                }
            }
        }
        $scope.removeApp = function(app) {
                if (app.nopower) {
                    return false;
                }

                app.ischeck = false;
                delete $scope.authJSON[app.id];
                $scope.allcheck['app'] = false;
            }
            //已选应用中选择应用
        $scope.selCurrentApp = function(app) {
            $scope.iscurrentweb = app.platform == 'H5';
            $scope.isAndroidAPP = app.platform == 'Android';
            $scope.iswx = app.platform == 'wx';
            if ($scope.steps == 2) { //渠道活动
                //切换应用重置全选
                if (app.allcheck == true) {
                    $scope.allcheck.camp = true;
                } else {
                    $scope.allcheck.camp = false;
                }
                if (app.allActiveCheck == true) {
                    $scope.allcheck.active = true;
                } else {
                    $scope.allcheck.active = false;
                }
                $scope.curCampApp = app;
                $scope.curCampInfos = $scope.authJSON[app.id].datas;
            }
            if ($scope.steps == 3) { //权限
                //切换应用重置全选
                if (app.allAuth == true) {
                    $scope.allcheck.auth = true;
                } else {
                    $scope.allcheck.auth = false;
                }
                $scope.curAuthApp = app;
                $scope.curAuthInfos = $scope.authJSON[app.id].menus;
                if (app.industory == 'ec') {
                    $scope.authJSON[app.id].payEnable = $scope.authJSON[app.id].orderAuth ? true : false;
                    $scope.authJSON[app.id].payAuth = $scope.authJSON[app.id].orderAuth ?
                        $scope.authJSON[app.id].payAuth : false;
                } else {
                    $scope.authJSON[app.id].payEnable = true;
                }
                getShowAsmData(app.id);


            }
            $scope.isAllCheck();
            $scope.showPlaceAccountList();

        }

        /**
         * 判断'ASM延迟归因'下是否有数据,是否菜单显示
         */
        function getShowAsmData(appid) {
            var pm = HttpService.getInfo("report/" + appid + "/asmeffectevaluate_num/number?datatype=list");
            pm.then(function(data) {
                var num = 0;
                if (typeof data == 'number') {
                    num = data;
                } else if (typeof data == 'object') {
                    num = data.content;
                }
                $scope.isShowAsm = num ? true : false;
            });
        }

        //选择app查询对应的渠道数据
        $scope.$watch("curCampApp", function(n) {
            if (angular.isDefined(n) && ($scope.curCampInfos == null || $scope.authJSON[n.id].olddatas)) {
                ToolService.showLoading();
                var channelPM = HttpService.getInfo(n.id + "/channel/find");
                channelPM.then(function(data) {
                    var channelData = []
                    for(var i in data){
                        var item = data[i];
                        channelData.push({"category": item.category, "delFlag": item.delFlag, "firstchar": item.firstchar, 
                        "id": item.id, "name": item.name, "type": item.type, "uniqueName": item.uniqueName});
                    }
                    $scope.curCampInfos = $scope.authJSON[n.id].datas = channelData;

                    $scope.getCurrentChannelList();
                });

                $q.all([channelPM]).then(function() {
                    //编辑信息赋值
                    var olddata = $scope.authJSON[n.id].olddatas;
                    if (olddata) {
                        var oldjson = {};
                        olddata.filter(function(item) {
                            oldjson[item.channel] = item;
                        });
                        var allChannel = 0,
                            allActive = 0;
                        $scope.curCampInfos.filter(function(channel) {
                            var temp = oldjson[channel.id];
                            if (temp) {
                                channel.isall = temp.allCampaign;
                                channel.issingle = temp.channelPermit;
                                // 分包子活动回显
                                if (temp.pkgsubcampaign) {
                                    channel.pkgsubcampaign = temp.pkgsubcampaign
                                }
                                if (channel.isall) {
                                    ++allChannel;
                                }
                                if (channel.issingle) {
                                    ++allActive;
                                }
                                if (!channel.isall) {
                                    channel.camps = temp.campaignList;
                                } else {
                                    //$scope.allcheck.camp = true;
                                    channel.camps = [];
                                }
                            }
                        });
                        $scope.getCurrentChannelList();
                        if (allChannel == $scope.curCampInfos.length) {
                            $scope.allcheck['camp'] = true;
                            $scope.allcheck['active'] = false;
                            $scope.curCampApp.isHideAll = true;
                        } else {
                            $scope.allcheck['camp'] = false;
                        }
                        if (allActive == $scope.curCampInfos.length) {
                            $scope.allcheck['active'] = true;
                        } else {
                            $scope.allcheck['active'] = false;
                        }
                        delete $scope.authJSON[n.id].olddatas;
                    }
                    ToolService.hideLoading();
                });
            }
            $scope.letter = "";
            if ($scope.iscurrentweb || $scope.iswx) {
                $scope.channType = null;
            } else {
                $scope.channType = "ry_coop";
            }
            $scope.getCurrentChannelList();

        });
        $scope.granted = false;
        $scope.enableAccountAndCampBox = false; // 账号和活动列表是否渲染
        $scope.grantedFilter = function() {
            ToolService.showLoading();
            $scope.enableAccountAndCampBox = false;
            $scope.granted = !$scope.granted;
            $scope.$evalAsync($scope.getCheckChannelList($scope.granted));
            setTimeout(function() {
                ToolService.hideLoading();
            }, 1000);
        };
        $scope.changeType = function(type) {
            $scope.channType = type;
            $scope.letter = "";
            $scope.getCurrentChannelList();
        }
        $scope.getCurrentChannelList = function() {
            if (!$scope.curCampInfos) {
                return false;
            }

            $scope.curChannelList = $scope.curCampInfos.filter(function(item) {
                let ishassub = false
                if (item.pkgsubcampaign) {
                    for (let k in item.pkgsubcampaign) {
                        if (item.pkgsubcampaign[k] && item.pkgsubcampaign[k].length>0) {
                            ishassub = true
                            break
                        }
                    }
                }
                return item.type == $scope.channType && ($scope.iswx ? item.osWeixin : true) && ($scope.granted ? item.isall == true || item.issingle == true || (item.camps && item.camps.length > 0) || ishassub : true);
            });
        }

        $scope.getCheckChannelList = function(flag) {
            $scope.curChannelList = $scope.curCampInfos.filter(function(item) {
                let ishassub = false
                if (item.pkgsubcampaign) {
                    for (let k in item.pkgsubcampaign) {
                        if (item.pkgsubcampaign[k] && item.pkgsubcampaign[k].length>0) {
                            ishassub = true
                            break
                        }
                    }
                }
                return item.type == $scope.channType && (flag ? item.isall == true || item.issingle == true ||  (item.camps && item.camps.length > 0) || ishassub: true);
            });
        }
            
        $scope.channelStyle = function(channel) {
            var className = "";
            if (channel.isall) {
                if ($scope.curCampApp && $scope.curCampApp.nopower) {
                    className = " checked";
                } else {
                    className = " active";
                }
            } else if (channel.camps && channel.camps.length > 0) {
                className = 'hased';
            } else if (channel.id == '5305') {
                var accountList = $scope.gdtAccountList[$scope.curCampApp.id];
                if (accountList && accountList.length > 0) {
                    for (var i = 0; i < accountList.length; i++) {
                        var item = accountList[i];
                        if (item.checked) {
                            className = 'hased';
                            break;
                        }
                    }
                }
            }
            return className;
        }

        $scope.channelStyle2 = function(channel) {

            var className = "";
            var hasOne = false;
            var hasAll = true;
            if (channel.isall) {
                if ($scope.curCampApp && $scope.curCampApp.nopower) {
                    className = " checked";
                } else {
                    className = " active";
                }
            }else if (channel.camps && channel.camps.length > 0) {
                
                for(var i in $scope.channelCampList){
                    var item = $scope.channelCampList[i]
                    if(channel.camps.indexOf(item.id) != -1){
                        hasOne = true;
                    }else{
                        hasAll = false;
                    }
                }
                
                if (!hasOne){
                    // 一个没有
                    className = " "
                }else if (hasAll){
                    // 全选
                    className = " active"
                }else{
                    className = 'hased';
                }
            }else{
                className = " ";
            }
            return className;
        }

        //点击渠道全选
        var allCTip = false;
        $scope.channelCheck = function(channel) {
            $scope.channelCamp = channel;
            if ($scope.curCampApp.nopower) {
                return false;
            }
            $scope.selectChannel("all");
            channel.isall = !channel.isall;
            channel.pkgsubcampaign = {}
            if (channel.isall && !allCTip) {
                ToolService.showTips($translate.instant("全选表示选中该渠道下的所有活动，包括已创建的和之后新增的活动"), 3000);
                allCTip = true;
            }
            if (!channel.isall) {
                channel.camps = [];
            }

            channel.issingle = false;
            $scope.curCampApp.allcheck = false;
            $scope.allcheck['camp'] = false;
            var allCount = 0;
            $scope.curCampInfos.filter(function(channel) {
                if (channel.isall) {
                    ++allCount;
                }
            });
            if (allCount == $scope.curCampInfos.length) {
                $scope.allcheck['camp'] = true;
                $scope.allcheck['active'] = false;
                $scope.curCampApp.isHideAll = true;
            } else {
                $scope.curCampApp.isHideAll = false;
            }
            
            if (channel.uniqueName == "gdt") {
                // $scope.gdtAccountList[$scope.curCampApp.id] = $scope.gdtAccountFirstList;
                $scope.getChannelCamplist(channel);
                var accountList = $scope.gdtAccountList[$scope.curCampApp.id] || [];
                for (var i = 0; i < accountList.length; i++) {
                    var item = accountList[i];
                    item.checked = channel.isall ? true : null;
                }
                $scope.getChannelCamplist(channel, function(chan) {
                    if (chan.isall) {
                        if (chan.campIdAll) {
                            chan.camps = JSON.parse(chan.campIdAll)
                        }
                    } else {
                        chan.camps = [];
                    }
                });
            }

        }
        //点击 启用全选 停用全选
        $scope.categoryCheck = function(channel){
            $scope.channelCamp = channel
            var isCheckAll = true; // 当前是否选中
            $scope.searchCamp = '';
            for(var i in $scope.channelCampList){
                var item = $scope.channelCampList[i];
                if(channel.camps.indexOf(item.id) == -1){
                    isCheckAll = false;
                    break;
                }
            }
            if(isCheckAll){
                if (channel.isall){
                    channel.isall=false;
                    for(var i in $scope.channelCamp.campaignList){
                        var item = $scope.channelCamp.campaignList[i]
                        var idx = channel.camps.indexOf(item.id);
                        if(idx == -1){
                            channel.camps.push(item.id);
                        }
                    }
                }
                for(var i in $scope.channelCampList){
                    var item = $scope.channelCampList[i]
                    var idx = channel.camps.indexOf(item.id);
                    if(idx != -1){
                        channel.camps.splice(idx, 1);
                    }
                }
            }else{
                for(var i in $scope.channelCampList){
                    var item = $scope.channelCampList[i]
                    var idx = channel.camps.indexOf(item.id);
                    if(idx == -1){
                        channel.camps.push(item.id);
                    }
                }
            }
        }

        // 存储不同应用广点通账号
        // {appid: [{id,checked}]}
        $scope.gdtAccountList = {};
        //展开渠道-添加账号维度勾选
        // 账号授权  item.checked为true全选  false半选  null全不选
        $scope.showPlaceAccountList = function() {
            var accountList = $scope.gdtAccountList[$scope.curCampApp.id];
            if (!accountList) {
                var campPM = HttpService.getInfo($scope.curCampApp.id + "/channel/findGdtThirdAccount?account=" + infoId);
                campPM.then(function(data) {
                    if (data.code != 200) {
                        $scope.gdtAccountList[$scope.curCampApp.id] = data;
                        // $scope.gdtAccountFirstList = data;
                    }
                });
            }
        }

        $scope.showPlaceAccount = function(channel) {
            if (channel.id == "5305") {
                $scope.enableAccountAndCampBox = true;
                channel.showAccount = !channel.showAccount;
                channel.ischeck = false;
                var appObj = $scope.gdtAccountList[$scope.curCampApp.id];
                if (!appObj || appObj.length == 0 || !channel.campaignList) {
                    $scope.getChannelCamplist(channel);
                }
                if (channel.isActive == true) {
                    channel.isActive = false;
                  } else {
                    channel.isActive = true;
                }
            }
        }

        $scope.setAccountState = function(isSelect) {
            var accountList = $scope.gdtAccountList[$scope.curCampApp.id];
            if (accountList) {
                // for (var item of accountList) {
                for (var i in accountList) {
                    var item = accountList[i]
                    item.checked = isSelect ? true : null;
                }
            }
        }

        $scope.changeAccountChecked = function(item, channel, isChecked){
            if (!channel.camps) {
                channel.camps = [];
            }
            $scope.channelCamp = channel;

            if(item.checked != isChecked){
                if (item.checked) {
                    // 取消选中的话同时取消对应的活动
                    item.checked = null;
                    channel.isall = false;
                } else {
                    item.checked = true;
                }
                $scope.idArrayUpdate(channel.camps, item.campaign || [], item.checked ? "add" : "del")
            }
        }

        //账号授权
        $scope.clickAccount = function(item, channel) {
            
            $scope.changeAccountChecked (item, channel, !item.checked);
        }

        var hasSingle = false; //是否选过
        $scope.campCheck = function(channel) {
                if ($scope.curCampApp.nopower) {
                    return false;
                }

                channel.issingle = !channel.issingle;
                if (channel.issingle && !hasSingle) {
                    ToolService.showTips($translate.instant("勾选第三步“权限设置”中推广活动的编辑权限，即可具备创建该渠道推广活动权限"), 3000);
                    hasSingle = true;
                }
                $scope.allcheck['active'] = false;
                var allCount = 0;
                $scope.curCampInfos.filter(function(channel) {
                    if (channel.issingle) {
                        ++allCount;
                    }
                });
                if (allCount == $scope.curCampInfos.length) {
                    $scope.allcheck['active'] = true;
                } else {
                    $scope.allcheck['active'] = false;
                }
            }
            //展开渠道-活动
        $scope.showCamp = function(channel) {
            // $scope.gdtAccountList[$scope.curCampApp.id] = $scope.gdtAccountFirstList;
            $scope.enableAccountAndCampBox = true;
            if (channel.uniqueName == "gdt" || channel.uniqueName == "adwords") {
                var accountLists = $scope.gdtAccountList[$scope.curCampApp.id] || [];
                if (accountLists && accountLists.length > 0) {
                    $scope.statusList = accountLists.filter(function(item) {
                        var fals = true;

                        for (var i = 0; i < accountLists.length; i++) {
                            var bean = accountLists[i];
                            if (bean.name != "不筛选投放账号") {
                                bean.name = bean.id;
                            }
                            if (bean.checked && item.id == bean.id) {
                                fals = false;
                                break;
                            }
                        }
                        return fals;
                    });
                    $scope.statusList.unshift({ id: "", name: $translate.instant("不筛选投放账号") });
                } else {
                    $scope.statusList = accountLists;
                    $scope.statusList.unshift({ id: "", name: $translate.instant("不筛选投放账号") });
                }
            }
            $scope.statusidInit = $scope.statusid = "";
            $scope.allcheck['camp'] = false;
            $scope.searchCamp = "";
            channel.isActive = false;
            if (channel.ischeck == true) {
                channel.ischeck = false;
            } else {
                if ($scope.channelCamp) {
                    $scope.channelCamp.ischeck = false;
                }
                // if (!channel.campaignList) {
                //     $scope.getChannelCamplist(channel);
                // } else {
                //     if (channel.uniqueName == "gdt") {
                //         $scope.getChannelCamplistFilter(channel)
                //     };
                // }
                if (channel.uniqueName == "gdt") {
                    $scope.getChannelCamplistFilter(channel)
                }else{
                    $scope.getChannelCamplist(channel);
                }

                if (!channel.camps) {
                    channel.camps = [];
                }
                channel.ischeck = true;
                channel.showAccount = false;
                $scope.channelCamp = channel;
            }
                $scope.selectChannel("all")        
        }
        $scope.selectFlag = "all"
        $scope.selectChannel= function(flag){
            $scope.selectFlag = flag
            if($scope.channelCamp.campaignList && $scope.channelCamp.campaignList.length>0){
                $scope.channelCampList = $scope.channelCamp.campaignList.filter(function(value) {
                    if(flag == 'disable'){
                        return value.delFlag == true
                    }else if(flag == 'enabled'){
                        return value.delFlag == false
                    }else{
                        return true
                    }
                    
                })            
            }
        }
        
        $scope.$on("statusid", function(e, msg) {
            $scope.statusid = msg.info.id;
        });

        $scope.showCampChecked = function(channel) {
            if (channel.haschecked == true) {
                channel.haschecked = false;
            } else {
                if (!channel.campaignList) {
                    $scope.getChannelCamplist(channel);
                }
                channel.haschecked = true;
            }
            $(document).on("click", function() {
                channel.haschecked = false;
                $scope.$apply();
            });
        }

        /**
         * 获取活动数据
         */
        $scope.getChannelCamplist = function(channel, callBack) {
            ToolService.showLoading();
            var campaignPM = HttpService.getInfo($scope.curCampApp.id + "/campaign/findbychannel/all?channelid=" + channel.id);
            campaignPM.then(function(data) {
                $scope.channelCampList = channel.campaignList = data;
                ToolService.hideLoading();
                // 初始化thirdAccount值
                $scope.initThirdAccount(channel);
                if (channel.uniqueName == "gdt") {
                    var ids = []
                    for (var i in data) {
                        var item = data[i]
                        ids.push(item.id);
                    }
                    channel.campIdAll = JSON.stringify(ids);
                    $scope.getChannelCamplistFilter(channel);
                    if (typeof callBack === "function") {
                        callBack(channel);
                    }
                }
            });
        }

        $scope.initThirdAccount = function(channel) {
            var accountList = $scope.gdtAccountList[$scope.curCampApp.id];
            if (accountList) {
                for (var i in accountList) {
                    var item = accountList[i];
                    var actId = item.id;
                    var campaignList = item.campaign || [];

                    for (var i in channel.campaignList) {
                        var camp = channel.campaignList[i];
                        if (!camp.isTemp && campaignList.indexOf(camp.id) != -1) {
                            camp.thirdAccount = actId;
                            camp.isTemp = true;
                        }
                    }
                }
            }


        }
        $scope.getChannelCamplistFilter = function(channel) {
            var accountList3 = $scope.gdtAccountList[$scope.curCampApp.id];
            //过滤账号授权选过的活动
            channel.campaignList.filter(function(item) {
                item.showActive = false
                    // 账号授权里
                var fals = true;
                if (accountList3) {
                    for (var i = 0; i < accountList3.length; i++) {
                        var bean = accountList3[i];
                        if (item.name != "广点通点击数据" && (!item.thirdAccount || bean.checked && item.thirdAccount == bean.id)) {
                            item.showActive = true
                            fals = false;
                            break;
                        }
                    }
                }
                return fals;

            });

        }

        //选择活动
        $scope.showChecked = true;
        $scope.clickCamp = function(camp, channel) {
            $scope.channelCamp = channel;
            if ($scope.curCampApp.nopower) {
                return false;
            }
            if (channel.pkgsubcampaign) channel.pkgsubcampaign[camp.id] = []
            if (camp.channel == "5305") {
                if ($scope.channelCamp.isall) { //当前是全选状态时，取消全选并且把当前选中取消
                    $scope.channelCamp.isall = false;
                }
                var idx = $scope.channelCamp.camps.indexOf(camp.id);
                if (idx > -1) {
                    $scope.channelCamp.camps.splice(idx, 1);
                } else {
                    $scope.channelCamp.camps.push(camp.id);
                }

            } else {
                if ($scope.channelCamp.isall) { //当前是全选状态时，取消全选并且把当前选中取消
                    $scope.channelCamp.isall = false;
                    $scope.channelCamp.camps = []
                    $scope.channelCamp.campaignList.map(function(item) {
                        if (item.id != camp.id) {
                            $scope.channelCamp.camps.push(item.id);
                        }
                    });
                }else {
                    var idx = $scope.channelCamp.camps.indexOf(camp.id);
                    if (idx > -1) {
                        $scope.channelCamp.camps.splice(idx, 1);
                    } else {
                        $scope.channelCamp.camps.push(camp.id);
                    }
                }
            }

            $scope.allcheck['camp'] = false;

            // 处理账号选中问题
            if (camp.channel == "5305") {
                $scope.checkAccountBox(camp.thirdAccount, $scope.channelCamp.camps.indexOf(camp.id) > -1);
            }

        }

        // 分包子活动授权
        $scope.subpackageAuthShow = false
        $scope.subPackageCampaignList = []
        $scope.subpackageAuth = function (event, channel, camp) {
            event.stopPropagation();
            $scope.subpackageAuthShow = true
            ToolService.showAlp();
            $scope.subpackageSearchTxt = ''
            $scope.subpackageselectFlag = 'all'
            $scope.cursubCampChannel = channel
            $scope.curCampaign = camp
            if (!channel.pkgsubcampaign) channel.pkgsubcampaign = {}
            if (!channel.pkgsubcampaign[camp.id]) channel.pkgsubcampaign[camp.id] = []
            $scope.subPackageCampaignList = camp.pkgSubCampaignList.filter(function(data) {
                data.id = String(data.id)
                return true
            })
            $scope.filterSubCampaignList()
        }
        $scope.subpackageAuthHide = function () {
            $scope.subpackageAuthShow = false
            ToolService.hideAlp();
        }
        $scope.filterSubCampaignList = function () {
            $scope.curSubPackageCampaignList = $scope.subPackageCampaignList.filter(function (data) {
                return data.name.indexOf($scope.subpackageSearchTxt) > -1 && ($scope.subpackageselectFlag == 'all' ? true : $scope.subpackageselectFlag == 'enabled' ? !data.delFlag : data.delFlag)
            })
        }
        $scope.$watch('subpackageSearchTxt+subpackageselectFlag', function (n) {
            $scope.curSubPackageCampaignList = $scope.subPackageCampaignList.filter(function (data) {
                return data.name.indexOf($scope.subpackageSearchTxt) > -1 && ($scope.subpackageselectFlag == 'all' ? true : $scope.subpackageselectFlag == 'enabled' ? !data.delFlag : data.delFlag)
            })
        })
        $scope.subpackageclass = function (subcampid) {
            if (($scope.cursubCampChannel.isall || $scope.cursubCampChannel.camps.indexOf($scope.curCampaign.id) > -1 || $scope.cursubCampChannel.pkgsubcampaign && $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id] && $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id].indexOf(subcampid) > -1) && $scope.curCampApp.nopower) {
                return 'checked'
            }else if ($scope.cursubCampChannel.isall || $scope.cursubCampChannel.camps.indexOf($scope.curCampaign.id) > -1 ||  $scope.cursubCampChannel.pkgsubcampaign && $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id] && $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id].indexOf(subcampid) > -1) {
                return 'active'
            }
        }
        $scope.clickSubCamp = function (subcampid) {
            if ($scope.curCampApp.nopower) {
                return false;
            }
            if ($scope.cursubCampChannel.isall || $scope.cursubCampChannel.camps.indexOf($scope.curCampaign.id) > -1) {
                $scope.clickCamp($scope.curCampaign, $scope.cursubCampChannel)
                $scope.subPackageCampaignList.forEach(function (data) {
                    if (data.id != subcampid) {
                        $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id].push(data.id)
                    }
                })
            } else {
                var idx = $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id].indexOf(subcampid);
                if (idx > -1) {
                    $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id].splice(idx, 1);
                } else {
                    $scope.cursubCampChannel.pkgsubcampaign[$scope.curCampaign.id].push(subcampid);
                }
            }
        }

        /**
         * 设置账号选中状态
         */
        $scope.checkAccountBox = function(accountNo, isSelect) {
            // if(accountNo){
            // 当前选择的应用对应人账号列表
            var accountList = $scope.gdtAccountList[$scope.curCampApp.id];
            if (isSelect) {
                // 当前checkbox 被选中了
                if (accountList && accountList.length > 0) {
                    // for (var item of accountList) {
                    for (var i in accountList) {
                        var item = accountList[i];
                        if (item.id == accountNo) {
                            item.checked = false
                            break;
                        }
                    }
                }

            } else {
                // 当前 checkbox 被取消了
                // for (var item of $scope.channelCamp.campaignList) {
                for (var i in $scope.channelCamp.campaignList) {
                    var item = $scope.channelCamp.campaignList[i];
                    $scope.channelCamp.camps = $scope.channelCamp.camps.map(Number);
                    // console.log($scope.channelCamp.camps,item.id)
                    if (item.thirdAccount == accountNo && $scope.channelCamp.camps.indexOf(item.id) < 0) {
                        // for (var _account of accountList) {
                        for (var i in accountList) {
                            var _account = accountList[i]
                            if (_account.id == accountNo) {
                                _account.checked = null;
                                break;
                            }
                        }
                        break;
                    }
                }
            }
            // }
        }
        $scope.campFilterCheck = function(channel, txt, flag) {
            var accountListSet = [];
            channel.campaignList.filter(function(camp) {
                var _thirdAccount = camp.thirdAccount;
                if (txt != '' && $scope.statusid == '') {
                    if (camp.name.indexOf(txt) > -1) {
                        var idx = channel.camps.indexOf(camp.id);
                        if (idx == -1 && flag == 1) {
                            channel.camps.push(camp.id);
                        }
                        if (idx > -1 && flag == 2) {
                            channel.camps.splice(idx, 1);
                        }
                        if (accountListSet.indexOf(_thirdAccount) == -1) {
                            accountListSet.push(_thirdAccount);
                        }
                    }
                } else if (txt == '' && $scope.statusid != '') {
                    if (camp.thirdAccount == $scope.statusid) {
                        var idx = channel.camps.indexOf(camp.id);
                        if (idx == -1 && flag == 1) {
                            channel.camps.push(camp.id);
                        }
                        if (idx > -1 && flag == 2) {
                            channel.camps.splice(idx, 1);
                        }
                        if (accountListSet.indexOf(_thirdAccount) == -1) {
                            accountListSet.push(_thirdAccount);
                        }
                    }
                } else if (txt != '' && $scope.statusid != '') {
                    if (camp.name.indexOf(txt) > -1 && camp.thirdAccount == $scope.statusid) {
                        var idx = channel.camps.indexOf(camp.id);
                        if (idx == -1 && flag == 1) {
                            channel.camps.push(camp.id);
                        }
                        if (idx > -1 && flag == 2) {
                            channel.camps.splice(idx, 1);
                        }
                        if (accountListSet.indexOf(_thirdAccount) == -1) {
                            accountListSet.push(_thirdAccount);
                        }
                    }
                }

            });
            // for (var a of accountListSet) {
            for (var i in accountListSet) {
                var a = accountListSet[i]
                $scope.checkAccountBox(a, flag == 1 ? true : false);
            }

        }
        $scope.acountFilterCheck = function(searchAccount, channel, flag) {
            var accountListSet = [];
            
            $scope.gdtAccountList[$scope.curCampApp.id].filter(function(item){
                if(item.id.indexOf(searchAccount)>-1){
                    accountListSet.push(item);
                }
            })
            
            for (var i in accountListSet) {
                var item = accountListSet[i]
                //$scope.checkAccountBox(a, flag);
                $scope.changeAccountChecked(item, channel, flag)
            }

        }

        $scope.getDataAuthStyle = function(k) {
                return $scope.steps === 3 && $scope.authJSON[$scope.curAuthApp.id] && $scope.authJSON[$scope.curAuthApp.id][k];
            }
            //选择数据权限
        $scope.clickDataAuth = function(k) {
                var appAuth = $scope.authJSON[$scope.curAuthApp.id];
                if ($scope.curAuthApp.nopower || (!appAuth.payEnable && k == 'payAuth' && $scope.curAuthApp.industory == 'ec')) {
                    return false;
                }

                var txtTips = $scope.getMenuTips();
                if (txtTips != '') {
                    ToolService.showTips(txtTips);
                    return false;
                }

                var curAUTH = $scope.authJSON[$scope.curAuthApp.id];
                curAUTH[k] = !curAUTH[k];

                if (!curAUTH.payAuth) {
                    for (var i = 0; i < curAUTH.menus.length; i++) {
                        var temp = curAUTH.menus[i];
                        for (var j = 0; j < temp.length; j++) {
                            if (temp[j].auth == 'roi') {
                                temp[j].view = false;
                                break;
                            }
                        }
                    }
                }
                if (k == 'orderAuth' && $scope.curAuthApp.industory == 'ec') {
                    appAuth.payEnable = appAuth['orderAuth'] ? true : false;
                    if (appAuth['payAuth'] && !appAuth.payEnable) {
                        appAuth['payAuth'] = false
                    }
                }
            }
            //把权限转化成数组
        $scope.getAuthInfo = function(auths) {
            var arr = [];
            auths = copyArray(auths);
            var get = function(list) {
                list.filter(function(item) {
                    if (item.children) {
                        var children = copyArray(item.children);
                        delete item.children;
                        if (item.view == true || item.edit == true) {
                            arr.push(item);
                        }
                        get(children);
                    } else {
                        if (item.view == true || item.edit == true) {
                            arr.push(item);
                        }
                    }
                });
            }
            auths.filter(function(item) {
                get(item);
            });
            return arr;
        }
        $scope.save = function() {
            var par = {
                id: $scope.accountInfo.id,
                "email": $scope.accountInfo.email,
                "name": $scope.accountInfo.name,
                "roleCategory": $scope.roleCategory,
                "remark": $scope.accountInfo.remark
            };

            var donext = true;
            if ($scope.roleCategory > 1) {
                var appAuth = [];
                if ($scope.roleCategory == 2) {
                    $scope.authapplist.filter(function(item) {
                        if (item.ischeck) {
                            appAuth.push({ app: item.id });
                        }
                    });

                    if (appAuth.length == 0) {
                        ToolService.showTips($translate.instant("请选择应用"));
                        return false;
                    }
                } else {
                    for (var k in $scope.authJSON) {
                        var auth = $scope.authJSON[k],
                            power = {
                                app: k,
                                payAuth: auth.payAuth,
                                retentionAuth: auth.retentionAuth,
                                orderAuth: auth.orderAuth,
                                isNatureOpen: auth.isNatureOpen,
                                topAuth: auth.topAuth,
                                roleAuthDetailList: [],
                                dataAuth: [],
                                arouseAuth: auth.arouseAuth,
                                eventAuth: auth.eventAuth
                            };
                        $scope.authapplist.filter(function(item) {
                            if (item.ischeck && k == item.id) {
                                if (item.industory == 'ec') {
                                    power.retentionAuth = false;
                                } else {
                                    power.orderAuth = false;
                                }
                            }
                        });
                        if (auth.createAccount) {
                            power.createAccount = auth.createAccount;
                            power.createTime = auth.createTime;
                        }
                        if (auth.olddatas) { //编辑赋值未点击app情况
                            power.dataAuth = auth.olddatas;
                        } else {
                            if (auth.datas == null) {
                                donext = false;
                                ToolService.showTips($translate.instant("请选择") + auth.appname + $translate.instant("渠道活动"))
                                break;
                            }
                            auth.datas.filter(function(channel) {
                                let ishassub = false
                                for (let k in channel.pkgsubcampaign) {
                                    if (channel.pkgsubcampaign[k].length > 0) {
                                        ishassub = true
                                    } else {
                                        delete channel.pkgsubcampaign[k]
                                    }
                                }
                                if (channel.isall) {
                                    power.dataAuth.push({
                                        channel: channel.id,
                                        campaignList: [],
                                        allCampaign: true,
                                        channelPermit: false,
                                        pkgsubcampaign: {}
                                    });
                                } else if ((channel.camps && channel.camps.length > 0) || channel.issingle || ishassub) {
                                    power.dataAuth.push({
                                        channel: channel.id,
                                        campaignList: channel.camps,
                                        allCampaign: false,
                                        channelPermit: channel.issingle,
                                        pkgsubcampaign: channel.pkgsubcampaign
                                    });
                                }
                            });

                            if (auth.datas.length > 0 && power.dataAuth.length == 0) {
                                donext = false;
                                ToolService.showTips($translate.instant("请选择") + auth.appname + $translate.instant("渠道活动"))
                                break;
                            }
                        }
                        if ($scope.roleCategory == 3 || $scope.roleCategory == 5 || $scope.roleCategory>5) {
                            donext = false;
                            power.roleAuthDetailList = $scope.getAuthInfo(auth.menus);
                            for (var i = 0; i < power.roleAuthDetailList.length; i++) {
                                var temp = power.roleAuthDetailList[i];
                                if (temp.view == true) {
                                    donext = true;
                                    break;
                                }
                            }
                            if (!donext) {
                                ToolService.showTips($translate.instant("请设置") + auth.appname + $translate.instant("权限"));
                                break;
                            }
                        }
                        appAuth.push(power);
                    }
                }
                par.authList = appAuth;
                par.thirdAccountAuth = [];
                for (var appKey in $scope.gdtAccountList) {
                    var appObj = $scope.gdtAccountList[appKey];
                    // for (var item of appObj) {
                    for (var i in appObj) {
                        var item = appObj[i]
                        if (item.checked) {
                            par.thirdAccountAuth.push({ "third_account": item.id, "account": infoId, "channel_permit": false });
                        }

                    }
                }


            }
            if (!donext) {
                return false;
            }

            var savePM = HttpService.postInfo("mng/auth/createauth", par);
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($translate.instant("配置成功"));
                $scope.cancel();
            });
        }
        $scope.cancel = function() {
            $state.go("collect.auth");
        }

        /**
         * 操作 id数组 数据公共方法
         * sourceArray:
         * targetArray:
         * delOrAdd: "del" 和 "add"
         */
        $scope.idArrayUpdate = function(sourceArray, targetArray, delOrAdd) {
            if (sourceArray && targetArray) {
                targetArray = targetArray.map(Number);
                for (var i in targetArray) {
                    var _id = targetArray[i]
                    var _idIndex = sourceArray.indexOf(_id);
                    if (_idIndex == -1) {
                        if (delOrAdd == "add") {
                            sourceArray.push(_id);
                        }
                    } else {
                        if (delOrAdd == "del") {
                            sourceArray.splice(_idIndex, 1);
                        }
                    }
                }

            }

        }

        /**
         * 语言切换监听
         */
        /*$scope.$watch("lang",function(val,oldVal){
            if(val && oldVal && val!==oldVal){
                initSelect();
                roleAuthDic && (roleAuthDic = {});
                var data = $scope.applistInfo;
                if (angular.isDefined(data)) {
                    $scope.authapplist = copyArray(data);
                    if ($scope.isAppManage && !UtilService.isNullStr(infoId)) {
                        var hasAuthAppsPM = HttpService.getInfo("app/find/" + infoId + "/AuthApp");
                        hasAuthAppsPM.then(function (data) {
                            $scope.init(data);
                        });
                    }
                    else {
                        $scope.init();
                    }
                }
            }
        });*/

    }
})();