(function() {
    angular.module("app.manage")
        .controller("authroleCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$filter", authroleCtrl])
        .controller("authroleDetailCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$filter", authroleDetailCtrl]);


    var copyArray = function(arr) {
        return $.extend(true, [], arr);
    }

    function authroleCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $filter) {
        var infoId = $scope.id = $stateParams.aid;

        $scope.queryRoleList = function() {
            var rolePM = HttpService.getInfo("mng/auth/role/find");
            rolePM.then(function(data) {
                $scope.roleList = data;
            });
        }
        $scope.queryRoleList();

        $scope.deleteRole = function(d) {
            ToolService.sendBehaviorUv("deleteRole");
            $scope.delInfo = d;
            $scope.winFlag = 1;
            ToolService.showAlp();
        }
        $scope.doDelete = function() {
            $scope.closeWin();
            ToolService.showLoading();
            var deletePM = HttpService.deleteInfo("mng/auth/role/" + $scope.delInfo.id + "/delete");
            deletePM.then(function(data) {
                ToolService.hideLoading();
                if (data.status == "PARAM_INVALID") { //有账号应用此权限配置
                    $scope.winFlag = 2;
                    ToolService.showAlp();
                    $scope.hasEmails = data.emails;

                    var moreArr = data.emails.split(","),
                        len = moreArr.length;
                    $scope.emailLen = len;
                    if (len > 5) {
                        $scope.hasEmails.moreArr.slice(0, 5).join(",");
                    }
                } else {
                    ToolService.showTips($filter('translate')("删除成功"));
                    $scope.queryRoleList();
                }
            });
        }
        $scope.closeWin = function(flag) {
            $scope.winFlag = 0;
            ToolService.hideAlp();
        }
        $scope.gopage = function(info) {
                ToolService.sendBehaviorUv("gopage");
                if (angular.isDefined(info)) {
                    $state.go("collect.authroleDetail", { aid: info.id });
                } else {
                    $state.go("collect.authroleDetail");
                }
            }
            /**
             * 语言切换监听
             */
        $scope.$watch("lang", function(val, oldVal) {
            if (val && oldVal && val != oldVal) {
                $scope.queryRoleList();
            }
        });

    }


    function authroleDetailCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $filter) {
        var infoId = $scope.id = $stateParams.aid;

        var initSelect = function() {
            var menuPM = HttpService.getInfo("mng/auth/3/findMenu");
            ToolService.showLoading();
            menuPM.then(function(data) {
                $scope.authMenuList = $scope.solveMenus(data.roleAuthDetails);
                ToolService.hideLoading();
                $scope.init();
            });

            $scope.dataAuthList = [
                { id: 'isNatureOpen', name: $filter('translate')('自然量'), tips: $filter('translate')('勾选后可以查看仪表盘和报表中的自然量数据统计。') },
                { id: 'retentionAuth', name: $filter('translate')('留存'), tips: $filter('translate')('勾选后可以查看仪表盘和报表中的留存数据统计。') },
                { id: 'orderAuth', name: $filter('translate')('订单'), tips: $filter('translate')('勾选后可以查看仪表盘和报表中的订单数据统计。') },
                { id: 'payAuth', name: $filter('translate')('付费'), tips: $filter('translate')('勾选后可以查看仪表盘和报表中与付费相关的数据统计。') },
                { id: 'topAuth', name: $filter('translate')('TOP指标'), tips: $filter('translate')('勾选后可以查看仪表盘和渠道效果对比中的TOP指标数据统计。') },
                { id: 'arouseAuth', name: $filter('translate')('调起'), tips: $filter('translate')('勾选后可以查看推广活动详情中的调起数据统计') },
                { id: 'eventAuth', name: $filter('translate')('自定义事件'), tips: $filter('translate')('勾选后可以查看推广活动详情、投放广告详情、分包推广详情、再营销活动详情、用户生命周期回流分析报表中自定义事件统计') }
            ];

            // if ($rootScope.isDeepLinkAcount) {
            //     $scope.dataAuthList.push({ id: 'arouseAuth', name: $filter('translate')('调起'), tips: $filter('translate')('勾选后可以查看推广活动详情中的调起数据统计') })
            // }
        }
        initSelect();
        //把菜单列表转化成页面显示结构数据
        $scope.menucate = ['dash','lifecycle', 'admonitor', 'tool', 'export','promotionManagement','config', 'senior'];
        $scope.solveMenus = function(list) {
            var authMenuList = [];
            $scope.menucate.filter(function(i) { authMenuList.push([]) })
            if (angular.isArray(list)) {
                list.filter(function(item) {
                    var idx = $scope.menucate.indexOf(item.parentAuth);
                    if (idx > -1) {
                        if ((!$scope.limitInfo || !$scope.limitInfo.platformExport) && item.auth == 'logexport') {
                            //母账户没有导出权限，子账户就没有日志导出权限
                        } else if ($rootScope.fakeType != 2 && $rootScope.fakeType != 1 && item.auth == 'fake') {
                            //母账户没有开通防作弊卫士，子账户就没有此功能
                        } else if (item.auth == 'recycleanalysis') { //去掉回本分析

                        } else {
                            authMenuList[idx].push(item);
                        }
                    } else {
                        var idx = $scope.menucate.indexOf(item.auth);
                        if (idx > -1) {
                            authMenuList[idx].unshift(item);
                        }
                    }
                });
            }
            authMenuList.filter(function(root) {
                root.sort(function(a, b) {
                    return a.sort > b.sort ? 1 : -1;
                });
                root.filter(function(item) {
                    if (angular.isArray(item)) {
                        item.sort(function(a, b) {
                            return a.sort > b.sort ? 1 : -1;
                        });
                    }
                    if (item.children) {
                        item.children.sort(function(a, b) {
                            return a.sort > b.sort ? 1 : -1;
                        });
                    }
                });
            });
            return authMenuList;
        }

        //flag:1一级，2二级，3三级,4设置编辑
        $scope.checkMenu = function(flag, menu, iii) {

            var bol;
            if (typeof menu == 'boolean') { //权限全选情况下
                bol = menu;
            } else {
                bol = !menu.view;
            }
            var set = function(list) {
                list.filter(function(menu) {
                    menu.view = bol;
                    menu.edit = bol;
                    if (menu.children) {
                        set(menu.children);
                    }
                });
            }
            if (flag == 1) {
                set($scope.curAuthInfos[iii]);
            } else if (flag == 2) {
                //没有付费，注收比不可选
                if (menu.auth == 'roi' && !$scope.roleAuthData.payAuth) {
                    return false;
                }
                menu.view = bol;
                menu.edit = bol;
                if (menu.children) {
                    set(menu.children);
                }
            } else if (flag == 3) {
                //没有付费，注收比不可选
                if (menu.auth == 'roi' && !$scope.roleAuthData.payAuth) {
                    return false;
                }
                menu.view = bol;
                if (!bol) {
                    menu.edit = false;
                }
                if (iii != undefined && iii.view == true) {
                    var falseNum = 0;
                    for (var i = 0; i < iii.children.length; i++) {
                        if (iii.children[i].view == false) {
                            falseNum = falseNum + 1;
                        }
                    }
                    if (falseNum == iii.children.length) {
                        iii.view = false;
                    }
                } else if (iii != undefined && iii.view == false) {
                    var falseNum = 0;
                    for (var i = 0; i < iii.children.length; i++) {
                        if (iii.children[i].view == true) {
                            falseNum = falseNum + 1;
                        }
                    }
                    if (falseNum > 0) {
                        iii.view = true;
                    }
                }
            } else if (flag == 4) {
                if (menu.view) {
                    menu.edit = !menu.edit;
                }
            }
        }

        $scope.menuStyle = function(menu, flag) {
            var css = {},
                cn = 'active';

            if (flag == 1) {
                css[cn] = menu.view && menu.edit;
            } else if (flag == 2) {
                css[cn] = menu.edit;
                css['dis'] = !menu.view;
            } else if (flag == 3) {


                css[cn] = menu.view && ((menu.auth == 'roi' && $scope.roleAuthData.payAuth) || menu.auth != 'roi');
                css['dis'] = !authObj.payAuth && menu == 'roi';
            } else {
                css[cn] = menu.view;
            }

            return css;
        }

        $scope.roleAuthInfos = [];
        $scope.roleAuthData = {};
        $scope.init = function() {
            if (infoId) {
                var menuPM = HttpService.getInfo("mng/auth/" + infoId + "/findMenu");
                menuPM.then(function(data) {
                    $scope.roleAuthInfos = $scope.solveMenus(data.roleAuthDetails);
                    $scope.roleAuthData = {
                        payAuth: data.payAuth,
                        retentionAuth: data.retentionAuth,
                        orderAuth: data.orderAuth,
                        isNatureOpen: data.isNatureOpen,
                        topAuth: data.topAuth,
                        arouseAuth: data.arouseAuth,
                        eventAuth: data.eventAuth
                    }
                    $scope.roleName = data.roleName;
                });
            } else {
                $scope.roleAuthInfos = copyArray($scope.authMenuList);
                $scope.roleAuthData = {
                    payAuth: false,
                    retentionAuth: false,
                    orderAuth: false,
                    isNatureOpen: false,
                    topAuth: false,
                    arouseAuth: false,
                    eventAuth: false
                }
                $scope.roleName = "";
            }
        }

        $scope.getDataAuthStyle = function(k) {
                return $scope.roleAuthData[k];
            }
            //选择数据权限
        $scope.clickDataAuth = function(k) {
            $scope.roleAuthData[k] = !$scope.roleAuthData[k];

            if (!$scope.roleAuthData.payAuth) {
                for (var i = 0; i < $scope.roleAuthInfos.length; i++) {
                    var temp = $scope.roleAuthInfos[i];
                    for (var j = 0; j < temp.length; j++) {
                        if (temp[j].auth == 'roi') {
                            temp[j].view = false;
                            break;
                        }
                    }
                }
            }
        }

        //把权限转化成数组
        $scope.getAuthInfo = function(auths) {
                var arr = [];
                auths = copyArray(auths);
                var get = function(list) {
                    list.filter(function(item, index) {
                        if (index == 0) {

                        } else if (item.children) {
                            var children = copyArray(item.children);
                            delete item.children;
                            /*if(item.view==true || item.edit==true){
                                arr.push(item);
                            }*/
                            get(children);
                        } else {
                            if (item.view == true || item.edit == true) {
                                arr.push(item);
                            }
                        }
                    });
                }
                auths.filter(function(item) {
                    get(item);
                });
                return arr;
            }
            //保存角色
        $scope.save = function() {
            var par = {
                    roleName: $scope.roleName
                },
                roleAuth = $scope.getAuthInfo($scope.roleAuthInfos);

            var verPar = {
                roleName: {
                    key: "numLetter",
                    val: par.roleName,
                    nullTxt: $filter('translate')("请填写角色名称"),
                    max: 16,
                    txt: $filter('translate')("请输入16位字符以内的中英文或数字")
                }
            };

            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            var donext = false;
            for (var i = 0; i < roleAuth.length; i++) {
                var temp = roleAuth[i];
                if (temp.view == true) {
                    donext = true;
                    break;
                }
            }
            if (!donext) {
                ToolService.showTips($filter('translate')("请设置权限"));
                return false;
            }

            for (var k in $scope.roleAuthData) {
                par[k] = $scope.roleAuthData[k];
            }
            par.roleAuthDetails = roleAuth;

            var savePM = null,
                txtTips = $filter('translate')("添加成功");
            if (infoId) {
                par.id = infoId;
                savePM = HttpService.putInfo("mng/auth/role/" + infoId + "/update", par);
                txtTips = $filter('translate')("修改成功");
            } else {
                savePM = HttpService.postInfo("mng/auth/role/create", par);
            }
            ToolService.showLoading();
            savePM.then(function(data) {
                    ToolService.hideLoading();
                    ToolService.showTips(txtTips);
                    $scope.cancel();
                    if (!infoId) {
                        $rootScope.operSubmitData($filter('translate')("新建"));
                    }
                },
                function(data) {
                    if (data.code == -6001) {
                        ToolService.hideLoading();
                        ToolService.showTips($filter('translate')("该角色名称已存在"));
                    } else if (data.code == -300) {
                        ToolService.hideLoading();
                        ToolService.showTips($filter('translate')("超过限定值，无法添加"));
                    }
                });
        }

        $scope.cancel = function() {
            $state.go("collect.authrole");
        }

        $scope.$watch("lang", function(val, oldVal) {
            if (val != oldVal) {
                initSelect();
            }
        });
    }
})();