(function() {
    angular.module("app.manage")
        .controller("campaignCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$timeout", "$stateParams", "ArrayConstant", "$filter", campaignCtrl])
        .controller("campaignDetailCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$timeout", "ArrayConstant", "$filter", campaignDetailCtrl]);

    function campaignCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $timeout, $stateParams, ArrayConstant, $filter) {
        var currentTime =new Date().Format('yyyy-MM-dd');
        $scope.$watch("appid+lang", function(n) {
            init();
            if (angular.isDefined($scope.appid)) {
                ToolService.showLoading();
                var gdtPM = HttpService.getInfo($scope.appid + "/channel/find/gdt");
                gdtPM.then(function(data) {
                    // ToolService.hideLoading();
                    $scope.gdtDataId = data.id;
                });
                // $scope.flipPage = null;
                $scope.getChannelList();
                $scope.query();
                //查询渠道

                var channelPM = HttpService.getInfo("mng/channel/find/" + $scope.appid + "/byaccount/show?accountAll=1");
                channelPM.then(function(data) {
                    $scope.channelList = data;
                    var channelAllObj = {};
                    data.forEach(function(item) {
                        channelAllObj[item.id] = { id: item.id, name: item.name };
                    });
                    $scope.channelAllObj = channelAllObj;
                    ToolService.hideLoading();
                });
            }
        });


        var rmd = new Date().getTime();
        $scope.$on("deviceId", function(e, msg) {
            var newSeeF = msg.info.id;
            if (!(newSeeF && newSeeF !== $scope.seeFlag)) {
                return false;
            }
            $scope.seeFlag = newSeeF;
            if ($scope.seeFlag == 1) {
                $scope.findName = 'find';
            } else {
                $scope.findName = 'findDisable';
            }
            var totalNum = $scope.totalMap[$scope.channType]
            $scope.query();
        });

        $scope.$on("activityTypeId", function(e, msg) {
            $scope.activityType = msg.info.id;
            if(!$scope.campaignList) return;
            if($scope.activityType == 1){//再营销活动
                    $scope.campaignList = $scope.baseList.filter(function(item) {
                        return $scope.channelId != 1 ? item.channel == $scope.channelId && item.deeplink :item.deeplink
                    })
            }else if($scope.activityType == 2){//预约活动
                $scope.campaignList = $scope.baseList.filter(function(item) {
                    return $scope.channelId != 1 ? item.channel == $scope.channelId && item.subscribes : item.subscribes
                })
            }else if($scope.activityType == 0){//常规
                $scope.campaignList = $scope.baseList.filter(function(item) {
                    if ($scope.channelId == 1 ){
                       return !item.subscribes && !item.deeplink;
                    }else{
                        return item.channel == $scope.channelId && !item.subscribes && !item.deeplink;
                    }
                })
            }else{
                $scope.campaignList = $scope.baseList;
            }
        })
      

        // $scope.mipTypeList = ["小程序码","小程序二维码","链接"];
        $scope.mipTypeList = ToolService.getValues(ArrayConstant.wayPromObj);
        $scope.wayPromKey = ToolService.getKeys(ArrayConstant.wayPromObj);
        $scope.$on("channelFilterId", function(e, msg) {
            var channelId =$scope.channelIdTwo =  msg.info.id;
            if (!(channelId && channelId !== $scope.channelId)) {
                return false;
            }
            $scope.channelId = channelId;
            if ($scope.totalMap[$scope.channType] && $scope.totalMap[$scope.channType] >= 1000) {
                $scope.query();
            } else if ($scope.channelId != 1) {
                $scope.campaignList = $scope.baseList.filter(function(item) {
                    if($scope.activityType == 1){//1再营销活动
                        return item.channel == $scope.channelId && item.deeplink;
                    }else if($scope.activityType == 2){//2预约活动
                        return item.subscribes && item.channel == $scope.channelId
                    }else if($scope.activityType == 0){//常规
                        return item.channel == $scope.channelId && !item.subscribes && !item.deeplink
                    }else{
                        return item.channel == $scope.channelId
                    }
                });
            } else {
                $scope.campaignList = $scope.baseList;
                $scope.query();
            }
        });
        //页面筛选，渠道下拉列表查询
        $scope.getChannelList = function(){
            var pm = HttpService.getInfo("mng/campaign/"+$scope.appid+"/find/linkchannels",{type:$scope.channType});
            pm.then(function(data){
                data.unshift({id:1,name:'不筛选渠道'});
                $scope.channelFilterList = data;
                $scope.channelFilterInit = $scope.channelFilterList[0].id;
            });
        };
        /**
         * 监听列表查询结果baseList和所有渠道对象channelAllObj，过滤出含有活动的渠道列表。
         */
        /*$scope.$watch("{channelAllObj:channelAllObj,baseList:baseList}", function() {
            $scope.channelFilterList = [{ id: 1, name: $filter('translate')('不筛选渠道') }];
            $scope.channelFilterInit = $scope.channelFilterList[0].id;
            if ($scope.channelAllObj && $scope.baseList && $scope.baseList.length > 0) {
                $scope.baseList.forEach(function(item) {
                    if (item.channel) {
                        var channelItem = $scope.channelAllObj[item.channel];
                        if (channelItem && $scope.channelFilterList.indexOf(channelItem) == -1) {
                            $scope.channelFilterList.push(channelItem);
                        }
                    }
                });
            }
        }, true);*/


        var init = function() {
            $scope.iswx = $rootScope.iswx || localStorage.getItem("iswx") === 'true';
            var type = $stateParams.aid;
            if (!UtilService.isNullStr(type)) {
                $scope.channType = type;
            } else if ($scope.iswx || $scope.iswg) {
                $scope.channType = 'custom';
            } else {
                $scope.channType = 'ry_coop';
            }

            $scope.deviceList = [
                { id: 1, name: $filter('translate')("已启用") },
                { id: 2, name: $filter('translate')("已停用") }
            ];
            $scope.deviceInit = $scope.deviceList[0].id;
            if($scope.appid){
                $scope.activityTypeList = []
                $scope.querySubscribe()
            }
        }
        $scope.querySubscribe =function(){
            //有预约活动
            var sub = HttpService.getInfo("mng/campaign/"+ $scope.appid + "/type/dropdownlist");
            sub.then(function(data){
                var deepLink = data.deepLink; //再营销活动
                var subscribes = data.subscribes; //预约活动
                if(deepLink && subscribes){
                    $scope.activityTypeList = [{ id: "all", name: $filter('translate')("不筛选活动类型") },{ id: "0", name: $filter('translate')("常规活动") }, { id: "1", name: $filter('translate')("再营销活动") },{ id: "2", name: $filter('translate')("预约活动") }]
                }else if(subscribes){
                    $scope.activityTypeList = [{ id: "all", name: $filter('translate')("不筛选活动类型") },{ id: "0", name: $filter('translate')("常规活动") },{ id: "2", name: $filter('translate')("预约活动")}]
                }else if(deepLink){
                    $scope.activityTypeList = [{ id: "all", name: $filter('translate')("不筛选活动类型") },{ id: "0", name: $filter('translate')("常规活动") },{ id: "1", name: $filter('translate')("再营销活动")}]
                }else{
                    $scope.activityTypeList = []
                }
                if($scope.activityTypeList.length > 0){
                    $scope.activityTypeInit = $scope.activityTypeList[0].id;
                }
            })
        }
        init();
        $scope.cleanEvent = "cleanEvent"
        $scope.filterTypeList = function(type) {
            ToolService.sendBehaviorUv("type");
            $scope.channType = type;
            $scope.deviceInit = $scope.deviceList[0].id;
            $scope.deviceId = 1;
            $scope.findName = 'find';
            $scope.typefresh = ++rmd;
            $rootScope.thirdtab = { 'ry_coop': $filter('translate')('常规渠道'), 'custom': $filter('translate')('自定义渠道'), 'ry_bd': $filter('translate')('SEM渠道') }[type];
            if (type == 'ry_bd') {
                if ($rootScope.isall) {
                    $scope.isShowCkBatchManage = true;
                } else if ($rootScope.isChannelU) {
                    $scope.isShowCkBatchManage = false;
                } else {
                    var Pm = HttpService.getInfo("sem/findAuth");
                    Pm.then(function(data) {
                        if (data) {
                            for (var k in data) {
                                if (data[k] == true) {
                                    $scope.isShowCkBatchManage = true;
                                    break;
                                }
                            }
                        }

                    });
                }
            }
            $scope.getChannelList();
            $scope.query();
        };
        var userID = UtilService.getCookie("ryioUid");
        // var begintime;
      
        $scope.totalMap = {};
        $scope.query = function(flag) {
            if ($scope.findName == undefined || $scope.appid == undefined) {
                return false;
            }
            $scope.totalNum = $scope.totalMap[$scope.channType] || 0;
            var par = {
                type: $scope.channType,
            }
            if ($scope.totalNum >= 1000) {
                par.channel = $scope.channelId;
                par.name = $scope.filterTxt;
            }
            $scope.curEditId = -1;
            ToolService.showLoading();
            var campaignPM = HttpService.postInfo("mng/campaign/" + $scope.appid + "/" + $scope.findName + "/link", par);
            campaignPM.then(function(data) {
                $scope.campaignListData = data;
                if(data.data.length>0){
                    $rootScope.onlineDateInfo = data.data[0].onlineDate;
                }
                ToolService.hideLoading();
                $scope.baseList = $scope.campaignList = data.data;
                $scope.paginationTotal = data.data.length;
                $scope.total = data.total;
                $scope.totalMap[$scope.channType] = $scope.total
                $scope.selectIDS = [];
                $scope.searchTxt = "";
                if($scope.channType === 'ry_coop'){
                    $scope.filtRate(data.data);

                }
                //判断GDT、adwords归因数量
                $scope.surlLength = 0;
                for (var i = 0; i < $scope.campaignList.length; i++) {
                    if ($scope.campaignList[i].surl == '') {
                        $scope.surlLength = $scope.surlLength + 1;
                    }
                }
                $scope.closeAlert = localStorage.getItem("ry" + userID + "_" + $scope.appid);
                if ($scope.closeAlert == null || $scope.closeAlert == undefined || $scope.closeAlert == '') {
                    $scope.closeAlert = 0;
                    localStorage.setItem("ry" + userID + "_" + $scope.appid, $scope.closeAlert);
                }
                if (parseInt($scope.closeAlert) < 3) {
                    $scope.closeAlertType = true;
                } else {
                    $scope.closeAlertType = false;
                }
            });
        }
        $scope.filtRate = function(data){
            if ($scope.channelId != 1 && $scope.activityType != 'all') {
                $scope.campaignList = data.filter(function(item) {
                    if($scope.activityType == 1){//1再营销活动
                        return item.channel == $scope.channelId && item.deeplink;
                    }else if($scope.activityType == 2){//2预约活动
                        return item.subscribes && item.channel == $scope.channelId
                    }else if($scope.activityType == 0){//常规
                        return item.channel == $scope.channelId && !item.subscribes && !item.deeplink
                    }else{
                        return item.channel == $scope.channelId
                    }
                })
            }else if($scope.channelId != 1 && $scope.activityType == 'all'){
                $scope.campaignList = data.filter(function(item) {
                    return item.channel == $scope.channelId;
                });
            }else if($scope.channelId == 1 && $scope.activityType == '1'){//再营销活动
                $scope.campaignList = data.filter(function(item) {
                    return item.deeplink;
                });
            }else if($scope.channelId == 1 && $scope.activityType == '2'){//预约活动
                $scope.campaignList = data.filter(function(item) {
                    return item.subscribes;
                });
            }else if($scope.channelId == 1 && $scope.activityType == '0'){//常规
                $scope.campaignList = data.filter(function(item) {
                    return !item.subscribes && !item.deeplink;
                });
            }
        }
        $scope.filterByTxt = function(txt) {
            $scope.filterTxt = txt;
            $scope.query();
        }
        $scope.closeGdtAwords = function() {
            $scope.closeAlert = parseInt($scope.closeAlert) + 1;
            localStorage.setItem("ry" + userID + "_" + $scope.appid, $scope.closeAlert);
            $scope.closeAlertType = false;
        }

        $scope.editName = function(info) {
            ToolService.sendBehaviorUv("editName");
            $scope.curEditId = info.id;
            info.rename = info.name;
        }
        $scope.saveName = function(info) {
            if (info.name == info.rename) {
                $scope.curEditId = -1;
                return false;
            }
            if (info.rename == '') {
                ToolService.showTips($filter('translate')("不能为空"));
                return false;
            }
            var verPar = {
                rename: {
                    key: 'spcname1',
                    val: info.rename,
                    txt: $filter('translate')("支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内")
                }
            };

            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ == true) {
                ToolService.showLoading();
                var namePM = HttpService.putInfo("mng/campaign/" + $scope.appid + "/update/" + info.id + "?name=" + info.rename);
                namePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data) {

                        ToolService.showTips($filter('translate')("修改成功"));
                        info.name = info.rename;
                        $scope.curEditId = -1;
                    } else {
                        ToolService.showTips($filter('translate')("名称重复"));
                    }
                });
            } else {
                ToolService.showTips($scope.tip.rename.txt);
            }

        }


        var curfilpPage = null,
            rmd = new Date().getTime();
        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;

            $scope.flipChange = ++rmd;
        });
        $scope.$watch("flipChange+campaignList", function() {
            if ($scope.flipPage && $scope.campaignList) {
                curfilpPage = { start: $scope.flipPage.start + 1, end: $scope.flipPage.end };
                if (curfilpPage.end > $scope.campaignList.length) {
                    curfilpPage.end = $scope.campaignList.length;
                }

                $timeout(function() {
                    var clipboard = new Clipboard('.copyBtn');
                    clipboard.on('success', function(e) {
                        $scope.$apply(function() {
                            ToolService.showTips($filter('translate')("复制成功"));
                            $scope.copyingContent = e.text;
                        });
                    });

                    clipboard.on('error', function(e) {
                        $scope.$apply(function() {
                            ToolService.showTips($filter('translate')("复制失败！"));
                        });
                    });
                }, 200);
            }
        });
        $scope.sendEve = function() {
            ToolService.sendBehaviorUv("search");
        }
        $scope.doRemove = function(info) {
            ToolService.sendBehaviorUv("doRemove");
            if ($scope.seeFlag == 1) {
                // $scope.delTips = $filter('translate')("您正在停用“") + info.name + $filter('translate')("”停用后将不在接收该活动以后的所有点击（展示）数据，已拥有该活动权限的账号，查看此数据不受影响。是否确认停用？");
                if ($scope.channType == 'ry_bd' && info.subCampaignNumber > 0) {
                    if (info.subCampaignNumber > 0) {
                        $scope.delTips = $filter('translate')("该推广活动下包含") + info.subCampaignNumber + $filter('translate')("个子活动，停用后该推广活动下的所有子活动将不在接收所有点击（展示）数据。是否确认停用？");
                    } else {
                        $scope.delTips = $filter('translate')("您正在停用“") + info.name + $filter('translate')("”停用后将不能查看该活动以后的推广相关数据，且将为您关闭子账号对该推广活的权限。是否确认停用？");
                    }
                } else {
                    $scope.delTips = $filter('translate')("您正在停用“") + info.name + $filter('translate')("”停用后将不在接收该活动以后的所有点击（展示）数据，已拥有该活动权限的账号，查看此数据不受影响。是否确认停用？");
                }
                $scope.delstatus = true;
                $scope.delId = info.id;
                $scope.delObj = info;
            } else {
                $scope.subscribesInfo = false;
                if (info.subCampaignNumber > 0) {
                    $scope.delTips = $filter('translate')("该推广活动下包含") + info.subCampaignNumber + $filter('translate')("个子活动，启用后该推广活动下的所有子活动将继续接收新点击（展示）数据。是否确认启用？");
                } else {
                    if($scope.channType == 'ry_coop' && info.subscribes && info.onlineDate < currentTime){
                        $scope.delTips = "您的产品已上线，预约活动不可启用";
                        $scope.subscribesInfo = info.subscribes;
                    }else{
                        $scope.delTips = $filter('translate')("是否启用“") + info.name + $filter('translate')("”活动？");
                    }
                }
                $scope.delstatus = true;
                $scope.delId = info.id;
                $scope.delObj = info;
            }

        }

        $scope.delResultStatus = false;
        $scope.removeInfo = function() {
            if ($scope.seeFlag == 1) {
                var removePM = HttpService.deleteInfo("mng/campaign/" + $scope.appid + "/delete/" + $scope.delId);
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.delstatus = false;
                    if (typeof data == 'object' && data.code == -1009) {
                        $scope.delResultStatus = true;
                        // ToolService.showTips($filter('translate')("该推广活动短链地址正在被onelink使用，当前不可被停用，请先修改或删除对应该推广活动的onelink短链"));
                    } else {
                        ToolService.showTips($filter('translate')("停用成功"));
                        $rootScope.operSubmitData($filter('translate')("停用"));
                        $scope.query(1);
                    }
                });
            } else {
                if($scope.channType == 'ry_coop' && $scope.subscribesInfo){ $scope.delstatus = false; return false;}
                var removePM = HttpService.putInfo("mng/campaign/" + $scope.appid + "/enable/" + $scope.delId);
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.delstatus = false;
                    ToolService.showTips($filter('translate')("启用成功"));
                    $rootScope.operSubmitData($filter('translate')("启用"));
                    $scope.query(1);
                });
            }
        }
        $scope.cancelDelTip = function() {
            $scope.delResultStatus = false;
        };

        $scope.clickCkx = function(id) {
            ToolService.sendBehaviorUv("clickCkx");
            var idx = $scope.selectIDS.indexOf(id);
            if (idx > -1) {
                $scope.selectIDS.splice(idx, 1);
            } else {
                $scope.selectIDS.push(id);
            }
        }
        $scope.setCurrentList = function() {
            var curList = $scope.campaignList;
            if (!UtilService.isNullStr($scope.searchTxt)) {
                var myFilterList = $scope.campaignList ? $scope.campaignList.filter(function(item) {
                    if ((item.name && angular.uppercase(String(item.name)).indexOf(angular.uppercase($scope.searchTxt)) > -1) || (item.trackurl && angular.uppercase(String(item.trackurl)).indexOf(angular.uppercase($scope.searchTxt)) > -1)) {
                        return true;
                    } else {
                        return false;
                    }
                }) : [];
                curList = myFilterList;
            }
            $scope.curShowList = curList;
        }
        $scope.curPageAll = function() {
            if (!$scope.flipPage || !$scope.campaignList) { return false; }

            $scope.setCurrentList();
            curfilpPage.end = $scope.curShowList.length > curfilpPage.end ? curfilpPage.end : $scope.curShowList.length;
            var len = curfilpPage.end - curfilpPage.start,
                count = 0;

            for (var i = curfilpPage.start; i < curfilpPage.end; i++) {
                var temp = $scope.curShowList[i];

                if ($scope.selectIDS.indexOf(temp.id) > -1) {
                    count++;
                }
            }
            $scope.onePageCount = count;
            return len == count && len > 0;
        }
        $scope.checkAllCurrent = function() {
            var bol = $scope.curPageAll();
            curfilpPage.end = $scope.curShowList.length > curfilpPage.end ? curfilpPage.end : $scope.curShowList.length;
            for (var i = curfilpPage.start; i < curfilpPage.end; i++) {
                var temp = $scope.curShowList[i],
                    idx = $scope.selectIDS.indexOf(temp.id);
                if (bol && idx > -1) {
                    $scope.selectIDS.splice(idx, 1);
                }
                if (!bol && idx == -1) {
                    $scope.selectIDS.push(temp.id);
                }
            }
        }

        $scope.checkAllPage = function() {
            $scope.selectIDS = [];
            var len = $scope.curShowList.length,
                count = 0;
            for (var i = 0; i < len; i++) {
                $scope.selectIDS.push($scope.curShowList[i].id);
            }
        }

        $scope.NocheckAllPage = function() {
            $scope.selectIDS = [];
        }

        $scope.$watch("searchTxt", function(n) {
            if (angular.isDefined(n)) {
                $scope.selectIDS = [];
            }
        });
        $scope.$watch("selectIDS", function(n) {
            if ($scope.selectIDS && $scope.selectIDS.length > 0) {
                $scope.iptHolder = $filter('translate')("搜索后，所选内容将清除");
            } else {
                $scope.iptHolder = $filter('translate')("输入名称或短链搜索");
            }
        });

        $scope.doBatchRemove = function() {
            $scope.delbatch = true;
        }

        $scope.removeBatch = function() {
            if ($scope.seeFlag == 1) {
                $scope.delbatch = false;
                var removePM = HttpService.deleteInfo("mng/campaign/" + $scope.appid + "/batchdelete?ids=" + $scope.selectIDS.join(","));
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.code == -1000) {
                        ToolService.showTips($filter('translate')("停用推广活动下含有子活动，不可被停用，请先停用该推广活动的子活动"));
                    } else if (data.code == -1009) {
                        ToolService.showTips($filter('translate')("您选择的推广活动中包含正在被onelink使用的推广活动，不可批量停用，请重新选择或先删除对应推广活动的onelink短链"));
                    } else {
                        ToolService.showTips($filter('translate')("停用成功"));
                        $scope.query(1);
                    }
                });
            } else {
                $scope.delbatch = false;
                var removePM = HttpService.putInfo("mng/campaign/" + $scope.appid + "/batchenable?ids=" + $scope.selectIDS.join(","));
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("启用成功"))
                    $scope.query(1);
                });
            }

        }
        $scope.exportBatch = function(flag) {
            if (flag == 1) {
                // window.location.href = "api/mng/campaign/" + $scope.appid + "/exportsurls?ids=" + $scope.selectIDS.join(",") + "&type=" + $scope.channType + "&lang=" + $rootScope.lang + "&showurl=1";
                var pm = HttpService.downFilePost("mng/campaign/" + $scope.appid + "/exportsurls?type=" + $scope.channType + "&lang=" + $rootScope.lang + "&showurl=1", { ids: $scope.selectIDS }, '活动短链列表.txt')
            } else {
                ToolService.showLoading();
                var exportPM = HttpService.postInfo("mng/campaign/subcampaign/batchExportSubCampaign/" + $scope.appid, { ids: $scope.selectIDS });
                exportPM.then(function(data) {
                    if (data == true) {
                        ToolService.hideLoading();
                        ToolService.showTips($filter('translate')("导出成功，正在为您下载！稍后请到”数据导出-子活动导出“中查看下载进度"));
                    } else {
                        ToolService.showTips($filter('translate')($filter('translate')("导出失败")));
                    }
                });
            }
        }
        $scope.gopage = function(id,inform) {
            ToolService.sendBehaviorUv("create");
            if (angular.isDefined(id)) {
                $state.go("collect.campaignDetail", { aid: inform});
            } else {
                $state.go("collect.campaignDetail");
            }
            $rootScope.campaignUrl = 'campaign';
        }

        $scope.toSubcamp = function(info, flag) {
            ToolService.sendBehaviorUv("toSubcamp");
            $rootScope.campChannel = info;
            if (flag && flag == 1) {
                $state.go("collect.subcampaignlistDetail");
            } else {
                $state.go("collect.subcampaignlist");
                $rootScope.campaignUrl = 'campaign';
            }
        }

        $scope.isShowShortUrl = false;
        $scope.showShortUrlTip = false;
        var impressionFlag = true;
        $scope.showShortUrl = function(info) {
            if (!info) {
                impressionFlag = true
            } else {
                impressionFlag = true
                if (info.impressionStop == 1) {
                    impressionFlag = false
                }
            }

            if (!$scope.isShowShortUrl && $scope.campaignList.length > 0 && !$scope.showShortUrlTip && impressionFlag) {
                $scope.showShortUrlTip = true;
                $scope.disabledtime = 3;
            }
        };
        $scope.showShortUrlSure = function() {
            $scope.showShortUrlTip = false;
            $scope.isShowShortUrl = true;
            // ToolService.showTips($filter('translate')("请勿将展现链接作为点击链接使用！"));
            $scope.copyingContent = undefined;
        };

        $scope.downLoadCode = function(campaignid) {
            if (campaignid) {
                var pm = HttpService.downFile("mng/mip/download/" + campaignid);
                pm.then(function(data) {

                });
            }
        }

        $scope.img = function(campaignid) {
            if (campaignid) {
                var pm = HttpService.getInfo("mng/mip/impression/" + campaignid);
                pm.then(function(data) {

                });
            }
        }

        /* $scope.initInfo = function(info){
             return {
                 isShowTrackUrl:(info.pack_channelid=='' || info.pack_channelid==null) && info.surl != '' && info.surl != '-1',
                 trackUrl:(info.channel==5305 && !info.surl) ?'-': info.trackurl,
                 impTrackurl:(info.surl == '' || info.surl == '-1')? '-': info.impTrackurl,/!*(info.channel==5305 && !info.surl)*!/
              };
         }*/
    }

    function campaignDetailCtrl($scope, $rootScope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $timeout, ArrayConstant, $filter) {
        if($stateParams.aid){
            $scope.isWangyan = $stateParams.aid.wangyan
            var infoId = $scope.id = $stateParams.aid.id;
            if($rootScope.campaignUrl == "subpackage"){
                infoId = $scope.id = $stateParams.aid
            }
            var onlineDateVal=$stateParams.aid.onlineDate;
            var subscribesVal=$stateParams.aid.subscribes;
        }
       

        var adBackURL = "http://uri6.com/attribute?idfa={md5_advertising_id}&lat={lat}&click_url={click_url}&click_timestamp={click_ts}&campaign_id={campaign_id}&video_id={video_id}";
        var oldname = "",
            oldpackcid = "";
        var oldScheme = "",
            olddomain = "";
        $scope.isedit = false;
        //$scope.specialGroup = 0;
        //1:gdt,2:domob,3:adwords,4:apploviv,5:xinshu,6:zhangyue,7:有道 8:智汇推，9:微信mp,10:inmobi,11:Thinklean,12:baiduysgg,13:xinlangfuyi
        //var specialChannel = ["","gdt","domob","adwords","applovin","xinshu","zhangyue","youdao","zht","weixinmp","inmobi","thinklean","baiduysgg","xinlangfuyi"];
        //$scope.dialogflag = ["gdt","zht","weixinmp","baiduysgg","xinlangfuyi"];
        $rootScope.feedback = ['gdt', 'zht', 'weixinmp', 'xinlangfuyi', 'huaweiads']; //后三种选中时，会出现Feedback_URL字段，有些同样的逻辑。
        $scope.batchList = ['baiduysgg', 'bilibili', 'kuaishou', 'xinshu', 'fengchao'];
        // $scope.mipTypeList = ['miniCode','miniQrCode','link'];
        $scope.mipTypeList = ToolService.getKeys(ArrayConstant.wayPromObj);
        if ($scope.iswx) {
            $scope.mipType = $scope.mipTypeList[0];
        } else if ($scope.iswg) {
            $scope.mipType = $scope.mipTypeList[2];
        }


        $scope.setProType = function(val) {
            if (!$scope.isedit) {
                $scope.mipType = val;
            }
        }


        $scope.goSet = function(type) { //管理员账号可以去配置，子账号没有权限配置
            if ($rootScope.isSuper || $rootScope.isManage) {
                $state.go("collect.channel", { aid: type });
            } else {
                ToolService.showTips($filter('translate')("您的账号无此权限，请使用主账号绑定"));
            }
        }
        $scope.timeDisable = true
        // if ($rootScope.isSuper || $rootScope.isManage) {
        if($rootScope.isall){
            $scope.timeDisable = false
        }

        $scope.openDialog = function() {
            if ($scope.nodeUrl != undefined || $scope.nodeUrl != null) {
                window.open($scope.nodeUrl);
            }
        }

        var channelObj = null;
        if (infoId != null) {
            $scope.isedit = true;
        }

        var channelPM = null;
        $scope.$on("curchannel", function(e, msg) {
            $scope.clickChannel(msg.info);
        });

        var accountPM = null;
        $scope.$watch("{appid:appid,lang:lang}", function(n, o) {
            if (angular.isDefined($scope.appid)) {
                ToolService.showLoading();
                var channelPM = HttpService.getInfo("mng/channel/find/" + $scope.appid + "/byaccount/show?showDel=1&filter=true");
                channelPM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.channelList = data;
                    $scope.channelList = data.filter(function(item) { //不显示优酷、优酷GD
                        if (item.name == "优酷" || item.name == "优酷GD") {
                            return false;
                        }
                        return true;
                    });
                });

                var nowApp = $scope.appInstance;
                $scope.isweb = nowApp.platform == "H5";

                if (nowApp.platform == 'Android') {
                    $scope.appos = '2';
                    $scope.adBackUrl = adBackURL + "&androidid={adid}";
                    $scope.gdtbundleid = "";
                } else if (nowApp.platform == 'iOS') {
                    $scope.appos = '1';
                    $scope.adBackUrl = adBackURL;
                    $scope.gdtbundleid = nowApp.bundleid;
                } else if (nowApp.platform == 'selfBuilt') {
                    $scope.appos = '5';
                    $scope.adBackUrl = adBackURL;
                    $scope.gdtbundleid = '';
                } else if (nowApp.platform == 'wx' || nowApp.platform == 'wg') {
                    $scope.appos = '4';
                    $scope.adBackUrl = adBackURL;
                    $scope.gdtbundleid = "";
                } else {
                    $scope.appos = '3';
                    $scope.adBackUrl = adBackURL;
                    $scope.gdtbundleid = "";
                }
                $scope.curappid = nowApp.id;
                if ($scope.demoU) {
                    $scope.url = "https://www.reyun.com";
                } else {
                    $scope.url = nowApp.url;
                }

                $scope.platname = nowApp.platform;

                if (angular.isDefined(channelObj) && channelObj != null) {
                    if (nowApp.platform == 'Android') {
                        $scope.subStr = channelObj.androidparam;
                    } else if (nowApp.platform == 'iOS') {
                        $scope.subStr = channelObj.iosparam;
                    } else {
                        $scope.subStr = "";
                    }
                }

                accountPM = HttpService.getInfo("mng/auth/find/" + $scope.appid);
                accountPM.then(function(data) {
                    $scope.accountList = data ? data.filter(function(item) {
                        return item.status == 1
                    }) : [];
                });
            }

            if (n.lang && o.lang && n.lang !== o.lang) {

            }

        }, true);


        $scope.empowerType = false;
        $scope.isDeeplink = false
        $scope.specialParams = [];
        $scope.specialAccounts = [];
        $scope.setInfoByChannel = function(obj) {
            $scope.channelname = obj.name;
            if (obj.uniqueName == "kuaishou") {
                $scope.isKuaishou = true;
            } else {
                $scope.isKuaishou = false;
            }
            $scope.uniqueName = obj.uniqueName;
            $scope.ismarket = obj.category == 'APPMARKET';
            $scope.ismarket && ($scope.batchNumber = undefined); //分包的时候活动创建数置空
            if (!UtilService.isNullStr(obj.specialParams)) {
                $scope.specialParams = JSON.parse(obj.specialParams);
                $scope.urlType = 'single';
            } else {
                $scope.specialParams = [];
            }
            $scope.ishttps = obj.ishttps;
            $scope.channType = obj.type;
            $scope.nodeUrl = obj.nodeUrl;
            var accPM = HttpService.getInfo("mng/auth/findchannel/" + $scope.appid + "/" + $scope.channel, {});
            accPM.then(function(data) {
                $scope.specialAccounts = data;
            });

            // deeplink 判断显示
            if (obj.type == 'ry_coop' && (($rootScope.isandroid && obj.category == 'ADVERTISING') || ($rootScope.isios && obj.category == 'ADVERTISING'))) {
                $scope.isDeeplink = true
            } else {
                $scope.isDeeplink = false
                $scope.delFlag = false
            }
        }

        $scope.clickChannel = function(obj) {
            channelObj = obj;
            $scope.channel = obj.id;
            $scope.surl = obj.trackurl;
            $scope.clickLinkType = obj.ishttps;
            if ($scope.platname == 'Android') {
                $scope.subStr = obj.androidparam;
            } else if ($scope.platname == 'iOS') {
                $scope.subStr = obj.iosparam;
            } else {
                $scope.subStr = "";
            }
            $scope.nodeUrl = channelObj.nodeUrl;
            if (obj.specialParams == null) {
                obj.specialParams = [];
            }
            if (!UtilService.isNullStr(obj.frontGenSurl) && obj.specialParams.length > 0) {
                ToolService.showLoading();
                var makeSurlPM = HttpService.getInfo("mng/campaign/" + $scope.appid + "/makesurl");
                makeSurlPM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.mysurl = data[0].surl;
                });
            }

            $scope.setInfoByChannel(obj);
            //广点通、adwords渠道
            if ($scope.uniqueName == "kuaishou") {
                $scope.isKuaishou = true;
            } else {
                $scope.isKuaishou = false;
            }

            if (($scope.uniqueName == 'gdt' || ($scope.uniqueName == 'adwords' && $scope.isios)) && ($rootScope.campaignUrl == 'campaign')) {
                $scope.isGdtAdwords = true;
            } else {
                $scope.isGdtAdwords = false;
            }
            // if ($scope.uniqueName == 'gdt') {
            //     $scope.isGdtAdwords = true;
            // } else {
            //     $scope.isGdtAdwords = false;
            // }
            if ($scope.feedback.indexOf($scope.uniqueName) > 0) {
                $scope.isNewMysurl = false;
            }
            //百度原生OCPC时，显示提示信息，样式变化。
            $scope.changeMB();
        }

        $scope.changeMB = function() {
            if ($scope.uniqueName == 'baiduysgg' && $scope.urlType == 'batch') {
                $scope.newMarginBottom = { 'margin-bottom': '10px' };
            } else {
                $scope.newMarginBottom = {};
            }
        }

        $scope.userOldModel = function() {

            $scope.isGdtAdwords = false;
        }

        var qrcode = null,
            qrcodeImp = null;
        try {

            qrcode = new QRCode(document.getElementById("mainfo"), {
                width: 300,
                height: 300
            });
            qrcodeImp = new QRCode(document.getElementById("mainfoImp"), {
                width: 300,
                height: 300
            });

        } catch (e) {
            // window.location.href="login.html";
        }

        $scope.showMa = false;
        $scope.showMaImp = false;
        $scope.$watch("surl+subStr+mysurl", function(val) {
            if (!angular.isDefined($scope.surl)) { return; }
            if ($scope.subStr != "" && $scope.subStr != null) {
                $scope.surltxt = $scope.surl + "?" + $scope.subStr;
                $scope.batchSub = "?" + $scope.subStr;
            } else {
                $scope.surltxt = $scope.surl;
                $scope.batchSub = "";
            }
            $scope.showMa = false;
            $scope.showMaImp = false;

            $scope.surltxt = $scope.surltxt.replace("$surl", $scope.mysurl);
            //feedback
            if ($scope.feedback.indexOf($scope.uniqueName) > -1) {
                $scope.feedbackUrl = $scope.surltxt;
            }

        });

        $scope.$watch("subStr+mysurl", function(newVal, oldVal) {
            if ($scope.feedback.indexOf($scope.uniqueName) > 0 && newVal && !$scope.isNewMysurl) {
                $scope.isNewMysurl = true;
            }
        });

        $scope.createMa = function() {
            qrcode.makeCode($scope.surltxt);
            $("#mainfo img").css({ "height": "60px", "width": "60px" });
            $timeout(function() {
                $scope.showMa = true;
                var src = $("#mainfo img").attr("src");
                $("#erwm").attr("href", src);
                $("#erwm").attr("download", $scope.mysurl + ".png");
            }, 200);
        };
        $scope.createMaImp = function() {
            qrcodeImp.makeCode($scope.impTrackurlTxt);
            $("#mainfoImp img").css({ "height": "60px", "width": "60px" });
            $timeout(function() {
                $scope.showMaImp = true;
                var src = $("#mainfoImp img").attr("src");
                $("#erwmImp").attr("href", src);
                $("#erwmImp").attr("download", $scope.mysurl + "_Imp.png");
            }, 200);
        };

        //商务账号列表
        $scope.holderids = [];


        $scope.checkType = function(type) {
            $scope.urlType = type;
            if (type == 'batch') {
                if (angular.isUndefined($scope.tip)) {
                    $scope.tip = {};
                }
                $scope.tip.name = {
                    txt: "",
                    status: false
                }
            }
            $scope.changeMB();
        }
        $scope.autoExportData = function(falg) {

        }

        $scope.autoExport = function() {
                //回显是否自动导出推广活动
                var autoExportPM = HttpService.getInfo("mng/campaign/" + $scope.appid + "/isAutoExport");
                autoExportPM.then(function(data) {
                    $scope.isAutoExportid = data.id;
                    if (data.isAutoExport == 1) {
                        $scope.autoExportData = true;

                    } else {
                        $scope.autoExportData = false;

                    }
                })
            }
            //判断deeplink app参数是否填写
        $scope.shoTipDeeplink = false;
        $scope.echoDeepLink = function() {
            var echoPM = HttpService.getInfo("mng/deeplink/" + $scope.appid + "/echoDeepLink");
            echoPM.then(function(data) {
                if (data.hasOwnProperty("code") && data.code == 200) {
                    $scope.shoTipDeeplink = true;
                } else {
                    $scope.shoTipDeeplink = false;
                }
            })
        }

        //回显deeplink
        $scope.getDeeplinkList = function(id) {
            ToolService.showLoading();
            var campaignid;
            if (id == -1) {
                campaignid = -1;
            } else {
                campaignid = $scope.id;
            }
            var deepInfoPM = HttpService.getInfo("mng/campaign/" + $scope.appid + "/" + campaignid + "/echoDeepLink");
            deepInfoPM.then(function(data) {
                var msg = data.message;
                var data = data.content;
                if (data) {
                    if ($scope.isedit) {
                        if ($scope.isedit && msg == "old") {
                            if (data.urlScheme) {
                                $scope.delFlag = true;
                            }
                            if (data.paths) {
                                $scope.delFlagdp = true;
                            }
                        }
                        if ($scope.isedit && msg == "new") {
                            $scope.delFlag = false;
                            $scope.delFlagdp = false;
                        }

                    }

                    $scope.deeplinkId = data.id;
                    if ($scope.delFlag == true) {
                        $scope.url = data.appDownload;
                    }

                    $scope.urlScheme = oldScheme = data.urlScheme;
                    $scope.mydomain = olddomain = data.linkId;

                    $scope.deeplinkpath = data.paths;
                    ToolService.hideLoading();
                }

            })
        }

        $scope.beginDate = $rootScope.onlineDateInfo;
        $scope.promotionFlag = false;
        $scope.doSwitchPromotion = function() { // true 表示开启的状态
            if($scope.promotionFlag && $scope.isedit){
                return false;
            }
            $scope.promotionFlag = !$scope.promotionFlag;
        }
        $scope.$on("beginDate",function(e,msg){
            $scope.beginDate = msg;
        });
        var init = function() {
            $scope.urlType = "single";
            $scope.batchnum = 1;
            $scope.batchNumber = "";
            $scope.clickLinkType = false;
            //批量生成短链情况下，显示提示信息
            if ($scope.showBatchurl == true && $scope.showBatchTip == false) {
                $scope.showBatchTip = true;
                return false;
            }
            if (angular.isDefined($scope.appid)) {
                $scope.autoExport();
                $scope.echoDeepLink();
                if (!$scope.isedit) {
                    $scope.getDeeplinkList(-1);

                }
            }

            //修改时，初始化该条数据到页面
            if ($scope.isedit) {
                $scope.promotionFlag = subscribesVal;
                $scope.beginDate = onlineDateVal;
                var eidtInfoPM = HttpService.getInfo("mng/campaign/find/" + $scope.id);
                // ToolService.showLoading();
                eidtInfoPM.then(function(data) {
                    $scope.type = data.type;
                    $scope.channel = data.channel;
                    $scope.name = oldname = data.name;
                    $scope.url = data.url;
                    $scope.clickLinkType = data.clickLinkType;
                    if ($scope.iswx) {
                        $scope.mipType = data.mipType;
                    } else {
                        $scope.pack_channelid = oldpackcid = data.pack_channelid;
                        $scope.impTrackurlTxt = data.impTrackurl;
                    }
                    if (UtilService.isNullStr(data.holderids)) {
                        $scope.holderids = [];
                    } else {
                        $scope.holderids = data.holderids.split(",");
                    }

                    if (data.advertiserid && data.advertiserid != '') {
                        $scope.advertiserid = data.advertiserid;
                        $scope.gdtbundleid = data.bundleid;
                    }
                    if(data.advertisid){
                        $scope.advertisid = data.advertisid
                    }
                    $scope.getDeeplinkList();

                });


                $q.all([channelPM, eidtInfoPM, accountPM]).then(function(data) {
                    ToolService.hideLoading();
                    var editInfo = data[1];
                    var appinfo = $scope.applistInfo ? $scope.applistInfo.filter(function(item) {
                        return item.id == editInfo.app;
                    }) : [];
                    if (appinfo.length > 0) {
                        var mapp = appinfo[0];
                        $scope.curappid = mapp.id;
                        $scope.curappname = mapp.name;
                        $scope.platname = mapp.platform;
                    }

                    $scope.setInfoByChannel(editInfo.channelobj);

                    if ($scope.specialParams.length > 0 && !UtilService.isNullStr(editInfo.specialKeys)) {
                        var params = editInfo.specialKeys,
                            paramsjson = {};
                        params.split("&").filter(function(item) {
                            var kkks = item.split("=");
                            var v = item.substring(item.indexOf("=") + 1);
                            paramsjson[kkks[0]] = v;
                        });
                        $scope.specialParams && $scope.specialParams.filter(function(sp) {
                            sp.val = paramsjson[sp.key];
                        });
                    }
                    $scope.mysurl = editInfo.surl;
                    $scope.surl = editInfo.trackurl;

                    $scope.accountList && $scope.accountList.filter(function(item) {
                        if ($scope.holderids.indexOf(item.id + "") > -1) {
                            item.ischeck = true;
                        }
                    });
                });
            }
        }
        init();


        //判断名称是否存在 
        $scope.exixtName = function(flag) {
            if (angular.isDefined(flag) && flag == 1) {
                ToolService.showLoading();
            }
            var doNext = function() {
                if (angular.isDefined(flag) && flag == 1) {
                    if ($scope.ismarket) {
                        $scope.exixtPackCid(1);
                    } else {
                        ToolService.hideLoading();
                        $scope.save();
                    }
                } else {
                    ToolService.hideLoading();
                }
            }
            if ($scope.urlType != 'batch' && $scope.judgeNameChange(oldname, $scope.name)) {
                var namePM = HttpService.getInfo("mng/campaign/valid/" + $scope.curappid, { name: $scope.name });
                namePM.then(function(data) {
                    $scope.tip = {};
                    if (data == true) { //存在
                        $scope.tip = {
                            name: {
                                status: true,
                                txt: $filter('translate')("名称已存在")
                            }
                        }
                        ToolService.hideLoading();
                    } else {
                        doNext();
                    }
                });
            } else {
                doNext();
            }
        }

        //判断渠道ID是否存在
        $scope.exixtPackCid = function(flag) {
            if ($scope.judgeNameChange(oldpackcid, $scope.pack_channelid)) {
                var packPM = HttpService.getInfo("mng/campaign/packcid/valid/" + $scope.curappid, { packchannelid: $scope.pack_channelid });
                packPM.then(function(data) {
                    $scope.tip = {};
                    if (data == true) { //存在
                        $scope.tip = {
                            pack_channelid: {
                                status: true,
                                txt: $filter('translate')("ID已存在")
                            }
                        }
                        ToolService.hideLoading();
                    } else {
                        if (angular.isDefined(flag) && flag == 1) {
                            $scope.save();
                        }
                    }
                });
            } else {
                if (angular.isDefined(flag) && flag == 1) {
                    $scope.save();
                }
            }
        }

        //批量创建数字 
        $scope.startNumber = 1;
        $scope.$watch("batchNumber", function(n) {

            // if(angular.isDefined(n)){//batchNumber设置为空是不应该排除
            if ($scope.urlType == 'batch' && $scope.batchNumber >= 2) {
                $scope.endNumberType = true;
                $scope.endNumber = parseInt($scope.startNumber) + parseInt($scope.batchNumber) - 1;
            } else {
                $scope.endNumberType = false;
                $scope.endNumber = 0;
            }
            // }
        });
        $scope.$watch("startNumber", function(n) {
            if (angular.isDefined(n)) {
                if ($scope.startNumber > 1) {
                    $scope.endNumber = parseInt($scope.startNumber) + parseInt($scope.batchNumber) - 1;
                }
            }
        });

        $scope.$on("noNumber", function() { 
            setTimeout(function() {
                $scope.batchNumber = "";
                $scope.$digest();
            }, 100);
        });
        $scope.checkChinese = function(obj_val){
            // var reg = new RegExp("[\\u4E00-\\u9FFF]+","g");
            var reg =/^\w+$/; //验证包含字符、数字和下划线
            if(reg.test(obj_val)){
                return false;
            }
            return true;
        }
        $scope.checkUrl = function(obj_val){
            var reg=/(http|https):\/\/[^\s]+/;
            if(reg.test(obj_val)){
                return false;
            }
            return true;
        }
        $scope.checkHuawei = function(obj_val){
            if(obj_val.indexOf(" ")==-1 && obj_val.length>=6 && obj_val.length<=64){
                return false
            }
            return true;
        }
        $scope.save = function() {
            ToolService.showLoading();
            var par = {
                channel: !$scope.channel ? "" : $scope.channel,
                name: $scope.name,
                callback: $scope.callback,
                url: $scope.url,
                os: $scope.platname,
                app: $scope.curappid,
            };
            var verPar = {
                name: {
                    key: 'spcname1',
                    val: par.name,
                    txt: $filter('translate')("支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内")
                },
                channelname: {
                    key: 'isNull',
                    val: $scope.channelname
                }
            };
            if ($scope.ismarket) { //分包
                par.pack_channelid = $scope.pack_channelid;
                verPar.pack_channelid = {
                    key: 'isNull',
                    val: $scope.pack_channelid
                };
                $scope.urlType = 'single';
                $scope.batchNumber = 1;
            }
            if ($scope.delFlag) {
                verPar.urlScheme = {
                    key: 'isNull',
                    val: $scope.urlScheme
                };

                if ($scope.delFlagdp) {
                    verPar.deeplinkpath = {
                        key: 'isNull',
                        val: $scope.deeplinkpath
                    };
                }
            }

            //批量创建增加字段

            if ($scope.uniqueName == 'gdt') {
                par.bundleid = $scope.gdtbundleid;
                par.advertiserid = $scope.advertiserid;
                verPar.gdtbundleid = {
                    key: 'isNull',
                    val: $scope.gdtbundleid
                };
                verPar.advertiserid = {
                    key: 'isNull',
                    val: $scope.advertiserid
                };
            }
            verPar.url = {
                key: 'url',
                val: $scope.url,
                txt: $filter('translate')("url不合法（支持输入以http://或https://开头的链接地址）")
            };
            // 爱奇艺分包
            if($scope.channel==10454 && $scope.isandroid && $scope.advertisid){
                par.advertisid = $scope.advertisid;
                verPar.advertisid = {
                    key: 'num',
                    max: 64,
                    txt: $filter('translate')("请输入数字，最多不可超过64位"),
                    val: $scope.advertisid
                };
            }
            // verPar.mpaccess_token = {
            //     key: 'url',
            //     val: $scope.url,
            //     txt: $filter('translate')("url不合法（支持输入以http://或https://开头的链接地址）")
            // };
            var holderids = [];
            $scope.accountList && $scope.accountList.filter(function(item) {
                if (item.ischeck) {
                    holderids.push(item.id);
                }
            });

            if ($scope.iswx) {
                whenWX(par, verPar);
            } else if ($scope.iswg) {
                whenWG(par, verPar);
            }
            $scope.tip = formJudge(verPar);
            if($scope.delFlag && $scope.urlScheme && ($scope.urlScheme.indexOf("://") < 1 || $scope.urlScheme.endsWith("://"))){
                    $scope.tip.succ = false;
                    $scope.tipMsg = true;
            }

            if (!$scope.isedit) {
                if ($scope.urlType == 'batch') {
                    par.batchNumber = $scope.batchNumber;
                    par.startNumber = $scope.startNumber;
                    par.endNumber = $scope.endNumber;
                    if (UtilService.isNullStr($scope.startNumber)) {
                        $scope.tip.succ = false;
                        $scope.tip.startNumber = {
                            txt: $filter('translate')("必填"),
                            status: true
                        }
                    } else if (par.startNumber <= 0) {
                        $scope.tip.succ = false;
                        $scope.tip.startNumber = {
                            txt: $filter('translate')("请输入>=1整数"),
                            status: true
                        }
                    }
                    if (UtilService.isNullStr($scope.batchNumber)) {
                        $scope.tip.succ = false;
                        $scope.tip.batchNumber = {
                            txt: $filter('translate')("必填"),
                            status: true
                        }
                    } else if (par.batchNumber < 2 || par.batchNumber > 100) {
                        $scope.tip.succ = false;
                        $scope.tip.batchNumber = {
                            txt: $filter('translate')("请输入>=2且<=100整数"),
                            status: true
                        }
                    }

                } else {
                    par.batchNumber = 1;
                }
            } else {
                par.surl = $scope.mysurl;
            }


            var error = 0;
            if ($scope.specialParams && $scope.specialParams.length > 0 && !$scope.ismarket) {
                var paramvals = [];
                $scope.specialParams.filter(function(item) {
                    if (UtilService.isNullStr(item.val) && !item.notrequired) {
                        item.txt = $filter('translate')("必填");
                        item.status = true;
                        error++;
                    }else if(item.val &&item.key == 'mpaccess_token' && $scope.checkUrl(item.val)){
                        item.txt = $filter('translate')("请输入正确的地址");
                        item.status = true;
                        error++;
                    } else if((item.key == 'mpappid'|| item.key == 'mpappsecret' ||item.key == 'mpmobile_app_id' ) && $scope.checkChinese(item.val)){
                        item.txt = $filter('translate')("输入格式错误");
                        item.status = true;
                        error++;
                    } else if($scope.channel== 17559 && item.key == "akey" && $scope.checkHuawei(item.val)){
                        item.txt = $filter('translate')("输入格式错误");
                        item.status = true;
                        error++;
                    }
                    else {
                        item.status = false;
                        paramvals.push(item.key + "=" + (item.val ? item.val : ''));
                    }
                    
                });
                if (error == 0) {
                    par.specialKeys = paramvals.join("&");
                }
            }
            if (error > 0) {
                ToolService.hideLoading();
                return false;
            }
            if ($scope.tip.succ == true) {
                var savePM = null,
                    txtTips = $filter('translate')("添加成功");
                par.holderids = holderids.join(",")
                if ($scope.autoExportData == true) {
                    $scope.statusExport = 1
                } else {
                    $scope.statusExport = 2
                }

                //deeplink 参数
                if ($scope.delFlag) {
                    par.appDeepLink = {
                        "appid": $scope.appid,
                        "urlScheme": $scope.urlScheme,
                        "linkId": $scope.mydomain,
                        "callType": 0,
                        "paths": $scope.deeplinkpath
                    }

                    if ($scope.delFlagdp && ($rootScope.isios || $rootScope.isandroid)) {
                        par.appDeepLink.callType = 1;
                    }
                }
                par.uniqueName = $scope.uniqueName;
                if($rootScope.showOnlineDates && $scope.isDeeplink){
                    if($scope.promotionFlag){ //开启创建预约推广活动
                        par.subscribes = true;
                        par.onlineDate = $scope.beginDate;
                    }else{
                        par.subscribes = false;
                        par.onlineDate = null;
                    }
                }
                
                if ($scope.isedit) {
                    par.id = infoId;
                    if ($scope.deeplinkId && $scope.delFlag) {
                        par.appDeepLink.id = $scope.deeplinkId;
                    }
                    savePM = HttpService.putInfo("mng/campaign/" + $scope.curappid + "/" + $scope.statusExport + "/" + $scope.isAutoExportid + "/update", par);
                    txtTips = $filter('translate')("修改成功");
                } else {
                    if (!UtilService.isNullStr($scope.surl)) {
                        par.surl = $scope.mysurl;
                    }
                    if($scope.uniqueName != 'gdt' && !$scope.ismarket && !$scope.iswx && !$scope.iswg){
                        par.clickLinkType = $scope.clickLinkType
                    }
                    savePM = HttpService.postInfo("mng/campaign/" + $scope.curappid + "/" + $scope.statusExport + "/create", par);
                    savePM.then(function(data) {
                        if (!$scope.ismarket && data[0] && data[0].id != undefined) {
                            var ids = "";
                            for (i = 0; i < data.length; i++) {
                                ids = ids + data[i].id + ",";
                            }
                            ids = ids.substring(0, ids.length - 1);
                            if (!$scope.iswx || ($scope.iswx && $scope.mipType == $scope.mipTypeList[2])) {
                                if ($scope.autoExportData) {
                                    $scope.downloadCampaign(ids, $scope.name);
                                }

                            } else {

                                if (data[0] && data[0].id) {
                                    $scope.downLoadCode(data[0].id);
                                }
                            }
                        }
                    });
                }

                savePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.code == -200) {
                        ToolService.showTips($filter('translate')("添加失败"));
                    } else if (data.hasOwnProperty("code") && data.code !== 200) {
                        ToolService.showTips(data.message);
                    } else if (angular.isArray(data) && data[0].id == undefined) {
                        $scope.sameNum = [];
                        for (i = 0; i < data.length; i++) {
                            $scope.sameNum.push(data[i].split("_")[1]);
                        }
                        if ($scope.sameNum.length <= 5) {
                            $scope.sameNum = $scope.sameNum.toString();
                        }
                    } else {
                        if (!$scope.isedit && $scope.uniqueName == 'smsearch') { //新建神马搜索的推广活动
                            //$scope.smcrmStatus = true;
                            $scope.empowerType = true;
                        } else {
                            ToolService.showTips(txtTips);
                            $scope.cancel(1);
                        }
                        if (!$scope.isedit) {
                            $rootScope.operSubmitData($filter('translate')("新建"));
                        }
                    }
                });
            } else {
                ToolService.hideLoading();
                ToolService.showTips($scope.formTipMsg);
            }
        }

        function whenWX(par, verPar) {
            par.url = $scope.url;
            par.mipType = $scope.mipType;
            verPar.url = {
                key: 'deviceManage',
                val: par.url,
                max: 255,
                reg: /^[A-Za-z0-9\/\_\-]+$/,
                txt: $filter('translate')("支持输入大小写字母、数字、斜线(/)、下划线(_)、中划线(-)")
            }
            verPar.mipType = {
                key: 'isNull',
                val: par.mipType
            }
            delete verPar.url;
            // delete par.url;
        }

        function whenWG(par, verPar) {
            par.mipType = $scope.mipType;
            verPar.mipType = {
                key: 'isNull',
                val: par.mipType
            }
            delete verPar.url;
            // delete par.url;
        }

        $scope.downloadCampaign = function(ids, name) {
            var downPM = HttpService.downFile("mng/campaign/autodownloadsurls/" + $scope.appid + "?ids=" + ids + "&name=" + name);
            //ToolService.showLoading();
            downPM.then(function(data) {
                //ToolService.hideLoading();
            });
        }

        $scope.cancel = function(flag) {
            if ($rootScope.campaignUrl == 'subpackage') {
                var key = 'subpackage';
            } else {
                var key = 'campaign';
            }
            if ($scope.isedit || flag) {
                var type = $scope.channType == null ? "custom" : $scope.channType;
                $state.go("collect." + key, { aid: type });
            } else {
                $state.go("collect." + key);
            }
        }

        $timeout(function() {
            var clipboard = new Clipboard('.campCopy');
            clipboard.on('success', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制成功"));
                });
            });

            clipboard.on('error', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制失败"));
                });
            });
        }, 200);


        $scope.downLoadCode = function(campaignid) {
            if (campaignid) {
                var pm = HttpService.downFile("mng/mip/download/" + campaignid);
                pm.then(function(data) {

                });
            }
        }



        $scope.openUrl = function() {
            window.open("https://developers.weixin.qq.com/miniprogram/dev/framework/app-service/scene.html");
        }
        $scope.openUrlDpApi = function(url) {
            window.open($rootScope.docDomain+url);
        }
        $scope.closeAdd = function() {
            ToolService.hideAlp();
            $scope.hintRefresh = false;
        }

        $scope.closeAwake = function() {
            ToolService.hideAlp();
            $scope.awakeRefresh = false;
        }
        $scope.goConfig = function() {
                if ($rootScope.isSuper) {
                    $state.go("collect.deeplink");
                } else {
                    ToolService.showTips($filter('translate')("您的账号无此权限，请使用主账号绑定"));
                }

            }
            //显示隐藏渠道开关
        $scope.hintRefresh = false;
        $scope.delFlag = false;
        $scope.awakeRefresh = false
        $scope.doSwitch = function() { // true 表示开启的状态
            $scope.delFlag = !$scope.delFlag;
            if (!$scope.delFlag) {
                $scope.delFlagdp = false;
            } else {
                if ($rootScope.arouseStatus == -1 || $rootScope.arouseStatus == 3) { //-1：未申请；1：审核中；2：已开通；3：已过期；
                    ToolService.showAlp();
                    $scope.awakeRefresh = true;
                }
            }

        }
       
        $scope.doSwitchUniversal = function() {
            if (!$scope.delFlag) {
                $scope.delFlagdp = false;
                return
            }
            if ($scope.shoTipDeeplink) {
                ToolService.showAlp();
                $scope.hintRefresh = true;
            } else {
                $scope.delFlagdp = !$scope.delFlagdp;
            }

        }
    }
})();