(function () {
    angular.module("app.manage")
        .controller("campgroupCtrl",["$scope","$rootScope","HttpService","ToolService","UtilService","$state","$filter",campgroupCtrl])
        .controller("campgroupDetailCtrl",["$scope","$rootScope","HttpService","ToolService","UtilService","$q","$state","$stateParams","$filter",campgroupDetailCtrl]);

    function campgroupCtrl($scope,$rootScope,HttpService,ToolService,UtilService,$state,$filter){
        $scope.$watch("appid+lang",function(n){
            if(angular.isDefined($scope.appid)){
                $scope.query();
                var onlineTime = $scope.appInstance.onlineDate;
                var currentTime =new Date().Format('yyyy-MM-dd');
                $scope.showOnlineTime = false;
                if(onlineTime &&  currentTime <= onlineTime){
                    $scope.showOnlineTime = true;
                }else{
                    $scope.showOnlineTime = false;
                }
                $scope.initFiltrate()
            }
        });
        
        $scope.curUID = Number(UtilService.getCookie("ryioUid"));
        $scope.initFiltrate = function(){
            $scope.customList = [
                { id: "all", name: $filter('translate')("全选")},
                { id: "0", name: $filter('translate')("常规活动组")},
                { id: "1", name: $filter('translate')("再营销活动组")},
                { id: "2", name: $filter('translate')("预约活动组")}
            ];
            $scope.customInit = $scope.customList[0].id;
        }
        
        $scope.$on("customId", function(e, msg) {
            var newInfo = msg.info.id;
            if($scope.groupData ){
                $scope.groupList = $scope.groupData.filter(function(item) {
                    if (newInfo == '1') {//再营销活动组
                        return item.deeplink;
                        }else if(newInfo == '2'){//预约活动组
                            return  item.type==1;
                        }else if(newInfo == '0'){//常规活动组
                            return item.type != 1 && !item.deeplink;
                        }
                        else{
                        return true;
                    }       
                });
            }
        });
        $scope.query = function () {
            var groupPM = HttpService.getInfo("mng/campgroup/" + $scope.appid + "/find");
            ToolService.showLoading();
            groupPM.then(function (data) {
                ToolService.hideLoading();
                $scope.groupList = data;
                $scope.groupData = data;

            });
        }
        $scope.sendEve = function(){
            ToolService.sendBehaviorUv("search");
                }
        $scope.$on('flipinfo', function (e, msg) {
            $scope.flipPage = msg;
        });

        $scope.doRemove = function (id) {
            ToolService.sendBehaviorUv("doRemove");
            $scope.delstatus = true;
            $scope.delId = id;
        }

        $scope.removeInfo = function () {
            var removePM = HttpService.deleteInfo("mng/campgroup/delete/" + $scope.delId);
            ToolService.showLoading();
            removePM.then(function (data) {
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($filter('translate')("删除成功"));
                $rootScope.operSubmitData($filter('translate')("删除"));
                $scope.query();
            });
        }

        $scope.split = function (string) {
            if (UtilService.isNullStr(string)) {
                return 0;
            } else {
                return string.split(",").length;
            }
        };

        $scope.gopage = function (id) {
            ToolService.sendBehaviorUv("create");
            if (angular.isDefined(id)) {
                $state.go("collect.campgroupDetail", { aid: id });
            } else {
                $state.go("collect.campgroupDetail");
            }
        }
    }

    function campgroupDetailCtrl($scope,$rootScope,HttpService,ToolService,UtilService,$q,$state,$stateParams,$filter){
        var editInfo = $stateParams.aid,infoId = null,oldname = "";
        $scope.groupType = false;

        $scope.setCustomData = function(type){
            if (!editInfo) {
                    $scope.groupType = type;
                    $scope.groupsType(type)
            }
        }
        $scope.groupsType = function(type){
            if($scope.channel){
                if(type){
                    $scope.campaignList = $scope.campaignListCopy.filter(function (item) {
                        return $rootScope.showOnlineDates || item.subscribes ? item.subscribes && item.channel == $scope.channel:item.deeplink && item.channel == $scope.channel;
                    });
                }else{
                    $scope.campaignList = $scope.campaignListCopy.filter(function (item) {
                        return $rootScope.showOnlineDates ? !item.subscribes && item.channel == $scope.channel : !item.deeplink && item.channel == $scope.channel;
                    });
                }
            }else{//新建
                if(type){
                    $scope.campaignList = $scope.campaignListCopy.filter(function (item) {
                        return $rootScope.showOnlineDates ? item.subscribes : item.deeplink
                    });
                }
                else{
                    $scope.campaignList = $scope.campaignListCopy.filter(function (item) {
                        return $rootScope.showOnlineDates ? !item.subscribes :!item.deeplink
                    });
                }
            } 
        }
        if (angular.isDefined(editInfo) && editInfo != null) {
            infoId = $scope.id = editInfo.id;
            if($rootScope.showOnlineDates){
                $scope.groupType = editInfo.type == 1 ? true: false;
            }else{
                $scope.groupType = editInfo.deeplink;
            }
        }

        var init = function () {
            if (editInfo != null) {
                $scope.name = oldname = editInfo.name;
                var curUID = Number(UtilService.getCookie("ryioUid")), cid = editInfo.createAccount;
                $scope.islook = (curUID != cid);
                if($rootScope.isall && curUID != cid){
                    $scope.islook = false;
                }
            }
        }
        init();

        $scope.selectCamp = function (campaign) {
            if ($scope.islook) { return false; }
            campaign.ischeck = false;
        }

        //渠道列表
        var channelObj = null;
        var channelPM = null;
        $scope.$on("curchannel",function(e,msg){
            $scope.clickChannel(msg.info);
        });


        $scope.$watch("appid+lang",function(n){
            if(angular.isUndefined($scope.appid)){return false;}
            ToolService.showLoading()
            var campaignPM = HttpService.getInfo($scope.appid+"/campaign/find");
            campaignPM.then(function(data){
                ToolService.hideLoading()
                $scope.oldcampaignList = data;
                $scope.campaignList = data;
                $scope.oldcampaignListCopy = data;
                $scope.campaignListCopy = data;
                $scope.groupsType($scope.groupType);
                if(editInfo!=null){
                    var ids = editInfo.campaigns,idsArr = ids.split(",");
                    $scope.campaignList.filter(function(item){
                        if(idsArr.indexOf(item.id+"")>-1){
                            item.ischeck = true;
                        }
                    });
                }
            });

            var channelPM = HttpService.getInfo("mng/channel/find/"+$scope.appid+"/byaccount/show?showDel=1");
            channelPM.then(function (data) {
                $scope.channelList = data;
                $scope.channelList = data.filter(function(item){
                        if(item.name == "优酷" || item.name == "优酷GD"){
                            return false;
                        }
                        return true;
                    });
            });

            var nowApp = $scope.appInstance;
            $scope.isweb = nowApp.platform == "H5";
            if(nowApp.platform == 'Android'){
                $scope.appos = '2';
            }
            else if(nowApp.platform == 'iOS'){
                $scope.appos = '1';
            }else if(nowApp.platform == 'selfBuilt'){
                $scope.appos = '5';
            }else if(nowApp.platform =='wx' || nowApp.platform =='wg'){
                $scope.appos = '4';
            }
            else{
                $scope.appos = '3';
            }
            $scope.curappid = nowApp.id;
            $scope.platname = nowApp.platform;
        });

        $scope.clickChannel = function (obj) {
            channelObj = obj;
            $scope.channel = obj.id;
            $scope.channelname = obj.name;
            $scope.uniqueName = obj.uniqueName; 

            if(obj.uniqueName == 'gdt' || obj.uniqueName == 'adwords'){
                var campPM = HttpService.getInfo($scope.appid+"/campaign/findallthird/"+obj.id);
                campPM.then(function(data){
                    data.unshift({id:"",name:$filter('translate')("不筛选投放账号")});
                    $scope.statusList = data;
                });
            }
            $scope.statusidInit = $scope.statusid = "";
            $scope.groupsType($scope.groupType);
            
        }
        $scope.deleteChannel = function () {
            channelObj = null;
            $scope.channel = '';
            $scope.channelname = '';
            $scope.uniqueName = ''; 
            $scope.groupsType($scope.groupType);
        }
        //选择投放列表
        $scope.$on("statusid", function (e, msg) {
            $scope.statusid = msg.info.id;
            if ($scope.statusid != '') {
                $scope.campaignList = $scope.oldcampaignList.filter(function (item) {
                    return item.channel == $scope.channel && item.thirdAccount == $scope.statusid;
                });
            } else {
                $scope.campaignList = $scope.oldcampaignList.filter(function (item) {
                    return item.channel == $scope.channel;
                });
            }
        });

        //判断推广活动组名称是否存在
        $scope.hsaName = false;
        $scope.exixtName = function () {
            if ($scope.judgeNameChange(oldname, $scope.name)) {
                var namePM = HttpService.postInfo("mng/campgroup/nameValid", { name: $scope.name, app: $scope.appid });
                namePM.then(function (data) {
                    $scope.tip = {};
                    if (data.code == -6001) {//存在
                        $scope.tip = {
                            name:{
                                status:true,
                                txt:$filter('translate')("名称已存在")
                            }
                        }
                        $scope.hsaName = true;
                    } else {
                        $scope.hsaName = false;
                    }
                });
            }
            else {
                $scope.hsaName = false;
            }
        }

        $scope.save = function () {
            if ($scope.hsaName) {
                return false;
            }
            var checkcmps = [];
                $scope.campaignList.filter(function (item) {
                if(item.ischeck == true){
                        checkcmps.push(item.id);
                }
            });
            var par = {
                app: $scope.appid,
                name: $scope.name,
                campaigns: checkcmps.join(",")
            };
            var verPar = {
                name: {
                    key: 'spcname1',
                    val: par.name,
                    txt: $filter('translate')("支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内")
                }
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            else{
                if(checkcmps.length == 0){
                    ToolService.showTips($filter('translate')("请至少选择一个推广活动"));
                    return false;
                }
            }
            if($rootScope.arouseStatus == 2 && !$rootScope.showOnlineDates){
                par.deeplink = $scope.groupType;
            }
            if($rootScope.showOnlineDates){
                par.type = $scope.groupType ? 1:0;
                par.subscribes = $scope.groupType;
            }
            var savePM = null,txtTips = $filter('translate')("添加成功");
            if(infoId!=null){
                par.id = infoId;
                savePM = HttpService.putInfo("mng/campgroup/update",par);
                txtTips = $filter('translate')("修改成功");
            }else{
                savePM = HttpService.postInfo("mng/campgroup/create",par);
            }
            ToolService.showLoading();
            savePM.then(function (data) {
                ToolService.hideLoading();
                if(data.code == -6001){
                    ToolService.showTips($filter('translate')("名称已存在"));
                    $scope.tip = {
                        name: {
                            txt:$filter('translate')('名称已存在'),
                            status:true
                        }
                    }
                }
                else {
                    ToolService.showTips(txtTips);
                    $scope.cancel();
                    if (!infoId) {
                        $rootScope.operSubmitData($filter('translate')("新建"));
                    }
                }
            }, function (data) {
                ToolService.hideLoading();
                if(data.code == -6001){
                    ToolService.showTips($filter('translate')("名称已存在"));
                    $scope.tip = {
                        name: {
                            txt:$filter('translate')('名称已存在'),
                            status:true
                        }
                    }
                }
            });
        }

        $scope.cancel = function () {
            $state.go("collect.campgroup");
        }
        $scope.selAll = false;
        $scope.selectAllEvent = function () {
            $scope.selAll = !$scope.selAll;
            var result = $filter('filter')($scope.campaignList, { name: $scope.cmpname });
            result.filter(function (item) {
                item.ischeck = $scope.selAll;
            });
        }
        $scope.myFilter = function (e) {
            return true;
        };
    }
})();
