angular.module("app.manage").controller("ckBatchManageCtrl",["$scope","$rootScope","ToolService","HttpService","UtilService","$filter",ckBatchManageCtrl]);

function ckBatchManageCtrl($scope,$rootScope,ToolService,HttpService,UtilService,$filter){

        var init = function(){
            $scope.typeList = [
                {id:'all',name:$filter('translate')('全部类型')},
                {id:'KEYWORDS',name:$filter('translate')('关键词')},
                {id:'CREATIVE',name:$filter('translate')('创意')},
            ]
            $scope.ckDataTypes = {
                "CREATIVE":$filter('translate')("创意"),
                "KEYWORDS":$filter('translate')("关键词")
            }
        }
        init();
        /*$scope.channelList = [
            {id:'all',name:'全部渠道'},
            {id:'545',name:'百度关键词'},
            {id:'5839',name:'搜狗搜索'},
        ];*/

        $scope.getChannelList = function (){
            var pm = HttpService.getInfo("sem/findChannel");
            pm.then(function(data){
                data.unshift({id:'all',name:$filter('translate')('全部渠道')});
                $scope.channelList = data;
                $scope.getChannelObj(data);
                //渠道初始值
                $scope.channelId = $scope.channelInit = $scope.channelList[0].id;
                $scope.filterChannel();
            });
        }

        $scope.getChannelList();

        $scope.filterChannel = function(){
            if($rootScope.isall){
                $scope.filterChannelList = $scope.channelList;
            }else{
                var Pm = HttpService.getInfo("sem/findAuth");
                Pm.then(function(data){
                    if(data){
                        $scope.filterChannelList = $scope.channelList.filter(function(item){
                            return item.id=='all' || data[item.id]==true;
                        });
                    }

                });
            }
        }

        $scope.filterChannel();

       /* $scope.channelObj = {
            '545':'百度关键词',
            '5839':'搜狗搜索'
        };*/
       $scope.getChannelObj = function(arr){
           var channelObj = {};
           arr.forEach(function(item){
               if(item.id!='all'){
                   channelObj[item.id] = item.name;
               }
           });
           $scope.channelObj = channelObj;
       }
        $scope.typeId = $scope.typeInit = $scope.typeList[0].id;

        $scope.taskStatuses = {
            0:$filter('translate')("进行中"),
            1:$filter('translate')("已完成"),
            2:$filter('translate')("系统异常")
        }

        //查询任务列表数据
        $scope.queryTaskList = function(){
            var appid = UtilService.getCookie("ryioLastApp");//从cookie中取出产品id
            if(appid){
                var Pm = HttpService.getInfo("sem/taskList/"+appid);
                Pm.then(function(data){
                    var bool = false;
                    if(data && data.length && $scope.isTaskList===undefined){
                        for(var i=0;i<data.length;i++){
                            if(!data[i].status){
                                bool = true;
                                break;
                            }
                        }
                        $scope.isTaskList = bool;
                    }
                    $scope.baseList = data;
                    $scope.filter();
                });
            }

        }

        //查询关键词创意Id列表
        $scope.queryCk = function(){
            var Pm = HttpService.getInfo("sem/keywordsList");
            Pm.then(function(data){
                $scope.baseList = data;
                $scope.filter();
            });
        }
        //关键词/创意 与 任务列表的切换,一些数据重置
        $scope.setTaskListStatus = function(val){
            $scope.isTaskList = val;
            $scope.searchTxt = "";
            !$scope.flipPage && ($scope.flipPage = {});
            $scope.flipPage.start = -1;
            $scope.flipPage.end = $scope.flipPage.pagen;
            $scope.baseList = $scope.filterList = [];
        }

    //监听页码，页数大小选择
    $scope.$on('flipinfo',function(e,msg){
        $scope.flipPage = msg;
    });

    $scope.$on('channelId',function(e,msg){
        $scope.channelId = msg.info.id;
    });

    $scope.$on('typeId',function(e,msg){
        $scope.typeId = msg.info.id;
    });


    $scope.$watch("isTaskList",function(newVal,oldVal){
        if(newVal===undefined || ($scope.isTaskList && oldVal!==undefined)){
            $scope.queryTaskList();
        }else if(newVal===false){
            $scope.queryCk();
        }
    });


    $scope.$watch('searchTxt+channelId+typeId',function(newVal,oldVal){
        $scope.filter();
    });

    $scope.filter = function(){
        if($scope.isTaskList===undefined) return;
        var key = $scope.searchTxt;
        if($scope.isTaskList){
            if(key){
                $scope.filterList = $scope.baseList ? $scope.baseList.filter(function(item){
                    return (item.cname ? (item.cname).indexOf(key)>-1 : false) || ((item.status==0 || item.status==1 ) ? ($scope.taskStatuses[item.status]).indexOf(key)>-1:false); //状态汉化，待处理。
                }):[];
            }else{
                $scope.filterList = $scope.baseList;
            }
        }else{
            $scope.filterList = $scope.baseList ? $scope.baseList.filter(function(item){
                return (($scope.channelId && $scope.channelId!='all') ? item.channelId == $scope.channelId :true) && (($scope.typeId && $scope.typeId!='all') ? item.dataType==$scope.typeId:true)
                    && (key ? (item.keyId.indexOf(key)>-1 || item.value.indexOf(key)>-1):true);
            }):[];
        }
    }

    $scope.delete = function(item){
        // ToolService.confirmDelete(item,"/aa","哈哈哈~~");
        if(item){
            $scope.selectedItem = item;

            $scope.isDel = true;
        }
    }

    //遮盖层显示/隐藏
    $scope.clickCover = function(val){
        $scope.isDel = val;
    }
    //遮盖层显示/隐藏
    $scope.clickCover1 = function(val){
        $scope.isErrorNumInfo = val;
    }
    //遮盖层内，显示页面，点击不关闭遮盖层
    $scope.clickCoverChild = function(e){
        e.stopPropagation();
    }
    //删除功能
    $scope.removeInfo = function(){
        if($scope.selectedItem){
            var url = $scope.isTaskList ? "sem/semtaskDelete/":"sem/keywordsDelete/";
            var Pm = HttpService.deleteInfo(url+$scope.selectedItem.id);
            Pm.then(function(data){
                if(!data){
                    ToolService.showTips($filter('translate')("删除成功"));
                    $scope.isDel = false;
                    $scope.isTaskList ? $scope.queryTaskList() : $scope.queryCk();
                }else{
                    ToolService.showTips($filter('translate')("删除失败"));
                }
            });
        }else{
            ToolService.showTips($filter('translate')("请选择一条数据"));
        }
    }
    //展示错误行
    $scope.showErorNumInfo = function(info){
        var errorLines = info.errorLine.split(',');
        if(info.errorLine && errorLines.length>0){
            if(errorLines[errorLines.length-1]<=50){
                $scope.errorMessage = info.errorLine+$filter('translate')("行未成功上传，请检查更新。");
            }else if(errorLines[errorLines.length-1]>50){
                var newErrorLines = errorLines.filter(function(item){
                    return item<=50;
                }).join(',');
                $scope.errorMessage = newErrorLines+$filter('translate')("等")+errorLines.length+$filter('translate')("行未成功上传，可能原因是关键词/创意id和名称有值为空或过长，请检查更新。");
            }
        }else{
            $scope.errorMessage = $filter('translate')("未有上传失败的行。");
        }
        $scope.isErrorNumInfo = true
    }

    /**
     * 语言切换
     */
    /*$scope.$watch("lang",function (n,o) {
        if(n && o && n!==o){
            init();
            $scope.getChannelList();
            $scope.filterChannel();
        }
    });*/

};