angular.module("app.manage").controller("ckBatchUploadCtrl",["$scope","$rootScope","$http","ToolService","HttpService","UtilService","$filter",ckBatchUploadCtrl]);

function ckBatchUploadCtrl($scope,$rootScope,$http,ToolService,HttpService,UtilService,$filter){

    /*$scope.channelList = [
        {id:'',name:'请选择渠道'},
        {id:'545',name:'百度关键词'},
        {id:'5839',name:'搜狗搜索'},
        {id:'10952',name:'360搜索'},
    ];*/

    $scope.getChannelList = function () {
        var pm = HttpService.getInfo("sem/findChannel");
        pm.then(function(data){
            data.unshift({id:'',name:$filter('translate')('请选择渠道')});
            $scope.channelList = data;
            //渠道初始值
            $scope.channelInit = $scope.channelId = $scope.channelList[0].id;
            $scope.filterChannel();
        });
    }

    $scope.getChannelList();


    //过滤渠道列表，对有权限的渠道在下拉中显示。
    $scope.filterChannel = function () {
        if ($rootScope.isall) {
            $scope.filterChannelList = $scope.channelList;
        } else {
            var Pm = HttpService.getInfo("sem/findAuth");//请求后台，获取渠道的权限
            Pm.then(function (data) {
                if (data) {
                    $scope.filterChannelList = $scope.channelList.filter(function (item) {
                        return item.id == '' || data[item.id] == true;
                    });
                }
            });
        }
    }



    //文件未上传状态
    $scope.uploadType = 'noupload';
    //选择文件
    $scope.$on("myFile",function(e,file){
        if(!$scope.channelId){
            ToolService.showTips($filter('translate')("请先选择渠道"));
            return false;
        }
        var name = file.name;
        var subIdx = name.lastIndexOf(".") + 1, subTxt = name.substring(subIdx);
        if (subTxt == 'xls' || subTxt == 'xlsx') {
            var size = file.size;
            if(size > 500 * 1024 * 1024){
                ToolService.showTips($filter('translate')("文件不能大于500M"));
                return false;
            }
            else {
                $scope.uploadname = name;
                $scope.uploadType = 'inupload';
                //$scope.uploadFile(file);
                $scope.uploadData = file;
            }
        }
        else{
            ToolService.showTips($filter('translate')("仅支持excel"));
            return false;
        }
    });
    //上传
    $scope.uploadFile = function(){
        if(!$scope.channelId){
            ToolService.showTips($filter('translate')("请先选择渠道"));
            return false;
        }
        if($scope.uploadType != 'inupload'){
            ToolService.showTips($filter('translate')("请先上传文件"));
            return false;
        }
        var channelId = $scope.channelId,appid  = UtilService.getCookie("ryioLastApp");//从cookie中取出产品id
        if(!channelId || !appid){
            ToolService.showTips($filter('translate')("渠道或者产品信息没有取到。"));
            return false;
        }
        var fd = new FormData();
        fd.append('file', $scope.uploadData);
        ToolService.showLoading();

        $http({
            method: 'POST',
            url: "api/sem/upload/" + channelId + "/" + appid,
            data: fd,
            headers: { 'Content-Type': undefined },
            transformRequest: angular.identity
        })
            .success(function (data) {
                if(data.code == 200){
                    data = data.content;
                    ToolService.hideLoading();
                    $scope.uploadType = 'upload';
                    ToolService.showTips($filter('translate')("上传成功"));
                    $scope.goPage('collect.ckBatchManage');
                }else{
                    // ToolService.showTips($filter('translate')("抱歉，当前内容或标题和模板不一致，请检查后重新上传！"));
                    ToolService.showTips(data.message,3000);
                }
                // $scope.cancel();
                // $scope.query();
            })
            .error(function (data) {
                $scope.uploadType = 'noupload';
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("网络超时，请重新上传"));
            });
    }
    //监听渠道选择
    $scope.$on('channelId', function (e, msg) {
        $scope.channelId = msg.info.id;
    });

    /**
     * 语言切换
     */
    $scope.$watch("lang",function (n,o) {
        if(n && o && n!==o){
            $scope.getChannelList();
        }
    });

};