angular.module("app.manage").controller("crowdAnalysisGuideCtrl",["$scope","$rootScope","$stateParams","ToolService","HttpService","cctFactory","$filter",crowdAnalysisGuideCtrl])
    .controller("crowdAnalysisCtrl",["$scope","$rootScope","$stateParams","ToolService","HttpService","$filter",crowdAnalysisCtrl])
    .controller("createCrowdTagCtrl",["$scope","$rootScope","$stateParams","ToolService","HttpService","cctFactory","$filter",createCrowdTagCtrl])
    .controller("crowdAnalysisListCtrl",["$scope","$rootScope","$stateParams","ToolService","HttpService","cctFactory","$filter",crowdAnalysisListCtrl])
    .controller("crowdAnalysisInfoCtrl",["$scope","$rootScope","$stateParams","ToolService","HttpService","cctFactory","$filter",crowdAnalysisInfoCtrl]);
//人群分析引导页控制类
function crowdAnalysisGuideCtrl($scope,$rootScope,$stateParams,ToolService,HttpService,cctFactory,$filter){
    $scope.message = $filter('translate')("我是人群分析引导页面");

    $scope.findOrders = function(){
        ToolService.showLoading();
        var qPM = HttpService.getInfo("crowd/findOrders");
        qPM.then(function(data){
            ToolService.hideLoading();
                // var data = [{"id": 58,"hobbyLabel": true,"payLabel": true,"weights": false,"dataRange": "all","iosAppkey": "0d401839250deff23daf62fd49a444cb","androidAppKey": "5c4af9a652ad53e71c68564ebac6e2e2","rootAccount": 38,"status": 1,"createTime": 1524131577000,"iosAppName": "trackingIO","androidAppName": "王者荣耀","payment": 0,"applyAccount": 38,"map": null,"deviceid_cnt": 120,"price": 10.0,"total": 360.0,"contractCode": "BJ-2018041921"}, {"id": 59,"hobbyLabel": true,"payLabel": true,"weights": false,"dataRange": "all","iosAppkey": "0d401839250deff23daf62fd49a444cb","androidAppKey": "d53944d0a73f1d7cb2941f201b36db36","rootAccount": 38,"status": 0,"createTime": 1524136545000,"iosAppName": "trackingIO","androidAppName": "h5sdkTest","payment": 0,"applyAccount": 38,"map": null,"deviceid_cnt": 0,"price": 0.0,"total": 0.0,"contractCode": "BJ-2018041906"}];
                // data[0].payment = 1;
            if(data.length==1){
                    if(data[0].status==0){
                        $scope.goCreateCrowdTag(2);
                    }else if(data[0].status==1){
                        $scope.goPage("collect.crowdAnalysisList");
                        cctFactory.list = data;
                    }
            }else if(data.length>=2){
                    $scope.goPage("collect.crowdAnalysisList");
                    cctFactory.list = data;
            }else{
                    $scope.goPage('collect.createCrowdTag');
            }
        });
    }
}
//人群分析控制类
function crowdAnalysisCtrl($scope,$rootScope,$stateParams,ToolService,HttpService,$filter){


}

function createCrowdTagCtrl($scope,$rootScope,$stateParams,ToolService,HttpService,cctFactory,$filter){
    //第一步
    $scope.step =  $stateParams.step || 1;

    if($stateParams.step==3){
        queryDetail($stateParams.id);
    }
    //重置
    //兴趣标签、付费、标签权重默认值
    $scope.hobbyLabel = $scope.payLabel = $scope.isAll = $scope.agree = true;
    $scope.weights = false;
    $scope.sysType = 0;

    $scope.iosList = [];
    $scope.andList = [];

    $scope.selectedTagIos = [];
    $scope.selectedTagAnd = [];

    $scope.errObj = {};

    $scope.setSysType = function(v){
        $scope.sysType = v;
    }

    $scope.getAppList = function(){
        ToolService.showLoading();
        $scope.iosList = [];
        $scope.andList = [];
        var appListPm = HttpService.getInfo("crowd/findApps");
        appListPm.then(function(data){
            ToolService.hideLoading();
            data.forEach(function(item){
                if(item.platform =="Android"){
                    $scope.andList.push(item);
                }else if(item.platform =="iOS"){
                    $scope.iosList.push(item);
                }
            });
        });
    }
    $scope.getAppList();

    $scope.save = function(){
            if(!$scope.checkForm()){
                ToolService.showTips($filter('translate')("信息填写不完整，请检查更新。"));
            }else{
                var params = {
                    weights:$scope.weights,
                }
                $scope.hobbyLabel && (params.hobbyLabel = $scope.hobbyLabel);
                $scope.payLabel && (params.payLabel = $scope.payLabel);
                params.dataRange = $scope.isAll?'all':'three';
                if($scope.selectedTagIos.length>0){
                    params.iosAppkey = $scope.selectedTagIos[0].appkey;
                    params.iosAppName = $scope.selectedTagIos[0].name;
                }
                if($scope.selectedTagAnd.length>0){
                    params.androidAppKey = $scope.selectedTagAnd[0].appkey;
                    params.androidAppName = $scope.selectedTagAnd[0].name;
                }
                ToolService.showLoading();
                var savePM = HttpService.postInfo("crowd/create",params);
                savePM.then(function(data){
                    ToolService.hideLoading();
                    if(data && data.id){
                        $scope.step = 2;
                    }else{
                        ToolService.showTips($filter('translate')("出现错误！"));
                    }
                });
            }
    }

    $scope.checkForm = function(){
        var isOk = true;
        if(!$scope.hobbyLabel && !$scope.payLabel){
            $scope.errObj.chooseTagType = {
                status:true,
                txt: $filter('translate')('请至少选择一种类型标签'),
            }
            isOk &&(isOk = false);
        }else{
            delete $scope.errObj.chooseTagType;
        }
        if(!($scope.weights == true || $scope.weights == false)){
            $scope.errObj.weights = {
                status:true,
                txt: $filter('translate')('请至少选择一种标签权重'),
            }
            isOk &&(isOk = false);
        }else{
            delete $scope.errObj.weights;
        }
        if(!($scope.isAll == true || $scope.isAll == false)){
            $scope.errObj.isAll = {
                status:true,
                txt: $filter('translate')('请选择用户群'),
            }
            isOk &&(isOk = false);
        }else{
            delete $scope.errObj.isAll;
        }
        if($scope.selectedTagIos.concat($scope.selectedTagAnd)<1){
            $scope.errObj.selectedTags = {
                status:true,
                txt: $filter('translate')('请至少选择一个产品'),
            }
            isOk &&(isOk = false);
        }else{
            delete $scope.errObj.selectedTags;
        }
        return isOk;
    }

    $scope.clickDire = function(val){
        $scope.showDire = val;//收费标准说明介绍页面
        $scope.direTag = false;//收费标准说明页面 标签体系隐藏/展示
        $scope.clickCover(val);
    }

    $scope.retBack = function(){
        var toUrl = 'collect.crowdAnalysisGuide';
       if($scope.step ==3){
            toUrl = "collect.crowdAnalysisList";
           $scope.goPage(toUrl);
        }else{
            ToolService.showLoading();
            var qPM = HttpService.getInfo("crowd/findOrders");
            qPM.then(function(data) {
                ToolService.hideLoading();
                if(data.length>1 || (data.length==1 && data[0].status>0)) {
                    toUrl = "collect.crowdAnalysisList";
                    cctFactory.list = data;
                }
                $scope.goPage(toUrl);
            })
        }
    }

    function queryDetail(id){
        //查询订单详情
        if(id){
            ToolService.showLoading();
            var orderDetailPM = HttpService.getInfo('crowd/findDetail/'+id);
            orderDetailPM.then(function(data){
            $scope.curOrder = data;
            $scope.newValue = ToolService.detailSort(data.map.value);
            ToolService.hideLoading();
            $scope.priceList = ToolService.countPrice(data);
            // console.log($scope.priceList);
            });
        }else{
            ToolService.showTips($filter('translate')("未取到订单ID"));
        }
    }
    //遮盖层显示/隐藏
    $scope.clickCover = function(val){
        $scope.showCover = val;
    }
    //遮盖层内，显示页面，点击不关闭遮盖层
    $scope.clickCoverChild = function(e){
        e.stopPropagation();
    }
    //服务协议隐藏/显示
    $scope.clickDoc = function(val){
        $scope.showDoc = val;
        $scope.clickCover(val);
    }

    $scope.cancel = function(){

    }

    /**
     * 语言切换
     */
    $scope.$watch("lang",function (n,o) {
        if(n && o && n!==o){
            $scope.getAppList();
        }
    });
}

function crowdAnalysisListCtrl($scope,$rootScope,$stateParams,ToolService,HttpService,cctFactory,$filter){

    $scope.goDetails = function(info){
        var isPay = info.payment,status = info.status,id=info.id;
        if(isPay){
            $scope.goCrowdAnalysisInfo(id);
        }else{
            if(status){
                $scope.goCreateCrowdTag(3,id);
            }else{
                $scope.goCreateCrowdTag(2);
            }
        }
    }

    $scope.findOrders = function(){
        ToolService.showLoading();
        var qPM = HttpService.getInfo("crowd/findOrders");
        qPM.then(function(data){
            ToolService.hideLoading();
            $scope.deviceFilterList = data;
            // data[0].payment = 1;
        });
    }

    if(cctFactory.list.length>0){
        $scope.deviceFilterList = cctFactory.list;
        // cctFactory.list = [];
    }else{
        $scope.findOrders();
    }

    $scope.downFile = function(id){
        ToolService.showLoading();
        var downPM =  HttpService.downFile("crowd/download/"+id);
        downPM.then(function(){
            ToolService.hideLoading();
            $rootScope.operSubmitData($filter('translate')("下载"));
        });
    }

    $scope.$on('flipinfo',function(e,msg){
        $scope.flipPage = msg;
    });

    /**
     * 语言切换
     */
    $scope.$watch("lang",function (n,o) {
        if(n && o && n!==o){
            $scope.findOrders();
        }
    });
}

function crowdAnalysisInfoCtrl($scope,$rootScope,$stateParams,ToolService,HttpService,cctFactory,$filter){

    $scope.queryDetail = function(){
        //查询订单详情
        var id = $stateParams.id;
        if(id){
            ToolService.showLoading();
            var orderDetailPM = HttpService.getInfo('crowd/findDetail/'+id);
            orderDetailPM.then(function(data){
                $scope.curOrder = data;
                $scope.newValue = ToolService.detailSort(data.map.value);
                ToolService.hideLoading();
            });
        }else{
            ToolService.showTips($filter('translate')("未取到订单ID"));
        }
    }

    $scope.queryDetail();

    /**
     * 语言切换
     */
    $scope.$watch("lang",function (n,o) {
        if(n && o && n!==o){
            $scope.queryDetail();
        }
    });

}

