(function() {
    angular.module("app.manage")
        .controller("customchannelCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "DateService", "$timeout", "$filter", "$translate", customchannelCtrl]);

    function customchannelCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $q, $state, $stateParams, DateService, $timeout, $filter, $translate){
        var init = function() {
            $scope.deviceList = [
                { id: 1, name: $translate.instant("已启用") },
                { id: 2, name: $translate.instant("已停用") }
            ];
        }
        init();
        if ($rootScope.isSuper || $rootScope.isManage) {
            $scope.editPower = true;
        } else {
            $scope.editPower = false;
        }
        $scope.deviceInit = $scope.deviceList[0].id;
        $scope.filterList = function() {
                $scope.channelList = [];
                if($scope.customList.length>0){
                    $scope.channelList = $scope.customList.filter(function(item) {
                        if (item.name == "优酷" || item.name == "优酷GD") {
                            return false;
                        }
                        if ($scope.seeFlag == 1) { return item.delFlag != true; }
                        if ($scope.seeFlag == 2) { return item.delFlag == true; }
                    });
            }
        }
        $scope.query = function(bol) {
            var url = "mng/channel/find";
            ToolService.showLoading();
            var channelPM = HttpService.getInfo(url);
            channelPM.then(function(data) {
                ToolService.hideLoading();
                $scope.customList = data;
                $scope.filterList();
            });
        }
        $scope.query();
        var rmd = new Date().getTime();
        $scope.$on('flipinfo', function(e, msg) {
            if (msg.listkey == 'account') {
                $scope.flipPage2 = msg;
            } else if (msg.listkey == 'public') {
                $scope.flipPage = msg;
                $scope.flipChange = ++rmd;
            } else {
                $scope.flipPage3 = msg;
            }
        });
        $scope.$on("deviceId", function(e, msg) {
            $scope.seeFlag = msg.info.id;
            if ($scope.customList) {
                $scope.filterList();
            }
        });
        $scope.gopage = function(info) {
            if (angular.isDefined(info)) {
                $state.go("collect.channelDetail", { aid: info });
            } else {
                $state.go("collect.channelDetail");
            }
        }
        $scope.doRemove = function(info) {
            ToolService.sendBehaviorUv("doRemove");
            $scope.delId = info.id;
            $scope.delInfo = info;
            ToolService.showLoading();
            var prePM = HttpService.getInfo("mng/channel/delete/valid/" + $scope.delId);
            prePM.then(function(data) {
                ToolService.hideLoading();
                if (angular.isNumber(data) && data > 0) {
                    $scope.delflagStatus = 2;
                    $scope.campnum = data;
                } else {
                    $scope.delflagStatus = 1;
                }
                $scope.delstatus = true;
            });
        }
        $scope.removeInfo = function() {
            if ($scope.delflagStatus == 2) {
                $scope.delstatus = false;
                return false;
            }
            var removePM = HttpService.deleteInfo("mng/channel/delete/" + $scope.delId);
            ToolService.showLoading();
            $scope.delstatus = 0;
            removePM.then(function(data) {
                ToolService.hideLoading();

                ToolService.showTips($translate.instant("停用成功"))
                $scope.query(true);
                $rootScope.operSubmitData($translate.instant("停用"));
            });
        }
        $scope.enableInfo = function(info) {
            ToolService.sendBehaviorUv("enableInfo");
            var isEnablePM = HttpService.postInfo("mng/channel/channelname/check",{name:info.name,id:info.id});
            isEnablePM.then(function (data) {
                if (data.code && data.code== -5002) {
                    ToolService.showTips(data.message)
                } else {
                    var enablePM = HttpService.putInfo("mng/channel/enable/" + info.id);
                    ToolService.showLoading();
                    enablePM.then(function(data) {
                        ToolService.hideLoading();
                        ToolService.showTips($translate.instant("启用成功"))
                        $scope.query(true);
                        $rootScope.operSubmitData($translate.instant("启用"));
                    });
                }
            })
        }
    }
})();