(function(){
    angular.module("app.manage")
        .controller("customeventCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$http","$timeout","$filter",customeventCtrl]);

    function customeventCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$http,$timeout,$filter){
        $scope.$watch("appid+lang",function(n){
            if(angular.isDefined($scope.appid)){
                $scope.query();
            }
        });

        $scope.query = function(){
            if($scope.appid == undefined){
                return false;
            }
            $scope.curEditId = -1;
            var subPM = HttpService.getInfo("sdkevent/find/"+$scope.appid);
            ToolService.showLoading();
            subPM.then(function(data){
                ToolService.hideLoading();
                $scope.groupList = data;
            });
        }
        /**
         *  事件排序，按照event_1、event_2、event_3。。。进行排序
         * @param item
         * @returns {number}
         */
        $scope.eventSort = function(item){
            var na = item.eventName;
            if(na.indexOf('event_')>-1){
                return parseInt(na.substr(na.indexOf('event_')+'event_'.length));
            }else{
                return new Date().getTime();
            }
        }
        $scope.sendEve = function(){
            ToolService.sendBehaviorUv("search");
        }
        
        $scope.editName = function(info){
            ToolService.sendBehaviorUv("editName");
            $scope.curEditId = info.id;
            info.rename = info.eventAlias;
        }
        $scope.saveName = function(info){
            if(info.eventAlias == info.rename){
                $scope.curEditId = -1;
                return false;
            }
            if(info.rename==''){
                ToolService.showTips($filter('translate')("不能为空"));
                return false;
            }
            var verPar = {
                rename: {
                    key: 'spcname3',
                    val: info.rename,
                    txt: $filter('translate')("支持输入汉字、大小写字母、数字，最多20个字符，不可为空"),
                    max:20
                }
            };
            $scope.tip = formJudge(verPar);
            if($scope.tip.succ == true){

                info.eventAlias = info.rename

                ToolService.showLoading();
                var namePM = HttpService.putInfo("sdkevent/update/"+info.id,info);
                namePM.then(function(data){
                    ToolService.hideLoading();
                    if(data==true){
                        ToolService.showTips($filter('translate')("修改成功"));
                        info.subChannelName = info.rename;
                        $scope.curEditId = -1;
                    }
                    else{
                        ToolService.showTips($filter('translate')("名称重复"));
                    }
                });
            }
            else{
                ToolService.showTips($scope.tip.rename.txt);
            }
        }
        var curfilpPage = null,rmd = new Date().getTime();
        $scope.$on('flipinfo',function(e,msg){
            $scope.flipPage = msg;

            $scope.flipChange = ++ rmd;
        });
    }
 
})();
        