(function() {
    angular.module("app.manage")
        .controller("datacbCtrl", ["$rootScope", "$scope", "$rootScope", "HttpService", "ToolService", "UtilService", "$state", "$filter", datacbCtrl])
        .controller("datacbDetailCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$filter", datacbDetailCtrl]);

    /*数据回调 {"codename":"install","name":"激活"},*/

    var newbackEvts = [];


    function datacbCtrl($rootScope, $scope, $rootScope, HttpService, ToolService, UtilService, $state, $filter) {
        var backEvts = [
            { id: "reged", "codename": "reged", "name": $filter('translate')('注册') },
            { id: "loggedin", "codename": "loggedin", "name": "登录" },
            { id: "payment", "codename": "payment", "name": $filter('translate')('付费') }
        ];
        var eventNames = [
            { "id": "install", "codename": "install", "name": $filter('translate')('激活') },
            { id: "reged", "codename": "reged", "name": $filter('translate')('注册') },
            { id: "order", "codename": "order", "name": $filter('translate')('订单') },
            { id: "loggedin", "codename": "loggedin", "name": $filter('translate')('登录') },
            { id: "event", "codename": "event", "name": $filter('translate')('效果点') },
            { id: "payment", "codename": "payment", "name": $filter('translate')('付费') },
            { id: "nextday", "codename": "nextday", "name": $filter('translate')('次留') },
            { id: "firstdayPayment", "codename": "firstdayPayment", "name": $filter('translate')('新增付费') },
            { id: "invoke", "codename": "invoke", "name": $filter('translate')('调起') },
            { id: "keybehavior", "codename": "keybehavior", "name": $filter('translate')('关键行为') },
        ];

        $scope.query = function(flag) {
            var backPM = null;
            if (flag) {
                $scope.backFlag = flag;
                $rootScope.thirdtab = { 'define': $filter('translate')('自定义回调管理'), 'install': $filter('translate')('激活回调管理') }[flag];
            }
            if ($scope.backFlag == 'define') {
                $scope.searchtip = $filter('translate')('输入名称搜索');
                backPM = HttpService.getInfo("mng/datacb/find/" + $scope.appid);
            } else {
                $scope.searchtip = $filter('translate')('输入渠道搜索');
                backPM = HttpService.getInfo("mng/datacb/install/" + $scope.appid);
            }

            ToolService.showLoading();
            $scope.searchTxt = "";
            backPM.then(function(data) {
                ToolService.hideLoading();
                $scope.backList = data; 
            });
        }

        $scope.$watch("appid+lang", function(n) {
            if (angular.isDefined($scope.appid)) {

                var effectPM = HttpService.getInfo($scope.appid + "/event/find");
                effectPM.then(function(data) {
                    $scope.effectList = data;
                });

                /*var channelPM = HttpService.getInfo("mng/channel/find/"+$scope.appid+"/byaccount/show");
                channelPM.then(function(data){
                    $scope.channelList = data;
                });*/

                $scope.query();
            }
        });

        $scope.backFlag = 'define';
        $scope.searchtip = $filter('translate')('输入名称搜索');
        $scope.changeBack = function(flag) {
            $scope.backFlag = flag;
            $scope.query();
        }

        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;
        });

        /*var channelPM = HttpService.getInfo("mng/channel/find/"+$scope.appid+"/byaccount/show");
        channelPM.then(function(data){
            $scope.channelList = data;
        });*/

        $scope.getChannelName = function(id) {
            if (!$scope.channelList) { return ""; }

            var name = "";
            for (var i = 0; i < $scope.channelList.length; i++) {
                var temp = $scope.channelList[i];
                if (temp.id == id) {
                    name = temp.name;
                    break;
                }
            }
            return name;
        }

        $scope.eventName = function(obj) {
            var backs = eventNames.filter(function(item) {
                return item.codename == obj.what;
            });
            if (backs.length > 0) {
                return backs[0].name;

            } else if ($scope.effectList && $scope.effectList.length > 0) {
                var name = "";
                for (var i = 0; i < $scope.effectList.length; i++) {
                    var temp = $scope.effectList[i];
                    if (temp.eventName == obj.what) {
                        name = temp.eventNameAlias;
                        break;
                    }
                }
                return name;
            } else {
                return "";
            }
        }
        $scope.sendEve = function() {
            ToolService.sendBehaviorUv("search");
        }

        $scope.onUser = function(info) {
            ToolService.sendBehaviorUv("onUser");
            var id = info.id;
            var par = {
                what: info.what
            }
            ToolService.showLoading();
            var userPM = HttpService.putInfo("mng/datacb/enable/" + id, par);
            userPM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("启用成功"));
                $rootScope.operSubmitData($filter('translate')("启用"));
                $scope.query();
            });
        }
        $scope.offUser = function(info) {
            ToolService.sendBehaviorUv("offUser");
            var id = info.id;
            var par = {
                what: info.what
            }
            var userPM = HttpService.putInfo("mng/datacb/forbidden/" + id, par);
            ToolService.showLoading();
            userPM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("停用成功"));
                $rootScope.operSubmitData($filter('translate')("停用"));
                $scope.query();
            });
        }

        $scope.onActive = function(info) {
            ToolService.sendBehaviorUv("onActive");
            var tips = $filter('translate')('启用成功'),
                bol = 1;
            if (info.status == true) {
                tips = $filter('translate')('停用成功');
                bol = 0;
            }
            var userPM = HttpService.postInfo("mng/datacb/install/" + $scope.appid + "/setting?channelid=" + info.channel + "&button=" + bol, {});
            ToolService.showLoading();
            userPM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips(tips)
                $scope.query();
            });
        }
        $scope.doRemove = function(info) {
            ToolService.sendBehaviorUv("doRemove");
            $scope.delstatus = true;
            $scope.delId = info.id;
            $scope.what = info.what;

        }
        $scope.removeInfo = function() {
            var removePM = HttpService.deleteInfo("mng/datacb/delete/" + $scope.delId + "?what=" + $scope.what);
            ToolService.showLoading();
            removePM.then(function(data) {
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($filter('translate')("删除成功"));
                $rootScope.operSubmitData($filter('translate')("删除"));
                $scope.query();
            });
        }

        $scope.gopage = function(info) {
            ToolService.sendBehaviorUv("create");
            if (angular.isDefined(info)) {
                $state.go("collect.datacbDetail", { aid: info });
            } else {
                $state.go("collect.datacbDetail");
            }
        }
    }

    function datacbDetailCtrl($scope, $rootScope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $filter) {
        var backEvts = [
            { id: "reged", "codename": "reged", "name": $filter('translate')('注册') },
            { id: "loggedin", "codename": "loggedin", "name": "登录" },
            { id: "payment", "codename": "payment", "name": $filter('translate')('付费') }
        ];
        var eventNames = [
            { "id": "install", "codename": "install", "name": $filter('translate')('激活') },
            { id: "reged", "codename": "reged", "name": $filter('translate')('注册') },
            { id: "loggedin", "codename": "loggedin", "name": $filter('translate')('登录') },
            { id: "event", "codename": "event", "name": $filter('translate')('效果点') },
            { id: "payment", "codename": "payment", "name": $filter('translate')('付费') }
        ];
        var editInfo = $stateParams.aid,
            infoId = null;
        if (editInfo != null) {
            infoId = $scope.id = editInfo.id;
            $scope.listWhat = editInfo.what; //编辑时的选中事件
            whenAdwordsEdit(editInfo); //渠道是否为'adwords'
        }

        var effectPM = null,
            oldname = "";

        var paramsPM = HttpService.getInfo('mng/datacb/find/params');
        paramsPM.then(function(data) {
            $scope.paramsInfos = data;
        });

        var channelPM = HttpService.getInfo("mng/channel/find/" + $scope.appid + "/byaccount/show?showDel=1");
        channelPM.then(function(data) {
            $scope.channelList = data;
            $scope.channelList = data.filter(function(item) {
                if (item.name == "优酷" || item.name == "优酷GD") {
                    return false;
                }
                return true;
            });
        });

        $scope.$watch("appid+lang", function(n) {
            if (angular.isDefined($scope.appid)) {
                var appObj = $scope.appInstance;
                if (appObj.platform == 'Android') {
                    $scope.appos = '2';
                } else if (appObj.platform == 'iOS') {
                    $scope.appos = '1';
                } else {
                    $scope.appos = '3';
                }

                effectPM = HttpService.getInfo($scope.appid + "/event/find");
                effectPM.then(function(data) {
                    $scope.effectList = [];
                    data.filter(function(item, i) {
                        var temp = {
                            id: i + 1,
                            codename: item.eventName,
                            name: item.eventNameAlias
                        };
                        $scope.effectList.push(temp);
                    });
                });

                $q.all([paramsPM, effectPM]).then(function() {
                    $scope.eventList = UtilService.merge(newbackEvts, $scope.effectList);
                    if (editInfo == null) {
                        $scope.myeventInit = $scope.eventList[0].id;
                    }
                });

                $scope.init();
            }
        });
        $scope.$on('myevent', function(e, msg) {
            $scope.selEvent(msg.info);
            if(msg.info.id == 'nextday'){
                $scope.showSpecialNextday(msg.info.id)
            }else{
                $scope.specialNextday = false
            }
            

        });

        $scope.selAll = false;
        var eventParams = [];
        $scope.selEvent = function(obj) {
            var isArr = eventParams;
            if (typeof obj == 'string') {
                obj = angular.fromJson(obj);
            }
            $scope.eventid = obj.codename;
            $scope.eventname = obj.name;

            if (obj.id != obj.codename) { //效果点
                $scope.paramsList = $scope.paramsInfos["effect"];
            } else {
                $scope.paramsList = $scope.paramsInfos[$scope.eventid];
            }

            $scope.selAll = false;
            if (!$scope.paramsList) { $scope.paramsList = []; }
            $scope.paramsList.filter(function(item) {
                if (angular.isDefined(isArr) && isArr.indexOf(item.key) > -1) {
                    item.ischeck = true;
                } else {
                    item.ischeck = false;
                }
            });
            eventParams = [];
        }
        $scope.selectAllEvent = function() {
            $scope.selAll = !$scope.selAll;
            $scope.paramsList.filter(function(item) {
                item.ischeck = $scope.selAll;
            });
        }

        $scope.keybehaviorInit = '';
        var sdkeventPM = HttpService.getInfo("sdkevent/find/" + $scope.appid);
        sdkeventPM.then(function(data) {
            data.unshift({eventName:'',eventAlias:'请选择需要回调的事件'})
            $scope.keybehaviorList = data;
        });
        $scope.$on('keybehavior', function(e, msg) {
            $scope.keybehavior = msg.info.eventName
        });

        $scope.hasPaymentAmount = 0;
        $scope.hasSpecialNextday = 0;
        $scope.clickSpecialNextday= function(flag){
            $scope.hasSpecialNextday = flag
        }
        $scope.isIntegrateChannel = false;
        $scope.$on("curchannel", function(e, msg) {
            $scope.clickChannel(msg.info)
        });
        $scope.clickChannel = function(obj, wh) {
            $scope.channel = obj.id;
            $scope.channelname = obj.name;
            $scope.clickChannelInfo = obj
            whenAdwords(obj); //渠道是否为'adwords'
            $scope.isIntegrateChannel = obj.isintegrate == true;
            if ($scope.isIntegrateChannel == true) { //isIntegrateChannel含义：是否有回调渠道模板
                var intePM = HttpService.getInfo("mng/datacb/find/events/" + obj.id);
                intePM.then(function(data) {
                    // $scope.eventList = data;
                    if (data.length > 0) {
                        var curevent = null;
                        $scope.eventList = data.filter(function(item) {
                            item.id = item.codename;
                            if (angular.isDefined(wh) && item.codename == wh) {
                                curevent = item;
                            }
                            return true
                        });
                        if (curevent != null) {
                            $scope.myeventInit = curevent.id;
                        } else {
                            $scope.myeventInit = $scope.eventList[0].id;
                        }
                    }
                });
            } else {
                $scope.eventList = UtilService.merge(newbackEvts, $scope.effectList);
                $scope.myeventInit = $scope.eventList[0] && $scope.eventList[0].id;
            }
        }
        $scope.specialNextday = false
        $scope.showSpecialNextday = function(){
            var type = $scope.clickChannelInfo.type
            var category = $scope.clickChannelInfo.category
            $scope.loginuserName = UtilService.getCookie("ryioUname");

            if(type== 'ry_coop' && category == 'ADVERTISING' && ($scope.loginuserName == 'trackingio@webeye.com' || $scope.loginuserName =='trackingio@reyun.com')){
                $scope.specialNextday = true
            }
        }
        $scope.init = function() {
            $scope.allData = false;
            $scope.usecode = false;

            $scope.eventList = UtilService.merge(backEvts, []);
            if (infoId != null) {
                var data = editInfo;
                $scope.id = id = data.id;
                $scope.name = oldname = data.name;

                $scope.channel = data.channel;

                $scope.allData = data.allData;

                if(data.what=='keybehavior'){
                    $scope.keybehavior = $scope.keybehaviorInit = data.event;
                }
                if(($scope.channel==514 || $scope.channel==9219 || $scope.channel==501)&&(data.what=='payment'||data.what=='firstdayPayment')){
                    $scope.hasPaymentAmount = data.hasPaymentAmount;
                }

                if (data.url == null) {
                    $scope.accepturl = "";
                } else {
                    var url = data.url,
                        ps = url.substring(url.indexOf("?") + 1),
                        pA = ps.split("&"),
                        name = "";
                    $scope.accepturl = url.substring(0, url.indexOf("?"));
                }

                $q.all([paramsPM, effectPM, channelPM]).then(function(infos) {
                    var mychannels = $scope.channelList.filter(function(item) {
                        return item.id == data.channel;
                    });
                    if (mychannels.length > 0 && mychannels[0].isintegrate == true) {
                        $scope.isIntegrateChannel = true;

                        $scope.usecode = false;
                        $scope.successcode = "";
                        $scope.successkey = "";
                        $scope.successvalue = "";

                        $scope.clickChannel(mychannels[0], data.what);
                    } else {
                        $scope.isIntegrateChannel = false;
                        $scope.channelname = mychannels[0].name;

                        $scope.successcode = data.successcode;
                        if (UtilService.isNullStr(data.successcode)) {
                            $scope.usecode = false;
                        } else {
                            $scope.usecode = true;
                        }
                        $scope.successkey = data.successkey;
                        $scope.successvalue = data.successvalue;

                        var pas = [];
                        if (pA) {
                            for (var i = 0, len = pA.length; i < len; i++) {
                                var item = pA[i],
                                    pp = item.split("=");
                                pas.push(pp[0]);
                            }
                        }

                        eventParams = pas;
                        $scope.eventList.filter(function(item) {
                            if (item.codename == data.what) {
                                $scope.myeventInit = item.id;
                            }
                        });
                    }
                });
            }
        };
        //判断账号是否存在
        $scope.exixtName = function(flag) {
            if (angular.isDefined(flag) && flag == 1) {
                ToolService.showLoading();
            }

            if ($scope.judgeNameChange(oldname, $scope.name)) {
                var namePM = HttpService.getInfo("mng/datacb/valid/" + $scope.appid, { name: $scope.name });
                namePM.then(function(data) {
                    $scope.tip = {};
                    if (data == true) { //存在
                        $scope.tip = {
                            name: {
                                status: true,
                                txt: $filter('translate')("名称已存在")
                            }
                        }
                        ToolService.hideLoading();
                    } else {
                        if (angular.isDefined(flag) && flag == 1) {
                            //
                            if ($scope.hideFormItem) {
                                $scope.veriAppKeyAdLink($scope.save);
                            } else {
                                $scope.save();
                            }
                        }
                        ToolService.hideLoading();
                    }
                });
            } else {
                if (angular.isDefined(flag) && flag == 1) {
                    ToolService.hideLoading();
                    if ($scope.hideFormItem) {
                        $scope.veriAppKeyAdLink($scope.save);
                    } else {
                        $scope.save();
                    }
                }
            }
        }

        $scope.eventText = false;

        $scope.save = function() {

            var par = {
                name: $scope.name, //回调‘名称’
                app: $scope.appid, //‘产品ID’
                channel: $scope.channel, //‘渠道’
                allData: $scope.allData, //‘数据范围’
                what: $scope.eventid //‘事件’
            };
            //verPar 校验表单项用的对象
            var verPar = {
                name: {
                    key: 'spcname1',
                    val: par.name,
                    txt: $filter('translate')("支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内")
                },
                channelname: {
                    key: 'isNull',
                    val: $scope.channelname
                },
                whatname: {
                    key: 'isNull',
                    val: $scope.eventid
                }
            }

            var pArr = []; //已选参数
            if ($scope.isIntegrateChannel == false && !$scope.hideFormItem) { //当'渠道'选择'adwords'时，‘事件’下的页面项不进行校验。
                par.url = $scope.accepturl;
                verPar.accepturl = {
                        key: 'url',
                        val: $scope.accepturl,
                        txt: $filter('translate')("url格式有误")
                    }
                    //'参数'-已选参数
                $scope.paramsList.filter(function(item) {
                    if (item.ischeck == true) {
                        pArr.push(item.key + "=" + item.value);
                    }
                });

                if ($scope.usecode == true) { //'启动状态码'
                    par.successcode = $scope.successcode;
                    verPar.successcode = {
                        key: "isNull",
                        val: $scope.successcode
                    }
                } else {
                    par.successkey = $scope.successkey; //'成功key'
                    par.successvalue = $scope.successvalue; //'成功value'

                    verPar.successkey = {
                        key: "isNull",
                        val: $scope.successkey
                    }
                    verPar.successvalue = {
                        key: "isNull",
                        val: $scope.successvalue
                    }
                }
            } else {
                par.allData = false; // 数据范围不显示的条件下 默认传false
            }

            if($scope.eventid=="keybehavior"){
                par.event = $scope.keybehavior
                verPar.keybehavior = {
                    key: "isNull",
                    val: $scope.keybehavior
                }
            }
            if(($scope.channel==514 || $scope.channel==9219  || $scope.channel==501)&&($scope.eventid=="payment"||$scope.eventid=="firstdayPayment")){
                par.hasPaymentAmount = $scope.hasPaymentAmount
            }
            if($scope.specialNextday){
                if($scope.hasSpecialNextday == 1){
                    if($scope.keybehaviorList.length<2 || !$scope.keybehavior){
                        ToolService.showTips($scope.formTipMsg);
                        return false
                    }
                    par.special_event = $scope.keybehavior
                }
                par.special_nextday = $scope.hasSpecialNextday
            }
            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ == true) { //资料验证
                if ($scope.isIntegrateChannel == false && !$scope.hideFormItem) { //同上
                    if (pArr.length == 0) { //'参数'校验
                        $scope.tip = {
                            moreparams: {
                                status: true,
                                txt: $filter('translate')("至少选择一个参数")
                            }
                        }
                        return false;
                    } else {
                        par.url += "?" + pArr.join("&");
                    }
                }

                var savePM = null,
                    txtTips = $filter('translate')("添加成功");
                if (infoId != null) {
                    par.id = infoId;
                    savePM = HttpService.putInfo("mng/datacb/update", par);
                    txtTips = $filter('translate')("修改成功");
                } else {
                    savePM = HttpService.postInfo("mng/datacb/create", par);
                }
                ToolService.showLoading();
                savePM.then(function(data) {
                    ToolService.hideLoading();
                    if (angular.isUndefined(data.code) == false && data.code == '-1011') {
                        $scope.eventText = true;
                    } else if (angular.isUndefined(data.code) == false && data.code == '-5005') {
                        $scope.eventText = false;
                        ToolService.showTips(data.content);
                    } else {
                        $scope.eventText = false;
                        ToolService.showTips(txtTips);
                        $scope.cancel();
                        if (!infoId) {
                            $rootScope.operSubmitData($filter('translate')("新建"));
                        }
                    }
                }, function(data) {
                    ToolService.hideLoading();
                    if (data.code == '-1011') {
                        $scope.eventText = true;
                    }
                });
            } else {
                ToolService.showTips($scope.formTipMsg);
            }
        }

        $scope.cancel = function() {
            $state.go("collect.datacb");
        }

        $scope.veriAppKeyAdLink = function(save) {
            if (!$scope.appid) {
                ToolService.showTips($filter('translate')("您当前appkey未绑定adwords账号的linkID，请先进行绑定再配置。"));
                return false;
            }
            var vakaPm = HttpService.getInfo("mng/datacb/validlinkid/" + $scope.appid);
            vakaPm.then(function(data) {
                if ((typeof data == 'number' && data > 0) || (typeof data == 'object' && data.content > 0)) {
                    save();
                } else {
                    ToolService.showTips($filter('translate')("您当前appkey未绑定adwords账号的linkID，请先进行绑定再配置。"));
                }
            });
        }

        function whenAdwords(obj) {
            $scope.hideFormItem = obj.uniqueName == "adwords"; //选择渠道adwords时,隐藏表单'事件'以下的项。
        }

        function whenAdwordsEdit(obj) {
            $scope.hideFormItem = obj.channel == 5303; //选择渠道adwords时,隐藏表单'事件'以下的项。
        }
    }
})();