angular.module("app.manage").controller("deviceManageCtrl",["$scope","$rootScope","ToolService","HttpService","$filter",deviceManageCtrl]);
function deviceManageCtrl($scope,$rootScope,ToolService,HttpService,$filter){

    $scope.searchtip = $filter('translate')("请输入关键字搜索");
    //一个用户允许添加的最大条数
    $scope.maxItems = 200;

    $scope.query = function(){
        ToolService.showLoading()
        var listPM = HttpService.getInfo("white/find");
        listPM.then(function(data){
            $scope.deviceList = data;
            ToolService.hideLoading();
        });
    }
    //首次进入页面查询
    $scope.query();

    //搜索关键字和后台返回列表数组进行监听，深度监听
    $scope.$watch("{'searchTxt':searchTxt,'deviceList':deviceList}",function(newVal){
        var key = newVal.searchTxt ? newVal.searchTxt:"";
        if($scope.deviceList){
            // $scope.deviceFilterList && $scope.deviceFilterList.reverse();
            ($scope.deviceFilterList = $scope.deviceList.filter(function(item){
                    for(var k in item){
                        if(item[k] && (typeof item[k] =='string') && item[k].indexOf(key)!=-1)return true;
                    }
                })
            )
        }
    },true);

    $scope.sendEve = function(){
        ToolService.sendBehaviorUv("search");
    }
    
    //表尾翻页事件监听
    $scope.$on('flipinfo',function(e,msg){
        $scope.flipPage = msg;
    });

    //弹出删除询问框
    $scope.confirmDelete = function(item){
        ToolService.sendBehaviorUv("confirmDelete");
        $scope.selectedItem = item;
        if($scope.selectedItem && $scope.selectedItem.id){
            $scope.delstatus = true;
        }else{
            ToolService.showTips($filter('translate')("数据没有选中！"))
        }
    }
    //点击确认
    $scope.removeInfo = function(){
        if($scope.selectedItem && $scope.selectedItem.id){
            var url = "white/delete/"+$scope.selectedItem.id;
            var removePM = HttpService.postInfo(url);
            ToolService.showLoading();
            $scope.delstatus = false;
            removePM.then(function(data){
                ToolService.hideLoading();
                ToolService.showTips($filter('translate')("删除成功"))
                $scope.query();
            });
        }else{
            ToolService.showTips($filter('translate')("数据没有选中！"))
        }
    }
    function resetSelectItem(){
        $scope.selectedItem =  {
            id:'',
            deviceName:'',
            platform:$scope.systemList[1].id,
            idfa:'',
            androidId:'',
            imei:'',
            oaid:''
        };
        $scope.errObj = {};
    }
    $scope.add = function(){
        ToolService.sendBehaviorUv("add");
        if($scope.deviceFilterList.length>= $scope.maxItems){
            ToolService.showTips($filter('translate')("最多添加200个白名单设备！"))
        }else{
            $scope.addstatus = true;
            resetSelectItem();
        }
    }

    $scope.closeAdd = function () {
        $scope.addstatus = false;
        var oldItem = $scope.oldSelectedItem;
        //取消按钮，恢复修改的数据。
        for(var key in oldItem){
            $scope.selectedItem[key] = oldItem[key];
        }
        $scope.errObj = {};
    }

    $scope.systemList = [
        {id:'ios',name:'IOS'},
        {id:'android',name:'Android'}
    ]
    //监听系统类型切换
    $scope.$on('platform',function(e,msg){
        !$scope.selectedItem.id && resetSelectItem();
        $scope.platform = $scope.selectedItem.platform = msg.info.id;
        $scope.errObj = {};
    })

    var params = {
        platform:{
            key: 'deviceManage',//验证的哪条规则
            val: '',
            nullTxt:$filter('translate')('请选择系统')
        }, deviceName:{
            key: 'deviceManage',
            val: '',
            max: 40,
            regFlag: false,//不匹配这条规则的报错。
            reg: /^[a-zA-Z0-9_\-\·\u4E00-\u9FA5]+$/,
            txt: $filter('translate')('支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内。'),
            nullTxt:$filter('translate')('请输入设备名')
        },idfa:{
            key: 'deviceManage',
            val: '',
            max: 40,
            regFlag: false,
            reg: /^[a-zA-Z0-9-]+$/,
            txt: $filter('translate')('仅支持大小写字母、数字、中划线。'),
            nullTxt:$filter('translate')('请输入IDFA')
        },androidId:{
            key: 'deviceManage',
            val: '',
            max: 40,
            regFlag: false,
            reg: /^[a-zA-Z0-9]+$/,
            txt: $filter('translate')('仅支持大小写字母、数字。'),
            nullTxt:$filter('translate')('请输入Android ID'),
            canBeEmpty: true
        }
        // ,imei:{
        //     key: 'deviceManage',
        //     val: '',
        //     max: 40,
        //     regFlag: false,
        //     reg: /^[a-zA-Z0-9]+$/,
        //     txt: $filter('translate')('仅支持大小写字母、数字。'),
        //     nullTxt:$filter('translate')('请输入IMEI')
        // },
    }

    $scope.checkParams = function(item){
        var param = {};
        var paramVal = {};
        var demo = params[item['key']];
        for(var key in demo){
            paramVal[key] = params[item['key']][key];
        }
        paramVal.val = item.val;
        param[item['key']] = paramVal;
        var infoObj = formJudge(param);
        if(infoObj.succ){
            delete $scope.errObj[item['key']];
        }else{
            $scope.errObj[item['key']] = infoObj[item['key']]
        }
    }

    $scope.save = function(){
        // if($rootScope.demoU){return false;}
        var thisObj = angular.copy($scope.selectedItem),
            platform = thisObj['platform'],
            newParams = {};
        for(var k in thisObj){//安卓系统时，不提交idfa值；ios系统时，不提交imei、androidID、oaid；
            if(params[k]){
                if((platform ==this.systemList[0].id && (k == 'imei' ||k == 'androidId' || k == 'oaid')) || (platform==this.systemList[1].id && (k == 'idfa'))){
                    delete thisObj[k];
                    continue;
                }
                newParams[k] = {};
                for(var ke in params[k]){
                    newParams[k][ke] = params[k][ke];
                }
                newParams[k].val = thisObj[k];
            }
        }
       
        var checkAll = formJudge(newParams);
        if(checkAll.succ){
            if (platform == 'android' && !$scope.selectedItem.androidId && !$scope.selectedItem.imei && !$scope.selectedItem.oaid){
                $scope.errObj['androidId'] ={status:true,txt: '请至少添加一种设备ID'};
                $scope.errObj['imei'] ={status:true,txt: '请至少添加一种设备ID'};
                $scope.errObj['oaid'] ={status:true,txt: '请至少添加一种设备ID'};
                return;
            }
            ToolService.showLoading();
            var savePM = HttpService.postInfo(thisObj.id ? ('white/update/'+thisObj.id) :'white/create',thisObj);
            savePM.then(function(data){
                ToolService.hideLoading();
                if(data.code == -300){
                    ToolService.showTips(data.message)
                    return false;
                }
                if(data.id){
                    $scope.addstatus = false;
                    $scope.query();
                }else{
                    for(var k in data){
                        var kChi ='';
                        switch(k){
                            case 'platform':
                                kChi = $filter('translate')('该名称');
                                break;
                            case 'idfa':
                                kChi = $filter('translate')('AID/IDFA值');
                                break;
                            case 'imei':
                                kChi = $filter('translate')('IMEI值');
                                break;
                            case 'oaid':
                                kChi = $filter('translate')('OAID值');
                                break;
                            case 'androidId':
                                kChi = $filter('translate')('Android ID值');
                                break;
                            default:
                                kChi = $filter('translate')('该值');
                        }
                        $scope.errObj[k] ={status:true,txt: kChi+$filter('translate')('已存在，请检查更新。')};
                    }
                }
                
            });
        }else{
            this.errObj = checkAll;
            // ToolService.showTips("信息填写不完整，请检查更新。");
        }
    }

    $scope.edit = function (item) {
        ToolService.sendBehaviorUv("edit");
        $scope.addstatus = true;
        $scope.selectedItem = item;
        $scope.oldSelectedItem = {};
        for(var key in item){
            $scope.oldSelectedItem[key] = item[key];
        }
        $scope.selectedItem && !$scope.selectedItem.platform && ($scope.platform = $scope.selectedItem.platform = $scope.systemList[1].id);
        $scope.errObj = {};
    }

    $scope.$watch("lang",function(n,o){
        if(n && o && n!==o){
            $scope.query();
            $scope.searchtip = $filter('translate')("请输入关键字搜索");
        }
    });

}