(function(){
    angular.module("app.manage")
        .controller("onelinkCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$state","$timeout","$stateParams","$filter",onelinkCtrl])
        .controller("onelinkDetailCtrl",["$scope","HttpService","ToolService","UtilService","$q","$state","$stateParams","$http","$filter",onelinkDetailCtrl]);

    function onelinkCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$state,$timeout,$stateParams,$filter){

        $scope.$watch("appid+lang",function(n){
            if(angular.isDefined($scope.appid)){
                var systemType = $scope.platform;
                var appId = $scope.appid;
                $scope.query();
            }
        });

        $scope.query = function(){
            var oneLinkPM = HttpService.getInfo("mng/onelink/"+$scope.appid+"/find");
            ToolService.showLoading();
            oneLinkPM.then(function(data){
                ToolService.hideLoading();
                $scope.oneLinkList = data;
            });
        }  
        
        var curfilpPage = null,rmd = new Date().getTime();
        $scope.$on('flipinfo',function(e,msg){
            $scope.flipPage = msg;

            $scope.flipChange = ++ rmd;
        });

        $scope.$watch("flipChange+oneLinkList",function(){
            if($scope.flipPage && $scope.oneLinkList){
                curfilpPage = {start:$scope.flipPage.start+1,end:$scope.flipPage.end};
                if(curfilpPage.end > $scope.oneLinkList.length){
                    curfilpPage.end = $scope.oneLinkList.length;
                }

                $timeout(function(){
                    var clipboard = new Clipboard('.copyBtn');
                    clipboard.on('success', function(e) {
                        $scope.$apply(function(){
                            ToolService.showTips($filter('translate')("复制成功"));
                        });
                    });

                    clipboard.on('error', function(e) {
                        $scope.$apply(function(){
                            ToolService.showTips($filter('translate')("复制成功"));
                        });
                    });
                },200);
            }
        });

        $scope.doRemove = function(info){
            if(info.son == true){
                ToolService.showTips($filter('translate')("你没有")+info.sonName+$filter('translate')("产品权限，不能删除。"));
            }else{
                $scope.delTips = $filter('translate')("是否删除 “")+info.name+$filter('translate')("” ONELINK？");
                $scope.delstatus = true;
                $scope.delId = info.id;
                $scope.delObj = info;
            }
            
        }
        $scope.removeInfo = function(){
            var removePM = HttpService.deleteInfo("mng/onelink/"+$scope.appid+"/delete/"+$scope.delId);
            ToolService.showLoading();
            removePM.then(function(data){
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($filter('translate')("删除成功"))
                $scope.query();
            });
        }

        $scope.addOneLink = function(){
            ToolService.sendBehaviorUv("addOneLink");
            var addLinkPM = HttpService.getInfo("mng/onelink/"+$scope.appid+"/valid");
            ToolService.showLoading();
            addLinkPM.then(function(data){
            // var data = {};
                ToolService.hideLoading();
                // data.content = 2;//
                if(data.content == 3 || data == 3){
                    if($scope.platform == 'iOS'){
                        ToolService.showTips($filter('translate')("当前没有Android App，不能创建onelink。"));
                    }else{
                        ToolService.showTips($filter('translate')("当前没有iOS App，不能创建onelink。"));
                    }
                }else if(data.content == 0 || data == 0){
                    if($scope.platform == 'iOS'){
                        ToolService.showTips($filter('translate')("当前iOS App的自定义渠道和SEM渠道下没有推广活动，不能创建onelink。"));
                    }else{
                        ToolService.showTips($filter('translate')("当前Android App的自定义渠道和SEM渠道下没有推广活动，不能创建onelink。"));
                    }
                }else if(data.content == 1 || data == 1){
                    if($scope.platform == 'iOS'){
                        ToolService.showTips($filter('translate')("该主账号Android App的自定义渠道和SEM渠道下没有推广活动，不能创建onelink。"));
                    }else{
                        ToolService.showTips($filter('translate')("该主账号iOS App的自定义渠道和SEM渠道下没有推广活动，不能创建onelink。"));
                    }
                }else{
                    $state.go("collect.onelinkDetail");
                }
            });
        }

        $scope.gopage = function(info){
            if(angular.isDefined(info)){
                if(info.son == true){
                    ToolService.showTips($filter('translate')("你没有")+info.sonName+$filter('translate')("产品权限，不能编辑。"));
                }else{
                    $state.go("collect.onelinkDetail",{aid:info});
                }
                
            }else{
                $state.go("collect.onelinkDetail");
            }
        }
        $scope.doDownload = function(info){
            var dlPM = HttpService.downFile("mng/onelink/"+$scope.appid+"/download/"+info.id);
            dlPM.then(function(data){
            })
        }
    }
    function onelinkDetailCtrl($scope,HttpService,ToolService,UtilService,$q,$state,$stateParams,$http,$filter){
        var type = 'ry_bd',ios = 'ios',and='and';
        $scope.isSem = false;//是否有一个选了sem选项
        $scope.firstSem = '';//是哪个选了sem选项
        //当前主产品
        $scope.$watch("platform",function(n){
            if(angular.isDefined(n)){
            
            }else{
                $state.go("collect.onelink");
            }
        });
        $scope.$watch("{AndroidActive:AndroidActive}",function(n,o){
            if(n.AndroidActive && n.AndroidActive != 0 && ($scope.andChannelType == null && $scope.category == 'APPMARKET')){
                $scope.getPackagesubcampaign($scope.AndroidActive)
            }

        })
        $scope.$on("AndroidSubcampaignActive",function(e,msg){
            setTimeout(function(){
                $scope.AndroidSubcampaignActive = msg.info.id
                $scope.AndroidActiveSurl = msg.info.surl;
                $scope.AndroidActiveTrackurl = msg.info.trackUrl;
                $scope.AndroidActiveurl = msg.info.url;
                $scope.AndroidActiveIosParam = msg.info.androidParam;
            })
        })
        $scope.codeFlag = false;
        $scope.doSwitch = function() { // true 表示开启的状态
            $scope.codeFlag = !$scope.codeFlag;
            if (!$scope.codeFlag) {
                $scope.codeFlag = false;
            }
        }
        $scope.MainAppName = $scope.appInstance && $scope.appInstance.name;
        $scope.MainAppId = $scope.appInstance && $scope.appInstance.id;
        var rmd = new Date().getTime();
        $scope.isedit1 = false;
        $scope.isedit2 = false;
        $scope.iosFirstActive = true;
        //IOS activity
        $scope.iosActive = function(id,channel){
            var IOSActivePM = HttpService.getInfo("mng/onelink/"+id+"/find/campaigns/"+channel);
            IOSActivePM.then(function(data){
                $scope.IosActiveList = data;
                $scope.$on("IosActive",function(e,msg){
                    $scope.channelType1 = msg.info.type;
                    $scope.IosActive = msg.info.id;
                    $scope.IosActiveTrackurl = msg.info.trackurl;
                    $scope.mainIosParam = msg.info.onelikParam;
                    $scope.IosinfoType = msg.info.type;
                    $scope.IosActiveSurl = msg.info.surl;
                    $scope.IosActiveurl = msg.info.url;  
                    $scope.IosActiveIosParam = msg.info.iosParam;
                });
                if($stateParams.aid && $stateParams.aid.iosCampaignl){
                    setTimeout(function(){
                        if ($scope.iosFirstActive){
                            $scope.IosActive = $scope.IosActiveInit = $stateParams.aid.iosCampaignl;
                            $scope.iosFirstActive = false;
                        }else{
                            $scope.IosActive = $scope.IosActiveInit = 0;
                        }
                        if($scope.channelType1 == "ry_coop"){
                            $scope.isedit1 = true;
                        }else{
                            $scope.isedit1 = false;
                        }         
                    },300);
                    
                }
                 
            });
        }

        $scope.$on("curchannel",function(e,msg){
            $scope.channelType = msg.info.type;
            $scope.IosChannelInitStr = msg.info.name;
            $scope.IosChannel = msg.info.id;
            if(!$scope.firstSem || $scope.firstSem==ios){
                $scope.isSem = msg.info.type == type
                $scope.firstSem = $scope.isSem ? ios :'';
            }
            if($scope.channelType == "ry_coop"){
                $scope.isedit2 = true;
            }else{
                $scope.isedit2 = false;
            }
            $scope.AndroidChannelListFilter();
            $scope.iosActive($scope.IosApp,$scope.IosChannel);
            if(!$scope.isInit2){
                if($scope.IosActiveInit == 0){
                    $scope.iosActivefresh = ++rmd;
                }else{
                    $scope.IosActiveInit = 0
                }
            }
            else{
               $scope.isInit2 = false; 
               $scope.IosActiveInit = 0
               $scope.iosActivefresh = ++rmd;
            }
        });

        $scope.sendMsgIdAndroid = "sendMsgIdAndroid";
        $scope.$on($scope.sendMsgIdAndroid,function(e,msg){
            $scope.androidChannelType =  msg.info.type;
            $scope.andChannelType =  msg.info.type;
            $scope.AndroidChannelInitStr = msg.info.name;
            $scope.category = msg.info.category;
            $scope.AndroidChannel = msg.info.id;
            if(!$scope.firstSem || $scope.firstSem==and){
                $scope.isSem = msg.info.type == type
                $scope.firstSem =$scope.isSem? and:'';
            }
            if($scope.androidChannelType == "ry_coop"){
                $scope.isedit1 = true;
            }else{
                $scope.isedit1 = false;
            }
            
            $scope.IosChannelListFilter();
            $scope.androidActive($scope.AndroidApp,$scope.AndroidChannel);
            if(!$scope.isInit4){
                if($scope.AndroidActiveInit == 0){
                    $scope.AndroidActivefresh = ++rmd;
                }else{
                    $scope.AndroidActiveInit = 0
                }
            }
            else{
               $scope.isInit4 = false; 

            }
        });

        
        //IOS ChannelList
        $scope.iosChannel = function(id){
            var IOSChannelPM = HttpService.getInfo("mng/onelink/"+id+"/find/channels");
            IOSChannelPM.then(function(data){
                $scope.IosChannelListAll =  data;
                $scope.IosChannelListFilter(data);
                if($stateParams.aid){
                    //回显IosChannel
                    var iosChannelLen = data.length;
                    for(var i=0;i< iosChannelLen; i++){
                        var item = data[i]
                        if(item.id == $stateParams.aid.iosChannel ){
                            $scope.IosChannelInitStr = item.name;
                            break;
                        }
                    }
                }
            });  
        }

        //请求IOS产品列表
        $scope.getIOS = function(){
            var IOSPM = HttpService.getInfo("mng/onelink/"+$scope.appid+"/find/apps?platform=iOS");
            IOSPM.then(function(data){
                $scope.IosAppList = data;
                $scope.$on("IosApp",function(e,msg){
                    $scope.IosApp = msg.info.id;
                    $scope.iosChannel($scope.IosApp);
                    if(!$scope.isInit1){
                        if($scope.IosChannelInit == 0){
                            $scope.iosChannelfresh = ++rmd;
                        }else{
                            $scope.IosChannelInit = 0
                        }
                        if($scope.IosActiveInit == 0){
                            $scope.iosActivefresh = ++rmd;
                        }else{
                            $scope.IosActiveInit = 0
                        }
                    }
                    else{
                       $scope.isInit1 = false; 
                    }
                });
            });  
        }
        $scope.androidFirstActive = true;
        //Android activity
        $scope.androidActive = function(id,channel){
            var androidActivePM = HttpService.getInfo("mng/onelink/"+id+"/find/campaigns/"+channel);
            androidActivePM.then(function(data){
                $scope.AndroidActiveList = data;
                $scope.$on("AndroidActive",function(e,msg){
                    $scope.androidChannelType1 = msg.info.type;
                    $scope.IosinfoType = msg.info.type;
                    $scope.AndroidActive = msg.info.id;
                    $scope.andChannelType = msg.info.type;
                        $scope.AndroidActiveSurl = msg.info.surl;
                        $scope.AndroidActiveTrackurl = msg.info.trackurl;
                        $scope.AndroidActiveurl = msg.info.url;
                        $scope.AndroidActiveIosParam = msg.info.androidParam;
                });
                if($stateParams.aid && $stateParams.aid.androidCampaignl){
                    if($scope.androidFirstActive){
                        $scope.AndroidActive = $scope.AndroidActiveInit = $stateParams.aid.androidCampaignl;
                        $scope.androidFirstActive = false;
                    }else{
                        $scope.AndroidActive = $scope.AndroidActiveInit =  0;
                    }
                    setTimeout(function(){
                        if($scope.androidChannelType1 == "ry_coop"){
                            $scope.isedit2 = true;
                         }else{
                             $scope.isedit2 = false;
                         }
                    },300)
                }
            });
        }
        $scope.getPackagesubcampaign = function(campChannelid){
            var campPM = HttpService.getInfo("mng/campaign/packagesubcampaign/"+campChannelid+"/list");
            campPM.then(function(data){
                data.unshift({'id': 0,'name':'请选择子活动'})
                $scope.subcampaignList=data;
                if(!$scope.packagesubcampaignTxt){
                    $scope.AndroidSubcampaignActive = $scope.AndroidSubcampaignInit=0;
                }
                $scope.packagesubcampaignTxt = false;
            })
        }
        //Android ChannelList
        $scope.androidChannel = function(id){
            var androidChannel = HttpService.getInfo("mng/onelink/"+id+"/find/channels");
            androidChannel.then(function(data){
                // $scope.AndroidChannelList = data;
                $scope.AndroidChannelListAll =  data;
                $scope.AndroidChannelListFilter(data);
                if($stateParams.aid){
                    //回显AndroidChannel
                    var androidChannelLen = data.length;
                    for(var i=0;i< androidChannelLen; i++){
                        var item = data[i]
                        if(item.id == $stateParams.aid.androidChannel ){
                           $scope.category = item.category;
                            $scope.andChannelType == item.type;
                            $scope.AndroidChannelInitStr = item.name;
                            break;
                        }
                    }
                }
            });  
        }

        //请求Android产品列表
        $scope.getAndroid = function(){
            var AndroidPM = HttpService.getInfo("mng/onelink/"+$scope.appid+"/find/apps?platform=android");
            AndroidPM.then(function(data){
                $scope.AndroidAppList =  data;
                $scope.$on("AndroidApp",function(e,msg){
                    $scope.AndroidApp = msg.info.id;
                    $scope.androidChannel($scope.AndroidApp);
                    if(!$scope.isInit3){
                        if(!$stateParams.aid){
                            if($scope.AndroidChannelInit == 0){
                                $scope.AndroidChannelfresh = ++rmd;
                            }else{
                                $scope.AndroidChannelInit = 0
                            }
                            if($scope.AndroidActiveInit == 0){
                                $scope.AndroidActivefresh = ++rmd;
                            }else{
                                $scope.AndroidActiveInit = 0
                            }
                        }
                    }
                    else{
                       $scope.isInit3 = false; 
                    }
                });
                $scope.AndroidAppfresh = ++rmd;
            });
        }

        //判断新建或修改
        if($stateParams.aid != null){
            $("#oneLinkName").focus();
            $scope.packagesubcampaignTxt = true;
            $scope.fixId = $stateParams.aid.id;
            $scope.name = $stateParams.aid.name;
            $scope.defaultUrl = $stateParams.aid.defaultUrl;
            // $scope.uploadname = $stateParams.aid.qcodeName;
            console.log($stateParams.aid.iosApp)
            $scope.IosApp = $scope.IosAppInit = $stateParams.aid.iosApp;
            
            $scope.IosChannel = $scope.IosChannelInit = $stateParams.aid.iosChannel;
            
            $scope.iosActive($scope.IosApp,$scope.IosChannel);
            $scope.IosActive = $scope.IosActiveInit = $stateParams.aid.iosCampaignl;
       
            //$scope.androidId = $stateParams.aid.androidId;
            $scope.AndroidApp = $scope.AndroidAppInit = $stateParams.aid.androidApp;
            $scope.AndroidChannel = $scope.AndroidChannelInit = $stateParams.aid.androidChannel;
            $scope.androidActive($scope.AndroidApp,$scope.AndroidChannel);
            $scope.AndroidActive = $scope.AndroidActiveInit = $stateParams.aid.androidCampaignl;
            if($stateParams.aid.pakageCampaignl){
                $scope.getPackagesubcampaign($stateParams.aid.androidCampaignl);
                $scope.AndroidSubcampaignActive = $scope.AndroidSubcampaignInit= $stateParams.aid.pakageCampaignl;
            }
           
            if($stateParams.aid.qcodeEnable){
                $scope.codeFlag = true;
            }else{
                $scope.codeFlag = false;
            }
            $scope.isInit1 = true;  
            $scope.isInit2 = true;

            $scope.isInit3 = true;  
            $scope.isInit4 = true;
            
        }else{
            $scope.IosApp = $scope.IosAppInit = 0;
            $scope.IosChannel = $scope.IosChannelInit = 0;
            $scope.IosActive = $scope.IosActiveInit = 0;
            $scope.AndroidApp = $scope.AndroidAppInit = 0;
            $scope.AndroidChannel = $scope.AndroidChannelInit = 0;
            $scope.AndroidActive = $scope.AndroidActiveInit = 0;
            $scope.AndroidSubcampaignInit = 0;
        }

        //判断主产品
        if($scope.platform == 'iOS'){
            $scope.ifIos = true;
            $scope.IosApp = $scope.MainAppId;
            $scope.getAndroid();
            $scope.iosChannel($scope.IosApp);
        }else{
            $scope.ifIos = false;
            $scope.AndroidApp = $scope.MainAppId;
            $scope.getIOS();
            $scope.androidChannel($scope.AndroidApp);
        }


        $scope.nameValid = function(){
            if($scope.name == "" || $scope.name == null){
                return false;
            }
            if($scope.fixId == undefined){
                var nameValidPM = HttpService.getInfo("mng/onelink/"+$scope.appid+"/valid/name?name="+$scope.name);
            }else{
                var nameValidPM = HttpService.getInfo("mng/onelink/"+$scope.appid+"/valid/name?name="+$scope.name+"&id="+$scope.fixId);
            }
            nameValidPM.then(function(data){
                if(data.content == false){
                    $scope.sameName = true;
                }else{
                    $scope.sameName = false;
                }
            });
        }

        if($scope.demoU){
            $scope.defaultUrl = "http://www.reyun.com";
        }

        //图片未上传状态
        $scope.uploadType = 'noupload';
        $scope.$on("myFile",function(e,file){
            var name = file.name;
            var subIdx = name.lastIndexOf(".")+1,subTxt = name.substring(subIdx);
            var num = 1024;
            //允许jpg、gif、png、bmp
            if(subTxt == 'jpg' || subTxt == 'gif' || subTxt == 'png' || subTxt == 'bmp'){
                var size = file.size;
                var imgSize = (size / num).toFixed(2) //转kb
                if(imgSize > 200 ){
                    ToolService.showTips($filter('translate')("图片大小超出200K范围"));
                    return false;
                }
                else{
                    $scope.uploadname = name;
                    $scope.uploadType = 'inupload';
                    $scope.uploadData = file;
                    $scope.uploadImg();
                }
            }
            else{
                ToolService.showTips($filter('translate')("仅支持jpg、gif、png、bmp格式"));
                return false;
            }
        });
        $scope.uploadImg = function(){
            var fd = new FormData();
            fd.append('file', $scope.uploadData); 
            ToolService.showLoading();
            $http({
                    method:'POST',
                    url:"/api/mng/onelink/"+$scope.appid+"/logoQcode/"+$scope.AndroidActiveSurl+$scope.IosActiveSurl,
                    data: fd,
                    headers: {'Content-Type':undefined},
                    transformRequest: angular.identity 
                }).success(function(data)
                {
                    ToolService.hideLoading();
                    $scope.urlPath = data.content.url_path;
                    ToolService.hideLoading();
                    $scope.uploadType = 'upload';
                })
                .error(function(data){
                    ToolService.hideLoading();
                    $scope.uploadType = 'noupload';
                    ToolService.hideLoading();    
                    ToolService.showTips($filter('translate')("网络超时，请重新上传"));
                }); 

        }

        $scope.save = function(){
            $scope.nameValid();
            var par = {
                name:$scope.name,
                //iosId:$scope.IosApp+"-"+$scope.IosChannel+"-"+$scope.IosActive,
                iosApp:$scope.IosApp,
                iosChannel:$scope.IosChannel,
                iosCampaignl:$scope.IosActive,
                iosSurl:$scope.IosActiveSurl,
                //androidId:$scope.AndroidApp+"-"+$scope.AndroidChannel+"-"+$scope.AndroidActive,
                androidApp:$scope.AndroidApp,
                androidChannel:$scope.AndroidChannel,
                androidCampaignl:$scope.AndroidActive, //请选择推广活动
                androidSurl:$scope.AndroidActiveSurl,
                defaultUrl:$scope.defaultUrl,
                mainApp:$scope.MainAppId,
                androidParam:$scope.AndroidActiveIosParam,
                iosParam:$scope.IosActiveIosParam,
            }
            par.mainParam = $scope.ifIos ? $scope.IosActiveIosParam:$scope.AndroidActiveIosParam;
            var verPar = {
                name: {
                    key: 'onelink',
                    val: par.name,
                    max: 40,
                    txt:$filter('translate')("仅支持20汉字内的中文，英文，数字，下划线，中划线")
                },
                defaultUrl: {
                    key: 'url',
                    val: $scope.defaultUrl,
                    txt: $filter('translate')("仅支持http://或https://开头")
                }
            }
            var reg = /^[a-zA-Z0-9_\_\-\u4E00-\u9FA5]+$/;
            $scope.tip = formJudge(verPar);
            if($scope.name == "" || $scope.name == undefined){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.name = {
                    status:true,
                    txt:$filter('translate')("必填")
                }
            }
            if($scope.name != undefined && $scope.name != '' && !reg.test($scope.name)){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.name = {
                    status:true,
                    txt:$filter('translate')("仅支持20汉字内的中文，英文，数字，下划线，中划线")
                }
            }

            if($scope.sameName == true){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
            }
            
            if($scope.IosActive == 0){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.ios = {
                    status:true,
                    txt:$filter('translate')("请选择iOS活动")
                }
            }
            if($scope.IosChannel == 0){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.ios = {
                    status:true,
                    txt:$filter('translate')("请选择iOS渠道")
                }
            }
            if($scope.IosApp == 0){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.ios = {
                    status:true,
                    txt:$filter('translate')("请选择iOS产品")
                }
            }

            if($scope.AndroidActive == 0){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.android = {
                    status:true,
                    txt:$filter('translate')("请选择Android活动")
                }
            }
            
            if($scope.AndroidChannel == 0){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.android = {
                    status:true,
                    txt:$filter('translate')("请选择Android渠道")
                }
            }
            if($scope.AndroidApp == 0){
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.android = {
                    status:true,
                    txt:$filter('translate')("请选择Android产品")
                }
            }
            if($scope.category == 'APPMARKET' && $scope.andChannelType == null){
                par.pakageCampaignl = $scope.AndroidSubcampaignActive;
                if($scope.AndroidSubcampaignActive == 0 ){
                    if ($scope.tip.succ == true) {
                        $scope.tip.succ = false;
                    }
                    $scope.tip.android = {
                        status:true,
                        txt:$filter('translate')("请选择子活动")
                    }
                }
            }
            if ($scope.tip.succ != true) { 
                return false;
            }
            if($scope.codeFlag){// 是否开启生成二维码  1 是 0 否
                par.qcodeEnable = 1;
                // if($scope.uploadType != 'upload'){
                //     ToolService.showTips($filter('translate')("请选择图片"));
                //     return false;
                // }
                par.logoFile = $scope.urlPath;
            }else{
                par.qcodeEnable = 0;
            }
           
            if($stateParams.aid != null){
                par.id = $scope.fixId;
                if($scope.IosinfoType == "ry_coop" ){
                    par.mainParam = $scope.mainIosParam;
                }
                var savePM = HttpService.putInfo("mng/onelink/"+$scope.appid+"/update",par);
                ToolService.showLoading();
                savePM.then(function(data){
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("修改成功"));
                    $state.go("collect.onelink");
                });
            }else{
                if($scope.IosinfoType == "ry_coop" ){
                    par.mainParam = $scope.mainIosParam;
                }
                
                var savePM = HttpService.postInfo("mng/onelink/"+$scope.appid+"/create",par);
                ToolService.showLoading();
                savePM.then(function(data){
                    ToolService.hideLoading();
                    if(data.code == -200){
                        ToolService.showTips($filter('translate')("添加失败"));
                    }else{
                        ToolService.showTips($filter('translate')("添加成功"));
                        $state.go("collect.onelink");
                    }
                });
            }
            
        }

        $scope.AndroidChannelListFilter = function(data){
            data = data ||$scope.AndroidChannelListAll;
            if($scope.isSem && $scope.firstSem == ios){
                $scope.AndroidChannelInitStr = "请选择渠道";
                $scope.AndroidChannel = 0;
                $scope.AndroidChannelList =  (data ? data.filter(function(item){
                    return item.type ==type ||item.id==0;
                }):[]);
            }else{
                if($scope.channelType == "ry_coop"){  //常规渠道
                    $scope.AndroidChannelList =  (data ? data.filter(function(item){
                        return item.id == $scope.IosChannel;
                    }):[]);
                    if (data){
                        $scope.AndroidChannelInitStr = ""
                        var dataLen = data ? data.length : 0;
                        for (var i=0; i< dataLen; i++){
                            var item = data[i];
                            if(item.id == $scope.IosChannel){
                                $scope.AndroidChannelInitStr = item.name;
                                $scope.AndroidChannel = $scope.IosChannel
                                $scope.category =  item.category
                                $scope.andChannelType = item.type
                                $scope.androidActive($scope.AndroidApp,$scope.AndroidChannel);
                                break;
                            }
                        }
                        if($scope.AndroidChannelInitStr == ""){
                            $scope.AndroidChannelInitStr = "请选择渠道"
                            $scope.AndroidChannel = 0;
                        }
                    }
                }else if($scope.channelType == "ry_bd"){ //SEM渠道
                 
                }else{
                    $scope.AndroidChannelList =  data;

                }
               
            }
        }
        

        $scope.IosChannelListFilter = function(data){
            data = data ||$scope.IosChannelListAll;
            if($scope.isSem && $scope.firstSem == and){
                $scope.IosChannelInitStr = "请选择渠道"
                $scope.IosChannel = 0;
                $scope.IosChannelList =  (data ? data.filter(function(item){
                    return item.type ==type ||item.id==0;
                }):[]);
            }else{
                if($scope.androidChannelType == "ry_coop"){  //常规渠道
                    $scope.IosChannelList =  (data ? data.filter(function(item){
                        return item.id == $scope.AndroidChannel;
                    }):[]);
                    if (data){
                        $scope.IosChannelInitStr = ""
                        var dataLen = data ? data.length : 0;
                        for (var i=0; i< dataLen; i++){
                            var item = data[i];
                            if(item.id == $scope.AndroidChannel){
                                $scope.IosChannelInitStr = item.name;
                                $scope.IosChannel = $scope.AndroidChannel;

                                $scope.iosActive($scope.IosApp,$scope.IosChannel);
                                break;
                            }
                        }
                        if($scope.IosChannelInitStr == ""){
                            $scope.IosChannelInitStr = "请选择渠道"
                            $scope.IosChannel = 0;
                        }
                    }
                }else if($scope.andChannelType == "ry_bd"){ //SEM渠道
                   
                }else{
                    $scope.IosChannelList =  data;
                }

                
            }
        }
    }

})();
        