(function(){
    angular.module("app.manage")
        .controller("subchannelCtrl",["$rootScope","$scope","HttpService","ToolService","UtilService","$http","$timeout","$filter",subchannelCtrl]);

    function subchannelCtrl($rootScope,$scope,HttpService,ToolService,UtilService,$http,$timeout,$filter){
        $scope.tableflag = 1;
        $scope.$watch("appid+lang",function(n){
            if(angular.isDefined($scope.appid)){
                var channelPM = HttpService.getInfo("subchannel/findchannel/"+$scope.appid);
                channelPM.then(function(data){
                    data.unshift({id:-1,name:$filter('translate')("全部渠道")});
                    $scope.statusList = data;
                    $scope.statusNameInit = $filter('translate')("全部渠道");
                    $scope.statusidInit = $scope.statusid = -1;
                });    
            }
        });
        $scope.$on("statusid",function(e,msg){
            $scope.statusid = msg.info.id;
        });

        $scope.$watch("statusid",function(n){
            if(angular.isDefined(n)){
                $scope.query();
            }
        });

        $scope.query = function(){
            if($scope.appid == undefined){
                return false;
            }
            $scope.curEditId = -1;
            var subPM = HttpService.getInfo("subchannel/findSubchannelList/"+$scope.appid+"/"+$scope.statusid);
            ToolService.showLoading();
            subPM.then(function(data){
                ToolService.hideLoading();
                $scope.campaignList = data;
            });
        }



        $scope.editName = function(info){
            $scope.curEditId = info.id;
            info.rename = info.subChannelName;
        }
        $scope.saveName = function(info){
            if(info.subChannelName == info.rename){
                $scope.curEditId = -1;
                return false;
            }
            if(info.rename==''){
                ToolService.showTips($filter('translate')("不能为空"));
                return false;
            }
            var verPar = {
                rename: {
                    key: 'spcname1',
                    val: info.rename,
                    txt: $filter('translate')("支持输入汉字、大小写字母、数字、下划线、中划线、间隔号点（·），长度限制40字符以内")
                }
            };
            $scope.tip = formJudge(verPar);
            if($scope.tip.succ == true){
                //info.subChannelName = info.rename;
                var par = {
                    name:info.rename,
                    cid:info.cid
                }
                ToolService.showLoading();
                var namePM = HttpService.putInfo("subchannel/update/"+info.id+"?name="+info.rename+"&cid="+info.cid+"&appId="+$scope.appid);
                namePM.then(function(data){
                    ToolService.hideLoading();
                    if(data==true){
                        ToolService.showTips($filter('translate')("修改成功"));
                        info.subChannelName = info.rename;
                        $scope.curEditId = -1;
                    }
                    else{
                        ToolService.showTips($filter('translate')("名称重复"));
                    }
                });
            }
            else{
                ToolService.showTips($scope.tip.rename.txt);
            }
        }
        var curfilpPage = null,rmd = new Date().getTime();
        $scope.$on('flipinfo',function(e,msg){
            $scope.flipPage = msg;

            $scope.flipChange = ++ rmd;
        });

        $scope.doRemove = function(id){
            $scope.delstatus = true;
            $scope.delId = id;
        }

        $scope.removeInfo = function(){
            var removePM = HttpService.postInfo("subchannel/delete/"+$scope.delId);
            ToolService.showLoading();
            removePM.then(function(data){
                ToolService.hideLoading();
                $scope.delstatus = false;
                ToolService.showTips($filter('translate')("删除成功"));
                $scope.query();
            });
        }

        $scope.query2 = function(){
            $scope.tableflag = 2;
            var channelPM = HttpService.getInfo("subchannel/findchannel/"+$scope.appid);
            channelPM.then(function(data){
                data.unshift({id:-1,name:$filter('translate')("请选要批量修改的渠道")});
                $scope.uploadList = data;
                $scope.uploadNameInit = $filter('translate')("请选要批量修改的渠道");
                $scope.uploadidInit = $scope.uploadid = -1;
                $scope.uploadResh = ++rmd;
            });         
        }

        $scope.$on("uploadid",function(e,msg){
            $scope.uploadid = msg.info.id;
        });

        $scope.$watch("uploadid",function(n){
            $scope.uploadname = "";
            $scope.uploadType = 'noupload';
        });

        $scope.cancel = function(){
            $scope.uploadname = "";
            $scope.uploadType = 'noupload';
            $scope.tableflag = 1;
        }

        //文件未上传状态
        $scope.uploadType = 'noupload';
        $scope.$on("myFile",function(e,file){
            if($scope.uploadid == -1){
                ToolService.showTips($filter('translate')("请先选择渠道"));
                return false;
            }
            var name = file.name;
            var subIdx = name.lastIndexOf(".")+1,subTxt = name.substring(subIdx);
            if(subTxt == 'xls' || subTxt == 'xlsx'){
                var size = file.size;
                if(size > 1 * 1024 * 1024){
                    ToolService.showTips($filter('translate')("文件不能大于1M"));
                    return false;
                }
                else{
                    $scope.uploadname = name;
                    $scope.uploadType = 'inupload';
                    //$scope.uploadFile(file);
                    $scope.uploadData = file;
                }
            }
            else{
                ToolService.showTips($filter('translate')("仅支持excel"));
                return false;
            }
        });

        $scope.uploadFile = function(){
            if($rootScope.demoU){return false;}
            if($scope.uploadid == -1){
                ToolService.showTips($filter('translate')("请先选择渠道"));
                return false;
            }
            if($scope.uploadType != 'inupload'){
                ToolService.showTips($filter('translate')("请先上传文件"));
                return false;
            }
            var fd = new FormData();
            fd.append('file', $scope.uploadData); 
            ToolService.showLoading();
            $http({
                method:'POST',
                url:"/api/subchannel/upload/"+$scope.uploadid+"/"+$scope.appid,
                data: fd,
                headers: {'Content-Type':undefined},
                transformRequest: angular.identity 
            })   
            .success(function(data)
            {
                data = data.content;
                ToolService.hideLoading();
                $scope.uploadType = 'upload';
                ToolService.showTips($filter('translate')("上传成功"));
                $scope.cancel();
                $scope.query();
            })
            .error(function(data){
                $scope.uploadType = 'noupload';
                ToolService.hideLoading();    
                ToolService.showTips($filter('translate')("网络超时，请重新上传"));
            }); 
        }
        //demo账号时，鼠标样式
        $rootScope.demoU && ($scope.newSty = {cursor:'default'});
    }
 
})();
        