(function() {
    angular.module("app.manage")
        .controller("subpackageCtrl", ["$rootScope", "$scope", "HttpService", "ToolService", "UtilService", "$state", "$timeout", "$stateParams", "$filter", subpackageCtrl])
        .controller("subpackageDetailCtrl", ["$scope", "$rootScope", "HttpService", "ToolService", "UtilService", "$q", "$state", "$stateParams", "$timeout", "$filter", subpackageDetailCtrl]);

    function subpackageCtrl($rootScope, $scope, HttpService, ToolService, UtilService, $state, $timeout, $stateParams, $filter) {
        var rmd = new Date().getTime();
        $scope.deviceList = [
            { id: 1, name: $filter('translate')("已启用") },
            { id: 2, name: $filter('translate')("已停用") }
        ];
        $scope.deviceInit = $scope.deviceList[0].id;
        $scope.$on("deviceId", function(e, msg) {
            $scope.seeFlag = msg.info.id;
            if ($scope.seeFlag == 1) {
                $scope.findName = 'find';
            } else {
                $scope.findName = 'findDisable';
            }
            $scope.query();
        });

        var type = $stateParams.aid;
        if (!UtilService.isNullStr(type)) {
            $scope.channType = type;
        } else {
            $scope.channType = 'ry_coop';
        }

        $scope.filterTypeList = function(type) {
            $scope.channType = type;
            $scope.deviceInit = $scope.deviceList[0].id;
            $scope.deviceId = 1;
            $scope.typefresh = ++rmd;
        };
        $scope.query = function(flag) {
            if (!$scope.isandroid) {
                $state.go("collect.campaign");
                return false;
            }
            if ($scope.findName == undefined || $scope.appid == undefined) {
                return false;
            }

            $scope.curEditId = -1;
            var campaignPM = HttpService.getInfo("mng/campaign/" + $scope.appid + "/" + $scope.findName + "/package?type=" + $scope.channType);
            ToolService.showLoading();
            campaignPM.then(function(data) {
                ToolService.hideLoading();
                //$scope.campaignAllList = data;
                $scope.baseList = $scope.campaignList = data;
                $scope.selectIDS = [];
                $scope.searchTxt = "";
            });
        }
        $scope.editName = function(info) {
            $scope.curEditId = info.id;
            info.rename = info.name;
        }
        $scope.saveName = function(info) {
            if (info.name == info.rename) {
                $scope.curEditId = -1;
                return false;
            }
            if (info.rename == '') {
                ToolService.showTips($filter('translate')("不能为空"));
                return false;
            }
            var verPar = {
                rename: {
                    key: 'spcname',
                    val: info.rename,
                    txt: $filter('translate')("含非法字符或过长（支持输入汉字、大小写字母、数字、下划线、中划线，长度限制40字符以内）")
                }
            };

            $scope.tip = formJudge(verPar);
            if ($scope.tip.succ == true) {
                ToolService.showLoading();
                var namePM = HttpService.putInfo("mng/campaign/" + $scope.appid + "/update/" + info.id + "?name=" + info.rename);
                namePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data) {
                        ToolService.showTips($filter('translate')("修改成功"));
                        info.name = info.rename;
                        $scope.curEditId = -1;
                    } else {
                        ToolService.showTips($filter('translate')("名称重复"));
                    }
                });
            } else {
                ToolService.showTips($scope.tip.rename.txt);
            }

        }
        $scope.$watch("appid", function(n) {
            if (angular.isDefined($scope.appid)) {
                $scope.flipPage = null;
                if ($scope.isweb) {
                    $scope.channType = 'custom';
                }
                $scope.query();
            }

            //查询渠道
            var channelPM = HttpService.getInfo("mng/channel/find/" + $scope.appid + "/byaccount/show");
            channelPM.then(function(data) {
                $scope.channelList = data;
                var channelAllObj = {};
                data.forEach(function(item) {
                    channelAllObj[item.id] = { id: item.id, name: item.name };
                });
                $scope.channelAllObj = channelAllObj;
            });

        });


        /**
         * 监听列表查询结果baseList和所有渠道对象channelAllObj，过滤出含有活动的渠道列表。
         */
        $scope.$watch("{channelAllObj:channelAllObj,baseList:baseList}", function() {
            $scope.channelFilterList = [{ id: 1, name: $filter('translate')('不筛选渠道') }];
            $scope.channelFilterInit = $scope.channelFilterList[0].id;
            if ($scope.channelAllObj && $scope.baseList && $scope.baseList.length > 0) {
                $scope.baseList.forEach(function(item) {
                    if (item.channel) {
                        var channelItem = $scope.channelAllObj[item.channel];
                        if (channelItem && $scope.channelFilterList.indexOf(channelItem) == -1) {
                            $scope.channelFilterList.push(channelItem);
                        }
                    }
                });
            }
        }, true);

        $scope.$on("channelFilterId", function(e, msg) {
            $scope.channelId = msg.info.id;
            if ($scope.channelId != 1) {
                $scope.campaignList = $scope.baseList.filter(function(item) {
                    return item.channel == $scope.channelId;
                });
            } else {
                $scope.campaignList = $scope.baseList;
            }
        });


        var curfilpPage = null,
            rmd = new Date().getTime();
        $scope.$on('flipinfo', function(e, msg) {
            $scope.flipPage = msg;

            $scope.flipChange = ++rmd;
        });
        $scope.$watch("flipChange+campaignList", function() {
            if ($scope.flipPage && $scope.campaignList) {
                curfilpPage = { start: $scope.flipPage.start + 1, end: $scope.flipPage.end };
                if (curfilpPage.end > $scope.campaignList.length) {
                    curfilpPage.end = $scope.campaignList.length;
                }
            }
        });

        $scope.doRemove = function(info) {
            if ($scope.seeFlag == 1) {
                if (info.subCampaignNumber > 0) {
                    $scope.delTips = $filter('translate')("该推广活动下包含") + info.subCampaignNumber + $filter('translate')("个子活动，停用后该推广活动下的所有子活动将不在接收所有点击（展示）数据。是否确认停用？");
                } else {
                    $scope.delTips = $filter('translate')("您正在停用“") + info.name + $filter('translate')("”停用后将不能查看该活动以后的推广相关数据，且将为您关闭子账号对该推广活的权限。是否确认停用？");
                }

                $scope.delstatus = true;
                $scope.delId = info.id;
                $scope.delObj = info;
            } else {
                if (info.subCampaignNumber > 0) {
                    $scope.delTips = $filter('translate')("该推广活动下包含") + info.subCampaignNumber + $filter('translate')("个子活动，启用后该推广活动下的所有子活动将继续接收新点击（展示）数据。是否确认启用？");
                } else {
                    $scope.delTips = $filter('translate')("是否启用 “") + info.name + $filter('translate')("” 活动?");
                }
                $scope.delstatus = true;
                $scope.delId = info.id;
                $scope.delObj = info;
            }

        }

        $scope.removeInfo = function() {
            if ($scope.seeFlag == 1) {
                var removePM = HttpService.deleteInfo("mng/campaign/" + $scope.appid + "/delete/" + $scope.delId);
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.delstatus = false;
                    if (data.code == -1009) {
                        ToolService.showTips($filter('translate')("该推广活动短链地址正在被onelink使用，当前不可被停用，请先修改或删除对应该推广活动的onelink短链"));
                    } else {
                        ToolService.showTips($filter('translate')("停用成功"))
                        $scope.query(1);
                    }
                });
            } else {
                var removePM = HttpService.putInfo("mng/campaign/" + $scope.appid + "/enable/" + $scope.delId);
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    $scope.delstatus = false;
                    ToolService.showTips($filter('translate')("启用成功"))
                    $scope.query(1);
                });
            }

        }

        $scope.clickCkx = function(id) {
            var idx = $scope.selectIDS.indexOf(id);
            if (idx > -1) {
                $scope.selectIDS.splice(idx, 1);
            } else {
                $scope.selectIDS.push(id);
            }
        }
        $scope.setCurrentList = function() {
            var curList = $scope.campaignList;
            if (!UtilService.isNullStr($scope.searchTxt)) {
                var myFilterList = $scope.campaignList.filter(function(item) {
                    if ((item.name && angular.uppercase(String(item.name)).indexOf(angular.uppercase($scope.searchTxt)) > -1) || (item.trackurl && angular.uppercase(String(item.trackurl)).indexOf(angular.uppercase($scope.searchTxt)) > -1)) {
                        return true;
                    } else {
                        return false;
                    }
                });
                curList = myFilterList;
            }
            $scope.curShowList = curList;
        }
        $scope.curPageAll = function() {
            if (!$scope.flipPage || !$scope.campaignList) { return false; }

            $scope.setCurrentList();
            curfilpPage.end = $scope.curShowList.length > curfilpPage.end ? curfilpPage.end : $scope.curShowList.length;
            var len = curfilpPage.end - curfilpPage.start,
                count = 0;

            for (var i = curfilpPage.start; i < curfilpPage.end; i++) {
                var temp = $scope.curShowList[i];

                if ($scope.selectIDS.indexOf(temp.id) > -1) {
                    count++;
                }
            }
            $scope.onePageCount = count;
            return len == count && len > 0;
        }
        $scope.checkAllCurrent = function() {
            var bol = $scope.curPageAll();
            curfilpPage.end = $scope.curShowList.length > curfilpPage.end ? curfilpPage.end : $scope.curShowList.length;
            for (var i = curfilpPage.start; i < curfilpPage.end; i++) {
                var temp = $scope.curShowList[i],
                    idx = $scope.selectIDS.indexOf(temp.id);
                if (bol && idx > -1) {
                    $scope.selectIDS.splice(idx, 1);
                }
                if (!bol && idx == -1) {
                    $scope.selectIDS.push(temp.id);
                }
            }
        }

        $scope.checkAllPage = function() {
            $scope.selectIDS = [];
            var len = $scope.curShowList.length,
                count = 0;
            for (var i = 0; i < len; i++) {
                $scope.selectIDS.push($scope.curShowList[i].id);
            }
        }

        $scope.NocheckAllPage = function() {
            $scope.selectIDS = [];
        }

        $scope.$watch("searchTxt", function(n) {
            if (angular.isDefined(n)) {
                $scope.selectIDS = [];
            }
        });
        $scope.$watch("selectIDS", function(n) {
            if ($scope.selectIDS && $scope.selectIDS.length > 0) {
                $scope.iptHolder = $filter('translate')("搜索后，所选内容将清除");
            } else {
                $scope.iptHolder = $filter('translate')("输入名称或短链搜索");
            }
        });

        $scope.doBatchRemove = function() {
            $scope.delbatch = true;
        }

        $scope.removeBatch = function() {
            if ($scope.seeFlag == 1) {
                $scope.delbatch = false;
                var removePM = HttpService.deleteInfo("mng/campaign/" + $scope.appid + "/batchdelete?ids=" + $scope.selectIDS.join(","));
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    if (data.code == -1000) {
                        // ToolService.showTips($filter('translate')("停用推广活动下含有子活动，不可被停用，请先停用该推广活动的子活动"));
                    } else if (data.code == -1009) {
                        ToolService.showTips($filter('translate')("您选择的推广活动中包含正在被onelink使用的推广活动，不可批量停用，请重新选择或先删除对应推广活动的onelink短链"));
                    } else {
                        ToolService.showTips($filter('translate')("停用成功"));
                        $scope.query(1);
                    }
                });
            } else {
                $scope.delbatch = false;
                var removePM = HttpService.putInfo("mng/campaign/" + $scope.appid + "/batchenable?ids=" + $scope.selectIDS.join(","));
                ToolService.showLoading();
                removePM.then(function(data) {
                    ToolService.hideLoading();
                    ToolService.showTips($filter('translate')("启用成功"))
                    $scope.query(1);
                });
            }

        }
        $scope.exportBatch = function() {
            // window.location.href = "api/mng/campaign/" + $scope.appid + "/exportsurls?ids=" + $scope.selectIDS.join(",") + "&showurl=2";
            var pm = HttpService.downFilePost("mng/campaign/" + $scope.appid + "/exportsurls?showurl=1", { ids: $scope.selectIDS }, '活动短链列表.txt')
        }

        $scope.gopage = function(id) {
            if (angular.isDefined(id)) {
                $state.go("collect.campaignDetail", { aid: id });
            } else {
                $state.go("collect.campaignDetail");
            }
            $rootScope.campaignUrl = 'subpackage';
        }

        $scope.toSubcamp = function(info, flag) {
            $rootScope.campChannel = info;
            if (flag && flag == 1) {
                $state.go("collect.subpackageDetail");
            } else {
                $state.go("collect.subcampaignlist");
                $rootScope.campaignUrl = 'subpackage';
                $rootScope.campaignChannType = $scope.channType;

            }
        }
        $rootScope.feedback = ['gdt_apk', 'zht', 'weixinmp', 'xinlangfuyi', 'weixinmp_fenbao'];
    }

    function subpackageDetailCtrl($scope, $rootScope, HttpService, ToolService, UtilService, $q, $state, $stateParams, $timeout, $filter) {
        var info = $stateParams.aid;
        var oldname = "";
        $scope.isDeeplink = false;
       /*回显deeplink
        *@param id 参数说明：-1表示新建,否则是编辑
        */
       $scope.getDeeplinkList = function(id) {
        ToolService.showLoading();
        var campaignid;
        if (id == -1) { // -1表示 新建
            campaignid = -1;
        } else {
            campaignid = $scope.id; //编辑
        }
        var deepInfoPM = HttpService.getInfo("mng/campaign/packagesubcampaign/" + $scope.appid + "/" + campaignid + "/echoDeepLink");
        deepInfoPM.then(function(data) {
            var msg = data.message;
            var data = data.content;
            ToolService.hideLoading();
            if (data) {
                if (info) {
                    if (info && msg == "old") {
                        if (data.urlScheme) {
                            $scope.delFlag = true;
                        }
                        if (data.paths) {
                            $scope.delFlagdp = true;
                        }
                    }
                    if (info && msg == "new") {
                        $scope.delFlag = false;
                        $scope.delFlagdp = false;
                    }
                }

                $scope.deeplinkId = data.id;
                if ($scope.delFlag == true) {
                    $scope.url = data.appDownload;
                }

                $scope.urlScheme = oldScheme = data.urlScheme;
                $scope.mydomain = olddomain = data.linkId;
                $scope.deeplinkpath = data.paths;
                
            }

        })
        }
        //判断deeplink app参数是否填写
        $scope.shoTipDeeplink = false;
        $scope.echoDeepLink = function() {
            var echoPM = HttpService.getInfo("mng/deeplink/" + $scope.appid + "/echoDeepLink");
            echoPM.then(function(data) {
                if (data.hasOwnProperty("code") && data.code == 200) {
                    $scope.shoTipDeeplink = true;
                } else {
                    $scope.shoTipDeeplink = false;
                }
            })
        }

        $scope.init = function() {
            $scope.campChannel = $rootScope.campChannel;
            if (UtilService.isNullStr($scope.campChannel)) {
                $scope.goPage('collect.subpackage');
                return false;
            }
            $scope.app = $rootScope.campChannel.app;
            $scope.parent = $rootScope.campChannel.id;
            $scope.parentCampaignid = $rootScope.campChannel.campaignid;
            $scope.campaignId = $rootScope.campChannel.id;
            $scope.feedback = ['huaweiads_apk'];
            var channelPM = HttpService.getInfo($scope.appid + "/channel/findall");
            channelPM.then(function(data) {
                $scope.channelList = data;
                var curChannel = {};
                for (var i = 0; i < $scope.channelList.length; i++) {
                    if ($scope.channelList[i].id == $scope.campChannel.channel) {
                        curChannel = $scope.channelList[i];
                        $scope.campChannel.channelname = curChannel.name;
                        $scope.uniqueName = curChannel.uniqueName;
                        $scope.channType = curChannel.type;
                        // if($scope.uniqueName=='bdocpc_apk'){
                        $scope.initUrlType();
                        // };
                        $scope.nodeUrl = curChannel.nodeUrl;
                        if (!UtilService.isNullStr(curChannel.specialParams)) {
                            $scope.specialParams = JSON.parse(curChannel.specialParams);
                        } else {
                            $scope.specialParams = [];
                        }
                        if (info && !UtilService.isNullStr(info.specialKeys)) {
                            var params = info.specialKeys,
                                paramsjson = {};
                            params.split("&").filter(function(item) {
                                var kkks = item.split("=");
                                var v = item.substring(item.indexOf("=") + 1);
                                paramsjson[kkks[0]] = v;
                            });
                            $scope.specialParams && $scope.specialParams.filter(function(sp) {
                                sp.val = paramsjson[sp.key];
                            });
                        }
                        if ((!info && !UtilService.isNullStr(curChannel.frontGenSurl) && $scope.specialParams.length > 0) || curChannel.uniqueName== 'huaweiads_apk') {
                            var makeSurlPM = HttpService.getInfo("mng/campaign/" + $scope.appid + "/makesurl");
                            makeSurlPM.then(function(data) {
                                var url = curChannel.ishttps ? data[0].url.replace('http://', 'https://') : data[0].url;
                                $scope.feedbackUrl = url + '?' + curChannel.androidparam;
                            });
                        }

                        break;
                    }
                }
                $scope.channelname = $scope.campChannel.channelname;
                //广点通默认新版本
                $scope.uniqueName == 'gdt_apk' && ($scope.isNew = true);

                // deeplink 判断显示
                if (curChannel.type == 'ry_coop' && (($rootScope.isandroid && curChannel.category == 'APPMARKET') )) {
                    $scope.isDeeplink = true
                } else {
                    $scope.isDeeplink = false
                    $scope.delFlag = false
                }
            });


            $scope.pack_channelid = $scope.campChannel.pack_channelid;
            $scope.channel = $scope.campChannel.channel;
            $scope.firstname = $scope.campChannel.name;
            $scope.echoDeepLink();
            if (info) {
                $scope.id = info.id;
                $scope.name = oldname = info.name;
                $scope.url = info.url;
                if (info.advertiserid && info.advertiserid != '') {
                    $scope.advertiserid = info.advertiserid;
                    $scope.gdtbundleid = info.bundleid;
                }
                $scope.feedbackUrl = info.trackUrl;
                $scope.getDeeplinkList();
            } else {
                

                $scope.getDeeplinkList(-1);
                $scope.url = $scope.campChannel.url;
            }


        }
        $scope.init();
         
        //更改样式
        $scope.changeMB = function() {
            if ($scope.uniqueName == 'bdocpc_apk' && $scope.urlType == 'batch') {
                $scope.newMarginBottom = { 'margin-bottom': '10px' };
            } else {
                $scope.newMarginBottom = {};
            }
        }

        //显示隐藏渠道开关
        $scope.hintRefresh = false;
        $scope.delFlag = false;
        $scope.awakeRefresh = false
        $scope.doSwitch = function() { // true 表示开启的状态
            $scope.delFlag = !$scope.delFlag;
            if (!$scope.delFlag) {
                $scope.delFlagdp = false;
            } else {
                if ($rootScope.arouseStatus == -1 || $rootScope.arouseStatus == 3) { //-1：未申请；1：审核中；2：已开通；3：已过期；
                    ToolService.showAlp();
                    $scope.awakeRefresh = true;
                }
            }

        }
        $scope.closeAdd = function() {
            ToolService.hideAlp();
            $scope.hintRefresh = false;
        }

        $scope.closeAwake = function() {
            ToolService.hideAlp();
            $scope.awakeRefresh = false;
        }
        $scope.goConfig = function() {
                if ($rootScope.isSuper) {
                    $state.go("collect.deeplink");
                } else {
                    ToolService.showTips($filter('translate')("您的账号无此权限，请使用主账号绑定"));
                }

        }
        $scope.doSwitchUniversal = function() {
            if (!$scope.delFlag) {
                $scope.delFlagdp = false;
                return
            }
            if ($scope.shoTipDeeplink) {
                ToolService.showAlp();
                $scope.hintRefresh = true;
            } else {
                $scope.delFlagdp = !$scope.delFlagdp;
            }

        }

        $scope.packageType = true;
        $scope.exixtName = function() {
                if ($scope.judgeNameChange(oldname, $scope.name)) {
                    ToolService.showLoading();
                    var namePM = HttpService.getInfo("mng/campaign/packagesubcampaign/" + $scope.campaignId + "/valid", { name: $scope.name });
                    namePM.then(function(data) {
                        $scope.tip = {};
                        if (data.content == false) { //存在
                            $scope.tip = {
                                name: {
                                    status: true,
                                    txt: $filter('translate')("名称已存在")
                                }
                            }
                            $scope.packageType = false;
                        } else {
                            $scope.packageType = true;
                        }
                        ToolService.hideLoading();
                    });
                }
            }
            /**
             * 当渠道选择百度原生OCPC_分包时，可以批量创建。
             */
        $scope.initUrlType = function() {
            $scope.urlType = "single";
            $scope.checkType = function(type) {
                $scope.urlType = type;
                if (type == 'batch') {
                    if (angular.isUndefined($scope.tip)) {
                        $scope.tip = {};
                    }
                    $scope.tip.name = {
                        txt: "",
                        status: false
                    }
                }
                $scope.changeMB();
            }

            //批量创建数字
            $scope.startNumber = 1;
            $scope.$watch("batchNumber", function(n) {
                // if(angular.isDefined(n)){//batchNumber设置为空是不应该排除
                if ($scope.urlType == 'batch' && $scope.batchNumber >= 2) {
                    $scope.endNumberType = true;
                    $scope.endNumber = parseInt($scope.startNumber) + parseInt($scope.batchNumber) - 1;
                } else {
                    $scope.endNumberType = false;
                    $scope.endNumber = 0;
                }
                // }
            });
            $scope.$watch("startNumber", function(n) {
                if (angular.isDefined(n)) {
                    if ($scope.startNumber > 1) {
                        $scope.endNumber = parseInt($scope.startNumber) + parseInt($scope.batchNumber) - 1;
                    }
                }
            });

            //百度原生OCPC时，显示提示信息，样式变化。
            $scope.changeMB();
        }

        $scope.addBatchParams = function(par) {
            if (!$scope.id) {
                if ($scope.urlType == 'batch') {
                    par.batchNumber = $scope.batchNumber;
                    par.startNumber = $scope.startNumber;
                    par.endNumber = $scope.endNumber;
                    if (UtilService.isNullStr($scope.startNumber)) {
                        $scope.tip.succ = false;
                        $scope.tip.startNumber = {
                            txt: $filter('translate')("必填"),
                            status: true
                        }
                    } else if (par.startNumber <= 0) {
                        $scope.tip.succ = false;
                        $scope.tip.startNumber = {
                            txt: $filter('translate')("请输入>=1整数"),
                            status: true
                        }
                    }
                    if (UtilService.isNullStr($scope.batchNumber)) {
                        $scope.tip.succ = false;
                        $scope.tip.batchNumber = {
                            txt: $filter('translate')("必填"),
                            status: true
                        }
                    } else if (par.batchNumber < 2 || par.batchNumber > 100) {
                        $scope.tip.succ = false;
                        $scope.tip.batchNumber = {
                            txt: $filter('translate')("请输入>=2且<=100整数"),
                            status: true
                        }
                    }
                } else {
                    par.batchNumber = 1;
                }
            } else {
                par.surl = $scope.mysurl;
            }
        }

        $scope.checkChinese = function(obj_val){
            // var reg = new RegExp("[\\u4E00-\\u9FFF]+","g");
            var reg =/^\w+$/; //验证包含字符、数字和下划线
            if(reg.test(obj_val)){
                return false;
            }
            return true;
        }
        $scope.checkHuawei = function(obj_val){
            if(obj_val.indexOf(" ")==-1 && obj_val.length>=6 && obj_val.length<=64){
                return false
            }
            return true;
        }
        $scope.checkUrl = function(obj_val){
            var reg=/(http|https):\/\/[^\s]+/;
            if(reg.test(obj_val)){
                return false;
            }
            return true;
        }
        $scope.save = function() {
            var par = {
                app: $scope.app,
                channel: $scope.channel,
                parent: $scope.parent,
                parentCampaignid: $scope.parentCampaignid,
                name: $scope.name,
                url: $scope.url,
                packChannelid: $scope.pack_channelid
            };
            var verPar = {
                    url: {
                        key: 'url',
                        val: par.url
                    }
                }
                //批量创建增加字段

            if ($scope.uniqueName == 'gdt_apk') {
                par.bundleid = $scope.gdtbundleid;
                par.advertiserid = $scope.advertiserid;
                verPar.gdtbundleid = {
                    key: 'isNull',
                    val: $scope.gdtbundleid
                };
                verPar.advertiserid = {
                    key: 'isNull',
                    val: $scope.advertiserid
                };
            }
            if ($scope.delFlag && !$rootScope.showOnlineDates) {
                verPar.urlScheme = {
                    key: 'isNull',
                    val: $scope.urlScheme
                };

                if ($scope.delFlagdp) {
                    verPar.deeplinkpath = {
                        key: 'isNull',
                        val: $scope.deeplinkpath
                    };
                }
            }
            $scope.tip = formJudge(verPar);
            if($scope.delFlag && $scope.urlScheme && ($scope.urlScheme.indexOf("://") < 1 || $scope.urlScheme.endsWith("://"))){
                $scope.tip.succ = false;
                $scope.tipMsg = true;
        }
            var error = 0;
            if ($scope.specialParams && $scope.specialParams.length > 0) {
                var paramvals = [];
                $scope.specialParams.filter(function(item) {
                    // if (UtilService.isNullStr(item.val)) {
                    //     item.txt = $filter('translate')("必填");
                    //     item.status = true;
                    //     error++;
                        // $scope.tip.succ = false;
                        // $scope.tip[item] = item;
                    // } else {
                    //     item.status = false;
                    //     paramvals.push(item.key + "=" + item.val);
                    // }
                    if (UtilService.isNullStr(item.val) && !item.notrequired) {
                        item.txt = $filter('translate')("必填");
                        item.status = true;
                        error++;
                        $scope.tip.succ = false;
                        $scope.tip[item] = item;
                    }else if(item.val &&item.key == 'mpaccess_token' && $scope.checkUrl(item.val)){
                        item.txt = $filter('translate')("请输入正确的地址");
                        item.status = true;
                        error++;
                        $scope.tip.succ = false;
                        $scope.tip[item] = item;
                    } else if((item.key == 'mpappid'|| item.key == 'mpappsecret' || item.key == 'mpmobile_app_id' ) && $scope.checkChinese(item.val)){
                        item.txt = $filter('translate')("输入格式错误");
                        item.status = true;
                        error++;
                        $scope.tip.succ = false;
                        $scope.tip[item] = item;
                    }else if($scope.uniqueName== 'huaweiads_apk' && item.key == "akey" && $scope.checkHuawei(item.val)){
                        item.txt = $filter('translate')("输入格式错误");
                        item.status = true;
                        error++;
                    }
                    else {
                        item.status = false;
                        paramvals.push(item.key + "=" + (item.val ? item.val : ''));
                    }
                });
                if (error == 0) {
                    par.specialKeys = paramvals.join("&");
                }
            }
            if ($scope.name == undefined || $scope.name == "") {
                if ($scope.tip.succ == true) {
                    $scope.tip.succ = false;
                }
                $scope.tip.name = {
                    status: true,
                    txt: $filter('translate')("必填")
                }
            }

            // if($scope.uniqueName=='bdocpc_apk'){
            $scope.addBatchParams(par);
            // }

            if ($scope.tip.succ != true) {
                ToolService.showTips($scope.formTipMsg);
                return false;
            }
            if ($scope.packageType == false) {
                $scope.tip.name = {
                    status: true,
                    txt: $filter('translate')("名称已存在")
                }
                return false;
            }
             //deeplink 参数
             if ($scope.delFlag) {
                par.appDeepLink = {
                    "appid": $scope.appid,
                    "urlScheme": $scope.urlScheme,
                    "linkId": $scope.mydomain,
                    "callType": 0,
                    "paths": $scope.deeplinkpath
                }

                if ($scope.delFlagdp && $rootScope.isandroid) {
                    par.appDeepLink.callType = 1;
                }
            }

            var savePM = null,
                txtTips = $filter('translate')("添加成功");
            if ($scope.id != null) {
                par.id = $scope.id;
                if ($scope.deeplinkId && $scope.delFlag) {
                    par.appDeepLink.id = $scope.deeplinkId;
                }
                savePM = HttpService.putInfoNew("mng/campaign/packagesubcampaign/update", par);
                txtTips = $filter('translate')("修改成功");
            } else {
                savePM = HttpService.postInfoNew("mng/campaign/packagesubcampaign/create", par);
            }
            ToolService.showLoading();
            savePM.then(function(data) {
                ToolService.hideLoading();
                ToolService.showTips(txtTips);
                $scope.downloadCampaign(data, $scope.name);
                $scope.cancel();
            }, function(data) {
                ToolService.hideLoading();
                ToolService.showTips(data.message);
            });
        }
        $timeout(function() {
            var clipboard = new Clipboard('.campCopy');
            clipboard.on('success', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制成功"));
                });
            });

            clipboard.on('error', function(e) {
                $scope.$apply(function() {
                    ToolService.showTips($filter('translate')("复制成功"));
                });
            });
        }, 200);
        $scope.openDialog = function() {
                if ($scope.nodeUrl != undefined || $scope.nodeUrl != null) {
                    window.open($scope.nodeUrl);
                }
            }
            /*$scope.cancel = function(){
                $scope.goPage("collect.subpackage");
            }*/
        $scope.cancel = function() {
            $scope.goPage("collect.subcampaignlist");
            $rootScope.campaignUrl = 'subpackage';
            $rootScope.campaignChannType = $scope.channType;
        }
        $scope.goCamp = function() {
            $state.go("collect.subpackage", { aid: 'ry_coop' });
        }
        $scope.goSet = function(type) {
            if ($rootScope.isSuper || $rootScope.isManage) {
                $state.go("collect.channel", { aid: type });
            } else {
                ToolService.showTips($filter('translate')("您的账号无此权限，请使用主账号绑定"));
            }
        }

        $scope.setOld = function() {
            $scope.isNew = false;
        }

        $scope.$on("noNumber", function() {
            setTimeout(function() {
                $scope.batchNumber = "";
                $scope.$digest();
            }, 100);
        });
        //批量创建完下载
        $scope.downloadCampaign = function(data, name) {
            var content = data.content;
            if ($scope.urlType == 'batch' && data.content && Array.isArray(content)) {
                var ids = "";
                for (i = 0; i < content.length; i++) {
                    ids = ids + content[i].id + ",";
                }
                ids = ids.substring(0, ids.length - 1);
                var downPM = HttpService.downFile("mng/campaign/packagesubcampaign/export/" + $scope.campaignId + "?ids=" + ids);
                downPM.then(function(data) {});
            }
        }

        /**
         * 语言切换
         */
        $scope.$watch("lang", function(n, o) {
            if (n && o && n !== o) {
                $scope.init();
            }
        });

    }

})();