package com.reyun.service.impl;

import com.reyun.model.*;
import com.reyun.repository.*;
import com.reyun.service.AccountFlowRestrictService;
import com.reyun.service.AutoTodayFlowService;
import com.reyun.task.AdvertisingApiTask;
import com.reyun.task.AutoOnlineAppSyncDeleteSubscribesSurlTask;
import com.reyun.util.NoSQLDBUtil;
import org.joda.time.DateTime;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.omg.CORBA.PUBLIC_MEMBER;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration({"classpath:applicationContext.xml"})
public class AppNameTest {

    @Autowired
    AppRepository appRepository;

    @Autowired
    AdvertisingApiTask advertisingApiTask;

    @Autowired
    AdvertisingBinduserRepository advertisingBinduserRepository;

    @Autowired
    AutoTodayFlowService autoTodayFlowService;

    @Autowired
    AccountRepository accountRepository;

    @Autowired
    AccountRestrict4WebRepository accountRestrict4WebRepository;

    @Autowired
    AccountFlowRestrictService accountFlowRestrictService;

    @Autowired
    RestrictFlowsLogRepository restrictFlowsLogRepository;
    @Autowired
    AutoOnlineAppSyncDeleteSubscribesSurlTask autoOnlineAppSyncDeleteSubscribesSurlTask;

    @Test
    public void testName() {
        List<Object[]> apps = appRepository.findNotDebugApp();

        List<String> erroApps = new ArrayList<>();
        for (Object[] app : apps) {
            App appD = new App();
            appD.setAppkey(app[0].toString());
            appD.setName(app[1].toString());

            try {

                NoSQLDBUtil.putAppName(appD);

            } catch (Exception e) {
                erroApps.add(appD.getAppkey());
            }

            System.out.println(appD.getAppkey());
        }

        for (String erroApp : erroApps) {

            System.out.println("错误 " + erroApp);

        }
    }

    @Test
    public void testFlow() {
        Account account = accountRepository.findOne(38L);
        autoTodayFlowService.autoTodayFlowTask(account);
    }


    @Test
    public void testPackNotify() {
        AccountRestrict4Web restrict4Web = accountRestrict4WebRepository.findOne(533790L);
        Account account = accountRepository.findOne(38L);
        autoTodayFlowService.packageFlowNotify(restrict4Web, account);
    }

    @Test
    public void testPackFlowToday() {
        DateTime today = DateTime.now();
        String appkeys = "'1c3beeedf3d80d371f4658dc2a7c21eb'";
        BigInteger two = accountFlowRestrictService.getTotalNum(today.plusDays(-1).toString("yyyy-MM-dd"),
                today.toString("yyyy-MM-dd"), appkeys, "account_package_today_click_flow", "click_sum");
        System.out.println(two.doubleValue());

    }

    @Test
    public void testOldLogs() {
        List<RestrictFlowsLog> oldLogs = restrictFlowsLogRepository.findNotUseful(DateTime.now().plusMonths(-1).toString("yyyy-MM-dd"), 38L);
        if (oldLogs != null && !oldLogs.isEmpty()) {
            restrictFlowsLogRepository.delete(oldLogs);
        }
    }


    @Test
    public void testAdt() {

        AdvertisingBinduser binduser = advertisingBinduserRepository.findByApp(146817L);
        binduser.setAuto(true);
        binduser.setPreDate(DateTime.now().plusDays(-1).toString("yyyy-MM-dd"));
        Map<String, String> adsMap = new HashMap<>();
       /* adv_id
        7399
        7400
        8143*/
        adsMap.put("7399","");
        adsMap.put("7400","");
        adsMap.put("8143","");

        advertisingApiTask.adtSQLBuilder(binduser, new StringBuffer(),
                "b5b6b9049d9ac7769fa1266f6c746c60", adsMap, binduser.getSecureKey());
    }
    @Test
    public void testS(){
        autoOnlineAppSyncDeleteSubscribesSurlTask.run();
    }


}
