package com.reyun.service.impl;

import java.io.IOException;
import java.util.List;

import org.junit.Before;
import org.junit.Test;
import org.springframework.util.Assert;

import com.reyun.util.AwsS3Util;
import com.reyun.util.Constant;
import com.reyun.util.CosUtil;

public class ObjectStorageTest {
    String bucketName = "unittesting";

    @Before
    public void init() {
        Constant.cosRegion = "ap-beijing";
        Constant.cosSecretId = "AKIDHJ8k9IVSSCoBLJCQPAfwoRq1yiDVrGk0";
        Constant.cosSecretKey = "C6lAIBpEQxxhBMHxOYUEn9D0PaU8XBbn";
        Constant.cosAppid = "1302420315";
        Constant.accessKey = "AKIAOS2UEXIFNVER2O6A";
        Constant.secretKey = "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";
        Constant.ddbregion = "cn-north-1";
    }

    @Test
    public void testListPutDelObj() throws IOException {
        List<String> list1 = AwsS3Util.getInstance().getS3Keys(bucketName, "testListObj");
        List<String> list2 = CosUtil.getInstance().listObjects(bucketName, "testListObj");
        Assert.isTrue(list1.isEmpty(), "MD");
        Assert.isTrue(list2.isEmpty(), "MD");
        AwsS3Util.getInstance().uploadStringToS3(bucketName, "testListObj1", "aaaaaa");
        AwsS3Util.getInstance().uploadStringToS3(bucketName, "testListObj2", "aaaaaa");
        AwsS3Util.getInstance().uploadStringToS3(bucketName, "XXXXListObj1", "aaaaaa");
        list1 = AwsS3Util.getInstance().getS3Keys(bucketName, "testListObj");
        Assert.isTrue(list1.size() == 2, "MD");
        CosUtil.getInstance().putObjectInString(bucketName, "testListObj1", "aaaaaa");
        CosUtil.getInstance().putObjectInString(bucketName, "testListObj2", "aaaaaa");
        CosUtil.getInstance().putObjectInString(bucketName, "XXXXListObj1", "aaaaaa");
        list2 = CosUtil.getInstance().listObjects(bucketName, "testListObj");
        Assert.isTrue(list2.size() == 2, "MD");
        Assert.isTrue(list1.get(0).equals(list2.get(0)), "MD");
        Assert.isTrue(list1.get(1).equals(list2.get(1)), "MD");
        long len11 = AwsS3Util.getInstance().length(bucketName, "testListObj1");
        long len12 = AwsS3Util.getInstance().length(bucketName, "testListObj2");
        long len13 = AwsS3Util.getInstance().length(bucketName, "XXXXListObj1");
        long len21 = CosUtil.getInstance().getLength(bucketName, "testListObj1");
        long len22 = CosUtil.getInstance().getLength(bucketName, "testListObj2");
        long len23 = CosUtil.getInstance().getLength(bucketName, "XXXXListObj1");
        Assert.isTrue(len11 == len21, "MD");
        Assert.isTrue(len12 == len22, "MD");
        Assert.isTrue(len13 == len23, "MD");
        boolean exist1 = AwsS3Util.getInstance().doesObjectExist(bucketName, "XXXXListObj1");
        boolean exist2 = CosUtil.getInstance().doesObjectExist(bucketName, "XXXXListObj1");
        Assert.isTrue(exist1 == exist2 && exist1 == true, "MD");
        AwsS3Util.getInstance().deleteS3Object(bucketName, "testListObj1");
        AwsS3Util.getInstance().deleteS3Object(bucketName, "testListObj2");
        CosUtil.getInstance().deleteObject(bucketName, "testListObj1");
        CosUtil.getInstance().deleteObject(bucketName, "testListObj2");
        list1 = AwsS3Util.getInstance().getS3Keys(bucketName, "testListObj");
        Assert.isTrue(list1.size() == 0, "MD");
        list2 = CosUtil.getInstance().listObjects(bucketName, "testListObj");
        Assert.isTrue(list2.size() == 0, "MD");
        exist1 = AwsS3Util.getInstance().doesObjectExist(bucketName, "testListObj1");
        exist2 = CosUtil.getInstance().doesObjectExist(bucketName, "testListObj1");
        Assert.isTrue(exist1 == exist2 && exist1 == false, "MD");
    }
}
