package com.reyun.service.impl;


import com.reyun.model.Account;
import com.reyun.model.App;
import com.reyun.model.Campaign;
import com.reyun.model.Channel;
import com.reyun.repository.AccountRepository;
import com.reyun.repository.AppRepository;
import com.reyun.repository.CampaignRepository;
import com.reyun.repository.ChannelRepository;
import com.reyun.service.CampaignService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.util.CollectionUtils;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.Stream;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration({"classpath:applicationContext.xml"})
public class PackBatchCreateTest {


    @Autowired
    AppRepository appRepository;
    @Autowired
    ChannelRepository channelRepository;
    @Autowired
    CampaignService campaignService;
    @Autowired
    AccountRepository accountRepository;
    @Autowired
    CampaignRepository campaignRepository;

    /**
     * 根据文件手动批量创建分包推广活动
     *
     * @throws IOException
     */
    @Test
    public void batchCreate() throws IOException {

        String filename = "乐推今日头条自投111.txt";
        Long account = 21492L;
        Long channelId = 10457L;
        String appkey = "cde4dd5c01f8bf9fbe645885ac5d91d7";

        //App app = appRepository.findOne(appid);
        App app = appRepository.findByAppkey(appkey);
        Account loginAccount = accountRepository.findOne(account);
        Channel channelOne = channelRepository.findOne(channelId);
        if (app == null || loginAccount == null || channelOne == null) {
            System.out.println("app不存在");
            return;
        }

        if (!app.getAccount().equals(loginAccount.getId())) {
            System.out.println("账号配置错误");
        }

        List<Campaign> campaigns;
        try (Stream<String> stream = Files.lines(Paths.get("C:\\Users\\reyun\\Desktop\\分包批量创建.txt"))) {
            campaigns = stream.skip(1).map(v -> {
                Campaign campaign = new Campaign();
                String[] values = v.split("\t");
                campaign.setApp(app.getId());
                campaign.setChannel(channelOne.getId());
                campaign.setName(values[0].trim());
                campaign.setOs(app.getPlatform());
                campaign.setPack_channelid(values[2].trim());
                campaign.setUniqueName(channelOne.getUniqueName());
                campaign.setUrl(values[1].trim());
                campaign.setHolderids("");
                campaign.setBatchNumber(1);
                campaign.setVivo2DDb(false);
                if (campaign.getChannel().equals(13296L)) {
                    campaign.setVivo2DDb(true);
                }
                campaign.setAccount(loginAccount.getId());
                campaign.setCreateAccount(loginAccount.getId());
                campaign.setCreateTime(new Date());

                if (!appkey.equals(values[4])) {
                    System.out.println("appkey 配置错误");
                }

                if (!values[3].equals(channelOne.getName())) {
                    System.out.println("渠道配置错误");
                }

                return campaign;
            }).collect(Collectors.toList());
        }

        Map mapValues = campaigns.stream().collect(Collectors.toMap(v -> v.getPack_channelid(), v -> "1"));
        if (mapValues.size() != campaigns.size()) {
            System.out.println("分包渠道重复");
        }
        Map<String, String> createMap = null;

        //List<String> created = Arrays.asList("15790013, 15800014, 15810015, 15820016, 15830017, 15840018, 15850019, 15860020, 15870021, 15880022, 15890023, 15900024, 15910025, 15920026, 15930027, 15940028, 15950029, 15960030, 15970031, 15980032, 15990033, 16000034, 16010035, 16020036".split(","));
        //createMap = created.stream().collect(Collectors.toMap(v -> v.trim(), v -> ""));

        if (createMap != null) {
            // 跳过已生成完成的 分包活动
            List<Campaign> listTwo = new ArrayList<>();
            for (Campaign campaign : campaigns) {
                if (!createMap.containsKey(campaign.getPack_channelid())) {
                    listTwo.add(campaign);
                }
            }
            campaigns = listTwo;
        }


        List<Campaign> campaignList = campaignRepository.findByAppAndPackcid(app.getId(),
                campaigns.stream().map(v -> v.getPack_channelid()).collect(Collectors.toList()));

        if (campaignList != null && !campaignList.isEmpty()) {
            System.out.println("分包活动已存在");
            campaignList.forEach(v -> System.out.println(v.getCampaignid()));
            return;
        }

        int loop = 0;
        int all_size = 1;
        for (Campaign v : campaigns) {
            try {

                if (loop > 10) {
                    loop = 0;
                    Thread.sleep(350);
                    System.out.println("成功生成 " + all_size + " 条");
                }
                all_size++;
                loop++;

                if (createMap != null && createMap.containsKey(v.getPack_channelid())) {
                    continue;
                }
                //后端生成的short url
                List<String> shortUrlList = campaignService.makesurls(app.getId(), loginAccount, v.getBatchNumber());
                if (!CollectionUtils.isEmpty(shortUrlList) && v.getBatchNumber() == 1) {
                    //单个创建推广活动
                    v.setSurl(shortUrlList.get(0));
                    List campains = new ArrayList();
                    campains.add(campaignService.create(app.getId(), v));
                    campaignService.createVivoParam(campains, v);
                }
            } catch (Exception e) {
                e.printStackTrace();
                System.out.println("失败的id：" + v.getPack_channelid());
            }
        }


    }
}
